$MODULE_FACTORY_REGISTRY = typeof $MODULE_FACTORY_REGISTRY != 'undefined' ? $MODULE_FACTORY_REGISTRY : {};
$MODULE_REGISTRY = typeof $MODULE_REGISTRY != 'undefined' ? $MODULE_REGISTRY : {};
if(typeof require == 'undefined')
function require(path){if(!$MODULE_REGISTRY[path]) $MODULE_REGISTRY[path] = $MODULE_FACTORY_REGISTRY[path](); return $MODULE_REGISTRY[path]};$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NGJSEnvironmentSupport'] = exports; /**

 # NGJSEnvironmentSupport.js
 # webgame
 #
 # Created by Frederic Barthelemy on 10/01/10.
 # Copyright 2010 ngmoco:). All rights reserved.

 */

/**
 * Provides Environmental support for features missing on certain platforms.
 */


/**
 * setTimeout and setInterval implementation for platforms that don't have it.
 *	It fires timers at the beginning of the first frame past the requested millisecond,
 *	before it processes messages for a particular frame.
 *
 * Platform Consumers:
 *	- Android
 *
 * Note:
 *	- Only accurate to within the frame.
 *	- Does behaves like webkit in that it lets clearInterval and clearTimeout
 *		clear timers created by each other's constructor style.
 *
 */
var NGSetTimeoutCustom = false;
var NGSetTimeoutCallbacks = {};

exports.NGSetTimeoutRunTimers = function() {
	if(NGSetTimeoutCustom) {
		var timersToExecute = [];
		var curTime = new Date().getTime();
		for (var tk in NGSetTimeoutCallbacks) {
			if (NGSetTimeoutCallbacks.hasOwnProperty(tk) && NGSetTimeoutCallbacks[tk].shouldExecute(curTime)) {
				timersToExecute.push(NGSetTimeoutCallbacks[tk]);
			}
		}

		for (var i in timersToExecute) {
			if (timersToExecute.hasOwnProperty(i)) {
				timersToExecute[i].execute();
			}
		}
	}
};

if(typeof(setTimeout) != "function") {
	NGSetTimeoutCustom = true;

	var NGSingleTimeoutInstance = function(fptr, timeMs) {
		this.uid = setTimeout.uidGenerator++;
		this.fptr = fptr;
		this.interval = timeMs;
		this.requestedTime = new Date().getTime() + timeMs;
	};

	NGSingleTimeoutInstance.prototype.shouldExecute = function(curTime) {
		if(curTime < this.requestedTime) {
			return false;
		}
		return true;
	};

	NGSingleTimeoutInstance.prototype.execute = function() {
		delete NGSetTimeoutCallbacks[this.uid];
		this.fptr();
	};
	/**
	*
	*/
	setTimeout = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	/**
	*
	*/
	clearTimeout = function(uid) {
		if(NGSetTimeoutCallbacks.hasOwnProperty(uid)) {
			delete NGSetTimeoutCallbacks[uid];
		}
	};
	/**
	*
	*/
	setInterval = function(fptr,requestedTime) {
		if(requestedTime < 0 || typeof(requestedTime) != "number") {
			requestedTime = 0;
		}

		var inst = new NGSingleTimeoutInstance(fptr,requestedTime);
		/*Special setIntervalMagic */
		inst.execute = function() {
			this.requestedTime = new Date().getTime() + this.interval;
			this.fptr();
		};
		/*End setIntervalMagic */
		NGSetTimeoutCallbacks[inst.uid] = inst;
		return inst.uid;
	};
	clearInterval = clearTimeout;

	setTimeout.uidGenerator = 0;
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/SystemBinding'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/SystemBinding'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var ResultSetReq = require('NGCore/Client/Plus/ResultSet');

var NGSystemBindingCommands = {
    HandleAction: 0
};

var SystemBinding = ClassReq.Class.subclass({
    classname: "SystemBinding",
    callbacks: {},
    callbacksUidGenerator: 0,
    _contResultSets: {},
    _contResultSetIdxs: {}
});

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBinding._closeContactsResultSet(this);
    }
});

SystemBinding._pushContactsCmd = function(cmdname, callbackFunc, continueId) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: cmdname,
        callbackId: callbackId
    };
    if (typeof continueId != 'undefined') {
        message.continueId = continueId;
    }
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding._closeContactsResultSetfunction = function(rSet) {
    // Passing empty callback as caller does not need to know when the close
    // is complete
    var cb = function() {};
    SystemBinding._pushContactsCmd('closecontacts', cb, rSet._continueId);
};

SystemBinding._getMoreContacts = function(rSet, callbackFunc) {
    if ((typeof rSet._continueId != 'undefined') &&
    (rSet.items.length < rSet.totalLength)) {
        SystemBinding._pushContactsCmd('morecontacts', callbackFunc, rSet._continueId);
        return true;
    }
    return false;
};

SystemBinding.getContacts = function(callbackFunc) {
    SystemBinding._pushContactsCmd('contacts', callbackFunc, undefined);
};

SystemBinding.getDeviceToken = function(callbackFunc) {
    // Generate unused callbackEntry
    var callbackId = SystemBinding.callbacksUidGenerator++;
    if ( !! !callbackFunc) {
        callbackFunc = function() {};
    }
    SystemBinding.callbacks[callbackId] = callbackFunc;
    var message = {
        name: 'devicetoken',
        callbackId: callbackId
    };
    message = JSON.stringify(message);
    NgPushCommand3(NgEntityTypes.NgSystemBinding, NGSystemBindingCommands.HandleAction,
    Base64.encode(message));
};

SystemBinding.handleCommand = function(command) {
    var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
    var cmd = JSON.parse(fields[1]);
    if (cmd.name == 'callback') {
    	var cb = SystemBinding.callbacks[cmd.callbackId];
		if (typeof cb == "function") {
            if (cmd.callbackname == 'contacts') {
                var obj = SystemBinding._contResultSets[cmd.continueId];
                if (typeof obj == 'undefined') {
                    // First time for this callback
                    obj = new ResultSetReq.ResultSet(cmd.continueId);
                    SystemBinding._contResultSets[cmd.continueId] = obj;
                    SystemBinding._contResultSetIdxs[cmd.continueId] = 0;
                }

                var addedCount = cmd.list.length;
                while (cmd.list.length > 0) {
                    var item = cmd.list.shift();
                    obj.items.push(item);
                }

                var newIdx = SystemBinding._contResultSetIdxs[cmd.continueId];
				if ((typeof newIdx) != 'undefined') {
                	SystemBinding._contResultSetIdxs[cmd.continueId] = newIdx + addedCount;
				}

                // Invalidate the continueId if done - when total is return (no
                // more result) or when result set is explicitly closed (cmd.closed)
                if ((typeof cmd.total != 'undefined') ||
                (typeof cmd.rsclosed != 'undefined')) {
                    if (typeof cmd.total != 'undefined') {
                        obj.totalLength = cmd.total;
                    }
                    delete obj._continueId;
                    delete SystemBinding._contResultSets[cmd.continueId];
                    delete SystemBinding._contResultSetIdxs[cmd.continueId];
                }

                delete SystemBinding.callbacks[cmd.callbackId];
				if (cmd.success) {
                	cb(undefined, obj, newIdx, addedCount);
				} else {
                	cb(cmd.error, obj, newIdx, addedCount);
				}
            } else {
                // other callbacks
                delete SystemBinding.callbacks[cmd.callbackId];
                cb(cmd);
            }
        }
    }
};

exports.SystemBinding = SystemBinding;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI'] || {}; $MODULE_REGISTRY['NGCore/Client/UI'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

/**
 * <p>Classes and objects contained by the UI module.</p>
 * @name UI
 * @namespace
 * @description <p>The UI module is a collection of classes that control user interface components of a device.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link UI.AbstractView}</code>A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.CellView}</code>: Construct <code>CellView</code> objects.</li>
 * <li><code>{@link UI.CheckBox}</code>: Construct objects that are used as checkboxes in an application.</li>
 * <li><code>{@link UI.CheckoutView}</code>: Construct objects that handle and manage information associated with <code>POST</code> methods in an application.</li>
 * <li><code>{@link UI.DateField}</code>: Construct objects used for handling data returned by date functions.</li>
 * <li><code>{@link UI.DocumentView}</code>: Constructs objects that control the location of application documents.</li>
 * <li><code>{@link UI.EditText}</code>: Constructs objects for handling editable text in an application.</li>
 * <li><code>{@link UI.EditTextArea}</code>: Constructs objects for handling multiline editable text in an application.</li>
 * <li><code>{@link UI.Element}</code>: A base class object for constructing other UI objects.</li>
 * <li><code>{@link UI.GLView}</code>: Construct objects that provide applications with access to OpenGL.</li>
 * <li><code>{@link UI.Image}</code>: Constructs objects that control the location and size of images used in the user interface.</li>
 * <li><code>{@link UI.Label}</code>: Constructs objects that control the look and feel of application labels.</li>
 * <li><code>{@link UI.ListView}</code>: Construct <code>ListView</code> objects.</li>
 * <li><code>{@link UI.ListViewItem}</code>: Construct <code>ListViewItem</code> objects.</li>
 * <li><code>{@link UI.ListViewSection}</code>: Construct <code>ListViewSection</code> objects.</li>
 * <li><code>{@link UI.NavController}</code>: Construct objects that control the flow of applcation navigation.</li>
 * <li><code>{@link UI.ProgressDialog}</code>: Construct objects that control application progress messaging.</li>
 * <li><code>{@link UI.ScrollView}</code>: Construct <code>ScrollView</code> objects.</li>
 * <li><code>{@link UI.Spinner}</code>: Construct objects that handle application menu spinners.
 * <li><code>{@link UI.Toast}</code>: Construct <code>Toast</code> objects.
 * <li><code>{@link UI.View}</code>: Construct objects that control the look and feel of the application view state.</li>
 * <li><code>{@link UI.ViewGeometry.Rect}</code>: Construct rectangle objects for use as positionable elements in the user interface.</li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code>: Construct objects that handle view geometry for different scales of measurement.</li>
 * <li><code>{@link UI.WebView}</code>: Construct objects that pass event callback functions when web page events occur.</li>
 * <li><code>{@link UI.Window}</code>: Construct application window objects.</li>
 * </ul>
 */

exports.UI = {
	Commands: Commands,
	
	FontStyle: Commands.FontStyle,
	State: Commands.State,
	FitMode: Commands.FitMode,
	
	
	Window: require('NGCore/Client/UI/Window').Window,
	Element: require('NGCore/Client/UI/Element').Element,
	View: require('NGCore/Client/UI/View').View,
	Label: require('NGCore/Client/UI/Label').Label,
	Image: require('NGCore/Client/UI/Image').Image,
	Button: require('NGCore/Client/UI/Button').Button,
	GLView: require('NGCore/Client/UI/GLView').GLView,
	NavController: require('NGCore/Client/UI/NavController').NavController,
	WebView: require('NGCore/Client/UI/WebView').WebView,
	ScrollView: require('NGCore/Client/UI/ScrollView').ScrollView,
	ListView: require('NGCore/Client/UI/ListView').ListView,
	ListViewSection: require('NGCore/Client/UI/ListViewSection').ListViewSection,
	ListViewItem: require('NGCore/Client/UI/ListViewItem').ListViewItem,
	CellView: require('NGCore/Client/UI/CellView').CellView,
	CheckBox: require('NGCore/Client/UI/CheckBox').CheckBox,
	EditText: require('NGCore/Client/UI/EditText').EditText,
	EditTextArea: require('NGCore/Client/UI/EditTextArea').EditTextArea,
	DateField: require('NGCore/Client/UI/DateField').DateField,
	AlertDialog: require('NGCore/Client/UI/AlertDialog').AlertDialog,
	ProgressDialog: require('NGCore/Client/UI/ProgressDialog').ProgressDialog,
	Toast: require('NGCore/Client/UI/Toast').Toast,
	/** @private */
	AdView: require('NGCore/Client/UI/AdView').AdView,
	ViewGeometry: ViewGeometry,
	Scale: ViewGeometry.Scale,
	DocumentView: require('NGCore/Client/UI/DocumentView').DocumentView,
	CheckoutView: require('NGCore/Client/UI/CheckoutView').CheckoutView,
	Spinner: require('NGCore/Client/UI/Spinner').Spinner,
	ProgressBar: require('NGCore/Client/UI/ProgressBar').ProgressBar,
	MapView: require('NGCore/Client/UI/MapView').MapView,
	MapAnnotation: require('NGCore/Client/UI/MapAnnotation').MapAnnotation,
	
	/**
	 *	@function
	 * 	@name UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
	animate: Commands.animate,
	
	/**
		@name UI#compositeImages
		Creates a composition of images to an offscreen bitmap, writing the resulting picture to disk.
		
		The filename returned in the callback may not be the same as originally requested!
		
		@example
		UI.compositeImages( 200, 200, "basic.png", [
			{
				image:'./Content/background.png',
				rect:[ 0,0, 200, 200 ]
			},
			{
				image:'./Content/CanYouSeeThisImage.png',
				rect:[ 50, 50, 100, 100 ]
			},
		], function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	 */
	compositeImages: function( w, h, filename, infoArray, callback )
	{
		if ( typeof(callback) != 'function' )
			return;
		
		var	cb = Commands.registerTemporaryCallback( callback );		
		Commands.doCompositeImages( w, h, filename, infoArray, cb );
	},
	
	/**
		@name UI#choosePhoto
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
	choosePhoto:	function( 
		/**int*/ targetWide,
		/**int*/ targetHigh,
		/**string*/ filename, 
		/**Object*/ options,
		/**function*/ callback,
		/**Object*/ invokingView )
	{
		if ( typeof(callback) != 'function' )
			return;
		
		if ( options == undefined )
			options = {};
			
		if ( !invokingView || !invokingView.__objectRegistryId ) {
			new exports.UI.Toast({
				'text': "Photo picker requires an invoking view.",
				'onDisappear': function() {
					this.destroy();
				}
			}).show();
			return;
		}
		
		var	cb = Commands.registerTemporaryCallback( callback );		
		Commands.doChoosePhoto( targetWide, targetHigh, filename, options, cb, invokingView.__objectRegistryId );
	},
	
	/**
		@name UI#choosePhotoCamera
		Show fullscreen user interface for taking a picture with the camera or choosing an existing
		photo.
		
		Currently there are no 'options' keys defined.  
		In the future, we're considering "forAvatar" key to use a custom cropping UI.
		
		The filename returned in the callback may not be the same as originally requested!
		If the user cancels or an error occurs, the callback will be passed an error string.
		
		Passing 0 for targetWide or High will return the original unscaled image.
		
		@example
		UI.choosePhoto( 0, 0, "basic.png", undefined, function( data ) { 
			if ( data.error == undefined ) { 
				NgLogD("yay, picture! at:"+data.filename);
			}
		} );
	*/
	choosePhotoCamera:	function( 
		/**int*/ targetWide,
		/**int*/ targetHigh,
		/**string*/ filename, 
		/**Object*/ options,
		/**function*/ callback )
	{
		if ( typeof(callback) != 'function' )
			return;
		
		if ( options == undefined )
			options = {};
		
		var	cb = Commands.registerTemporaryCallback( callback );		
		Commands.doChooseCamera( targetWide, targetHigh, filename, options, cb );
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadManifest'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadManifest'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var XHR = require('NGCore/Client/Network/XHR').XHR;
var Util = require('NGCore/Client/Network/Util').Util;
var DownloadFile = require('NGCore/Client/Network/DownloadFile').DownloadFile;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;

// JMarr temporary hack to supress archive downloads on flash.
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Manifest = Class.subclass(
{
	classname: 'Manifest',

	initialize: function()
	{
	},

	reset: function ()
	{
		this.mJson = null;
		this.mArchives = null;
	},

	initWithJsonText: function ( text, emptyOnFail)
	{
		try
		{
			this.mJson = JSON.parse ( text );
			if (!this.mJson)
			{
				this.mJson = {};
			}
		}
		catch (e)
		{
			this.mJson = {};
		}

		if('__archives' in this.mJson)
		{
			this.mArchives = this.mJson['__archives'].files;
			delete this.mJson['__archives'];
		}
		else
		{
			this.mArchives = [];
		}
	},

	//cb: function ( itemKey, dstList, srcList ), which is compareItems
	//cb returns ! null, then dst[ item ] = cb return value.
	//cb returns null, then delete dst[ item ].
	foreach: function ( other, cb )
	{
		var dst = this.mJson;
		var src = other.mJson;
		// Handle all things in src.
		for ( var key in src )
		{
			this.handleItem ( key, dst, src, cb );
		}
		// Build up list of all things not in src.
		for ( var key in dst )
		{
			// Handle all things not in src.
			if ( ! (key in src) )
			{
				this.handleItem ( key, dst, src, cb );
			}
		}
	},

	handleItem: function ( key, dst, src, cb )
	{
		var ret = cb ( key, dst, src );
		if ( !ret )
		{
			delete dst[ key ];
		}
	},

	write: function ( fname )
	{
		var cb = function (err)
		{
			if (err)
			{
				console.log('Error writing manifest! ' + err);
			}
			// DO stuff?
		}
		if (this.mJson)
		{
			var out = JSON.stringify(this.mJson);
			FileSystem.writeFile(fname, out, cb);
		}
	}
});

////////////////////////////////////////////////////////////////////////////////

exports.DownloadManifest = MessageListener.subclass(
/** @lends Network.DownloadManifest.prototype */
{
	classname: 'DownloadManifest',

	/**
	 * @class The <code>DownloadManifest</code> class constructs objects that initiate the handling of a manifest file. 
	 * This ensures a set of files are kept up-to-date in the specified directory from the specified URL.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.reset();
	},

	_clearConnections: function()
	{
		for (var i in this.mConnections)
		{
			if(!this.mConnections.hasOwnProperty(i)) continue;
			
			this.mConnections[i].abort();
		}
		this.mConnections = [];
	},

	reset: function ()
	{
		this.mConcurrentRequests = 6;

		this.mManifest = null;

		this.mRemoteUrl = null;
		this.mLocalPath = null;
		this.mLocalRoot = null;

		this.mLocalText = null;
		this.mRemoteText = null;
		/** @private */
		this.mProgressCb = function() {};
		/** @private */
		this.mDoneCb = function() {};

		this.mPaused = false;
		this.mValid = false;

		this._clearConnections();
		this.mPendingItems = [];
		this.mCompleteBytes = 0;
		this.mTotalBytes = 0;
		
		this.mSpaceNeeded = 0;
		
		this.mNumRemoteManifestFiles = 0;
		this.mNumRemoteManifestBytes = 0;
		
		this.mDownloadArchives = true;
		this.mActiveRequests = [];

		this.mLocalGameList = LocalGameList;

		this.mNewJS = false;
		this.mAppObserver = null;

		this.mRetrySchedule = Util.RetrySchedule(50, 2000);
		this.mManifestRetrySchedule = this.mRetrySchedule.slice(0);

		if(this._statusListener)
		{
			this._statusListener.destroy()
			this._statusListener = null;
		}
		this.mCheckUpdateOnly = false;
		this.mCheckUpdateCallback = null;
	},

	_ensureTrailingSlashes: function(remoteUrl, localPath, secureContentUrl)
	{
		// Check for trailing slashes
		this.mRemoteUrl = remoteUrl.match(/.*\/$/) ? remoteUrl : remoteUrl + '/';
		// If the local path is nothing, do not alter the filename. Otherwise, ensure trailing slash
		this.mLocalRoot = (localPath.match(/.*\/$/) || (!localPath)) ? localPath : localPath + '/';
		this._secureContentUrl = ((!secureContentUrl) || secureContentUrl.match(/.*\/$/)) ? secureContentUrl : secureContentUrl + '/';
	},

	_readLocalManifest: function()
	{
		FileSystem.readFile ( this.mLocalPath, this._onReadLocalManifest.bind(this) );
	},

	_setRemotePath: function(manifestName)
	{
		if (this._secureContentUrl)
		{
			this.mRemotePath = this._secureContentUrl + manifestName;
		}
		else
		{
			this.mRemotePath = this.mRemoteUrl + manifestName;
		}
	},

	isUpdated: function(remoteUrl, localPath, manifestName, doneCB, errorCB)
	{
		this.mCheckUpdateOnly = true;
		this.mCheckUpdateCallback = doneCB;

		this.mDoneCb = (typeof errorCB == 'function') ? errorCB : function() {};
		this.mProgressCb = function(done, left) {};
		var httpStatusCode = 0;
		Util.OperationWithRetries(
			(function(failCb)
			{
				// Start remote manifest download.
				var req = new XHR();
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						this.mManifest = new Manifest ();
						var manifestUrl = null;
						// Only parse if we got a good response back
						if (req.status == 200)
						{
							manifestUrl = JSON.parse(req.responseText).contentUrl;
						}

						// If config didn't have contentUrl or we never parsed(local testing), use the base URL
						if (!manifestUrl)
							manifestUrl = remoteUrl;

						this._ensureTrailingSlashes(manifestUrl, localPath);
						this.mLocalPath = this.mLocalRoot + manifestName;
						this._setRemotePath(manifestName);
						this._readLocalManifest();
					}
				}).bind(this);

				req.open ( 'GET', remoteUrl + "/configuration.json" + Util.getCacheBustingString(), true );
				req.send ();
			}).bind(this),
			(function()
			{
				console.log('Exceeded maximum number of manifest download retires, failing');
				this._processError('Failed to download manifest (' + httpStatusCode + ')', false);
			}).bind(this),
			this.mFailEarly
		);

		this.mValid = true;
	},

	// progressCb: function ( completedRequests, totalRequests )
	// doneCb: function ( err, manifest )
	// throws if url/path arguments are null or empty.
	// TODO: Allow headers argument.  Currently null.
	// TODO: Allow HTTP method argument.  Currently GET.
	/**
	* @name Network.DownloadManifest#start
	* @description Start a download of a remote manifest file at <code>[remoteUrl + manifestName]</code> 
	* and read a local manifest at <code>[localPath + manifestName]</code>.<br><br>
	* <ul>
	* <li>If the local manifest does not exist, all files specified by the remote manifest are downloaded.</li>
	* <li>If the local manifest does exist, this method will update the file system at 
	* <code>[localPath]</code> to match the files specified in the remote manifest.</li>
	* </ul>
	* Each file download will trigger a <code>progress</code> callback function that returns the 
	* number of items downloaded and the total number of items to download.
	* <pre class="code">progressCb: function ( completedRequests, totalRequests )</pre>
	* When all downloads are complete, a <code>done</code> callback function is triggered that returns an error (if any) 
	* and the contents of <code>[localPath + manifestName]</code>. 
	* <pre class="code">doneCb: function ( err, manifest )</pre>
	* If an error does not occur, this function returns <code>undefined</code>.<br><br>
	* <b>Note:</b> The contents of <code>[localPath + manifestName]</code> are saved whether an error occurs or not.
	* @param {String} remoteUrl The URL to a manifest file.
	* @param {String} localPath The directory path to a manifest file.
	* @param {String} manifestName The manifest filename. 
	* @param {Function} progressCb The callback function to call for download progress.
	* @param {Function} doneCb The callback function to call when the download is complete.
	* @throws {invalid arguments} If the URL or directory path returns as empty or <code>null</code>.
	* @example Network.DownloadManifest.start(this._URL, './', this._manifestName, progressCb, doneCallback);
	* @function
    * @status iOS, Android
	*/
	/** @ignore */
	start: function ( remoteUrl, localPath, manifestName, progressCb, doneCb, disableArchives, failEarly )
	{
		this.mCheckUpdateOnly = false;

		console.log('DownloadManifest.start(', remoteUrl, localPath, manifestName, ')');
		if ( ! remoteUrl || ! localPath || remoteUrl == '' || localPath == '' )
		{
			throw new Error ( 'invalid arguments: ' + JSON.stringify ( arguments ) );
		}

		// Set up instance state for this request.
		this.mManifest = new Manifest ();
		if(disableArchives)
			this.mDownloadArchives = false;
		
		// JMarr temporary hack to disable archive downloads on flash.
		if(Capabilities.getPlatformOS() == 'flash')
		{
			console.log('Flash does not yet support archive downloads');
			this.mDownloadArchives = false;
		}

		this._ensureTrailingSlashes(remoteUrl, localPath, this._secureContentUrl);
		this._setRemotePath(manifestName);
		this.mLocalPath = this.mLocalRoot + manifestName;
		this.mFailEarly = failEarly;

		// try these to prevent a failed update due to bad code
		/** @private */
		this.mProgressCb = function (done, left)
		{
			try
			{
				progressCb(done, left);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		}

		var that = this;
		/** @private */
		this.mDoneCb = function (err, man, hadCache)
		{
			try
			{
				// touch the .nomedia file (MOB-1355)
				FileSystem.writeFile(that.mLocalRoot + '/.nomedia', '');

				/** @private */
				this.mProgressCb = function() {};
				/** @private */
				this.mDoneCb = function() {};
				this._setLifecycleListening(false);
				doneCb(err, man, hadCache);
			}
			catch (ex)
			{
				NgLogException(ex);
			}
		}

		this._readLocalManifest();
		this._setLifecycleListening(true);
		this.mValid = true;
	},

	abort: function()
	{
		this.reset();
	},

	pause: function()
	{
		// Cancel downloads
		this._clearConnections();

		// move active requests back to pending
		this.mPendingItems = this.mPendingItems.concat(this.mActiveRequests);
		this.mActiveRequests = [];

		this.mPaused = true;
	},

	resume: function()
	{
		if (this.mPaused)
		{
			this.mPaused = false;
			this._downloadPendingItems();
		}
	},

	_setLifecycleListening: function(toListen)
	{
		if (toListen && !this.lifeListening)
		{
			Device.LifecycleEmitter.addListener(this,
				function (event)
				{
					switch (event)
					{
						case Device.LifecycleEmitter.Event.Suspend:
						case Device.LifecycleEmitter.Event.Terminate:
							this._writeManifest();
						break;
					}
				}
			);
			this.lifeListening = true;
		}
		else if (this.lifeListening)
		{
			Device.LifecycleEmitter.removeListener(this);
			this.lifeListening = false;
		}
	},

	_theQuestion: function (toBe)
	{
		return toBe | !toBe;
	},

	_setConfig: function (cfg)
	{
		// For saving after completion
		this._Config = cfg;
		// for skipping JS download
		this._noJS = cfg.omitJsUpdate;
		// For using separate content URL
		this._secureContentUrl = cfg.secureContentUrl;
	},

	// Callback for read of local manifest file in start method.

	_onReadLocalManifest: function ( err, data )
	{
		if (this.mValid)
		{
			try	// always start try block in async callbacks
			{
				if ( ! err )
				{
					this.mLocalText = data;
				}
				else
				{
					this.mLocalText = '{}';	// Empty string is ! null.  It's ok for the read to fail.
				}
				this._downloadManifest();
			}
			catch ( ex )
			{
				NgLogException ( ex );
				this._processError ( 'Error reading local manifest err: ' + err , false );
			}
		}
	},

	// Called to start the manifest download.
	_downloadManifest: function()
	{
		var httpStatusCode = 0;
		Util.OperationWithRetries(
			(function(failCb)
			{
				// Start remote manifest download.
				var req = new XHR();
				var id = this.mConnections.push(req) - 1;
				req.onreadystatechange = (function()
				{
					if( req.readyState == 4 && this.mValid )	// done && not cancelled
					{
						delete this.mConnections[id];
						httpStatusCode = req.status;
						if ( httpStatusCode == 200 )
						{
							this.mRemoteText = req.responseText;
							this._checkItems();

							if (this.mCheckUpdateOnly)
								this._checkUpdate();
							else
								this._evalManifests ();
						}
						else
						{
							console.log( 'Download of manifest at ' + this.mRemotePath
								+Util.getCacheBustingString() + ' failed: ' + httpStatusCode + ' '
								+ req.responseText);
							failCb();
						}
					}
				}).bind(this);

				req.open ( 'GET', this.mRemotePath + Util.getCacheBustingString(), true );
				req.send ();
			}).bind(this),
			(function()
			{
				console.log('Exceeded maximum number of manifest download retires, failing');
				this._processError('Failed to download manifest (' + httpStatusCode + ')', false);
			}).bind(this),
			this.mFailEarly
		);
	},

	// Can be called at any time.

	_processError: function ( message , writeManifest)
	{
		if (writeManifest && this.mManifest)
		{
			this._writeManifest();
		}

		// Don't call the doneCB without checking local text
		if (this.mLocalText && this.mValid)
		{
			this.mDoneCb ( message, null,  this.mLocalText.length > 2);
			this.reset ();
		}
	},

	_checkItems: function()
	{
		// Init source and destination manifests.
		this.mManifest.initWithJsonText ( this.mLocalText , true );
		var other = new Manifest ();
		other.initWithJsonText ( this.mRemoteText );

		// Build list of pending local items.
		this.mManifest.foreach ( other, this._compareItems.bind(this));
	},

	_checkUpdate: function()
	{
		this.mPendingItems = [];
		this.mCheckUpdateCallback(this.mTotalBytes > 0, this.mTotalBytes);
	},

	_evalManifests: function ()
	{
		try
		{
			// JMarr always download with zips if they are available.
			// If we only need to download less than 33% of files and less than 33% of bytes, then don't use an archive.
			// Additinoally, we must be on wifi, or else carriers might tamper with our files.
			/*var NetworkEmitter = require('../Device/NetworkEmitter').NetworkEmitter;
			if(this.mPendingItems.length < this.mNumRemoteManifestFiles * 0.33
				&& this.mTotalBytes < this.mNumRemoteManifestBytes * 0.33
				&& NetworkEmitter.getLastStatus() == NetworkEmitter.Status.Wifi)
			{
				this.mDownloadArchives = false;
			}*/
			
			// Cache total bytes into separate variable. Archive download might increase
			// space needed, but not total bytes.
			this.mSpaceNeeded = this.mTotalBytes;

			var other = new Manifest ();
			other.initWithJsonText ( this.mRemoteText );
			// If there is no archive in the manifest, don't download an archive.
			if(!other.mArchives)
				this.mDownloadArchives = false;

			// Prepare for archive downloads. If mDownloadArchives is true,
			// then all files will be downloaded through an archive. Otherwise,
			// only files that are makred as force archive will be downloaded
			// through archive.
			this._prepareForArchiveDownload(other.mArchives, !this.mDownloadArchives);
			
			// Trigger progress callback.
			this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );

			this.mLocalGameList.freeSpace(this.mSpaceNeeded, (function (err)
			{
				if (err)
				{
					this._processError(err, false);
					return;
				}
				// Download anything that got into pending list
				this._downloadPendingItems ();
			}).bind(this));
		}
		catch (e)
		{
			NgLogException ( e );
			this.mDoneCb ( 'Failed processing manifests!', null );
		}
	},
	
	// Decides which archives need to be downloaded to ensure that all of the pending files are downloaded.
	_prepareForArchiveDownload: function(archives, onlyForcedFiles)
	{
		console.log('DownloadManfiest._prepareForArchiveDownload onlyForcedFiles:', onlyForcedFiles);
		// Iterate over files that need to be covered and make sure they are included.
		var neededFiles = [];
		var includedArcns = {};
		var includedExpSize = 0;
		var includedArcSize = 0;
		var filesToCover = this.mPendingItems;
		var nonForcedFiles = [];
		for(var i=0; i < filesToCover.length; ++i)
		{
			// If this file isn't an archive, just download the file.
			var f = filesToCover[i];
			if(!f.arcn)
			{
				//console.log('NonForced: including arnc-less %s', f.name);
				neededFiles.push(f);
				includedExpSize += f.size;
				continue;
			}
			
			// Record that this archive provides this file.
			var arcn = f.arcn;
			var a = archives[arcn];
			if(!a.files)
				a.files = [f];
			else
				a.files.push(f);
			
			// Is this archive already incldued?
			if(includedArcns[arcn])
				continue;
			
			// If we are only including forced files, remember that this
			// is a non forced file that we need to download. If after evaluating
			// all of the forced files and these files are not included, they will
			// be explicitly included.
			if(onlyForcedFiles && !f.arcForce)
			{
				nonForcedFiles.push(f);
				//console.log('NonForced: delaying decision about %s in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('Forced: including %s from arcn %d', f.name, f.arcn);
			
			// Include the archive associated with this arcn.
			neededFiles.push(a);
			includedArcns[arcn] = true;
			includedExpSize += a.expSize;
			includedArcSize += a.arcSize;
		}
		
		// If only downloading forced archives, examine all of the queued
		// files that are not forced. If their archive is not included, then 
		// directly include the file.
		for(i=0; i < nonForcedFiles.length; ++i)
		{
			// Is the archive for this file already incldued?
			// This will happen if a forced file (like a .js) 
			// forced the archive to be included.
			var f = nonForcedFiles[i];
			if(includedArcns[f.arcn])
			{
				//console.log('NonForced: skipping %s because it is already in arcn %d', f.name, f.arcn);
				continue;
			}
			
			//console.log('NonForced: including %s from arch %d', f.name, f.arcn);
			
			// Otherwise, include this file.
			neededFiles.push(f);
			includedExpSize += f.size;
		}
		
		// Tell the rest of the world about our choices.
		this.mPendingItems = neededFiles;
		this.mTotalBytes = includedExpSize;
		this.mSpaceNeeded = includedExpSize + includedArcSize;
	},

	// Callback from Manifest.foreach.

	_compareItems: function ( key, dst, src )
	{
		var ditem = dst[key];
		var sitem = src[key];

		// Early out for removed file.  Always delete.
		if ( ! sitem )
		{
			var fname = this.mLocalRoot + key;
			var cb = function(err)
			{
				if (err)
				{
					console.log('Error deleting ' + fname + ' error: ' + err);
				}
			}
			FileSystem.deleteFile(fname, cb);

			// If the item was pending, delete the temporary file it was downloading
			if ('pending' in ditem )
			{
				fname = fname + '.tmp';
				FileSystem.deleteFile(fname, cb);
			}
			return false;
		}

		var isJS = this._extensionMatch ( key, 'js' );

		// Don't download the html or the js with noJS.
		if (this._noJS && (isJS || key == "index.html"))
		{
			// Don't download JS!! keep it in the local manifest, but don't push it to download
			return true;
		}

		sitem.name = key;
		this.mNumRemoteManifestFiles += 1;
		this.mNumRemoteManifestBytes += sitem.size;

		// No local version or version mismatch, must download.
		if ( ! ditem || ditem.hash != sitem.hash)
		{
			if ( isJS )
			{
				this.mNewJS = true;
			}

			// Tally the space we need for downloading new items
			this.mTotalBytes += sitem.size;

			// Add to the pending queue.
			this.mPendingItems.push ( sitem );
		}
		
		return true;
	},

	// Utility method to check for case-insensitive match for file extension.
	
	_extensionMatch: function ( fname, ext )
	{
		var pattern = new RegExp ( '^.*\.(' + ext + ')$', 'i' );
		var ret = fname.match ( pattern );
		return ret;
	},

	// Once in download state, this method is called to start downloading 
	// assets from manifest.  When each asset successfully completes, this method
	// will also be called to start the next download.  This method institutes
	// the logic for having a limited number of concurrent downloads from
	// the mCurrentRequests and mConcurrentRequests members.

	_downloadPendingItems: function ()
	{
		if (this.mValid && !this.mPaused)
		{
			// Are we done?
			if ( this.mPendingItems.length == 0 && this.mActiveRequests.length == 0)
			{
				if (this.mTotalBytes > 0)
				{
					this._writeManifest ();
				}
				this._writeConfig();

				// Trigger done callback and reset.
				this.mDoneCb ( null, this.mManifest );
				this.reset ();
				return;
			}

			// Not done, pop more pending items and start their downloads.
			while ( this.mPendingItems.length && this.mActiveRequests.length < this.mConcurrentRequests )
			{
				// Download the next pending file.
				var item = this.mPendingItems.pop ();
				item.retrySchedule = this.mRetrySchedule.slice(0);
				this._downloadItem(item);
			}
		}
	},
	
	_downloadItem: function(item)
	{
		this.mActiveRequests.push(item);
		var remoteUrl = this.mRemoteUrl + item.name;
		if(item.mangled)
		{
			var i = remoteUrl.lastIndexOf('.');
			remoteUrl = remoteUrl.substr(0, i) + '-' + remoteUrl.substr(i+1) + '.bin';
		}

		Util.OperationWithRetries((function(failCb)
		{
			// Start the download.
			var dlFile = new DownloadFile();
			var id = this.mConnections.push(dlFile) - 1;
			dlFile.start(this.mLocalRoot + item.name,
				'GET',
				remoteUrl + Util.getCacheBustingString(),
				[],
				this._onDownloadItemComplete.bind(this, item, failCb, id));
		}).bind(this), (function()
		{
			console.log('Manifest download failed. Too many failed download attempts for ' + item.name );
			this._processError ( 'Could not download file ' + item.name , true);
		}).bind(this), this.mFailEarly);
	},

	_removeActiveRequest: function (item)
	{
		for (var i in this.mActiveRequests)
		{
			if (item == this.mActiveRequests[i])
			{
				this.mActiveRequests.splice(i, 1);
			}
		}
	},

	// Callback for completion of download started in downloadItem method.
	// Will throw if item does not have pending member set.

	_onDownloadItemComplete: function ( item, failCb, id, status, hash )
	{
		try
		{
			delete this.mConnections[id];
			// Was there an error or bad download?
			if(status != 200 || item.hash != hash)
			{
				// Try to download the item again.
				console.log('Download failed.  Retrying ' + item.name );
				console.log('Status: ' + status + ' manifest hash: ' + item.hash + ' actual hash: ' + hash);
				failCb();
				return;
			}
			
			// Is this an archive?
			if(item.files)
			{
				// Temporarially increase the max number of connections while we decompress the archive.
				++this.mConcurrentRequests;
				
				FileSystem.decompressFile(this.mLocalRoot + item.name, this.mLocalRoot, false, (function(err, files)
				{
					// Restore max connections to original value.
					--this.mConcurrentRequests;
					
					// Delete the zip file.
					FileSystem.deleteFile(this.mLocalRoot + '/' + item.name);
					
					if(err)
					{
						// Try to download the item again.
						console.log('Decompress failed.  Retrying ' + item.name );
						failCb();
					}
					
					for(var i=0; i < item.files.length; ++i)
					{
						var f = item.files[i];
						this.mManifest.mJson[f.name] = {size: f.size, hash: f.hash};
					    if (typeof f.encryption != "undefined")
						this.mManifest.mJson[f.name].encryption = f.encryption;
					}

					this._removeActiveRequest(item);
					this.mCompleteBytes += Number(item.expSize);
					this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
					this._downloadPendingItems ();
				}).bind(this));
			}
			else
			{
				// Update our working manifest.
				this.mManifest.mJson[item.name] = {size: item.size, hash: item.hash};
			    if (typeof item.encryption != "undefined")
				this.mManifest.mJson[item.name].encryption = item.encryption;
				
				// Make callbacks (like a boss).
				this._removeActiveRequest(item);
				this.mCompleteBytes += Number(item.size);
				this.mProgressCb ( this.mCompleteBytes, this.mTotalBytes );
				this._downloadPendingItems ();
			}
		}
		catch ( ex )
		{
			// Unlikely, but safety
			NgLogException ( ex );
			this._processError ( 'Error after finishing the download of item ' + item 
				+ '. status is ' + status , true );
		}
	},

	// Flush changes to locally cached manifest file.

	_writeManifest: function ()
	{
		console.log("DM Complete!");
		try
		{
			if (this.mManifest)
				this.mManifest.write ( this.mLocalPath );
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	},

	_writeConfig: function ()
	{
		try
		{
			if (this._Config)
			{
				// console.log("writing |%s| to %s", JSON.stringify(this._Config), this.mLocalRoot + Capabilities._getConfigFile());
				FileSystem.writeFile(this.mLocalRoot + Capabilities._getConfigFile(),
					JSON.stringify(this._Config), function(err) {console.log(err); } );
			}
		}
		catch (ex)
		{
			NgLogException(ex);
		}
	}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Proc = require('NGCore/Client/Core/Proc').Proc;
var Class = require('NGCore/Client/Core/Class').Class;
var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var LifeListener = MessageListener.subclass(
{
	initialize: function(listen)
	{
		LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
		this._listener = listen;
	},

	destroy: function()
	{
		LifecycleEmitter.removeListener(this);
	},

	onLifecycleUpdate: function(event)
	{
		switch (event)
		{
			case Device.LifecycleEmitter.Event.Resume:
				this._listener.onResume();
				break;
		}
	}
});

exports.LocalGameList = Class.singleton (
/** @lends Core.LocalGameList.prototype */
{
	classname: 'LocalGameList',

	/**
	 * @class The <code>LocalGameList</code> class constructs objects that handle the loading and updating of a user's game list.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this);

		new LifeListener(this);
		this.mRefCount = 0;
		this.mRefTable = [];
		this.mSpaceAvailable = 0;
		this.mRequiredAvailableSpace = 0;
		
		this.mSpaceCB = [];

		this._getRepoSpaceSendGen();

		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";
		this.onResume();
	},


	/** @private */
	onResume: function()
	{
		this._reloadGameList();
	},

	_reloadGameList: function()
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				this.mGameList = list;
				if (typeof this.mListListen == 'function')
					this.mListListen();
			}).bind(this),
			true
		);
	},

	/** @private */
	setListListener: function(funk)
	{
		this.mListListen = funk;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 302
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method _setUpdateProgressVisible = 7
	// Method _setUpdateProgressBounds = 8
	// Method pauseUpdate = 9
	// Method resumeUpdate = 10
	// Method cancelUpdate = 11
	// Method updateProgress = 12
	// Method runGame = 13
	// Method finishGame = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift() );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._updateDoneRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 12:
					instance._updateProgressRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[302] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateDoneRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateDone from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_updateProgressRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "cur" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "cur" ] === undefined )
		{
			NgLogE("Could not parse cur in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "total" ] = Proc.parseInt( cmd[ 2 ] );
		if( obj[ "total" ] === undefined )
		{
			NgLogE("Could not parse total in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Proc.parseBool( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in LocalGameList.updateProgress from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_updateGameSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 2 + "," + this.__objectRegistryId + "," + Base64.encode( obj[ "url" ] ) + "," + obj[ "id" ]  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 4 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_deleteGameSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 6 + "," + this.__objectRegistryId + "," + Base64.encode( obj[ "mdFive" ] )  );
	},
	
	/** @private */
	__setUpdateProgressVisibleSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 7 + "," + this.__objectRegistryId + "," + ( obj[ "visible" ] ? 1 : 0 )  );
	},
	
	/** @private */
	__setUpdateProgressBoundsSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 8 + "," + this.__objectRegistryId + "," + obj[ "x" ] + "," + obj[ "y" ] + "," + obj[ "w" ] + "," + obj[ "h" ]  );
	},
	
	/** @private */
	_pauseUpdateSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 9 + "," + this.__objectRegistryId + "," + Base64.encode( obj[ "url" ] )  );
	},
	
	/** @private */
	_resumeUpdateSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 10 + "," + this.__objectRegistryId + "," + Base64.encode( obj[ "url" ] )  );
	},
	
	/** @private */
	_cancelUpdateSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 11 + "," + this.__objectRegistryId + "," + Base64.encode( obj[ "url" ] )  );
	},
	
	/** @private */
	_runGameSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 13 + "," + this.__objectRegistryId + "," + Base64.encode( obj[ "url" ] )  );
	},
	
	/** @private */
	_finishGameSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 302 + "," + 14 + "," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// updateGame: function( url, id ) {}
	
	// _updateDoneRecv: function( cmd ) {}
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// deleteGame: function( mdFive ) {}
	
	// _setUpdateProgressVisible: function( visible ) {}
	
	// _setUpdateProgressBounds: function( x, y, w, h ) {}
	
	// pauseUpdate: function( url ) {}
	
	// resumeUpdate: function( url ) {}
	
	// cancelUpdate: function( url ) {}
	
	// _updateProgressRecv: function( cmd ) {}
	// runGame: function( url ) {}
	
	// finishGame: function(  ) {}
	

// {{/Wg Generated Code}}
	
	_setProgressVisible: function (progressVisible) {
		this.progressVisible = progressVisible;
		this.__setUpdateProgressVisibleSendGen({visible: progressVisible});
	},
	
	_setProgressBounds: function(bounds) {
		this.__setUpdateProgressBoundsSendGen(
		{
			x: bounds[0],
			y: bounds[1],
			w: bounds[2],
			h: bounds[3]
		});
	},
	
	_createProcSwitchDialog: function(title)
	{
		var UI = require('NGCore/Client/UI').UI;
		var Device = require('NGCore/Client/Device').Device;
		var w = NGWindow.outerWidth;
		var h = NGWindow.outerHeight;
		
		if(Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.Landscape
			|| Device.OrientationEmitter.getInterfaceOrientation() == Device.OrientationEmitter.Orientation.LandscapeLeft)
		{
			w = NGWindow.outerHeight;
			h = NGWindow.outerWidth;
		}
		
		var r = new UI.ViewGeometry.Rect(0, 0, w, h);
		
		var background = new UI.View({
			'frame': r.array(),
			'title': title,
			'backgroundColor': "8000",
		});
		
		r.inset(Math.round( (h - 238) / 2.0 ), 10);
		
		var dialog = new UI.View({
			'frame': r.array(),
			'gradient': {
				gradient: ["FF102031 0.0", "FF102031 0.394", "FF101820 0.394", "FF101820 1.0"],
				outerLine: "FF9c 1.0",
			}
		});
		background.addChild(dialog);

		r.x = r.y = 0;
		
		var header = new UI.Label({
			'frame': r.sliceVertical(94).array(),
			'text': (title || "Please Wait…"),
			'textColor': "FFFF",
			'textShadow': "8000 1.0 {0,-1}",
			'textSize': 24.0,
			'textGravity': [0.0, 0.5],
			'textInsets': [10, 30, 10, 30],
		});
		dialog.addChild(header);
		
		r.inset(36, 36 + Math.floor( (r.w - r.h) / 2));
		r.h = r.w;
		
		var spinner = new UI.Spinner({
			'frame': r.array(),
		});
		dialog.addChild(spinner);
		
		UI.Window.document.addChild(background);
		
		return background;
	},

	/**
	* Restart the current game
	*/
	restartGame: function()
	{
		this.runGame(Capabilities.getServer() + "/" + Capabilities.getGame());
	},

	/**
	* Launch a game from the specified URL.
	* @param {String} url The specified URL of a game. Null to return to mobage.
	*/
	
	runGame: function( url )
	{
		console.log("Calling runGame with " + url);
		if (!url)
		{
			console.log("Finishing");
			this._finishGame();
		}
		else
		{
			this._runGameSendGen({url: Util.NormalizeUrl(url)});
		}
	},

/** private */
	_finishGame: function()
	{
		this._finishGameSendGen();
	},

	// Next 5 functions are for mobage, not developers.

	// callback = function(gameUrl, dl'd, total, error)
	// mobage responsibility to intercept when dl'd == total, update is finished
	//	or know if there was an error by checking that param

	listenUpdates: function(callback)
	{
		this.mUpdateListener = callback;
	},

	stopUpdateListening: function()
	{
		delete this.mUpdateListener;
	},

	pauseUpdate: function(url)
	{
		this._pauseUpdateSendGen({url: Util.NormalizeUrl(url)});
	},

	resumeUpdate: function(url)
	{
		this._resumeUpdateSendGen({url: Util.NormalizeUrl(url)});
	},

	cancelUpdate: function(url)
	{
		this._cancelUpdateSendGen({url: Util.NormalizeUrl(url)});
	},

	/**
	* Update an application at the specified URL.
	* @example Core.LocalGameList.updateGame(url, (function(err)
	*	{
	*		if (err)
	*		{
	*			NgLogE("GameHub error updating game! " + err);
	*			Network.Util.showSimpleNetworkError();
	*			this._loadingGame = false;
	*		}
	*		else
	*		{
	*			Core.LocalGameList.runGame(url);
	*		}
	*	});
	* @param {String} url The specified URL.
	* @param {Function} cb The callback function to pass in.
	*/
	
	updateGame: function( url , cb )
	{
		var obj = {};
		obj.url = Util.NormalizeUrl(url);
		obj.id = this.mRefCount;
		this.mRefTable[this.mRefCount++] = cb;

		this._updateGameSendGen(obj);
		return obj.id;
	},
	
	/**
	* Launch an updated application from the specified URL.
	* @example Core.LocalGameList.runUpdatedGame('/games/MyGames');
	* @param {String} url The specified URL of an updated application.
	*/
	
	runUpdatedGame: function (url)
	{
		if (!url)
		{
			this._finishGame();
			return;
		}

		this.updateGame(url,
			(function(err)
			{
				if (err)
				{
					NgLogE("LGL Error updating game! " + err);
					Util.showFatalErrorDialog();
				}
				else
				{
					this.runGame(url);
				}
			}).bind(this)
		);
	},

	_updateProgressRecv: function( cmd )
	{
		var obj = {};
		this._updateProgressRecvGen(cmd, obj);
		if (this.mUpdateListener)
			this.mUpdateListener(obj.url, obj.cur, obj.total, obj.error);
	},

	_updateDoneRecv: function( cmd )
	{
		var obj = {};
		this._updateDoneRecvGen(cmd, obj);

		this._reloadGameList();

		var cb = this.mRefTable[obj.id];
		if (cb)
		{
			cb(obj.error);
		}

		delete this.mRefTable[obj.id];
		this._getRepoSpaceSendGen();
	},

	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space - 7340032; // KJ report 7mb less
		console.log('LocalGameList.got response:', this.mSpaceAvailable, 'and need:', this.mRequiredAvailableSpace);
		
		if(this.mRequiredAvailableSpace > this.mSpaceAvailable)
		{
			var errorAlert = new UI.AlertDialog();
			errorAlert.setText(Core.Localization.getString("SD card is full"));
			errorAlert.setChoices([Core.Localization.getString("Exit")]);
			errorAlert.game = this.game;
			errorAlert.onchoice = function(ret)
			{
				errorAlert.hide();
				LifecycleEmitter.exitProcess();
			};
			errorAlert.show();
		}
		else
		{
			for(var i=0; i < this.mSpaceCB.length; ++i)
			{
				this.mSpaceCB[i]();
			}
			this.mSpaceCB = [];
			this.mRequiredAvailableSpace = 0;
		}
	},

	/**
	 * @private
	 */
	getGameList: function()
	{
		// Caveat! This will return an empty list if it is the first call. Must initialize beforehand.-KJ
		return this.mGameList;
	},

	/**
	 * @private
	 */
	updateGameList: function(list)
	{
		this.mGameList = list;
	},

	/**
	 * @private
	 */
	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace += space;
		
		this.mSpaceCB.push(cb);
		console.log('LocalGameList.freeSpace space=', this.mRequiredAvailableSpace);
		if(this.mSpaceCB.length == 1)
		{
			console.log('LocalGameList.sending request to native');
			// Send request to native if this is the first requester.
			this._getRepoSpaceSendGen();
		}
	},

	/**
	 * @private
	 */
	deleteGame: function(url)
	{
		url = Util.NormalizeUrl(url);
		var hash = toMD5(url);
		this._deleteGameSendGen({mdFive:hash});

		var self = this;
		var doneCB = function ()
		{
			NgLogD("LocalGameList finished deleting game from " + self.mActiveGameKey + " for " + hash );
		};

		// Update cached game list to match what's going to happen in high-priv.
		// Matches logic in _LocalGameList._deleteGameFromStorage, but doesn't
		// write to Storage key.
		if( this.mGameList )
		{
			var list = this.mGameList;
			var good = false;
			var ind;
			var out = [];
			for(ind = 0; ind < list.length; ++ind)
			{
				if(list[ind].name == hash)
					good = true;
				else
					out.push(list[ind]);
			}

			if( good )
			{
				NgLogD("LocalGameList found and removed " + hash);
				this.mGameList = out;
			}
			else
				NgLogD("LocalGameList failed to find and remove " + hash);
		}
		else
			NgLogD("LocalGameList cache not warm, can't remove " + hash);
	},

	/**
	 * Check if an update is available for the specified application.<br><br>
	 * The following code illustrates how to retrieve an application name to pass in for this call.
	 * @param {String} game The specified game. Use <code>{@link Core.Capabilities.getGame}</code> to return the game name.
	 * @param {Function} callback The function to call once the check is complete.
	 * @example
	 *
	 * updateButton.onclick = function() {
	 *     LocalGameList.updateAvailable(Core.Capabilities.getUrl(), function(updated, spaceNeeded) {
	 *         if (updated)
	 *             LGL.runUpdatedGame(Core.Capabilities.getUrl());
	 *     });
	 * };
	 * @status
	 */
	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Device'] = exports; /**
 * <p>Classes and objects contained by the Device module.</p>
 * @name Device
 * @namespace
 * @description <p>The Device module is a collection of classes that support the effect of physical movement on a device.
 * Each class instantiates a device singleton that emits when specific device conditions are met:</p>
 *<ul>
 *<li><code>{@link Device.KeyEmitter}</code>: A singleton object for emitting when the user presses or releases a device hardware key.</li>
 *<li><code>{@link Device.LifecycleEmitter}</code>: A singleton object for emitting when device lifecycle events occur.</li>
 *<li><code>{@link Device.LocationEmitter}</code>: A singleton object for emitting the geographic location of a device.</li>
 *<li><code>{@link Device.MemoryEmitter}</code>: A singleton object for emitting when low-memory states occur on a device.</li>
 *<li><code>{@link Device.MotionEmitter}</code>: A singleton object for emitting objects that collect spatial data from a device.</li>
 *<li><code>{@link Device.NetworkEmitter}</code>: A singleton object for emitting when a change in network status occurs for a device.</li>
 *<li><code>{@link Device.OrientationEmitter}</code>: A singleton object for emitting when a change to the physical orientation of the device occurs.</li>
 *<li><code>{@link Device.ShakeEmitter}</code>: A singleton object for emitting when the device detects a shake gesture.</li>
 *</ul>
 */
exports.Device =
{
    LifecycleEmitter:    require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter,
    LocationEmitter:     require('NGCore/Client/Device/LocationEmitter').LocationEmitter,
    MemoryEmitter:       require('NGCore/Client/Device/MemoryEmitter').MemoryEmitter,
    MotionEmitter:       require('NGCore/Client/Device/MotionEmitter').MotionEmitter,
    NetworkEmitter:      require('NGCore/Client/Device/NetworkEmitter').NetworkEmitter,
    OrientationEmitter:  require('NGCore/Client/Device/OrientationEmitter').OrientationEmitter,
    ShakeEmitter:        require('NGCore/Client/Device/ShakeEmitter').ShakeEmitter,
    KeyEmitter:          require('NGCore/Client/Device/KeyEmitter').KeyEmitter,
    PushNotificationEmitter: require('NGCore/Client/Device/_PushNotificationEmitter').PushNotificationEmitter,
    InAppPurchaseEmitter: require('NGCore/Client/Device/_InAppPurchaseEmitter').InAppPurchaseEmitter,
    InAppPurchase:       require('NGCore/Client/Device/_InAppPurchase').InAppPurchase,
    IPCEmitter:              require('NGCore/Client/Device/IPCEmitter').IPCEmitter,
    LayoutEmitter:		require('NGCore/Client/Device/LayoutEmitter').LayoutEmitter
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core'] || {}; $MODULE_REGISTRY['NGCore/Client/Core'] = exports; /**
 * <p>Classes and objects contained by the Core module.</p>
 * @name Core
 * @namespace
 * @description <p>The Core module is a collection of classes that provide applications with access to:</p>
 * <ul>
 * <li>Core components of a device.</li>
 * <li>APIs that define a class-based structure for development.</li>
 * <li>Objects that support application updates.</li>
 * </ul>
 * <p>Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link Core.Analytics}</code>: Construct objects that keep track of game-specific items that require analysis and counting.</li>
 * <li><code>{@link Core.Capabilities}</code>: A singleton object that contains data about device hardware components.</li>
 * <li><code>{@link Core.Class}</code>: Supports construction of objects and classes for use in OOP environments.</li>
 * <li><code>{@link Core.Color}</code>: Control the RGB color components of a device.</li>
 * <li><code>{@link Core.LocalGameList}</code>: Construct objects that manage a user's game list.</li>
 * <li><code>{@link Core.MessageEmitter}</code>: A base class object for constructing objects that emit application notifications.</li>
 * <li><code>{@link Core.MessageListener}</code>: A base class object for constructing objects that handle application notifications.</li>
 * <li><code>{@link Core.NativeAppLaunch}</code>: Construct objects for storing <code>intent</code> strings.</li>
 * <li><code>{@link Core.Point}</code>: Control the point values for <i>x</i> and <i>y</i> coordinates.</li>
 * <li><code>{@link Core.Rect}</code>: Construct rectangle objects.</li>
 * <li><code>{@link Core.Size}</code>: Control the values for <i>height</i> and <i>width</i> components.</li>
 * <li><code>{@link Core.Time}</code>: A singleton that contains data about device timing values.
 * <li><code>{@link Core.UpdateEmitter}</code>: Control the application update time rate.</li>
 * <li><code>{@link Core.Vector}</code>: Control the vector values for <i>x</i> and <i>y</i> coordinates.</li>
 * </ul>
 */
exports.Core =
{
    Analytics:             require('NGCore/Client/Core/Analytics').Analytics,
    Base64:				   require('NGCore/Client/Core/Base64').Base64,
	Capabilities:          require('NGCore/Client/Core/Capabilities').Capabilities,
	Class:                 require('NGCore/Client/Core/Class').Class,
	Color:                 require('NGCore/Client/Core/Color').Color,
	Vector:                require('NGCore/Client/Core/Vector').Vector,
	Point:                 require('NGCore/Client/Core/Point').Point,
	Size:                  require('NGCore/Client/Core/Size').Size,
	Rect:                  require('NGCore/Client/Core/Rect').Rect,
	MessageEmitter:        require('NGCore/Client/Core/MessageEmitter').MessageEmitter,
	MessageListener:       require('NGCore/Client/Core/MessageListener').MessageListener,
	ObjectRegistry:        require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry,
	Time:                  require('NGCore/Client/Core/Time').Time,
	toMD5:                 require('NGCore/Client/Core/toMD5').toMD5,
	SHA1:                  require('NGCore/Client/Core/SHA1').SHA1,
	UpdateEmitter:         require('NGCore/Client/Core/UpdateEmitter').UpdateEmitter,
	Proc:                  require('NGCore/Client/Core/Proc').Proc,
	Logger:				   require('NGCore/Client/Core/Logger').Logger,
	LocalGameList:         require('NGCore/Client/Core/LocalGameList').LocalGameList,
	Localization:          require('NGCore/Client/Core/Localization').Localization,    
	_LocalGameList:        require('NGCore/Client/Core/_LocalGameList')._LocalGameList,
	NativeAppLaunch:       require('NGCore/Client/Core/NativeAppLaunch').NativeAppLaunch,
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Capabilities'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Capabilities'] = exports; 	////////////////////////////////////////////////////////////////////////////////
// Class Capabilities
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

////////////////////////////////////////////////////////////////////////////////

exports.Capabilities = Class.singleton(
/** @lends Core.Capabilities.prototype */
{
	classname: 'Capabilities',
	_configFile: 'configuration.json',

	/**
	 * @class The <code>Capabilities</code> class constructs a singleton object that contains device properties. These objects represent the device and provide access to device information. 
	 * This class also provides information about how a device and game servers communicate.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this);

        // Please keep this on one line, sed won't update otherwise
		this._fields = {version: 'sdks_1.1-20110616-1.1.6', buildDate: '20110701', buildHash: 'g3984b42'};
	},

	_getConfigFile:			function() {return this._configFile;},
	_isGameLoaded:			function() {return this._fields._gamePreLoaded;},

	/**
	 * Return the object stored in configuration.json for your game.
	 * @returns {Object} The JSON.parsed object represented in your configuration.json file.
	 * @type Object
	 * @status
	 */
	getConfigs:			function() {return this._configuration;},

	/**
	 * Return the SDK version number from the <code>Capabilities</code> of this device.
	 * @returns {String} The version of the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKVersion:           function() { return this._fields.version },

	/**
	 * Return the build date for the currently installed SDK. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildDate:           function() { return this._fields.buildDate },
	
	/**
	 * Return the build hash of the currently installed SDK.
	 * @returns {String} The build hash for the SDK on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSDKBuildHash:           function() { return this._fields.buildHash },

	/**
	 * Return the version of the currently running ngCore binary
	 * @returns {String} The version of ngCore running
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryVersion:           function() { return this._fields.binaryVersion },

	/**
	 * Return the build date for the currently running ngCore binary. The build date is in the format <i>YYYYMMDD</i>.
	 * @returns {String} The build date for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildDate:           function() { return this._fields.binaryBuildDate },

	/**
	 * Return the build hash of the currently running ngCore binary
	 * @returns {String} The build hash for the ngCore binary
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBinaryBuildHash:           function() { return this._fields.binaryBuildHash },
	
	/**
	 * Return the device ID. 
	 * @returns {String} The device ID for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getUniqueId:           function() { return this._fields.uniqueId },

	/**
	 * Return the lifetime constant value of the device.<br><br>
	 * <b>Note:</b> Currently only available on Android.
	 * @returns {String} <code>Settings.Secure.ANDROID_ID</code>: A 64-bit number as a hex string randomly generated on first boot of the device. 
	 * <b>Note:</b> This value only changes when the device is reset.
	 * @status Android
	 */
	getLifetimeName: function() { return this._fields.lifetimeName },
	
	/**
	 * Return the device name.
	 * @returns {String} The device name for the device running the application.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceName:         function() { return this._fields.deviceName },
	
	/**
	 * Return the operating system.
	 * @returns {String} The operating system of the device running the application.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformOS:         function() { return this._fields.platformOs },
	
	/**
	 * Return the operating system version number.
	 * @returns {String} The version number of the operating system running on the device.
	 * @type String
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPlatformOSVersion:  function() { return this._fields.platformOsVersion },
	
	/**
	 * Return the device hardware type.
	 * @returns {String} The type of device hardware running the application.
	 * @type String
	 * @status iOS, Flash, Test, iOSTested, AndroidTested
	 */
	getPlatformHW:         function() { return this._fields.platformHw },
	
	/**
	 * Return the total amount of installed memory.
	 * @returns {Number} The amount of installed memory on the device running the application.
	 * @type Number
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPhysicalMem:        function() { return this._fields.physicalMem },
	
	/**
	 * Return the total number of installed CPUs.
	 * @returns {Number} The number of CPUs installed on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getPhysicalCpus:       function() { return this._fields.physicalCpus },
	
	/**
	 * Return the number of active CPUs.
	 * @returns {Number} The number of active CPUs on the device running the application.
	 * @type Number
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getActiveCpus:         function() { return this._fields.activeCpus },
	
	/**
	 * Return the installed user language. 
	 * @returns {String} The installed user language on the device running the application.
	 * Expressed as a canonicalized IETF BCP 47 language identifier.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLanguage:         function() { return this._fields.language },

	_getBoot:         function() { return this._fields.boot },
	_getBootServer:         function() { return this._fields.bootServer },

	/**
	 * Return the URL for the content of this application.
	 * @returns {String} The URL to content for this application.
	 * @status
	 */
	getContentUrl:			function() {return this._fields.contentUrl;},

	/**
	 * Return the name of the root application. Root application refers to the application that launches when the user taps the application icon.
	 * @returns {String} The directory name for the root application.
	 * @status
	 */
	getBootGame:         function() { return this._fields.bootgame },

	/**
	 * Return the starting server for an application.
	 * @returns {String} The start server.
	 * @type String
	 * @status
	 */
	getStartingServer:         function() { return this._fields.startingServer },

	/**
	 * Return the name of the application bundled with the binary of this build.
	 * @returns {String} The name of the bundled game.
	 * @type String
	 * @status
	 */
	getBundleGame:         function() { return this._fields.bundleGame },

	/**
	 * Return the server bundled with the binary of this build.
	 * @returns {String} The bundle server.
	 * @type String
	 * @status
	 */
	getBundleServer:         function() { return this._fields.bundleServer },

	/**
	 * Return the bundle identifier for the binary of this build.
	 * @returns {String} The bundle identifier.
	 * @type String
	 * @status
	 */
	getBundleIdentifier:         function() { return this._fields.bundleIdentifier },
	
	/**
	 * Return the directory name of the currently running application.
	 * @returns {String} The current folder name for the application.
	 * @type String
	 * @status iOS, Android, Flash
	 */
	getGame:         function() { return this._fields.game },

	/**
	 * Return the server from which an application was downloaded.
	 * @returns {String} The download server.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getServer:         function() { return this._fields.server },

	/**
	 * Return the full URL for the current application.
	 * @returns {String} The URL from which a application is downloaded.
	 * @type String
	 * @status
	 */
	getUrl:         function() { return this._fields.url },

	/**
	 * Return the logical screen width for this device.
	 * @returns {Number} The current screen width of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenWidth:        function() { return this._fields.screenWidth },
	
	/**
	 * Return the logical screen height for this device.
	 * @returns {Number} The current screen height of the device.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScreenHeight:       function() { return this._fields.screenHeight },
	
	/**
	 * Return a reasonable factor for scaling logical coordinates to the current display.
	 * @returns {Number} Logically scaled screen units for the device.
	 * @type Number
	 * @status
	 */
	getScreenUnits:        function() { return this._fields.screenUnits },
	
	/**
	 * Return the number of physical pixels associated with one unit of logical space.
	 * @returns {Number} The total number of pixels that equal one screen unit.
	 * @type Number
	 * @status
	 */
	getScreenPixelUnits:       function() { return this._fields.screenPixelUnits },
	
	/**
	 * Return the maximum number of supported textures.
	 * @returns {Number} The maximum number of supported textures per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureSize:     function() { return this._fields.maxTextureSize },
	
	/**
	 * Return the maximum number of supported texture units.
	 * @returns {Number} The maximum number of supported texture units per coordinate (<i>x</i>,<i>y</i>).
	 * @type Number
	 * @status Test, iOSTested, AndroidTested
	 */
	getMaxTextureUnits:    function() { return this._fields.maxTextureUnits },
	
	/**
	 * @deprecated Replaced by {@link UI.GLView#getOGLExtensions}.
	 */
	getOglExtensions:      function() { return this._fields.oglExtensions },
	
	/**
	 * Return the directory path to the temp directory for this device.
	 * @returns {String} The directory path to the temp directory on the device.
	 * @type String
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTmpDir:           function() { return this._fields.tmpDir },

	/**
	 * Check the <code>Capabilities</code> of this device for an accelerometer.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an accelerometer.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasAccel:           function() { return this._fields.hasAccel },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a gyroscope.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains an gyroscope.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasGyro:            function() { return this._fields.hasGyro },
	
	/**
	 * Check the <code>Capabilities</code> of this device for touchscreen input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports touchscreen input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasTouch:           function() { return this._fields.hasTouch },
	
	/**
	 * Check the <code>Capabilities</code> of this device for multi-touch input support.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application supports multi-touch input.
	 * @type Boolean
	 * @status iOS, Test, iOSTested, AndroidTested
	 */
	getHasMultiTouch:      function() { return this._fields.hasMultiTouch },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a GPS unit.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a GPS unit.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasGps:             function() { return this._fields.hasGps },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a magnetic compass.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a magnetic compass.
	 * @type Boolean
	 * @status Android, Test, iOSTested, AndroidTested
	 */
	getHasCompass:         function() { return this._fields.hasCompass },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a hardware keyboard.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a hardware keyboard.
	 * @type Boolean
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHasHwKeyboard:      function() { return this._fields.hasHwKeyboard },
	
	/**
	 * Check the <code>Capabilities</code> of this device for a <b>Back</b> button.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a <b>Back</b> button.
	 * @status
	 */
	getHasBackButton:      function() { return this._fields.hasBackButton },

	/**
	 * Check the <code>Capabilities</code> of this device for a camera.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application contains a camera.
	 * @type Boolean
	 * @status Test, iOSTested, AndroidTested
	 */
	getHasCamera:          function() { return this._fields.hasCamera },
	
	/**
	 * Check the <code>Capabilities</code> of this device for access to a wide area network (WAN).
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to a WAN.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWwan:            function() { return this._fields.hasWwan },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @type Boolean
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getHasWifi:            function() { return this._fields.hasWifi },

	/**
	 * Check the <code>Capabilities</code> of this device for access to a Wi-Fi network.
	 * @returns {Boolean} Returns <code>true</code> when the device running the application has access to Wi-Fi.
	 * @status
	 */
	getCarrier:            function() { return this._fields.carrier },

	/**
	 * Return the URL used to launch this application.
	 * @returns {String} The URL for launching this application. If the application is not launched from a URL, returns an empty string.
	 * @type String
	 * @status
	 */
	getIntentUrl:            function() { return this._fields.intentUrl },
	
	/**
	 * Return the height of the system status bar.
	 * @returns {Number} The status bar height rounded to the nearest integer (in pixels).
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 * @status Android
	*/
     getStatusBarHeight:            function() { return this._fields.statusBarHeight },
	
	/**
	 * Return the device locale.
	 * @returns {String} The regional location of a device.
	 * The <code>locale</code> string is a combination of ISO 639-1 and ISO 3166-1. For example, <code>en_US</code>, <code>ja_JP</code>.
	 * @type String
	 * @status
	 */
	getLocale: function() { return this._fields.locale },

	/**
	 * Return a list of installed fonts on this device.
	 * @returns {Array (Strings)} An array of font names installed on the system or addressable by name.
	 * @type Array
	 * @status iOS, Android
	 */
	getAvailableFonts: function()
	{
		return this._deserializedFonts || (this._deserializedFonts = JSON.parse(this._fields.availableFonts));
	},
	
	/** @private */
	getAutorotateDisabled: function()
	{
		return this._fields.autorotateDisabled || false;
	},
	

	/**
	 * Return the social server used for this application.
	 * @returns {String} The social server URL. For example, partner.plusplus.com.
	 * @status
	 */	
	getSocialServer: function()
	{
		return this.socialServer;
	},

	/*
	 * Returns the name of the Mobage distribution first installed on the device.
	 * @returns {String} The name of the distribution.
	 */
	getDistributionName: function() 
	{
		return this._fields.distributionName;
	},

	/*
	 * @status
	 */	
	getSourceAppID: function()
	{
		return this._fields.sourceAppID;
	},

	/*
	 * @status Android
	 */	
	getAppSignatures: function()
	{
		return this._fields.appSignatures;
	},
	
	/*
	 * Return the release version of this application.  The value comes directly from the 
	 * configuration.json value for releaseVersion.
	 * @returns {String} The version identifier. For example, 1.1:20110607183748_blf7gety.
	 * @status
	 */
	getAppReleaseVersion: function()
	{
		return this._releaseVersion;
	},
	
	
	/** @private */
	_init: function(dict)
	{
		// parse the dict
		var ifields = [];
		NgParseCommandDictionary(dict, 2, this._fields, ifields);

		try {
			// Change server based on URL passed in
			var items = /(https?:\/\/.+?)\/(.*)/.exec(this._fields.url);
			this._fields.server = items[1];
			this._fields.game  = items[2];
		}
		catch (e)
		{
			NgLogException(e);
		}

		// KJ this is necessary because an empty string passed becomes undefined
		if (!this._fields.intentUrl)
			this._fields.intentUrl = "";

		try
		{
			this._configuration = JSON.parse(this._fields.configJSON);
			this._fields.contentUrl = this._configuration.contentUrl;
			this.socialServer = this._configuration.socialServer;
			this._releaseVersion = this._configuration.releaseVersion;
		}
		catch (e)
		{
			NgLogE("Unable to parse config!! (" + this._fields.configJSON + ")");
			this._fields.contentUrl = this.getServer() + '/' + this.getGame()
			 + (this.getPlatformOS() == 'Android') ? '/android' : "";
		}
		
		console.log( "dict : JS version : " + this.getSDKVersion() );
		console.log( "dict : JS build date : " + this.getSDKBuildDate() );
		console.log( "dict : JS build hash : " + this.getSDKBuildHash() );

		console.log("dict : contentUrl : " + this._fields.contentUrl);
		console.log("dict : socialServer : " + this.socialServer);
		console.log("dict : releaseVersion : " + this._releaseVersion);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 301
	// Method create = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift() );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Capabilities._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[301] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 301 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Localization'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Localization'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Localization'] = exports; var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var FileSystem = require('NGCore/Client/Storage/FileSystem').FileSystem;

var LocalizationEngine = exports.LocalizationEngine = MessageEmitter.subclass(
/** @lends Core.Localization.prototype */
{
	classname: 'Localization',
    
    /**
     * Specifies the directory path to language files this object will load.
     */
    directoryPath:null,
    
    /**
     * Specifies the directory path to a language file for a specific language.
     */
	languageFilePath:null,
    
	/**
	 * @class The <code>Localization</code> class provides applications with access to localized strings.
	 * Applications supply a language code corresponding to a file in <code>Content/Localization/</code> or a JSON object.<br><br> 
     * Loading of dictionary files is an anynchronous process. Applications need to listen for emitted notifications from <code>Localization</code> objects that signal when the language dictionary
     * is modified. When a <code>Localization</code> object emits a notification, localized strings are available to the application (see <code>{@link Core.MessageEmitter#emit}</code>).
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function(directoryPath)
	{
		if(!directoryPath){directoryPath = "./Content/Localization/";}
	    NgLogD("Localization : init ("+directoryPath+")");
	    this.directoryPath = directoryPath;
	    
        this.setLanguage(Capabilities.getLanguage());
	},
    
	/**
	 * Aynchronously load the localization dictionary for the specified language.
     * <br><br>
	 * <b>Notes:</b> 
	 * <ul>
	 * <li>This function looks for the corresponding JSON dictionary file in the <code>Content/Localization</code> directory.
     * For example, <code>Content/Localization/fr.json</code>. If the application cannot load a dictionary, this call has no effect.</li>
     * <li><code>Localization</code> objects emit a notification with the new language string if this call succeeds.</li>
     *</ul>
	 *
	 * @example
	 * Core.Localization.addListener(listener, function()
     * {
     *     listener.label.setText(Core.Localization.getString("Hello World"));
     * });
	 * Core.Localization.setLanguage('es');
	 *
	 * @param {String} language The base name of a JSON dictionary file in <code>./Content/Language</code>.
	 * @see Core.Localization#setDictionary, 
	 * @see Core.MessageListener
	 * @status
	 */    
    setLanguage: function(language)
    {
        var dictionaryPath = this.languageFilePath = this.directoryPath + language + '.json';
        var self = this;
        NgLogD("Localization : reading json file "+ dictionaryPath);
        
		FileSystem.readFile(dictionaryPath, function(error, data)
        {
            if(error === '')
            {
                NgLogD("Localization : successfully read json file "+ dictionaryPath);  
                self.setDictionary(language, JSON.parse(data));
            }
            else
            {
                NgLogD("Localization: unable to read json file "+ dictionaryPath + ", use default english setting instead");                
            }
        });
    },

	/**
	 * Directly set the language code and localization dictionary.
     * <code>Localization</code> objects emit a message with the new language string during this call.
	 * 
	 * @example
     * var chDictionary =    
     * {
     *     "Hello World": "你好世界"
     * };
	 * Core.Localization.setDictionary('ch', chDictionary);
	 * label.setText(Core.Localization.getString("Hello World"));
	 *
	 * @param {String} language A string identifying the specified language or localization.
	 * @param {Object} dictionary An object containing key/value pairs for the specified language.
	 * @see Core.Localization#setLanguage,
	 * @see Core.MessageEmitter#emit
	 * @status
	 */    
    setDictionary: function(lang, dictionary)
    {
        this._lang = lang;
        this._dictionary = dictionary;
        this.emit(this._lang);
    },    
    
    /**
	 * Retrieve a localized string.
     * @param {String} str A localization key.
	 * @returns {String} The localized string or the provided key if the application is unable to lcoate the specified string.
	 * @status
	 */
	getString: function(str)
	{        
        if(this._dictionary && typeof this._dictionary === 'object')
        {
            var value = this._dictionary[str];
            if(value && typeof value !== 'undefined')
            {
                return value;
            }
        }
        
        return this.unknownString(str);
	},
	
	/** @protected */
	unknownString:function(str){
		NgLogD("Localization: ... No localization for "+str+" in "+this._lang);
		return str;
	}
});

/**
 * Global Localization Singleton, gets initialized when the device locale is known.
 */
exports.Localization = LocalizationEngine.singleton({});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage'] = exports; /**
 * <p>Classes and objects contained by the Storage module.</p>
 * @name Storage
 * @namespace
 * @description <p>The Storage module is a collection of classes that support file manipulation operations.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 *  <li><code>{@link Storage.FileSystem}</code>: Construct objects for reading a file, writing to a file, deleting a file, or decompressing a file.</li>
 *  <li><code>{@link Storage.KeyValue}</code>: Construct objects that store key/value pairs.</li>
 * </ul>
 * <b>Note:</b> The static method <code>KeyValueCache.global()</code> creates a <code>KeyValueCache</code> object that multiple applications can use. 
 * @param {String} globalKey The module name for the <code>KeyValueCache</code> object. The <code>global()</code> method creates a new <code>KeyValueCache</code> 
 * when the module with that name doesn't already exist.
 */
exports.Storage =
{
	KeyValue: require('NGCore/Client/Storage/KeyValue').KeyValue,
	KeyValueCache: require('NGCore/Client/Storage/KeyValue').KeyValueCache,
	FileSystem: require('NGCore/Client/Storage/FileSystem').FileSystem,
}; 
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Logger'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Logger'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Logger'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var sprintf = require('NGCore/Shared/Lib/sprintf').sprintf;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

var Logger = Class.singleton(
/** @lends Core.Logger.prototype */
{
	classname: 'Logger',

	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this);
	},

	/** @private */
	_disable: function()
	{
		console.log("Logger : javascript logging disabled");
		console.log = Logger.log = function(message, argv) {};
	},

	_enable: function()
	{
		console.log = Logger.log = function(message, argv)
		{
			if (arguments.length > 1) {
				try {
					var params = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						params[i] = arguments[i];
					}
					var result = sprintf(params);
					params.unshift(result);
					message = params.join(" ");
				} catch (err) {
					var concat = new Array();
					for (var i = 0; i < arguments.length; ++i) {
						concat[i] = arguments[i];
					}
					message = concat.join(" ");
				}
			}
			__underscore_SysLog(message);
		};

		console.log("Logger : javascript logging enabled");
	},

	/**
	 * Log a message to the development console.
	 * @param {string} message
	 * @param {Array} argv Additional arguments to log.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	log: function(message, argv)
	{
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 305
	// Method create = -1
	// Method log = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift() );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Logger._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[305] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 305 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_logSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 305 + "," + 2 + "," + this.__objectRegistryId + "," + Base64.encode( obj[ "msg" ] )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// log: function( msg ) {}
	

// {{/Wg Generated Code}}
	
});

Logger.instantiate();

__underscore_SysLog = function(_massage)
{
	Logger._logSendGen( { msg: _massage } );
}

// JMarr Don't override console.log when on flash.
if(typeof(_NG_TARGET_FLASH) == 'undefined')
	console.log = Logger.log;

exports.Logger = Logger;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Class'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Class'] = exports; exports.Class = require('NGCore/Shared/Class').Class;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Base64'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Base64'] = exports; exports.Base64 = require('NGCore/Shared/Lib/base64').Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Plus/ResultSet'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] || {}; $MODULE_REGISTRY['NGCore/Client/Plus/ResultSet'] = exports; var ClassReq = require('NGCore/Client/Core/Class');
var SystemBindingReq = require('NGCore/Client/UI/SystemBinding');

var ResultSet = ClassReq.Class.subclass({
    classname: "ResultSet",
    initialize: function(continueId) {
        this.items = [];
        this._continueId = continueId;
        this.totalLength = Number.MAX_VALUE;
    },
    /*
	 * Call to getMore adds more items to items list.
	 * Please note that in the callback, it is possible that addedCount == 0
	 * in some cases.  In that case access to items[newIdx] does not yield
	 * any result
	 */
    getMore: function(cb) {
        return SystemBindingReq.SystemBinding._getMoreContacts(this, cb);
    },
    /*
	 * Releases resource used by current ResultSet.
	 *
	 * To avoid resource leakage, please call closeResultSet if getMore
	 * is not called all the way to the end.
	 */
    closeResultSet: function() {
        SystemBindingReq.SystemBinding._closeContactsResultSet(this);
    }
});

exports.ResultSet = ResultSet;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Class'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Class'] || {}; $MODULE_REGISTRY['NGCore/Shared/Class'] = exports; /**
 * The default constructor.
 * @constructor 
 * @class The <code>Class</code> object provides an environment for Object Oriented Programming (OOP) development in Javascript, such as Java or C++.
 * @name Core.Class
 */
var Class = function() {}
exports.Class = Class;

/**
 * Create a new class by extending another class.
 * @example
 * var MyClass = Class.subclass(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * var myClass = new MyClass();
 * myClass.foo('param');
 * @param {Object} extensions Object literal containing new functions for the derived class.
 * @function
 * @name Core.Class.subclass
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.subclass = (function()
{
/**#@+ @ignore */
	// Parse a function body and extract the parameter names.
	function argumentNames(body)
	{
		var names = body.toString().match(/^[\s\(]*function[^(]*\(([^)]*)\)/)[1]
			.replace(/\/\/.*?[\r\n]|\/\*(?:.|[\r\n])*?\*\//g, '')
			.replace(/\s+/g, '').split(',');
		return names.length == 1 && !names[0] ? [] : names;
	}
	
	// Create a function that calls overrideBody with a closure to ancestorBody.
	function overrideMethod(overrideBody, ancestorBody)
	{
		if(ancestorBody !== undefined)
		{
			// Create a function that calls overrideBody with a closure to ancestorBody as the first param.
			var override = function()
			{
				var localThis = this;
				var $super = function() { return ancestorBody.apply(localThis, arguments) };
				Array.prototype.unshift.call(arguments, $super);
				return overrideBody.apply(this, arguments);
			}
		}
		else
		{
			// Create a function that calls overrideBody with undefined as the first param, because ancestorBody is undefined.
			var override = function()
			{
				Array.prototype.unshift.call(arguments, undefined);
				return overrideBody.apply(this, arguments);
			}
		}

		// Hide our dirty tricks from the rest of the world.
		override.valueOf = function() { return overrideBody.valueOf() };
		override.toString = function() { return overrideBody.toString() };
		return override;
	}
	
	// Define some empty functions used later. This is a speed optimization.
	function TempClass() {}
	function emptyFunction() {}
	
	return function()
	{
		// Constructor for new class to be created.
		var properties = arguments[0];
		var classname = properties.classname || "AnonymousClass";
		var NewClass = eval('(function ' + classname + '(){this.initialize.apply(this, arguments)})');
		
		// Copy statics from this.
		for(var property in this)
		{
			if(!this.hasOwnProperty(property)) continue;
			NewClass[property] = this[property];
		}
		
		// Copy prototype from this.
		var ancestorPrototype = this.prototype;
		TempClass.prototype = ancestorPrototype;
		NewClass.prototype = new TempClass();
		NewClass.prototype.superclass = ancestorPrototype;
		NewClass.prototype.constructor = NewClass;
		
		// Copy properties into NewClass prototype.
		for(var property in properties)
		{
			if(!properties.hasOwnProperty(property)) continue;

			// getters / setters behave differently than normal properties.
			var getter = properties.__lookupGetter__(property)
			var setter = properties.__lookupSetter__(property)
			if(getter || setter)
			{
				if(getter)
				{
					// Copy getter into klass.
					var value = getter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupGetter__(property));
					NewClass.prototype.__defineGetter__(property, value);
				}

				if(setter)
				{
					// Copy setter into klass.
					var value = setter;
					if(argumentNames(value)[0] == "$super")
						value = overrideMethod(value, ancestorPrototype.__lookupSetter__(property));
					NewClass.prototype.__defineSetter__(property, value);
				}
			}
			else
			{
				var value = properties[property];
				if(typeof value === "function" && property[0] != '$')
				{
					if(argumentNames(value)[0] == "$super")
					{
						// Create override method if first param is $super.
						value = overrideMethod(value, ancestorPrototype[property]);
					}
					else if(property == 'initialize')
					{
						var ancestorInitialize = ancestorPrototype.initialize
						if(ancestorInitialize)
						{
							// Automatically call inherited constructor.
							var derivedInitialize = value;
							value = function()
							{
								ancestorInitialize.apply(this, arguments);
								derivedInitialize.apply(this, arguments);
							};
						}
					}
					else if(property == 'destroy')
					{
						var ancestorDestroy = ancestorPrototype.destroy
						if(ancestorDestroy)
						{
							// Automatically call inherited destructor.
							var derivedDestroy = value;
							value = function()
							{
								derivedDestroy.apply(this, arguments);
								ancestorDestroy.apply(this, arguments);
							};
						}
					}

					// Copy function into new class prototype.
					NewClass.prototype[property] = value;
				}
				else
				{
					if(property[0] == '$')
						property = property.slice(1);

					// Copy enum into new class and the prototype.
					NewClass[property] = value;
					NewClass.prototype[property] = value;
				}
			}
		}
		
		// Make sure the is an initialize function.
		if(!NewClass.prototype.initialize)
			NewClass.prototype.initialize = emptyFunction;

		return NewClass;
	}
/**#@-*/
})();

/**
 * Create a singleton by extending a class.
 * @example
 * var MySingleton = Class.singleton(
 * {
 *    initialize: function()
 *    {
 *        console.log('constructor');
 *    },
 *    foo: function(v)
 *    {
 *        console.log('MyClass.foo(' + v + ')');
 *    },
 * });
 * MySingleton.foo('param');
 * @param {Object} extensions Object literal containing new functions for the singleton.
 * @function
 * @name Core.Class.singleton
 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
 */
Class.singleton = function()
{
	// Create sublcass as normal.
	var tempClass = this.subclass.apply(this, arguments);
	
	// Hide the initialize.
	var initialize = tempClass.prototype.initialize;
	tempClass.prototype.initialize = function() {};
	
	// Now instantiate.
	var instance = new tempClass();
	
	// Hide every prototype function with an instance function that calls initialize.
	var functions = [];
	/** 
	 * Ensure that the singleton has been created and fully initialized.
	 * @status iOS, Android, Flash
	*/
	var instantiate = function(real)
	{
		// Delete all of the instance functions we added.
		for(var i in functions)
		{
			var func = functions[i];
			delete instance[func];
		}
		
		// Restore the initialize function and call it.
		instance.initialize = initialize;
		instance.initialize();
		
		// Replace instantiate method with an empty function.
		instance.instantiate = function() {};
		
		// Call the function that caused this instantiation.
		var args = Array.prototype.slice.call(arguments, 1);
		return real.apply(instance, args);
	}
	
	// Iterate over all prototype functions.
	for(var i in instance)
	{
		// Don't do anything for setters or getters.
		if(instance.__lookupGetter__(i)
			|| instance.__lookupSetter__(i))
		{
			//TODO Should put proxies here too.
			continue;
		}
			
		var value = instance[i];
		if(typeof(value) == 'function')
		{
			// Remember the function names that we added so that instantiate() can remove them.
			functions.push(i);
			
			// Add an instance function to hide the prototype function, which will call instantiate.
			instance[i] = instantiate.bind(this, value);
		}
	}
	
	// Add instantiate method.
	instance.instantiate = instantiate.bind(this, function() {});
	
	// Return the isntance.
	return instance;
}

/**
 * @ignore
 */
Class.prototype.bind = function(func)
{
	var context = this;
	if(arguments.length < 2)
	{
		// Fast path if only the 'this' pointer is being bound.
		return function()
		{
			return func.apply(context, arguments);
		}
	}
	else
	{
		// Slower path if additional parameters are being bound.
		var args = Array.prototype.slice.call(arguments, 1);
		return function()
		{
			var finalArgs = args.concat(Array.prototype.slice.call(arguments, 0));
			return func.apply(context, finalArgs);
		}
	}
}

/**
 * @ignore
 */
Class.prototype.toString = function()
{
	return this.constructor.name;
}

// Debug implementation that will replace every method in destroyed objects with a grenade.
/*Class.prototype.destroy = function()
{
	function suicide()
	{
		throw new Error('Function called on destroyed object');
	}
	
	for(var i in this)
	{
		var value = this[i];
		if(typeof(value) == 'function')
		{
			this[i] = suicide;
		}
	}
}*/
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/base64'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/base64'] = exports; /**
*
*  Base64 encode / decode
*  http://www.webtoolkit.info/
*
**/
 
var Base64 = {
 
	// private property
	_keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
 
	// public method for encoding
	encode : function (input) {
		if(!input){return "";}

		var output = "";
		var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
		var i = 0;
		
		input = Base64._utf8_encode(input);
 
		while (i < input.length) {
 
			chr1 = input.charCodeAt(i++);
			chr2 = input.charCodeAt(i++);
			chr3 = input.charCodeAt(i++);
 
			enc1 = chr1 >> 2;
			enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
			enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
			enc4 = chr3 & 63;
 
			if (isNaN(chr2)) {
				enc3 = enc4 = 64;
			} else if (isNaN(chr3)) {
				enc4 = 64;
			}
 
			output = output +
			this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
			this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
 
		}
 
		return output;
	},
 
	// public method for decoding
	decode : function (input) {
		if(!input){return input;}

		var output = "";
		var chr1, chr2, chr3;
		var enc1, enc2, enc3, enc4;
		var i = 0;
 
		input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
 
		while (i < input.length) {
 
			enc1 = this._keyStr.indexOf(input.charAt(i++));
			enc2 = this._keyStr.indexOf(input.charAt(i++));
			enc3 = this._keyStr.indexOf(input.charAt(i++));
			enc4 = this._keyStr.indexOf(input.charAt(i++));
 
			chr1 = (enc1 << 2) | (enc2 >> 4);
			chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
			chr3 = ((enc3 & 3) << 6) | enc4;
 
			output = output + String.fromCharCode(chr1);
 
			if (enc3 != 64) {
				output = output + String.fromCharCode(chr2);
			}
			if (enc4 != 64) {
				output = output + String.fromCharCode(chr3);
			}
 
		}
 
		output = Base64._utf8_decode(output);
 
		return output;
 
	},
 
	// private method for UTF-8 encoding
	_utf8_encode : function (string) {
		if(string == undefined) return undefined;
		if(typeof string != "string") string = string.toString();

		var utftext = "";
 
		for (var n = 0; n < string.length; n++) {
 
			var c = string.charCodeAt(n);
 
			if (c < 128) {
				utftext += String.fromCharCode(c);
			}
			else if((c > 127) && (c < 2048)) {
				utftext += String.fromCharCode((c >> 6) | 192);
				utftext += String.fromCharCode((c & 63) | 128);
			}
			else {
				utftext += String.fromCharCode((c >> 12) | 224);
				utftext += String.fromCharCode(((c >> 6) & 63) | 128);
				utftext += String.fromCharCode((c & 63) | 128);
			}
 
		}
 
		return utftext;
	},
 
	// private method for UTF-8 decoding
	_utf8_decode : function (utftext) {
		var string = "";
		var i = 0;
		var c = c1 = c2 = 0;
 
		while ( i < utftext.length ) {
 
			c = utftext.charCodeAt(i);
 
			if (c < 128) {
				string += String.fromCharCode(c);
				i++;
			}
			else if((c > 191) && (c < 224)) {
				c2 = utftext.charCodeAt(i+1);
				string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
				i += 2;
			}
			else {
				c2 = utftext.charCodeAt(i+1);
				c3 = utftext.charCodeAt(i+2);
				string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
				i += 3;
			}
 
		}
 
		return string;
	}
 
};

exports.Base64 = Base64;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Commands'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Commands'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Commands'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Commands
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

var Commands = exports.Commands = Core.Class.singleton(
/** @lends UI.Commands.prototype */
{
	/**
	 * @name UI.Commands
	 * @class 
	 * @augments Core.Class
	 */
	/** 
	 * @field
	 */
	classname: 'Commands',
	
	/**
	 * @constructs
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this.initializeNative(this.__objectRegistryId);
		this._tempCBs = {};
		this._tempCBCount = 0;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Enumeration for image fit modes.
			* Image Fit is always applied relative to view bounds *after* content insets are applied.
			* @namespace
			 */
	FitMode:
	{ 
		/** The image content is not scaled at all. */
		None: 0,
		/** The image will be aspect-scaled to fit completely within the view. */
		Inside: 1,
		/** The image will be aspect-scaled to cover the entire view bounds. Clipping may occur. */
		Fill: 2,
		/** The image will be distorted to cover the exact view bounds. */
		Stretch: 3,
		/** The image will be aspect-scaled so its width matches the view bounds. Clipping may occur. */
		AspectWidth: 5,
		/** The image will be aspect-scaled so its height matches the view bounds. Clipping may occur. */
		AspectHeight: 6,
		/** The image will be scaled down to fit completely within the view, but not upscaled. */
		InsideNoUpscaling: 7,
	},
	
	/** 
			* Enumeration for supported units for dimensions.
			* Math.round() is your friend. Sending decimal pixel coordinates can result in unpredictable behavior on various platforms, but half- and quarter-pixels can be useful tools on iOS.
			* @namespace
			 */
	Scaling:
	{ 
		/** The native format, and the default for view bounds. No conversion will be performed. */
		Pixels: 0,
		/** Adjusted to roughly one typesetting point, downscaled from 72 to 160 dpi. */
		Points: 1,
		/** 1.0 represents 100% of the provided or implied size (usually a view width or height). */
		Unit: 2,
		/** A percentage of the provided or implied size (typically from 0 to 100). */
		Percent: 3,
		/** At this scale, the device's screen is always 320 units wide. */
		iPhone: 4,
	},
	
	/** 
			* Enumeration for text font styles.
			* @namespace
			 */
	FontStyle:
	{ 
		/** * */
		Normal: 0,
		/** * */
		Bold: 1,
		/** * */
		Italic: 2,
		/** * */
		BoldItalic: 3,
	},
	
	/** 
			* Flags for control / view states. Used in View and its subclasses.
			* When setting content and properties for states, the value with the highest id when AND'ed with the current state, but no additional bits, will be used.
			* @namespace
			 */
	State:
	{ 
		/** The view is in an unexceptional state. */
		Normal: 0x00,
		/** * */
		Focused: 0x01,
		/** * */
		Selected: 0x02,
		/** * */
		Pressed: 0x04,
		/** * */
		Checked: 0x08,
		/** * */
		Custom: 0x00FF0000,
		/** * */
		Disabled: 0x40000000,
	},
	
	/** 
			* Enumeration for Enter Key Behavior in editable text fields.
			* @namespace
			 */
	EnterKeyType:
	{ 
		/** * */
		Return: 0,
		/** * */
		Done: 1,
		/** * */
		Next: 2,
		/** * */
		Submit: 3,
		/** * */
		Go: 4,
		/** * */
		Search: 5,
		/** * */
		Send: 6,
	},
	
	/** 
			* Enumeration for Input Types for editable text fields.
			* @namespace
			 */
	InputType:
	{ 
		/** * */
		None: 0,
		/** * */
		TextWithCorrection: 1,
		/** * */
		Password: 2,
		/** * */
		Numeric: 4,
		/** * */
		Email: 5,
		/** * */
		URL: 6,
		/** * */
		Date: 7,
		/** * */
		ANDROID_LANDSCAPE_FULLSCREEN: 8,
	},
	
	/** 
			* Arrangement of combinations of text and images for buttons. When stacked, the button rect will be divided proportionally into two rects that completely cover the button. Gravity will apply to the image and text within their rects.
			* @namespace
			 */
	ButtonLayout:
	{ 
		/** The view is in an unexceptional state. */
		CenterTextOver: 0,
		/** * */
		StackImageLeft: 1,
		/** * */
		StackImageTop: 2,
		/** * */
		StackImageRight: 3,
		/** * */
		StackImageBottom: 4,
		/** * */
		CenterImageOver: 5,
	},
	
	/** 
			* Describes what direction a user swiped during a swipe callback.
			* @see UI.AbstractView#setOnSwipe
			* @namespace
			 */
	SwipeDirection:
	{ 
		/** * */
		Left: 1,
		/** * */
		Right: 2,
		/** * */
		Up: 3,
		/** * */
		Down: 4,
	},
	
	///////
	// Class Summary and Generated Constants (for internal use only):
	// Class ID = 337
	// Method -1: _initializeNative ( int reservedId )
	// Method -2: _create ( int newObjectId, str className )
	// Method 3: _destroy (  )
	// Method 4: _setActive ( bool active )
	// Method 5: _setTouchable ( bool touchable )
	// Method 6: _enableEvent ( str eventName )
	// Method 7: _disableEvent ( str eventName )
	// Method -8: _eventOccurred ( json eventObject )
	// Method 9: _setIsVisible ( bool visible )
	// Method 10: _setEnabled ( bool enable )
	// Method 11: _setState ( int state )
	// Method 12: _addSubview ( int __objectRegistryId, int index )
	// Method 13: _removeFromSuperview (  )
	// Method -14: _startAnimation ( int durationMs, str callbackId )
	// Method -15: _executeAnimation (  )
	// Method 16: _setFrame ( float x, float y, float w, float h )
	// Method 17: _setOrigin ( float x, float y )
	// Method 18: _setAnchor ( float x, float y )
	// Method 19: _setSize ( float w, float h )
	// Method 20: _setTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 21: _setBackgroundColor ( str color )
	// Method 22: _setImage ( int state, str imageURL )
	// Method 23: _setImageBorder ( int state, json gradientJSON )
	// Method 24: _setImageFitMode ( int fitMode )
	// Method 25: _setImageGravity ( float x, float y )
	// Method 26: _setImageOrigin ( float x, float y )
	// Method 27: _setImageAnchor ( float x, float y )
	// Method 28: _setImageSize ( float w, float h )
	// Method 29: _setImageInsets ( float t, float r, float b, float l )
	// Method 30: _setImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method 31: _setText ( int state, str text )
	// Method 32: _setTextColor ( int state, str text )
	// Method 33: _setTextFont ( int state, str fontName )
	// Method 34: _setTextShadow ( int state, str shadow )
	// Method 35: _setTextSize ( float textFontSize )
	// Method 36: _setTextGravity ( float x, float y )
	// Method 37: _setTextInsets ( float t, float r, float b, float l )
	// Method 38: _setTextOverflow ( int overflowMode )
	// Method 39: _setTextMaxLines ( int maxLines )
	// Method 40: _setTextMinSize ( float minSize )
	// Method 41: _setTitle ( int state, str title )
	// Method 42: _setTitleColor ( int state, str title )
	// Method 43: _setTitleFont ( int state, str fontName )
	// Method 44: _setTitleShadow ( int state, str shadow )
	// Method 45: _setTitleSize ( float titleFontSize )
	// Method 46: _setTitleGravity ( float x, float y )
	// Method 47: _setTitleInsets ( float t, float r, float b, float l )
	// Method 48: _setTitleOverflow ( int overflowMode )
	// Method 49: _setTitleMaxLines ( int maxLines )
	// Method 50: _setTitleMinSize ( float minSize )
	// Method 51: _setGradient ( int state, json gradientJSON )
	// Method 52: _setStringValue ( str value )
	// Method 53: _setFloatValue ( float value )
	// Method 54: _setIntValue ( int value )
	// Method 55: _setBoolValue ( bool value )
	// Method 56: _setButtonLayout ( int layoutType )
	// Method 57: _setContentInsets ( float t, float r, float b, float l )
	// Method 58: _setBarGradient ( int state, json gradientJSON )
	// Method 59: _setPlaceholderText ( str placeholder )
	// Method 60: _setPlaceholderTextColor ( str color )
	// Method 61: _setPlaceholderTextShadow ( str shadow )
	// Method 62: _setEnterKeyType ( int enterKeyType )
	// Method 63: _setInputType ( int inputType )
	// Method 64: _setChecked ( bool checked )
	// Method 65: _setScrollPosition ( float x, float y )
	// Method 66: _setScrollableSize ( float w, float h )
	// Method 67: _setSections ( json idArray )
	// Method 68: _setTitleView ( int titleObjectID )
	// Method 69: _setSourceDocument ( str documentURL )
	// Method 70: _setChoices ( json stringArray, int defaultChoiceIndex, int cancelChoiceIndex )
	// Method 71: _show (  )
	// Method 72: _hide (  )
	// Method 73: _setPostData ( str data )
	// Method 74: _loadPostURL ( str url )
	// Method 75: _loadGetURL ( str url )
	// Method 76: _loadURL ( str url, json headers, float timeout )
	// Method 77: _stopLoading (  )
	// Method 78: _reload (  )
	// Method 79: _invoke ( str script )
	// Method 80: _goBack (  )
	// Method 81: _goForward (  )
	// Method 82: _setBasicAuthCredentials ( json credentials )
	// Method 83: _setRightImage ( int state, str rightImageURL )
	// Method 84: _setRightImageBorder ( int state, json gradientJSON )
	// Method 85: _setRightImageFitMode ( int fitMode )
	// Method 86: _setRightImageGravity ( float x, float y )
	// Method 87: _setRightImageOrigin ( float x, float y )
	// Method 88: _setRightImageAnchor ( float x, float y )
	// Method 89: _setRightImageSize ( float w, float h )
	// Method 90: _setRightImageInsets ( float t, float r, float b, float l )
	// Method 91: _setRightImageTransform ( float a, float b, float c, float d, float tx, float ty )
	// Method -92: _setStatusBarHidden ( bool statusBarStatus )
	// Method 93: _pauseAds (  )
	// Method 94: _resumeAds (  )
	// Method 95: _setAdRefreshRate ( int refreshRate )
	// Method 96: _setAdAllowAutoplay ( bool autoplay )
	// Method 97: _setAlpha ( float alpha )
	// Method 98: _postURL ( str url, str data )
	// Method 99: _setProgressGradient ( int state, json gradientJSON )
	// Method 100: _setSecondaryGradient ( int state, json gradientJSON )
	// Method 101: _setProgress ( float progress, float secondaryProgress )
	// Method 102: _useForUpdateProgress ( bool use )
	// Method 103: _setDarkStyle ( bool use )
	// Method -104: _doCompositeImages ( int w, int h, str filename, json infoArray, str callbackId )
	// Method -105: _REMOVED_doChoosePhoto ( int w, int h, str filename, json options, str callbackId )
	// Method -106: _doChooseCamera ( int w, int h, str filename, json options, str callbackId )
	// Method 107: _setScrollable ( bool enabled )
	// Method 108: _setZoomable ( bool enabled )
	// Method 109: _addAnnotation ( int __objectRegistryId )
	// Method 110: _removeAnnotation ( int __objectRegistryId )
	// Method 111: _selectAnnotation ( int __objectRegistryId )
	// Method 112: _setRegion ( float latitude, float longitude, float latitudeDelta, float longitudeDelta, bool animated )
	// Method 113: _setView ( int __objectRegistryId )
	// Method 114: _setCoordinate ( float latitude, float longitude )
	// Method 115: _setCalloutTitle ( str title )
	// Method 116: _setCalloutSubtitle ( str subTitle )
	// Method 117: _setCalloutEnabled ( bool enabled )
	// Method 118: _setCalloutLeftView ( int __objectRegistryId )
	// Method 119: _setCalloutRightView ( int __objectRegistryId )
	// Method 120: _setCenterOffset ( float xOffset, float yOffset )
	// Method -121: _doChoosePhoto ( int w, int h, str filename, json options, str callbackId, int invokingView )
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -8:
					Commands._eventOccurredRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Commands._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[337] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_eventOccurredRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		obj[ "eventObject" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "eventObject" ] === undefined )
		{
			NgLogE("Could not parse eventObject in Commands.eventOccurred from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$initializeNative: function( reservedId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + -1  + "," + reservedId  );
	},
	
	/** @private */
	$create: function( newObjectId, className )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + -2  + "," + newObjectId + "," + Core.Base64.encode( className )  );
	},
	
	/** @private */
	destroy: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 3 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	setActive: function( active )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 4 + "," + this.__objectRegistryId + "," + ( active ? 1 : 0 )  );
	},
	
	/** @private */
	setTouchable: function( touchable )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 5 + "," + this.__objectRegistryId + "," + ( touchable ? 1 : 0 )  );
	},
	
	/** @private */
	enableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 6 + "," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	disableEvent: function( eventName )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 7 + "," + this.__objectRegistryId + "," + Core.Base64.encode( eventName )  );
	},
	
	/** @private */
	setIsVisible: function( visible )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 9 + "," + this.__objectRegistryId + "," + ( visible ? 1 : 0 )  );
	},
	
	/** @private */
	setEnabled: function( enable )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 10 + "," + this.__objectRegistryId + "," + ( enable ? 1 : 0 )  );
	},
	
	/** @private */
	setState: function( state )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 11 + "," + this.__objectRegistryId + "," + state  );
	},
	
	/** @private */
	addSubview: function( __objectRegistryId, index )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 12 + "," + this.__objectRegistryId + "," + __objectRegistryId + "," + index  );
	},
	
	/** @private */
	removeFromSuperview: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 13 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	$startAnimation: function( durationMs, callbackId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + -14  + "," + durationMs + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$executeAnimation: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + -15  );
	},
	
	/** @private */
	setFrame: function( x, y, w, h )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 16 + "," + this.__objectRegistryId + "," + x + "," + y + "," + w + "," + h  );
	},
	
	/** @private */
	setOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 17 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 18 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 19 + "," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 20 + "," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setBackgroundColor: function( color )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 21 + "," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setImage: function( state, imageURL )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 22 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( imageURL )  );
	},
	
	/** @private */
	setImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 23 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 24 + "," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 25 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 26 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 27 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 28 + "," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 29 + "," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 30 + "," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	setText: function( state, text )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 31 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextColor: function( state, text )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 32 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( text )  );
	},
	
	/** @private */
	setTextFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 33 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTextShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 34 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTextSize: function( textFontSize )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 35 + "," + this.__objectRegistryId + "," + textFontSize  );
	},
	
	/** @private */
	setTextGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 36 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTextInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 37 + "," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTextOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 38 + "," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTextMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 39 + "," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTextMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 40 + "," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setTitle: function( state, title )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 41 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleColor: function( state, title )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 42 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setTitleFont: function( state, fontName )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 43 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( fontName )  );
	},
	
	/** @private */
	setTitleShadow: function( state, shadow )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 44 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setTitleSize: function( titleFontSize )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 45 + "," + this.__objectRegistryId + "," + titleFontSize  );
	},
	
	/** @private */
	setTitleGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 46 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setTitleInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 47 + "," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setTitleOverflow: function( overflowMode )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 48 + "," + this.__objectRegistryId + "," + overflowMode  );
	},
	
	/** @private */
	setTitleMaxLines: function( maxLines )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 49 + "," + this.__objectRegistryId + "," + maxLines  );
	},
	
	/** @private */
	setTitleMinSize: function( minSize )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 50 + "," + this.__objectRegistryId + "," + minSize  );
	},
	
	/** @private */
	setGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 51 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setStringValue: function( value )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 52 + "," + this.__objectRegistryId + "," + Core.Base64.encode( value )  );
	},
	
	/** @private */
	setFloatValue: function( value )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 53 + "," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setIntValue: function( value )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 54 + "," + this.__objectRegistryId + "," + value  );
	},
	
	/** @private */
	setBoolValue: function( value )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 55 + "," + this.__objectRegistryId + "," + ( value ? 1 : 0 )  );
	},
	
	/** @private */
	setButtonLayout: function( layoutType )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 56 + "," + this.__objectRegistryId + "," + layoutType  );
	},
	
	/** @private */
	setContentInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 57 + "," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setBarGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 58 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setPlaceholderText: function( placeholder )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 59 + "," + this.__objectRegistryId + "," + Core.Base64.encode( placeholder )  );
	},
	
	/** @private */
	setPlaceholderTextColor: function( color )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 60 + "," + this.__objectRegistryId + "," + Core.Base64.encode( color )  );
	},
	
	/** @private */
	setPlaceholderTextShadow: function( shadow )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 61 + "," + this.__objectRegistryId + "," + Core.Base64.encode( shadow )  );
	},
	
	/** @private */
	setEnterKeyType: function( enterKeyType )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 62 + "," + this.__objectRegistryId + "," + enterKeyType  );
	},
	
	/** @private */
	setInputType: function( inputType )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 63 + "," + this.__objectRegistryId + "," + inputType  );
	},
	
	/** @private */
	setChecked: function( checked )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 64 + "," + this.__objectRegistryId + "," + ( checked ? 1 : 0 )  );
	},
	
	/** @private */
	setScrollPosition: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 65 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setScrollableSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 66 + "," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setSections: function( idArray )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 67 + "," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( idArray ) )  );
	},
	
	/** @private */
	setTitleView: function( titleObjectID )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 68 + "," + this.__objectRegistryId + "," + titleObjectID  );
	},
	
	/** @private */
	setSourceDocument: function( documentURL )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 69 + "," + this.__objectRegistryId + "," + Core.Base64.encode( documentURL )  );
	},
	
	/** @private */
	setChoices: function( stringArray, defaultChoiceIndex, cancelChoiceIndex )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 70 + "," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( stringArray ) ) + "," + defaultChoiceIndex + "," + cancelChoiceIndex  );
	},
	
	/** @private */
	show: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 71 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	hide: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 72 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	setPostData: function( data )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 73 + "," + this.__objectRegistryId + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	loadPostURL: function( url )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 74 + "," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadGetURL: function( url )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 75 + "," + this.__objectRegistryId + "," + Core.Base64.encode( url )  );
	},
	
	/** @private */
	loadURL: function( url, headers, timeout )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 76 + "," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( JSON.stringify( headers ) ) + "," + timeout  );
	},
	
	/** @private */
	stopLoading: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 77 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	reload: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 78 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	invoke: function( script )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 79 + "," + this.__objectRegistryId + "," + Core.Base64.encode( script )  );
	},
	
	/** @private */
	goBack: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 80 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	goForward: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 81 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	setBasicAuthCredentials: function( credentials )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 82 + "," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( credentials ) )  );
	},
	
	/** @private */
	setRightImage: function( state, rightImageURL )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 83 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( rightImageURL )  );
	},
	
	/** @private */
	setRightImageBorder: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 84 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setRightImageFitMode: function( fitMode )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 85 + "," + this.__objectRegistryId + "," + fitMode  );
	},
	
	/** @private */
	setRightImageGravity: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 86 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageOrigin: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 87 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageAnchor: function( x, y )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 88 + "," + this.__objectRegistryId + "," + x + "," + y  );
	},
	
	/** @private */
	setRightImageSize: function( w, h )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 89 + "," + this.__objectRegistryId + "," + w + "," + h  );
	},
	
	/** @private */
	setRightImageInsets: function( t, r, b, l )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 90 + "," + this.__objectRegistryId + "," + t + "," + r + "," + b + "," + l  );
	},
	
	/** @private */
	setRightImageTransform: function( a, b, c, d, tx, ty )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 91 + "," + this.__objectRegistryId + "," + a + "," + b + "," + c + "," + d + "," + tx + "," + ty  );
	},
	
	/** @private */
	$setStatusBarHidden: function( statusBarStatus )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + -92  + "," + ( statusBarStatus ? 1 : 0 )  );
	},
	
	/** @private */
	pauseAds: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 93 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	resumeAds: function(  )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 94 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	setAdRefreshRate: function( refreshRate )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 95 + "," + this.__objectRegistryId + "," + refreshRate  );
	},
	
	/** @private */
	setAdAllowAutoplay: function( autoplay )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 96 + "," + this.__objectRegistryId + "," + ( autoplay ? 1 : 0 )  );
	},
	
	/** @private */
	setAlpha: function( alpha )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 97 + "," + this.__objectRegistryId + "," + alpha  );
	},
	
	/** @private */
	postURL: function( url, data )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 98 + "," + this.__objectRegistryId + "," + Core.Base64.encode( url ) + "," + Core.Base64.encode( data )  );
	},
	
	/** @private */
	setProgressGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 99 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setSecondaryGradient: function( state, gradientJSON )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 100 + "," + this.__objectRegistryId + "," + state + "," + Core.Base64.encode( JSON.stringify( gradientJSON ) )  );
	},
	
	/** @private */
	setProgress: function( progress, secondaryProgress )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 101 + "," + this.__objectRegistryId + "," + progress + "," + secondaryProgress  );
	},
	
	/** @private */
	useForUpdateProgress: function( use )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 102 + "," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	setDarkStyle: function( use )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 103 + "," + this.__objectRegistryId + "," + ( use ? 1 : 0 )  );
	},
	
	/** @private */
	$doCompositeImages: function( w, h, filename, infoArray, callbackId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + -104  + "," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( infoArray ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	$doChooseCamera: function( w, h, filename, options, callbackId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + -106  + "," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId )  );
	},
	
	/** @private */
	setScrollable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 107 + "," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setZoomable: function( enabled )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 108 + "," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	addAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 109 + "," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	removeAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 110 + "," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	selectAnnotation: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 111 + "," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setRegion: function( latitude, longitude, latitudeDelta, longitudeDelta, animated )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 112 + "," + this.__objectRegistryId + "," + latitude + "," + longitude + "," + latitudeDelta + "," + longitudeDelta + "," + ( animated ? 1 : 0 )  );
	},
	
	/** @private */
	setView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 113 + "," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCoordinate: function( latitude, longitude )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 114 + "," + this.__objectRegistryId + "," + latitude + "," + longitude  );
	},
	
	/** @private */
	setCalloutTitle: function( title )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 115 + "," + this.__objectRegistryId + "," + Core.Base64.encode( title )  );
	},
	
	/** @private */
	setCalloutSubtitle: function( subTitle )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 116 + "," + this.__objectRegistryId + "," + Core.Base64.encode( subTitle )  );
	},
	
	/** @private */
	setCalloutEnabled: function( enabled )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 117 + "," + this.__objectRegistryId + "," + ( enabled ? 1 : 0 )  );
	},
	
	/** @private */
	setCalloutLeftView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 118 + "," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCalloutRightView: function( __objectRegistryId )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 119 + "," + this.__objectRegistryId + "," + __objectRegistryId  );
	},
	
	/** @private */
	setCenterOffset: function( xOffset, yOffset )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + 120 + "," + this.__objectRegistryId + "," + xOffset + "," + yOffset  );
	},
	
	/** @private */
	$doChoosePhoto: function( w, h, filename, options, callbackId, invokingView )
	{
		Core.Proc.appendToCommandString( ":" + 337 + "," + -121  + "," + w + "," + h + "," + Core.Base64.encode( filename ) + "," + Core.Base64.encode( JSON.stringify( options ) ) + "," + Core.Base64.encode( callbackId ) + "," + invokingView  );
	},
	

// {{/Wg Generated Code}}

	_eventOccurredRecv: function( cmd ) {
		var str = Core.Proc.parseString( cmd[ 0 ] );
		Commands.Window.doCommand(str);
	},
	
	registerTemporaryCallback: function( callback ) {
		if (typeof callback != 'function') return '';
		var regId = ++this._tempCBCount + ':func(' + callback.arity + ' args)';
		Commands._tempCBs[regId] = callback;
		return regId;
	},
	
	takeTemporaryCallback: function( regId ) {
		var cb = Commands._tempCBs[regId];
		delete Commands._tempCBs[regId];
		return cb;
	},

	/**
	 *	@function UI#animate
	 * 	Animate changes to the properties of one or more UI objects.
	 * 	Currently animates changes to frame and alpha, and animates the addition / removal of subviews.
	 * 	@param {Function} action A closure that sets the property or properties to be animated.
	 * 		This function may manipulate several objects.
	 * 	@param {Number} duration The time over which to execute the animation, in milliseconds.
	 * 	@param {Function} onCompletion A closure to be executed after the animation has completed.
	 */
	animate: function(action, duration, callback) {
		if (typeof action == 'function') {
			var cbFn = (typeof callback == 'function') ? callback : duration;
			var duration = (typeof duration == 'number') ? duration : callback;
			if (typeof duration != 'number') duration = 400;

			Commands.startAnimation( duration, Commands.registerTemporaryCallback(callback));
			action();
			Commands.executeAnimation();
		}
	},
});

exports.Commands.instantiate();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewGeometry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewGeometry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;

/**
 * <p>Classes and objects contained by the <code>ViewGeometry</code> class.</p>
 * @name UI.ViewGeometry
 * @namespace
 * @description <p>The <code>ViewGeometry</code> class is a collection of classes and objects that control spatial components for UI views. 
 * Derived classes from <code>ViewGeometry</code> include:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.Rect}</code></li>
 * <li><code>{@link UI.ViewGeometry.Scale}</code></li>
 * </ul>
 * <p><code>ViewGeometry</code> utilizes the following enumerated constants:</p>
 * <ul>
 * <li><code>{@link UI.ViewGeometry.FitMode}</code></li>
 * <li><code>{@link UI.ViewGeometry.Gravity}</code></li>
 * </ul>
 */

var Scale = exports.Scale = Class.singleton(
/** @lends UI.ViewGeometry.Scale.prototype */
{
	/**
	 * @name UI.ViewGeometry.Scale
	 * @class The <code>Scale</code> class constructs objects that handle view geometry for different scales of measurement.
         * @constructs The default constructor.
	 * @augments Core.Class
	 */
   
	initialize: function() {
		var screenUnits = Capabilities.getScreenUnits();
		this.iOSConversion = screenUnits;
		this.pointConversion = this.iOSConversion * 160 / 72; 
	},

	// Use the values of generated constants... Mostly for if we need to send these to native in the future.
	Pixels: Commands.Scaling.Pixels,
	Points: Commands.Scaling.Points,
	Unit: Commands.Scaling.Unit,
	Percent: Commands.Scaling.Percent,
	iPhone: Commands.Scaling.iPhone,
	
	// Internals.
    
	pointConversion: 1.0,
    
	iOSConversion: 1.0,

    /** 
     * Retrieve the supported measurement scale from the device.
     * @param {Number} units The unit of measure.
     * @param {Number} size The screen size of the device.
     * @returns The current screen dimension supported by the device.
     */
	getScale: function(units, size) {
		switch (+units) {
			case this.Points:
				return this.pointConversion;
			case this.Unit:
				return size;
			case this.Percent:
				return size / 100;
			case this.iPhone:
				return this.iOSConversion;
		}
		return 1.0;
	}
});

var Gravity = exports.Gravity = 
{
		
	/** 
	 * @name UI.ViewGeometry.Gravity
	 * @class Enumeration for image gravity in a view.
	 */
	/** 
	* Center of gravity is the top-left corner of the image. 
	* @fieldof UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	TopLeft: [0.0,0.0],
	/** 
	* Center of gravity is the top-center portion of the image. 
	* @fieldOf UI.ViewGeometry.Gravity.prototype 
	* @constant		
	*/
	TopCenter: [0.5,0.0],
	/** 
	* Center of gravity is the top-right corner of the image. 
	* @fieldOf UI.ViewGeometry.Gravity.prototype 
	* @constant
	*/
	TopRight: [1.0, 0.0],
	/** 
	* Center of gravity is the left side of the image. 
	* @fieldof UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Left: [0.0,0.5],
	/** 
	* Center of gravity is the center of the image. 
	* @fieldof UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Center: [0.5,0.5],
	/** 
	* Center of gravity is the right side of the image. 
	* @fieldof UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	Right: [1.0,0.5],
	/** 
	* Center of gravity is the bottom-left corner of the image. 
	* @fieldof UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomLeft: [0.0,1.0],
	/** 
	* Center of gravity is the bottom-center portion of the image. 
	* @fieldof UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomCenter: [0.5,1.0],
	/** 
	* Center of gravity is the bottom-right corner of the image. 
	* @fieldof UI.ViewGeometry.Gravity.prototype
	* @constant
	*/
	BottomRight: [1.0,1.0]
};

 
exports.FitModes = Commands.FitMode;
/** 
* @name UI.ViewGeometry.FitMode
* @class Enumeration for image fit modes in a view.
* @see UI.Commands#FitMode
*/

	
var Rect = exports.Rect = Class.subclass(
/** @lends UI.ViewGeometry.Rect.prototype */
{
	/**
	 * @name UI.ViewGeometry.Rect
	 * @class <code>Rect</code> constructs rectangle objects for use as positionable elements in the user interface. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */

    initialize: function(arg0)
    {
    	if (arg0 instanceof this.constructor){
    		// Another Rect
    		this.x = arg0.x;
    		this.y = arg0.y;
    		this.w = arg0.w;
    		this.h = arg0.h;
    	} else if (arg0 instanceof Array) {
    		if (arguments.length == 2 
    			&& arguments[0].length >= 2 
    			&& arguments[1] instanceof Array 
    			&& arguments[1].length >= 2) {
				
				// Arguments can be two arrays, one of which is a point and one of which is a size,
				this.x = arguments[0][0];
				this.y = arguments[0][1];
				this.w = arguments[1][0];
				this.h = arguments[1][1];
			}
			else if (arguments.length == 1 && arg0.length >= 4) {
				// Single Array
				this.x = arg0[0];
				this.y = arg0[1];
				this.w = arg0[2];
				this.h = arg0[3];
			}
			else {
				NgLogD("UI.ViewGeometry.Rect initialized with unparseable Array(s)");
			}
		} else if (arguments.length == 4) {
			// Four numbers
			this.x = arguments[0];
			this.y = arguments[1];
			this.w = arguments[2];
			this.h = arguments[3];
		}
		return this;
    },
	/**
	 * @returns {Boolean} Returns <code>true</code> if any component value is undefined, NaN, or the value indicates this rect has an area of 0 (<i>width</i> * <i>height</i>).
	 */
	isEmpty: function(){
		return !(this.w * this.h > 0) || isNaN(this.x) || isNaN(this.y) || isNaN(this.w) || isNaN(this.h);
	},
	/**
	 * Copy the component values of this <code>Rect</code>
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> with identical component values.
	 */	
	copy: function() {
		return new (this).constructor(this);
	},
    /**
	 * Retrieve the component values of this <code>Rect</code>.
	 * @returns {Array (Number)} An array of component values for the specified <code>Rect</code> (<i>x</i>, <i>y</i>, <i>height</i>, <i>width</i>).
	 */	
	array: function() {
		return [this.x, this.y, this.w, this.h];
	},
    /**
	 * Set the dimensions of this <code>Rect</code> as an inset.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} t The size for the top of the rectangle.
	 * @param {Number} r The size for the right side of the rectangle.
	 * @param {Number} b The size for the bottom of the rectangle.
	 * @param {Number} l The size for the left side of the rectangle.
	 * @param {UI.ViewGeometry.Scale} units The unit of measure for the rectangle.
	 * @returns {UI.ViewGeometry.Rect} This function returns <code>this</code> to support method invocation chaining.
	 */	
	inset: function(t, r, b, l, units) {
		if (arguments.length > 4) {
			var xScale = Scale.getScale(units, this.w);
			var yScale = Scale.getScale(units, this.h);
			t = Math.floor(t * yScale);
			r = Math.floor(r * xScale);
			b = Math.floor(b * yScale);
			l = Math.floor(l * xScale);
		}
		
		if (arguments.length < 2) {
			r = t;
		}
		if (arguments.length < 4) {
			b = t;
			l = r;
		}
		this.y += t;
		this.h -= t + b;
		this.x += l;
		this.w -= l + r;
		return this;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the top (if positive) or bottom (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var topPart = rect.inset(10).sliceVertical(50, UI.Scale.Percent);
	 * @param {Number} height The new rect height.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceHorizontal
	 */	
	sliceVertical: function(height, units) {
		if (arguments.length > 1) height = Math.floor(height * Scale.getScale(units, this.h));
		
		var newRect = this.copy();
		if (height < 0) {
			// Return the bottom area...
			newRect.h = -height;
			this.h += height;
			newRect.y += this.h;
		} else {
			newRect.h = height;
			this.y += height;
			this.h -= height;
		}
		return newRect;
	},
    /**
	 *	Create and return a new <code>Rect</code> representing the left (if positive) or right (if negative).
	 *	Destructively modifies this Rect, removing the new rect area from the receiver.
	 * @example var imageRect = null;
	 * var remainingRect = rect.copy();
	 * ...
	 * imageRect = remainingRect.sliceHorizontal(110).inset(8,15,8,15);
	 * @param {Number} width The new rect width.
	 * @param {UI.ViewGeometry.Scale} [units] The scale of measurement.
	 * @returns {UI.ViewGeometry.Rect} A new <code>Rect</code> object.<br>
	 * @see UI.ViewGeometry.Rect#sliceVertical
	 */	
	sliceHorizontal: function(width, units) {
		if (arguments.length > 1) width = Math.floor(width * Scale.getScale(units, this.w));

		var newRect = this.copy();
		if (width < 0) {
			newRect.w = -width;
			this.w += width;
			newRect.x += this.w;
		} else {
			newRect.w = width;
			this.x += width;
			this.w -= width;
		}
		return newRect;
	},

	toString: function() {
		return "Rect: {" + this.array().join(',') + "}";
	},

	/**
	 * Retrieve an array of component values for this <code>Rect</code> with rows and columns redistributed evenly.
	 * @returns {Array (Number)}
	 * @param {Number} rows The rect rows.
	 * @param {Number} columns The rect columns.
	 * @param {String} flat A one-dimensional array (left to right, top to bottom).
	 */
	getGrid: function(rows, columns, flat) {
		// Return an array of this rect divided equally into columns and rows.
		flat = (flat == true);
		var cellW = Math.floor(this.w / columns);
		var cellH = Math.floor(this.h / rows);
		
		var rowSet = new Array();
		for (var i = 0; i < rows; i++) {
			var colSet = new Array();
			for (var j = 0; j < columns; j++) {
				var r = new this.constructor(this.x + j * cellW, this.y + i * cellH, cellW, cellH);
				(flat ? rowSet : colSet).push(r);
			}
			if (!flat) rowSet.push(colSet);
		}
		return rowSet;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Window'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Window'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Window'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Element = require('NGCore/Client/UI/Element').Element;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var WindowLayer = require('NGCore/Client/UI/WindowLayer').WindowLayer;

// Singleton
// Methods beginning with an underscore are considered private and should
// not be called from outside of the class.

Commands.Window = exports.Window = Class.singleton({

	/**
	 * @deprecated Replaced by {@link UI.Window#getWidth}.
	 */
	_outerWidth: 0,

	/**
	 * @deprecated Replaced by {@link UI.Window#getHeight}.
	 */
	_outerHeight: 0,

	/**
	 * @private
	 */
	_width: 0,
	/**
	 * @private
	 */
	_height: 0,

	 /**
	 * @class The <code>Window</code> class constructs a singleton object that manages application access to native UI.<br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @name UI.Window
	 * @augments Core.Class	
	 * @see UI.Window#document
	 * @constructs The default constructor.
	 */
	initialize: function() {
		if (!this._outerWidth || !this._outerHeight) this.setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		if (!this._width || !this._height) this._setWidthAndHeight(Capabilities.getScreenWidth(), Capabilities.getScreenHeight());
		
		Commands.instantiate();
		var LayoutListener = Core.MessageListener.subclass(
		{
			initialize: function()
			{
				Device.LayoutEmitter.addListener(this, this.onUpdate);
			},
			
			onUpdate: function(layout)
			{
				UI.Window._setWidthAndHeight(layout['width'], layout['height']);
			}
		});
		var layout = new LayoutListener();
		NgLogD("window: outer = " + this._outerWidth + " × " + this._outerHeight + " frame = " + this._width + " × " + this._height);
	},
	
	document: WindowLayer.singleton({
		'type': 'document',
		register: function() {
			// This is not a registered object.
			this.__objectRegistryId = 0;
		}
	}),
	
	_layers: {},
	_getLayer: function(level) {
		return this._layers[level] || (this._layers[level] = new WindowLayer({'level':level || 0}));
	},
	
	/**
	 * @private
	 */
	destroyObject: function(obj) {
		obj.removeFromParent();
		Commands.destroy.call(obj);
		ObjectRegistry.unregister(obj);
	},
	
	/**
	 * @private
	 */
	handleCommand: function(command) {
		// this.log(["Raw Command", command]);
		var fields = NgParseCommand2(command, NgParseInt, NgParseBase64);
	//	this.log(["handleCommand:", fields[1]]);
		this.doCommand(fields[1]);
	},
	/**
	* @private
	*/
	setStatusBarHidden: function(value) {
		Commands.setStatusBarHidden(value);
		this._outerHeight = Capabilities.getScreenHeight() - (value ? 0 : (Capabilities.getStatusBarHeight() || 0));
	},
	
	/**
	 * @private
	 */
	doCommand: function(jsonString) {
		//NgLogD(jsonString);
		var command = JSON.parse(jsonString);
		if(command.name == 'callback'){
			var cb = Commands.takeTemporaryCallback(command.callback_id);
			if (typeof cb == 'function') {
				cb(command);
			}
		} else {
			var object = ObjectRegistry.idToObject(command.objId);
			if (object instanceof Element) {
				switch (command.name) {
					case 'event':
						object.performEventCallback(command);
						break;
					case 'update':
						var properties = command.properties || {};
						for (var property in properties) {
							try {
								var setter = object['update' + property.charAt(0).toUpperCase() + property.substr(1)];
								if (typeof setter == 'function') {
									setter.apply(object, [properties[property]]);
								} else {
									// Set read-only properties!
									object['_'+property] = properties[property];
								}
							} catch (e) {};
						}
						break;
					default:
						object.handleCommand(command);
				}
			} else {
				console.log("Message received for non-element object with id " + command.objId);
				return;
			}
		}
		// log(["Got message back", command]);
	},
    
	/**
	 * @private
	 */    
	log: function(object) {
		NgLogD(object.toString());
		// this.postMessage({name: 'log', message: object});
	},
	/**
	 * Return the available screen width, with respect to orientation and system status bars.
	 * @returns {Number} The currently available width in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},

	/**
	 * Return the available screen height, with respect to orientation and system status bars.
	 * @returns {Number} The currently available height in pixels that can be drawn to.
	 * @type Number
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},

	getOuterWidth: function() {
		return this._outerWidth;
	},
	
	getOuterHeight: function() {
		return this._outerHeight;
	},

	getFrame: function() {
		return new Rect(0, 0, this._width, this._height);
	}
});

// Cause property access to initialize the singleton. Needed for backward compatibility.
Commands.Window.__defineGetter__("outerWidth", function() {return this.getOuterWidth()});
Commands.Window.__defineGetter__("outerHeight", function() {return this.getOuterHeight()});

/**
 * @private
 */
Commands.Window._setWidthAndHeight = function(width, height)
{
	console.log("window: set layout size to: " + width + ' × ' + height);
	this._width = width;
	this._height = height;
};

/**
 * @private
 */
Commands.Window.setWidthAndHeight = function(width, height)
{
	console.log("window: set outer size to: " + width + ' × ' + height);
	this._outerWidth = width;
	this._outerHeight = height;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Element'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Element'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Element'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;

var Element = exports.Element = Class.subclass(
/** @lends UI.Element.prototype */
{
	$subclass: function() {
		if (typeof this._init == 'function') this._init();
		return Class.subclass.apply(this, arguments);
	},
	
	classname: "UI_Element",
	/**
	 * @field
	 * @private
	 */
	analyticsName: null,
	/**
	 * @field
	 * @type Boolean
	 * @private
	 */
	belongsToPlus: false,
	
	/**
	 * @class The <code>Element</code> class is a base class for derived classes that manage object properties and handle user interface events.<br><br>
	 * <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime.
	 * Derived classes from <code>Element</code> include:
	* <div class="ul">
	 * <li>{@link UI.AbstractView}</li>
	 * <li>{@link UI.AlertDialog}</li>
	 * <li>{@link UI.ListViewSection}</li>
	 * <li>{@link UI.ProgressDialog}</li>	 
	 * </div>
	 * @constructs The default constructor. 
	 * @param {String} properties
	 * @augments Core.Class
	*/
	initialize: function(properties) {
		if (Element._init) Element._init();
		
		this.register();
		
		this._eventCallbacks = {};
		
		this.setAttributes(properties);
		
	/*	This is awesome. Maybe use it in production code, but we want to keep
	//	our stylistic constraints for core development.
	
		for (var propName in this._setters) {
			this.__defineSetter__(propName, this._setters[propName]);
		}
		for (propName in this._getters) {
			this.__defineGetter__(propName, this._getters[propName]);
		}
	*/
	
		return this;
	},
	
	register: function() {
		try {
			ObjectRegistry.register(this);
			Commands.create(this.__objectRegistryId, this.type || this.classname);
		} catch (e) {
			// Nothing yet
		} finally {
			return this.__objectRegistryId;
		}
	},
	
	retain: function() {
		(this.__retainCount) ? ++this.__retainCount : (this.__retainCount = 1);
		return this;
	},
	
	release: function() {
		if (--this.__retainCount === 0) {
			this.destroy();
		}
	},
		
	/**
	 * Retrieve the property value of the given key. 
	 * @param {String} key The property keyword.
	 * @returns {String} The current property value.
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttribute: function(key) {
		var getter = this._getters[key];
		return (typeof getter == 'function') ? getter.call(this) : undefined;
	},
	
	/**
	 * Set the property value for the given key.
	 * @example var glView = new UI.GLView
	 * ...
	 * glView.setAttribute('active', true);
	 * @param {String} key The property keyword.
	 * @param {String} value The new property value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttribute: function(key, value){
		var setter = this._setters[key];
		if (typeof setter == 'function') {
			return setter.call(this, value);
		} else {
			NgLogD("Unable to set " + this.type + '.' + key);
		}
		return this;
	},
	
	/**
	 * Set the property value for each specified key. Property values are passed in as key/value pairs.
	 * @param {Object} dict A dictionary of property key/value pairs.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#getAttributes,
	 * @see UI.Element#setAttribute
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setAttributes: function(dict) {
		for (var key in dict) {
			this.setAttribute(key, dict[key]);
		}
		return this;
	},
	
	/**
	 * Retrieve property values for each specified key. 
	 * @param {String} list A list of property keywords.
	 * @returns {Object} A list of key/value pairs.
	 * @see UI.Element#getAttribute,
	 * @see UI.Element#setAttribute,
	 * @see UI.Element#setAttributes
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getAttributes: function(list) {
		var output = {};
		if (list instanceof Array) {
			var key;
			for (var i = 0; i < list.length; i++) {
				key = list[i];
				output[key] = this._getters[key].call(this);
			}
		} else {
			for (var key in this._getters) {
				output[key] = this._getters[key].call(this);
			}
		}
		return output;
	},

	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	enableEvent: Commands.enableEvent,
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	toString: function() {
		return this.type + '(' + this.__objectRegistryId + ')';
	},

	/**
	 * @function
	 * @description Destroy this instance and release resources on the backend.
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	destroy: function() {
		Commands.destroy.call(this);
		ObjectRegistry.unregister(this);
		delete this.prototype;
		for (var i in this) {
			if (this.hasOwnProperty(i)) {
				delete this[i];
			}
		}
		this._destroyed = true;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	*/
	registerCallback: function(func, oneTime) {
		var callbackId = ++this.callbackCounter;
		var obj = this;
		this.callbacks[callbackId] = function(obj, args) {
			try {
				func(obj, args);
				if(oneTime) {
					delete obj.callbacks[callbackId];
				}
			}
			catch(e) {
				NgLogException(e);
			}
		};
		return callbackId;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performCallback: function(event) {
		var cb = this.callbacks[event.callbackId];
		if(cb) {
			cb(this, event.arguments);
		}
	},
	
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	performEventCallback: function(event) {
		try {
			if((this._eventCallbacks[event.eventType])) {
				this._eventCallbacks[event.eventType].call(this, event);
			}
		}
		catch(e) {
			NgLogException(e);
		}
	},	
	
	// STATICS: Setter and Getter Registration
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerAccessors: function(propName, getterFn, setterFn, deprecationMessage) {
		// Put the new setter / getter functions into the prototype.
		var caseAdjusted = propName.charAt(0).toUpperCase() + propName.substr(1);
		var byKeyOnly = Boolean(deprecationMessage || false);
	//	NgLogD("Synthesizing set" + caseAdjusted + (shouldSetClosure ? " (custom)" : " (standard)") +
	//		" and get" + caseAdjusted + (onGetClosure ? " (custom)" : " (standard)") + " for member variable " + localVar);
	
		// If this is an instance, use the instance. Otherwise, if we are a class constructor, modify the prototype.
		var pType = (this instanceof Element) ? this : this.prototype;
		if (typeof getterFn == 'function') {
			if (!pType.hasOwnProperty('_getters')) {
				try {
					var heritableMap = function() {return this;};
					var superGetters = pType.superclass._getters;
					if (superGetters) heritableMap.prototype = superGetters;
					pType._getters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['get'+caseAdjusted] = function() {
					NgLogD("WARNING: Use of get" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					getterFn.apply(this, arguments);
				};
			} else {
				pType['get'+caseAdjusted] = getterFn;
			}
			pType._getters[propName] = getterFn;
		}
		if (typeof setterFn == 'function') {
			if (!pType.hasOwnProperty('_setters')) {
				try {
					var heritableMap = function() {return this;};
					var superSetters = pType.superclass._setters;
					if (superSetters) heritableMap.prototype = superSetters;
					pType._setters = new heritableMap();
				} catch (e) {};
			}
			if (byKeyOnly) {
				pType['set'+caseAdjusted] = function() {
					NgLogD("WARNING: Calling set" + caseAdjusted + "() is deprecated. " + deprecationMessage);
					setterFn.apply(this, arguments);
				}
			} else {
				pType['set'+caseAdjusted] = setterFn;
			}
			pType._setters[propName] = setterFn;
		}
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$registerEventType: function(eventName) {
		var onEventName = 'on' + eventName.charAt(0).toUpperCase() + eventName.substr(1);
		var localVar = '_' + onEventName;
		var pType = this.prototype;
		
		var getterFn = function() {
			return (this._eventCallbacks || 0)[eventName];
		};
		var setterFn = function(callback) {
			var map = (this._eventCallbacks || (this._eventCallbacks = {}));
			var isFn = (typeof callback == 'function');
			if (isFn) {
				map[eventName] = callback;
			} else {
				delete map[eventName]
			}
			this.enableEvent(eventName, isFn);
		};
		this.registerAccessors(onEventName, getterFn, setterFn);
		
		// Legacy support. Let's concentrate on removing this soon or at least fixing the casing.
		pType.__defineGetter__(onEventName.toLowerCase(), getterFn);
		pType.__defineSetter__(onEventName.toLowerCase(), setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizePropertyWithState: function(propName, CommandsFn) {
		var lVarName = '_' + propName + 'Map';
		var setterFn;
		if (propName) {
			setterFn = function(value, optState) {
				optState = +(optState || 0);
			//	NgLogD("Set " + this.type + "." + propName + "[" + optState + "] = " + value);
				(this[lVarName] || (this[lVarName] = {}))[optState] = value;
				CommandsFn.call(this, optState, value);
				return this;
			};
		} else {
			setterFn = function(value, optState) {
				CommandsFn.call(this, +(optState || 0), value);
				return this;
			};
		}
		
		var getterFn = function(state) {
			return (this[lVarName] || 0)[+(state || 0)];
		};
		
		this.registerAccessors(propName, getterFn, setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeCompoundProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Synthesized setters accept EITHER an array of reasonable length OR individual args.
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array)
					? args
					: Array.prototype.slice.call(arguments);
				CommandsFn.apply(this, this[lVarName]);
				return this;
			}
		} else {
			setterFn = function(args) {
				this[lVarName] = (args instanceof Array) ? args : Array.prototype.slice.call(arguments);
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	$synthesizeProperty: function(propName, CommandsFn) {
		var lVarName = '_' + propName;
		var setterFn;
		if (CommandsFn) {
			// Optional args are still passed through, even though only the first arg is assigned.
			setterFn = function(arg) {
				this[lVarName] = arg;
				CommandsFn.apply(this, arguments);
				return this;
			}
		} else {
			setterFn = function(arg) {
				this[lVarName] = arg;
				return this;
			}
		}
		
		this.registerAccessors(propName, function() {return this[lVarName];} , setterFn);
	}
});


// Event Handlers
Element._init = function() {
	delete Element._init;
	
	/**
	 * @name UI.Element#setOnLoad
	 * @description Set a function to call when the <code>load</code> event occurs.
	 * @param {Function} loadCallback The new functoin to call.<br><br><b>Note:</b> The <code>load</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLoad.loaded = true; 
	 * };
	 * @see UI.Element#event:getOnLoad
	 * @event
	 */
	/**
	 * @name UI.Element#getOnLoad
	 * @description Retrieve the function to call when the <code>load</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnLoad
	 * @event
	 */
	Element.registerEventType('load');
	/**
	 * @name UI.Element#setOnUnload
	 * @description Set a function to call when the <code>unload</code> event occurs.
	 * @param {Function} unloadCallback The new functoin to call.<br><br><b>Note:</b> The <code>unload</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onUnload.unloaded = true; 
	 * };
	 * @see UI.Element#event:getOnUnload	
	 * @event
	 */
	/**
	 * @name UI.Element#getOnUnload
	 * @description Retrieve the function to call when the <code>unload</code> event occurs.
	 * @returns {Function} The current function to call.
	 * @see UI.Element#event:setOnUnload	 
	 * @event
	 */
	Element.registerEventType('unload');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/View'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/View'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/View'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Window = require('NGCore/Client/UI/Window').Window;

var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;

var View = exports.View = AbstractView.subclass(
/** @lends UI.View.prototype */
{
	'type':'view',

	/**	 
	 * @class The <code>View</code> class is a base class for derived classes that handle application views. Derived classes from <code>View</code> include:
	 * <div class="ul">
	 * <li>{@link UI.ScrollView}</li>
	 * <li>{@link UI.Toast}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (View._init) View._init();
		ViewParent.initialize.call(this);
		return $super(properties);
	},
	/**
	* Add a child node to this <code>View</code> at the specified index.
	* @example var mainView = new UI.View();
	* ...
	* var errorView = new UI.View();
	* ...
	* mainView.addChild(errorView);
	* @param {GL2.Node} childNode The child node to add.
	* @param {Number} index The specified index.
	* @throws {this.type + ".addChild: " + childNode + " is not a view!"} Specified node is not attached to a view.
	* @returns This function returns <code>this</code> to support method invocation chaining.
	* @see UI.View#removeChild
    * @status iOS, Android, Test
	*/
	addChild: ViewParent.addChild,
	
	/**
	* Remove a child node from this <code>View</code> at the specified index.
	* @example mainView.removeChild(errorView);
	* @param {GL2.Node} childNode The child node to remove.
	* @throws {this.type + ".removeChild: " + childNode + " is not a view!} Specified node is not attached to a view.
	* @returns The child node that was removed.
	* @see UI.View#addChild
    * @status iOS, Android, Test
	*/    
	removeChild: ViewParent.removeChild,


	/**
	 * Retrieve a count of the child nodes attached to this <code>View</code>.
	 * @return {Number} The current number of child nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildCount: ViewParent.getChildCount,

	/**
	 * Retrieve the child nodes attached to this <code>View</code>.
	 * @return {Object} All attached children nodes.
	 * @status Javascript, iOS, Android, Flash
	 */
	getChildren: ViewParent.getChildren,

	/**
	 * @function
	 * @description Override this for custom view subclass layout code.
	 */
	layoutSubviews: function() {
		//Override this for custom view subclass layout code
	},
	/** @protected */
	_style:null,
	/**
	 * Retrieve the style for this <code>View</code>.
	 * @returns {UI.Style} The current <code>View</code> style.
	 * @see UI.View#setStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	getStyle:function(){
		return this._style;
	},
	/**
	 * Set the style for this <code>View</code>. This call allows custom view objects to process and update their styles more easily.
	 * @param {UI.Style} style The new <code>View</code> style.
	 * @see UI.View#getStyle
	 * @status Javascript, iOS, Android, Flash
	 */
	setStyle: function(/*UI.Style*/style) {
		//Override this for custom view subclass styling code
		this._style = style;
	},
	
	/**
	 * @protected
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	_setVisible: function($super, makeVisible) {
		var wasVisible = this._visible;
		$super(makeVisible);
		if (this._visible != wasVisible) {
			var l = this._children.length;
			for (var i = 0; i < l; i++) {
				this._children[i]._setVisible(makeVisible);
			}
		}
	},
});

// Properties
View._init = function() {
	delete View._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.View#setImage
	 * @description Set an image URL for a view state. This property defines a remote image resource to use in arbitrary contexts.
	 * @example var someSprite = new UI.View();        
	 * someSprite.setImage('./Content/mySprite.png', [w, h], [0, 0]);
	 * @see UI.View#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.View#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.View#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.View#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.View#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.View#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.View#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	View.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.View#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.View#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.View#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	View.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.View#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var someSprite = new UI.View();
	 * ...
	 * someSprite.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.View#getImageFit
	 * @function
	 */
	/**
	 * @name UI.View#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.View#setImageFit
	 * @function
 	 * @status 
	 */
	View.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing View." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			View.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
	bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Label'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Label'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Label'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Label = exports.Label = AbstractView.subclass(
/** @lends UI.Label.prototype */
{
	'type':'label',
	/**
	 * @name UI.Label
	 * @class The <code>Label</code> class constructs objects for managing strings that are used as application labels. 
	 * These objects include access to a wide range of attributes for manipulating the look and feel of application labels.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Label._init) Label._init();
		$super(properties);
	}
});

Label._init = function() {
	delete Label._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Label#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setText("Friends List");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getText
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>text</code>.
	 * @see UI.Label#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('text', Commands.setText);	
	/**
	 * @name UI.Label#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code>.
	 * @see UI.Label#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Label#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string for a label in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextColor('FFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextColor
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.Label#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Label#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on labels in the specified view state.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Label#getTextShadow
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.Label#setTextShadow
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.Label#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>Label</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Label#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.Label#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>Label</code>. This property defines the size of text strings for a label.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextGravity(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Label#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property for this <code>Label</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.Label#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeProperty('textSize', Commands.setTextSize);

	/**
	 * @name UI.Label#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property for this <code>Label</code>. This property defines the viewable area of a text string when applying gravity.
	 * @example var label = new UI.Label();
	 * ...
	 * label.setTextInsets(0, 0, 0, 64);
	 * @param {Number, Array (Number)} textInsets The new value for <code>textInsets</code>. Set as individual components or a single array of components.
	 * @see UI.Label#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Label#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property for this <code>Label</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textInsets</code>.
	 * @see UI.Label#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Label.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
			// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Label." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Label.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Image'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Image'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Image'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Image = exports.Image = AbstractView.subclass(
/** @lends UI.Image.prototype */
{
	/**
	 * @name UI.Image
	 * @class The <code>Image</code> class constructs objects that control the location and size of images used in the user interface.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (Image._init) Image._init();
		$super(properties);
	},
	
	'type':'image'
});


// Properties
Image._init = function() {
	delete Image._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.Image#setImage
	 * @description Set an image URL for a view state. This property defines how an image appears for specific conditions. For example,
	 * set one image for the default view state and another image for a view state with focus.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImage('./Content/splash.png');
	 * @see UI.Image#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Image#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Image#setImage
	 * @status iOS, Android, Test
	 * @function
	 */
	Image.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Image#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Image#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Image#setImageBorder
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.Image#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#getImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> expressed as two floats.
	 * @see UI.Image#setImageGravity
	 * @function
	 * @status iOS, Android, Test
	 */
	Image.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.Image#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images.
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Image#getImageTransform
	 * @function
	 */
	/**
	 * @name UI.Image#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Image#setImageTransform
	 * @function
	 */
	 Image.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Image#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var splashGraphic = new UI.Image();
	 * ...
	 * splashGraphic.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Image#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Image#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Image#setImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	Image.synthesizeProperty('imageFit', Commands.setImageFitMode);
	
		// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Image." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Image.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('image');
    bindStateProperties('imageBorder');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Button'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Button'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Button'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Button = exports.Button = AbstractView.subclass(
/** @lends UI.Button.prototype */
{
	/**
	 * @name UI.Button
	 * @class The <code>Button</code> class constructs objects that are used as application buttons.
	 * @augments UI.AbstractView
	 */
	'type':'button',

	'Layout':Commands.ButtonLayout,
	
	initialize: function($super, properties) {
		if (Button._init) Button._init();
		$super(properties);
	}
});

// Properties
Button._init = function() {
	delete Button._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.Button#setImage
	 * @description Set an image URL for a view state. This defines how buttons appear for specific conditions. For example, 
	 * set different images for a button in the default view state and a button when it is pressed.
	 * @example var backButton = new UI.Button();        
	 * backButton.setImage('./Content/backButton.png', [w, h], [0, 0]);
	 * @see UI.Button#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] A set of flags describing the view state(s) for using this URL.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getImage
	 * @description Retrieve the <code>image</code> URL for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state..
	 * @see UI.Button#setImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.Button#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.Button#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.Button#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.Button#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.Button#getImageFit
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.Button#setImageFit
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.Button#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how a image for a button is positioned within a viewable area.
	 * @example var backButton = new UI.Button();
	 * ...
	 * backButton.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Button#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.Button#setImageGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	Button.synthesizeCompoundProperty('imageGravity', Commands.setImageGravity);
	/**
	 * @name UI.Button#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for an image used as a button.
	 * @example var button = new UI.Button()
	 * ...
	 * button.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. 
	 * Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.Button#getImageTransform
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.Button#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.Button#setImageTransform
 	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	Button.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.Button#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getImageBorder
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.Button#setImageBorder
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	
	/**
	 * @name UI.Button#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setText("More information");
	 * @see UI.Button#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state..
	 * @see UI.Button#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.Button#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label on a 
	 * button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextColor('FFFFFF');
	 * @see UI.Button#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	/**
	 * @name UI.Button#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state..
	 * @see UI.Button#setTextColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.Button#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Button#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.Button#setTextFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.Button#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings for a button in different view states.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.Button#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state..
	 * @see UI.Button#setTextShadow	
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.Button#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string for a button is positioned within a viewable area.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components.
	 * @see UI.Button#getTextGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.Button#setTextGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.Button#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a button.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextSize(24);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.Button#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.Button#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.Button#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var infoButton = new UI.Button();
	 * ...
	 * infoButton.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.Button#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.Button#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.Button#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	Button.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			Button.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/GLView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/GLView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/GLView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var GLView = exports.GLView = AbstractView.subclass(
/** @lends UI.GLView.prototype */
{
	'type':'glview',
	/**
	* @class The <code>GLView</code> class constructs objects that provide applications with access to OpenGL. Games must instantiate a <code>GLView</code> object, 
	* set the active state to <code>true</code> and wait for the callback before instantiating any objects in the {@link GL2} module.
	* @name UI.GLView
	* @augments UI.AbstractView	
	*/
	initialize: function($super, properties) {
		if (GLView._init) GLView._init();
		$super(properties);
	}
});

GLView._init = function() {
	delete GLView._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.GLView#setActive
	 * @description Set the value of the <code>active</code> property.
	 * @example var glView = new UI.GLView()
	 * ...
	 * glView.setActive(true);
	 * @param {Boolean} active Set as <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#getActive
	 * @status iOS, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.GLView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>GLView</code> object is active.
	 * @see UI.GLView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	GLView.synthesizeProperty('active', Commands.setActive);
	
	/**
	 * @name UI.GLView#getOGLExtensions
	 * @description Return an array containing all of the OpenGL extensions that are supported within the context of this view.
	 * The return value of this method is only valid when the view is active.
	 * @status Android
	 * @function
	 */
	GLView.registerAccessors('OGLExtensions', function() {return this['_OGLExtensions'];}, function() {} );
	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/NavController'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/NavController'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/NavController'] = exports; var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
var KeyEmitter = require('NGCore/Client/Device/KeyEmitter').KeyEmitter;
var Window = require('NGCore/Client/UI/Window').Window;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Device = require('NGCore/Client/Device').Device;
var Element = require('NGCore/Client/UI/Element').Element;
var View = require('NGCore/Client/UI/View').View;

function getAnalyticsName(item){
	if(item && item.hasOwnProperty("analyticsName")){
		return item["analyticsName"] || undefined;	// If NULL, return undefined.
	}
	return undefined;
}

var NavKeyListener = MessageListener.subclass({
	classname: "UI_NavController_KeyListener",
});

var NavController = exports.NavController = View.subclass(
/** @lends UI.NavController.prototype */
{
	/**
	 * @class The <code>NavController</code> class constructs objects that define application navigation components.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 */
	initialize: function($super, properties) {
		if (NavController._init) NavController._init();
		
	    this.navStack = [];
		var onAndroid = Capabilities.getPlatformOS() == 'Android';
	    this._useBackButton = !onAndroid;
	
		this.keyListener = new NavKeyListener();
		KeyEmitter.addListener(this.keyListener, this.onKeyPressed.bind(this));
		$super(properties);
	},
	
	/**
	 * Turn on the onscreen <b>Back</b> button. Applications designed for iOS should always provide the <b>Back</b> button 
	 * and integrate it into the application UI (calling <code>{@link UI.NavController#back}</code> when pressed).<br><br>
	 * <b>Note:</b> This is turned off by default for applcations designed for Android because Android devices contain a hardware <b>Back</b> button.
	 * @param {Boolean} toUse Set as <code>true</code> to enable the onscreen <b>Back</b> button.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	setUseBackButton: function(toUse) {
		this._useBackButton = toUse;
		if (toUse) {
			this._createBackButton();
		} else if (this.backButton) {
			this.backButton.removeFromParent();
		}
	},
    
	/**
	 * Reset the stack for this <code>NavController</code>.
	 * @param {String} fromButton The button to reset.
	 * @status Javascript, iOS, Android, Flash
	 */    
	clear: function(fromButton) {
		return this.backToView(undefined);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	logNavEvent: function (from, to, via) {
		var toName = getAnalyticsName(to);
		var fromName = getAnalyticsName(from);
		var viaName = getAnalyticsName(via);
		if (fromName || toName) {
			Core.Analytics._getPipe().navigationEvent(fromName, toName, viaName);
		}
	},
	
	/**
	 * Retrieve the top view from the nav stack of this <code>NavController</code>.
	 * @returns {Object} The top view in the nav stack
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	getTopView: function() {
		return (this.navStack.length > 0) ? this.navStack[ (this.navStack.length - 1) ] : undefined;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	navStackDepth: function() {
		return this.navStack.length;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	depthOfView: function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){return -1;}
		
		return this.navStack.length - targetIndex - 1;
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	viewAtDepth: function(targetDepth) {
		if(targetDepth >= this.navStack.length){
			return null;
		}
		return this.navStack[this.navStack.length - targetDepth - 1];
	},
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	*/
	removeDeepView:function(targetView) {
		var targetIndex = this.navStack.indexOf(targetView);
		if(targetIndex == -1){
			NgLogE("NavController: trying to remove a nonexistent view from the nav stack!");
			return;
		}
		this.navStack.splice(targetIndex,1);
	},
    
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_viewTransition: function(fromView, toView, back, buttonRef) {
		//The views transition within the container (which is 'this')
		var myFrame = this.getFrame();
		var w = myFrame[2];
		var h = myFrame[3];
		
		//TODO: animate this (below) transition.
		if (toView) {
			toView.setFrame( (back ? -w : w), 0, w, h);
			this.addChild(toView);
		}
		
		UI.animate(function() {
			if (fromView) fromView.setFrame( (back ? w : -w), 0, w, h);
			if (toView) toView.setFrame(0, 0, w, h);
		}, 400, function() {
			if (fromView) fromView.removeFromParent();
		});
		
		this.logNavEvent(fromView, toView, buttonRef);
		this._createBackButton();
	},

	/**
	 * Retrieve removed views in the reverse order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.forwardToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#backToView
	 */    
	forwardToView: function(destView, fromButton) {
		var currentView = this.getTopView();
		if (destView && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPush == "function" 
					&& this._delegate.navControllerShouldPush(this,destView))
			)) {
			
			destView.performEventCallback({eventType:"push",navController:this})
			
			this.navStack.push(destView);
			this._viewTransition(currentView, destView, false, fromButton);
		}
	},
    
	/**
	 * Set back navigation for this <code>NavController</code>.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forward	
	 */
	back: function(fromButton) {
		var removed = this.navStack.pop();
		
		if (removed && 
			(!this._delegate 
				|| (this._delegate 
					&& typeof this._delegate.navControllerShouldPop == "function" 
					&& this._delegate.navControllerShouldPop(this,removed))
			)) {
			removed.performEventCallback({eventType:"pop",navController:this});
		} else {
			return null;
		}
		this._viewTransition(removed, this.getTopView(), true, fromButton);
		return removed;
	},

	/**
	 * Retrieve removed views in the order they were removed.
	 * @example var page = new NavPage({...});
	 *
	 * var controller = new UI.NavController({...});
	 *
	 * NavPage.navController = controller;
	 * controller.backToView(page);
	 * @param {String} destView The destination view for this navigation component.
	 * @param {String} fromButton The button that triggers this navigation component.
	 * @status Javascript, iOS, Android, Flash
	 * @see UI.NavController#forwardToView
	 */    
	backToView: function(destView, fromButton) {
		var removedSet = [];
		var removed = this.navStack.pop();
		var originalView = removed;
		if (removed) {
			do {
				if (removed && 
					(!this._delegate 
						|| (this._delegate 
							&& typeof this._delegate.navControllerShouldPop == "function" 
							&& this._delegate.navControllerShouldPop(this,removed))
					)) {
					removedSet.push(removed);
					removed.performEventCallback({eventType:"pop",navController:this});
				}
				else {
					//There was nothing to remove, or the this._delegate said "don't remove".
					break;
				}
				
				if (this.getTopView() == destView){break;}
			} while ((removed = this.navStack.pop()));
		}
		if(removedSet.length > 0) {
			this._viewTransition(originalView, this.getTopView(), true, fromButton);
		}
		return removedSet;
	},

	/**
	 * Set this <code>NavController</code> to launch the application when activated.
	 * @status Javascript, iOS, Android, Flash
	 */    
	loadApp: function() {		
	},
    
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */    
	onBackPressed: function() {
		if (this.navStack.length > 1) {
		//	NgLogD("Handle back on nav stack. Number of views on stack=" + this.navStack.length);
			
			var analyticsName = "bcksbtn"; // Back System Button
			
			// if the topmost view has an analytics name, prefix the button
			var topView = this.getTopView();
			if(topView.analyticsName){
				analyticsName = topView.analyticsName + "." + analyticsName;
			}

			this.back({
				analyticsName: analyticsName
			});
			return true;
		}
		return false;
	},
	
	onKeyPressed: function(event) {
		if ((event.code === Device.KeyEmitter.Keycode.back) && (this.navStack.length > 1)) {
			this.back();
			return true;
		}
		return false;
	},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 */
	_delegate:null,
	/**
	 * @description Set subscribers to the <code>NavController</code> behavior. Subscribers can modify what happens. 
	 * NavControllerDelegateProtocol:
	 *	@optional - (BOOL)navControllerShouldPop(NavController,View)
	 *	@optional - (BOOL)navControllerShouldPush(NavController,View)
	 * @param {String} navDelegate A <code>NavController</code> subscriber.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setDelegate:function( /*NavControllerDelegate*/ navDelegate){
		this._delegate = navDelegate;
	},
	
	delegate:function(){return this._delegate;},
	
	/**
	 * @protected
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	_createBackButton: function() {
		// Do nothing if this device does not require an onscreen button.
		if (!this._useBackButton) return;
		
		if (!this.backButton) {
			this.backButton = new UI.Button({
				normalText: 'Back',
				textSize: 13.0,
				normalTextColor: "FF",
				normalTextShadow: "00 1.5 {0,-1}",
				frame: [-2, 20, Window.outerWidth / 5, Window.outerHeight / 12],
				normalGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerShadow: "99FF 2.0 {0,-1}",
					gradient: [
						"FFCC 0.0",
						"FF80 1.0"
					]
				},
				highlightedGradient: {
					corners: "0 8 8 0",
					outerLine: "00 1.5",
					innerLine: "FF00 15 {0,-1}",
					gradient: [
						"FF50 0.0",
						"FF80 1.0"
					]
				}
			});
			this.backButton.onclick = this.bind(this.onBackPressed);
		}
		
		if (this.navStack.length > 1) {
			if (!this.backButton.getParent()) Window.document.addChild(this.backButton);
		} else if ( this.backButton.getParent() ) {
			this.backButton.removeFromParent();
		}
	}
});

NavController._init = function() {
	delete NavController._init;
	if (View._init) View._init();
}; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WebView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WebView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WebView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var WebView = exports.WebView = AbstractView.subclass(
/** @lends UI.WebView.prototype */
{
	'type':'webview',

	/**
	 * @class The <code>WebView</code> class constructs objects for loading and navigating documents. 
	 * <code>WebView</code> objects also trigger event callback functions when web page events occur.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties Object properties.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (WebView._init) WebView._init();
		this._canGoBack = false;
		this._canGoForward = false;
		return $super(properties);
	},
	
	/** @private */
	_onShouldLoad: function(event) {
		NgLogD("Should Load " + event.url + " ???????");
		var fn = this.getOnShouldload();
		if (typeof fn == 'function') {
			// If we SHOULDN'T load the url, bail.
			if (!Boolean(fn.call(this, event))) return;
		}
		// The default (if the function was missing or not a function) is to load the url.
		this.loadUrl(event.url);
	},
	
	/** @private */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'shouldload') {
				// We need to call the onShouldLoad function in a way that captures the return value.
				this._onShouldLoad(event);
				return;
			}
			if (event.eventType == 'pageload') {
				// Do not touch this parsing code. Everything else is wrong, extensive testing was done.
				this._canGoBack = event.canGoBack = Boolean(JSON.parse(event.canGoBack));
				this._canGoForward = event.canGoForward = Boolean(JSON.parse(event.canGoForward));
			}
			$super(event);
		} catch(e) {
			NgLogException(e);
		}
	},
	// invoke doesn't return a value. to get response, use onpageevent
	/**
	* Run a string of Javascript code in this <code>WebView</code>. Any code requiring a result from <code>invoke()</code> must explicitly 
	* return a value by attempting to load an ngcore:// URL. The attempted load is caught by <code>pageEvent</code>. 
	* @see UI.WebView#event:setOnPageevent
	* @function
    * @status iOS, Android
	*/
	invoke: Commands.invoke,
	/**
	* Set a document to load from the specified URL.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('http://www.webdoc.com/");
	* @param {String} url The URL from which to load a document.
	* @param {String} [headers] The document headers.
	* @param {Number} [timeout] The timeout duration.
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	loadUrl: function(url, headers, timeout) {
		Commands.loadURL.call(this, url, headers || null, +(timeout || 0));
	},
	/**
	* Set a document to load from the specified local path.
	* @example myWebView = new UI.WebView();
	* ...
	* myWebView.loadUrl('./path/to/document/");
	* @param {String} relativePath The local path from which to load a document.
	* @see UI.WebView#loadUrl
    * @status iOS, Android
	*/
	loadDocument: function(relativePath){
		Commands.setSourceDocument.call(this, relativePath);
	},
	/**
	* Load a URL using the HTTP <code>POST</code> method.
	* @param {String} url The URL to load using <code>POST</code>.
	* @param {String / Object} data A string containing the raw <code>POST</code> body, or an object to post with <code>www/form-data</code> encoding containing key/value pairs.
	* @see UI.WebView#loadUrl,
	* @see UI.WebView#loadDocument
    * @status iOS, Android
	*/
	postUrl: function(url, data){
		var dataStr;
		if(typeof data == "object"){
			var params = [];
			for(var key in data){
				params.push(encodeURIComponent(key) + '=' + encodeURIComponent(data[key]));
			}
			dataStr = params.join('&');
		}else{
			dataStr = data;
		}
		Commands.postURL.call(this, url, dataStr);
	},
	/**
	* Stop loading a document. 
	* @function
    * @status iOS, Android
	*/
	stopLoading: Commands.stopLoading,
	/**
	* Reload a document called with <code>loadDocument()</code> or <code>loadUrl()</code>.
	* @see UI.WebView#loadDocument,
	* @see UI.WebView#loadUrl
	* @function
    * @status iOS, Android
	*/
	reload: Commands.reload,
	/**
	* Navigate to the previous page in a document view.
	* @see UI.WebView#goForward
	* @function
    * @status iOS, Android
	*/
	goBack: Commands.goBack,
	/**
	* Navigate to the next page in a document view.
	* @see UI.WebView#goBack
	* @function
    * @status iOS, Android
	*/
	goForward: Commands.goForward,
	/**
	* Set back navigation as supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports back navigation.
	* @see UI.WebView#canGoForward
    * @status iOS
	*/
	canGoBack: function(){
		return this._canGoBack;
	},
	/**
	* Set that forward navigation is supported in this <code>WebView</code>.
	* @returns {Boolean} Returns <code>true</code> if this <code>WebView</code> supports forward navigation.
	* @see UI.WebView#canGoBack
    * @status iOS
	*/
	canGoForward: function(){
		return this._canGoForward;
	},
	/**
	* Set the authentication credentials for this <code>WebView</code> session.
	* @param {String} host The authentication host.
	* @param {String} realm The security realm.
	* @param {String} username The username to use for authenticating the session.
	* @param {String} password The password to use for authenticating the session.
    * @status iOS, Android
	*/
	setBasicAuthCredential: function(host, realm, username, password){
		Commands.setBasicAuthCredentials.call(this, {'host':host, 'realm':realm, 'username':username, 'password':password});
	}
});

WebView._init = function() {
	delete WebView._init;
	if (AbstractView._init) AbstractView._init();
	
	WebView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	/**
	 * @name UI.WebView#setOnStartload
	 * @description Set a function to call when the <code>startload</code> event occurs.
	 * @param {Function} startloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>startload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnStartload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnStartload
	 * @description Retrieve the function to call when the <code>startload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnStartload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('startload');
	/**
	 * @name UI.WebView#setOnPageload
	 * @description Set a function to call when the <code>pageload</code> event occurs.
	 * @param {Function} pageloadCallback The function to call.<br><br>
	 * <b>Note:</b> The <code>pageload</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageload
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageload
	 * @description Retrieve the function to call when the <code>pageload</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageload
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageload');
	/**
	 * @name UI.WebView#setOnError
	 * @description Set a function to call when the <code>error</code> event occurs.
	 * @param {Function} [errorCallback] The function to call.<br><br>
	 * <b>Note:</b> The <code>error</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnError
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnError
	 * @description Retrieve the function to call when the <code>error</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnError
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('error');
	/**
	 * @name UI.WebView#setOnPageevent
	 * @description Set a function to call when the <code>pageevent</code> event occurs.
	 * @param {Function} pageeventCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>pageevent</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.WebView#event:getOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	/**
	 * @name UI.WebView#getOnPageevent
	 * @description Retrieve the function to call when the <code>pageevent</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.WebView#event:setOnPageevent
	 * @event
	 * @status iOS, Android
	 */
	WebView.registerEventType('pageevent');	
	/** 
	* @name UI.WebView#setOnShouldLoad
	* @description Set a function to call when the <code>shouldload</code> event occurs. The callback for the event returns 
	* <code>true</code> if the page should be loaded. Otherwise, the callback returns <code>false</code>.
	* @param {function} shouldloadCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>shouldload</code> event is disabled if the value of this parameter is not a function.
	* @example  myWebView.setOnShouldload( function(event) {
	NgLogD("URL is " + event.url);
	NgLogD("Nav Type is " + event.navigation);
  } );
	* @see UI.WebView#event:getOnShouldLoad
	* @event
	*/
	/**
	* @name UI.WebView#getOnShouldLoad
	* @description Retrieve the function to call when the <code>shouldload</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnShouldLoad
	* @event
	*/
	WebView.registerEventType('shouldload');
	
	/** 
	* @name UI.WebView#setOnExternalLink
	* @description Set a function to call when a link will be opened in an external application.
	* @param {function} ExternalLinkCallback The new callback function.<br><br>
	* @see UI.WebView#event:getOnExternalLink
	* @event
	*/
	/**
	* @name UI.WebView#getOnExternalLink
	* @description Retrieve the function to call when the <code>ExternalLink</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.WebView#event:setOnExternalLink
	* @event
	*/
	WebView.registerEventType('externalLink');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ScrollView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ScrollView'] = exports; var View = require('NGCore/Client/UI/View').View;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ScrollView = exports.ScrollView = View.subclass(
/** @lends UI.ScrollView.prototype */
{
	'type':'scrollview',
	/**
	* @class The <code>ScrollView</code> class constructs objects that handle views in a scrolling list (see <code>{@link UI.ListView}</code>). 
	* You can define these views as scrolling vertically, horizontially, or both directions.<br><br>
	* <b>Note:</b> Android devices can only scroll in one direction at a time.
	* @name UI.ScrollView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		if (ScrollView._init) ScrollView._init();
		this._scrollPosition = [0, 0];
		return $super(properties);
	},
	
	/**
	 * @private
	 */    
	updateScrollPosition: function(newVal) {
		this._scrollPosition = newVal;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'scroll') this.updateScrollPosition(e.scrollPosition);
		$super(e);
	}
});

// Properties
ScrollView._init = function() {
	delete ScrollView._init;
	if (View._init) View._init();

	/**
	 * @name UI.ScrollView#setContentSize
	 * @description Set the value for the <code>contentSize</code> property. This property defines the size of a scroll area.
	 * @example var dialog = {
	 * 	width: screen.width * sizeRate.width / 100,
	 *	height: screen.height * sizeRate.height / 100
	 * };
	 * ...
	 * this.scrollView.setContentSize([dialog.width, 600]);
	 * @params {Number, Array (Number, String)} Individual components or a component array.
	 * @see UI.ScrollView#getContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getContentSize
	 * @description Retrieve the value of the <code>contentSize</code> property.
	 * @returns {Number, Array (Number, String)} The current value of <code>contentSize</code>.
	 * @see UI.ScrollView#setContentSize
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('contentSize', Commands.setScrollableSize);
	/**
	 * @name UI.ScrollView#setScrollPosition
	 * @description Set the value for the <code>scrollPosition</code> property.
	 * @example var hscroller = new UI.ScrollView();
	 * ...
	 * hscroller.setScrollPosition([0.5,0]);
	 * @params {Number, Array (Number)} Individual components or a component array.
	 * @see UI.ScrollView#getScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getScrollPosition
	 * @description Retrieve the value of the <code>scrollPosition</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>scrollPosition</code>.
	 * @see UI.ScrollView#setScrollPosition
	 * @function
     * @status iOS, Android, Test
	 */
	ScrollView.synthesizeCompoundProperty('scrollPosition', Commands.setScrollPosition);

	/**
	 * @name UI.ScrollView#setOnScroll
	 * @description Set a function to call when the <code>scroll</code> event occurs.
	 * @param {Function} scrollCallback The new callback function.<br><br>
	 * <b>Note:</b> The <code>pageevent</code> event is disabled if the value of this parameter is not a function.
	 * @see UI.ScrollView#event:getOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ScrollView#getOnScroll
	 * @description Retrieve the function to call when the <code>scroll</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.ScrollView#event:setOnScroll
	 * @event
     * @status iOS, Android, Test
	 */
	ScrollView.registerEventType('scroll');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ScrollView = require('NGCore/Client/UI/ScrollView').ScrollView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');

var ListView = exports.ListView = ScrollView.subclass(
/** @lends UI.ListView.prototype */
{
	'type':'listview',
	/**
	* @class The <code>ListView</code> class constructs objects that contain <code>{@link UI.ListViewItem}</code> and <code>{@link UI.ListViewSection}</code> objects. 
	* These objects handle and render scrolling lists in an application.
	* A <code>ListView</code> object can contain potentially thousands of items, 
	* in sections, that use a pool of reusable views to display content.
	* @name UI.ListView
	* @augments UI.ScrollView
	*/
	initialize:function($super, properties) {
		if (ListView._init) ListView._init();
		$super(properties);
		
		this._sections = [];
		this._scrollPosition = [0,0];
		this.enableEvent('scroll', true);
		
		this._ownedViews = [];
		this._queuedViews = {};
		
		this._cellDivider = 0;
		
		return this;
	},
	
	destroy: function($super) {
		var l = this._ownedViews.length;
		for (var i = 0; i < l; i++) {
			this._ownedViews[i].release();
		}
		this._ownedViews = null;
		$super();
	},
	
	addChild: function($super, child, index) {
		if (index == "cell") {
			index = this._cellDivider++;
		} else if ((index || -1) >= 0) {
			index += this._cellDivider;
		}
		$super(child, index);
	},
	
	_viewForItem: function(lvItem) {
		if (lvItem._currentView instanceof AbstractView) return lvItem._currentView;
		
		var rID = lvItem._reuseId;
		var queue = this._queuedViews[rID];
		
		var view = null;
		while (queue && queue.length > 0) {
			if ((view = queue.pop()) instanceof AbstractView) break;
		}
		
		if (!(view instanceof AbstractView)) {
			view = lvItem._onCreateView(lvItem);
			if (view instanceof AbstractView) {
				this._ownedViews.push(view.retain());
				this.addChild(view, "cell");
			} else {
				console.log("Error creating view for list item with reuse id " + rID);
			}
		}
	//	console.log("_viewForItem: " + lvItem + " = " + view);
		return view;
	},
	
	_queueViewForItem: function(lvItem) {
		var viewToQueue = lvItem._currentView;
		if (viewToQueue instanceof AbstractView) {
			var rId = lvItem._reuseId;
			var queue = this._queuedViews[rId] || (this._queuedViews[rId] = []);
			queue.push(viewToQueue);
		}
		lvItem._setCurrentView();
	},
	
	_removeQueuedViews: function() {
		for (var q in this._queuedViews) {
			if (!this._queuedViews.hasOwnProperty(q)) continue;
			
			q = this._queuedViews[q];
			for (var i = 0, l = q.length; i < l; i++) {
				q[i].removeFromParent();
			}
		}
		this._cellDivider = 0;
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	flushSections: function() {
		for (var i in this._sections) {
			if(!this._sections.hasOwnProperty(i)) { continue; }
				
			var section = this._sections[i];
			// Cause every section to completely queue out its item views.
			section.flush();
			section.calculateItemPositions();
		}
		this._removeQueuedViews();
	},
	
	/**
	 * Clear this <code>ListView</code> and reload all list data.
	 * @see UI.ListViewItem,
	 * @see UI.ListViewSection
 	 * @status Javascript, iOS, Android, Flash
	 */
	reloadData: function() {
		this.flushSections();
		this.calculateSectionPositions();
		this.updateScrollPosition(this._scrollPosition);
	},
	
	/**
	 * Retrieve all contained sections by this <code>ListView</code>.
	 * @returns {Object} The current section list as an array of section IDs.
	 * @see UI.ListView#setSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	getSections: function() {
		return this._sections;
	},
	
	/**
	 * Set the list of sections that this <code>ListView</code> contains.
	 * @example var sections = [];
	 * var section = new UI.ListViewSection;
	 * ...
	 * var items = [];
	 * for(news in News)
	 * {
	 *	var item = new ListItem.ListItem();
	 *	item.game = News[news];
	 *	items.push(item);
	 * }
	 *
	 * section.setItems(items);
	 * sections.push(section);
	 *
	 * gameNews.setSections(sections);
	 * @param {Object} newSections A new aray of section IDs.
	 * @see UI.ListView#getSections
 	 * @status Javascript, iOS, Android, Flash
	 */
	setSections: function(newSections) {
		this.flushSections();
		for (var i in this._sections) {
			if(this._sections.hasOwnProperty(i)) {
				this._sections[i].setListView(null);
			}
		}
		this._sections = newSections;
		var idArray = new Array();
		for (var i in newSections) {
			if(newSections.hasOwnProperty(i)) {
				idArray.push(0+(newSections[i].__objectRegistryId || 0));
			}
		}
		UI.Commands.setSections.call(this, idArray);
		this.reloadData();
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	calculateSectionPositions: function() {
		this._stackedSections = {};
		topY = 0;
		// Should account for header here.
		var l = this._sections.length;
		for (var i = 0; i < l; i++) {
		//	NgLogD("Calculating height for Section " + i + " / " + l + " from yPos " + topY);
			var section = this._sections[i];
			this._stackedSections[topY] = section;
			section.setListView(this);
			section.setYPosition(topY);
			var relTopY = this._scrollPosition[1/*y*/] - topY;
			section.updateVisibleRange(relTopY, relTopY + this._frame[3/*h*/]);
			var h = section._measureHeight();
			// Set the section's frame...
			section._setFrame(0, topY, this._frame[2], h);
			topY += h;
		}
		// Should account for footer here.
		this.setContentSize([this._frame[2], topY]);
	},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	updateScrollPosition:function(newVal) {
		if (this._scrollPosition[1] === newVal[1]) return;
		this._scrollPosition = newVal;
		
		var myHeight = this._frame[3];
		for (var yPos in this._stackedSections) {
			if(this._stackedSections.hasOwnProperty(yPos)) {
				var section = this._stackedSections[yPos];
				relTopY = newVal[1] - yPos;
				section.updateVisibleRange(relTopY, relTopY + myHeight);
			}
		}
	},
	
	/**
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	'_onScroll': function() {},
	
	/**
	 * @private
 	 * @status Javascript, iOS, Android, Flash
	 */
	enableEvent: function($super, eventName, enable) {
		// Don't allow scrolling events to be turned off!
		if ( (eventName == 'scroll') && !enable ) return;
		$super(eventName, enable);
	}
});

ListView._init = function() {
	delete ListView._init;
	if (ScrollView._init) ScrollView._init();

	/**
	 * @name UI.ListView#setHeader
	 * @description Set the value for the <code>header</code> property. This string is used as a header for the <code>ListView</code>.
	 * @example var friendHeader = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('Friends List');
	 * @param {String} header The new header.
	 * @see UI.ListView#getHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getHeader
	 * @description Retrieve the value of the <code>header</code> property.
	 * @returns {String} The current header.
	 * @see UI.ListView#setHeader
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('header');
	/**
	 * @name UI.ListView#setFooter
	 * @description Set the value for the <code>footer</code> property. This string is used as a footer for the <code>ListView</code>.
	 * @example var friendFooter = mew UI.ListView();
	 * ...
	 * friendHeader.setHeader('This is a footer');
	 * @param {String} footer The new footer.
	 * @see UI.ListView#getFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.ListView#getFooter
	 * @description Retrieve the value of the <code>footer</code> property.
	 * @returns {String} The current footer.
	 * @see UI.ListView#setFooter
	 * @function
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	ListView.synthesizeProperty('footer');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewSection'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewSection'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var ListViewItem = require('NGCore/Client/UI/ListViewItem').ListViewItem;

/* This class does not have a physical view representation.
	We still fully map and register it so that sections can be persisted independently of tables. */

var ListViewSection = exports.ListViewSection = Element.subclass(
/** @lends UI.ListViewSection.prototype */
{
	'type':'listview-section',
	/**
	* @class The <code>ListViewSection</code> class constructs objects that contain <code>ListViewItem</code> objects. 
	* These objects are rendered as individual sections of a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewSection
	* @augments UI.Element
	*/
	initialize:function($super, properties) {
		if (ListViewSection._init) ListViewSection._init();
		
		this._visibleRange = [0,0];
		this._headerHeight = 0;
		this._titleHeight = 0;
		
		delete this._measuredHeight;
		this._needsLayout = false;
		
		$super(properties);
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	addItemToVisible: function(lvItem, index) {
		if (!(lvItem instanceof ListViewItem)) return;
		if (lvItem._currentView instanceof Element) return;
		
		var useView = this._listView._viewForItem(lvItem);
		var w = this._listView.getFrame()[2];
		
		if (this._rowHeight > 0) {
			useView.setFrame(0, this._yPosition + this._titleHeight + index * this._rowHeight, w, this._rowHeight);
		} else {
			useView.setFrame(0, this._yPosition + this._cellPositions[index], w, lvItem._height);
		}
		
		lvItem._setCurrentView(useView);
		if (!useView.getParent()) this._listView.addChild(useView, "cell");
	},
	
	_setFrame: function(l, t, w, h) {
		UI.Commands.setFrame.call(this, l, t, w, h);
		if (this._titleView) {
			var f = this._titleView.getFrame();
			this._titleView.setFrame(l, t, w, f[3]);
		}
	},
	
	/**
	 * Reset the visible range for this <code>ListViewSection</code>.
	 * @function
	 * @status Javascript, iOS, Android, Flash
	 */
	flush: function() {
		for (var i = this._visibleRange[0], l = this._visibleRange[1]; i < l; i++) {
			this._listView._queueViewForItem(this._items[i]);
		}
		this._visibleRange = [0,0];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	updateVisibleRange: function(topY, bottomY) {
		var totalH = this._getMeasuredHeight();
		
		// Expand the view window. This is really only necessary for Android...
		var l = this._items.length;
		var rowH = this._rowHeight > 0 ? this._rowHeight : totalH / l;
		topY -= rowH * 5;
		bottomY += rowH * 5;
		
		var oldStartIndex = this._visibleRange[0];
		var oldEndIndex = this._visibleRange[1];
		var startIndex = l > 0 ? Math.max(0, Math.floor(topY / rowH)) : 0;
		var endIndex = l > 0 ? Math.min(l, startIndex + Math.floor((bottomY - topY) / rowH)) : 0;
		
		if (this._cellPositions) {
			// We should have a good guess into the array from the above code,
			// so now it just needs to be adjusted until accurate.
			while (startIndex < l && this._cellPositions[startIndex] < topY) startIndex++;
			while (startIndex > 0 && this._cellPositions[startIndex] > topY) startIndex--;
			if (startIndex >= l) startIndex = Math.max(0, l - 1);
			
			while (endIndex < l && this._cellPositions[endIndex] < bottomY) endIndex++;
			while (endIndex > startIndex && this._cellPositions[endIndex] > bottomY) endIndex--;
		
			topY = this._cellPositions[startIndex];
			// EndIndex is one past the last element...
			bottomY = endIndex == 0 ? topY : (this._cellPositions[endIndex-1] + this._items[endIndex-1]._height );
		}
		if (bottomY < 0 || topY > totalH) {
			for (var i = this._visibleRange[0]; i < this._visibleRange[1]; i++) {
				this._listView._queueViewForItem(this._items[i]);
			}
			this._visibleRange = [0,0];
			return;
		}
		
		if (oldStartIndex == startIndex && oldEndIndex == endIndex) return;
		
//		NgLogD("(" + oldStartIndex + "," + oldEndIndex + ") -> (" + startIndex + "," + endIndex + ")");
		
		if (oldStartIndex == oldEndIndex) {
			for (var i = startIndex; i < endIndex; i++) {
				this.addItemToVisible(this._items[i], i);
			}
		} else {
			// Dequeue and requeue from both ends.
			if (oldStartIndex < startIndex) {
				do {
					this._listView._queueViewForItem(this._items[oldStartIndex]);
				} while (++oldStartIndex < startIndex);
			}
			if (oldEndIndex > endIndex) {
				while (oldEndIndex-- > endIndex) {
					this._listView._queueViewForItem(this._items[oldEndIndex]);
				}
				oldEndIndex = endIndex;	// Keep later codepath from triggering
			}
		
			if (oldStartIndex > startIndex) {
				while (oldStartIndex-- > startIndex) {
					this.addItemToVisible(this._items[oldStartIndex], oldStartIndex);
				}
				oldStartIndex = startIndex;
			} 
			if (oldEndIndex < endIndex) {
				do {
					this.addItemToVisible(this._items[oldEndIndex], oldEndIndex);
				} while (++oldEndIndex < endIndex)
			}
		
		}
		this._visibleRange = [startIndex, endIndex];
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	setListView : function(listView) {
		this._listView = listView;
		delete this._measuredHeight;
		return this;
	},
	
	_getMeasuredHeight : function() {
		return this._measuredHeight || this._measureHeight();
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	_measureHeight : function() {
		// Sum the heights of the rows.  No variable-heights yet!!!
		if (this._rowHeight < 0) {
			// Variable Height Trigger
			var totalHeight = this._titleHeight + this._headerHeight;
			var runningHeights = [];
			var l = this._items.length;
			for (var i = 0; i < l; i++) {
				runningHeights.push(totalHeight);
				totalHeight += this._items[i]._height;
			}
			this._cellPositions = runningHeights;
			return this._measuredHeight = totalHeight;
		}
		
		delete this._cellPositions;
		return this._measuredHeight = this._titleHeight + this._headerHeight + this._rowHeight * this._items.length;
	},
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	calculateItemPositions: function() {
		// Not used?.
	},
});

ListViewSection._init = function() {
	delete ListViewSection._init;
	if (Element._init) Element._init();

	// We don't have a set pattern for sending the id of a view we want to assign by reference...
	/**
	 * @name UI.ListViewSection#setTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#getTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var boundTitleFunction = function() {
		if (this.listViewMonitor) this.listViewMonitor.setTitleView(this);
		boundTitleFunction._superfunc.apply(this, Array.prototype.slice.call(arguments));
	};
	var setTitleView = function(titleView) {
		if (this._titleView && this._titleView.listViewMonitor == this) {
			delete this._titleView.listViewMonitor;
		}
		this._titleView = titleView;
		
		if (!(titleView.listViewMonitor == this)) {
			titleView.listViewMonitor = this;
			if (!boundTitleFunction._superfunc) {
				boundTitleFunction._superfunc = titleView.setFrame;
			}
			if (titleView.setFrame != boundTitleFunction) {
				titleView.registerAccessors('frame', null, boundTitleFunction);
			}
		}
		
		this._titleHeight = titleView.getFrame()[3];
		delete this._measuredHeight;
		Commands.setTitleView.call(this, ObjectRegistry.objectToId(titleView));
		return this;
	}
	/**
	 * @name UI.ListViewSection#getTitleView
	 * @description 
	 * @function
	 * @see UI.ListViewSection#setTitleView
 	 * @status Javascript, iOS, Android, Flash
	 */
	var getTitleView = function() {
		return this._titleView;
	}
	/**
	 * @name UI.ListViewSection#setTitle
	 * @description Set the value for the <code>title</code> property.
	 * @param {String} title The new section title.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ListViewSection#getTitle
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getTitle
	 * @description Retrieve the value of the <code>title</code> property.
	 * @returns {String} The current section title.
	 * @see UI.ListViewSection#setTitle
	 * @function
	 */
	ListViewSection.registerAccessors('titleView', getTitleView, setTitleView);
	
	// Other properties
	/**
	 * @name UI.ListViewSection#setRowHeight
	 * @description Set the value for the <code>rowHeight</code> property.
	 * @param {Number} rowHeight The new row height.
	 * @see UI.ListViewSection#getRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getRowHeight
	 * @description Retrieve the value of the <code>rowHeight</code> property.
	 * @returns {Number} The current row height.
	 * @see UI.ListViewSection#setRowHeight
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('rowHeight');
	/**
	 * @name UI.ListViewSection#setItems
	 * @description Set the value for the <code>items</code> property.
	 * Setting this updates the visual state of the <code>listView</code> if the section is in a <code>listView</code> that is visible.
	 * @param {UI.ListViewItem} items The new <code>ListView</code> items.
	 * @see UI.ListViewSection#getItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var setItems = function(newItems) {
		newItems = (newItems instanceof Array) ? newItems : Array.prototype.slice.call(arguments);
		
		this.flush();
		this._items = newItems;
		
		if (!this._listView) return;
		this._listView.reloadData();
		delete this._measuredHeight;
	}
	/**
	 * @name UI.ListViewSection#getItems
	 * @description Retrieve the value of the <code>items</code> property.
	 * @returns {UI.ListViewItem} The current <code>ListView</code> items.
	 * @see UI.ListViewSection#setItems
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	var getItems = function() {
		return this._items;
	}
	ListViewSection.registerAccessors('items', getItems, setItems);
	/**
	 * @name UI.ListViewSection#setYPosition
	 * @description Set the value for the <code>yPosition</code> property.
	 * @param {Number} yPosition The new position for <i>y</i>.
	 * @see UI.ListViewSection#getYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.ListViewSection#getYPosition
	 * @description Retrieve the value of the <code>yPosition</code> property.
	 * @returns {Number} The current position of <i>y</i>.
	 * @see UI.ListViewSection#setYPosition
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	ListViewSection.synthesizeProperty('yPosition');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ListViewItem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ListViewItem'] = exports; /* This class does not have a physical view representation, and is just a holder for closures / a bag for data...
	We still fully map and register it so that sections can be persisted independently of tables. */
var Class = require('NGCore/Client/Core/Class').Class;

var ListViewItem = exports.ListViewItem = Class.subclass(
/** @lends UI.ListViewItem.prototype */
{	/**
	* @class The <code>ListViewItem</code> class constructs objects that contain data for individual items in a scrolling list (see <code>{@link UI.ListView}</code>).
	* @name UI.ListViewItem
	* @constructs The default constructor.
	* @augments Core.Class
	*/
	
	'type':'listview-item',
	
	_reuseId: "__default__",
	/** @protected */
	_currentView: null,
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onCreateView: function() {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onReleaseView: function(oldView) {},
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_onSetView: function(newView) {},
	
	/**
	 * Set the callback for the <code>onCreateView</code> event. 
	 * This event must return a newly created view that displays the data type represented by the item.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnCreateView: function(newFn)	{this._onCreateView = newFn},
	/**
	 * Set the callback for the <code>onReleaseView</code> event. This event occurs when the view is set to <code>null</code>. 
	 * Use this to remove uncommon view states or clean up the view when necessary.
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnReleaseView: function(newFn)	{this._onReleaseView = newFn},
	/**
	 * Set the callback for the <code>onSetView</code> event. When this event occurs, the item puts any relevant visual state / data into <code>newView</code>.
	 * This transfer should occur before the item is visible to the user:
	 * <pre class="code">onSetView(newView)</pre>
	 * @param {Function} newFn The new function to call.
	 * @event
	 */
	setOnSetView: function(newFn)		{this._onSetView = newFn},
	
	/**
	 * Set the height of the current ListViewItem in pixels.
	 * <pre class="code">setHeight(Number)</pre>
	 * This should occur before the item is visible to the user.
	 * This setting is only used when the item's ListViewSection has height = -1
	 * @param {Function} newFn The new function to call.
	 */
	setHeight: function(h) {
		this._height = h;
	},
	
	/**
	 * Get the current height of the ListViewItem.
	 * <pre class="code">getHeight()</pre>
	 * This should occur before the item is visible to the user.
	 * @returns {Number} The height of this ListViewItem.
	 */
	getHeight: function() {
		return this._height;
	},
	
	/**
	 * @function
	 * @protected
 	 * @status Javascript, iOS, Android, Flash
	 */
	_setCurrentView: function(newView) {
		if (newView instanceof Class) {
			this._onSetView(newView);
		} else {
			this._onReleaseView(this._currentView);
		}
		this._currentView = newView;
		return this;
	},
	
	/**
 	 * Retrieve the current view attached to this <code>ListViewItem</code>.
	 * @returns {UI.View} The current <code>ListViewItem</code> view.
	 * @status Javascript, iOS, Android, Flash
	 */
	getCurrentView: function(){
		return this._currentView;
	},
		
	initialize: function(reuseId) {
		if (reuseId) this._reuseId = reuseId;
		return this;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CellView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CellView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CellView'] = exports; var View = require('NGCore/Client/UI/View').View;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CellView = exports.CellView = View.subclass(
/** @lends UI.CellView.prototype */
{
	'type':'cell',
	/**
	* @class The <code>CellView</code> class constructs objects that handle cell views in an application. For example, a cell in a scrolling list.
	* These objects are rendered with images on the left and right, and two text areas (title and text) stacked vertically in the middle.
	* @name UI.CellView
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (CellView._init) CellView._init();
		$super(properties);
	}
});

// Properties
CellView._init = function() {
	delete CellView._init;
	if (View._init) View._init();
	
	/**
	 * @name UI.CellView#setImage
	 * @description Set the value of the <code>image</code> property for a view state. This defines how a cell view appears for specific conditions. For example,
	 * set different images for a cell view in the default state and when the cell view has focus.
	 * @example background.setImage('./Content/blank.png', [w, h], [0, 0]);
	 * @param {String} image The new <code>image</code> URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImage
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImage
	 * @description Retrieve the value of the <code>image</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current <code>image</code> URL.
	 * @see UI.CellView#setImage
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CellView#setImageBorder
	 * @description Set the value of the <code>imageBorder</code> property for a view state. This property defines a border for images used in the specified view state.
	 * @param {Object} imageBorder The new value for <code>imageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getImageBorder
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageBorder
	 * @description Retrieve the value of the <code>imageBorder</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current value of <code>imageBorder</code>.
	 * @see UI.CellView#setImageBorder
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	CellView.synthesizePropertyWithState('imageBorder', Commands.setImageBorder);
	/**
	 * @name UI.CellView#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example background.setImageInsets([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (float).
	 * @see UI.CellView#getImageInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CellView#setImageInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	/**
	 * @name UI.CellView#setImageFit
	 * @description Set the value of the <code>imageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example background.setImageFit(UI.FitMode.None);
	 * @param {Number} imageFit The new value for <code>imageFit</code>.
	 * @see UI.CellView#getImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageFit
	 * @description Retrieve the value of the <code>imageFit</code> property.
	 * @returns {Number} The current value of <code>imageFit</code>.
	 * @see UI.CellView#setImageFit
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageFit', Commands.setImageFitMode);
	/**
	 * @name UI.CellView#setImageGravity
	 * @description Set the value of the <code>imageGravity</code> property. This property defines how an image is positioned within a viewable area.
	 * @example background.setImageGravity([0.5, 0.0]);
	 * @param {Number} imageGravity The new value for <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#getImageGravity
	 * @function
 	 * @status iOS, Android, Test
	 */
	/**
	 * @name UI.CellView#getImageGravity
	 * @description Retrieve the value of the <code>imageGravity</code> property.
	 * @returns {Number} The current value of <code>imageGravity</code> (expressed as two floats).
	 * @see UI.CellView#setImageGravity
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	CellView.synthesizeProperty('imageGravity', Commands.setImageGravity);
	 /**
	 * @name UI.CellView#setImageTransform
	 * @description Set the value of the <code>imageTransform</code> property. This property defines data compression for images used with a cell view.
	 * @example background.setImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} imageTransform The new value for <code>imageTransform</code>. Set as an array of floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#getImageTransform
	 * @description Retrieve the value of the <code>imageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>imageTransform</code>.
	 * @see UI.CellView#setImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('imageTransform', Commands.setImageTransform);
	/**
	 * @name UI.CellView#getRightImage
	 * @description Retrieve the value of the <code>rightImage</code> property in the specified view state.
	 * @returns {String} The current value of <code>rightImage</code>.
	 * @function
	 * @see UI.CellView#setRightImage
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setRightImage
	 * @description Set the value of the <code>rightImage</code> property in the specified view state. This defines how images used for UI controls appear for specific conditions. For example, 
	 * use seperate images for a closure arrow in the default state and a closure arrow when expanded.
	 * @example var cellClosure = new UI.CellView()
	 * ...
	 * cellClosure.setRightImage('./Content/closure.png', [w, h], [0, 0]);
	 * @param {String} rightImage The new value for <code>rightImage</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI State.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImage
	 */
	CellView.synthesizePropertyWithState('rightImage', Commands.setRightImage);
	/**
	 * @name UI.CellView#getRightImageBorder
	 * @description Retrieve the value of the <code>rightImageBorder</code> property in the specified view state. 
	 * @returns {Object} The current value of <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setRightImageBorder
	 */
	/**
	 * @name UI.CellView#setRightImageBorder
	 * @description Set the value of the <code>rightImageBorder</code> property in the specified view state. This property defines a border for images used in the specified view state.
	 * @param {Object} rightImageBorder The new value for <code>rightImageBorder</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI View state.
 	 * @status iOS, Android, Test
	 * @function
	 * @see UI.CellView#getRightImageBorder
	 */
	CellView.synthesizePropertyWithState('rightImageBorder', Commands.setRightImageBorder);
	/**
	 * @name UI.CellView#getRightImageInsets
	 * @description Retrieve the value of the <code>rightImageInsets</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageInsets</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageInsets
	 */
	/**
	 * @name UI.CellView#setRightImageInsets
	 * @description Set the value of the <code>rightImageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example closureIcon.setRightImageInsets([10,10,10,10]);
	 * @param {Array (Number)} rightImageInsets The new value for <code>rightImageInsets</code>. Set as floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageInsets
	 */
	CellView.synthesizeProperty('rightImageInsets', Commands.setRightImageInsets);
	/**
	 * @name UI.CellView#getRightImageFit
	 * @description Retrieve the value of the <code>rightImageFit</code> property. 
	 * @returns {Number} The current value of <code>rightImageFit</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageFit
	 */
	/**
	 * @name UI.CellView#setRightImageFit
	 * @description Set the value of the <code>rightImageFit</code> property. This property defines the scaling of bitmap images to fit within the bounds of a control 
	 * (subtracting the value for <code>imageInsets</code>).
	 * @example closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageFit(UI.FitMode.None);
	 * @param {Number} rightImageFit The new value for <code>rightImageFit</code>.
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageFit
	 */
	CellView.synthesizeProperty('rightImageFit', Commands.setRightImageFitMode);
	/**
	 * @name UI.CellView#getRightImageGravity
	 * @description Retrieve the value of the <code>rightImageGravity</code> property. 
	 * @returns {Number} The current value of <code>rightImageGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setRightImageGravity
	 */
	/**
	 * @name UI.CellView#setRightImageGravity
	 * @description Set the value of the <code>rightImageGravity</code> property. This property defines how a image for a control is positioned within a viewable area.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageGravity([0.5, 0.0]);
	 * @param {Number} rightImageGravity The new value for <code>rightImageGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getRightImageGravity
	 */
	CellView.synthesizeProperty('rightImageGravity', Commands.setRightImageGravity);
	/**
	 * @name UI.CellView#getRightImageTransform
	 * @description Retrieve the value of the <code>rightImageTransform</code> property.
	 * @returns {Array (Number)} The current value of <code>rightImageTransform</code>.
	 * @see UI.CellView#setRightImageTransform
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	 /**
	 * @name UI.CellView#setRightImageTransform
	 * @description Set the value of the <code>rightImageTransform</code> property. This property defines data compression for images used with right image objects.
	 * @example var closureIcon = new UI.CellView();
	 * ...
	 * closureIcon.setRightImageTransform([Math.cos(angle), Math.sin(angle), Math.sin(angle), Math.cos(angle), 0, 0]);
	 * @param {Array (Number)} rightImageTransform The new value for <code>rightImageTransform</code>. 
	 * Set as six floats (<i>a</i>, <i>b</i>, <i>c</i>, <i>d</i>, <i>tx</i>, <i>ty</i>).
	 * @see UI.CellView#getRightImageTransform
 	 * @status iOS, Android, Test
	 * @function
	 */
	 CellView.synthesizeCompoundProperty('rightImageTransform', Commands.setRightImageTransform);
	 
	/**
	 * @name UI.CellView#getTitle
	 * @description Retrieve the value of the <code>title</code> property in a view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 * @see UI.CellView#setTitle
	 */
	/**
	 * @name UI.CellView#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for a view in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitle('Game of Foo');
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitle
	 * @function
	 */
	CellView.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.CellView#getTitleColor
	 * @description Retrieve the value of the <code>titleColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleColor</code>.
	 * @see UI.CellView#setTitleColor
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTitleColor
	 * @description Set the value of the <code>titleColor</code> property for a view state. This property defines the title string color for the <code>CellView</code> object in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleColor(0,0,1);
	 * @param {String} titleColor The new value for <code>titleColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTitleColor
	 * @function 
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleColor', Commands.setTitleColor);
	/**
	 * @name UI.CellView#getTitleFont	 
	 * @description Retrieve the value of the <code>titleFont</code> property in a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleFont</code>.
	 * @function
	 * @see UI.CellView#setTitleFont
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleFont
	 * @description Set the value of the <code>titleFont</code> property in a view state. This property defines the title string font for cell view labels in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleFont('Content/Cacophony.ttf');
	 * @param {String} titleFont The new value for <code>titleFont</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @function
	 * @see UI.CellView#getTitleFont
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizePropertyWithState('titleFont', Commands.setTitleFont);
	/**
	 * @name UI.CellView#getTitleShadow
	 * @description Retrieve the value of the <code>titleShadow</code> property in a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>titleShadow</code>.
	 * @see UI.CellView#setTitleShadow
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleShadow
	 * @description Set the value of the <code>titleShadow</code> property in a view state. This property defines the amount of text shadowing used for title strings in a cell view.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleShadow('FFCCCCFF 2.0 {0,0}');
	 * @param {String} titleShadow The new value for <code>titleShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTitleShadow
	 * @function
	 */
	CellView.synthesizePropertyWithState('titleShadow', Commands.setTitleShadow);

	/**
	 * @name UI.CellView#getTitleGravity
	 * @description Retrieve the value of the <code>titleGravity</code> property. 
	 * @returns {Array (Number)} The current value of <code>titleGravity</code>.
	 * @see UI.CellView#setTitleGravity
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleGravity
	 * @description Set the value of the <code>titleGravity</code> property. This property defines how a title string is positioned within a viewable area.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleGravity([0.5, 0.0]);	 
	 * @param {Array (Number)} titleGravity The new value for <code>titleGravity</code>. Set as two floats (<i>x</i>, <i>y</i>).
	 * @see UI.CellView#getTitleGravity
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('titleGravity', Commands.setTitleGravity);

	/**
	 * @name UI.CellView#getTitleSize
	 * @description Retrieve the value of the <code>titleSize</code> property.
	 * @returns {Number} The current value of <code>titleSize</code>.
	 * @see UI.CellView#setTitleSize
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleSize
	 * @description Set the value of the <code>titleSize</code> property. This property defines the text size of title strings in the specified view state.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleSize(32);
	 * @param {Number} titleSize The new value for <code>titleSize</code>. Set as two floats (<i>x</i>, <i>y</i>).	
	 * @function
	 * @see UI.CellView#getTitleSize
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeProperty('titleSize', Commands.setTitleSize);
	/**
	 * @name UI.CellView#getTitleInsets
	 * @description Retrieve the value of the <code>titleInsets</code> property.	 
	 * @returns {Array (Number)} The current value of <code>titleInsets</code>.
	 * @function
	 * @see UI.CellView#setTitleInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTitleInsets
	 * @description Set the value of the <code>titleInsets</code> property. This property defines the viewable area of a title string when applying gravity.
	 * @example var cellTitle = new UI.CellView()
	 * ...
	 * cellTitle.setTitleInsets([10,10,10,10]);	 
	 * @param {Array (Number)} titleInsets The new value for <code>titleInsets</code>. Set as four floats (<i>t</i>, <i>r</i>, <i>b</i>, <i>l</i>).
	 * @function
	 * @see UI.CellView#getTitleInsets
 	 * @status iOS, Android, Test
	 */
	CellView.synthesizeProperty('titleInsets', Commands.setTitleInsets);
	
	/**
	 * @name UI.CellView#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>..
	 * @see UI.CellView#setText
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var cellView = new UI.CellView();
	 * ...
	 * cellView.setText(this.game.description);
	 * @see UI.CellView#getText
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CellView#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code>.
	 * @see UI.CellView#setTextColor
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextColor('FFFF');
	 * @see UI.CellView#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function 
	 */
	CellView.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CellView#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.CellView#setTextShadow	
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var cellText = new UI.CellView();
	 * ...
	 * cellText.setTextShadow('FFCCCCFF 2.0 {0,0}');
	 * @see UI.CellView#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CellView#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CellView#setTextFont
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	/**
	 * @name UI.CellView#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a cell view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextFont('Content/Cacophony.ttf');
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CellView#getTextFont
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	/**
	 * @name UI.CellView#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @see UI.CellView#setTextGravity
	 */
	/**
	 * @name UI.CellView#setTextGravity	 
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextGravity([0.5, 0.0]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a component array (<i>x</i>, <i>y</i>).
	 * @function
 	 * @status iOS, Android, Test
	 * @see UI.CellView#getTextGravity
	 */
	CellView.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CellView#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CellView#setTextSize
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the size of text strings for a view.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CellView#getTextSize
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CellView#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CellView#setTextInsets
 	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CellView#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var cellText = new UI.CellView()
	 * ...
	 * cellText.setTextInsets([10,10,10,10]);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CellView#getTextInsets
 	 * @status iOS, Android, Test
	 * @function
	 */
	CellView.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		//** extra-deprecated */
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing CellView." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CellView.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('text');
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('textFont');
	bindStateProperties('title');
	bindStateProperties('titleColor');
	bindStateProperties('titleFont');
	bindStateProperties('titleShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
	bindStateProperties('imageBorder');
	bindStateProperties('rightImage');
	bindStateProperties('rightImageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckBox'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckBox'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var gradients = {
	'normal': {
		"gradient": ["FFED 0.000", "FFA4 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'pressed': {
		"innerShadow": "FF00 6.0 {0.0,-1.0}",
		"gradient": ["FF80 0.000", "FF80 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "FF51 2.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
	'checked': {"innerLine":"FF27A227 2.0","corners":"3.0 3.0 3.0 3.0","insets":"{4.0,4.0,4.0,4.0}","gradient":["FF2CFF2B 0.000","FF179117 1.000"],"outerShadow":"0000 0.0 {0.0,0.0}","outerLine":"FF51 3.0","innerShadow":"FF97FE97 1.0 {0.0,0.0}"},
	'checkedpressed': {"innerShadow":"FF0F610F 5.0 {0.0,-1.0}","gradient":["FF179117 0.000","FF179117 1.000"],"insets":"{4.0,4.0,4.0,4.0}","outerLine":"FF2B512B 3.0","outerShadow":"0000 0.0 {0.0,0.0}","corners":"3.0 3.0 3.0 3.0"},
	'disabled': {
		"innerShadow": "0000 0.0 {0.0,0.0}",
		"gradient": ["66B6 0.000", "66CA 1.000"],
		"insets": "{4.0,4.0,4.0,4.0}",
		"outerLine": "7FE0 3.0",
		"outerShadow": "0000 0.0 {0.0,0.0}",
		"corners": "3.0 3.0 3.0 3.0"
	},
};

var CheckBox = exports.CheckBox = AbstractView.subclass(
/** @lends UI.CheckBox.prototype */
{
	'type':'checkbox',

    /**
     * @class The <code>CheckBox</code> class constructs objects that handle the state of application checkboxes.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (CheckBox._init) CheckBox._init();
        this._checked = false;
        $super();
		this.setGradient(gradients['normal'], Commands.State.Normal);
		this.setGradient(gradients['pressed'], Commands.State.Pressed);
		this.setGradient(gradients['checked'], Commands.State.Checked);
		this.setGradient(gradients['checkedpressed'], Commands.State.Checked | Commands.State.Pressed);
		this.setGradient(gradients['disabled'], Commands.State.Disabled);
		this.setImageInsets([4,4,4,4]);
		this.setAttributes(properties);
    },
	
	/**
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
    performEventCallback: function($super, event) {
		if (event.eventType == 'click') {
        	this._checked = event.checked;
			if (this._checked) {
				this._state = this._state | Commands.State.Checked;
			} else {
				this._state = this._state & ~Commands.State.Checked;
			}
		}
		$super(event);
    }
});

CheckBox._init = function() {
	delete CheckBox._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.CheckBox#getImage
	 * @description Retrieve the <code>image</code> URL for a view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current image URL for the specified view state.
	 * @see UI.CheckBox#setImage
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImage
	 * @description Set an image URL for a view state. This defines how a checkbox appears for specific conditions. For example,
	 * set different images for a checkbox in the default state and when the checkbox is checked.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImage('./Content/checkbox.png', [w, h], [0, 0]);
	 * @see UI.CheckBox#getImage
	 * @param {String} imageURL The new image URL.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('image', Commands.setImage);
	/**
	 * @name UI.CheckBox#getImageInsets
	 * @description Retrieve the value of the <code>imageInsets</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>imageInsets</code>.
	 * @see UI.CheckBox#setImageInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setImageInsets
	 * @description Set the value of the <code>imageInsets</code> property. This property defines the viewable area of an image when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setImageInset([10,10,10,10]);
	 * @param {Number, Array (Number)} imageInsets The new value for <code>imageInsets</code>. Set as insets or an array of insets (expressed as floats).
	 * @see UI.CheckBox#getImageInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('imageInsets', Commands.setImageInsets);
	
	/**
	 * @name UI.CheckBox#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code> in the specified view state.
	 * @see UI.CheckBox#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use as a label for a 
	 * checkbox in the specified view state.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setText("Yes");
	 * @see UI.CheckBox#getText
	 * @param {String} text The new value for <code>text</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('text', Commands.setText);
	/**
	 * @name UI.CheckBox#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textColor</code> in the specified view state.
	 * @see UI.CheckBox#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string used as a label for a 
	 * checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextColor('FFFFFF');
	 * @see UI.CheckBox#getTextColor
	 * @param {String} textColor The new value for <code>textColor</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function 
	 */
	CheckBox.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.CheckBox#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code> in the specified view state.
	 * @see UI.CheckBox#setTextShadow	
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of shadowing used on text strings for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextShadow("FF00 2.0 {0,-1}");
	 * @see UI.CheckBox#getTextShadow
	 * @param {String} textShadow The new value for <code>textShadow</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	/**
	 * @name UI.CheckBox#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property (expressed as floats).
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.CheckBox#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property. This property defines how a text string is positioned within a viewable area.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as individual components or a single array of components (expressed as floats).
	 * @see UI.CheckBox#getTextGravity
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);

	/**
	 * @name UI.CheckBox#getTextSize
	 * @description Retrieve the value of the <code>textSize</code> property.
	 * @returns {Number} The current value for <code>textSize</code>.
	 * @see UI.CheckBox#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextSize
	 * @description Set the value of the <code>textSize</code> property. This property defines the text size of labels for a checkbox.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.CheckBox#getTextSize
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.CheckBox#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value for <code>textFont</code> in the specified view state.
	 * @see UI.CheckBox#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with labels for a checkbox in different view states.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code> in the specified view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.CheckBox#getTextFont
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizePropertyWithState('textFont', Commands.setTextFont);
	/**
	 * @name UI.CheckBox#getTextInsets
	 * @description Retrieve the value of the <code>textInsets</code> property.
	 * @returns {Array (Number)} The curent value for <code>textInsets</code>.
	 * @see UI.CheckBox#setTextInsets
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setTextInsets
	 * @description Set the value of the <code>textInsets</code> property. This property defines the viewable area of a text string when applying gravity.
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setTextInsets(0, 0, 0, 64);
	 * @param {Array (Number)} textInsets The new value for <code>textInsets</code>.
	 * @see UI.CheckBox#getTextInsets
	 * @status iOS, Android, Test
	 * @function
	 */
	CheckBox.synthesizeCompoundProperty('textInsets', Commands.setTextInsets);
	
	// Corresponding event is onClick
	/**
	 * @name UI.CheckBox#getChecked
	 * @description Retrieve whether this <code>CheckBox</code> is currently "checked".
	 * @returns {Boolean} Returns <code>true</code> if this <code>CheckBox</code> is currently "checked".
	 * @see UI.CheckBox#setChecked
	 * @status Javascript, iOS, Android, Flash
	 * @function
	 */
	/**
	 * @name UI.CheckBox#setChecked
	 * @description Set whether this <code>CheckBox</code> is "checked".
	 * @example var gameCheck = new UI.CheckBox();
	 * ...
	 * gameCheck.setChecked(true);
	 * @param {Boolean} checked Set as <code>true</code> if this <code>CheckBox</code> is "checked".
	 * @see UI.CheckBox#getChecked
	 * @status iOS, Android
	 * @function 
	 */
	CheckBox.synthesizeProperty('checked', Commands.setChecked);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
		'checked': Commands.State.Checked,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			CheckBox.registerAccessors(thisStatePropName, getterFn, setterFn, 
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('text');
	bindStateProperties('textColor');
    bindStateProperties('textFont');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
	bindStateProperties('image');
    bindStateProperties('imageBorder');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditText'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditText'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditText'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditText = exports.EditText = AbstractView.subclass(
/** @lends UI.EditText.prototype */
{
	'type':'edittext',
	/**
	* @class The <code>EditText</code> class is a base class for derived classes that handle text-editing functions.
	* Derived classes from <code>EditText</code> include:
	* <div class="ul">
	 * <li>{@link UI.DateField}</li>
	 * </div>
	* @name UI.EditText
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditText._init) EditText._init();
		$super(properties);
	},
	
	
	'InputTypes': Commands.InputType,
	'EnterKeyTypes': Commands.EnterKeyType,
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					// Fallthrough
				default: $super(event);
			}
		} catch(e) {
			NgLogException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditText#setText
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property. This property defines a text string to use in arbitrary fashion.
	 * @example var someText = new UI.EditText();
	 * ...
	 * someText.setText("Pow!");
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditText#getText
	 * @status Javascript, iOS, Android, Test
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	}
});

EditText._init = function() {
	delete EditText._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditText.registerAccessors('text', EditText.prototype.getText, EditText.prototype.setText);
	
	/**
	 * @name UI.EditText#getPlaceholder
	 * @description Retrieve the value of the <code>placeholderText</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.
	 * @see UI.EditText#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholder
	 * @description Set the value of the <code>placeholderText</code> property. This property defines a text string to use as a placeholder for fields that require text input.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholder("This is a placeholder");
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditText#getPlaceholder
	 * @function
	 */
	EditText.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditText#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholderTestColor</code> property. 
	 * @see UI.EditText#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditText#setPlaceholderColor
	 * @description Set the value of the <code>placeholderTestColor</code> property. This property defines the color of the placeholder text string.
	 * @returns {String} The current value of <code>placeholderTextColor</code>.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderColor('FFFFFF');
	 * @param {String} placeholderColor The new value for <code>placeholderTestColor</code>.
	 * @see UI.EditText#getPlaceholderColor
	 * @function
	 */
	EditText.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditText#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholderTestShadow</code> property.
	 * @returns {String} The current value of <code>placeholderTestShadow</code>.
	 * @see UI.EditText#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setPlaceholderShadow
	 * @description Set the value of the <code>placeholderTestShadow</code> property.  This property defines the amount of shawdow applied to the placeholder text string.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setPlaceholderShadow("FF00 2.0 {0,-1}");
	 * @param {String} placeholderShadow The new value for <code>placeholderTestShadow</code>.
	 * @see UI.EditText#getPlaceholderShadow
	 * @function
	 */
	 EditText.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	// ==== Behavior
	/**
	 * @name UI.EditText#getInputType
	 * @description Retrieve the value of the <code>inputType</code> property.
	 * @returns {Number} The current value of <code>inputType</code>.
	 * @see UI.EditText#setInputType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setInputType
	 * @description Set the value of the <code>inputType</code> property.
	 * @param {Number} inputType The new value for <code>inputType</code>.
	 * @see UI.EditText#getInputType
	 * @function
	 */	
	 EditText.synthesizeProperty('inputType', Commands.setInputType);
	/**
	 * @name UI.EditText#getEnterKeyType
	 * @description Retrieve the value of the <code>enterKeyType</code> property.
	 * @returns {Number} The current value of <code>enterKeyType</code>.
	 * @see UI.EditText#setEnterKeyType
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setEnterKeyType
	 * @description Set the value of the <code>enterKeyType</code> property.
	 * @param {Number} enterKeyType The new value for <code>enterKeyType</code>.
	 * @see UI.EditText#getEnterKeyType
	 * @function
	 */
	EditText.synthesizeProperty('enterKeyType', Commands.setEnterKeyType);
	
	// ==== Appearance
	/**
	 * @name UI.EditText#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.
	 * @see UI.EditText#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state. This property defines the color of a text string in the specified view state.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextColor('FFFFFF');
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditText#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.
	 * @see UI.EditText#setTextShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state. This property defines the amount of text shadowing used on text strings in this view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextShadow("FF00 2.0 {0,-1}");
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditText#getTextShadow
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditText#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditText</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.
	 * @see UI.EditText#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditText</code>. This property defines how a text string is positioned within a viewable area.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextGravity([0.1, 0.5]);
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditText#getTextGravity
	 * @function
	 */
	EditText.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditText#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditText</code>.
	 * @returns {Number} The current value of <code>textSize</code>.
	 * @see UI.EditText#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditText</code>. This property defines the size of text strings for a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextSize(18);
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditText#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditText#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditText</code>.
	 * @returns {String} The current value of <code>textFont</code>.
	 * @see UI.EditText#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditText#setTextFont
	 * @description Set the value of the <code>textFont</code> property. This property defines the font face used with text strings in a view.
	 * @example var placeHolder = new UI.EditText();
	 * ...
	 * placeHolder.setTextFont(myFont);
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditText#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditText.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditText#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditText#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditText#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditText.registerEventType('change');
	/**
	 * @name UI.EditText#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditText#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditText#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditText#event:getOnFocus
	 * @event
	 */
	EditText.registerEventType('focus');
	/**
	 * @name UI.EditText#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditText#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @note WARNING! This event is not guaranteed to occur on Android devices. Developers must not rely on this event occurring.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditText#event:getOnBlur
	 * @event
	 */
	EditText.registerEventType('blur');

	/**
	 * @name UI.EditText#getOnAction
	 * @description Retrieve the function to call when the <code>action</code> event occurs.
	 * @returns {Function} The current <code>action</code> callback function.
	 * @see UI.EditText#event:setOnAction
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditText#setOnAction
	 * @description Set a function to call when a keyboard key corresponding to executing an action is pressed.
	 * Available since 1.1.6
	 * @note WARNING! Soft keyboards on Android devices are not required to offer actions. Developers must not rely on this event occurring.
	 * @param {Function} actionCallback The new <code>action</code> callback function.<br><br><b>Note:</b> The <code>action</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditText#event:getOnAction
	 * @event
	 */
	EditText.registerEventType('action');

	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditText.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/EditTextArea'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/EditTextArea'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var EditTextArea = exports.EditTextArea = AbstractView.subclass(
/** @lends UI.EditTextArea.prototype */
{
	'type':'edittextarea',
	/**
	* @class The <code>EditTextArea</code> class is multiline text-editing area.
	* @name UI.EditTextArea
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (EditTextArea._init) EditTextArea._init();
		$super(properties);
	},
	
	
	performEventCallback: function($super, event) {
		try {
			switch (event.eventType) {
				case 'change':
					this._text = event.text;
					$super(event);
					break;
				case 'focus':
				case 'blur':
					$super(event);
					break;
			}
		} catch(e) {
			NgLogException(e);
		}
	},
	
	// Adapt API to the single-state model for "text" on editable text.
	/**
	 * Retrieve the value of the <code>text</code> property.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.EditTextArea#setText
	 * @status Javascript, iOS
	 * @function
	 */	
	getText: function() {
		return this._text || "";
	},
	
	/**
	 * Set the value of the <code>text</code> property.
	 * @param {String} text The new value for <code>text</code>.
	 * @see UI.EditTextArea#getText
	 * @status Javascript, iOS
	 * @function
	 */
	setText: function(text) {
		this._text = text;
		Commands.setText.call(this, 0, text);
	}
});

EditTextArea._init = function() {
	delete EditTextArea._init;
	if (AbstractView._init) AbstractView._init();
	
	// ==== Content
	// API defines state for the text property, but we ONLY support one state for this control.
	
	EditTextArea.registerAccessors('text', EditTextArea.prototype.getText, EditTextArea.prototype.setText);
	
	/**
	 * @name UI.EditTextArea#getPlaceholder
	 * @description Retrieve the value of the <code>placeholder</code> property.
	 * @returns {String} The current value of <code>placeholder</code>.<br>
	 * @see UI.EditTextArea#setPlaceholder
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholder
	 * @description Set the value of the <code>placeholder</code> property.
	 * @param {String} placeholder The new value for <code>placeholder</code>.
	 * @see UI.EditTextArea#getPlaceholder
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholder', Commands.setPlaceholderText);
	/**
	 * @name UI.EditTextArea#getPlaceholderColor
	 * @description Retrieve the value of the <code>placeholder color</code> property.
	 * @returns {String} The current value of <code>placeholder color</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */	
	/**
	 * @name UI.EditTextArea#setPlaceholderColor
	 * @description Set the value of the <code>placeholder color</code> property.
	 * @param {String} placeholderColor The new value for <code>placeholder color</code>.
	 * @see UI.EditTextArea#getPlaceholderColor
	 * @function
	 */
	EditTextArea.synthesizeProperty('placeholderColor', Commands.setPlaceholderTextColor);
	/**
	 * @name UI.EditTextArea#getPlaceholderShadow
	 * @description Retrieve the value of the <code>placeholder shadow</code> property.
	 * @returns {String} The current value of <code>placeholder shadow</code>.<br>
	 * @see UI.EditTextArea#setPlaceholderShadow
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setPlaceholderShadow
	 * @description Set the value of the <code>placeholder shadow</code> property.
	 * @param {String} placeholderShadow The new value for <code>placeholder shadow</code>.
	 * @see UI.EditTextArea#getPlaceholderShadow
	 * @function
	 */
	 EditTextArea.synthesizeProperty('placeholderShadow', Commands.setPlaceholderTextShadow);
	
	
	// ==== Appearance
	/**
	 * @name UI.EditTextArea#getTextColor
	 * @description Retrieve the value of the <code>textColor</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} textColor The current value of <code>textColor</code>.<br>
	 * @see UI.EditTextArea#setTextColor
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextColor
	 * @description Set the value of the <code>textColor</code> property for a view state.
	 * @param {String} textColor The new value for <code>textColor</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextColor
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textColor', Commands.setTextColor);
	/**
	 * @name UI.EditTextArea#getTextShadow
	 * @description Retrieve the value of the <code>textShadow</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>textShadow</code>.<br>
	 * @see UI.EditTextArea#setTextShadow
	 * @private not working on iOS
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextShadow
	 * @description Set the value of the <code>textShadow</code> property for a view state.
	 * @param {String} textShadow The new value for <code>textShadow</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.EditTextArea#getTextShadow
	 * @private not working on iOS
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textShadow', Commands.setTextShadow);
	
	/**
	 * @name UI.EditTextArea#getTextGravity
	 * @description Retrieve the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @returns {Number, Array (Number)} The current value of <code>textGravity</code>.<br>
	 * @see UI.EditTextArea#setTextGravity
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextGravity
	 * @description Set the value of the <code>textGravity</code> property for this <code>EditTextArea</code>.
	 * @param {Number, Array (Number)} textGravity The new value for <code>textGravity</code>. Set as a float or an array.
	 * @see UI.EditTextArea#getTextGravity
	 * @function
	 */
	EditTextArea.synthesizeCompoundProperty('textGravity', Commands.setTextGravity);
	/**
	 * @name UI.EditTextArea#getTextSize
	 * @description Retrieve the value of the <code>teztSize</code> property for this <code>EditTextArea</code>.
	 * @returns {Number} The current value of <code>textSize</code>.<br>
	 * @see UI.EditTextArea#setTextSize
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextSize
	 * @description Set the value of the <code>textSize</code> property for this <code>EditTextArea</code>.
	 * @param {Number} textSize The new value for <code>textSize</code>.
	 * @see UI.EditTextArea#getTextSize
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizeProperty('textSize', Commands.setTextSize);
	/**
	 * @name UI.EditTextArea#getTextFont
	 * @description Retrieve the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @returns {String} The current value of <code>textFont</code>.<br>
	 * @see UI.EditTextArea#setTextFont
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.EditTextArea#setTextFont
	 * @description Set the value of the <code>textFont</code> property for this <code>EditTextArea</code>.
	 * @param {String} textFont The new value for <code>textFont</code>.
	 * @see UI.EditTextArea#getTextFont
	 * @status iOS, Test
	 * @function
	 */
	EditTextArea.synthesizePropertyWithState('textFont', Commands.setTextFont);
	
	// ==== Events
	/**
	 * @name UI.EditTextArea#getOnChange
	 * @description Retrieve the function to call when the <code>change</code> event occurs.
	 * @returns {Function} The current <code>change</code> callback function.
	 * @see UI.EditTextArea#event:setOnChange
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnChange
	 * @description Set a function to call when the <code>change</code> event occurs.
	 * @param {Function} changeCallback The new <code>change</code> callback function. <br><br><b>Note:</b> The <code>change</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnChange
	 * @status iOS
	 * @event
	 */
	EditTextArea.registerEventType('change');
	/**
	 * @name UI.EditTextArea#getOnFocus 
	 * @description Retrieve the function to call when the <code>focus</code> event occurs.
	 * @returns {Function} The current <code>focus</code> callback function.
	 * @see UI.EditTextArea#event:setOnFocus
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event	 
	 */
	/**
	 * @name UI.EditTextArea#setOnFocus
	 * @description Set a function to call when the <code>focus</code> event occurs.
	 * @param {Function} focusCallback The new <code>focus</code> callback function. <br><br><b>Note:</b> The <code>focus</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnFocus
	 * @event
	 */
	EditTextArea.registerEventType('focus');
	/**
	 * @name UI.EditTextArea#getOnBlur
	 * @description Retrieve the function to call when the <code>blur</code> event occurs.
	 * @returns {Function} The current <code>blur</code> callback function.
	 * @see UI.EditTextArea#event:setOnBlur
	 * @status Javascript, iOS, Android, Flash, Test
	 * @event
	 */
	/**
	 * @name UI.EditTextArea#setOnBlur
	 * @description Set a function to call when the <code>blur</code> event occurs.
	 * @param {Function} blurCallback The new <code>blur</code> callback function.<br><br><b>Note:</b> The <code>blur</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.EditTextArea#event:getOnBlur
	 * @event
	 */
	EditTextArea.registerEventType('blur');
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'normal': Commands.State.Normal,
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled
	};
	
	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			};
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			};
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			EditTextArea.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		};
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};
	
	bindStateProperties('textColor');
	bindStateProperties('textShadow');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DateField'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DateField'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DateField'] = exports; var EditText = require('NGCore/Client/UI/EditText').EditText;

function isValidDate(d) {
	if ( !d.getTime )
		return false; 
		
	return !isNaN(d.getTime());
}

/*
 Date Parser code to handle WebKit's lack of following the implementation.
 http://stackoverflow.com/questions/3085937/safari-js-cannot-parse-yyyy-mm-dd-date-format/3085993#3085993
 */
function parseDate(input, format) {
  format = format || 'yyyy-mm-dd'; // default format
  var parts = input.match(/(\d+)/g), 
      i = 0, fmt = {};
  // extract date-part indexes from the format
  format.replace(/(yyyy|dd|mm)/g, function(part) { fmt[part] = i++; });

  return new Date(parts[fmt['yyyy']], parts[fmt['mm']]-1, parts[fmt['dd']]);
}
/*
 * Our Code is not actually passing its format to parseDate (already had all the code to rejigger the date pieces to yyyy-mm-dd before I realized the problems with webkit's date constructor / date string parser). -fbartho 2010-11-30
 */

exports.DateField = EditText.subclass(
/** @lends UI.DateField.prototype */
{
	/**
	 * @class The <code>DateField</code> class constructs objects that handle data returned by date functions.
	 * @constructs The default constructor. 
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.EditText
	 */
	initialize: function($super, properties) {
		var constructorRVal = $super(properties);
		this.setDateFormat("yyyy-mm-dd");
		this.ondatechange = function(newDate){};
		
		this.setInputType(EditText.InputTypes.Date);
		return constructorRVal;
	},
    
	/**
	 * Trigger an event callback for this <code>DateField</code>.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {String} event The event that triggers a callback function.
	 * @private
	 * @status Javascript, iOS, Android, Flash
	 */
	performEventCallback: function($super, event) {
		try {
			if (event.eventType == 'change') {
				// Make Sure the Text is changed (call $super), before we call our listeners!
				var oldText = this.getText();
				$super(event);
				this.ondatechange(this.getDate());
			}
		} catch(e) {
			NgLogException(e);
		}
	},
	_filterAndInsertDashes:function(oldText,newText) {
		var t = newText;
		if((oldText.length == t.length + 1) && oldText[oldText.length-1] == "-") {
			//This lets the user backspace through - marks as if they weren't there.
			// fbartho: Currently not in use! 2010-12-10
			//this.setText(t.substring(0,t.length-1));
			return t.substring(0,t.length-1);
		}
		
		var nt = "";
		var j = 0;
		for(var i = 0; i < t.length && nt.length < this.formatStr.length; i++,j++) {
			if(j < this.formatStr.length && this.formatStr[j] == "-" && i < t.length){
				if(t[i] == "-"|| t[i] == "/"){
					nt+="-";
					continue;
				}
				else {
					nt+="-";
					nt+=t[i];
					continue;
				}
			}
			if ( i < t.length && (t[i] == "-" || t[i] == "/") ) {
				--j; 
				continue;
			}
			nt+=t[i];
		}
		
		if(this.formatStr.length > j && (this.formatStr[j] == "-" || this.formatStr[j] == "/") ) {
			nt+="-";
		}
		
		return nt;
	},
	/**
	 * Format a date parsed from this <code>DateField</code> into a human-readable string.
	 * @status Javascript, iOS, Android, Flash, Test
	 */    
	normalizeDateLayout:function() {
		var ot = this.getText();
		var nt = this._filterAndInsertDashes(this.getText(),this.getText());
		if(ot!=nt)this.setText(nt);
	},
	/**
	 * Retrieve the date format of date strings parsed from this <code>DateField</code>
	 * @returns {String} The current date format.
	 * @see UI.DateField#setDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDateFormat:function() {
		return this.formatStr;
	},
	/**
	 * Set the date format for date strings parsed from this <code>DateField</code>.
	 * @param {String} dateFormat The new date format.
	 * @see UI.DateField#getDateFormat
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	setDateFormat:function(fStr) 
	{
		if (   fStr != "yyyy-mm-dd"
			&& fStr != "mm-yyyy"
			&& fStr != "yyyy-mm"
			&& fStr != "mm-dd-yyyy"
			&& fStr != "dd-mm-yyyy" ) {
			// Invalid Format String Error Case
			NgLogD("Error: Invalid Format String set for Birthdate Field!!\n");
			
			return;
		}
		
		this.formatStr = fStr;
		this.setPlaceholder(this.formatStr);
		return;
	},
	/**
	 * Retrieve a date string parsed from this <code>DateField</code>.
	 * @returns {String} The current date.
	 * @status Javascript, iOS, Android, Flash, Test
	 */
	getDate:function() {
		return this._dateFromText(this._filterAndInsertDashes(this.getText(),this.getText()));
	}, 
	_dateFromText:function(text) 
	{
		var tmp = null;
		var t = text;
		var bits = null;
		var b2 = null;
		if ( this.formatStr == "dd-mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push(bits.pop());
			tmp = parseDate(b2.join("-"));
		} else if ( this.formatStr == "mm-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[1].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.pop());
			b2.push("01");
			var tStr = b2.join("-");
			
			tmp = parseDate(tStr);
		} else if ( this.formatStr == "yyyy-mm" ) {
			bits = t.split("-");
			if(bits.length != 2 || bits[0].length != 4)
				return null;
			
			tmp = parseDate(t+"-01");
		} else if ( this.formatStr == "mm-dd-yyyy" ) {
			bits = t.split("-");
			if(bits.length != 3 || bits[2].length != 4)
				return null;
			
			b2 = [];
			b2.push(bits.pop());
			b2.push(bits.shift());
			b2.push(bits.shift());
			tmp = parseDate(b2.join("-"));
		} else {
			tmp = parseDate(t);
		}
		
		if(!isValidDate(tmp)) {
			NgLogD("Failed to parse date: "+tmp+"   -  "+tmp.toString()+"\n");
			return null;
		}
		return tmp;
	}
});

//TODO: make a proper DatePicker?
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AlertDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AlertDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var AlertDialog = exports.AlertDialog = Element.subclass(
/** @lends UI.AlertDialog.prototype */
{
	'type':'alertdialog',
	/**
	 * @name UI.AlertDialog
	 * @class The <code>AlertDialog</code> class constructs objects that handle alert dialogs in an application.
	 * @augments UI.Element
	 */
	initialize: function($super, properties) {
		if (AlertDialog._init) AlertDialog._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
	 */
	show: Commands.show,
	/** 
	 * Hide this dialog.
	 * @function
	 */
	hide: Commands.hide
});

// Properties
AlertDialog._init = function() {
	delete AlertDialog._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.AlertDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a view state. This property defines the title string for an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * alertDialog.setTitle("Exiting Game..");
	 * @see UI.AlertDialog#getTitle
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a view state.
	 * @see UI.AlertDialog#setTitle
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.AlertDialog#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string that is on display within an alert dialog window.
	 * @example var alertDialog = new UI.AlertDialog();
	 * ...
	 * alertDialog.setText("Returning to launcher..");
	 * @see UI.AlertDialog#getText
	 * @param {String} text The new value for <code>text</code>
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @see UI.AlertDialog#setText
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizePropertyWithState('text', Commands.setText);
	// Not a compound property; AlertDialog.getChoices() should return the array of strings.
	/**
	 * @name UI.AlertDialog#setChoices
	 * @description Set the value of the <code>choices</code> property. This property defines any available interface options for the user.
	 * @example var errorAlert = new UI.AlertDialog();
	 * ...
	 * errorAlert.setChoices(["Yes", "No"]);
	 * @see UI.AlertDialog#getChoices
	 * @param {String} choices The new value for <code>choices</code>.
	 * @param {Number} defaultChoice The index of the default choice.
	 * @param {Number} cancelChoice The index of the <code>cancel</code> choice.
 	 * @status iOS, Android
	 * @function
	 */
	/**
	 * @name UI.AlertDialog#getChoices
	 * @description Retrieve the value of the <code>choices</code> property.
	 * @see UI.AlertDialog#setChoices
	 * @returns {Array (String)} The current value of <code>choices</code>.
	 * @function
 	 * @status Javascript, iOS, Android, Flash, Test
	 */
	AlertDialog.synthesizeProperty('choices', Commands.setChoices);
	
	// Event will contain .choice, which is the index of the option chosen.
	/**
	 * @name UI.AlertDialog#setOnChoice
	 * @description Set a function to call on <code>choice</code> events.	 
	 * @param {Function} choiceCallback The new function to call. <br><br>
	 * <b>Note:</b> The <code>choice</code> event is disabled if the value for this parameter is not a function.
	 * @see UI.AlertDialog#event:getOnChoice
 	 * @status iOS, Android, Test
	 * @event
	 */
	/**
	 * @name UI.AlertDialog#getOnChoice
	 * @description Retrieve the function to call on <code>choice</code> events.
	 * @see UI.AlertDialog#event:setOnChoice
	 * @returns {Function} The current function to call.
	 * @event
	 * @type {Function}
 	 * @status iOS, Android, Test
	 */
	 AlertDialog.registerEventType('choice');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressDialog'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressDialog'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var ProgressDialog = exports.ProgressDialog = Element.subclass(
/** @lends UI.ProgressDialog.prototype */
{
	'type':'progressdialog',

    /**
     * @class The <code>ProgressDialog</code> class constructs objects that handle progress updates from the application.
     * @constructs The default constructor. 
     * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
     * @param {String} properties Object properties.
     * @augments UI.Element
     */
    initialize: function($super, properties) {
		if (ProgressDialog._init) ProgressDialog._init();
        return $super(properties);
    },
	/**
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    show: Commands.show,
	/**
	 * Hide this dialog.
	 * @function
     * @status iOS, Android, Test
	 */    
    hide: Commands.hide
});

ProgressDialog._init = function() {
	delete ProgressDialog._init;
	if (Element._init) Element._init();
	
	/**
	 * @name UI.ProgressDialog#setTitle
	 * @description Set the value of the <code>title</code> property for a <code>ProgressDialog</code>. This property defines the title string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setTitle("Downloading game components...");
	 * @param {String} title The new value for <code>title</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getTitle
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getTitle
	 * @description Retrieve the value of the <code>title</code> property for a <code>ProgressDialog</code> in the specified view state. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>title</code>.
	 * @see UI.ProgressDialog#setTitle
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('title', Commands.setTitle);
	/**
	 * @name UI.ProgressDialog#setText
	 * @description Set the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state. This property defines a text string for a progress dialog in the specified view state.
	 * @example var progDialog = new UI.ProgressDialog();
	 * progDialog.setText("Please wait...");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.ProgressDialog#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.ProgressDialog#getText
	 * @description Retrieve the value of the <code>text</code> property for a <code>ProgressDialog</code> in the specified view state.	 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.ProgressDialog#setText
	 * @function
     * @status iOS, Android, Test
	 */
	ProgressDialog.synthesizePropertyWithState('text', Commands.setText);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Toast'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Toast'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Toast'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Toast = exports.Toast = Element.subclass(
/** @lends UI.Toast.prototype */
{	
    'type': 'toast',
    /**
    * @class The <code>Toast</code> class constructs objects that render temporary messages on the device screen.
    * @name UI.Toast
    * @augments UI.View
    */
	initialize: function($super, properties) {
		if (Toast._init) Toast._init();
		$super(properties);
	},
	
	/** 
	 * Show this dialog.
	 * @function
     * @status iOS, Android, Test
	 */
    show: Commands.show
});

Toast._init = function() {
	delete Toast._init;
	if (Element._init) Element._init();

	/**
	 * @name UI.Toast#setText
	 * @description Set the value of the <code>text</code> property for a view state. This property defines a text string to use in the specified view state.
	 * @example var tempMessage = new UI.Toast();
	 * tempMessage.setText("Game Over");
	 * @param {String} text The new value for <code>text</code>.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.Toast#getText
	 * @function
     * @status iOS, Android, Test
	 */
	/**
	 * @name UI.Toast#getText
	 * @description Retrieve the value of the <code>text</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {String} The current value of <code>text</code>.
	 * @see UI.Toast#setText
	 * @function	 
     * @status iOS, Android, Test
	 */
	Toast.synthesizePropertyWithState('text', Commands.setText);
	/** 
	* @name UI.Toast#setOnDisappear
	* @description Set a function to call when the <code>disappear</code> event occurs. The callback for the event returns 
	* <code>true</code> if the temporary message should disappear. Otherwise, the callback returns <code>false</code>.
	* @param {function} disappearCallback The new callback function.<br><br>
	* <b>Note:</b> The <code>disappear</code> event is disabled if the value of this parameter is not a function.
	* @see UI.Toast#event:getOnDisappear
	* @event
	*/
	/**
	* @name UI.Toast#getOnDisappear
	* @description Retrieve the function to call when the <code>disappear</code> event occurs.
	* @returns {function} The current callback function.
	* @see UI.Toast#event:setOnDisappear
	* @event
	*/
	Toast.registerEventType('disappear');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AdView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AdView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AdView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private */
var AdView = exports.AdView = AbstractView.subclass(
{
	'type':'adview',

	/**
	 * @class The <code>AdView</code> class constructs objects that handle event callback functions and ad event metadata.
	 * @constructs The default constructor. 
	 * @param $super This parameter is stripped out during execution. Do not supply it.
	 * @param {String} properties
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (AdView._init) AdView._init();
		$super(properties);
		
		this.onappear = this.bind(this._onappear);
		this.ondisappear = this.bind(this._ondisappear);
		this.onclick = this.bind(this._onclick);
	},
	
	/**
	 * An event for signaling when an <code>AdView</code> is on display.
	 * @event
	 */
	onappear: function() {
	 },
	
	/**
	 * An event for signaling when an <code>AdView</code> has been closed.
	 * @event
	 */
	ondisappear: function() { 
	},
	
	/** @protected */
	_onappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADSHOW",  this.getAdEventMetadata());
        visible = true;
	},
	
	/** @protected */
	_ondisappear: function($super, event) {
		( $super || function(){} )(event);
//		Core.Analytics._getPipe().revenueEvent("ADCLOSE", this.getAdEventMetadata());
        visible = false;
	},
	
	performEventCallback: function($super, event) {
		if (event.eventType == 'click')
		{
//			Core.Analytics._getPipe().revenueEvent("ADCLCK", this.getAdEventMetadata());
			NgLogD("AD WAS CLICKED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
		if (event.eventType == 'load')
		{
//			Core.Analytics._getPipe().revenueEvent("ADLOAD", this.getAdEventMetadata());
			NgLogD("AD WAS LOADED in AdView wooo!!!!");
			( $super || function(){} )(event);
		}
	},
	/**
	* Pause this <code>AdView</code>.<br><br>
	* <b>Note:</b> If an <code>AdView</code> is already paused, this call does nothing.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	pauseAds: function() {
		Commands.pauseAds.call(this);
	},
	/**
	* Resume this <code>AdView</code> from a paused state. Setting this will resume the <code>AdView</code> from the current position.
	* @see UI.AdView#resumeAds
	* @status Android
	*/
	resumeAds: function() {
		Commands.resumeAds.call(this);
	},
	/**
	* Set the refresh rate for this <code>AdView</code>. 
	* @param {Number} refreshRate The amount of time each ad is on display (in milliseconds).
	* @status Android
	*/
	setRefreshRate: function(refreshRate) {
		Commands.setAdRefreshRate.call(this, refreshRate);
	},
	/**
	* Set this <code>AdView</code> to automatically play.
	* @status Android
	* @param {Boolean} autoplay Set as <code>true</code> if autoplay is enabled.
	*/
	setAutoplay: function(autoplay) {
		Commands.setAdRefreshRate.call(this, autoplay);
	},
	
	/**
	 * Retrieve event metadata from this <code>AdView</code>. 
	 */
	getAdEventMetadata: function(){
		NgLogD("AD EventMetetData was requested!");
		var AdMeteData = "DefaultAdEventMetaData";
		return AdMeteData;
	}
});

// Event Handlers
AdView._init = function() {
	delete AdView._init;
	if (AbstractView._init) AbstractView._init();

    /**
	 * @name UI.AdView#getActive
	 * @description Retrieve the value of the <code>active</code> property.
	 * @returns {Boolean} Returns <code>true</code> if the <code>AdView</code> object is set to active.
	 * @see UI.AdView#setActive
	 * @status iOS, Android, Flash, Test
	 * @function
	 */
	AdView.synthesizeProperty('active', Commands.setActive);
    
	/**
	 * @name UI.AdView#setOnClick
	 * @description Set a function to call on <code>click</code> events.	 
	 * @param {Function} clickCallback The new <code>click</code> callback function. <br><br>
	 * <b>Note:</b> The <code>click</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:setOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnClick
	 * @description Retrieve the function to call on <code>click</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>click</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('click');
	/**
	 * @name UI.AdView#setOnLoad
	 * @description Set a function to call on <code>load</code> events.	 
	 * @param {Function} loadCallback The new <code>load</code> callback function. <br><br>
	 * <b>Note:</b> The <code>load</code> event is disabled if the value for this parameter is not a function.<br>
	 * @see UI.AdView#event:getOnClick
 	 * @status Android, Test
	 * @event
	 */
	/**
	 * @name UI.AdView#getOnLoad
	 * @description Retrieve the function to call on <code>load</code> events.<br>
	 * @see UI.AdView#event:getOnClick
	 * @returns {Function} The current <code>load</code> callback function.<br>
 	 * @status Android, Test
	 * @event
	 */
	AdView.registerEventType('load');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/DocumentView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/DocumentView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var DocumentView = exports.DocumentView = AbstractView.subclass(
/** @lends UI.DocumentView.prototype */
{
	'type':'documentview',
	/**
	 * @name UI.DocumentView
	 * @class The <code>DocumentView</code> class constructs objects that handle document locations.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (DocumentView._init) DocumentView._init();
		$super(properties);
	}
});

// Properties
DocumentView._init = function() {
	delete DocumentView._init;
	if (AbstractView._init) AbstractView._init();
	
	/**
	 * @name UI.DocumentView#setDocumentURL
	 * @description Set the document URL for this <code>DocumentView</code>.
	 * @param {String} documentURL The new document URL.
	 * @see UI.DocumentView#getDocumentURL
	 * @status Javascript, iOS, Android, Flash, Test
	 * @function
	 */
	/**
	 * @name UI.DocumentView#getDocumentURL
	 * @description Retrieve the document URL of this <code>DocumentView</code>.
	 * @returns {String} The current document URL.
	 * @see UI.DocumentView#setDocumentURL
	 * @status iOS, Android, Test
	 * @function
	 */
	DocumentView.synthesizeProperty('documentURL', Commands.setSourceDocument);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/CheckoutView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/CheckoutView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var ViewGeometry = require('NGCore/Client/UI/ViewGeometry');
var Commands = require('NGCore/Client/UI/Commands').Commands;

var CheckoutView = exports.CheckoutView = AbstractView.subclass(
/** @lends UI.CheckoutView.prototype */
{
	'type':'checkoutview',
	/**
	 * @name UI.CheckoutView
	 * @class The <code>CheckoutView</code> class constructs objects that handle and manage information associated with <code>POST</code> methods in an application.
	 * @augments UI.AbstractView
	 */
	initialize: function($super, properties) {
		if (CheckoutView._init) CheckoutView._init();
		$super(properties);
	}
});

// Properties
CheckoutView._init = function() {
	delete CheckoutView._init;
	if (AbstractView._init) AbstractView._init();
	
	// THESE ARE METHODS NOT PROPERTIES... THIS SHOULD BE FIXED.
	// We define ONLY setters, and no getters (write-only props, no local copies)
	/**
	 * @name UI.CheckoutView#setPostData
	 * @description Set the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postData The new value for <code>postData</code>.
	 * @see UI.CheckoutView#getPostData
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostData
	 * @description Retrieve the value returned by the <code>postData()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postData</code>.
	 * @see UI.CheckoutView#setPostData
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postData', null, Commands.setPostData);
	/**
	 * @name UI.CheckoutView#setPostURL
	 * @description Set the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} postURL The new value for <code>postURL</code>.
	 * @see UI.CheckoutView#getPostURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getPostURL
	 * @description Retrieve the value returned by the <code>postURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value of <code>postURL</code>.
	 * @see UI.CheckoutView#setPostURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('postURL', null, Commands.loadPostURL);
	/**
	 * @name UI.CheckoutView#setGetURL
	 * @description Set the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @param {String} getURL The new value for <code>getURL</code>.
	 * @see UI.CheckoutView#getGetURL
	 * @status Android
	 * @function
	 */
	/**
	 * @name UI.CheckoutView#getGetURL
	 * @description Retrieve the value returned by the <code>getURL()</code> method of this <code>CheckoutView</code>.
	 * @returns {String} The current value for <code>getURL</code>.
	 * @see UI.CheckoutView#setGetURL
	 * @status Android
	 * @function
	 */
	CheckoutView.registerAccessors('getURL', null, Commands.loadGetURL);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/Spinner'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/Spinner'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var Spinner = exports.Spinner = AbstractView.subclass(
/** @lends UI.Spinner.prototype */
{
	'type':'spinner',
	
	/**
	* @class The <code>Spinner</code> class constructs objects that handle menu spinners in a user interface. 
	* @name UI.Spinner
	* @augments UI.AbstractView
	*/
	initialize: function($super, properties) {
		if (Spinner._init) Spinner._init();
		return $super(properties);
	}
});

Spinner._init = function() {
	delete Spinner._init;
	if (AbstractView._init) AbstractView._init();
	
	Spinner.synthesizeProperty('darkStyle', Commands.setDarkStyle);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ProgressBar'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ProgressBar'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var WindowR = require('NGCore/Client/UI/Window');

var ProgressBar = exports.ProgressBar = AbstractView.subclass(
/** @lends UI.ProgressBar.prototype */
{
	'type':'progressbar',

    /**
     * @class <code>ProgressBar</code> constructs a horizontal bar that gives a finite indication of progress.
     * @constructs The default constructor. 
     * @param $super This parameter is stripped out during execution. Do not supply it.
     * @param {String} properties
     * @augments UI.AbstractView
     */
    initialize: function($super, properties) {
		if (ProgressBar._init) ProgressBar._init();
        return $super(properties);
    },

	useForUpdateProgress: Commands.useForUpdateProgress,
});

ProgressBar._init = function() {
	delete ProgressBar._init;
	if (AbstractView._init) AbstractView._init();

	/**
	 * @name UI.ProgressBar#getProgressGradient
	 * @description Retrieve the <code>progressGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current progressGradient for the specified view state.<br>
	 * @see UI.ProgressBar#setProgressGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgressGradient
	 * @description Set a progressGradient for a view state.
	 * @see UI.ProgressBar#getProgressGradient
	 * @param {Object} progressGradientURL The new progressGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('progressGradient', Commands.setProgressGradient);
	/**
	 * @name UI.SecondaryBar#getSecondaryGradient
	 * @description Retrieve the <code>secondaryGradient</code> for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current secondaryGradient for the specified view state.<br>
	 * @see UI.SecondaryBar#setSecondaryGradient
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.SecondaryBar#setSecondaryGradient
	 * @description Set a secondaryGradient for a view state.
	 * @see UI.SecondaryBar#getSecondaryGradient
	 * @param {Object} secondaryGradientURL The new secondaryGradient.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @status Android
	 * @function 
	 */
	ProgressBar.synthesizePropertyWithState('secondaryGradient', Commands.setSecondaryGradient);
	
	/**
	 * @name UI.ProgressBar#getProgress
	 * @description Retrieve the value of the <code>progress</code> properties.
	 * @returns {Array} The current values of <code>progress</code> and <code>secondaryProgress</code>.<br>
	 * @see UI.ProgressBar#setProgress
	 * @status Javascript, Android
	 * @function
	 */
	/**
	 * @name UI.ProgressBar#setProgress
	 * @description Set the values of the <code>progress</code> properties.
	 * @see UI.ProgressBar#getProgress
	 * @param {Number} progress The new value for <code>progress</code>, as a decimal Number between 0.0 and 1.0.
	 * @param {Number} secondaryProgress The new value for <code>secondaryProgress</code>, as a decimal Number between 0.0 and 1.0.
	 * @status Javascript, Android
	 * @function
	 */
	var setProgressGuarded = function(arg0) {
		var args = (arg0 instanceof Array) ? arg0 : Array.prototype.slice.call(arguments);
		while (args.length < 2) args.push(0);
		Commands.setProgress.apply(this, args);
	}
	ProgressBar.synthesizeCompoundProperty('progress', setProgressGuarded);
	
	// helpers for legacy support... Bind full properties to a single state of another.
	var states = {
		'focused': Commands.State.Focused,
		'pressed': Commands.State.Pressed,
		'selected': Commands.State.Focused,
		'highlighted': Commands.State.Pressed,
		'disabled': Commands.State.Disabled,
	};

	function bindStateProperties(propName) {
		var doSynthesis = function(propName, stateName, stateFlags) {
			var getterFn = function() {
				return this._getters[propName].call(this, stateFlags);
			}
			var setterFn = function(val) {
				return this._setters[propName].call(this, val, stateFlags);
			}
			var thisStatePropName = stateName + propName.charAt(0).toUpperCase() + propName.substr(1);
		//	NgLogD("Synthesizing Button." + thisStatePropName + " as getters[" + propName + "][" + stateFlags + "]");
			ProgressBar.registerAccessors(thisStatePropName, getterFn, setterFn,
				"Use " + propName + " accessors with a final state parameter instead.");
		}
		for (var stateName in states) {
			if (!states.hasOwnProperty(stateName)) continue;
			doSynthesis(propName, stateName, states[stateName]);
		}
	};

	bindStateProperties('progressGradient');
	bindStateProperties('secondaryGradient');
	bindStateProperties('gradient');
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapView'] = exports; var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var MapAnnotation = require('NGCore/Client/UI/MapAnnotation').MapAnnotation;

var MapView = exports.MapView = AbstractView.subclass(
/** @lends UI.MapView.prototype */
{
	'type':'mapview',
	/**
	* @class <code>MapView</code>
	* @name UI.MapView
	* @augments UI.View
	*/
	initialize: function($super, properties) {
		this._annotations = [];
		this._region = [];
		return $super(properties);
	},
	
	getCenterCoordinate: function()
	{
		return [this._region[0], this._region[1]];
	},
    
    setCenterCoordinate: function(lat, lon, animated)
    {
        this._region[0] = lat;
        this._region[1] = lon;
        if (!this._region[2])
            this._region[2] = 0.05;
        if (!this._region[3])
            this._region[3] = 0.05;            
        this.setRegion(this._region[0], this._region[1], this._region[2], this._region[3], animated);
    },
	
	getCoordinateSpan: function()
	{
		return [this._region[2], this._region[3]];
	},	
	
	selectAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				Commands.selectAnnotation.call(this, annotation.__objectRegistryId);
				return;
			}
		}
		Commands.selectAnnotation.call(this, -1);
	},
	
	addAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			this._annotations.push(annotation);
			
			Commands.addAnnotation.call(this, annotation.__objectRegistryId);
			
		} else throw {message: this.type + ".addAnnotation: " + annotation + " is not a MapAnnotation!"};
		return this;
	},
	
	removeAnnotation: function(annotation)
	{
		if (annotation instanceof MapAnnotation) {
			// Remove this node from parent's child list
			var index = this._annotations.indexOf(annotation);
			if (index != -1) {
				this._annotations.splice(index, 1);
			}
			
			// Remove from the parent at the system level
			Commands.removeAnnotation.call(this, annotation.__objectRegistryId);
		} else throw {message: this.type + ".removeAnnotation: " + annotation + " is not a MapAnnotation!"};
		return annotation;
	},
	
	/**
	 * @private
	 */    
	updateRegionFits: function(lat, lon ,latD , lonD) {
		//console.log(lat + " " + lon + " " + latD + " " + lonD);
		//console.log(this._region[0] + " " + this._region[1] + " " + this._region[2] + " " + this._region[3]);
		this._region[0] = lat;
		this._region[1] = lon;
		this._region[2] = latD;
		this._region[3] = lonD;
	},
	
	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		if (e.eventType == 'regionchange') this.updateRegionFits(e.latitude, e.longitude , e.latitudeDelta , e.longitudeDelta);
		$super(e);
	}
});

// Properties
(function() {
	MapView.synthesizeProperty('scrollable', Commands.setScrollable);
	
	MapView.synthesizeProperty('zoomable', Commands.setZoomable);
	
	MapView.synthesizeCompoundProperty('region', Commands.setRegion);
	
	MapView.registerEventType('regionchange');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/MapAnnotation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/MapAnnotation'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;

var MapAnnotation = exports.MapAnnotation = Element.subclass(
/** @lends UI.MapAnnotation.prototype */
{
	'type':'mapannotation',
	/**
	* @class <code>MapAnnotation</code>
	* @name UI.MapAnnotation
	* @augments Core.Class
	*/
	initialize: function($super, properties) {
		return $super(properties);
	},

	setCalloutLeftView: function(view)
	{
		this._calloutLeftView = view;
		Commands.setCalloutLeftView.call(this, view.__objectRegistryId);
	},

	getCalloutLeftView: function()
	{
		return this._calloutLeftView;
	},

	setCalloutRightView: function(view)
	{
		this._calloutRightView = view;
		Commands.setCalloutRightView.call(this, view.__objectRegistryId);
	},

	getCalloutRightView: function()
	{
		return this._calloutRightView;
	},

	setView: function(view)
	{
		this._view = view;
		Commands.setView.call(this, view.__objectRegistryId);
	},

	getView: function()
	{
		return this._view;
	},

	setImage: function(image)
	{
		console.log("WARNING : MapAnnotation.setImage has been deprecated. Use MapAnnotation.setView instead.");
		var iV = new UI.Image();
		iV.setImage(image);
		iV.setFrame([0, 0, 40, 40]);
		this.setView(iV);
	},

	/**
	 * @private
	 */    
	performEventCallback: function($super, e) {
		$super(e);
	}
});

// Properties
(function() {

	MapAnnotation.synthesizeCompoundProperty('coordinate', Commands.setCoordinate);
	
	MapAnnotation.synthesizeCompoundProperty('centerOffset', Commands.setCenterOffset);
	
	MapAnnotation.synthesizeProperty('calloutTitle', Commands.setCalloutTitle);

	MapAnnotation.synthesizeProperty('calloutSubtitle', Commands.setCalloutSubtitle);
	
	MapAnnotation.synthesizeProperty('calloutEnabled', Commands.setCalloutEnabled);

	MapAnnotation.registerEventType('select');
	MapAnnotation.registerEventType('deselect');
})();
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Analytics'] = exports; var Class = require('NGCore/Client/Core/Class').Class,
NgPipe = require('NGCore/Shared/NgPipe').NgPipe,
NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;

var Analytics = Class.singleton(
/** @lends Core.Analytics.prototype */
{
    classname: 'Analytics',

    /**
     * @class The <code>Analytics</code> class serves as the custom messaging channel to the ngCore platform. 
     * The <code>Analytics</code> class provides developers with a way to keep track of game-specific items that require analysis and counting.
     * Use this class when you need your games to send custom elements that require in-game analytics support. 
     * @constructs The default constructor for setting up the NgPipe.
     * @augments Core.Class
     * @param {Boolean} [sendToRemote=true] Set <code>sendToRemote</code> to <code>true</code> to send analytics data to a remote server.
     * @param {String} [analyticsServer=ngmoco analytics server] A custom analytics server.
     * @private
     */
    initialize: function() {
        if (!this._pipe) {
          this._pipe = new NgPipe();
        }
    },

    /** @private */
    enable: function() {
        this._pipe.enable();
    },

    /** @private */
    disable: function() {
        this._pipe.disable();
    },

    /** @private */
    setUrl: function(url) {
        this._pipe.setRemoteUrl(url);
    },

    /**
    * Report a navigation event that occurs when users navigate between application pages. 
    * Calling this function will alert the analytics platform that a user has generated a navigation event.
    * This information is used to plot how users move through the game, how long they spend on a page, and what page they navigate to next.
    *
    * @param {String} from The name of the page from which navigation originates. 
    * @param {String} to An analytics name for the destination page.
    * @param {String} btnid The ID of the button that triggered the navigation.
    * @private
    */
    reportNavigation : function(from, to, btnid) {
        if (!(from && to)) {
            return false;
        }
        this._pipe.uiEvent('NAV', {to: to, fro: from, btnid: btnid} );
        return true;
    },
    /**
    * Report a custom game event. Use this when something in your game happens that you want to know about, 
    * but does not change the user's core stats.<br><br>
    * <b>Note:</b> This function serves as a catch-all. If you need your game to count or analyze something that does not fit into any 
    * other category, use this call.
    * 
    * @param {String} eventId The ID for the custom event.
    * @param {Object} payload A hash of extra information.
    * @param {Object} playerState A hash of important player states.
    * @private
    */
    reportGameEvent : function(eventId, payload, playerState ) {
        if (!eventId) {
            return false;
        }

        this._pipe.gameEvent(eventId, payload, playerState);

        return true;
    },
    /**
    * Report a change to a playerstate. A playerstate is the object representation of the player's core stats. 
    * For example, if a player purchased an in-game item, you would call this to let the analytics system know what happened and how much gold was spent.
    * Everything in the player state is counted and recorded. Make sure to only pass in things for which you want to see the change 
    * (gold, mojo, grow, level, xp, health, lives, and so on).
    * <b>Note:</b> This is only for game state and should not include information that is unique to a user. For example, the user game tag or the user ID.
    *
    * @param {String} action The product ID of a purchased product. This essentially points out when an action is performed.
    * @param {Object} change A hash of currencies spent and/or gained. For example {mojo: 100, gold:-10}
    * @param {Object} playerState A hash of important player states after the purchase.
    * @private
    */
    reportPlayerStateChange : function(action, change,  playerState) {
        if (action) {
            this._pipe.playerEvent(action, 'PLSTCHANGE', change, playerState);
            return true;
        } else {
            return false;
        }
    },

    /**
    * Report when a user reaches a new stage of a funnel. Funnel refers to a set of pages or requirements a user is required to engage in before proceeding. 
    * You can use this call to keep track of progress for all users. For example, keeping track of various stages users engage in for game registration.
    * Funnel stages are ordered by numeric ID. The funnel <code>stageName</code> is used for display. You do not need to define funnels ahead of time.
    * Funnel stages start at 0 and increase as the user proceeds further.<br><br>
    * <b>Note:</b> Calling <code>reportFunnelStage()</code> multiple times for a single user generates an incorrect count.
    *
    * @param {String} funnelName The name of the funnel that the user has progressed to.
    * @param {Number} funnelStage The integer value of the stage that the user reached.
    * @param {String} stageName The name of the stage that the user reached.
    * @param {Object} playerState A hash of important player states after a funnel stage.
    * @private
    */
    reportFunnelStage : function(funnelName, funnelStage, stageName, playerState) {
        var payload =  {};

        if (!(funnelName)) {
            return false;
        }
        if (funnelStage !== null && funnelStage !== undefined) {
            payload.stage = funnelStage;
        } else {
            return false;
        }

        if (stageName) {
            payload.stageName = stageName;
        }
        if (!playerState) {
            this._pipe.funnelEvent(funnelName, payload, playerState);
        }

        return true;
    },
    /**
     * Report an interaction between two users.
     *
     * @param {String} actionId The action that the user is performing to interact with the other user
     * @param {String} friendGamerTag The other user with whom the current user is interacting.
     * @param {Object} payload A hash of extra information
     */
    reportSocialEvent: function(actionId, friendGamerTag, payload) {
        if (actionId && actionId.length && friendGamerTag && friendGamerTag.length ) {
            this._pipe.socialEvent(actionId, friendGamerTag, payload);
            return true;
        }
        return false;
    },
    /**
    * Report an error to analytics.
    *
    * @param {String} error_msg The error message to log.
    * @private
    */
    reportError : function(error_msg) {
        if (!error_msg) {
            return false;
        }
        this._pipe.gameOpsEvent("ERR", {err: error_msg } );
        return true;
    },
    addTag: function(tag) {
        if (tag) {
            var evpl = {tag:tag};
            this._pipe.gameEvent('tag', evpl);
            return true;
        }
        return false;
    },
    /** @private */
    _getPipe: function() {
        return this._pipe;
    }
});
exports.Analytics = Analytics;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Color'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Color'] = exports; exports.Color = require('NGCore/Shared/Color').Color;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Vector'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Vector'] = exports; exports.Vector = require('NGCore/Shared/Vector').Vector;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Point'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Point'] = exports; exports.Point = require('NGCore/Shared/Point').Point;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Size'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Size'] = exports; exports.Size = require('NGCore/Shared/Size').Size;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Rect'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Rect'] = exports; exports.Rect = require('NGCore/Shared/Rect').Rect;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageEmitter'] = exports; exports.MessageEmitter = require('NGCore/Shared/MessageEmitter').MessageEmitter;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/MessageListener'] = exports; exports.MessageListener = require('NGCore/Shared/MessageListener').MessageListener;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/ObjectRegistry'] = exports; var Class = require('NGCore/Client/Core/Class').Class;

exports.ObjectRegistry = Class.singleton(
{
	classname: 'ObjectRegistry',
		
	/** @private @class @status */
	initialize: function()
	{
		this._currentId = 0;
		this._guardId = 0;
		this._objects = {};
	},
	
	/** @status */
	register: function(obj)
	{
		if(obj.__objectRegistryId)
			throw new Error('ObjectRegistry.register: object already registered');
			
		var id = ++this._currentId;
		obj.__objectRegistryId = id;
		this._objects[id] = obj;
	},
	
	/** @status */
	unregister: function(obj)
	{
		if(!obj.__objectRegistryId)
			throw new Error('ObjectRegistry.unregister: object not registered');
			
		var id = obj.__objectRegistryId;
		obj.__objectRegistryId = 0;
		delete this._objects[id];
	},
	
	/** @status */
	isObjectRegistered: function(obj)
	{
		if(obj.__objectRegistryId)
			return true;
		else
			return false;
	},
	
	/** @status */
	isIdRegistered: function(id)
	{
		if(this._objects[id])
			return true;
		else
			return false;
	},
	
	/** @status */
	objectToId: function(obj)
	{
		var id = obj.__objectRegistryId;
		
		if(!id)
			throw new Error('ObjectRegistry.objectToId: object not registered');
		
		return id;
	},
	
	/** @status */
	idToObject: function(id)
	{
		return this._objects[id];
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Time'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Time'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Time'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Time
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;

var Time = Class.singleton(
/** @lends Core.Time.prototype */
{
	classname: 'Time',
	mFrameTime: 0,
	mFrameDelta: 0,

	/**
	 * @class the <code>Time</code> class constructs objects that provide access to the system clock and system timings for a device.
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
	},

	/**
	 * Return the timestamp for the current time frame (expressed in milliseconds).
	 * @returns {Number} The timestamp for the current time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameTime: function()
	{
		return this.mFrameTime;
	},

	/**
	 * Return the delta time in milliseconds since the last time frame.
	 * @returns {Number} The delta time since the last time frame.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameDelta: function()
	{
		return this.mFrameDelta;
	},

	/**
	 * Return the real-time clock in milliseconds. 
	 * <b>Note:</b> This differs from the time frame timestamp, which is constant for the entire time frame.
	 * @returns {Number} The real-time clock.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRealTime: function()
	{
		return (new Date()).getTime();
	},

	$_frameTimeRecv: function( cmd )
	{
		var o = {};
		this._frameTimeRecvGen(cmd, o);

		this.mFrameDelta = this.mFrameTime ? o.time - this.mFrameTime : 1;
		this.mFrameTime = o.time;
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 351
	// Method frameTime = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift() );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				case -1:
					Time._frameTimeRecv( cmd );
					break;
				default:
					NgLogE("Unknown static method id " + cmdId + " in Time._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[351] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	$_frameTimeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Time.frameTime from command: " + cmd );
			return false;
		}
		
		obj[ "time" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "time" ] === undefined )
		{
			NgLogE("Could not parse time in Time.frameTime from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $_frameTimeRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});

exports.Time = Time;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/toMD5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/toMD5'] = exports; exports.toMD5 = require('NGCore/Shared/Lib/md5').toMD5;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/SHA1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/SHA1'] = exports; var sha1 = require('NGCore/Shared/Lib/sha1');

exports.SHA1 = {
	b64_hmac_sha1: sha1.b64_hmac_sha1,
	hex_sha1: sha1.hex_sha1,
	b64_sha1: sha1.b64_sha1
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/UpdateEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Time = require('NGCore/Client/Core/Time').Time;

exports.UpdateEmitter = MessageEmitter.singleton(
/** @lends Core.UpdateEmitter.prototype */
{
	classname: 'UpdateEmitter',
		
	/**
	 * @class The <code>UpdateEmitter</code> module constructs a singleton object that emits every frame with the delta in milliseconds since the last frame.<br><br>
	 * <b>Note:</b> <code>{@link Core.UpdateEmitter#setTickRate}</code> is also used to define the framerate of any animation reproduced by a sprite 
	 * (see <code>{@link GL2.Sprite#setAnimation}</code>).
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this.__clubObject = new NgEngineEntity();
		this.__clubObject.mIsUpdatable = true;
		this.__clubObject.onUpdate = this._emitTime.bind(this);
		this.__clubObject.register();
		
		this._createSendGen(this);
	},
	
	_emitTime: function()
	{
		this.emit(Time.getFrameDelta());
	},
	/**
	 * Set the tick rate that this <code>UpdateEmitter</code> object uses to send updates.<br><br>
	 * <b>Example:</b> Calling <code>setTickRate(15)</code>, any <code>MessageListener</code> objects that are listening 
	 * to the <code>UpdateEmitter</code> receive messages 15 times a second.	 
	 * @param {Number} r The new tick rate.
	 * @see GL2.Sprite
	 * @status iOS, Android, Flash
	 */
	setTickRate: function( r ) 
	{
		this._setTickRateSendGen(
		{
			rate: r,
		});
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 304
	// Method create = -1
	// Method setTickRate = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift() );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in UpdateEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[304] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 304 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_setTickRateSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 304 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "rate" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setTickRate: function( rate ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/Proc'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/Proc'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/Proc'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Proc
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports.Proc = Class.singleton(
{
	classname: 'Proc',
	
	initialize: function()
	{
		this._commandString = "";
	},
	
	appendToCommandString: function( str )
	{
		this._commandString += str;
	},
	
	getCommandString: function()
	{
		return this._commandString;
	},
	
	clearCommandString: function ()
	{
		this._commandString = "";
	},
	
	parseBool: function( v )
	{
		return v == 1 ? true : false;
	},

	parseInt: function( v )
	{
		return parseInt( v, 10 );
	},
	
	parseFloat: function( v )
	{
		return parseFloat( v );
	},
	
	parseString: function( v )
	{
		return Base64.decode( v );
	},
	
	parseJSONString: function( v )
	{
		return JSON.parse( Base64.decode( v ) );
	},
	
// {{?Wg Generated Code}}
	_classRecvGen: function( cmd )
	{
		var classId = parseInt( cmd.shift() );
		
		var handler = PROC_DISPATCH_TABLE[classId];
		if(handler)
		{
			handler(cmd);
		}
		else
		{
			NgLogE( "Unknown class id " + classId + " in _classRecvGen" );
		}
	}
// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_LocalGameList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_LocalGameList'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _LocalGameList
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;
var Util = require('NGCore/Client/Network/Util').Util;
var Base64 = require('NGCore/Client/Core/Base64').Base64;

////////////////////////////////////////////////////////////////////////////////

exports._LocalGameList = Class.singleton (
/** @lends Core._LocalGameList.prototype */
{
	classname: '_LocalGameList',

	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this);

		this.mGameList = [];
		var Storage = require('NGCore/Client/Storage').Storage;
		this.mFile = Storage.FileSystem;
		this.mGameStore = Storage.KeyValueCache.global("Core.GameList");

		this.mLoadingGames = {};
		this.mActiveGameKey = "activeGames";
		this.mRequiredAvailableSpace = 0;
		this.mSpaceAvailable = 0;
		this.mSpaceFreeCallbacks = [];
		this._firstBootGameLaunch = true;

		this._getRepoSpaceSendGen();

		this._setStage(this.ProgressStage.BootFirst);
		this._reloadGameList();
	},
	
	ProgressStage:
	{
		BootFirst: {},
		BootSecond: {},
		GameWithoutSecond: {},
		GameWithSecond: {},
		Regular: {}
	},
	
	_setStage: function(stage)
	{
		this._progressStage = stage;
		switch(stage)
		{
			case this.ProgressStage.BootFirst:
				console.log('setStage BootFirst');
				this._progressMin = 0;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.BootSecond:
				console.log('setStage BootSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.25;
				break;
			case this.ProgressStage.GameWithoutSecond:
				console.log('setStage GameWithoutSecond');
				this._progressMin = 0.25;
				this._progressRange = 0.75;
				break;
			case this.ProgressStage.GameWithSecond:
				console.log('setStage GameWithSecond');
				this._progressMin = 0.5;
				this._progressRange = 0.5;
				break;
			case this.ProgressStage.Regular:
				console.log('setStage Regular');
				this._progressMin = 0;
				this._progressRange = 1;
				break;
			default:
				console.log('setStage ERROR');
				this._progressMin = 0;
				this._progressRange = 1;
		}
		console.log('min:', this._progressMin, 'range:', this._progressRange);
	},
	
	_nextStage: function()
	{
		switch(this._progressStage)
		{
			case this.ProgressStage.BootFirst:
				this._setStage(this.ProgressStage.GameWithoutSecond);
				break;
			case this.ProgressStage.BootSecond:
				this._setStage(this.ProgressStage.GameWithSecond);
				break;
			case this.ProgressStage.GameWithoutSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
			case this.ProgressStage.GameWithSecond:
				this._setStage(this.ProgressStage.Regular);
				break;
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 303
	// Method create = -1
	// Method updateGame = 2
	// Method updateDone = 3
	// Method getRepoSpace = 4
	// Method repoSpace = 5
	// Method deleteGame = 6
	// Method setUpdateProgress = 7
	// Method pauseUpdate = 8
	// Method resumeUpdate = 9
	// Method cancelUpdate = 10
	// Method updateProgress = 11
	// Method allowBGUpdates = 12
	// Method runGame = 13
	// Method finishGame = 14
	// Method setProgressText = 15
	// Method setSplashVisible = 16
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift() );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._updateGameRecv( cmd );
					break;
				case 5:
					instance._repoSpaceRecv( cmd );
					break;
				case 6:
					instance._deleteGameRecv( cmd );
					break;
				case 8:
					instance._pauseUpdateRecv( cmd );
					break;
				case 9:
					instance._resumeUpdateRecv( cmd );
					break;
				case 10:
					instance._cancelUpdateRecv( cmd );
					break;
				case 12:
					instance._allowBGUpdatesRecv( cmd );
					break;
				case 13:
					instance._runGameRecv( cmd );
					break;
				case 14:
					instance._finishGameRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _LocalGameList._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[303] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_updateGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		obj[ "id" ] = Proc.parseInt( cmd[ 1 ] );
		if( obj[ "id" ] === undefined )
		{
			NgLogE("Could not parse id in _LocalGameList.updateGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_repoSpaceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		obj[ "space" ] = Proc.parseInt( cmd[ 0 ] );
		if( obj[ "space" ] === undefined )
		{
			NgLogE("Could not parse space in _LocalGameList.repoSpace from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "mdFive" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "mdFive" ] === undefined )
		{
			NgLogE("Could not parse mdFive in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		obj[ "game" ] = Proc.parseString( cmd[ 1 ] );
		if( obj[ "game" ] === undefined )
		{
			NgLogE("Could not parse game in _LocalGameList.deleteGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_pauseUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.pauseUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_resumeUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.resumeUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_cancelUpdateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.cancelUpdate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_allowBGUpdatesRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		obj[ "allow" ] = Proc.parseBool( cmd[ 0 ] );
		if( obj[ "allow" ] === undefined )
		{
			NgLogE("Could not parse allow in _LocalGameList.allowBGUpdates from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_runGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in _LocalGameList.runGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_finishGameRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in _LocalGameList.finishGame from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 303 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_updateDoneSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 303 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "id" ] + "," + Base64.encode( obj[ "error" ] )  );
	},
	
	/** @private */
	_getRepoSpaceSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 303 + "," + 4 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_setUpdateProgressSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 303 + "," + 7 + "," + this.__objectRegistryId + "," + obj[ "progress" ]  );
	},
	
	/** @private */
	_updateProgressSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 303 + "," + 11 + "," + this.__objectRegistryId + "," + Base64.encode( obj[ "url" ] ) + "," + obj[ "cur" ] + "," + obj[ "total" ] + "," + ( obj[ "error" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_setProgressTextSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 303 + "," + 15 + "," + this.__objectRegistryId + "," + Base64.encode( obj[ "text" ] )  );
	},
	
	/** @private */
	_setSplashVisibleSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 303 + "," + 16 + "," + this.__objectRegistryId + "," + ( obj[ "visible" ] ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _updateGameRecv: function( cmd ) {}
	// updateDone: function( id, error ) {}
	
	// getRepoSpace: function(  ) {}
	
	// _repoSpaceRecv: function( cmd ) {}
	// _deleteGameRecv: function( cmd ) {}
	// setUpdateProgress: function( progress ) {}
	
	// _pauseUpdateRecv: function( cmd ) {}
	// _resumeUpdateRecv: function( cmd ) {}
	// _cancelUpdateRecv: function( cmd ) {}
	// updateProgress: function( url, cur, total, error ) {}
	
	// _allowBGUpdatesRecv: function( cmd ) {}
	// _runGameRecv: function( cmd ) {}
	// _finishGameRecv: function( cmd ) {}
	// setProgressText: function( text ) {}
	
	// setSplashVisible: function( visible ) {}
	

// {{/Wg Generated Code}}
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
	_updateGameRecv: function( cmd )
	{
		this._getRepoSpaceSendGen();

		var o = {};
		this._updateGameRecvGen(cmd, o);

		if (o.url in this.mLoadingGames)
		{
			this.mLoadingGames[o.url].id = o.id;
			this.mLoadingGames[o.url].dlman.resume();
		}
		else
		{
			this.updateGame(o.url, o.id,
				(function (url, newFiles, err)
				{
					o.error = err;
					o.id = this.mLoadingGames[url].id;
					this._updateDoneSendGen(o);
				}).bind(this, o.url)
			);
		}
	},
	mobageRunGame: function (funk)
	{
		this._gameRunner = funk;
	},
	_runGameRecv: function( cmd )
	{
		var o = {};
		this._runGameRecvGen(cmd, o);
		if (this._gameRunner)
		{
			console.log("_LGL running gameRunner " + o.url);
			this._gameRunner(o.url);
		}
		else
		{
			console.log("_LGL running game " + o.url);
			var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
			_int_LGL.launch(o.url, _int_LGL.ProcID.Game);
		}
	},
	/**
	 * set the function that kills the current game app
	 */
	setFinishGameHandler: function(funk)
	{
		this._finishGameHandler = funk;
	},
	_finishGameRecv: function()
	{
		if (this._finishGameHandler)
		{
			this._finishGameHandler();
		} else {
			console.log("_LocalGameList: finishGameHandler is not set");
		}
	},
	_repoSpaceRecv: function( cmd )
	{
		var obj = {};
		this._repoSpaceRecvGen(cmd, obj);
		this.mSpaceAvailable = obj.space;
		console.log("SD card space available(b): " + this.mSpaceAvailable);

		var length = this.mSpaceFreeCallbacks.length;
		while (length--)
		{
			(this.mSpaceFreeCallbacks.pop())();
		}
	},

	_deleteGameRecv: function( cmd )
	{
		// site to calc md5: http://pajhome.org.uk/crypt/md5/
		var allowedGames =
		[
			"http://10.15.", // Allow partial ones, for testing
			'http://gamehub.mobage.com/app/1.0s/gamehub',
			'url of allowed game'
		];

		var obj = {};
		this._deleteGameRecvGen(cmd, obj);
		var i;
		for(i in allowedGames)
		{
			var match = obj.game.match(allowedGames[i]);
			if(match && !match.index)
			{
				NgLogD("Deleting " + obj.mdFive);
				this.deleteGameFiles(obj.mdFive);

				var doneCB = (function ()
				{
					NgLogD("Finished deleting game from " + this.mActiveGameKey + " for " + obj.mdFive );
				}).bind(this);
				this._deleteGameFromStorage(obj.mdFive,doneCB);

				return;
			}
			else
			{
				// for testing, allow any local server starting with 10.15
			}
		}
		NgLogE("_LocalGameList unauthorized call to deleteGame from "+obj.game+"!");
	},

// _deleteGameFromStorage is for deleting the games info from LGL storage, not the game's storage

	_deleteGameFromStorage: function(mdFive,doneCB)
	{
		var self = this;
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				
				var good = false;
				var ind;
				var out = [];
				for(ind = 0; ind < list.length; ++ind)
				{
					if(list[ind].name == mdFive)
						good = true;
					else
						out.push(list[ind]);
				}
				
				if( good )
				{
					NgLogD("_LocalGameList found and removed " + mdFive);
					self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(out), doneCB);
				}
				else
				{
					NgLogD("_LocalGameList failed to find and remove " + mdFive);
					doneCB("Could not remove item: " + error);
				}
				
			}, true
		);
	},

	getGameConfig: function(identifier, isMDFive, callBack)
	{
		if (typeof isMDFive == 'function')
		{
			callBack = isMDFive;
			isMDFive = false;
		}

		var folder;
		if (isMDFive)
		{
			folder = identifier;
		}
		else
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			var norm = Util.NormalizeUrl(identifier);
			folder = toMD5(norm);
		}

		this.mFile.readFile(folder + "/" + Capabilities._getConfigFile(),
			function (err, contents)
			{
				var ret = {};
				if (err || !contents)
				{
					console.log("Could not get config from %s! err: %s", identifier, err);
				}
				else
				{
					ret = JSON.parse(contents);
				}
				callBack(ret);
			}
		);
	},

	getRepoSpace: function()
	{
		return this.mSpaceAvailable;
	},

	getConfig: function(gameOrigin, name, callback, failEarly)
	{// callback = function (config, err)
		// XHR
		var XHR = require('NGCore/Client/Network/XHR').XHR;
		var Util = require('NGCore/Client/Network/Util').Util;
		
		var httpStatus = 0;
		
		Util.OperationWithRetries(function(failCb)
		{
			var req = new XHR();
			req.onreadystatechange = function()
			{
				if(req.readyState == 4)
				{
					httpStatus = req.status;
					if(httpStatus == 200)
					{
						// Succes.
						callback(req.responseText);
					}
					else if(httpStatus == 404)
					{
						// File not on server, so load from the regular location
						console.log("no configuration file found at %s, using root server", gameOrigin + name);
						callback( "{}" );
					}
					else
					{
						//Error! Retry
						failCb();
					}
				}
			}

			req.open('GET', gameOrigin + name + Util.getCacheBustingString(), true);
			req.send();
		}, function()
		{
			callback(null, true, httpStatus);
		}, failEarly);
	},

	// gameOrigin: url to folder holding webgame.ngmanifest
	// doneCB = function(totalBytes, error)
	updateGame: function(gameOrigin, id, doneCB, failEarly, failAllowed)
	{
		// console.log ( "LGL.updateGame url = " + gameOrigin );
		// console.log ( "LGL.updateGame boot game = " + Capabilities.getBootGame() );
		
		var re = new RegExp(".*" + Capabilities.getBootGame());
		var match = gameOrigin.match(re)
		
		if (match) 
			this._firstBootGameLaunch = false;
			
		// console.log ( "_LocalGameList.updateGame updating game." );

		// Normalize URL
		var Util = require('NGCore/Client/Network/Util').Util;
		gameOrigin = Util.NormalizeUrl(gameOrigin);
		var name = toMD5(gameOrigin);
		this.mLoadingGames[gameOrigin] = {id: id};

		console.log(gameOrigin + " toMD5: " + name);

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;
		var build = "/" + buildPath[caps.getPlatformOS()];

		this._setProgress(0);

		var curContUrl = "";
		var configFile = toMD5(gameOrigin) + "/" + caps._getConfigFile();
		this.mFile.readFile(configFile,
			function(err, data)
			{
				if (data)
				{
					var obj = JSON.parse(data);
					curContUrl = obj.contentUrl;
				}
			}
		);

		this.getConfig(gameOrigin + build, "/" + caps._getConfigFile(),
		(function(config, error, status)
		{
			if (error)
			{
				doneCB(0, error);
				delete this.mLoadingGames[gameOrigin];
			}
			else
			{
				this._setProgress(0.1);

				// Read config
				var parsedConfig = JSON.parse(config);
				if(!parsedConfig.contentUrl)
				{
					parsedConfig.contentUrl = gameOrigin + build;
				}
				else if (parsedConfig.contentUrl == curContUrl)
				{
					// no need to update.
					this._setProgress( 1.0 );
					this._setStage(this.ProgressStage.Regular);
					this.mFile.writeFile(configFile, JSON.stringify(parsedConfig),
						function(err) {console.log(err); } );
					doneCB(0);
					delete this.mLoadingGames[gameOrigin];
					return;
				}

				this._callDownloadManifest(parsedConfig, gameOrigin, name, failEarly, failAllowed, (function(bytes, error)
				{
					this._setProgress( 1.0 );
					this._nextStage();

					if (! error) {
						var that = this;
						this._reloadGameList({name:name, url:gameOrigin}, function()
						{
							if (doneCB && (typeof doneCB == 'function')) {
								doneCB(bytes, error);
								delete that.mLoadingGames[gameOrigin];
							}
						});
					} else {
						doneCB(bytes, error);
						delete this.mLoadingGames[gameOrigin];
					}
				}).bind(this));
			}
		}).bind(this), failEarly);
	},

	_allowBGUpdatesRecv: function( cmd )
	{
		var o = {};
		this._allowBGUpdatesRecvGen(cmd, o);
		this._pauseOrResumeAll(o.allow);
	},

	_pauseOrResumeAll: function(resume)
	{
		for (i in this.mLoadingGames)
		{
			if (resume)
			{
				console.log("Resuming download of " + i);
				this.resumeUpdate(i);
			}
			else
			{
				console.log("Pausing download of " + i);
				this.pauseUpdate(i);
			}
		}
	},

	pauseUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.pause();
				this.mLoadingGames[url].userPause = true;
			}
		}
	},

	_pauseUpdateRecv: function(cmd)
	{
		var o = {};
		this._pauseUpdateRecvGen(cmd, o);
		this.pauseUpdate(o.url);
	},

	resumeUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			if(this.mLoadingGames[url].dlman)
			{
				this.mLoadingGames[url].dlman.resume();
				this.mLoadingGames[url].userPause = false;
			}
		}
	},

	_resumeUpdateRecv: function(cmd)
	{
		var o = {};
		this._resumeUpdateRecvGen(cmd, o);
		this.resumeUpdate(o.url);
	},

	cancelUpdate: function(url)
	{
		if (this.mLoadingGames[url])
		{
			this.mLoadingGames[url].dlman.abort();
			delete this.mLoadingGames[url];

			//Cancel the keep alive request as well
			var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter

            this.identification_key = 'manifest_download';
            LifecycleEmitter.cancelEngineKeepAlive(this);
		}
	},

	_cancelUpdateRecv: function(cmd)
	{
		var o = {};
		this._cancelUpdateRecvGen(cmd, o);
		this.cancelUpdate(o.url);
	},

	_setProgress: function (progress) {
		if(progress > 1) progress = 1;
		if(progress < 0) progress = 0;
		progress = progress*this._progressRange + this._progressMin;
		this._setUpdateProgressSendGen({progress: progress});
	},

	listenToProgress: function (listener)
	{
		this._privListener = listener;
	},

	_updateProgress: function(url, prog, total, err)
	{
		//console.log("Updating progress for: %s, %d, %d " + err, url, prog, total);
		if (this._privListener)
			this._privListener(url, prog, total, err);

		if (this.mLoadingGames[url] && this.mLoadingGames[url].id >=0)
			this._updateProgressSendGen({url: url, cur: prog, total: total, error: err});
	},

	// doneCB = function(totalBytes, error)
	_callDownloadManifest: function (config, gameOrigin, name, failEarly, failAllowed, doneCB)
	{
		var contentUrl = config.contentUrl;
		var reportTotalBytes = 0;
		var self = this;
		var Downloader = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;

		// Do download
		(function doDownload()
		{
			var dler = new Downloader();
			dler.mLocalGameList = self;
			var firstProgress = true;
            var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;
            this.identification_key = 'manifest_download';
            NgLogD("++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++Manifest Download Request Keep Engine Alive");
            LifecycleEmitter.requestEngineKeepAlive(this);
			// Only allow this on iOS
			config.omitJsUpdate = config.omitJsUpdate && (Capabilities.getPlatformOS() == "iPhone OS");
			dler._setConfig(config);
			dler.start(contentUrl, name, 'webgame.ngmanifest', function(bytesDownloaded, bytesTotal)
			{
				if(firstProgress)
				{
					// First progress callback is made when manifest is downloaded.
					firstProgress = false;
					self._setProgress(0.2);
					reportTotalBytes = bytesTotal;
				}
				else
				{
					self._setProgress(0.3 + 0.6 * (bytesDownloaded / bytesTotal));
				}

				// update LGL
				self._updateProgress(gameOrigin, bytesDownloaded, bytesTotal);
			}, function(error, manifest, wasCached)
			{
				if (failAllowed)
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes, error);
					}
				}
				else if(error)
				{
					NgLogE("Error: " + error);
					// update LGL
					self._updateProgress(gameOrigin, 0, 0, error);
					doneCB(0, error);
				}
				else
				{
					if (doneCB)
					{
						doneCB(reportTotalBytes);
					}
				}

                this.identification_key = 'manifest_download';
                LifecycleEmitter.cancelEngineKeepAlive(this);
			}, false, failEarly);
			self.mLoadingGames[gameOrigin].dlman = dler;
		})();
	},

	freeSpace: function(space, cb)
	{
		this.mRequiredAvailableSpace = space;
		this.mSpaceFreeCallbacks.push(
			(function()
			{
				if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
				{
					if (this._privListener)
					{
						this._privListener("", 0, 0, "SD card is full");
					}
					else
					{
						console.log("Warning!! Mobage is not handling SD card full error!");
						// This is Preservation of ancient code which has and will likely never execute
						var checkAgain = function()
						{
							if (this.mRequiredAvailableSpace > this.mSpaceAvailable)
							{
								this.pruneGames(1);
								this.mSpaceFreeCallbacks.push(checkAgain);
							}
							else
							{
								cb();
							}
						};
						// Is a redundant check on space, but looks better/is simpler/won't ever be used anyhow
						checkAgain();
					}
				}
				else
				{
					cb();
				}
			}).bind(this)
		);

		this._getRepoSpaceSendGen();
	},

	pruneGames: function(number)
	{
		var self = this;

		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		}

		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list = JSON.parse(value);
				list.sort(sort);
				while (number-- && (list.length - 1))
				{
					var game = list.pop();

					// Do not delete the currently loading game
					if (!(game.name in self.mLoadingGames))
					{
						// delete game
						self.deleteGameFiles(game.name);
					}
					else
					{
						list.push(game);
					}
				}

				// Save the data
				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));
			}, true
		);
	},

	deleteGame: function (url, callBack)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		var norm = Util.NormalizeUrl(url);
		var mdFive = toMD5(norm);

		this.deleteGameFiles(mdFive);
		this._deleteGameFromStorage(mdFive, callBack);
	},

	// Delete the KeyValueCache.local of the given game
	deleteGameKeyValue: function(mdFive)
	{
		var kvm = require('NGCore/Client/Storage').KeyValueCache;
		kvm.global(mdFive).clear();
	},

	deleteGameFiles: function(game)
	{
		var self = this;
		self.mFile.deleteFile( game , 
			function(err)
				{
					if(err == "" )
						NgLogI('Deleted');
					else
						NgLogD("Could not delete game");

					self._getRepoSpaceSendGen();
				});
	},

	getGameList: function()
	{
		return this.mGameList;
	},

	clearWatch: function()
	{
		var fs = require('NGCore/Client/Storage/FileSystem').FileSystem;
		fs.deleteFile(".watch");
	},

	/**
	 * @private
	 */
	_reloadGameList: function(newItem, cb)
	{
		this.mGameStore.getItem(this.mActiveGameKey,
			(function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				if (newItem)
				{
					var bNew = true;
					for (var i in list)
					{
						if (list[i].name == newItem.name)
						{
							bNew = false;
							newItem.lastRun = list[i].lastRun;
							list[i] = newItem;
							break;
						}
					}

					if (bNew)
					{
						list.push(newItem);
					}
					this.mGameStore.setItem(this.mActiveGameKey, JSON.stringify(list));
				}

				this.mGameList = list;

				if (typeof cb == 'function')
					cb();
			}).bind(this),
			true
		);
	},

	_getRunningGame: function(callBack)
	{
		// Function to put oldest games on top of the stack
		var sort = function (l, r)
		{
			return r.lastRun - l.lastRun;
		}

		this._reloadGameList(false, (function(cb)
		{
			var list = this.mGameList;
			list.sort(sort);
			var current = null;
			var len = list.length;
			for (var i = 0; i < len; ++i)
			{
				if (list[i].lastRun)
				{
					current = list[i];
					break;
				}
			}
			if (current && current.url)
				cb(current.url);
		}).bind(this, callBack));
	},

	/** @private */
	_pausingGame: function()
	{
		// true to resume download when pausing a game
		this._pauseOrResumeAll(true);
	},

	/** @private */
	_resumingGame: function()
	{
		// Check if the current game allows downloading
		this._getRunningGame((function(game)
		{
			this.getGameConfig(game, (function(config)
			{
				if (config.noBackgroundUpdates)
				{
					// false to pause download when resuming a game
					this._pauseOrResumeAll(false);
				}
			}).bind(this));
		}).bind(this));
	},

	setSplashVisible: function( visible )
	{
		this._setSplashVisibleSendGen({visible: visible});
	},

	setProgressText: function( text )
	{
		this._setProgressTextSendGen({text: text});
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		var _int_LGL = require('NGCore/Client/Core/_int_LGL')._int_LGL;
		_int_LGL.updateAvailable(game, doneCB, errorCB);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/NativeAppLaunch'] = exports; // @deprecated
var NativeAppLaunch;

exports.NativeAppLaunch = NativeAppLaunch;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipe'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipe'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipe'] = exports; var Class = require('NGCore/Shared/Class').Class;
var NgPipesRemote = require('NGCore/Shared/NgPipesRemote').NgPipesRemote;
var hex_sha1 = require('NGCore/Shared/Lib/sha1').hex_sha1;
var __hasProp = Object.prototype.hasOwnProperty;
var CapabilitiesReq = require('NGCore/Client/Core/Capabilities');

/*
The NgPipes object
*/

NgPipe = Class.subclass({
    classname: "NgPipe",
    initialize: function(options) {
        options = options || {};
        this._meta = options.meta || {};
        this._queue = null;
        this._isSendQueued = false;
        this._sendDelay = options.sendDelay || 5000;
        this._meta = options.meta || {};
        this._seqStart = options.seqStart || new Date().getTime();
        this._playerState = options.playerState || null;
        this._seqNumber = options.seqNumber || 0;
        this._allowedLargeValue = {
            msg: 1024 * 5,
            err: 1024 * 5,
            sid: 64,
            udid: 64
        };

        this._sendToRemote = true;
        this._globalKey = '__NgPipeStorage';
        var self = this;
        var cb = function(error,value, key) {
            var new_queue = [];
            if (!error) {
                try {
                    new_queue = JSON.parse(value);
                } catch(e) {
                    new_queue = [];
                }
            }

            if (self._queue) {
                new_queue = self._queue.concat(new_queue);
            }

            self._setQueue(new_queue);
            if (self._queue.length > 0 ){
                self._drainQueue();
            }
        };
        this._locListener = null;
        this._location = null;
        Storage.KeyValueCache.global(this._globalKey).getItem(this._globalKey, cb);
        var starting_queue = [].concat(options.queue || []);
        this._queue = starting_queue;
        this._sessionEnded = false;
        this._capAlphaNumStringKeys = ['afam', 'asku', 'srcty', 'evcl', 'evid', 'pltfmsku','carr','srv'];
        this.sessionStartEvent();
        this._hookLifetime();
        this._hookGeo();
        return true;
    },

    close: function() {
        this._drainQueue();
        return true;
    },

    enable: function() {
        this._sendToRemote = true;
    },

    disable: function() {
        this._sendToRemote = false;
    },

    setRemoteUrl: function(url) {
        NgPipesRemote.setUrl(url);
    },

    playerEvent: function(eventId, evcl, change, playerState) {
        var e;
        evcl || (evcl = "PLST");
        e = {
            change: change,
            srcty: 'GC',
            evid: eventId,
            evcl: evcl,
            plst: this._getPlayerStateDiff(playerState || this._playerState)
        };
        this._queueMessage(e);
        this._setCurrentPlayerState(playerState);
        return e;
    },
    gameEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAME'
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
        }
        this._queueMessage(e);
        return e;
    },
    gameOpsEvent: function(eventId, payload) {
        var e;
        e = {
            evid: eventId,
            evpl: payload,
            srcty: 'GC',
            evcl: 'GAMEOPS'
        };
        this._queueMessage(e);
        return e;
    },
    revenueEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'REV',
            evid: eventId,
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    uiEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'UI',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    funnelEvent: function(eventId, payload, playerState) {
        var e;
        e = {
            evcl: 'FUNNEL',
            srcty: 'GC',
            evid: eventId,
            evpl: payload
        };

        if (playerState) {
          e.plst = this._getPlayerStateDiff(playerState || this._playerState);
          this._setCurrentPlayerState(playerState);
        }
        this._queueMessage(e);
        return e;
    },
    plusEvent: function(eventId, payload) {
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    plusUIEvent: function(eventId, payload) {
        var e = {
            evcl: 'PLUSUI',
            srcty: 'PC',
            evid: eventId,
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },
    navigationEvent: function(fromScreen, toScreen, buttonID){
        var payload = {};
        payload.fro = fromScreen;
        payload.to  = toScreen;
        if(buttonID){
            payload.btnid = buttonID;
        }

        return this.plusUIEvent("NAV", payload);
    },
    sessionEndEvent: function() {
        if (!(this._sessionEnded)) {
            var e;
            var Capabilities = CapabilitiesReq.Capabilities;

            e = {
                evid:  'SFN',
                evcl:  'PLUS',
                srcty: 'PC',
                hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
                hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
                osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
                lang: Capabilities.getLanguage()
            };

            e = this._queueMessage(e);
            this._sessionEnded = true;
            return e;
        }
        return null;
    },
    sessionStartEvent: function() {
        var e;
        var Capabilities = CapabilitiesReq.Capabilities;

        e = {
            evid:  'SST',
            evcl:  'PLUS',
            srcty: 'PC',
            hwty:  Capabilities.getDeviceName(), // cat ro.product.manufacturer, ro.product.brandh, ro.product.model
            hwrev: Capabilities.getPlatformHW(), // cat ro.revision + ro.build.date.utc
            osrev: ""+  Capabilities.getPlatformOS() + " " + Capabilities.getPlatformOSVersion(), // ro.build.fingerprint
            lang: Capabilities.getLanguage()
        };



        e = this._queueMessage(e);
        return e;
    },
    socialEvent: function(eventId, friendId,  payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'GC',
            frid: friendId,
            evid: eventId,
            evpl: payload
        };
        return this._queueMessage(e);
    },
    initPlayerState: function(inState) {
        this._setCurrentPlayerState(inState);
        return true;
    },

    updatePlayerState: function(newState) {
        this._setCurrentPlayerState(newState);
        return true;
    },

    //params for internal IAP events:

    //promo campaign unique identifier
    //promoid (String)

    //price of virtual good
    //price (Float)

    //currency used. Defaults to USD
    //cur (String)

    //user's moba balance after purchase
    //mobabalance (Integer)

    //unique identifier for purchase
    //orderid (String)

    //a string identifier for an item, e.g. "IceCastle"
    //sku (String)

    //the value of the item in moba
    //mobaprice (Float)

    //the quantity of item being purchased
    //itemamt (Float)

    //a text description of the item.
    //desc (String)

    //a message displayed to the user when the debit or credit occurs
    //dispmsg (String)

    //the name of the item, as displayed to the user
    //dispname (String)

    //the Mobage ID for the product.
    //productid (Integer)

    //dynamic data accepts a custom object with any params not included above
    //dynamicdata (Object)

    reportAdShow : function(adid) {
        return this.revenueEvent('ADSHOW',{'adid':adid});      
    },

    reportAdClick : function(adid) {
        return this.revenueEvent('ADCLCK',{'adid':adid});    
    },

    reportPromoShow : function(promoid) {
        return this.revenueEvent('PROMOSHOW',{'promoid':promoid});    
    },

    reportPromoClick : function(promoid) {
        return this.revenueEvent('PROMOCLCK',{'promoid':promoid});    
    },

    reportPromoRedeem : function(promoid) {
        return this.revenueEvent('PROMOREDM',{'promoid':promoid});    
    },

    //user clicks on money sku
    reportMoneyIAPIntent : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPINTENT', evpl);
    },

    //user cancels a money sku transaction
    reportMoneyIAPCancel : function(sku,item_amt,price,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPCANCEL', evpl);
    },

    //money sku transaction is successful; orderid required
    reportMoneyIAPSuccess : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            orderid : orderid,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPSUCCESS',evpl);
    },

    //money iap purchase fails after being authorized by user; orderid optional if available, pass in null otherwise
    reportMoneyIAPFail : function(sku,item_amt,price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,cur,dynamicdata) {
        var evpl = {
            sku : sku,
            itemamt : item_amt,
            productid: product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance,
            amt : price,
            cur : cur || 'USD'
            };
        orderid ? evpl.orderid = orderid : "";
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('IAPFAIL', evpl);
    },

    //user opens money IAP store
    reportMoneyIAPShow : function() {
        return this.revenueEvent('IAPSHOW',{});
    },

    //user opens moba IAP store
    reportMobaIAPShow : function() {
        return this.revenueEvent('MOBAIAPSHOW',{});
    },

    //user clicks on a moba sku
    reportMobaIAPIntent : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPINTENT', evpl);
    },

    //user cancels moba sku transaction
    reportMobaIAPCancel : function(sku,moba_price,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPCANCEL', evpl);
    },

    //moba sku transaction is successful. orderid required. 
    reportMobaIAPSuccess : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            orderid : orderid,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPSUCCESS', evpl)
    },

    //moba sku purchase fails after being authorized by user. orderid optional if available, pass in null otherwise
    reportMobaIAPFail : function(sku,moba_price,orderid,product_id,display_name,user_end_moba_balance,description,display_message,dynamicdata) {
        var evpl = {
            sku : sku,
            mobaprice : moba_price,
            productid : product_id,
            //desc : description,
            dispmsg : display_message,
            dispname : display_name,
            mobabalance : user_end_moba_balance
            };
        orderid ? evpl.orderid = orderid : '';
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        return this.revenueEvent('MOBAIAPFAIL', evpl);
    },

    /**
    * Report us scraping a facebook user's profile - ext_id is the user's facebook ID.
    *
    */
    reportFacebookScrape : function(ext_id, dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            extid: ext_id,
            evid: 'FBSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report us scraping a user's contact list - ext_id is the user's facebook ID.
    *
    */
    reportContactScrape : function(dynamicdata) {
        var e;
        var evpl={};
        dynamicdata ? evpl.dynamicdata = dynamicdata : '';
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'CONTACTSCRAPE',
            evpl: evpl
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user posting to another user's wall.
    *
    */
    reportWallPost : function(friendId, payload) {
        var e;
        e = {
            evcl: 'SOCL',
            srcty: 'PC',
            frid: friendId,
            evid: 'WALLPOST',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * Report a user downloading a game from a specific section in the store.
    * @param {String} game is the asku for the game being downloaded.
    * @param {String} section is the name of the section that the user downloaded from:
    *   AllGames, FeaturedGames, MyProfile, FriendsLastPlayedGame, FriendsPlayingGame
    * @param {String} slot is the order of the game in the section (if applicable)
    */
    reportDownload : function(game, section, slot) {
        var payload = {};
        payload.game = game;
        payload.section = section;
        payload.slot = slot;
        var e;
        e = {
            evcl: 'PLUS',
            srcty: 'PC',
            evid: 'DOWNLOAD',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    /**
    * add internal tag to a user.
    */
    addTag : function(tagName) {
        var payload = {};
        payload.tag = tagName;
        var e;
        e = {
            evcl: 'PLUS',
            evid: 'TAG', 
            srcty: 'PC',
            evpl: payload
        };
        this._queueMessage(e);
        return e;
    },

    getSeqNumber: function() {
        this._seqNumber += 1;
        return this._seqNumber;
    },

    getQueueCount: function() {
        return this._queue.length;
    },

    getSendDelay: function() {
        return this._sendDelay;
    },

    setSendDelay: function(val) {
        return (this._sendDelay = val);
    },

    setMeta: function(key, value) {
        if (!value) {
            value = key;
            return (this._meta = value);
        } else {
            return (this._meta[key] = value);
        }
    },

    getMeta: function(key) {
        if (key) {
            return this._meta[key];
        } else {
            return this._meta;
        }
    },

    _queueMessage: function(msg) {
        if (!msg) {
            return false;
        }

        var self = this;

        //This sets metas that don't change often
        this._setUnsetMetaKeys();

        // The rest of these function set properties that 
        msg = this._mergeMeta(msg);
        msg = this._addSeqDetails(msg);
        msg = this._addGeo(msg);
        msg = this._addEvts(msg);
        msg = this._addGameSku(msg);
        msg = this._addGameRel(msg);
        msg = this._addCarrier(msg);
        msg = this._addService(msg);
        msg = this._addPlatformVersion(msg);
        msg = this._addUserId(msg);
        msg = this._addUserName(msg);
        msg = this._normalizeValues(msg);
        var queue = this._getQueue();
        queue.push(msg);
        this._setQueue(queue);

        if (!this._isSendQueued) {
            setTimeout(function() {
                self._isSendQueued = false;
                return self._drainQueue();
            }, self._sendDelay);
        }
        return msg;
    },
    _hookGeo: function() {
        var Social = require('NGCore/Client/Social').Social;
        if(Social.US){
            var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
            var Device = require('NGCore/Client/Device').Device, self = this;
            var LocationListener = MessageListener.subclass({
                initialize: function() {
                    Device.LocationEmitter.addListener(this, this.onUpdate, false)
                },
                onUpdate: function(location) {
                    self._location = location;
                    Device.LocationEmitter.removeListener(this);
                    self._locListener = null;
                }
            });
            this._locListener = new LocationListener();
        }
    },
    _hookLifetime: function() {
        var self = this;
        var MessageListener = require('NGCore/Client/Core/MessageListener').MessageListener;
        var Device = require('NGCore/Client/Device').Device;
        var ListenerClass =  MessageListener.subclass({
            initialize: function() {
                Device.LifecycleEmitter.addListener(this, this.onLifecycleUpdate);
            },
            onLifecycleUpdate: function(event) {
                switch (event) {
                case Device.LifecycleEmitter.Event.Suspend:
                case Device.LifecycleEmitter.Event.Terminate:
                    self.sessionEndEvent();
                    break;
                case Device.LifecycleEmitter.Event.Resume:
                default:
                    self.initialize();
                    break;
                }
            }
        });
        if (!this._listener) {
            this._listener = new ListenerClass();
        }
    },
    _setUnsetMetaKeys: function() {
        var Capabilities = CapabilitiesReq.Capabilities, udid;
        if ((!this.getMeta('udid')) && (udid = Capabilities.getUniqueId() )) {
            this.setMeta('udid', udid);
        }

        if (!this.getMeta('sid')) {
            var sid = ''+ hex_sha1(this._seqStart+ (this.getMeta('udid')|| "UNKNOWN"));
            this.setMeta('sid', sid);
        }

        if (!this.getMeta('pltfmsku')) {
            var platRegex = /android/;

            var plat = Capabilities.getPlatformOS();
            if (plat) {
                plat = plat.toLowerCase();
                if (plat.match(platRegex) ) {
                    plat = "android";
                } else if ("flash" === plat ) {
                    plat = "flash";
                } else {
                    plat = "ios";
                }
                this.setMeta( 'pltfmsku', plat);
            }
        }

        if (!this.getMeta('apiver')) {
            this.setMeta('apiver', 4);
        }
        return true;
    },

    _getPlayerStateDiff: function(newState) {
        var delta_sign, delta_value, diff, key, value;
        diff = {};
        if (!this._playerState) {
            this._setCurrentPlayerState(newState);
        }
        for (key in newState) {
            if (!__hasProp.call(newState, key)) continue;
            value = newState[key];
            if (typeof value === 'number') {
                delta_value = (value - this._playerState[key]) || 0;
                if (delta_value < 0) {
                    delta_sign = '-';
                }
                if (delta_value >= 0) {
                    delta_sign = '+';
                }
                diff[key] = "" + delta_sign + "," + Math.abs(delta_value) + "," + (this._playerState[key]);
            } else if (typeof value === 'string') {
                diff[key] = value;
            }
        }
        return diff;
    },

    _setCurrentPlayerState: function(pst) {
        var key, value;
        this._playerState = {};
        for (key in pst) {
            if (!__hasProp.call(pst, key)) continue;
            value = pst[key];
            this._playerState[key] = value;
        }
        return true;
    },

    _addEvts: function(msg) {
      var d = new Date(); 
      msg.evts = (60000 * d.getTimezoneOffset()) + d.getTime();
      return msg;
    },
    _addGeo: function(msg) {
        var loc_point;

        if (this._location && (loc_point = this._location.getPosition())  && !isNaN(loc_point.getX()) && !isNaN(loc_point.getY())) {
            msg.geo = "" + loc_point.getX() + "," + loc_point.getY();
        }
        return msg;
    },
    _addCarrier: function(msg) {
        var Capabilities = CapabilitiesReq.Capabilities;
        var carr = Capabilities.getCarrier();
        if (carr) {
            msg.carr = carr;
        }
        return msg;
    },
    _addService: function(msg) {
        var Analytics = require('NGCore/Client/Social').Social.Common.Analytics;
        msg.srvc = Analytics.getServiceId();
        return msg;
    },
    _addPlatformVersion: function(msg) {
        var Analytics = require('NGCore/Client/Social').Social.Common.Analytics;
        msg.pver = Analytics.getPlatformVersion();
        return msg;

    },
    _addSeqDetails: function(msg) {
        this._seqNum += 1;
        msg.seq = this.getSeqNumber();
        msg.seqdt = new Date().getTime() - this._seqStart;
        return msg;
    },
    _addUserId: function(msg) {
      var Analytics = require('NGCore/Client/Social').Social.Common.Analytics;
      var uid = Analytics.getUserId();
      if (uid) {
        msg.uid = uid;
      }
      return msg;
    },
    _addUserName: function(msg) {
      var Analytics = require('NGCore/Client/Social').Social.Common.Analytics;
      var un = Analytics.getUsername();
      if (un) {
        msg.plus = un;
      }
      return msg;
    },
    _addGameSku: function(msg) {
        var app_key = (Capabilities.getConfigs() || {} )["appId"];
        if ( app_key ) {
            msg.asku = app_key;
        }
        return msg;
    },
    _addGameRel: function(msg) {
        var arel = Capabilities.getAppReleaseVersion();
        if (arel) {
          msg.arel = arel;
        }
        return msg;
    },
    _normalizeValues: function(msg) {
        var key, value;
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            if (typeof value === 'string') {
                value = this._normalizeString(key, value);
            } else if (typeof value === 'object') {
                value = this._normalizeValues(value);
            }
            msg[key] = value;
        }
        return msg;
    },

    _normalizeString: function(key, value) {
        value = value.substring(0, this._allowedLargeValue[key] || 32);
        if (-1 !== this._capAlphaNumStringKeys.indexOf(key)) {
            value = value.toUpperCase().replace(/[^\w]+/g, "").replace("_", "");
        }
        return value;
    },

    _mergeMeta: function(msg) {
        var _ref, _ref2, key, new_msg, value;
        new_msg = {};
        for (key in msg) {
            if (!__hasProp.call(msg, key)) continue;
            value = msg[key];
            new_msg[key] = value;
        }
        for (key in _ref = this._meta) {
            if (!__hasProp.call(_ref, key)) continue;
            value = _ref[key];
            (_ref2 = new_msg[key]) ? _ref2 : new_msg[key] = value;
        }
        return new_msg;
    },

    _drainQueue: function() {
        var cb, self, toDrain;
        toDrain = this._getQueue();
        this._setQueue([]);
        self = this;

        if (! this._sendToRemote)
            return true;

        cb = function(state, not_sent) {
            if (state === NgPipesRemote.possibleStates.error) {
                self._queueMany(not_sent);
                self._sendDelay = self._sendDelay * 2;
            } else if (state === NgPipesRemote.possibleStates.finished ) {
                self._sendDelay = 5000;
            }
            return true;
        };
        NgPipesRemote.clearQueue(toDrain, cb);
        toDrain = null; // explicit clear to keep memory down
        return true;
    },

    _queueMany: function(msg_arr) {
        var _i, _len, msg, self = this;
        this._setQueue( (this._getQueue() || [] ).concat(msg_arr) );
        if (this._isSendQueued) {
          this._isSendQueued = true;
          setTimeout(function() {
              self._isSendQueued = false;
              return self._drainQueue();
          }, self._sendDelay);
        }

        return true;
    },
    _setQueue: function(new_queue) {
        this._queue = new_queue;
        Storage.KeyValueCache.global(this._globalKey).setItem(this._globalKey, JSON.stringify(this._queue));
        return true;
    },
    _getQueue: function() {
        return this._queue;

    }
});

exports.NgPipe = NgPipe;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/NgPipesRemote'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] || {}; $MODULE_REGISTRY['NGCore/Shared/NgPipesRemote'] = exports; var Network = require('NGCore/Client/Network').Network;

NgPipesRemote = {
  listeners: [],
  debug: false,

  possibleStates: {
    unknown: {},
    finished: {},
    error: {}
  }
};

NgPipesRemote.addListener = function(listner) {
  this.listeners.push(listner);
  return true;
};

NgPipesRemote.clearQueue = function(queue, callback) {
  var _i, _j, _len, _len2, copy_array, data, copy_array = [];
  if (!queue) {
    return false;
  }

  if (!this.getUrl()) {
    if (callback) {
      callback(NgPipesRemote.possibleStates.finished, []);
    }
    return false;
  }
  for (_i = 0, _len = queue.length; _i < _len; _i++) {
    copy_array.push(queue[_i]);
  }


  while (copy_array && copy_array.length > 0) {
    var to_send = copy_array.slice(0, 10);
    copy_array = copy_array.slice(10);
    data = "";

    for (_j = 0, _len2 = to_send.length; _j < _len2; _j++) {
      data += JSON.stringify(to_send[_j]);
      if (_j+1 < _len2) {
         data += "\r\n";
      } //if len
    } //for

    if (data) {
      NgPipesRemote._makeRequest(data, to_send, callback);
    } //if data
  }//while


}

NgPipesRemote._makeRequest = function(json_data, objs, callback) {
  var request = new Network.XHR(), url = this.getUrl();
  if (this.debug) {
    NgPipesRemote._debugOutput(json_data);
  }
  request.onreadystatechange = function() {
    var status = null;
    try {
      if (this.readyState === 4) {
        status = NgPipesRemote._handleResponse(request.responseText);
      } else {
        status = NgPipesRemote.possibleStates.unknown;
      }
    } catch (ex) {
      status = NgPipesRemote.possibleStates.error;
      NgLogException(ex);
    }

    if (callback) {
      callback(status, objs);
    }

    NgPipesRemote._notifyListeners(status);
    return true;
  };

  request.open("POST", url, true);

  request.setRequestHeader("X-Ngpipes-Api", "1.0");
  request.setRequestHeader("Content-Type", "application/json+batch");
  request.setRequestHeader("If-None-Match", "0");

  request.send(json_data);

  NgPipesRemote._notifyListeners('started');
  return true;
};
NgPipesRemote.setUrl = function(url) {
    this.url = url;
};
NgPipesRemote.getUrl = function() {
    if (this.url)
        return this.url;
    var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
    var url = null;
    
    if (Capabilities) {
      //Get the url from the configuration.json
      url = (Capabilities.getConfigs() || {} )["analyticsServer"] || null;
      if (url) {
        url = "https://"+url+"/pipes/r.2/bulk_record_stats";
        if (this.debug) {
          NgLogD("Pipes URL => " + url );
        }
      }
    }
    return url;
};


NgPipesRemote._handleResponse = function(respText) {
  var respObj, result;
  result = NgPipesRemote.possibleStates.unknown;
  if (respText && respText.length > 0) {
    try {
    respObj = JSON.parse(respText);
    } catch (e) {
      //Clean up after ourselves.
      respObj = null;
    }
	if (respObj  && (respObj.success !== null && respObj.success !== undefined ) && respObj.success) {
      if (this.debug) {
        NgLogD("[NgPipesRemote] Got Success" );
      }
      result = NgPipesRemote.possibleStates.finished;
    } else {
      result = NgPipesRemote.possibleStates.error;
    }
  } else {
      if (this.debug) {
        NgLogD('[NgPipesRemote] ERROR posting');
      }

    result = NgPipesRemote.possibleStates.error;
  }
  return result;
};

NgPipesRemote._debugOutput = function(str) {
  var _i, _len, _result, msg, msgs;
  msgs = str.split("\r\n");
  for (_i = 0, _len = msgs.length; _i < _len; _i++) {
    msg = msgs[_i];
    NgLogD("[NgPipesRemote] Message sent: " + msg);
  }
  return false;
};

NgPipesRemote._notifyListeners = function(state) {
  var _i, _len, _ref, l;
  for (_i = 0, _len = (_ref = this.listeners).length; _i < _len; _i++) {
    l = _ref[_i];
    l(state);
  }
  return true;
};

exports.NgPipesRemote = NgPipesRemote;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sha1'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sha1'] = exports; /*
 * A JavaScript implementation of the Secure Hash Algorithm, SHA-1, as defined
 * in FIPS PUB 180-1
 * Version 2.1a Copyright Paul Johnston 2000 - 2002.
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for details.
 */

/*
 * Configurable variables. You may need to tweak these to be compatible with
 * the server-side, but the defaults work in most cases.
 */
var hexcase = 0;  /* hex output format. 0 - lowercase; 1 - uppercase        */
var b64pad  = ""; /* base-64 pad character. "=" for strict RFC compliance   */
var chrsz   = 8;  /* bits per input character. 8 - ASCII; 16 - Unicode      */

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

/*
 * Perform the appropriate triplet combination function for the current
 * iteration
 */
function sha1_ft(t, b, c, d)
{
  if(t < 20) { return (b & c) | ((~b) & d); }
  if(t < 40) { return b ^ c ^ d; }
  if(t < 60) { return (b & c) | (b & d) | (c & d); }
  return b ^ c ^ d;
}

/*
 * Determine the appropriate additive constant for the current iteration
 */
function sha1_kt(t)
{
  return (t < 20) ?  1518500249 : (t < 40) ?  1859775393 :
         (t < 60) ? -1894007588 : -899497514;
}

/*
 * Calculate the SHA-1 of an array of big-endian words, and a bit length
 */
function core_sha1(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << (24 - len % 32);
  x[((len + 64 >> 9) << 4) + 15] = len;

  var w = Array(80);
  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;
  var e = -1009589776;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;
    var olde = e;

    for(var j = 0; j < 80; j++)
    {
      if(j < 16) { w[j] = x[i + j]; }
      else {
		w[j] = rol(w[j-3] ^ w[j-8] ^ w[j-14] ^ w[j-16], 1);
	  }
      var t = safe_add(safe_add(rol(a, 5), sha1_ft(j, b, c, d)),
                       safe_add(safe_add(e, w[j]), sha1_kt(j)));
      e = d;
      d = c;
      c = rol(b, 30);
      b = a;
      a = t;
    }

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
    e = safe_add(e, olde);
  }
  return Array(a, b, c, d, e);

}

/*
 * Convert an 8-bit or 16-bit string to an array of big-endian words
 * In 8-bit function, characters >255 have their hi-byte silently ignored.
 */
function str2binb(str)
{
  var bin = Array();
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < str.length * chrsz; i += chrsz) {
    bin[i>>5] |= (str.charCodeAt(i / chrsz) & mask) << (32 - chrsz - i%32);
  }
  return bin;
}

/*
 * Calculate the HMAC-SHA1 of a key and some data
 */
function core_hmac_sha1(key, data)
{
  var bkey = str2binb(key);
  if(bkey.length > 16) {
	bkey = core_sha1(bkey, key.length * chrsz);
  }

  var ipad = Array(16), opad = Array(16);
  for(var i = 0; i < 16; i++)
  {
    ipad[i] = bkey[i] ^ 0x36363636;
    opad[i] = bkey[i] ^ 0x5C5C5C5C;
  }

  var hash = core_sha1(ipad.concat(str2binb(data)), 512 + data.length * chrsz);
  return core_sha1(opad.concat(hash), 512 + 160);
}

/*
 * Convert an array of big-endian words to a string
 */
function binb2str(bin)
{
  var str = "";
  var mask = (1 << chrsz) - 1;
  for(var i = 0; i < bin.length * 32; i += chrsz) {
    str += String.fromCharCode((bin[i>>5] >>> (32 - chrsz - i%32)) & mask);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a hex string.
 */
function binb2hex(binarray)
{
  var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i++)
  {
    str += hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8+4)) & 0xF) +
           hex_tab.charAt((binarray[i>>2] >> ((3 - i%4)*8  )) & 0xF);
  }
  return str;
}

/*
 * Convert an array of big-endian words to a base-64 string
 */
function binb2b64(binarray)
{
  var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  var str = "";
  for(var i = 0; i < binarray.length * 4; i += 3)
  {
    var triplet = (((binarray[i   >> 2] >> 8 * (3 -  i   %4)) & 0xFF) << 16) |
                  (((binarray[i+1 >> 2] >> 8 * (3 - (i+1)%4)) & 0xFF) << 8 ) |
                   ((binarray[i+2 >> 2] >> 8 * (3 - (i+2)%4)) & 0xFF);
    for(var j = 0; j < 4; j++)
    {
      if(i * 8 + j * 6 > binarray.length * 32){
		str += b64pad;
	  } else {
		str += tab.charAt((triplet >> 6*(3-j)) & 0x3F);
	  }
    }
  }
  return str;
}

/*
 * These are the functions you'll usually want to call
 * They take string arguments and return either hex or base-64 encoded strings
 */
function hex_sha1(s){return binb2hex(core_sha1(str2binb(s),s.length * chrsz));}
function b64_sha1(s){return binb2b64(core_sha1(str2binb(s),s.length * chrsz));}
function str_sha1(s){return binb2str(core_sha1(str2binb(s),s.length * chrsz));}
function str_hmac_sha1(key, data){ return binb2str(core_hmac_sha1(key, data));}
function hex_hmac_sha1(key, data){ return binb2hex(core_hmac_sha1(key, data));}
function b64_hmac_sha1(key, data, padChar){
	if ((typeof padChar != "undefined") && padChar) {
        b64pad = padChar;
	}
	return binb2b64(core_hmac_sha1(key, data));
}

/*
 * Perform a simple self-test to see if the VM is working
 */
function sha1_vm_test()
{
  return hex_sha1("abc") == "a9993e364706816aba3e25717850c26c9cd0d89d";
}

// Exports for node.js
if((typeof exports != "undefined") && exports)
{
	exports.b64_hmac_sha1 = b64_hmac_sha1;
	exports.hex_sha1 = hex_sha1;
	exports.b64_sha1 = b64_sha1;
}
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social'] || {}; $MODULE_REGISTRY['NGCore/Client/Social'] = exports; /**
 * Public API for GameService
 * 
 * Access this file as NGCore/Client/Social.js
 */

// Note the proper require path for our public interface files is: "./Social/US/[filename]"

/** @namespace
 * @name Social
 * @description
 * The <code>Social</code> namespace provides interfaces for the Mobage Social APIs.
 */
exports.Social = {
};

/** @namespace
 * @name Social.Common
 * @description
 * The <code>Social.Common</code> namespace provides interfaces for functionality common to submodules for Japan (JP), the United States (US), 
 * and future submodules. The common features include Auth, People, Appdata, Blacklist, Profanity and Service. Service APIs can be both common
 * or native, and include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.Common = {
	Appdata: require('NGCore/Client/Social/US/Common/Appdata').Appdata,
	Auth: require('NGCore/Client/Social/US/Common/Auth').Auth,
	Blacklist: require('NGCore/Client/Social/US/Common/Blacklist').Blacklist,
	Config: require('NGCore/Client/Social/US/Common/Config').Config,
	People: require('NGCore/Client/Social/US/Common/People').People,
	Profanity: require('NGCore/Client/Social/US/Common/Profanity').Profanity,
	Request: require('NGCore/Client/Social/US/Common/Request').Request,
	Service: require('NGCore/Client/Social/US/Common/Service').Service,
  Analytics: require('NGCore/Client/Social/US/Common/Analytics').Analytics
};

/** @namespace
 * @name Social.US
 * @description
 * The <code>Social.US</code> namespace provides interfaces for the United States (US) submodule. 
 * The features include User, Game, Leaderboard, Score, Ordered List, and AppData.
 */
exports.Social.US = {
	// Data Models
	DataModel: require('NGCore/Client/Social/US/Models/DataModel').DataModel,
	User: require('NGCore/Client/Social/US/Models/User').User,
	Game: require('NGCore/Client/Social/US/Models/Game').Game,
	Leaderboard: require('NGCore/Client/Social/US/Models/Leaderboard').Leaderboard,
	Score: require('NGCore/Client/Social/US/Models/Score').Score,
	
	AppData: require('NGCore/Client/Social/US/Models/AppData').AppData,
	
	// Data Cache
	Cache: require('NGCore/Client/Social/US/Models/Cache').Cache,

	// Data APIs
	Session: require('NGCore/Client/Social/US/Data/Session').Session,
	Dispatcher: require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher
};

/** @namespace
 * @name Social.US.Service
 * @description
 * Service APIs include the Community button, the Balance button, the Friend Picker, the User Finder, and the User Profile.
 */
exports.Social.US.Service = {
	Friends: require('NGCore/Client/Social/US/Service/Friends').Friends,
	Profile: require('NGCore/Client/Social/US/Service/Profile').Profile,
	ButtonOverlays: require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays,
	GameLaunchPayload: require('NGCore/Client/Social/US/Service/GameLaunchPayload').GameLaunchPayload
};

/** @namespace
 * @name Bank
 * @description
 * The <code>Bank</code> namespace provides interfaces for the Mobage Bank APIs.
 */
exports.Bank = require('NGCore/Client/Social/US/Service/Bank').Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network'] || {}; $MODULE_REGISTRY['NGCore/Client/Network'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////
/**
 * @name Network
 * @namespace
 * <p>Classes and objects contained by the Network module.</p>
 * @description <p>The Network module is a collection of classes that support manipulation of network flow.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Network.DownloadFile}</code>: Construct objects that conduct a file download.</li>
 *<li><code>{@link Network.DownloadManifest}</code>: Construct objects that keep manifests up-to-date.</li>
 *<li><code>{@link Network.XHR}</code>: Construct XmlHttpRequest objects.</li>
 *</ul>
 */
exports.Network =
{
	XHR: require('NGCore/Client/Network/XHR').XHR,
	DownloadFile: require('NGCore/Client/Network/DownloadFile').DownloadFile,
	DownloadManifest: require('NGCore/Client/Network/DownloadManifest').DownloadManifest,
	Util: require('NGCore/Client/Network/Util').Util,
	_int_Util: require('NGCore/Client/Network/_int_Util')._int_Util
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/XHR'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/XHR'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/XHR'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class XHR
// XMLHttpRequest implementation
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Class = require('NGCore/Client/Core/Class').Class;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Util = require('NGCore/Client/Network/Util').Util;
var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;

////////////////////////////////////////////////////////////////////////////////

var Header = function (item, content)
{
	this.item = item;
	this.content = content;
}
var headerEx = /(.*?): (.*)/

/**
 * Constants
 */
var State =
{
	UNSENT: 0,
	OPENED: 1,
	HEADERS_RECEIVED: 2,
	LOADING: 3,
	DONE: 4,
};

// ///////////// Begin HTTP req'd methods of testing! //////
var methods =
[
	"OPTIONS",
	"GET",
	"HEAD",
	"POST",
	"PUT",
	"DELETE",
	"TRACE",
	"CONNECT"
];

var unsecureMethods = ["CONNECT", "TRACE", "TRACK"];

var checkMethod = function(method)
{
	if(!method) return "GET";

	method = method.toString();

	if (method in unsecureMethods)
	{
		throw "SECURITY_ERROR " + method + " not allowed."
	}
	if (method.toUpperCase() in methods)
	{
		return method.toUpperCase();
	}
	return method;
}

// ////////////////////////// End! /////////////////////

////////////////////////////////////////////////////////////////////////////////

exports.XHR = Class.subclass(
/** @lends Network.XHR.prototype */
{
	classname: 'XHR',
	
	/**
	 * @class The <code>XHR</code> class constructs <code>XmlHttpRequest</code> objects. Applications can use these objects to
	 * send HTTP or HTTPS requests directly to a web server and load the server response data directly back into a script.
	 * @constructs The default constructor. 
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/">Official W3C XmlHttpRequest specification</a>
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this.request;
		this.respHeaders = {};

		this.settings = {};
		this.headers = [];

		// State-associated flags
		this.sendFlag = false;
		this.errorFlag = false;
		
		// Status & response
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.status = 0;
		this.statusText = "";
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 340
	// Method create = -1
	// Method destroy = 2
	// Method sendStatus = 3
	// Method sendHeaders = 4
	// Method sendData = 5
	// Method onFinish = 6
	// Method start = 7
	// Method header = 8
	// Method setComposition = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._sendStatusRecv( cmd );
					break;
				case 4:
					instance._sendHeadersRecv( cmd );
					break;
				case 5:
					instance._sendDataRecv( cmd );
					break;
				case 6:
					instance._onFinishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in XHR._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[340] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendStatusRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statNum" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "statNum" ] === undefined )
		{
			NgLogE("Could not parse statNum in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		obj[ "statStr" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "statStr" ] === undefined )
		{
			NgLogE("Could not parse statStr in XHR.sendStatus from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendHeadersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		obj[ "headers" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "headers" ] === undefined )
		{
			NgLogE("Could not parse headers in XHR.sendHeaders from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_sendDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.sendData from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in XHR.sendData from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onFinishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in XHR.onFinish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 340 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 340 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_startSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 340 + "," + 7 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "method" ] ) + "," + Core.Base64.encode( obj[ "url" ] ) + "," + Core.Base64.encode( obj[ "data" ] ) + "," + obj[ "headers" ]  );
	},
	
	/** @private */
	_headerSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( obj[ "item" ] ) + "," + Core.Base64.encode( obj[ "content" ] )  );
	},
	
	/** @private */
	_setCompositionSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 340 + "," + 9 + "," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _sendStatusRecv: function( cmd ) {}
	// _sendHeadersRecv: function( cmd ) {}
	// _sendDataRecv: function( cmd ) {}
	// _onFinishRecv: function( cmd ) {}
	// start: function( method, url, data, headers ) {}
	
	// header: function( item, content ) {}
	
	// setComposition: function(  ) {}
	

// {{/Wg Generated Code}}

// API
	/**
	 * Initialize a request for this <code>XHR</code>.
	 *
	 * <b>Note:</b> Calling <code>open()</code> will wipe all request headers. You must set them after making this call.
	 *
	 * @param {String}
	 *            method The request method 
	 * 		(<code>GET</code>, <code>POST</code>, <code>OPTIONS</code>, <code>HEAD</code>,  
	 *		<code>PUT</code>, <code>DELETE</code>, <code>TRACE</code>, <code>CONNECT</code>)
	 * @param {String}
	 *            url The request URL.
	 * @param {Boolean}
	 *            [async=true] Returns <code>true</code> if the request is synchronous. Returns <code>false</code> in all other cases.<br><br> 
	 * 		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [user] Username for basic authentication.<br><br> 
	 *		<b>Note:</b> Currently not implemented.
	 * @param {String}
	 *            [password] Password for basic authentication.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	open: function(method, url, async, user, password)
	{
		url = url.split(' ').join('%20');
		this.settings =
		{
			"method": checkMethod(method),
			"url": Util.NormalizeUrl(url),
			"async": async,
			"user": user,
			"password": password
		};

		// Check URL and set XHR flag appropriately
// 		var localServer = Caps.getServer();
// 		if (localServer == url.substr(0, localServer.length) && Caps.getPlatformOS() == "Android")
// 		{
// 			this.NXS = true;
// 		}

		if (this.me && this.sendFlag)
		{
			http.abort(this.me);
		}
		this.reset();
		this.setState(State.OPENED);
	},

	/**
	* @ private
	* Send a request initialized by the <code>open()</code> method. 
	* @param {Array} [composition] Array of strings and file names to be composed into the body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android
	*/

	sendComposition: function(comp)
	{
		// ex: [{"str":"string to send"},{"file":"path/to/file.bin"},{"str":"more goods"}]
		this.composing = true;
		this.send(JSON.stringify(comp));
	},

	/**
	* Send a request initialized by the <code>open()</code> method.
	* @param {String} [data] The request entity body.<br><br>
	* <b>Note:</b> This parameter is ignored if <code>readyState</code> is set as <code>GET</code> or <code>HEAD</code>.
	* @throws {INVALID_STATE_ERR} If <code>readyState</code> is set as anything other than <code>OPENED</code> or if the <code>send()</code> flag is true.
	* @see Network.XHR#open
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	send: function(data)
	{
		if (this.readyState != State.OPENED || this.sendFlag)
		{
			throw "INVALID_STATE_ERR: " + (this.sendFlag ? "Already sending" : "in state " + this.readyState);
		}
		this.sendFlag = true;

		if (data && this.settings.method != "GET" && this.settings.method != "HEAD")
		{
			// TODO http://www.w3.org/TR/XMLHttpRequest/#the-send-method step 3
		}

		this.errorFlag = false;

		// Set content length header
		if (this.settings.method == "GET" || this.settings.method == "HEAD")
		{
			data = null;
		}
		else if (data)
		{
			var bFound = false;
			for (var i in this.headers)
			{
				if (this.headers[i].item == "Content-Type")
				{
					bFound = true;
					break;
				}
			}
			if (!bFound)
			{
				this.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
			}
		}

		this.responseText = "";

		// Send data to the server
		if (!data)
		{
			data = "";
		}

		ObjectRegistry.register(this);
		this._createSendGen(this);

/* Not supporting NXS. Could remove it, but maybe we will support it one day */
		if (this.NXS)
		{
			this.me = http.create(this);
			for (var i in this.headers)
			{
				var h = this.headers[i];
				http.addHeader(this.me, h.item + ": " + h.content);
			}
			http.send(this.me, this.settings.method, this.settings.url, data);
		}
		else
		{
			var obj = {};
			obj.method = this.settings.method;
			obj.headers = this.headers.length;
			obj.url = this.settings.url;
			obj.data = data;

			if (this.composing)
				this._setCompositionSendGen();

			this._startSendGen(obj);
			for (var i in this.headers)
			{
				var obj = this.headers[i];
				this._headerSendGen(obj);
			}
		}
	}, // this.send() 

	/**
	 * Cancel any existing or pending network activity for this <code>XHR</code>. 
	 * This method is invoked using the specification outlined by W3C.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-abort-method">W3C specification outline for <code>abort()</code></a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	abort: function()
	{
		this.responseText = null;
		this.errorFlag = true;
		this.headers = [];

		if (this.sendFlag)
		{
			if (this.NXS)
			{
				http.abort(this.me);
			}

			if (this.readyState != State.DONE)
			{
				this.sendFlag = false;
				this.setState(State.DONE);
			}
		}
		this.readyState = State.UNSENT;
	},

	/**
	 * Retrieve a header from the server response.
	 *
	 * @param {String}
	 *            header Name of header to retrieve.
	 * @returns {String} Text of the header or <code>null</code> if text does not exist.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getResponseHeader: function(header)
	{
		if (this.readyState > State.OPENED)
		{
			return this.respHeaders[header.toLowerCase()];
		}
		return null;
	},

	/**
	 * Nonstandard: Retrieve the key-value map of all response headers.
	 *
	 * @return {Object} A key-value map as an object.
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getUnflattenedResponseHeaders: function()
	{
		return this.respHeaders;
	},

	/**
	 * Retrieve all the response headers from a request.
	 * This method is invoked using the specification outlined by W3C.
	 * @return {String} All the response headers from a request.
	 * @see <a href="http://www.w3.org/TR/XMLHttpRequest/#the-getallresponseheaders-method">W3C specification outline for <code>getAllResponseHeaders()</code>.</a>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getAllResponseHeaders: function()
	{
		if (this.readyState < State.HEADERS_RECEIVED || this.errorFlag)
		{
			return "";
		}

		var result = "";
		for (var i in this.respHeaders)
		{
			result += i + ": " + this.respHeaders[i] + "\r\n";
		}
		return result.substr(0, result.length - 2);
	},

	/**
	 * Set a header for the request.
	 *
	 * @param {String}
	 *            header The name of the header.
	 * @param {String}
	 *            value The value of the header.
	 * @see Network.XHR#getRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setRequestHeader: function(header, value)
	{
		this.headers.push(new Header(header, value));
	},

	/**
	 * Retrieve a header from the request.
	 *
	 * @param {String} header The name of the header.
	 * @return {String} The value of the header.
	 * @see Network.XHR#setRequestHeader
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getRequestHeader: function(header)
	{
		var ret = null;
		for (var i in this.headers)
		{
			if (this.headers[i].item == header)
			{
				ret = this.headers[i].content;
				break;
			}
		}
		return ret;
	},

// Receivers
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onStatus: function ( num, str)
	{
		this.status = num;
		this.statusText = str;
	},

	_sendStatusRecv: function( cmd )
	{
		var obj = {};
		this._sendStatusRecvGen(cmd, obj);
		this.onStatus(obj.statNum, obj.statStr);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onHeaders: function(str)
	{
		var lines = str.split('\n');
		lines.pop();
		for (var i in lines)
		{
			var match = headerEx.exec(lines[i]);
			if (match)
				this.respHeaders[match[1].toLowerCase()] = match[2];
		}
		this.setState(State.HEADERS_RECEIVED);
	},

	_sendHeadersRecv: function( cmd )
	{
		var obj = {};
		this._sendHeadersRecvGen(cmd, obj);
		this.onHeaders(obj.headers);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onData: function(data)
	{
		this.responseText += data;
		this.setState(State.LOADING);
	},

	_sendDataRecv: function( cmd )
	{
		var obj = {};
		this._sendDataRecvGen(cmd, obj);
		this.onData(obj.data);
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	onFinish: function (err)
	{
		this.sendFlag = false;
		if (err)
		{
			this.responseText = null;
			this.error = "Network Error";
			this.errorFlag = true;
			this.status = 0;
		}
		this.setState(State.DONE);
	},

	_onFinishRecv: function( cmd )
	{
		var obj = {};
		this._onFinishRecvGen(cmd, obj);
		this.onFinish(obj.error);
	},

// Internal methods
	/**
	 * Reset all fields from a request. This call sets <code>readyState</code> to <code>UNSENT</code> 
	 * and the response properties to <code>null</code>.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	reset: function()
	{
		this.headers = [];
		this.readyState = State.UNSENT;
		this.responseText = null;
		this.responseXML = null;
		this.composing = false;
	},
	/**
	 * Change the value of <code>readyState</code> and call <code>onreadystatechange()</code>.
	 *
	 * @param {Number}
	 *            state The new value for <code>readyState</code>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setState: function(state)
	{
		this.readyState = state;
		if (state == State.DONE)
		{
			this._destroySendGen();
			ObjectRegistry.unregister(this);
		}
		if (typeof this.onreadystatechange != 'undefined')
		{
			try
			{
				this.onreadystatechange();
			}
			catch (e)
			{
				NgLogException(e);
			}
		}
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/DownloadFile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/DownloadFile'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class DownloadFile
// Downloads a file to the sandbox
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.DownloadFile = Class.subclass(
/** @lends Network.DownloadFile.prototype */
{
	classname: 'DownloadFile',
	/**
	* @class The <code>DownloadFile</code> class constructs objects that conduct a file download through an HTTP request.
	* @constructs The default constructor. 
	* @augments Core.Class
	*/
	initialize: function() {},

	/**
	  * Initiate a file download.
	  * @example var url = 'http://url/to/stuff/
	  * new Network.DownloadFile).start(filename, 'GET', url, [], (function(status, md5)
	  * @param {String} filename A local and relative path for storing the downloaded data.
	  * @param {String} method The HTTP method to use.  For example, <code>GET</code> or <code>POST</code>.
	  * @param {String} url The URL of the downloaded file.
	  * @param {Object} [headers] A dictionary that maps header names to header values.
	  * @param {Function} [callback] A callback function for notification
	  * of when the download completes. The signature for the callback is equivalent
	  * to:<br><br>
	  * <pre>function(statusCode,fileSignature)</pre><br>
	  * The <code>fileSignature</code> is currently the
	  * md5 checksum of the file.
	  * @type void
      * @status iOS, Android, Test, iOSTested, AndroidTested
	  */
	start: function(filename, method, url, headers, callback)
	{
		ObjectRegistry.register(this);
		this._createSendGen(this);

		url = url.split(' ').join('%20');
		// Check headers
		if (!(headers instanceof Array))
		{
			NgLogE('Improper headers sent('+headers+'). Need an array, ex: ["Content-Easter: egg"]');
			headers = [];
		}

		var send =
		{
			fileName: filename,
			method: method,
			url: url,
			headers: headers.length
		};

		// Send the goods
		this.__sendSendGen(send);

		// Send headers
		for (var i in headers)
		{
			var obj = headers[i];
			this.__headerSendGen(obj);
		}

		// Save the callback
		this.mCB = callback
	},

	abort: function()
	{
		this._destroySendGen();
		ObjectRegistry.unregister(this);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 341
	// Method create = -1
	// Method destroy = 2
	// Method _send = 3
	// Method _header = 4
	// Method finish = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._finishRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in DownloadFile._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[341] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_finishRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in DownloadFile.finish from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 341 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 341 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	__sendSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 341 + "," + 3 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "fileName" ] ) + "," + Core.Base64.encode( obj[ "method" ] ) + "," + Core.Base64.encode( obj[ "url" ] ) + "," + obj[ "headers" ]  );
	},
	
	/** @private */
	__headerSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( obj[ "item" ] ) + "," + Core.Base64.encode( obj[ "content" ] )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// _send: function( fileName, method, url, headers ) {}
	
	// _header: function( item, content ) {}
	
	// _finishRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	
	_finishRecv: function( cmd )
	{
		this._destroySendGen();
		
		var obj = {};
		this._finishRecvGen(cmd, obj);

		if (this.mCB)
			this.mCB(obj.status, obj.signature);

		ObjectRegistry.unregister(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/Util'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Utilities for Network
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Caps = require('NGCore/Client/Core/Capabilities').Capabilities;
var Time = require('NGCore/Client/Core/Time').Time;
var LifecycleEmitter = require('NGCore/Client/Device/LifecycleEmitter').LifecycleEmitter;

////////////////////////////////////////////////////////////////////////////////

var urlPathServerSplit = /^(https?:\/\/)?([^\/]*)(.*[^\/])?.?/i;

exports.Util =
{
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	NormalizeUrl: function(url)
	{
		// If the path is relative, then we append our server to the beginning of it
		if (url.charAt(0) == '/' || !url.length)
		{
			url = Caps.getServer() + url;
		}
		// Now split it into parts and make server bits lower case
		var parsed = url.match(urlPathServerSplit);
		if (parsed)
		{
			if (parsed[1])
			{
				// absolute path!
				url = parsed[1].toLowerCase() + parsed[2].toLowerCase() + (parsed[3] ? parsed[3] : "");
			}
			else
			{
				url = Caps.getServer() + "/" + Caps.getGame() + "/" + url;
			}
		}
		else
		{
			// Direct server, no path
			url = url.toLowerCase();
		}
		return url;
	},
	
	RetrySchedule: function(initialRetry, maxDuration)
	{
		var count = Math.floor(Math.log(maxDuration / initialRetry));
		var schedule = [initialRetry];
		for(var i=0; i < count + 1; ++i)
		{
			initialRetry *= 2;
			schedule.push(initialRetry);
		}
		return schedule;
	},
	
	OperationWithRetries: function(operationCb, failureCb, failEarly)
	{
		var abortAttempts;
		var abortTime;
		var abortTimeAttempts;
		
		if(failEarly)
		{
			abortAttempts = 3;
			abortTime = 10000;
			abortTimeAttempts = 1;
		}
		else
		{
			abortAttempts = Infinity;
			abortTime = 30000;
			abortTimeAttempts = 6;
		}
		
		// console.log('retry config abortAttempts:', abortAttempts, 'abortTime', abortTime, 'abortTimeAttempts', abortTimeAttempts);
		
		abortTime = Core.Time.getRealTime() + abortTime;
		var timeout = 250;
		var attemptCount = 1;
		
		var failed = false;
		var armed = true;
		
		var failureParam = function()
		{
			if(failed) return;
			
			if(!armed)
			{
				console.log('OperationWithRetries: failureParam called when not armed');
				return;
			}
			armed = false;
			
			if(attemptCount >= abortAttempts)
			{
				console.log('OperationWithRetries: too many retry attempts');
				var failed = true;
				failureCb();
				return;
			}
			
			if(Core.Time.getRealTime() >= abortTime && attemptCount >= abortTimeAttempts)
			{
				console.log('OperationWithRetries: retries took too long');
				console.log('OperationWithRetries: abortTime:', abortTime, 'realTime:', Core.Time.getRealTime());
				console.log('OperationWithRetries: attemptCount:', attemptCount, 'abortTimeAttempts:', abortTimeAttempts);
				var failed = true;
				failureCb();
				return;
			}
			
			console.log('OperationWithRetries: Failure, will retry in ' + timeout + 'ms');
			setTimeout(function()
			{
				if(failed) return;
				armed = true;
				operationCb(failureParam, abortParam);
			}, timeout);
			
			attemptCount += 1;
			timeout *= 2;
		}
		
		var abortParam = function()
		{
			var failed = true;
			failureCb();
		}
		
		operationCb(failureParam, abortParam);
		
		return abortParam;
	},
	
	showFatalErrorDialog: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("Exit")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
			LifecycleEmitter.exitProcess();
		};
		
		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': "File location has changed (302)",
			'400': "Bad request to server (400)",
			'401': "Authorization failed (401)",
			'403': "Server permissions error (403)",
			'404': "Resource not found (404)",
			'408': "Request timed out (408)",
			'500': "Internal server error (500)",
			'501': "Cannot process request (501)",
			'502': "Bad Gateway (502)",
			'503': "Service overloaded / down for maintenance (503)",
			'504': "Timeout at intervening gateway (504)",
		};
		myAlert.setText( Core.Localization.getString( commonErrors[status] || "This application requires a working data connection." ) );
		myAlert.show();
	},

	showSimpleNetworkError: function(status)
	{
		// Set up info dialog
		var myAlert = new AlertDialog();
		myAlert.setTitle(Core.Localization.getString("Network failure"));
		myAlert.setChoices([Core.Localization.getString("OK")]);

		myAlert.onchoice =
		function(ret)
		{
			myAlert.hide();
		};

		// TODO: Move this list somewhere localizable
		var commonErrors = {
			'302': " File location has changed (302)",
			'400': " Bad request to server (400)",
			'401': " Authorization failed (401)",
			'403': " Server permissions error (403)",
			'404': " Resource not found (404)",
			'408': " Request timed out (408)",
			'500': " Internal server error (500)",
			'501': " Cannot process request (501)",
			'502': " Bad Gateway (502)",
			'503': " Service overloaded / down for maintenance (503)",
			'504': " Timeout at intervening gateway (504)",
		};
		var message = "Cannot download game without network connection.";
		if (commonErrors[status])
		{
			message += commonErrors[status];
		}
		myAlert.setText( Core.Localization.getString( message ) );
		myAlert.show();
	},
	
	getCacheBustingString: function()
	{
		return '?t=' + (new Date()).getTime();
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Network/_int_Util'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] || {}; $MODULE_REGISTRY['NGCore/Client/Network/_int_Util'] = exports; ///////////////////////////////////////////////////////////////////////////////
// Class _int_Util
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;
////////////////////////////////////////////////////////////////////////////////

exports._int_Util = Class.singleton(
/** @lends Network._int_Util.prototype */
{
	classname: '_int_Util',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._callbackID = 0;
		this._callbacks = [];

		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 350
	// Method create = -1
	// Method destroy = 2
	// Method sign = 3
	// Method signCallback = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._signCallbackRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_Util._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[350] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_signCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signature" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signature" ] === undefined )
		{
			NgLogE("Could not parse signature in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in _int_Util.signCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 350 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 350 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_signSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 350 + "," + 3 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "baseString" ] ) + "," + obj[ "callbackID" ] + "," + Core.Base64.encode( obj[ "environment" ] )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// sign: function( baseString, callbackID, environment ) {}
	
	// _signCallbackRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	sign: function( baseString, environment, callback) {
		this._callbacks[this._callbackID] = callback;
		this._signSendGen({
			"baseString" : baseString,
			"environment" : environment,
			"callbackID" : this._callbackID
		});
		this._callbackID++;
	},
	_signCallbackRecv: function( cmd ) {
		var msg = {};
		if (! this._signCallbackRecvGen(cmd, msg)) {
			return;
		}
		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.signature);
		}
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LifecycleEmitter'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Proc = require('NGCore/Client/Core/Proc').Proc;

exports.LifecycleEmitter = MessageEmitter.singleton(
/** @lends Device.LifecycleEmitter.prototype */
{
	classname: 'LifecycleEmitter',
		
	/**
	 * @class The <code>LifecycleEmitter</code> class constructs a singleton object that emits <code><a href="Device.LifecycleEmitter.html#Event">Event</a></code> 
	 * objects when device lifecycle events occur.
	 * Applications can respond to these events by notifying external sources. For example,
	 * an application can respond to a <code>Terminate</code> event by writing an analytics log.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		ObjectRegistry.register(this);
		this._createSendGen(this);
		/** @private */
		this.identificationCache = {};
		this.uniqueEngineIDs = 0;
		this.numEngineRequests = 0;
	},
	
	_lifecycleEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._lifecycleEventRecvGen(cmd, msg))
			return;
			
		this.emit(msg.event);
		//Cascade the original message back out to native for forwarding
		//	to the next interpreter in the chain.
		this._lifecycleEventSendGen(msg);
	},

	/** @private */
	$exitProcess: function()
	{
		this._exitProcessSendGen();
	},

	/** @private */
	$pauseGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Pausing Game");
		this._pauseGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._pausingGame();
	},

	/** @private */
	$resumeGame: function()
	{
		NgLogD("+++++++++++++++++++++++++++++++++++++++++Resuming Game");
		this._resumeGameSendGen();
		var _lgl = require('NGCore/Client/Core/_LocalGameList')._LocalGameList;
		_lgl._resumingGame();
	},

	requestEngineKeepAlive: function(obj)
	{
		if(obj.identification_key === undefined){
			NgLogD("Attempted to keep engine alive without a valid identification key... Request Ignored");
		}else{
			NgLogD("Got a request to keep engine alive with identification value :" + obj.identification_key);
			
			//Store identification key and increment request to engine
			this.identificationCache[obj.identification_key] = this.uniqueEngineIDs;
			++this.uniqueEngineIDs;
			++this.numEngineRequests;
			this.incrementEngineAlive();
		}
	},
	
	cancelEngineKeepAlive: function(obj)
	{
		if(obj.identification_key === undefined){
			NgLogD("Attempted to keep engine alive without a valid identification key... Request Ignored");
		}else{
			NgLogD("Cancel engine alive with identification value :" + obj.identification_key);
			
			if(this.identificationCache[obj.identification_key] !== null){
				NgLogD("Identification Key found");
				//Store identification key and increment request to engine
				this.identificationCache[obj.identification_key] = null;
				--this.numEngineRequests;
				this.decrementEngineAlive();
			}else{
				NgLogD("Identification Key not found");
			}
		}
	},

	incrementEngineAlive: function()
	{
		this._incrementEngineAliveSendGen();
	},
	
	decrementEngineAlive: function()
	{
		this._decrementEngineAliveSendGen();
	},
	
	cancelAllEngineRequests: function()
	{
		this._cancelAllEngineRequestsSendGen();
	},

	_killGameProc: function( )
	{
		this.__killGameProcSendGen();
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration values for lifecycle events.
	 * @fieldOf Device.LifecycleEmitter.prototype
	 */
	Event:
	{ 
		/** Application is being suspended. */
		Suspend: 0,
		/** Application is being resumed. */
		Resume: 1,
		/** Application is being terminated. */
		Terminate: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 334
	// Method create = -1
	// Method lifecycleEvent = 2
	// Method exitProcess = -3
	// Method pauseGame = -4
	// Method resumeGame = -5
	// Method incrementEngineAlive = 6
	// Method decrementEngineAlive = 7
	// Method cancelAllEngineRequests = 8
	// Method _killGameProc = -9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._lifecycleEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LifecycleEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[334] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_lifecycleEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		obj[ "event" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "event" ] === undefined )
		{
			NgLogE("Could not parse event in LifecycleEmitter.lifecycleEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 334 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_lifecycleEventSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 334 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "event" ]  );
	},
	
	/** @private */
	$_exitProcessSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 334 + "," + -3  );
	},
	
	/** @private */
	$_pauseGameSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 334 + "," + -4  );
	},
	
	/** @private */
	$_resumeGameSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 334 + "," + -5  );
	},
	
	/** @private */
	_incrementEngineAliveSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 334 + "," + 6 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_decrementEngineAliveSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 334 + "," + 7 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_cancelAllEngineRequestsSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 334 + "," + 8 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	$__killGameProcSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 334 + "," + -9  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _lifecycleEventRecv: function( cmd ) {}
	// lifecycleEvent: function( event ) {}
	
	// $exitProcess: function(  ) {}
	
	// $pauseGame: function(  ) {}
	
	// $resumeGame: function(  ) {}
	
	// incrementEngineAlive: function(  ) {}
	
	// decrementEngineAlive: function(  ) {}
	
	// cancelAllEngineRequests: function(  ) {}
	
	// $_killGameProc: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageEmitter'] = exports; var Class = require('NGCore/Shared/Class').Class;
var MessageListener = require('NGCore/Shared/MessageListener').MessageListener;

exports.MessageEmitter = Class.subclass(
/** @lends Core.MessageEmitter.prototype */
{
	classname: 'MessageEmitter',
	
	/**
	 * @status iOS, Android, Flash
	 * @class The <code>MessageEmitter</code> class constructs emitter objects that send messages to registered <code>{@link Core.MessageListener}</code> objects. 
	 * When a defined condition triggers an emitter, all registered listener objects are in turn triggered.
	 * <br><br>
	 * Emitter objects support two communication modes: emit and chain. When emitting, each listener is called in turn.
	 * When chaining, each listener can halt the propagation of a message to 
	 * other listeners by returning <code>true</code> from their callback.
	 * <br><br>
	 * Each listener can include an optional priority ranking. Priority determines the order
	 * in which an emitter calls each listener. 
	 * If two listener objects are registered with the same priority, the emitter calls them in the order they were registered. 
	 * The default priority is <code>0</code>. 
	 * <br><br>
	 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>MessageEmitter</code> for instantiation. This includes:
	 * <div class="ul">
	 * <li>{@link Core.Localization}</li>
	 * <li>{@link Core.UpdateEmitter}</li>
	 * <li>{@link Device.KeyEmitter}</li>
	 * <li>{@link Device.LifecycleEmitter}</li>
	 * <li>{@link Device.LocationEmitter}</li>
	 * <li>{@link Device.MemoryEmitter}</li>
	 * <li>{@link Device.MotionEmitter}</li>
	 * <li>{@link Device.NetworkEmitter}</li>
	 * <li>{@link Device.OrientationEmitter}</li>
	 * <li>{@link Device.ShakeEmitter}</li>
	 * </div>
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._messageListenersCount = 0;
		this._messageListenerRecords = [];
		this._messageDeferredWork = [];
		this._messageShouldDefer = false;
	},
	
	/**
	 * Unregister all <code>MessageListener</code> objects from this <code>MessageEmitter</code>.<br><br>
	 * <b>Note:</b> Do not use the emitter after calling this.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function($super)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._destroyActual.bind(this, $super));
		}
		else
		{
			this._destroyActual($super);
		}
	},
	
	_destroyActual: function(superDestroy)
	{
		// Unregister all listeners.
		var records = this._messageListenerRecords;
		while(records.length)
		{
			this.removeListener(records[0].l);
		}
		
		if(superDestroy)
			superDestroy();
	},
	
	/**
	 * Retrieve the number of <code>MessageListener</code> objects registered with this <code>MessageEmitter</code>.
	 * @returns {Number} The current number of <code>MessageListener</code> objects.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getListenerCount: function()
	{
		return this._messageListenersCount;
	},
	
	/**
	 * Add a <code>MessageListener</code> to this <code>MessageEmitter</code>. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Core.MessageEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addListener: function(listener, func, priority)
	{
		if(!listener instanceof MessageListener)
			throw new Error('MessageEmitter.addListener: listener must be instances of MessageListener');
			
		if(!listener._startListeningEmitter(this))
			throw new Error('MessageEmitter.addListener: listener is already listening');
			
		if(!priority)
		{
			priority = 0;
		}
		
		this._messageListenersCount++;	
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._addListenerActual.bind(this, listener, func, priority));
		}
		else
		{
			this._addListenerActual(listener, func, priority);
		}
	},
	
	_addListenerActual: function(listener, func, priority)
	{
		//  The priority for default value is <code>0</code>
		if ((typeof priority) == 'undefined') {
			priority = 0;
		}
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			if(records[i].p <= priority)
				break;
		}
		records.splice(i, 0, {l: listener, f: func, p: priority});
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this <code>MessageEmitter</code>.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 *
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this <code>MessageEmitter</code>.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeListener: function(listener)
	{
		if(!listener._stopListeningEmitter(this))
			//throw new Error('MessageEmitter.removeListner: listener is not listening');
			return false;
		
		this._messageListenersCount--;
		if(this._messageShouldDefer)
		{
			// TODO Replace with binary search.
			var records = this._messageListenerRecords;
			var len = records.length;
			for(var i=0; i < len; ++i)
			{
				var record = records[i];
				if(record.l == listener)
				{
					record.f = null;
					break;
				}
			}
			
			this._messageDeferredWork.push(this._removeListenerActual.bind(this, listener));
		}
		else
		{
			this._removeListenerActual(listener);
		}
		
		return true;
	},
	
	_removeListenerActual: function(listener)
	{
		// TODO Replace with binary search.
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(record.l == listener)
			{
				records.splice(i, 1);
				break;
			}
		}
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code>. This emitter will trigger all listeners
	 * in descending order based on the listener priority. All listener callback functions are generated
	 * with parameters passed to <code>emit()</code>.
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	emit: function(params)
	{
		var handled = false;
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._emitActual.bind(this, arguments, false));
		}
		else
		{
			handled = this._emitActual(arguments, true);
		}
		return handled;
	},
	
	_emitActual: function(params, executeDeferred)
	{
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		var handled = false;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
				handled = true;
		}

		if(!handled)
		{
			//NgLogD("No listeners handling emitted key");
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}

		return handled;
	},
	
	/**
	 * Send a message to every registered <code>MessageListener</code> through a chain of command. 
	 * This emitter will trigger all listeners in descending order based on the listener priority.
	 * All listener callback functions are generated with parameters passed to <code>chain()</code>.	 
	 * <br><br>
	 * Unlike <code>emit()</code>, <code>chain()</code> allows a <code>MessageListener</code> to halt propagation of a message 
	 * to other listener objects by returning <code>true</code> for the callback function.
	 * This is useful for things like touch event handling. A <code>MessageListener</code> can respond to a touch event
	 * by returning <code>true</code>, masking the touch event from other listener objects.
	 *
	 * @param {Parameters} parameters Parameters to pass in the generated callback funtion.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener responded. Returns <code>false</code> in all other cases.
	 * <br><br>
	 * <b>Note:</b> If the application calls <code>chain()</code> recursively from
	 * within a message handler callback, it will always return <code>undefined</code>
	 * regardless of if a <code>MessageListener</code> responds or not.
	 * @see Core.MessageEmitter#emit
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	chain: function(params)
	{
		if(this._messageShouldDefer)
		{
			this._messageDeferredWork.push(this._chainActual.bind(this, arguments, false));
			return undefined;
		}
		else
		{
			return this._chainActual(arguments, true);
		}
	},
	
	_chainActual: function(params, executeDeferred)
	{
		var result = false;
		this._messageShouldDefer = true;
		
		var records = this._messageListenerRecords;
		var len = records.length;
		for(var i=0; i < len; ++i)
		{
			var record = records[i];
			if(!record.f) continue;
			
			if(record.f.apply(record.l, params))
			{
				result = true;
				break;
			}
		}
		
		this._messageShouldDefer = false;
		
		if(this._messageDeferredWork.length && executeDeferred)
		{
			this._executeDeferred();
		}
		
		return result;
	},
	
	_executeDeferred: function()
	{
		// NOTE: Don't factor out deferred.length. Deferred work can add more deferred work.
		var deferred = this._messageDeferredWork;
		for(var i=0; i < deferred.length; ++i)
		{
			deferred[i]();
		}
		this._messageDeferredWork = [];
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/MessageListener'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/MessageListener'] || {}; $MODULE_REGISTRY['NGCore/Shared/MessageListener'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.MessageListener = Class.subclass(
/** @lends Core.MessageListener.prototype */
{
	classname: 'MessageListener',
	
	/**
	 * @class The <code>MessageListener</code> class is a base class for constructing objects that listen for notifications from emitters 
	 * (see <code>{@link Core.MessageEmitter}</code>). Objects of this type are registered with emitters.
	 * When <code>{@link Core.MessageEmitter#emit}</code> or <code>{@link Core.MessageEmitter#chain}</code> is called on an emitter
	 * all registered listeners will generate a callback function.
	 * <br><br>
	 * Applications must unregister listener objects when they are no longer required in one of three ways: 
	 * <div class="ul"><font size="3">
	 * <li>Calling <code>{@link Core.MessageEmitter#removeListener}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageEmitter#destroy}</code> on the <code>MessageEmitter</code>.</li>
	 * <li>Calling <code>{@link Core.MessageListener#destroy}</code> on the <code>MessageListener</code></li>
	 * </font></div><br>
	 * <font size="3"><b>Note:</b> Applications should not attempt to register a listener with an emitter more than once. Registering a listener with an emitter
	 * multiple times results in exceptions. </font>
	 * @example
	 * var MyListener = Core.MessageListener.subclass(
	 * {
	 *     myCallback: function(verb, value)
	 *     {
	 *         console.log('MyListener.myCallback(' + verb + ', ' + value + ')');
	 *     },
	 * }
	 * var listener = new MyListener();
	 * emitter.addListener(listener, listener.myCallback);
	 * emitter.emit('fun', 5);
	 * @constructs The default constructor.
	 * @augments Core.Class
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		this._messageEmitters = [];
	},
	
	/**
	 * Unregister this <code>MessageListener</code> from all emitters.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		// Unregister from all emitters.
		var emitters = this._messageEmitters;
		while(emitters.length)
			emitters[0].removeListener(this);
	},
	
	// Called by MessageEmitter when this receiver starts listening.
	_startListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index !== -1)
			return false;
		
		emitters.push(emitter);
		return true;
	},
	
	// Called by MessageEmitter when this receiver stops listening.
	_stopListeningEmitter: function(emitter)
	{
		var emitters = this._messageEmitters;
		var index = emitters.indexOf(emitter);
		if(index === -1)
			return false;
		
		emitters.splice(index, 1);
		return true;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Core/_int_LGL'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] || {}; $MODULE_REGISTRY['NGCore/Client/Core/_int_LGL'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class _int_LGL
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var Proc = require('NGCore/Client/Core/Proc').Proc;
var Base64 = require('NGCore/Client/Core/Base64').Base64;
var toMD5 = require('NGCore/Client/Core/toMD5').toMD5;

////////////////////////////////////////////////////////////////////////////////

var _int_LGL = Class.singleton(
/** @lends Core._int_LGL.prototype */
{
	classname: '_int_LGL',

	launch: function(url, proc)
	{
		var Util = require('NGCore/Client/Network/Util').Util;
		// Default to game proc. Games should actually not be aware of the third option,
		//	as they cannot use it anyway.
		if (!proc)
			proc = _int_LGL.ProcID.Game;

		url = Util.NormalizeUrl(url);

//		console.log("launching game url " + url);

		var run = (function()
		{
			gNgShutdownPending = true;
			this._launchSendGen({url: url, proc: proc});
		}).bind(this);

		if (proc == _int_LGL.ProcID.Game)
		{
			this.updateGameUse(url, run);
		}
		else
		{
			run();
		}
	},

	updateAvailable: function(game, doneCB, errorCB)
	{
		// Normalize URL
		var url = game;
		if (! url.match(/^\//) && !url.match(/https?:\/\//))
			url = '/' + url;

		var caps = require('NGCore/Client/Core/Capabilities').Capabilities;

		// If we are testing ourselves, we don't to md5 our url
		var name = "";
		if (caps.getUrl() != game)
		{
			var Util = require('NGCore/Client/Network/Util').Util;
			url = Util.NormalizeUrl(url);
			name = toMD5(url);
		}

		// Get device-specific manifest directory
		var buildPath = {"Android" : "android", "iPhone OS" : "ios", "flash" : ""};
		// Get Device capabilities platformOs
		var build = "/" + buildPath[caps.getPlatformOS()];

		var DownloadManifest = require('NGCore/Client/Network/DownloadManifest').DownloadManifest;
		var dm = new DownloadManifest();
		dm.isUpdated(url + build, name, 'webgame.ngmanifest', doneCB, errorCB);
	},

// Utility (non-generated) functionality
	updateGameUse: function(game, doneCB)
	{
		var name = toMD5(game);
		var self = this;
		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		this.mGameStore = KeyValueCache.global("Core.GameList");
		this.mActiveGameKey = "activeGames";

		// Get our list of games
		this.mGameStore.getItem(this.mActiveGameKey,
			function(error, value)
			{
				var list;
				if (value)
					list = JSON.parse(value);
				else
					list = [];

				var item;
				for (var i in list)
				{
					if (list[i].name == name)
					{
						item = list[i];
						break;
					}
				}

				if (!item)
				{
					item = {"name": name};
					list.push(item);
				}

				item.lastRun = (new Date()).getTime();
				item.url = game;

 				self.mGameStore.setItem(self.mActiveGameKey, JSON.stringify(list));

                LocalGameList.updateGameList(list);
 				doneCB();
			}, true
		);
	},

// {{?Wg Generated Code}}
	
	// Enums.
	ProcID:
	{ 
		/** High privilege proc */
		Persist: -1,
		/** Low priv */
		Game: -2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 342
	// Method launch = -1
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Proc.parseInt( cmd.shift() );
			var instance = ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in _int_LGL._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[342] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_launchSendGen: function( obj )
	{
		Proc.appendToCommandString( ":" + 342 + "," + -1  + "," + Base64.encode( obj[ "url" ] ) + "," + obj[ "proc" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $launch: function( url, proc ) {}
	

// {{/Wg Generated Code}}

});

exports._int_LGL = _int_LGL;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/FileSystem'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/FileSystem'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class FileSystem
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Class = require('NGCore/Client/Core/Class').Class;

////////////////////////////////////////////////////////////////////////////////

exports.FileSystem = Class.singleton(
/** @lends Storage.FileSystem.prototype */
{
	classname: 'FileSystem',
	
	/**
	 * @class The <code>FileSystem</code> class constructs a singleton object that controls file manipulation tasks: reading, writing, deleting, or decompressing a file.
	 * 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.readRequests = {};
		/** @private */
		this.writeRequests = {};
		/** @private */
		this.cbIdCounter = 1;
		
		ObjectRegistry.register(this);
		this._createSendGen(this);
	},

	/**
	 * Read a file into memory from local storage.
	 * @example FileSys.readFile(SomeFile, true, function(err, data){...}
	 * @param {String} fname The name of the file to read into memory.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>readFile()</code> shouuld conduct a binary read.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file read operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFile: function( fname, binary, cb )
	{
		this.readFileIn(this.Store.Local, fname, binary, cb);
	},

	/**
	 * @private
	 *	read a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to read from
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	readFileIn: function( store, fname, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.readRequests[ cbId ] = cb;
		}
		this._readFileSendGen(
		{
			"callbackId": cbId,
			"storeId"	: store,
			"filename"	: fname,
			"binary"	: binary,
		});
	},

	/**
	 * Write a file to local storage.
	 * @example FileSys.writeFile(SomeFile, someData, true, (function(){...});
	 * @param {String} fname The name of the file to write into storage.
	 * @param {Binary, String} data The data to write to the file.
	 * @param {Boolean} [binary=false] Set as <code>true</code> if <code>writeFile()</code> should conduct a binary write.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file write operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFile: function( fname, data, binary, cb )
	{
		this.writeFileIn(this.Store.Local, fname, data, binary, cb);
	},

	/**
	 * @private
	 *	write a file to a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location to write to
	 *	@param {fname} The name of the file to be written
	 *	@param {cb} The callback function to be called after completion
	 *	@param {binary} binary mode or not
     *  @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	writeFileIn: function( store, fname, data, binary, cb )
	{
		var cbId = 0;

		if(typeof(binary) == 'function')
		{
			cb = binary;
			binary = false;
		}
		binary = binary || false;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}

		this._writeFileSendGen(
		{
			"callbackId": cbId,
			"storeId"	: store,
			"filename"	: fname,
			"data"		: data,
			"binary"	: binary,
		});
	},

	/**
	 * Delete a file from local storage.
	 * @example FileSys.deleteFile(SomeFile,function(err, data){});
	 * @param {String} fname The name of the file to delete.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file delete operation fails.
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFile: function ( fname, cb )
	{
		this.deleteFileIn(this.Store.Local, fname, cb);
	},

	/**
	 * @private
	 *	delete a file from a common store on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be deleted
	 *	@param {cb} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	deleteFileIn: function ( store, fname, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._deleteFileSendGen(
		{
			"callbackId": cbId,
			"storeId"	: store,
			"filename"	: fname,		
		});
	},
	
	/**
	 * Decompress a zipfile.
	 * @example FileSys.readFile(SomeFile, ./some/path/to/destination/, true, function(err, data){...}
	 * @param {String} fname The name of the zipfile to decompress.
	 * @param {String} destination The directory path where the contents of the decompressed file are written.
	 * @param {Boolean} [returnFiles] Set as <code>true</code> if <code>decompressFile()</code> should return a list of files contained in the zipfile specified by the <code>fname</code> parameter.
	 * @param {Function} [cb] Specifies a callback function that returns an error if the file decompress operation fails.
     * @status iOS, Android
	 */
	decompressFile: function( fname, destination, returnFiles, cb )
	{
		this.decompressFileIn(this.Store.Local, fname, destination, returnFiles, cb);
	},
	
	/**
	 * @private
	 *	decompress a file to a shared location on the filesystem
	 *	NOTE: This is not a secure location and games should not rely on this for critical data
	 *	@param {store} The shared location path
	 *	@param {fname} The name of the file to be read
	 *	@param {cb} The callback function to be called
	 *	@param {destination} destination location to unzip files to
	 *	@param {returnFiles} true/false if true it returns a json object with a list of each file, its MD5 hash and its size
     *  @status iOS, Android    
	 */
	decompressFileIn: function( store, fname, destination, returnFiles, cb )
	{
		var cbId = 0;

		if ( cb )
		{
			cbId = this.cbIdCounter++;
			this.writeRequests[ cbId ] = cb;
		}
		this._decompressFileSendGen(
		{
			"callbackId": cbId,
			"storeId":    store,
			"filename"	: fname,
			"destination": destination,
			"returnFiles": returnFiles,
		});
	},
	
	/**
	 * @private
	 */
	_readFileCbRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._readFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var data = msg[ "data" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			NgLogE ( "FileSystem.onReadFile: No cbId" );
			return;
		}
		
		var cb = this.readRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem.onReadFile: No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.readRequests[ cbId ];
		cb ( err, data );
	},
	
	/**
	 * @private
	 */
	_writeFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._writeFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
			
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}

		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_deleteFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._deleteFileCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg[ "callbackId" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err );
	},
	
	/**
	 * @private
	 */
	_decompressFileCbRecv: function( cmd )
	{
		var msg = {};
		if(!this._decompressFileCbRecvGen(cmd, msg))
			return;
			
		var cbId = msg[ "callbackId" ];
		var files = msg[ "files" ];
		var err = msg[ "error" ];
		
		if ( !cbId )
		{
			//NgLogE ( "FileSystem command : No cbId" );
			return;
		}
		
		var cb = this.writeRequests[ cbId ];
		
		if ( !cb )
		{
			NgLogE ( "FileSystem command : No registered cb found..cbId is :" + cbId );
			return;
		}
		
		try
		{
			files = JSON.parse(files);
		}
		catch(e)
		{
			NgLogE ( "FileSystem command : Could not parse response :" + files );
			err = "Could not parse files";
		}
		
		delete this.writeRequests[ cbId ];
		cb ( err, files );
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	Store:
	{ 
		/** /tmp */
		Temp: 0,
		/** local sandbox */
		Local: 1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 338
	// Method create = -1
	// Method readFile = 2
	// Method writeFile = 3
	// Method deleteFile = 4
	// Method decompressFile = 5
	// Method readFileCb = 6
	// Method writeFileCb = 7
	// Method deleteFileCb = 8
	// Method decompressFileCb = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._readFileCbRecv( cmd );
					break;
				case 7:
					instance._writeFileCbRecv( cmd );
					break;
				case 8:
					instance._deleteFileCbRecv( cmd );
					break;
				case 9:
					instance._decompressFileCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in FileSystem._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[338] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_readFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.readFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_writeFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.writeFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_deleteFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.deleteFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_decompressFileCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "files" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "files" ] === undefined )
		{
			NgLogE("Could not parse files in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in FileSystem.decompressFileCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 338 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_readFileSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 338 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "callbackId" ] + "," + obj[ "storeId" ] + "," + Core.Base64.encode( obj[ "filename" ] ) + "," + ( obj[ "binary" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_writeFileSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 338 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "callbackId" ] + "," + obj[ "storeId" ] + "," + Core.Base64.encode( obj[ "filename" ] ) + "," + Core.Base64.encode( obj[ "data" ] ) + "," + ( obj[ "binary" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_deleteFileSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 338 + "," + 4 + "," + this.__objectRegistryId + "," + obj[ "callbackId" ] + "," + obj[ "storeId" ] + "," + Core.Base64.encode( obj[ "filename" ] )  );
	},
	
	/** @private */
	_decompressFileSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 338 + "," + 5 + "," + this.__objectRegistryId + "," + obj[ "callbackId" ] + "," + obj[ "storeId" ] + "," + Core.Base64.encode( obj[ "filename" ] ) + "," + Core.Base64.encode( obj[ "destination" ] ) + "," + ( obj[ "returnFiles" ] ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// readFile: function( callbackId, storeId, filename, binary ) {}
	
	// writeFile: function( callbackId, storeId, filename, data, binary ) {}
	
	// deleteFile: function( callbackId, storeId, filename ) {}
	
	// decompressFile: function( callbackId, storeId, filename, destination, returnFiles ) {}
	
	// _readFileCbRecv: function( cmd ) {}
	// _writeFileCbRecv: function( cmd ) {}
	// _deleteFileCbRecv: function( cmd ) {}
	// _decompressFileCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/md5'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/md5'] = exports; /*
 * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
 * Digest Algorithm, as defined in RFC 1321.
 * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
 * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
 * Distributed under the BSD License
 * See http://pajhome.org.uk/crypt/md5 for more info.
 */

/*
 * Calculate the MD5 of a raw string
 */
function rstr_md5(s)
{
  return binl2rstr(binl_md5(rstr2binl(s), s.length * 8));
}

/*
 * Convert a raw string to a hex string
 */
function rstr2hex(input)
{
  var hex_tab = "0123456789abcdef";
  var output = "";
  var x;
  for(var i = 0; i < input.length; i++)
  {
    x = input.charCodeAt(i);
    output += hex_tab.charAt((x >>> 4) & 0x0F)
           +  hex_tab.charAt( x        & 0x0F);
  }
  return output;
}

/*
 * Encode a string as utf-8.
 * For efficiency, this assumes the input is valid utf-16.
 */
function str2rstr_utf8(input)
{
  var output = "";
  var i = -1;
  var x, y;

  while(++i < input.length)
  {
    /* Decode utf-16 surrogate pairs */
    x = input.charCodeAt(i);
    y = i + 1 < input.length ? input.charCodeAt(i + 1) : 0;
    if(0xD800 <= x && x <= 0xDBFF && 0xDC00 <= y && y <= 0xDFFF)
    {
      x = 0x10000 + ((x & 0x03FF) << 10) + (y & 0x03FF);
      i++;
    }

    /* Encode output as utf-8 */
    if(x <= 0x7F)
      output += String.fromCharCode(x);
    else if(x <= 0x7FF)
      output += String.fromCharCode(0xC0 | ((x >>> 6 ) & 0x1F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0xFFFF)
      output += String.fromCharCode(0xE0 | ((x >>> 12) & 0x0F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
    else if(x <= 0x1FFFFF)
      output += String.fromCharCode(0xF0 | ((x >>> 18) & 0x07),
                                    0x80 | ((x >>> 12) & 0x3F),
                                    0x80 | ((x >>> 6 ) & 0x3F),
                                    0x80 | ( x         & 0x3F));
  }
  return output;
}

/*
 * Convert a raw string to an array of little-endian words
 * Characters >255 have their high-byte silently ignored.
 */
function rstr2binl(input)
{
  var output = Array(input.length >> 2);
  for(var i = 0; i < output.length; i++)
    output[i] = 0;
  for(var i = 0; i < input.length * 8; i += 8)
    output[i>>5] |= (input.charCodeAt(i / 8) & 0xFF) << (i%32);
  return output;
}

/*
 * Convert an array of little-endian words to a string
 */
function binl2rstr(input)
{
  var output = "";
  for(var i = 0; i < input.length * 32; i += 8)
    output += String.fromCharCode((input[i>>5] >>> (i % 32)) & 0xFF);
  return output;
}

/*
 * Calculate the MD5 of an array of little-endian words, and a bit length.
 */
function binl_md5(x, len)
{
  /* append padding */
  x[len >> 5] |= 0x80 << ((len) % 32);
  x[(((len + 64) >>> 9) << 4) + 14] = len;

  var a =  1732584193;
  var b = -271733879;
  var c = -1732584194;
  var d =  271733878;

  for(var i = 0; i < x.length; i += 16)
  {
    var olda = a;
    var oldb = b;
    var oldc = c;
    var oldd = d;

    a = md5_ff(a, b, c, d, x[i+ 0], 7 , -680876936);
    d = md5_ff(d, a, b, c, x[i+ 1], 12, -389564586);
    c = md5_ff(c, d, a, b, x[i+ 2], 17,  606105819);
    b = md5_ff(b, c, d, a, x[i+ 3], 22, -1044525330);
    a = md5_ff(a, b, c, d, x[i+ 4], 7 , -176418897);
    d = md5_ff(d, a, b, c, x[i+ 5], 12,  1200080426);
    c = md5_ff(c, d, a, b, x[i+ 6], 17, -1473231341);
    b = md5_ff(b, c, d, a, x[i+ 7], 22, -45705983);
    a = md5_ff(a, b, c, d, x[i+ 8], 7 ,  1770035416);
    d = md5_ff(d, a, b, c, x[i+ 9], 12, -1958414417);
    c = md5_ff(c, d, a, b, x[i+10], 17, -42063);
    b = md5_ff(b, c, d, a, x[i+11], 22, -1990404162);
    a = md5_ff(a, b, c, d, x[i+12], 7 ,  1804603682);
    d = md5_ff(d, a, b, c, x[i+13], 12, -40341101);
    c = md5_ff(c, d, a, b, x[i+14], 17, -1502002290);
    b = md5_ff(b, c, d, a, x[i+15], 22,  1236535329);

    a = md5_gg(a, b, c, d, x[i+ 1], 5 , -165796510);
    d = md5_gg(d, a, b, c, x[i+ 6], 9 , -1069501632);
    c = md5_gg(c, d, a, b, x[i+11], 14,  643717713);
    b = md5_gg(b, c, d, a, x[i+ 0], 20, -373897302);
    a = md5_gg(a, b, c, d, x[i+ 5], 5 , -701558691);
    d = md5_gg(d, a, b, c, x[i+10], 9 ,  38016083);
    c = md5_gg(c, d, a, b, x[i+15], 14, -660478335);
    b = md5_gg(b, c, d, a, x[i+ 4], 20, -405537848);
    a = md5_gg(a, b, c, d, x[i+ 9], 5 ,  568446438);
    d = md5_gg(d, a, b, c, x[i+14], 9 , -1019803690);
    c = md5_gg(c, d, a, b, x[i+ 3], 14, -187363961);
    b = md5_gg(b, c, d, a, x[i+ 8], 20,  1163531501);
    a = md5_gg(a, b, c, d, x[i+13], 5 , -1444681467);
    d = md5_gg(d, a, b, c, x[i+ 2], 9 , -51403784);
    c = md5_gg(c, d, a, b, x[i+ 7], 14,  1735328473);
    b = md5_gg(b, c, d, a, x[i+12], 20, -1926607734);

    a = md5_hh(a, b, c, d, x[i+ 5], 4 , -378558);
    d = md5_hh(d, a, b, c, x[i+ 8], 11, -2022574463);
    c = md5_hh(c, d, a, b, x[i+11], 16,  1839030562);
    b = md5_hh(b, c, d, a, x[i+14], 23, -35309556);
    a = md5_hh(a, b, c, d, x[i+ 1], 4 , -1530992060);
    d = md5_hh(d, a, b, c, x[i+ 4], 11,  1272893353);
    c = md5_hh(c, d, a, b, x[i+ 7], 16, -155497632);
    b = md5_hh(b, c, d, a, x[i+10], 23, -1094730640);
    a = md5_hh(a, b, c, d, x[i+13], 4 ,  681279174);
    d = md5_hh(d, a, b, c, x[i+ 0], 11, -358537222);
    c = md5_hh(c, d, a, b, x[i+ 3], 16, -722521979);
    b = md5_hh(b, c, d, a, x[i+ 6], 23,  76029189);
    a = md5_hh(a, b, c, d, x[i+ 9], 4 , -640364487);
    d = md5_hh(d, a, b, c, x[i+12], 11, -421815835);
    c = md5_hh(c, d, a, b, x[i+15], 16,  530742520);
    b = md5_hh(b, c, d, a, x[i+ 2], 23, -995338651);

    a = md5_ii(a, b, c, d, x[i+ 0], 6 , -198630844);
    d = md5_ii(d, a, b, c, x[i+ 7], 10,  1126891415);
    c = md5_ii(c, d, a, b, x[i+14], 15, -1416354905);
    b = md5_ii(b, c, d, a, x[i+ 5], 21, -57434055);
    a = md5_ii(a, b, c, d, x[i+12], 6 ,  1700485571);
    d = md5_ii(d, a, b, c, x[i+ 3], 10, -1894986606);
    c = md5_ii(c, d, a, b, x[i+10], 15, -1051523);
    b = md5_ii(b, c, d, a, x[i+ 1], 21, -2054922799);
    a = md5_ii(a, b, c, d, x[i+ 8], 6 ,  1873313359);
    d = md5_ii(d, a, b, c, x[i+15], 10, -30611744);
    c = md5_ii(c, d, a, b, x[i+ 6], 15, -1560198380);
    b = md5_ii(b, c, d, a, x[i+13], 21,  1309151649);
    a = md5_ii(a, b, c, d, x[i+ 4], 6 , -145523070);
    d = md5_ii(d, a, b, c, x[i+11], 10, -1120210379);
    c = md5_ii(c, d, a, b, x[i+ 2], 15,  718787259);
    b = md5_ii(b, c, d, a, x[i+ 9], 21, -343485551);

    a = safe_add(a, olda);
    b = safe_add(b, oldb);
    c = safe_add(c, oldc);
    d = safe_add(d, oldd);
  }
  return Array(a, b, c, d);
}

/*
 * These functions implement the four basic operations the algorithm uses.
 */
function md5_cmn(q, a, b, x, s, t)
{
  return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s),b);
}
function md5_ff(a, b, c, d, x, s, t)
{
  return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
}
function md5_gg(a, b, c, d, x, s, t)
{
  return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
}
function md5_hh(a, b, c, d, x, s, t)
{
  return md5_cmn(b ^ c ^ d, a, b, x, s, t);
}
function md5_ii(a, b, c, d, x, s, t)
{
  return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
}

/*
 * Add integers, wrapping at 2^32. This uses 16-bit operations internally
 * to work around bugs in some JS interpreters.
 */
function safe_add(x, y)
{
  var lsw = (x & 0xFFFF) + (y & 0xFFFF);
  var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
  return (msw << 16) | (lsw & 0xFFFF);
}

/*
 * Bitwise rotate a 32-bit number to the left.
 */
function bit_rol(num, cnt)
{
  return (num << cnt) | (num >>> (32 - cnt));
}

var toMD5 = function(s) { return rstr2hex(rstr_md5(str2rstr_utf8(s))); }

/*
 * Perform a simple self-test to see if the VM is working
 */
function md5_vm_test()
{
  return toMD5("abc").toLowerCase() == "900150983cd24fb0d6963f7d28e17f72";
}

exports.toMD5 = toMD5;
exports.testMD5 = md5_vm_test;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Storage/KeyValue'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] || {}; $MODULE_REGISTRY['NGCore/Client/Storage/KeyValue'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class KeyValue
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

function KeyValueCache() {
};
exports.KeyValueCache = KeyValueCache;
/** @private */
KeyValueCache.lruMeanCacheSize = 100;
/** @private */
KeyValueCache.instanceMap = {};
//TODO: rename this later
var StorageGlobalScopes = [];

KeyValueCache.optimizeCaches = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			KeyValueCache.instanceMap[storeKey].optimize();
		}
	}
};

KeyValueCache.lowMemoryWarning = function() 
{
	for (var storeKey in KeyValueCache.instanceMap) {
		if(KeyValueCache.instanceMap.hasOwnProperty(storeKey)) {
			var instance = KeyValueCache.instanceMap[storeKey];
			instance.data = {};

			//Purge entries in callbacks
			var newCallbacks = {};
			newCallbacks.uidGenerator = instance.callbacks.uidGenerator;
			for(var cbId in instance.callbacks)
			{
				if(instance.callbacks.hasOwnProperty(cbId)) {
					if(instance.callbacks[cbId]) {
						newCallbacks = instance.callbacks[cbId];
					}
				}
			}
			instance.callbacks = newCallbacks;
		}
	}
};

KeyValueCache.init = function()
{
	KeyValueCache.local = new Storage.KeyValue();
	KeyValueCache.local.registerForKey("local");
};

/**
 * @static Scopes this <code>KeyValueCache</code> object as global. A globally scoped KeyValueCache object can be used by multiple applications for the same data. 
 * @param {String} globalKey The store key for the <code>KeyValueCache</code> object.
 */
KeyValueCache.global = function(globalKey)
{
	if(StorageGlobalScopes[globalKey])
	{
		return StorageGlobalScopes[globalKey];
	}

	//Miss Global Table Cache.
	var scope = new Storage.KeyValue();
	scope.registerForKey(globalKey);
	StorageGlobalScopes[globalKey] = scope;
	return scope;
};

exports.KeyValue = Core.Class.subclass(
/** @lends Storage.KeyValue.prototype */
{
	classname: "KeyValue",
	/**
	 * @class The <code>KeyValue</code> class constructs objects that store key/value pairs.<br><br>
	 * Call <code>KeyValueCache.local()</code> to access the <code>local</code> datastore for your application.<br><br>
	 * Call <code>KeyValueCache.global(globalKey)</code> to access a globally scoped datastore. Multiple applications can use a globally scoped datastore for the same data.<br><br>
	 * The <code>globalKey</code> parameter is a string that uniquely identifies the datastore.<br><br>
	 * Use the methods in the <code>KeyValue</code> class to manage the key-value pairs in your application's datastore.<br><br>
	 *
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		/** @private */
		this.initialized = false;
		/** @private */
		this.origin = null;
		/** @private */
		this.callbacks = {};
		/** @private */
		this.callbacks.uidGenerator = 0;
		/** @private */
		this.local = false;
		/** @private */
		this.lruCacheShrinkCounter = 0;
	
		/** @private */
		this.data = {};
		/** @private */
		this.usage = {};
		
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
    /*
	 * @private
	 * Call <code>registerForKey()</code> to access a datastore identified by the value of the <code>storeKey</code> parameter.
	 * @param {String} storeKey The unique identifier of the datastore.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	registerForKey: function(storeKey) 
	{
		this.origin = storeKey;
		KeyValueCache.instanceMap[storeKey] = this;

		//Push this instance across the native bridge
		this._registerCommandSendGen( 
		{ 	
			"storeKey": this.origin,
			"lruMeanCacheSize" : KeyValueCache.lruMeanCacheSize,
		} );
		
		return this;
	},
	/**
	 * Pass the value associated with the key to the callback function.
	 * @param {String} key The key that is associated with the value to pass to the callback function.
	 * @param {Function} callbackFunc The callback function that uses the value associated with the key.
	 * @param {Boolean} [ignoreCache=false] Set <code>ignoreCache</code> to <code>true</code> to force a read from storage.
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	getItem: function(key,callbackFunc,ignoreCache /*defaults to false*/)
	{
		if(!ignoreCache)
		{
			if(this.data[key]) {
				callbackFunc(null,this.data[key],key);
				this.usage[key]++;
				return;
			}
			else
			{
				NgLogD("Value not found in cache for..falling back to native");
			}
		}

		//Generate unused callbackEntry
		var callbackId = this.callbacks.uidGenerator++;

		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._getItemSendGen(
		{
			"storeKey" : this.origin,
			"callbackId" : callbackId,
			"key" : key,
		});
	},
	
	/**
	 * Associate a value with a key.
	 * @param {String} key The key to associate with the value.
	 * @param {String} value The value to associate with the key.
	 * @param {Function} [callbackFunc] A callback function with an error parameter. The error parameter is null when the <code>setItem()</code> function completes successfully.
     * @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	setItem: function(key,value,callbackFunc)
	{
		var value = value;
		this.data[key] = value;

		var callbackId = this.callbacks.uidGenerator++;
		if(!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._setItemSendGen(
		{
			"storeKey" : this.origin,
			"callbackId" : callbackId,
			"key" : key,
			"value" : value,
		});
	},
	
	/**
	 * Remove the value that is associated with a key.
	 * @param {String} key The key that is associated with the value to remove.
	 * @param {Function} [callbackFunc] Specifies a callback function.
     * @status iOS, Android, Test, iOSTested, AndroidTested     
	 */
	removeItem: function(key,callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._removeItemSendGen(
		{
			"storeKey" : this.origin,
			"callbackId" : callbackId,
			"key" : key,
		});
	},

	/**
	 *  @private
	 * 	clear all key/value pairs stored within this store
	 *  @param {callbackFunc} The callback function to be called
     *  @status iOS, Android, Test, iOSTested, AndroidTested          
	 */
	clear: function(callbackFunc)
	{
		var callbackId = this.callbacks.uidGenerator++;
		if(!!!callbackFunc) {
			callbackFunc = function(){};
		}
		this.callbacks[callbackId] = callbackFunc;

		this._clearSendGen(
		{
			"storeKey" : this.origin,
			"callbackId" : callbackId,
		});
	},
    /*
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	enforceLRUCacheSize: function()
	{
		NgLogD("Enforcing KeyValue Cache Size");
		var tmp = [];
		for (var k in this.data) {
			if (this.data.hasOwnProperty(k)) {
				tmp.push(k);
			}
		}
		var usage = this.usage;
		tmp.sort(function(a,b) {
			var p1 = usage[a];
			if (!p1) {
				p1 = 0;
			}

			var p2 = usage[b];
			if (!p2) {
				p2 = 0;
			}

			if (p1 == p2) { return 0; }
			return p1 < p2 ? 1 : -1;
		});

		var oldData = this.data;
		this.data = {};
		//Copy over the lruMeanCache(number) most used entries
		var stopPoint = KeyValueCache.lruMeanCacheSize;
		for (var i = 0; i < stopPoint && i < tmp.length; i++)
		{
			if(!oldData[tmp[i]]) {
				//Case cache didn't contain that key at this point in time
				stopPoint++;
			}
			else {
				this.data[tmp[i]] = oldData[tmp[i]];
			}
		}
	},
	
	_getInstanceRecv : function(cmd)
	{
		var msg = {};
		if(!this._getInstanceRecvGen(cmd, msg))
			return;
			
		var storeKey = msg["storeKey"];

		var instance = KeyValueCache.instanceMap[storeKey];
		//NgLogD("Storage.getInstanceForCommand Found instance for key [" + storeKey + "]: " + instance + " (" + command + ")");
		return instance;
	},
	
	_registerCommandCbRecv : function(cmd)
	{		
		var msg = {};
		if(!this._registerCommandCbRecvGen(cmd, msg))
			return;
		
		//NgLogD("Storage registerCallback: "+command+"\n");
		if(msg["error"]){
			console.log("Storage: Error registering for KeyValue location '"+msg["error"]+"'");
			if(!this.initialized) {
				delete StorageGlobalScopes[msg["originalStoreKey"]];
			}
			return;
		}

		if(this.origin == "local") {
			this.local = true;
			StorageGlobalScopes[this.origin] = this;
		}

		this.origin = msg["storeKey"];
		this.initialized = true;
		
		for(var i=0; i < msg.preloadDataCount; ++i)
		{
			var preload = {};
			if(!this._preloadDataRecvGen(cmd, preload))
				return;
			
			this.data[preload.key] = preload.value;
		}
	},
	
	_getItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._getItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		var value = msg["value"];
		if (error) {
			value = null;
		}

		this.data[key] = value;
		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,value,key);
			this.callbacks[cbId] = null;
		}

		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
		return this;
	},
	
	_setItemCommandCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._setItemCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];

		if(!this.usage[key]) {
			this.usage[key] = 1;
		} else {
			this.usage[key]++;
		}
		
		//NgLogD("Storage.setItemCommand Found instance for key [" + key + "]: " + " (" + cbId + ")");

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			//NgLogD("Storage.setItemCommand Found callback");
			cb(error,key);
			this.callbacks[cbId] = null;
		}
		if(((this.lruCacheShrinkCounter++) % KeyValueCache.lruMeanCacheSize) === 0) {
			this.enforceLRUCacheSize();
		}
	},
	
	_removeItemCbRecv : function(cmd)
	{
		var msg = {};
		if(!this._removeItemCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];
		var key = msg["key"];
		delete this.usage[key];
		delete this.data[key];

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,key);
			this.callbacks[cbId] = null;
		}
	},
	
	_clearCommandCbRecv : function(cmd)
	{
		var msg ={};
		if(!this._clearCommandCbRecvGen(cmd, msg))
			return;
		
		var cbId = msg["callbackId"];
		var error = msg["error"];

		this.data = {};
		this.usage = {};

		cb = this.callbacks[cbId];
		if(typeof cb == "function") {
			cb(error,this.origin);
			this.callbacks[cbId] = null;
		}

	},

	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for response types.
	 * @namespace
	 */
	Responses:
	{ 
		/** Register Storage */
		Register: 0,
		/** Get Item */
		GetItem: 1,
		/** Set Item */
		SetItem: 2,
		/** Remove Item */
		RemoveItem: 3,
		/** Clear All */
		Clear: 4,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 339
	// Method create = -1
	// Method destroy = 2
	// Method registerCommand = 3
	// Method getItem = 4
	// Method setItem = 5
	// Method removeItem = 6
	// Method clear = 7
	// Method getInstance = 8
	// Method registerCommandCb = 9
	// Method preloadData = 10
	// Method getItemCommandCb = 11
	// Method setItemCommandCb = 12
	// Method removeItemCb = 13
	// Method clearCommandCb = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._getInstanceRecv( cmd );
					break;
				case 9:
					instance._registerCommandCbRecv( cmd );
					break;
				case 10:
					instance._preloadDataRecv( cmd );
					break;
				case 11:
					instance._getItemCommandCbRecv( cmd );
					break;
				case 12:
					instance._setItemCommandCbRecv( cmd );
					break;
				case 13:
					instance._removeItemCbRecv( cmd );
					break;
				case 14:
					instance._clearCommandCbRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyValue._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[339] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_getInstanceRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getInstance from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_registerCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "originalStoreKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "originalStoreKey" ] === undefined )
		{
			NgLogE("Could not parse originalStoreKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "preloadDataCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "preloadDataCount" ] === undefined )
		{
			NgLogE("Could not parse preloadDataCount in KeyValue.registerCommandCb from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_preloadDataRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 2 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.preloadData from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 2);
		return true;
	},
	
	/** @private */
	_getItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.getItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_setItemCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 6 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "value" ] = Core.Proc.parseString( cmd[ 5 ] );
		if( obj[ "value" ] === undefined )
		{
			NgLogE("Could not parse value in KeyValue.setItemCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_removeItemCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		obj[ "key" ] = Core.Proc.parseString( cmd[ 4 ] );
		if( obj[ "key" ] === undefined )
		{
			NgLogE("Could not parse key in KeyValue.removeItemCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_clearCommandCbRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "response" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "response" ] === undefined )
		{
			NgLogE("Could not parse response in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "storeKey" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "storeKey" ] === undefined )
		{
			NgLogE("Could not parse storeKey in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "callbackId" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "callbackId" ] === undefined )
		{
			NgLogE("Could not parse callbackId in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 3 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in KeyValue.clearCommandCb from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 339 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 339 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_registerCommandSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 339 + "," + 3 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "storeKey" ] ) + "," + obj[ "lruMeanCacheSize" ]  );
	},
	
	/** @private */
	_getItemSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 339 + "," + 4 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "storeKey" ] ) + "," + obj[ "callbackId" ] + "," + Core.Base64.encode( obj[ "key" ] )  );
	},
	
	/** @private */
	_setItemSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 339 + "," + 5 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "storeKey" ] ) + "," + obj[ "callbackId" ] + "," + Core.Base64.encode( obj[ "key" ] ) + "," + Core.Base64.encode( obj[ "value" ] )  );
	},
	
	/** @private */
	_removeItemSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 339 + "," + 6 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "storeKey" ] ) + "," + obj[ "callbackId" ] + "," + Core.Base64.encode( obj[ "key" ] )  );
	},
	
	/** @private */
	_clearSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 339 + "," + 7 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "storeKey" ] ) + "," + obj[ "callbackId" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// registerCommand: function( storeKey, lruMeanCacheSize ) {}
	
	// getItem: function( storeKey, callbackId, key ) {}
	
	// setItem: function( storeKey, callbackId, key, value ) {}
	
	// removeItem: function( storeKey, callbackId, key ) {}
	
	// clear: function( storeKey, callbackId ) {}
	
	// _getInstanceRecv: function( cmd ) {}
	// _registerCommandCbRecv: function( cmd ) {}
	// _preloadDataRecv: function( cmd ) {}
	// _getItemCommandCbRecv: function( cmd ) {}
	// _setItemCommandCbRecv: function( cmd ) {}
	// _removeItemCbRecv: function( cmd ) {}
	// _clearCommandCbRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LocationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LocationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LocationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LocationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LocationEmitter.prototype */
{
	classname: 'LocationEmitter',

	Accuracy:
	{
		LOW:    0, // less power consumption. equivalent to "3km"  in iOS
		MEDIUM: 1, // equivalent to "100m" in iOS
		HIGH:   2  // most accurate, high power consumption. equivalent to "Best" in iOS
	},

	Elements:
	{
		LATITUDE:  1,
		LONGITUDE: 2,
		ALTITUDE:  4,
		HEADING:   8  // equivalent to "bearing" in Android
	},

	/**
	 * @class The <code>LocationEmitter</code> class constructs a singleton object that emits <a href="Device.LocationEmitter.Location.html">Location</a> objects.<br><br>
     * @constructs The default constructor. 
 	 * @see Device.LocationEmitter.Location
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
		this._lastLocation = undefined;
	},

	/**
	 * @param {LocationEmitter#Accuracy} Accuracy accuracy of updates. The default value is HIGH.
	 * @param {Number} elements OR-ed <code>LocationEmitter.Elements</code>. Example: LATITUDE | LONGITUDE. The default value is LATITUDE | LONGITUDE | ALTITUDE | HEADING (i.e. listens to all elements).
	 * @status
	 */
	setProperties: function(accuracy, elements)
	{
		if (! accuracy) accuracy = this.Accuracy.HIGH;
		if (! elements) elements = this.Elements.LATITUDE | this.Elements.LONGITUDE | this.Elements.ALTITUDE | this.Elements.HEADING;
		this.accuracy = accuracy;
		this.elements = elements;
		this._setPropertiesSendGen({accuracy: accuracy, elements: elements});
	},

	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.LocationEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, forceStart, priority) {
		if(forceStart == undefined)
		{
			this._startUpdatingSendGen({
			force: true,
			});
		}
		else
		{
			this._startUpdatingSendGen({
				force: forceStart,
			});
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.LocationEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener) {
		$super(listener);
		if(this.getListenerCount() == 0)
			this._stopUpdatingSendGen();
	},
    
	/**
	 * Retrieve the last location returned by this <code>LocationEmitter</code>.
	 * @returns {Device.LocationEmitter.Location} The last location returned.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLastLocation: function()
	{
		if(this._lastLocation == undefined || !this._lastLocation.getPosition()) return undefined;
		
		return this._lastLocation;
	},
	
    _locationUpdatedRecv: function( cmd ) {
		var msg = {};
		if (!this._locationUpdatedRecvGen(cmd, msg))
		    return;
		
		if (((this.elements & this.Elements.LATITUDE) == 0)  &&
			((this.elements & this.Elements.LONGITUDE) == 0) &&
			((this.Elements & this.Elements.ALTITUDE) == 0))
			return;

		this._lastLocation = new this.Location(
			new Core.Point(msg["latitude"], msg["longitude"]),
			msg["altitude"],
			undefined,
			msg["accuracy"],
			msg["timestamp"]);

		this.emit(this._lastLocation);
    },
	
	_headingUpdatedRecv: function( cmd ) 
	{
		var msg = {};
		if (!this._headingUpdatedRecvGen(cmd, msg))
			return;
			
		if ((this.elements & this.Elements.HEADING) == 0)
			return;

		this._lastLocation = new this.Location(
			this._lastLocation ? this._lastLocation.getPosition() : undefined,
			this._lastLocation ? this._lastLocation.getAltitude() : undefined,
			msg['magneticHeading'],
			this._lastLocation ? this._lastLocation.getAccuracy() : undefined,
			msg['timestamp']);
		
		if(msg['magneticHeading']) {
			this.emit(this._lastLocation);
		}
	},
	
	Location: Core.Class.subclass(
	/** @lends Device.LocationEmitter.Location.prototype */
	{
		classname: 'Location',
		
		/**
		 * @class <code>Location</code> constructs objects that encapsulate the location of a device.
		 * <code>Location</code> objects contain spatial components, like position and heading information, and a timestamp that indicates when a location is measured.
		 * 
		 * @constructs The default constructor. 
		 * @param {Core.Point} position The latitude / longitude of the device.
		 * @param {Number} altitude The altitude of the device.
		 * @param {Number} heading The heading of the device.
		 * @param {Number} accuracy The accuracy of the measurement.
		 * @param {Number} timestamp The timestamp when the location was measured.
		 * @augments Core.Class
		 */
		initialize: function(position, altitude, heading, accuracy, timestamp)
		{
			this._position = position;
			this._altitude = altitude;
			this._accuracy = accuracy;
			this._heading = heading;
			this._timestamp = timestamp;
		},
		
		/**
		 * Return the position of this <code>Location</code> as latitude / longitude.
		 * @returns {Core.Point} The current latitude / longitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Return the altitude of this <code>Location</code> in feet (ft).
		 * @returns {Number} The current altitude.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAltitude: function()
		{
			return this._altitude;
		},
		
		/**
		 * Return the heading of this <code>Location</code> in degrees east of north.
		 * @returns {Number} The current heading.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getHeading: function()
		{
			return this._heading;
		},
		
		/**
		 * Return the accuracy of the measurement for this <code>Location</code>.
		 * @returns {Number} The current location accuracy.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccuracy: function()
		{
			return this._accuracy;
		},
		
		/**
		 * Return the timestamp when this measurement was taken.
		 * Expressed in milliseconds since Epoch (Unix time).
		 * @returns {Number} The timestamp of the measurement.
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getTimestamp: function()
		{
			return this._timestamp;
		},
	}),
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 333
	// Method create = -1
	// Method destroy = 2
	// Method startUpdatingLocation = 3
	// Method stopUpdatingLocation = 4
	// Method locationUpdated = 5
	// Method startUpdatingHeading = 6
	// Method stopUpdatingHeading = 7
	// Method headingUpdated = 8
	// Method setProperties = 9
	// Method startUpdating = 10
	// Method stopUpdating = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 5:
					instance._locationUpdatedRecv( cmd );
					break;
				case 8:
					instance._headingUpdatedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LocationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[333] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_locationUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 5 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "latitude" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "latitude" ] === undefined )
		{
			NgLogE("Could not parse latitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "longitude" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "longitude" ] === undefined )
		{
			NgLogE("Could not parse longitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "altitude" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "altitude" ] === undefined )
		{
			NgLogE("Could not parse altitude in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 4 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.locationUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_headingUpdatedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 4 )
		{
			NgLogE("Could not parse due to wrong argument count in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "timestamp" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "timestamp" ] === undefined )
		{
			NgLogE("Could not parse timestamp in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "magneticHeading" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "magneticHeading" ] === undefined )
		{
			NgLogE("Could not parse magneticHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "trueHeading" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "trueHeading" ] === undefined )
		{
			NgLogE("Could not parse trueHeading in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		obj[ "accuracy" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "accuracy" ] === undefined )
		{
			NgLogE("Could not parse accuracy in LocationEmitter.headingUpdated from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_startUpdatingLocationSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "accuracy" ] + "," + obj[ "distanceFilter" ]  );
	},
	
	/** @private */
	_stopUpdatingLocationSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 4 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_locationUpdatedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 5 + "," + this.__objectRegistryId + "," + obj[ "timestamp" ] + "," + obj[ "latitude" ] + "," + obj[ "longitude" ] + "," + obj[ "altitude" ] + "," + obj[ "accuracy" ]  );
	},
	
	/** @private */
	_startUpdatingHeadingSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 6 + "," + this.__objectRegistryId + "," + obj[ "orientation" ] + "," + obj[ "angularFilter" ]  );
	},
	
	/** @private */
	_stopUpdatingHeadingSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 7 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_headingUpdatedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 8 + "," + this.__objectRegistryId + "," + obj[ "timestamp" ] + "," + obj[ "magneticHeading" ] + "," + obj[ "trueHeading" ] + "," + obj[ "accuracy" ]  );
	},
	
	/** @private */
	_setPropertiesSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 9 + "," + this.__objectRegistryId + "," + obj[ "accuracy" ] + "," + obj[ "elements" ]  );
	},
	
	/** @private */
	_startUpdatingSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 10 + "," + this.__objectRegistryId + "," + ( obj[ "force" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_stopUpdatingSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 333 + "," + 11 + "," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// startUpdatingLocation: function( accuracy, distanceFilter ) {}
	
	// stopUpdatingLocation: function(  ) {}
	
	// _locationUpdatedRecv: function( cmd ) {}
	// locationUpdated: function( timestamp, latitude, longitude, altitude, accuracy ) {}
	
	// startUpdatingHeading: function( orientation, angularFilter ) {}
	
	// stopUpdatingHeading: function(  ) {}
	
	// _headingUpdatedRecv: function( cmd ) {}
	// headingUpdated: function( timestamp, magneticHeading, trueHeading, accuracy ) {}
	
	// setProperties: function( accuracy, elements ) {}
	
	// startUpdating: function( force ) {}
	
	// stopUpdating: function(  ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MemoryEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MemoryEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MemoryEmitter.prototype */
{
	classname: 'MemoryEmitter',
		
	/**
	 * @class The <code>MemoryEmitter</code> class constructs a singleton object that emits messages
	 * when a low memory warning is received from the system.
	 * Applications can respond by releasing unused objects, allowing the system to re-allocate free memory.
	 * Failure to respond to low memory warnings may result in application 
	 * termination by the operating system.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
	},
	
	_memoryEventRecv: function( cmd ) 
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._memoryEventSendGen();
	},
													  
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 331
	// Method create = -1
	// Method memoryEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._memoryEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MemoryEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[331] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_memoryEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in MemoryEmitter.memoryEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 331 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_memoryEventSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 331 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _memoryEventRecv: function( cmd ) {}
	// memoryEvent: function(  ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/MotionEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/MotionEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.MotionEmitter = Core.MessageEmitter.singleton(
/** @lends Device.MotionEmitter.prototype */
{
	classname: 'MotionEmitter',
	
	/**
	 * @class The <code>MotionEmitter</code> class constructs a singleton object that tracks device movement through 3D space. 
	 * These objects emit <a href="Device.MotionEmitter.Motion.html">Motion</a> objects that retrieve spatial data for a given component from the device.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @see Device.MotionEmitter.Motion
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);

		this._lastAccel = null;
		this._lastGyro  = null;
		this._lastCompass = null;
	},

	Motion: Core.Class.subclass(
	/** @lends Device.MotionEmitter.Motion.prototype */
	{
		classname: 'Motion',
		
		/**
		 * @class A <code>Motion</code> object is what <code>MotionEmitter</code> uses to capture device movement through 3D space.
		 * These objects retrieve data from device components on how a device responds to 
		 * physical movement, as reported by the accelerometer, gyroscope and compass instruments.
		 * @constructs The default constructor. 
		 * @param {Array (Number)} accel The accelerometer data.
		 * @param {Array (Number)} gyro The gyroscope data.
		 * @param {Array (Number)} compass The compass data.
		 * @see Device.MotionEmitter
		 * @augments Core.Class
		 */
		initialize: function(accel, gyro, compass)
		{
			this._accel = accel;
			this._gyro  = gyro;
			this._compass = compass;
		},
		
		/**
		 * Retrieve accelerometer data from the device. If the device contains an accelerometer,
		 * calling <code>getAccelData()</code> returns an array of three floating point values. In all other cases,
		 * calling <code>getAccelData()</code> returns <code>undefined</code>.
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a accelerometer. 
		 * @returns {Array (Number)} The accelerometer data for the device.
		 * @see Core.Capabilities#getHasAccel
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getAccelData: function()
		{
			return this._accel;
		},
		
		/**
		 * Retrieve gyroscope data from the device. If the device contains a gyroscope,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>. <br><br>
		 * <b>Note:</b> Use a <code>{@link Core.Capabilities</code> object 
		 * to programmatically check a device for a gyroscope. 
		 * @returns {Array (Number)} The gyroscope data for the device.
		 * @see Core.Capabilities#getHasGyro
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getGyroData: function()
		{
			return this._gyro;
		},
		
		/**
		 * Retrieve compass data from the device. If the device contains a magnetic compass,
		 * this call returns an array of three floating point values. In all other cases,
		 * this call returns <code>undefined</code>.<br><br>
		 * <b>Note:</b> Use a <code>Capabilities</code> object to programmatically check a device for a compass. 
		 * @returns {Array (Number)} The compass data for the device.
		 * @see Core.Capabilities#getHasCompass
		 * @status iOS, Android, Test, iOSTested, AndroidTested
		 */
		getCompassData: function()
		{
			return this._compass;
		},
	}),

	/**
	 * Construct a <code>MessageListener</code> object and register it with this <code>MotionEmitter</code> object. If an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.<br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter once.
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 *
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			// start the Accelerometer if this is the first listener
			this._startMotionSendGen(this);
		}

		$super(listener, func, priority);
	},

	/**
	 * Remove a <code>MessageListener</code> object from this <code>MotionEmitter</code> object. 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.	 
	 * @returns {Boolean} Returns <code>true</code> when the registered listener was removed. Returns <code>false</code> in all other cases.
	 * @see Core.MessageEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			// stop the Accelerometer if this is the last listener
			this._stopMotionSendGen(this);
		}
	},

	_emitMotion: function()
	{
		var motion = new Device.MotionEmitter.Motion(this._lastAccel, this._lastGyro, this._lastCompass);
		this.emit(motion);
	},

	_accelChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._accelChangedRecvGen(cmd, msg))
			return;

		this._lastAccel = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._accelChangedSendGen(msg);
	},

	_gyroChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._gyroChangedRecvGen(cmd, msg))
			return;

		this._lastGyro = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._gyroChangedSendGen(msg);
	},
	
	_magneticChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._magneticChangedRecvGen(cmd, msg))
			return;
		
 		this._lastCompass = msg;
		this._emitMotion();
		
		//Cascade the original message back out to native for forwarding
		this._magneticChangedSendGen(msg);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 330
	// Method create = -1
	// Method accelChanged = 2
	// Method gyroChanged = 3
	// Method magneticChanged = 4
	// Method startMotion = 5
	// Method stopMotion = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._accelChangedRecv( cmd );
					break;
				case 3:
					instance._gyroChangedRecv( cmd );
					break;
				case 4:
					instance._magneticChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in MotionEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[330] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_accelChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.accelChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_gyroChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.gyroChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_magneticChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		obj[ "z" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "z" ] === undefined )
		{
			NgLogE("Could not parse z in MotionEmitter.magneticChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 330 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_accelChangedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 330 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "x" ] + "," + obj[ "y" ] + "," + obj[ "z" ]  );
	},
	
	/** @private */
	_gyroChangedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 330 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "x" ] + "," + obj[ "y" ] + "," + obj[ "z" ]  );
	},
	
	/** @private */
	_magneticChangedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 330 + "," + 4 + "," + this.__objectRegistryId + "," + obj[ "x" ] + "," + obj[ "y" ] + "," + obj[ "z" ]  );
	},
	
	/** @private */
	_startMotionSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 330 + "," + 5 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopMotionSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 330 + "," + 6 + "," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _accelChangedRecv: function( cmd ) {}
	// accelChanged: function( x, y, z ) {}
	
	// _gyroChangedRecv: function( cmd ) {}
	// gyroChanged: function( x, y, z ) {}
	
	// _magneticChangedRecv: function( cmd ) {}
	// magneticChanged: function( x, y, z ) {}
	
	// startMotion: function(  ) {}
	
	// stopMotion: function(  ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/NetworkEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.NetworkEmitter = Core.MessageEmitter.singleton(
/** @lends Device.NetworkEmitter.prototype */
{
	classname: 'NetworkEmitter',
	
	/**
	 * @class The <code>NetworkEmitter</code> class constructs a singleton object that tracks network connectivity status for a device.
	 * These objects emit a <a href="Device.NetworkEmitter.html#Status">Status</a> object when a change to device network connectivity status occurs.
	 * A change in network status is defined as:
	 * <div class="ul"><font size="3">
	 * <li>The device loses access to a network.</li>
	 * <li>The device gains access to a network.</li>
	 * <li>The device switches between cellular and Wi-Fi network access.</li>
	 * </font></div><br>
	 * <p><b>Note:</b> Applications should never directly allocate a singleton.</p>
	 * @constructs The default constructor. 
	 * @see Device.NetworkEmitter#Status
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);

		this._lastStatus = null;
	},

	/**
	 * Retrieve the network status of the device.
	 * @returns {Device.NetworkEmitter#Status} The current device network status.
	 * @status iOS, Android, Test
	 */
	getLastStatus: function()
	{
		return this._lastStatus;
	},

	/** 
	 * Enumeration values for device network status.
	 * @fieldOf Device.NetworkEmitter.prototype
	 */
	Status:
	{
		/** 
		* <code>0</code> = No network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		None: 0,
		
		/** 
		* <code>1</code> = Cellular network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Cellular: 1,
		
		/** 
		* <code>2</code> = Wi-Fi network connectivity. 
		* @fieldOf Device.NetworkEmitter.prototype
		* @constant
		*/
		Wifi: 2,
	},

	_statusChangedRecv: function( cmd )
	{
		var msg = {};
		if (!this._statusChangedRecvGen(cmd, msg))
		    return;

		this._lastStatus = msg['status'];
		this.emit(this._lastStatus);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 336
	// Method create = -1
	// Method statusChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._statusChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in NetworkEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[336] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_statusChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		obj[ "status" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "status" ] === undefined )
		{
			NgLogE("Could not parse status in NetworkEmitter.statusChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 336 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _statusChangedRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/OrientationEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class OrientationEmitter
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.OrientationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.OrientationEmitter.prototype */
{
	classname: 'OrientationEmitter',
		
	/**
	 * @class The <code>OrientationEmitter</code> class constructs a singleton object that tracks the physical orientation of the device.
	 * These objects emit an object that contains <a href="Device.OrientationEmitter.html#OrientationType">Orientation type </a> and <a href="Device.OrientationEmitter.html#Orientation">Orientation</a>, when a change in device or interface orientation occurs.<br><br>
	 * Rotating the device does not necessarily rotate the 
	 * interface presented to the user. Applications must
	 * explicitly call <code><a href="Device.OrientationEmitter.html#setInterfaceOrientation">setInterfaceOrientation()</a></code> to rotate the interface.
	 * This allows an application to selectively choose a supported device orientation.
	 * For example, an application can observe orientation change events and change the interface orientation only if the application suppoorts it.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 	 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);

		this._lastDeviceOrientation    = this.Orientation.Portrait;
		this._lastInterfaceOrientation = this.Orientation.Portrait;
	},
	
	/**
	 * Retrieve the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current device orienation.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getDeviceOrientation: function()
	{
		return this._lastDeviceOrientation;
	},
	
	/**
	 * Retrieve the interface orientation. Initially, this is the same
	 * as the device orientation.
	 * @returns {Device.OrientationEmitter#Orientation} The current interface orientation.
	 * @see Device.OrientationEmitter#setInterfaceOrientation
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getInterfaceOrientation: function()
	{
		return this._lastInterfaceOrientation;
	},
	
	/**
	 * Set the interface orientation.
	 * @example var orientation = new Device.OrientationEmitter(Device.OrientationEmitter.Orientation.Portrait, true);
	 * @param {Device.OrientationEmitter#Orientation} orientation The new device orientation.
	 * @param {Boolean} [animated] Set as <code>true</code> to render the orientation change with an animated effect.
	 * @see Device.OrientationEmitter#getInterfaceOrientation
	 * @status iOS, Test
	 */
	setInterfaceOrientation: function(orientation, animated)
	{
		if (orientation != this._lastInterfaceOrientation)
		{
			NgLogD("setInterfaceOrientation to " + orientation);
			this._setInterfaceOrientationSendGen( { "orientation": orientation, "animated": animated } );
			this._lastInterfaceOrientation = orientation;
		}
	},
	
	/**
	 * Enumeration for device orientation.
	 * @fieldOf Device.OrientationEmitter.prototype
	 */
	Orientation:
	{ 
		/** 
		* Portrait orientation. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Portrait: 0,
		/** 
		* Portrait orientation, but rotated 180 degrees. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		PortraitUpsideDown: 1,
		/** 
		* Landscape orientation with the top of the device to the left. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeLeft: 2,
		/** 
		* Landscape orientation with the top of the device to the right. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		LandscapeRight: 3,
		/** 
		* Oriented with the face of the device up. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceUp: 4,
		/** 
		* Oriented with the face of the device down. 
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		FaceDown: 5,
	},

	/**
	 * Enumeration for orientation type.
	 * It can be used to identify which event happens.
	 * @filedOf Device.OrientationEmitter.prototype
	 */
	OrientationType:
	{
		/**
		* Device orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Device: 0,
		/**
		* Interface orientation has changed.
		* @fieldOf Device.OrientationEmitter.prototype
		* @constant
		*/
		Interface: 1
	},

	_orientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._orientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastDeviceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Device, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._orientationChangedSendGen(msg);
	},
	
	_interfaceOrientationChangedRecv: function( cmd )
	{
		var msg = {};
		if(!this._interfaceOrientationChangedRecvGen(cmd, msg))
			return;
 
 		this._lastInterfaceOrientation = msg['orientation'];
		this.emit({type: this.OrientationType.Interface, orientation:msg['orientation']});
		
		//Cascade the original message back out to native for forwarding
		this._interfaceOrientationChangedSendGen(msg);
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 335
	// Method create = -1
	// Method orientationChanged = 2
	// Method setInterfaceOrientation = 3
	// Method interfaceOrientationChanged = 4
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._orientationChangedRecv( cmd );
					break;
				case 4:
					instance._interfaceOrientationChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in OrientationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[335] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_orientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.orientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_interfaceOrientationChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		obj[ "orientation" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "orientation" ] === undefined )
		{
			NgLogE("Could not parse orientation in OrientationEmitter.interfaceOrientationChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 335 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_orientationChangedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 335 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "orientation" ]  );
	},
	
	/** @private */
	_setInterfaceOrientationSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 335 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "orientation" ] + "," + ( obj[ "animated" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_interfaceOrientationChangedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 335 + "," + 4 + "," + this.__objectRegistryId + "," + obj[ "orientation" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _orientationChangedRecv: function( cmd ) {}
	// orientationChanged: function( orientation ) {}
	
	// setInterfaceOrientation: function( orientation, animated ) {}
	
	// _interfaceOrientationChangedRecv: function( cmd ) {}
	// interfaceOrientationChanged: function( orientation ) {}
	

// {{/Wg Generated Code}} }}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/ShakeEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var MotionEmitter = require('NGCore/Client/Device/MotionEmitter').MotionEmitter;

var ProxyListener = Core.MessageListener.subclass(
{
	onUpdate: function() {}
});

exports.ShakeEmitter = Core.MessageEmitter.singleton(
/** @lends Device.ShakeEmitter.prototype */
{
	classname: 'ShakeEmitter',
		
	/**
	 * @class The <code>ShakeEmitter</code> class constructs a singleton object that tracks when users physically shake the device. 
	 * These objects emit messages when the device recognizes a shake gesture.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @status iOS, Android
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
		this._proxyListener = new ProxyListener();
		
	},
	
	/**
	 * Add a <code>MessageListener</code> to this emitter. When an application calls <code>emit()</code> 
	 * or <code>chain()</code> 
	 * on this emitter, a callback function passed as a parameter is called on the specified listener.
	 * The parameters for the callback function are identical to parameters for <code>emit()</code> or
	 * <code>chain()</code>.
	 * <br><br>
	 * <b>Note:</b> Each listener can only listen to an emitter one time.<br><br>
	 * The following code examples illustrate different call styles for <code>addListener()</code>.
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onCallback);
	 *
	 * @example
	 * emitter.addListener(myListener, myListener.onEvent, 200);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to add.
	 * @param {Function} func The callback function.
	 * @param {Number} [priority=0] The priority for this <code>MessageListener</code>.
	 * @throws {MessageEmitter.addListener: listener is already listening} Calling <code>addListener()</code> multiple times on the same emitter
	 * with the same listener.
	 * @throws {MessageEmitter.addListener: listener must be instances of MessageListener} Listener is not an instance of <code>MessageListener</code>.
	 * @see Device.ShakeEmitter#removeListener,
	 * @see Core.MessageEmitter#emit,
	 * @see Core.MessageEmitter#chain
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	addListener: function($super, listener, func, priority)
	{
		if (this.getListenerCount() == 0) {
			MotionEmitter.addListener(this._proxyListener, function(){});
		}

		$super(listener, func, priority);
	},
	
	/**
	 * Remove a <code>MessageListener</code> from this emitter.<br><br> 
	 * The following code examples illustrate different call styles for <code>removeListener()</code>.
	 * @example
	 * emitter.removeListener(myListener, myListener.onCallback);
	 * @example
	 * emitter.removeListener(myListener);
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.MessageListener} listener The <code>MessageListener</code> to remove.
	 * @returns {Boolean} Returns <code>true</code> if the registered listener was removed. Returns <code>false</code> if the registered listener is not found 
	 * or is not registered with this emitter.
	 * @throws {MessageEmitter.removeListener: listener is not listening} Specified listener is not currently registered
	 * with this emitter.
	 * @see Device.ShakeEmitter#addListener
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	removeListener: function($super, listener)
	{
		$super(listener);

		if (this.getListenerCount() == 0) {
			MotionEmitter.removeListener(this._proxyListener);
		}
	},
	
	_shakeRecv: function( cmd )
	{
		this.emit();
		
		//Cascade the original message back out to native for forwarding
		this._shakeSendGen();
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 332
	// Method create = -1
	// Method shake = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._shakeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ShakeEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[332] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_shakeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ShakeEmitter.shake from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 332 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_shakeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 332 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _shakeRecv: function( cmd ) {}
	// shake: function(  ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/KeyEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/KeyEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;
var UI = require('NGCore/Client/UI').UI;

////////////////////////////////////////////////////////////////////////////////

// Private Class Statics
var keyCodeReverseMap = null;

exports.KeyEmitter = Core.MessageEmitter.singleton(
/** @lends Device.KeyEmitter.prototype */
{
	classname: 'KeyEmitter',

	/**
	 * @class The <code>KeyEmitter</code> class constructs a singleton object that emits a <code><a href="Device.KeyEmitter.KeyEvent.html">KeyEvent</a></code> object 
	 * when the user presses or releases a device hardware key.<br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.MessageEmitter
	 * @require Device
	 * @example
	 *
	 * var KeyListener = Core.MessageListener.subclass({
	 *   onUpdate: function(keyEvent) {
	 *     // back to the launcher when the back button is pressed
	 *     if (keyEvent.code === Device.KeyEmitter.Keycode.back) {
	 *        this.destroy();
	 *        LGL.runUpdatedGame('/Samples/Launcher');
	 *        return;
	 *     }
	 *
	 *     var text = '';
	 *     switch (keyEvent.type) {
	 *        case Device.KeyEmitter.EventType.onDown:
	 *           text += 'onDown :'
	 *           break;
	 *        case Device.KeyEmitter.EventType.onUp:
	 *           text += 'onUp :'
	 *           break;
	 *     }
	 *
	 *     text += Device.KeyEmitter.keyCodeToSymbol(keyEvent.code);
	 *     console.log(text);
	 *   }
	 * };
	 *
	 * var keyListener = new KeyListener();
	 * Device.KeyEmitter.addListener(keyListener, keyListener.onUpdate);
	 *
	 * @status Android, Test, AndroidTested
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
	},

	/**
	 * Convert a keycode into the equivalent human-readable symbol. The keycode to convert is passed in as a parameter.
	 * The following code example illustrates how to convert a keycode into a human-readable symbol.
	 * @param {String} keyCode The keycode to convert.
	 * @static
	 *
	 * @example
	 *   var symbol = Device.KeyEmitter.keyCodeToSymbol(0x1d);
	 *   // symbol => 'a'
	 *
	 * @status
	 */
	keyCodeToSymbol: function(keyCode)
	{
		if (!keyCodeReverseMap) {
			keyCodeReverseMap = {};
			for (var codename in this.Keycode) {
				keyCodeReverseMap[this.Keycode[codename]] = codename;
			}
		}
		return keyCodeReverseMap[keyCode] || '';
	},

	KeyEvent: Core.Class.subclass(
	/** @lends Device.KeyEmitter.KeyEvent.prototype */
	{
		classname: 'KeyEvent',

		/**
		 * @class <code>KeyEvent</code> constructs objects that contain the parcel of a keyboard event. 
		 * The keycode of the key that triggered the event is passed in as a parameter.
		 * @constructs The default constructor. 
		 * @augments Core.Class
		 * @param {Device.KeyEmitter.EventType} type The type of the keyboard event.
		 * @param {Integer} modifiers the bit-and of {@link Device.KeyEmitter#Modifier} combination.
		 * @param {Device.KeyEmitter.Keycode} code The actual keycode.
		 */
		initialize: function(type, modifiers, code)
		{
			this.type      = type;
			this.modifiers = modifiers;
			this.code      = code;
		}
	}),

	_onKeyEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onKeyEventRecvGen(cmd, msg))
			return;

		var keyEvent = new Device.KeyEmitter.KeyEvent(msg.type, msg.modifiers, msg.code);
		
		if(!this.chain(keyEvent)) {
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onKeyEventSendGen(msg);
		}
	},

// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Event type Enums.
	 * Currently we only have onUp and onDown events.
	 *
	 * @namespace
	 * */
	EventType:
	{ 
		/** the key is hooked up. */
		onUp: 0,
		/** the key is pressed down. */
		onDown: 1,
	},
	
	/** 
	 * Enums for modifiers that are being pressed.
	 * They are passed as bit-and-ed.
	 *
	 * @namespace
	 * @example
	 *
	 * var keyEvent; // emitted from KeyEmitter
	 * if (keyEvent.modifiers & Device.KeyEmitter.Modifier.ALT && 
	 *     keyEvent.modifiers & Device.KeyEmitter.Modifier.SHIFT)
	 *    console.log("ALT+SHIFT");
	 * */
	Modifier:
	{ 
		/** no modifiers */
		NONE: 0,
		/** SYMBOL modifier */
		SYMBOL: 1 << 0,
		/** ALT modifier */
		ALT: 1 << 1,
		/** ALT_LEFT modifier */
		ALT_LEFT: 1 << 2,
		/** ALT_RIGHT modifier */
		ALT_RIGHT: 1 << 3,
		/** SHIFT modifier */
		SHIFT: 1 << 4,
		/** SHIFT_LEFT modifier */
		SHIFT_LEFT: 1 << 5,
		/** SHIFT_RIGHT modifier */
		SHIFT_RIGHT: 1 << 6,
	},
	
	/** 
	 * Keycode Enums.
	 * Define bunch of key codes.
	 * @namespace
	 * */
	Keycode:
	{ 
		/** * */
		a: 0x1d,
		/** * */
		b: 0x1e,
		/** * */
		c: 0x1f,
		/** * */
		d: 0x20,
		/** * */
		e: 0x21,
		/** * */
		f: 0x22,
		/** * */
		g: 0x23,
		/** * */
		h: 0x24,
		/** * */
		i: 0x25,
		/** * */
		j: 0x26,
		/** * */
		k: 0x27,
		/** * */
		l: 0x28,
		/** * */
		m: 0x29,
		/** * */
		n: 0x2a,
		/** * */
		o: 0x2b,
		/** * */
		p: 0x2c,
		/** * */
		q: 0x2d,
		/** * */
		r: 0x2e,
		/** * */
		s: 0x2f,
		/** * */
		t: 0x30,
		/** * */
		u: 0x31,
		/** * */
		v: 0x32,
		/** * */
		w: 0x33,
		/** * */
		x: 0x34,
		/** * */
		y: 0x35,
		/** * */
		z: 0x36,
		/** TBD */
		up: 0x13,
		/** TBD */
		down: 0x14,
		/** TBD */
		left: 0x15,
		/** TBD */
		right: 0x16,
		/** * */
		enter: 0x42,
		/** * */
		backspace: 0x43,
		/** * */
		back: 0x04,
		/** backunhandled: 0x54, Special KeyCode to tell MobageService that the back was unhandled by the game, after the service declined first dibs. Stole MAX_KEYCODE (deprecated constant). */
		backunhandled: 0x54,
		/** * */
		menu: 0x52,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 343
	// Method create = -1
	// Method onKeyEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onKeyEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in KeyEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[343] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onKeyEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "type" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "type" ] === undefined )
		{
			NgLogE("Could not parse type in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "modifiers" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "modifiers" ] === undefined )
		{
			NgLogE("Could not parse modifiers in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		obj[ "code" ] = Core.Proc.parseInt( cmd[ 2 ] );
		if( obj[ "code" ] === undefined )
		{
			NgLogE("Could not parse code in KeyEmitter.onKeyEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 343 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_onKeyEventSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 343 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "type" ] + "," + obj[ "modifiers" ] + "," + obj[ "code" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onKeyEventRecv: function( cmd ) {}
	// onKeyEvent: function( type, modifiers, code ) {}
	

// {{/Wg Generated Code}}

});
// vim:set fdm=marker noexpandtab:
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_PushNotificationEmitter'] = exports; var Core = require('NGCore/Client/Core').Core;

/*
	NOTE: 	THIS IS FOR INTERNAL USE ONLY AND WILL BE DEPRECATED IN THE FUTURE.
			DO NOT USE IT IN ANY OF YOUR CODE.
*/

exports.PushNotificationEmitter = Core.MessageEmitter.singleton(
/** @lends Device.PushNotificationEmitter.prototype */
{
	classname: 'PushNotificationEmitter',
		
	/**
	 * @class Emits when native code recieves a push notification
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
	},
	
	_onPushNotificationRecv: function( cmd )
	{
		var msg = {};
		if (!this._onPushNotificationRecvGen(cmd, msg))
			return;
			
		this._lastMsgPayload = msg.msgPayload;
		
		if(!this.chain(msg.msgPayload))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPushNotificationSendGen(msg);
		}
		
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 345
	// Method create = -1
	// Method onPushNotification = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPushNotificationRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in PushNotificationEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[345] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPushNotificationRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		obj[ "msgPayload" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "msgPayload" ] === undefined )
		{
			NgLogE("Could not parse msgPayload in PushNotificationEmitter.onPushNotification from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 345 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_onPushNotificationSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 345 + "," + 2 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "msgPayload" ] )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPushNotificationRecv: function( cmd ) {}
	// onPushNotification: function( msgPayload ) {}
	

// {{/Wg Generated Code}}	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchaseEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchaseEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchaseEmitter = Core.MessageEmitter.singleton(
/** @lends Device.InAppPurchaseEmitter.prototype */
{
	classname: 'InAppPurchaseEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
	},
	
	_onPurchaseEventRecv: function( cmd ) {
		var msg = {};
		if (!this._onPurchaseEventRecvGen(cmd, msg))
			return;
		if(!this.chain(msg.err, msg.data, msg.verificationToken))	{
			//Noone handled this keyEvent. Cascade the original back out to native for forwarding
			//	to the next interpreter in the chain.
			this._onPurchaseEventSendGen(msg);
		}
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 347
	// Method create = -1
	// Method onPurchaseEvent = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._onPurchaseEventRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchaseEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[347] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onPurchaseEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "err" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "err" ] === undefined )
		{
			NgLogE("Could not parse err in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "data" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "data" ] === undefined )
		{
			NgLogE("Could not parse data in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		obj[ "verificationToken" ] = Core.Proc.parseString( cmd[ 2 ] );
		if( obj[ "verificationToken" ] === undefined )
		{
			NgLogE("Could not parse verificationToken in InAppPurchaseEmitter.onPurchaseEvent from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 347 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_onPurchaseEventSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 347 + "," + 2 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "err" ] ) + "," + Core.Base64.encode( obj[ "data" ] ) + "," + Core.Base64.encode( obj[ "verificationToken" ] )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _onPurchaseEventRecv: function( cmd ) {}
	// onPurchaseEvent: function( err, data, verificationToken ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/_InAppPurchase'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class InAppPurchase
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Client/Core/Class').Class;
var DeviceReq = require('NGCore/Client/Device');
var Localization = require('NGCore/Client/Core/Localization').Localization;

////////////////////////////////////////////////////////////////////////////////

exports.InAppPurchase = Class.singleton(
/** @lends Device.InAppPurchase.prototype */
{
	classname: 'InAppPurchase',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
	},

	initService: function(ordercb, donecb) {
		if ((!this._isIOS()) && (!this._isAndroid())) {
			NgLogE("ERROR: Neither Android nor iOS platform, IAP will not work");
			donecb();
			return;
		}
		if (!this._iapInited) {
			var IAPListener = Core.MessageListener.subclass({
				onPurchaseEvent: this._iapCallback.bind(this)
			});
			// Register for Android / iOS IAP callbacks the same way
			this.listener = new IAPListener();
	        DeviceReq.Device.InAppPurchaseEmitter.addListener(
				this.listener, this.listener.onPurchaseEvent);
	    	// listener will be called when purchase state changes
		}
		this._initDonecb = donecb;
		this._initOrdercb = ordercb;
		if (this._isAndroid()) {
			this._iapCallback('morenonces', '', '');
			/*
			 * Gets persisted unfulfilled orders, calls back ordercb for each
			 * unfulfilled order.
			 */
			var self = this;
			Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			function(err, currorders) {
	   			if (currorders && (currorders.length > 0)) {
					var orders = JSON.parse(currorders);
   					// _restoreOrders eventually calls _initService when fully
					// done.
					self._restoreOrders(orders);
				} else {
					self._initService();
				}
			});
		} else {
			// _isIOS - call _initService directly.  It will call back with
			// orphaned order if any.
			this._initService();
		}
	},

	launchPurchaseView: function(productID, quantity, purchasecb, failcb, cancelcb) {
		if (!this._iapInited) {
			NgLogE("ERROR: function initService must be called and its donecb " +
			"called back, before launchPurchaseView may be used.");
			failcb(false, "failed:initservice_not_done");
			return;
		}

		this._currentOrderProductID = productID;

		this._currentOrderCancelcb = cancelcb;
		this._currentOrderFailcb = failcb;
		this._currentOrderPurchasecb = purchasecb;

		// Android IAB currently only supports quantity of 1
		if (quantity !== 1 && this._isAndroid()) {
			failcb(false, "failed:unsupported_quantity");
			return;
		}

		// Place progress dialog underneath the IAB view first
        if(this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.ProgressDialog()).retain();
	        this._currentOrderProgressDialog.setText(Localization.getString("Processing Order"));
        } else if(!this._isIOS()) {
	        this._currentOrderProgressDialog = (new UI.AlertDialog()).retain();
	        this._currentOrderProgressDialog.setTitle(Localization.getString("Processing Order"));
            // todo: localization???
            this._currentOrderProgressDialog.setText(
                "Your order is being processed. You will receive a confirmation momentarily.");
            this._currentOrderProgressDialog.setChoices(["OK"]);
            this._currentOrderProgressDialog.onchoice = function(event) {
                this._currentOrderProgressDialog.release();
                this._currentOrderProgressDialog = null;
            };
        }

	    this._currentOrderProgressDialog.show();

		if (this._isIOS() || this._isAndroid()) {
	        DeviceReq.Device.InAppPurchase._requestPurchase(productID, quantity);
			// Note that _iapCallback will call the *cb callback function(s)
			return;
		}
	    this._currentOrderProgressDialog.hide();
        this._currentOrderProgressDialog.release();
	    this._currentOrderProgressDialog = undefined;
		NgLogE('launchPurchaseView failed: only Android and iOS platforms are currently supported.');
		failcb(false, "failed:unsupported_platform");
		return;
	},

	pushSingleNonce: function(nonce){
		var noncePool = [];
		noncePool.push(nonce);
		this._fillIABNoncePool(JSON.stringify(noncePool));
	},

	/**
	 * get a product information specified by productId.
	 * @param {String} productId the product ID registered at iTunes connect.
	 * @param {Function} callback called back when it gets a response. The signature for the callback is equivalent to:<br><br>
	 * <pre>function(productData, err)</pre><br>
	 * The <code>productData</code> is an product information like "JPY,115.000000".
	 * When something bad happenes, <code>err</code> is set to the error message. Otherwise, err will be null or undefined.
	 * @status iOS, iOSTested
	 */
	getProductInformation: function(productId, callback) {
		var obj = {productId:productId};
		this._getProductInformationCB = callback;
		this._getProductInformationSendGen(obj);
	},

	/*
	 * For Google IAB, these constants come from
	 * Consts.java in IAB sample code
	 *
	 *	public enum PurchaseState {
     *   PURCHASED,   // User was charged for the order. -- 0
     *   CANCELED,    // The charge failed on the server. -- 1
	 *   REFUNDED;    // User received a refund for the order. -- 2
	 */
	_IAB_PURCHASED: 0,
	_IAB_CANCELED: 1,
	_IAB_REFUNDED: 2,
	_IAB_ORPHANED: "com.ngmoco.in_app_purchase.iab_orphaned_orders",

	_capIsAndroid: undefined,
	_capIsIOS: undefined,

	// at most one outstanding order is supported
	_currentOrderCancelcb : undefined,
	_currentOrderFailcb : undefined,
	_currentOrderProductID : undefined,
	_currentOrderProgressDialog : undefined,
	_currentOrderPurchasecb : undefined,

	_initDonecb : undefined,
	_initOrdercb : undefined,
	_iapInited: false,

	_generateIABNonce: function(){
		var timestamp = new Date().getTime();
		var random = Math.floor(Math.random() * 1000);
		var nonce = (timestamp * 1000) + random;
		NgLogD("Generated nonce: " + nonce);
		return nonce;
	},

	_iapCallback: function( err, data, verificationToken ) {
		if (err == 'morenonces') {
			var count = 10;
			var noncePool = [];
			while(noncePool.length < count){
				noncePool.push(this._generateIABNonce());
			}
			this._fillIABNoncePool(JSON.stringify(noncePool));
			return true;
		}
		if ((err == 'initdone') || (err == 'initcheckdone')) {
			if (typeof this._initDonecb == 'function') {
				this._iapInited = true;
				this._initDonecb();
				this._initDonecb = undefined;
				this._initOrdercb = undefined;
			} else {
				NgLogW("WARN: " + err + " callback with empty donecb");
			}
	        // at most one listener gets iap events
	        return true;
		}
		if (err == 'getProductInformationDone') {
			if (data && data.length > 0) {
				var datajsonp = JSON.parse(data);
				this._getProductInformationCB(datajsonp.productId);
			} else {
				this._getProductInformationCB('', "no information on this product");
			}
			this._getProductInformationCB = undefined;
			return true;
		}
		var orderId = undefined;
		var prodId = "";
	    var firstOrder = undefined;
	    var datajson = undefined;
		if (data && data.length > 0) {
		    datajson = JSON.parse(data);
		    if ((typeof datajson.orders == 'undefined') ||
		        (datajson.orders.length <= 0)) {
		        // callback with no orders, try to get prodId
			    if (typeof datajson.productId != 'undefined') {
					prodId = datajson.productId.toUpperCase();
				}
		    } else {
 				if (this._isAndroid() &&
				 	(typeof this._currentOrderProgressDialog == 'undefined')) {
						// this callback comes in 'out of band', when user did
						// not attempt a purchase.  This happens on Android
						// when async callbacks are not confirmed due to
						// connectivity issue.  This callback is persisted for
						// the next 'initService' call to pick up. Only
						// successful orders will be used in callbacks.
						// Failed order and refunds are ignored.
						//
						// Note also that Android IAB could callback with
						// duplicate order numbers.  In other words, the same
						// order number could come back twice in 2 different
						// callbacks.  There is no code on client to detect
						// such duplicate.  It is up to the server to detect
						// orders which have already been fulfilled.
						//
						var successOrders = this._filterSuccessOrders(datajson, verificationToken);
						if (successOrders.length > 0) {
							this._persistOrphanedOrders(successOrders);
						}
						return true;
				} else if (datajson.orders.length === 1) {
					// on iOS, and in common cases on Android, there is at
					// most one order
				    firstOrder = datajson.orders[0];
					prodId = firstOrder.productId.toUpperCase();
					orderId = firstOrder.orderId;
				} else {
					var successOrders2 = this._filterSuccessOrders(datajson, verificationToken);
					// on Android, get the first match.  Then add any orphaned
					// orders to existing list of persisted
					// orders.  These will be processed during next initService
					if (successOrders2.length > 0) {
					    firstOrder = successOrders2.shift();
						prodId = firstOrder.productId.toUpperCase();
						orderId = firstOrder.orderId;
						if (successOrders2.length > 0) {
							this._persistOrphanedOrders(successOrders2);
						}
					}
				}
			}
		}
		if (this._currentOrderProductID != prodId) {
			NgLogW("iapCallback: product id mismatch in callback.  Req: '" +
					this._currentOrderProductID + "' CB:'" + prodId + "'");
		}
		if ((err && (err.length > 0)) || (firstOrder && firstOrder.purchaseState &&
			(firstOrder.purchaseState !== this._IAB_PURCHASED))) {
			if (firstOrder && firstOrder.purchaseState &&
				(firstOrder.purchaseState === this._IAB_REFUNDED)) {
				// refunds are generated 'out of the blue' by merchant and is
				// not part of normal flow.  Hence it is ignored.  Code now
				// continues to wait for actual purchase callback
				NgLogD("iapCallback: ignoring refunded order: " +
						JSON.stringify(firstOrder));
				return true;
			}
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
                this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}

			if (err == 'cancelled') {
				if ((typeof this._currentOrderCancelcb) == 'function') {
					this._currentOrderCancelcb();
					this._currentOrderCancelcb = undefined;
				}
			} else {
				if (err) {
					NgLogD("DEBUG: iapCallback: got error: " + err);
				} else {
					// _IAB_CANCELED
					NgLogD("DEBUG: iapCallback: got canceled purchaseState.");
				}
				if ((typeof this._currentOrderFailcb) == 'function') {
					this._currentOrderFailcb(false, err);
					this._currentOrderFailcb = undefined;
				}
			}

	        // at most one listener gets iap events
	        return true;
	    }
		if (typeof firstOrder == 'undefined') {
			// there was no (non-refunded) order in callback
			return true;
		}
	    var nextcb2 = function(cbIsDone) {
			if (typeof this._currentOrderProgressDialog != 'undefined') {
				this._currentOrderProgressDialog.hide();
		        this._currentOrderProgressDialog.release();
				this._currentOrderProgressDialog = undefined;
			}
		    if (cbIsDone !== false) {
				return;
			}
			// Currently, fail if the first try is not done, no retry
			if ((typeof this._currentOrderFailcb) == 'function') {
				this._currentOrderFailcb(true, "failed:no_more_retry");
				this._currentOrderFailcb = undefined;
			}
	    };
		if ((typeof this._currentOrderPurchasecb) == 'function') {
			var receipt = verificationToken;
			if (this._isAndroid()) {
				// on Android, both the data and signature are required
				// for verification
				var receiptj = {
					data: data,
					signature: verificationToken
				};
				receipt = JSON.stringify(receiptj);
			}
		    this._currentOrderPurchasecb(prodId, orderId, receipt, firstOrder, nextcb2.bind(this));
			this._currentOrderPurchasecb = undefined;
		} else if ((!this._iapInited) && ((typeof this._initOrdercb) ==
		 			'function')) {
			var initcb2 = function(){
				// Do nothing on iOS as Store Observer simply emits
				// asychronously until done.
			};
			// part of initService flow
		    this._initOrdercb(prodId, orderId, verificationToken, firstOrder,
			initcb2);
		}
        // at most one listener gets iap events
        return true;
    },

	_isAndroid: function() {
		if (typeof this._capIsAndroid != 'undefined') {
			return this._capIsAndroid;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'android')) {
	        this._capIsAndroid = true;
	    } else {
	        this._capIsAndroid = false;
		}
		return this._capIsAndroid;
	},

	_isIOS: function() {
		if (typeof this._capIsIOS != 'undefined') {
			return this._capIsIOS;
		}
		// Find out from capabilities
	    var capabilities = Core.Capabilities;
	    if ((typeof capabilities.getPlatformOS() != "undefined") &&
	        (capabilities.getPlatformOS().toLowerCase() == 'iphone os')) {
	        this._capIsIOS = true;
	    } else {
	        this._capIsIOS = false;
		}
		return this._capIsIOS;
	},

	_fillIABNoncePool: function(nonces) {
		var obj = {};
		obj.nonces = nonces;
		this._fillIABNoncePoolSendGen(obj);
	},
	_filterSuccessOrders: function(datajson, verificationToken) {
		var successOrders = [];
		for (var kdx in datajson.orders) {
			if ((datajson.orders[kdx].purchaseState) &&
				(datajson.orders[kdx].purchaseState ===
					this._IAB_PURCHASED)) {
				var theorder = datajson.orders[kdx];
				theorder.verificationToken = verificationToken;
				successOrders.push(theorder);
			}
		}
		return successOrders;
	},
	_persistOrphanedOrders: function(successOrders) {
		// add orders to existing list of persisted orders
		Storage.KeyValueCache.local.getItem(this._IAB_ORPHANED,
			(function(err, currorders){
				if (currorders && (currorders.length > 0)) {
					var orderlist = JSON.parse(currorders);
					for (var idx in orderlist) {
						successOrders.push(orderlist[idx]);
					}
				}
			    Storage.KeyValueCache.local.setItem(this._IAB_ORPHANED,
					JSON.stringify(successOrders), function(){
					NgLogD("Orphaned orders added to persistent store: " + JSON.stringify(successOrders));
			    });
			}).bind(this));
	},
	_initService: function() {
		var obj = {};
		this._initServiceSendGen(obj);
	},

	_requestPurchase: function( sku, quantity ) {
		var obj = {};
		obj.sku = sku;
		obj.quantity = quantity;
		this._requestPurchaseSendGen(obj);
	},

	/*
	 * Given unfulfilled orders, calls back ordercb for each unfulfilled order.
	 * Resets persisted store using removeItem when done, then call
	 * _initService to continue init process.
	 */
	_restoreOrders: function(orders) {
		var self = this;
		if (orders.length <= 0) {
			// No more unfulfilled orders
			Storage.KeyValueCache.local.removeItem(this._IAB_ORPHANED,
			function() {
				self._initService();
			});
			return;
		}
		var order = orders.pop();
		var cb = function() {
			self._restoreOrders(orders);
		};
		// part of initService flow
		this._initOrdercb(order.productId.toUpperCase(), order.orderId, order.verificationToken, order, cb.bind(this));
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 348
	// Method create = -1
	// Method initService = 2
	// Method requestPurchase = 3
	// Method fillIABNoncePool = 4
	// Method getProductInformation = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in InAppPurchase._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[348] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 348 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_initServiceSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 348 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_requestPurchaseSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 348 + "," + 3 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "sku" ] ) + "," + obj[ "quantity" ]  );
	},
	
	/** @private */
	_fillIABNoncePoolSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 348 + "," + 4 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "nonces" ] )  );
	},
	
	/** @private */
	_getProductInformationSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 348 + "," + 5 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "productId" ] )  );
	}
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// initService: function(  ) {}
	
	// requestPurchase: function( sku, quantity ) {}
	
	// fillIABNoncePool: function( nonces ) {}
	
	// getProductInformation: function( productId ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/IPCEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/IPCEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class IPCEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////

var Core = require('NGCore/Client/Core').Core;
var Class          = require('NGCore/Client/Core/Class').Class;
var Proc           = require('NGCore/Client/Core/Proc').Proc;
var ObjectRegistry = require('NGCore/Client/Core/ObjectRegistry').ObjectRegistry;
var Base64         = require('NGCore/Client/Core/Base64').Base64;
var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

////////////////////////////////////////////////////////////////////////////////

exports.IPCEmitter = MessageEmitter.singleton(
/** @lends Device.IPCEmitter.prototype */
{

	classname: 'IPCEmitter',

	/**
	 * @class The IPCEmitter class constructs a singleton object that handles Inter-Process Communication. 
	 * These objects emit events when a specified application is launched from within another application.
	 * @constructs The default constructor.
	 * @augments Core.MessageEmitter
	 */
	initialize: function()
	{
		console.log('IPCEmitter.initialize');
		this._callbackID = 0;
		this._callbacks = [];
		
		this._shouldEmitIntents = false;

		ObjectRegistry.register(this);
		this._createSendGen(this);
	},

	/**
	 * Check whether the host OS can launch the provided URL asynchronously.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.canLaunch(appToLaunch, function(canLaunch) {
	 * 	if (canLaunch) {
	 * 		console.log('launching... ' + canLaunch);
	 * 		Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 			label.setText('failed in launching the URL:' + appToLaunch);
	 * 		});
	 * 	} else {
	 * 		label.setText('cannot launch the URL:' + appToLaunch);
	 * 	}
	 * });
	 * @param {String} url A URL to test
	 * @param {Function} callback A callback function that passes a Boolean value when a result is returned. 
	 * If the URL is OK to launch, the callback returns <code>true</code>.
	 * @status
	 */
	canLaunch: function(url, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._canLaunchSendGen({url:url, callbackID:this._callbackID});
		this._callbackID++;
	},

	/**
	 * Request that the host OS launch the provided URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx'
	 * Device.IPCEmitter.launch(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url A URL to launch
	 * @param {Function} errCallback A callback function that passes an error object when an error occurs. 
	 * If the URL is successfully launched, no callback. Otherwise, the callback returns an error.
	 */
	launch: function(url, callback)
	{
		 this._callbacks[this._callbackID] = callback;
		 this._launchSendGen({url:url, callbackID:this._callbackID});
		 this._callbackID++;
	},

	launchIntent: function( intent, extras )
	{
		this._launchIntentSendGen({intent:intent, extras:extras});
	},
	
	launchService: function( intent, extras )
	{
		this._launchServiceSendGen({intent:intent, extras:extras});
	},

	/**
	 * Launch a Single Sign-on URL.
	 * @example var appToLaunch = 'mobage//auth?packageName=xxx.xxx&className=xxx.xxx';
	 * Device.IPCEmitter.launchForSSO(appToLaunch, function(error) {
	 * 	label.setText('failed in  launching the URL:' + appToLaunch);
	 * });
	 * @param {String} url The URL to launch. The URL must include the following as part of the query string: packageName=xxxx&className=yyyy.
	 * @param {Function} callback The callback function. 
	 * @status
	 */
	launchForSSO: function(url, callback)
	{
		url += '&sso_auth';
		this.launch(url, callback);
	},

	/**
	 * Return an array of signatures for the packageName.
	 * @param {String} packageName packageName is like "com.ngmoco.gamejs"
	 * @param {Function} callback callback function signature: function(signatures) { }
	 * @status Android
	 */
	getAppSignatures: function(packageName, callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getAppSignaturesSendGen({packageName:packageName, callbackID:this._callbackID});
		this._callbackID++;
	},

	/**
	 * Return the package name that invokes this ngCore app.
	 * @param {Function} callback The current callback function. Below is the callback signature. 
	 * @example function(packageName) { }
	 * @status Android
	 */
	getCallingPackage: function(callback)
	{
		this._callbacks[this._callbackID] = callback;
		this._getCallingPackageSendGen({callbackID:this._callbackID});
		this._callbackID++;
	},

	app: function()
	{
		return this._app;
	},

	App: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'App',

		/**
		 * @class Information about the app.
		 */
		initialize: function(sourceAppID, intentURL)
		{
			this._sourceAppID   = sourceAppID;
			this._intentURL     = intentURL;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getID: function()
		{
			return this._sourceAppID;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getURL: function()
		{
			return this._intentURL;
		}
	}),

	Intent: Class.subclass(
	/** @lends Device.IPCEmitter.App.prototype */
	{
		classname: 'Intent',

		/**
		 * @class Information about the app.
		 */
		initialize: function(action, extras)
		{
			this._action   = action;
			this._extras   = extras;
		},

		/**
		 * information for checking if application has launched or resumed with custom URL scheme.
		 * @type String
		 */
		getAction: function()
		{
			return this._action;
		},

		/**
		 * Returns the URL used to launch this app, or an empty string if not launched via URL
		 * @type String
		 */
		getExtras: function()
		{
			return this._extras;
		}
	}),


	// ------------------------------------------------------------------
	// private
	//

	/**
	 * invoked from native when the app is resumed back from other app.
	 */
	_onResumedFromOthers: function (url, sourceAppID)
	{
		this._app = new Device.IPCEmitter.App(sourceAppID, url);
		this.emit(this._app);

		//Cascade the original message back out to native for forwarding
		var msg = {url: url, sourceAppID: sourceAppID};
		this._onResumeFromOthersSendGen(msg);
	},
	
	// Should only be called by privileged callers
	_setEmitIntents: function ( emit ) {
		this._shouldEmitIntents = Boolean(emit);
	},

	_onIntentReceived: function (action, extras)
	{
		console.log("On IntentReceived: " + action + " / " + JSON.stringify(extras));
		if (this._shouldEmitIntents) {
			this.emit( new exports.IPCEmitter.Intent(action, extras) );
		}
	},

	// private
	_canLaunchCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._canLaunchCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_onResumeFromOthersRecv: function(cmd)
	{
		var msg = {};
		if (! this._onResumeFromOthersRecvGen(cmd, msg))
			return;

		this._onResumedFromOthers(msg.url, msg.sourceAppID);
	},

	_launchFailedRecv: function( cmd )
	{
		var msg = {};
		if (! this._launchFailedRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.canLaunch);
		}
	},

	_getAppSignaturesCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getAppSignaturesCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.signatures.split(','));
		}
	},

	_getCallingPackageCallbackRecv: function( cmd )
	{
		var msg = {};
		if (! this._getCallingPackageCallbackRecvGen(cmd, msg))
			return;

		var func = this._callbacks[parseInt(msg.callbackID)];
		if (func) {
			func(msg.packageName);
		}
	},
	
	_onIntentReceivedRecv: function( cmd )
	{
		var msg = {};
		if (! this._onIntentReceivedRecvGen(cmd, msg))
			return;
		
		this._onIntentReceived( msg.action, JSON.parse(msg.extras) );
	},

// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 349
	// Method create = -1
	// Method canLaunch = 2
	// Method launch = 3
	// Method onResumeFromOthers = 4
	// Method launchFailed = 5
	// Method canLaunchCallback = 6
	// Method getAppSignatures = 7
	// Method getAppSignaturesCallback = 8
	// Method getCallingPackage = 9
	// Method getCallingPackageCallback = 10
	// Method launchIntent = 11
	// Method launchService = 12
	// Method onIntentReceived = 13
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onResumeFromOthersRecv( cmd );
					break;
				case 5:
					instance._launchFailedRecv( cmd );
					break;
				case 6:
					instance._canLaunchCallbackRecv( cmd );
					break;
				case 8:
					instance._getAppSignaturesCallbackRecv( cmd );
					break;
				case 10:
					instance._getCallingPackageCallbackRecv( cmd );
					break;
				case 13:
					instance._onIntentReceivedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in IPCEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[349] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onResumeFromOthersRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "url" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "url" ] === undefined )
		{
			NgLogE("Could not parse url in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		obj[ "sourceAppID" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "sourceAppID" ] === undefined )
		{
			NgLogE("Could not parse sourceAppID in IPCEmitter.onResumeFromOthers from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_launchFailedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "error" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "error" ] === undefined )
		{
			NgLogE("Could not parse error in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.launchFailed from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_canLaunchCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "canLaunch" ] = Core.Proc.parseBool( cmd[ 0 ] );
		if( obj[ "canLaunch" ] === undefined )
		{
			NgLogE("Could not parse canLaunch in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.canLaunchCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getAppSignaturesCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "signatures" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "signatures" ] === undefined )
		{
			NgLogE("Could not parse signatures in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getAppSignaturesCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_getCallingPackageCallbackRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "packageName" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "packageName" ] === undefined )
		{
			NgLogE("Could not parse packageName in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		obj[ "callbackID" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "callbackID" ] === undefined )
		{
			NgLogE("Could not parse callbackID in IPCEmitter.getCallingPackageCallback from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onIntentReceivedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "action" ] = Core.Proc.parseString( cmd[ 0 ] );
		if( obj[ "action" ] === undefined )
		{
			NgLogE("Could not parse action in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		obj[ "extras" ] = Core.Proc.parseString( cmd[ 1 ] );
		if( obj[ "extras" ] === undefined )
		{
			NgLogE("Could not parse extras in IPCEmitter.onIntentReceived from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 349 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_canLaunchSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 349 + "," + 2 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "url" ] ) + "," + obj[ "callbackID" ]  );
	},
	
	/** @private */
	_launchSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 349 + "," + 3 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "url" ] ) + "," + obj[ "callbackID" ]  );
	},
	
	/** @private */
	_onResumeFromOthersSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 349 + "," + 4 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "url" ] ) + "," + Core.Base64.encode( obj[ "sourceAppID" ] )  );
	},
	
	/** @private */
	_getAppSignaturesSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 349 + "," + 7 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "packageName" ] ) + "," + obj[ "callbackID" ]  );
	},
	
	/** @private */
	_getCallingPackageSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 349 + "," + 9 + "," + this.__objectRegistryId + "," + obj[ "callbackID" ]  );
	},
	
	/** @private */
	_launchIntentSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 349 + "," + 11 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "intent" ] ) + "," + Core.Base64.encode( obj[ "extras" ] )  );
	},
	
	/** @private */
	_launchServiceSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 349 + "," + 12 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "intent" ] ) + "," + Core.Base64.encode( obj[ "extras" ] )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// canLaunch: function( url, callbackID ) {}
	
	// launch: function( url, callbackID ) {}
	
	// _onResumeFromOthersRecv: function( cmd ) {}
	// onResumeFromOthers: function( url, sourceAppID ) {}
	
	// _launchFailedRecv: function( cmd ) {}
	// _canLaunchCallbackRecv: function( cmd ) {}
	// getAppSignatures: function( packageName, callbackID ) {}
	
	// _getAppSignaturesCallbackRecv: function( cmd ) {}
	// getCallingPackage: function( callbackID ) {}
	
	// _getCallingPackageCallbackRecv: function( cmd ) {}
	// launchIntent: function( intent, extras ) {}
	
	// launchService: function( intent, extras ) {}
	
	// _onIntentReceivedRecv: function( cmd ) {}

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] || {}; $MODULE_REGISTRY['NGCore/Client/Device/LayoutEmitter'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class LayoutEmitter
//
// Copyright (C) 2011 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Core = require('NGCore/Client/Core').Core;

////////////////////////////////////////////////////////////////////////////////

exports.LayoutEmitter = Core.MessageEmitter.singleton(
/** @lends Device.LayoutEmitter.prototype */
{
	classname: 'LayoutEmitter',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
	},
	
	_layoutChangedRecv: function( cmd ) 
	{
		var msg = {};
		if(!this._layoutChangedRecvGen(cmd, msg))
			return;

 		this._width = msg['width'];
 		this._height = msg['height'];
 		//NgLogD("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++JS received width as :"+ this._width + " and height as :" + this._height); 
		this.emit(msg);
		this._layoutChangedSendGen(msg);
	},
	
	$getWidth: function()
	{
		return this._width;
	},
	
	$getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * @private
	 */
	setWidthAndHeight: function(width, height) {
		//NgLogD("---------------------------------Setting width and height for LayoutEmitter directly from native ......... width is " + width + " and height is " + height );
		this._width = width;
		this._width = height;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 352
	// Method create = -1
	// Method layoutChanged = 2
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._layoutChangedRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in LayoutEmitter._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[352] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_layoutChangedRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 2 )
		{
			NgLogE("Could not parse due to wrong argument count in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "width" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "width" ] === undefined )
		{
			NgLogE("Could not parse width in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		obj[ "height" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "height" ] === undefined )
		{
			NgLogE("Could not parse height in LayoutEmitter.layoutChanged from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 352 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_layoutChangedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 352 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "width" ] + "," + obj[ "height" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _layoutChangedRecv: function( cmd ) {}
	// layoutChanged: function( width, height ) {}
	

// {{/Wg Generated Code}}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Appdata'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Appdata
 * @description
 * Mobage provides a common API for application data, which you can use for both Japan and the US. 
 * <code>Appdata</code> is consistent with the Open Social <code>osapi.appdata</code> interface, 
 * and enables the application to store name/value pairs for arbitrary application data.
 * To add or update application data, call <code>updateEntries()</code>. To retrieve entries, call <code>getEntries()</code>. 
 * To delete entries, call <code>deleteEntries()</code>.
 */
exports.Appdata = {
		
	/**
	 * Retrieves a hash of one or more key/value pairs.
	 * If the <code>keys</code> parameter is <code>null</code>, <code>undefined</code> or an empty array, <code>getEntries()</code> 
	 * returns all key/value pairs to the callback function.
	 *
	 * @name Social.Common.Appdata.getEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Set as an array of key names. For example, <code>['key1', 'key2']</code>.
	 * @param {Function} callback Retrieves a hash of key/value pairs. If an error occurs, retursn an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.updateEntries
	 * @example 
	 * Appdata.getEntries(['key1', 'key2'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getEntries: function(keys, callback) {
		var cmd = {apiURL:"Common.Appdata.getEntries", keys:keys, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	},
	
	/**
	 * Inserts or updates the submitted key/value pairs. 
	 * <b>Note:</b> Limited to 30 key/value pairs per user, per game. 
	 * Maximum key name limited to 32 bytes. Maximum value limited to 1,024 bytes.
	 *
	 * @name Social.Common.Appdata.updateEntries
	 * @function
	 * @public
	 * 
	 * @param {Hash} entries Takes a hash of key/value pairs. For example, <code>{"favoriteMovie": "Pulp Fiction", "petName": "Rover"}</code>.
	 * @param {Function} callback Retrieves the updated entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var entries = {"favoriteMovie": "Pulp Fiction", "petName": "Rover"};
     * ...
     * function(error, entries){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var updatedEntries = entries;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @see Social.Common.Appdata.getEntries
	 * @example
	 * Appdata.updateEntries(
	 *              {   'favoriteMovie':'Pulp Fiction',    
	 *                  'petName':'Rover' }, 
	 *              callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	updateEntries: function(entries, callback) {
		if(entries) {
			var cmd = {apiURL:"Common.Appdata.updateEntries", entries:entries, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Entries to update are a required parameter"
					}, null);
			}
		}
	},
	
	
	/**
	 * Deletes one or more key/value pairs.
	 *
	 * @name Social.Common.Appdata.deleteEntries
	 * @function
	 * @public
	 * 
	 * @param {Array} keys Takes an array of key names. For example, <code>['petName']</code>. 
     * If <code>null</code>, the return object in the callback is not defined.
	 * @param {Function} callback  Retrieves a hash of the deleted entries. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var keys = {"petName"};
     * ...
     * function(error, keys){
     * &nbsp;&nbsp;   if (error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;   } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var deletedKeys = keys;
     * &nbsp;&nbsp;   }
	 * }
	 * </pre>
	 * @example
	 * Appdata.deleteEntries(['petName'], callback );
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	deleteEntries: function(keys, callback) {
		if(keys && keys.length > 0) {
			var cmd = {apiURL:"Common.Appdata.deleteEntries", keys:keys, callbackFunc:callback};
			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		} else {
			if(typeof callback === 'function') {
				callback({ 
						errorCode: 400,
						description: "Keys to delete are a required parameter"
					}, null);
			}
		}
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Auth'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.Common.Auth
 * @description
 * Retrieves a verification code.
 * Games call <code>Auth.authorizeToken()</code> if the game server is using the Mobage REST API.
 * For more information, refer to the Mobage RESTful API Conventions section of the developer's guide.
 */
exports.Auth = {
		
		
	/**
	 * Authorizes a temporary credential and returns a verification code.
	 *
	 * 
	 * @name Social.Common.Auth.authorizeToken
	 * @function
	 * @public
	 *
	 * @param {String} token The temporary credential identifier. 
	 * @param {Function} callback The callback function that handles the verification code and errors.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 *  <pre class="code">
     *  var verifier = "jklmnop";
	 *  function(error, verifier){
     *  &nbsp;&nbsp; if (error){
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 *  &nbsp;&nbsp; } else {
     *  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var verificationCode = verifier;    
     *  &nbsp;&nbsp; }
     *  }
	 * </pre>
	 * @example
	 * var token = "abcdefghi";
     * ...
	 * Social.Common.Auth.authorizeToken (token, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	authorizeToken: function(token, callback) {
		var cmd = {apiURL:"Common.Auth.authorizeToken", token:token, callbackFunc: callback };
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
		//callback(error, verifier)
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Blacklist'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.Blacklist
 * @description
 * Provides an interface for checking the user's blacklist.
 */
exports.Blacklist = {

	/**
	 * Retrieves the target user ID from the specified user's blacklist.
	 * This call passes a user ID and a target user ID to determine if the specified target user is blacklisted. 
	 * If the target user ID parameter is <code>null</code>, this call retrieves the entire blacklist. The callback function also receives the total number of 
	 * target user IDs, the starting index, and the number of target IDs returned for paging the results.
	 *
	 * @name Social.Common.Blacklist.checkBlacklist
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID for the user who owns the blacklist. 
	 * @param {String} targetUserId The target user ID to check in the blacklist. <br/>If <code>null</code>, it checks the entire blacklist.
	 * @param {Hash} opt Takes a hash containing the start index and count for pagination. <br/>E.g., <code>{'start': 1, 'count': 100}</code> 
     * Requires start index and count. The minimum start index is 1. 
     * If <code>null</code>, undefined or an empty array, the start index is 1 and the count is 50.
	 * @param {Function} callback Retrieves an array of user IDs found in the blacklist. Otherwise, it retrieves an empty array.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var listedUsers = ['user1', 'user2'];
     * ...
     * function(error, listedUsers, result)
	 * &nbsp;&nbsp;		{
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var blackListedUsers = listedUsers;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var total = result.total;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var start = result.start;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var count = result.count;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorCode = error.errorCode;
  	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;			var errorDesc = error.description;
  	 * &nbsp;&nbsp;	}
  	 * </pre>
  	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	checkBlacklist: function(userId, targetUserId, opt, callback) {
		var cmd = {apiURL:"Common.Blacklist.checkBlacklist", userId:userId, targetUserId:targetUserId, opt:opt, callbackFunc: function(error, args) {
			callback(error, args.users, args.result);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Config'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Config'] = exports; var Session = require('NGCore/Client/Social/US/Data/Session').Session;

/**
 * @class 
 * @name Social.Common.Config
 * @description
 * Mobage provides a common API to determine if the server is a sandbox server or a production server. 
 */
exports.Config = {

    /**
    * Returns whether the server is a sandbox server or a production server. 
    * Returns "unknown" if it cannot retrieve the current session
    * or if the server mode is not "sandbox" or "production."
    * 
    * @name Social.Common.Config.getServerEnvironment
    * @public
    * @function
    * @returns {String} "sandbox," "production" or "unknown."
    * @see Social.US.Session.serverModes
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	getServerEnvironment: function(){
		var session = Session.getCurrentSession();
		if(!session){
			return "unknown";
		}
		
		var serverMode = Session.getCurrentSession().serverMode();
		if(serverMode == Session.serverModes.production){
			return "production";
		}else if(serverMode == Session.serverModes.sandbox){
			return "sandbox";
		}else{
			return "unknown";
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/People'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/People'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class 
 * @name Social.Common.People
 * @description
 * The social API for returning user objects with their social graphs. The user object
 * retrieved varies from platform to platform. US platform required fields are <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
 * and <code>thumbnailUrl</code> of the <code>Person</code> data type.
 */
exports.People = {
	
	/**
	 * Retrieves fields for the specified user from the <code>Person</code> data type. The specified user corresponds to the user ID parameter.
	 * Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 * Use the <code>fields</code> parameter to retrieve non-required fields of the <code>Person</code> data type.
	 *
	 * @name Social.Common.People.getUser
	 * @function 
	 * @public 
	 *
	 * @param {String} userId The user ID of the user to retrieve.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>. If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the user specified by the <code>userId</code> parameter. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getCurrentUser
	 * @example
	 * var recordID = 2;
	 *
	 * Social.Common.People.getUser(recordID, 
	 *                              ['id','nickname','aboutMe'], 
	 *                              callback
	 *		});
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getUser: function(userId, fields, callback) {
		var cmd = {apiURL:"Common.People.getUser", userId:userId, fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves an array of users.
	 * Takes one or more user IDs and retrieves an array of users with the callback. 
	 * Retrieves up to 100 users, with no guarantee of retrieving the user array 
	 * in the order specified.
	 * Retrieves the <code>id</code>, <code>displayName</code>, <code>hasApp</code> 
	 * and <code>thumbnailUrl</code> fields of the <code>Person</code> data type for each user.
	 * To retrieve non-required fields of the <code>Person</code> data type, specify the non-required fields 
	 * desired in the <code>fields</code> parameter.
	 *	 
	 * @name Social.Common.People.getUsers
	 * @function 
	 * @public
	 * 
	 * @param {Array} userIds An array of user IDs of the users to retrieve. Minimum array size is 1, and maximum is 100.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, it retrieves only the required fields.
	 * @param {Function} callback Retrieves an array of users specified by the <code>userIds</code> parameter and/or an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, users){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedUsers = users;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getUsers([1,2,3],null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getUsers: function(userIds, fields, callback) {
		var cmd = {apiURL:"Common.People.getUsers", userIds:userIds, fields:fields, callbackFunc:function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for the current user from the <code>Person</code> data type. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></code>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li>
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getCurrentUser
	 * @function
	 * @public
	 *
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the callback. <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/>If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Function} callback Retrieves the current user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, user){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var currentUser = user;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getUser
	 * @example
	 * People.getCurrentUser(null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
	getCurrentUser: function(fields, callback) {
		var cmd = {apiURL:"Common.People.getCurrentUser", fields:fields, callbackFunc:callback};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves fields for friends of a specified user. Below are the fields returned by this call:
	 * <ul>
	 * <li><code>id</code></li>
	 * <li><code>displayName</code></li>
	 * <li><code>hasApp</code></li> 
	 * <li><code>thumbnailUrl</code></li>
	 * </ul>
	 *
	 * @name Social.Common.People.getFriends
	 * @function
	 * @public
	 * 
	 * @param {String} userId The user ID of the user whose friends are retrieved by the callback function. 
	 * @param {Array} [fields] An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call only retrieves the required fields.
	 * @param {Hash} [opt] A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the given user. If an error occurs, returns an error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriendsWithGame
	 * @example
	 * People.getFriends(4, null, {'start': 2}, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	getFriends: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriends", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	
	/**
	 * Retrieves a list of the user's friends playing the current game.
	 *
	 * @name Social.Common.People.getFriendsWithGame
	 * @function
	 * @public
	 *
	 * @param {String} userId The user ID of the person whose friends play the current game.
	 * @param {Array} fields An array of non-required fields of the <code>Person</code> data type to include in the response to the callback. 
     * <br/>For example, <code>['nickname','aboutMe']</code>.
     * <br/> If <code>null</code>, <code>undefined</code> or an empty array, this call retrieves only the required fields.
	 * @param {Hash} opt A hash containing the start index and count for pagination. <br/>For example, <code>{'start': 1, 'count': 100}</code> 
	 * @param {Function} callback Retrieves the friends of the specified user. If an error occurs, returns an error code and error description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, friends){
     * &nbsp;&nbsp; if (error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     * &nbsp;&nbsp; } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var retrievedFriends = friends;
     * &nbsp;&nbsp;}
	 * }</pre>
	 * @see Social.Common.People.getFriends
	 * @example 
	 * People.getFriendsWithGame(4, null, null, callback);
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	getFriendsWithGame: function(userId, fields, opt, callback) {
		var cmd = {apiURL:"Common.People.getFriendsWithGame", userId:userId, fields:fields, opt:opt, callbackFunc: function(errors, args) {
			callback(errors, args.users, args.results);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
	
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Profanity'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');	

/**
 * @class 
 * @name Social.Common.Profanity
 * @description
 * Provides an interface to check games for profanity.
 */
exports.Profanity = {
	
	/**
	 * Checks a text string to determine if it contains profanity.
	 * This call only conducts a check and does not attempt to cleanup the string.<br><br>
	 * <b>Note:</b> The server handles locale and language automatically.
	 *
	 * @name Social.Common.Profanity.checkProfanity
	 * @function
	 * @public
	 * 
	 * @param {String} text The string to check for profanity.
	 * @param {Function} callback Retrieves any profane words or phrases in the text parameter. 
     * The result of checking is either <code>true</code> or <code>false</code>. If the result is <code>false</code>, the text string contains profanity. 
     	 * If an error occurs, returns an error code and error description to the callback.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class='code'>function(error, args){
     * &nbsp;&nbsp; if(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
     * &nbsp;&nbsp;} else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var profanity = args.profanity;
     * &nbsp;&nbsp;}
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	checkProfanity: function(text, callback) {
		var cmd = {apiURL:"Common.Profanity.checkProfanity", text:text, callbackFunc:function(error, args) {
			callback(error, args.profanity);
		}};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);		
	}	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Request'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Request'] = exports; var Class = require('NGCore/Client/Core/Class').Class;


//Don't need to document
exports.Request = Class.subclass({
	execute: function(callback) {
		// [call US function here]	
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Service'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Service'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var ButtonOverlays = require('NGCore/Client/Social/US/Service/ButtonOverlays').ButtonOverlays;
var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.Common.Service
 * @description
 * This interface provides the following social game services: <br/>
 * <div class="ul">
 * <li>Balance Button</li>
 * <li>Community Button</li>
 * <li>Friend Picker</li>
 * <li>User Finder</li>
 * <li>User Profile</li>
 * </div>
 */
exports.Service = {

	
	/**
	* Opens the user finder screen.
	* The user finder provides a way for users to find other users using the following filters:
	* <ul>
	* <li>Suggested Friends</li>
	* <li>Contacts</li> 
	* <li>Requests</li>
	* <li>Search</li>
	* </ul>
	*
	* @name Social.Common.Service.openUserFinder 
	* @function
	* @public
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	openUserFinder: function() {
		Friends.showFindFriends(undefined);
	},

	
	/**
	* Opens the friend picker.
	*
	* @name Social.Common.Service.openFriendPicker 
	* @function
	* @public 
	* 
	* @param {Number} maxFriendsToSelect The maximum number of friends the user may select.
	* @param {Function} callback The callback function called after the view closes. Returns an array of friends.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, friendUserIds){
	* 	&nbsp;&nbsp;&nbsp;if (error){
	* 	&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorCode = error.errorCode;
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var errorDesc = error.description;
	* 	&nbsp;&nbsp;&nbsp;} else {
	*   &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  		var pickedFriends = friendUserIds;
	*   &nbsp;&nbsp;&nbsp;  	}
	*   &nbsp;&nbsp;  }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openFriendPicker: function(maxFriendsToSelect, callback) {
		Friends.showFriendPicker(maxFriendsToSelect, function(err, friends){
			var userIDs = [];
			friends = friends || [];
			for(var idx = 0; idx < friends.length; idx++){
				userIDs.push(friends[idx].gamertag);
			}
			callback( userIDs );
		});
	},

	
	/**
	* Opens the specified profile page.
	*
	* @name Social.Common.Service.openUserProfile 
	* @function
	* @public 
	* 
	* @param {String} userId The user ID or gamer name of the profile page to open.
	* @param {Function} callback The callback function if there is an error with the user ID or gamer name.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	openUserProfile: function(userId, callback) {
		if( !userId ){
			callback({errorCode: 400, description: "userid is invalid"});
		}
		else{
			User.getUserWithID(userId, function(err, user){
				if(err){
					if( err==="Sorry, we can't find anyone with that name." ){
						callback({errorCode: 404, description: err});
					} else {
						callback({errorCode: 500, description: err});
					}
				}else if(!user){
					callback({errorCode: 404, description: "User not found"});
				}else{
					Profile.showUserProfile(user, undefined);
				}
			});
	}
	},


	/**
	* Displays the <b>Mobage Community</b> button.
	*	
	* @name Social.Common.Service.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner. 
    * <b>Note:</b> Only supported for the US. Japan uses the top-left corner only.
	* @param {String} theme Displays the theme for the button (for example, "default", "dark", "light"). 
    * <b>Note:</b> Only supported for Japan. You can specify <code>null</code> for the US region.
	* @param {Function} callback The callback function if there is an error related
    * to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/           
	showCommunityButton: function(gravity, theme, callback) {
		ButtonOverlays.showCommunityButton(gravity, callback);
	},

	/**
	* Hides the <b>Mobage Community</b> button.
	*
	* @name Social.Common.Service.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	hideCommunityButton: function(callback) {
		ButtonOverlays.hideCommunityButton(callback);
	},

	
	/**
	* A message emitter object for adding a message emitter when inviting a user.
	*
	* @name Social.Common.Service.invitedUserEmitter
	* @field
	* @public
	* @example 
	* Social.Common.Service. ...
	* ... invitedUserEmitter.addListener(
	*			new Core.MessageListener(), 
	*			function(userId){
	*				NgLogD("New Emitter! " + userId);
	*			}
	*		);
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	invitedUserEmitter : new MessageEmitter(),

	
	/**
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
     * The minimum size of the button is:<br/>
     * <ul>
     * <li>10% of height in Landscape, and the absolute minimum size is 150 x 50.</li>
     * <li>6% of height in Portrait, and the absolute minimum size is 150 x 50.</li>
     	 * </ul>
	 *
	 * @name Social.Common.Service.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {		
		ButtonOverlays.showBalanceButton(rect, callback);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.Common.Service.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
     * </pre>
     * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		ButtonOverlays.hideBalanceButton(callback);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Common/Analytics'] = exports; var SessionReq = require('NGCore/Client/Social/US/Data/Session');

/**
 * @private
 * @name Social.Common.Analytics
 * @description Private interface for analytics data
 */
exports.Analytics = {
  getUserId: function() {
    var cur_sess =  SessionReq.Session.getCurrentSession(), cur_u = null;
    if (cur_sess) {
      cur_u = (cur_sess.user() || {}).recordID;
    }
    return cur_u;
  },
  getUsername: function() {
    var cur_sess =  SessionReq.Session.getCurrentSession(), cur_u = null;
    if (cur_sess) {
      cur_u = (cur_sess.user() || {}).gamertag;
    }
    return cur_u;
  },
  getPlatformVersion: function() {
    var cur_sess =  SessionReq.Session.getCurrentSession(), cur_pver = null;
    if (cur_sess) {
      cur_pver = cur_sess.platformVersion();
    }
    return cur_pver;
  },
  getServiceId: function() { return "US"; }
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/DataModel'] = exports; var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;
var SocialR = require('NGCore/Client/Social');
var SessionR        = require('NGCore/Client/Social/US/Data/Session');
var DispatcherR     = require('NGCore/Client/Social/US/Data/Dispatcher');

/**
 * <code>DataModel</code> constructs objects that emit messages when properties of an object change, and provides automatic caching,
 * serialization and deserialization between interpreters. 
 * <br/><br/>
 * <b>Note:</b> Do not instantiate this class directly. Use classes derived from <code>DataModel</code> for instantiation. These include:
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.AppData}</li>
 * <li>{@link Social.US.Game}</li>
 * <li>{@link Social.US.Score}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div>
 * @class 
 * @name Social.US.DataModel
 */
var DataModel = exports.DataModel = MessageEmitter.subclass({
		
	/**
	 * The default constructor.
	 * @constructs
	 * @private
	 */		
	initialize: function(recordID){
		this.recordID = recordID;

		this._cache();
	},
	beginChanges: function(){
		DispatcherR.Dispatcher.beginBatching();
	},
	endChanges: function(){
		DispatcherR.Dispatcher.endBatching();
	},
	_classname: function(){
		var classname = this.classname;
		return classname;
	},
	_cache: function(){
		if(!this._dataCache){
			var session = SessionR.Session.getCurrentSession();
			if(session){
				var cache = session.dataCache();
				if(cache){
					cache.addObject(this);
					this._dataCache = cache;
				}
			}
		}
		return this._dataCache;
	},
	$_serializedDataModel: function(obj){
		if(obj instanceof(DataModel)){
			obj = {
				classname: obj.classname,
				recordID:  obj.recordID
			};
		}
		return obj;
	},
	$_deserializedDataModel: function(value, cache){
		if(value && value.hasOwnProperty && value.hasOwnProperty("classname") && value.hasOwnProperty("recordID")){
			var theClassname = value.classname;
			var theClass = SocialR.Social.US[theClassname];
			var theRecordID = value.recordID;
			if(theClass && theRecordID){
				var theInstance = cache.getObjectWithRecordID(theClassname, theRecordID);
				if(!theInstance){
					theInstance = new theClass(theRecordID);
				}
				
				theInstance._deserializeFromHash(value.data);
				cache.addObject(theInstance);
    
				value = theInstance;
			}
		}
		return value;
	},
	_serializedHash: function(full){
		var theClass = this.constructor;
		var hash = {classname: theClass.classname, recordID: this.recordID};
		if(full === false){
			return hash; // if it's undefined, assume we want all the data
		}
		
		hash.data = {};
		
		var properties = this.constructor.properties || [];
		for(var idx = 0; idx < properties.length; idx++){
			var propertyName = properties[idx];
			var propertyValue = this[propertyName];

			if(propertyValue instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < propertyValue.length; propertyIndex++){
					propertyValue[propertyIndex] = DataModel._serializedDataModel(propertyValue[propertyIndex]);
				}
			}else{
				propertyValue = DataModel._serializedDataModel(propertyValue);
			}
			
			hash.data[propertyName] = propertyValue;
		}
		
		return hash;
	},
	_deserializeFromHash: function(data){
		if(!data){
			NgLogD("No public hash data for " + this.classname + " " + this.recordID);
			return;
		}
		
		var cache = this._cache();
		for(var key in data){
			var value = data[key];
			if(value instanceof(Array)){
				for(var propertyIndex = 0; propertyIndex < value.length; propertyIndex++){
					value[propertyIndex] = DataModel._deserializedDataModel(value[propertyIndex], cache);
				}
			}else{
				value = DataModel._deserializedDataModel(value, cache);
			}
			this[key] = value;
		}
	}
});

DataModel._oldSubclass = DataModel.subclass;
DataModel.subclass = function(contents){
	var theClass = DataModel._oldSubclass(contents);
	var properties = contents.properties || [];
	for(var idx = 0; idx < properties.length; idx++){
		var propertyName = properties[idx];
		
		(function(name){
			theClass.prototype.__defineSetter__(name, function(value){
				this["___" + name] = value;
				
				var msg = {};
				msg[""+name] = value;
				
				this.emit(msg);
			});
			theClass.prototype.__defineGetter__(name, function(value){
				return this["___" + name];
			});
		})(propertyName);
	}
	return theClass;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/User'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/User'] = exports; var DataModelR  = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher  = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Social      = require('NGCore/Client/Social').Social;

/**
* <code>User</code> constructs objects that provide a service interface for the current user. 
* <code>User</code> objects enable the current user to retrieve:
* <div class="ul">
* <li>user details</li>
* <li>a list of friends</li>
* <li>games</li>
* </div>
* @class
* @name Social.US.User
* @augments Social.US.DataModel
*/
var User = exports.User = DataModelR.DataModel.subclass({
		
    /**
    * @constructs
    * @ignore
    */
	classname: "User",

	 /**
	 * The user's gamer tag. Read-only.
	 * @name Social.US.User.gamertag
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The user's avatar ID. Read-only.
	 * @name Social.US.User.avatarId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's motto. Read-only.
	 * @name Social.US.User.motto
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The relation to this user. Read-only.
	 * @name Social.US.User.relation
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Sparse limits attributes in search results. Read-only.
	 * @name Social.US.User.sparse
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's photo ID. Read-only.
	 * @name Social.US.User.photoId
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's email address. Read-only.
	 * @name Social.US.User.emailAddress
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A hash of the user's email address. Read-only.
	 * @name Social.US.User.emailHash
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's phone number. Read-only.
	 * @name Social.US.User.phoneNumber
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's password. Read-only.
	 * @name Social.US.User.password
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The user's first name. Read-only.
	 * @name Social.US.User.firstName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */


	 /**
	 * The user's last name. Read-only.
	 * @name Social.US.User.lastName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether to hide the user's full name. Read-only.
	 * @name Social.US.User.hideFullName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user is age restricted. Read-only.
	 * @name Social.US.User.ageRestricted
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the relationship to the user is new. Read-only.
	 * @name Social.US.User.isNewRelationship
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user is a mutual friend. Read-only.
	 * @name Social.US.User.isMutualFriend
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * Whether the user shows his/her presence. Read-only.
	 * @name Social.US.User.showsPresence
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * Whether the user only shows friend notifications. Read-only.
	 * @name Social.US.User.setOnlyShowFriendNotifications
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's capabilities. Read-only.
	 * @name Social.US.User.capabilities
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's gamer score. Read-only.
	 * @name Social.US.User.gamerscore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level. Read-only.
	 * @name Social.US.User.gamerLevel
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	 

	 /**
	 * The user's gamer level name. Read-only.
	 * @name Social.US.User.gamerLevelName
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer level score. Read-only.
	 * @name Social.US.User.gamerLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The gamer score for the next level. Read-only.
	 * @name Social.US.User.gamerNextLevelScore
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The user's games. Read-only.
	 * @name Social.US.User.games
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	properties: [
		// public
		"gamertag",
		"avatarId",
		"motto",
		"relation",
		"sparse",
		"photoId",
		"emailHash",
		"ageRestricted",
		"isMutualFriend",
		
		// private
		"phoneNumber",
		"password",
		"firstName",
		"lastName",
		"hideFullName",
		"emailAddress",
		"isNewRelationship",
		"showsPresence",
		"onlyShowFriendNotifications",
		"capabilities",
		"gamerscore",
		"gamerLevel",
		"gamerLevelName",
		"gamerLevelScore",
		"gamerNextLevelScore",
		"games"
	],
	
	/**
	 * @constructs The default constructor constructs <code>User</code> objects.
	 * @name Social.US.User.initialize 
	 * @private
	 */
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("User Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Adds a user to the buddies list and ensures the added user is not on the blocked users list.
	* @name Social.US.User.addBuddy
	* @function
	* @private
	*
	* @param {Social.US.User} buddy The user to add to the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>	
	*/	
	addBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "addBuddy", [buddy, cb]);
	},
	
	
	/**
	* Removes a user from the buddies list.
	* @name Social.US.User.removeBuddy
	* @function
	* @private
	*
	* @param {User} buddy The user to remove from the buddies list. If not a user, the callback error is "No user."
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var buddyData = data;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	*/		
	removeBuddy: function(buddy, cb){
		Dispatcher.callMethodOnRemoteObject(this, "deleteBuddy", [buddy, cb]);
	},
	
	
	/**
	* Retrieves a user object with all of the this user's details.
	*
	* @name Social.US.User.getUserDetails
	* @function
	* @public
	* 
	* @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, user){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithDetails = user;
    * &nbsp;&nbsp;  }
	* }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getUserDetails: function(cb){
		Dispatcher.callMethodOnRemoteObject(this, "getUserDetails", [cb]);		
	},
	
	/**
	* Retrieves an ordered list of the user's friend requests on Mobage.
	* @name Social.US.User.getMobageFriendRequestLists
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} A list of the user's friend requests.
    * @example
    * var myMobageFriendRequests = userA.getMobageFriendRequestsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Friend Requests list.
	*/			
	getMobageFriendRequestsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getInvitesList", "_followersListInterface");
	},
	
	/**
	* Returns the user's friends list on Mobage.
	* @name Social.US.User.getMobageFriendsList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's friend list on Mobage.
    * @example
    * var myMobageFriendsList = userA.getMobageFriendsList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageFriendsList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsList", "_friendsListInterface");
	},
	
	/**
	* Returns the user's blocked user list.
	* @name Social.US.User.getMobageBlockedUserList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's blocked user list on Mobage.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	getMobageBlockedUserList: function(){
		return OrderedList.getObjectPublicInterface(this, "getBlockedUserList", "_enemyListInterface");
	},
	
	/**
	* Returns the user's games list.
	* @name Social.US.User.getOwnedGamesList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The user's Mobage game list.
    * @example
    * var myGamesList = userA.getOwnedGamesList();
    * @see Social.US.OrderedList for more information on iterating over the games list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/			
	getOwnedGamesList: function(){
		return OrderedList.getObjectPublicInterface(this, "getOwnedGamesList", "_ownedGamesListInterface");
	},
	
	/**
	* Returns the list of "featured" users.
	* @name Social.US.User.getFeaturedUsersList
	* @function
	* @public	
	*
	* @return {Social.US.OrderedList} The list of "featured" users.
    * @example
    * var mobageFeaturedUsers = userA.getFeaturedUsersList();
    * @see Social.US.OrderedList for more information on iterating over the Mobage Featured Users list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	getFeaturedUsersList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFeaturedUsersList", "_featuredUsersListInterface");
	},

	/**
	* Invites the user to the current game.
	* @name Social.US.User.inviteToCurrentGame
	* @public
	* @function
	* 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/
	inviteToCurrentGame: function(cb){
		var user = this;
		Dispatcher.callMethodOnRemoteObject(this, "inviteToCurrentGame", [function(err){
			if(!err){
				Social.Common.Service.invitedUserEmitter.emit({userId: user.recordID});
				Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
			}
			cb.apply(this, Array.apply(null, arguments));
		}]);		
	},
	
	/**
	 * Send a Push notification to this user through the GameService back end.
	 * @name Social.US.User.sendNotificationToUser
	 * @public
	 * @function
	 *
	 * @param {Alert Text} alertText The displayed message when the push is received.
	 * @param {Badge ID} badgeId Badge displayed on the push.
	 * @param {Sound} sound Sound played when push is received.
	 * @param {Extra Data} extraData Additional payload.
	 *
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	sendNotificationToUser: function(alertText, badgeId, sound, extraData) {
		Dispatcher.callMethodOnRemoteObject(this, "sendNotificationToUser", [alertText, badgeId, sound, extraData]);
	},

    /**
    * Adds a user to the current user's friend list for the current game. Implies a one-directional relationship or "follower" model.
    * Takes an optional group parameter to add the user to a particular group. Current user can only 
    * add the user to one group. If the current user adds the user to a second group in the friend list, 
    * the user is moved from the first group.
    *
    * A group is an arbitrary classification of friends. The <code>group</code> parameter is a string, which 
    * takes the name of the group. You may allow users to manage their own groups, create game-level groups, 
    * or omit groups altogether. A user may only reside in one group of another user's friend list.<br><br>
    * <b>Note:</b> This is part of the Game Graph API. 
    *
    * @example
    * //Retrieve a user and set up a follower relationship.
    * var userA = Social.US.User; 
    * Social.US.User.getUserWithGamertag("chuck", function(error, user){
    *   if(!user) {
    *       var errorCode = error.errorCode;
    *       var errorDesc = error.description;
    *   } else {
    *        userA = user;
    *   }
    * });
    * var userB = Social.US.Session.getCurrentSession().user();
    * userB.addFriend(userA, callback);
    * //...
    * @example
    * //To make the relationship bi-directional, 
    * //you must make the same call for the other user.
    * userA.addFriend(userB, callback);
    *
    * @name Social.US.User.addFriend
    * @public
    * @function
    *
    * @param user The user to add to the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {String} [group] An optional parameter for adding the friend into a group within the friend list.
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	addFriend: function(user, group, cb){
		if(typeof arguments[1] == "function" && !arguments[2]){
			cb = arguments[1];
			group = undefined;
		}
		Dispatcher.callMethodOnRemoteObject(this, "addGameFriend", [user, group, cb]);
	},

    /**
    * Removes a user from the current user's friend list for the current game.<br><br>
    * Does not require a group parameter, friends are only associated to one group in a friend list.
    * @name Social.US.User.removeFriend
    * @public
    * @function
    *
    * @param {Social.US.User} user The user to remove from the current user's friend list. If <code>null</code>, <code>undefined</code> or not a 
    * <code>Social.US.User</code> object, the callback error is "No user."
    * @param {Function} cb The callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error, data){
    * &nbsp;&nbsp;  if (error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var appData = data;
    * &nbsp;&nbsp;  }
	* } </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
    */		
	removeFriend: function(user, cb){
		Dispatcher.callMethodOnRemoteObject(this, "removeGameFriend", [user, cb]);
	},
	
	report: function(reason, cb){
		Dispatcher.callMethodOnRemoteObject(this, "report", [reason, cb]);
	},

    /**
    * Returns the user's friend list for the current game. If you specify the <code>group</code>
    * parameter, this call only returns friends within the group.<br><br>
    * <b>Note:</b> This is part of the Game Graph API.
    * @name Social.US.User.getFriendsList
    * @public
    * @function
    *
    * @param {String} group If specified, returns only friends in the group.
    * @return {Social.US.OrderedList} The user's friend list for the current game.
    * @example
    * var myFriendsList = userA.getFriendsList ("Best Buddies");
    * @see Social.US.OrderedList for more information on iterating over the friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-friends-" + group ) : "_gameFriendsList-friends"), "friends", group);
	},


    /**
    * Returns the user's mutual friends.
    * Mutual friends result when two users add each other to their respective friend list.<br><br>
    * <b>Note:</b> This is part of the game graph API.
    * @name Social.US.User.getMutualFriendsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend list. If specified, returns only mutual friends within the group.
    * @return {Social.US.OrderedList} The user's mutual friend list.
    * @example
    * userA.addFriend(userB);
    * userB.addFriend(userA);
    * var myMutualFriends = userA.getMutualFriendsList();
    * //userA appears in userB's mutual friends list, 
    * //because they are in each other's friend lists.
    * @see Social.US.OrderedList for more information on iterating over the mutual friends list.
    * @status iOS, Android, Test, iOSTested, AndroidTested    
    */	
	getMutualFriendsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-mutual-" + group) : "_gameFriendsList-mutual"), "mutual", group);
	},


    /**
    * Returns the user's friend requests list. If the <code>group</code> parameter is specified, returns
    * only friends within the group.
    * @name Social.US.User.getFriendRequestsList
    * @public
    * @function
    *
    * @param {String} group The group within the friend request list.
    * @return {Social.US.OrderedList} The user's friend requests list.
    * @example
    * var myFriendRequestsList = userA.getFriendRequestsList ();
    * @see Social.US.OrderedList for more information on iterating over the friend requests list. 
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */	
	getFriendRequestsList: function(group){
		return OrderedList.getObjectPublicInterface(this, "getGameFriendsList", (group ? ("_gameFriendsList-invitation-" + group) : "_gameFriendsList-invitation"), "invitation", group);
	},

	/**
	* Updates the email address for the current user.
	* @name Social.US.User.setEmailAddress
	* @function
	* @private
	*
	* @param {String} newAddress The email address for the current user.
	* @param {Function} cb The callback function if an error occurs (for example, invalid email address format).
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setEmailAddress:function(newAddress,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setEmailAddress", [newAddress, cb]);
	},
	
	/**
	* Sets whether the current user will receive notifications from other Mobage users or just from Mobage friends.
	* @name Social.US.User.setOnlyShowFriendNotifications
	* @function
	* @private
	*
	* @param {Boolean} isFriendsOnly Set to <code>true</code> if the current user will only receive notifications from Mobage users who are also Mobage friends. 
    * If set to <code>false</code>, the user receives notifications from all Mobage users. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setOnlyShowFriendNotifications:function(isFriendsOnly,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOnlyShowFriendNotifications", [isFriendsOnly, cb]);
	},
	
	/**
	* Sets whether the current user will receive game news and updates from Mobage.
	* @name Social.US.User.setOptsIn
	* @function
	* @private
	*
	* @param {Boolean} optIn Set to <code>true</code> if the current user will receive news and updates from Mobage. 
    * If set to <code>false</code>, the user will not receive news or updates from Mobage. 
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setOptsIn:function(optIn,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setOptsIn", [optIn, cb]);
	},

	/**
	* Sets a motto for the current user. In other words, the user's "about me" text string.
	* @name Social.US.User.setMotto
	* @function
	* @private
	*
	* @param {String} motto The motto for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setMotto:function(motto,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setMotto", [motto, cb]);
	},
	
	/**
	* Updates the first name for the current user.
	* @name Social.US.User.setFirstName
	* @function
	* @private
	*
	* @param {String} firstName The first name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setFirstName:function(firstName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setFirstName", [firstName, cb]);
	},
	
	/**
	* Updates the last name for the current user.
	* @name Social.US.User.setLastName
	* @function
	* @private
	*
	* @param {String} lastName The last name for the current user.
	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setLastName:function(lastName,cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setLastName", [lastName, cb]);
	},
	

	/**
	* Sets a password for the current user.
	* @name Social.US.User.setPassword
	* @function
	* @private
	*
	* @param {String} password The password for the current user.
    * @param {String} confirmation The password confirmation for the current user.
	* @param {Function} cb The callback function if an error occurs. For example, password does not meet requirements; password and confirmation do not match, and so on.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/
	setPassword:function(password,confirmation, cb) {
		Dispatcher.callMethodOnRemoteObject(this, "setPassword", [password, confirmation, cb]);
	},

	/**
	* Sets whether the target user is in the logged-in user's blocked user list.
	* @name Social.US.User.setBlocked
	* @function
	* @private
	*
	* @param {Social.US.User} user The user that is the subject of blocking or unblocking.
    * @param {Boolean} blocked Whether the current user blocks the specified user. If <code>true</code>, the specified user is blocked.
    	* @param {Function} cb The callback function if an error occurs.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
    * @status iOS, Android, Test, iOSTested, AndroidTested	
	*/	
	setBlocked:function(blocked, cb){
		Dispatcher.callMethodOnRemoteObject(this, "setBlocked", [blocked, cb]);
	}
});

User.GamertagKey = "gamertag";
User.AvatarKey = "badge_id";
User.MottoKey = "motto";
User.RelationKey = "relation";
User.FirstNameKey = "first_name";
User.LastNameKey = "last_name";
User.BirthdateKey = "birth_date";
User.GenderKey = "gender";
User.PrivacyKey = "fullname_privacy";
User.PhotoKey = "photo_url";
User.EmailAddressKey = "email";
User.EmailHashKey = "email_hash";
User.PhoneNumberKey = "phone_number";
User.AgeRangeKey = "age_restricted";
User.SpamKey = "opt_in";

User.PasswordKey = "password";
User.PasswordConfirmKey = "password_confirmation";
User.GamesKey = "games";
User.CapabilitiesKey = "capabilities";
User.NewBuddyKey = "new_buddy";
User.IsMutualFriendKey = "mutual_friends";
User.HidePresenceKey = "hide_presence";
User.OnlyShowFriendNotificationsKey = "friend_only_notification";

User.GamerScoreKey = "gamerscore";
User.LevelNumberKey = "level_position";
User.LevelNameKey = "level_name";
User.CurrentLevelScoreKey = "level_points";
User.NextLevelScoreKey = "level_next_points";

// properties that are not returned in sparse search results
User.NonSparseKeys = [User.PhotoKey, User.EmailAddressKey,
User.EmailHashKey, User.PhoneNumberKey, User.PasswordKey,
User.FirstNameKey, User.LastNameKey, User.PrivacyKey,
User.NewBuddyKey, User.CapabilitiesKey, User.HidePresenceKey,
User.OnlyShowFriendNotificationsKey, User.GamerScoreKey,
User.LevelNumberKey, User.LevelNameKey, User.CurrentLevelScoreKey,
User.NextLevelScoreKey, User.GamesKey];


/**
* Retrieves the user corresponding to the <code>userID</code> parameter.
* @name Social.US.User.getUserWithID
* @public
* @static
* @function
* 
* @param {String} userID The ID for the user.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithID = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithID = function(userID, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithID", [userID, cb]);
};

/**
* Retrieves the user corresponding to the <code>gamertag</code> parameter.
* @name Social.US.User.getUserWithGamertag
* @public
* @static
* @function
* 
* @param {String} gamertag The user's gamertag.
* @param {Function} cb The callback function if an error occurs.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, user){
* &nbsp;&nbsp;  if(!user) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var userWithGamertag = user;
* &nbsp;&nbsp;  }
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/	
User.getUserWithGamertag = function(gamertag, cb){
	Dispatcher.callClassMethodOnRemoteObject(User, "getUserWithGamertag", [gamertag, cb]);
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Game'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Game'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Game</code> objects identify a game and its properties.
 * Game properties include: 
 * <div class="ul">
 * <li><code>name</code></li>
 * <li><code>publisher</code></li>
 * <li><code>category</code></li>
 * <li><code>featured</code></li>
 * <li><code>numberOfLeaderboards</code></li> 
 * <li><code>numberOfAchievements</code></li>
 * <li><code>masterProductID</code></li>
 * <li><code>iconURL</code></li>
 * <li><code>AppStoreURL</code></li>
 * <li><code>feedURL</code></li>
 * <li><code>catalogURL</code></li>
 * </div>
 * <code>Game</code> objects provide static functions to return all games in a catalog or games associated to a user profile.
 * 
 * @class 
 * @name Social.US.Game
 * @augments Social.US.DataModel
 */
var Game = exports.Game = DataModelR.DataModel.subclass({
	classname: "Game",
	
	
	 //Game is a subclass of data model, and the getter/setter methods are generated by defineSetterCallbacks. The following
	 //comments document the generated methods.
	 /**
	 * The game name. Read-only.
	 * @name Social.US.Game.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The publisher name. Read-only.
	 * @name Social.US.Game.publisher
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The game category name. Read-only.
	 * @name Social.US.Game.category
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Whether the game is featured. Read-only.
	 * @name Social.US.Game.featured
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The number of leaderboards for the game. Read-only.
	 * @name Social.US.Game.numberOfLeaderboards
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The number of achievements. Read-only.
	 * @name Social.US.Game.numberOfAchievements
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The master product ID. Read-only.
	 * @name Social.US.Game.masterProductID
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the icon for a game. Read-only.
	 * @name Social.US.Game.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the store or marketplace for a game. Read-only.
	 * @name Social.US.Game.appStoreURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * A URL to the RSS feed for a game. Read-only.
	 * @name Social.US.Game.feedURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * Sets a catalog URL for the catalog of game items. Read-only.
	 * @name Social.US.Game.catalogURL
	 * @field
	 * @private
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	properties: [
		// public
		"name",
		"publisher",
		"category",
		"numberOfLeaderboards",
		"iconURL",
		
		// private
		"numberOfAchievements",
		"featured",
		"masterProductID",
		"appStoreURL",
		"feedURL",
		"catalogURL",
		"description",
		"phone_screenshot_urls",
		"ngcore_url"
	]
});

/**
 * Returns an ordered list interface to the Mobage game catalog.
 * 
 * @name Social.US.Game.getAllGamesList
 * @function
 * @private 
 * @static
 *
 * @returns {Social.US.OrderedList} An ordered list interface to the catalog of games.
 * @see Social.US.OrderedList
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getAllGamesList = function(){
		
	return OrderedList.getClassPublicInterface(Game, "getAllGamesList", "_allGamesInterface");
};

/**
 * Returns the current game. 
 *
 * @name Social.US.Game.getCurrentGame
 * @function
 * @public 
 * @static
 *
 * @param {Function} cb The callback function returns the current game or an error code and description.
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, game){
 * &nbsp;&nbsp; if(!game){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
 * &nbsp;&nbsp;} else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var currentGame = game;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Game.getCurrentGame = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Game, "getCurrentGame", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Leaderboard'] = exports; var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;
var OrderedList = require('NGCore/Client/Social/US/Models/OrderedList').OrderedList;

/**
 * <code>Leaderboard</code> objects enable the current user to get friend scores, top scores, and submit a score.
 * @class 
 * @name Social.US.Leaderboard
 * @augments Social.US.DataModel
 */
var Leaderboard = exports.Leaderboard = DataModelR.DataModel.subclass({

	 
	classname: "Leaderboard",
	properties: [
	"level",
	"title",
	"game",
	"iconURL"
	],

	
	/** 
	 * @constructs Constructs a <code>Leaderboard</code> object identified by the record ID. 
	 * @private
	 *
	 * @param {Type} $super A reference to the DataModel superclass.
	 * @param {String} recordId The record ID of the object.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	initialize: function($super, recordID){
		$super(recordID);
		NgLogD("Leaderboard Public! " + recordID + " " + this.recordID);
	},
	
	
	/**
	* Submits a score to the leaderboard.
	*
	* @name Social.US.Leaderboard.submitScore
	* @function
	* @public
	*
	* @param {Numeric} points The score points. If <code>null</code> or <code>undefined</code>, the callback error is "No score."
	* @param {Function} cb The callback function.
	* <br/> 
    * <b>Callback Example:</b><br/>
    * <pre class='code'>function(error, score){
    * &nbsp;&nbsp;  if(error) {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
    * &nbsp;&nbsp;  } else {
    * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var setScore = score;
    * }
    * </pre>
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
	submitScore: function(points, cb){
		Dispatcher.callMethodOnRemoteObject(this, "submitScoreWithPoints", [points, cb]);
	},	
	
	/**
	* Returns an <code>OrderedList</code> with the user's score and the highest scores.
	* 
	* @name Social.US.Leaderboard.getTopScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of highest scores.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getTopScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getTopScoresList", "_leaderboardTopScoresInterface");
	},
	
	/**
	* Returns an <code>OrderedList</code> of scores for the user's friends.
	* 
	* @name Social.US.Leaderboard.getFriendsScoresList
	* @function
	* @public
	*
	* @return {Social.US.OrderedList} The list of scores for the user's friends.
	* @see Social.US.OrderedList
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/		
	getFriendsScoresList: function(){
		return OrderedList.getObjectPublicInterface(this, "getFriendsScoresList", "_leaderboardFriendsScoresInterface");
	}

	 /**
	 * The user's level in the game. Read-only.
	 * @name Social.US.Leaderboard.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * The leaderboard title. Read-only.
	 * @name Social.US.Leaderboard.title
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */

	 /**
	 * The game name. Read-only.
	 * @name Social.US.Leaderboard.game
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	 /**
	 * A URL to the leaderboard icon. Read-only.
	 * @name Social.US.Leaderboard.iconURL
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
		 
});

/**
* Returns the leaderboard(s) for the current game.
*
* @name Social.US.Leaderboard.getLeaderboards
* @function
* @public
* @static
*
* @param cb Retrieves the leaderboard(s) for the current game. If an error occurs, returns an error code and error description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class='code'>function(error, leaderboards){
* &nbsp;&nbsp;  if(error) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;  } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var retrievedLeaderboards = leaderboards;
* }
* </pre>
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Leaderboard.getLeaderboards = function(cb){
	Dispatcher.callClassMethodOnRemoteObject(Leaderboard, "getLeaderboards", [cb]);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Score'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Score'] = exports; var DataModel 	  = require('NGCore/Client/Social/US/Models/DataModel').DataModel;

/**
 * <code>Score</code> constructs objects that reflect a user's score for the current game.
 * @class 
 * @name Social.US.Score
 * @augments Social.US.DataModel
 */
var Score = exports.Score = DataModel.subclass({
	
    classname: "Score",
    	
	 /**
	 * A user's score. Read-only.
	 * @name Social.US.Score.score
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 

	 /**
	 * The score as formatted for display. Read-only.
	 * @name Social.US.Score.displayScore
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's rank. Read-only.
	 * @name Social.US.Score.rank
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	 
	
	 /**
	 * The user's level in the current game. Read-only.
	 * @name Social.US.Score.level
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
    
	 /**
	 * A <code>Social.US.User</code> reference to the user associated to the score. Read-only.
	 * @name Social.US.Score.user
	 * @field
	 * @public
     * @see Social.US.User
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
	 
    properties: [
	"points",
	"displayScore",
	"rank",
	"level",
	"user"
	]
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/AppData'] = exports; var DataModelReq = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>AppData</code> constructs objects that get and set a user's properties, 
 * and provides permissions for sharing the user's properties with other users.
 * @class 
 * @name Social.US.AppData
 */
var AppData = exports.AppData = DataModelReq.DataModel.subclass({
		
	classname: "AppData",
	properties: [
		"data",
		"key",
		"user",
		"permissions"
	],
	
	/**
	 * The application data for the user. Limited to 1024 bytes.
	 * 
	 * @name Social.US.AppData.data
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The key describing the application data. Limited to 32 bytes.
	 * 
	 * @name Social.US.AppData.key
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The name of the user who owns the data.
	 * 
	 * @name Social.US.AppData.name
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	/**
	 * The permissions for the application data.<br/><br/>
	 * <code>Private</code>: only the user can read and write the user data.<br/>
	 * <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
	 * <code>PublicReadOnly</code>: all users can read the user data, but cannot write it.     
	 * 
	 * @name Social.US.AppData.permissions
	 * @field
	 * @public
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	
	
	
    /**
     * The default constructor.
     * @constructs 
     * @name Social.US.AppData.initialize
     * @private
     *
     * @param recordID A unique ID for the <code>AppData</code> object.
     *
     * @augments Social.US.DataModel
     * @status iOS, Android, Test, iOSTested, AndroidTested
     */	
    initialize: function($super, recordID) {
        $super(recordID);
    }
});

/**
* Takes a user reference and returns key/value pairs of the user for the current game.
* @name Social.US.AppData.getKeysForUser
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {Function} callback The callback function returns key/value pairs for the user and/or and error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">var entries = {"key1": "value1", "key2": "value2"};
* ...
* function(error, entries){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var retrievedEntries = entries;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AppData = Social.US.AppData;
* var retrievedEntries = null;
* AppData.getKeysForUser(user, function(error, entries){
*				retrievedEntries = entries;
*			});
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getKeysForUser = function(user, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getKeysForUser", [user, cb]);
};

/**
* Takes a user, a key (the name of the key for a name/value pair) and returns the key/value pair for the user for the current game.
* @name Social.US.AppData.getDataForUserWithKey
* @function
* @public
* @static
*
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Function} callback Retrieves the key/value pair for the user and/or an error code and description.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error, response){
* &nbsp;&nbsp;   if (error){
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;       var fetchedData = response.data;
* &nbsp;&nbsp;   }
* }
* </pre>
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var AData = Social.US.AppData;
* var errorCode = null;
* var errorDesc = null;
* var fetchedData = null;
* AData.getDataForUserWithKey( user, 
*                              key, 
*                              function(error, response){
*                                   errorCode = error.errorCode;
*                                   errorDesc = error.description;
*                                   fetchedData = response.data;
*                              }
*                            );
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.getDataForUserWithKey = function(user, key, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "getDataForUserWithKey", [user, key, cb]);
};


/**
* Takes data, a user, a key (the name of the key for a name/value pair) and permissions for the data and sets the application data for the user.
* @name Social.US.AppData.setDataForUserWithKeyAndPermissions
* @function
* @public
* @static 
*
* @param {String} data The data to set.
* @param {Social.US.User} user A reference to the user.
* @param {String} key The name of the key.
* @param {Social.US.AppData.Permissions} permission The permissions for the data.
* @param {Function} cb The callback function if there is an error with the parameters.
* <br/> 
* <b>Callback Example:</b><br/>
* <pre class="code">function(error){
* &nbsp;&nbsp;  if(!response) {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorCode = error.errorCode;
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var errorDesc = error.description;
* &nbsp;&nbsp;   } else {
* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;    var responseValues = response;
* &nbsp;&nbsp;   }
* }
* </pre>
* @see Social.US.AppData.Permissions
* @example
* var user = Social.US.Session.getCurrentSession().user();
* var data = "some data";
* var key = "some key";
* var errorCode = null;
* var errorDesc = null;
* var result = null; 
*
* var AData = Social.US.AppData;
* 
* AData.setDataForUserWithKeyAndPermissions(data, 
*                                           user, 
*                                           key, 
*                                           AppData.Permissions.Private, 
*                                           function(error, response){
*                                             errorCode = error.errorCode;
*                                             errorDesc = error.description;
*                                             result = response;
*                                           }
*                                         );
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.setDataForUserWithKeyAndPermissions = function(data, user, key, permissions, cb){
	Dispatcher.callClassMethodOnRemoteObject(AppData, "setDataForUserWithKeyAndPermissions", [data, user, key, permissions, cb]);
};



/**
* Defines permissions for viewing user data.<br/><br/>
* <code>Private</code>: only the user can read and write the user data.<br/>
* <code>FriendsReadOnly</code>: friends can read the user data, but cannot write it.<br/>
* <code>PublicReadOnly</code>: all users can read the user data, but cannot write it. 
* @name Social.US.AppData.Permissions
* @field
* @public
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
AppData.Permissions = {
	Private: 0,
	FriendsReadOnly: 1,
	PublicReadOnly: 2
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/Cache'] = exports; var Class = require('NGCore/Client/Core/Class').Class;
var SocialR = require('NGCore/Client/Social');

/**
 * <code>Cache</code> provides caching for a user's objects residing in the local interpreter.
 * @class 
 * @name Social.US.Cache
 * @private
 */
var Cache = exports.Cache = Class.subclass({


	classname: "Cache",
	inMemoryObjects: {},
	caches: {},
	
	/**
	 * Initializes a cache object upon instantiation. 
	 * @name Social.US.Cache.initialize
	 * @constructs
	 * @private
	 */			
	initialize: function(){
	},

	
	/**
	* Takes a classname and a unique record ID and returns the object or <code>null</code> if it doesn't find the object.
	*
	* @name Social.US.Cache.getObjectWithRecordID
	* @function
	* @private
	*
	* @param {String} classname The name of the class.
	* @param {Number} recordID The object ID.
	*
	* @return Returns the object corresponding to the <code>recordID</code> parameter or <code>null</code> if it doesn't find the object.
	*/
	getObjectWithRecordID: function(classname, recordID){
		var category = this.inMemoryObjects[classname];
		if(category){
			return category[recordID] || null;
		}else{
			return null;
		}
	},
	
	/**
	* Takes an object and adds it to the cache.
	* <code>addObject()</code> takes an object, ensures that it is not already in the cache, and adds it to the cache.
	*
	* @name Social.US.Cache.addObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to add to the cache.
	* @return Returns the record ID of the object added to the cache.
	*/	
	addObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(!category){
			category = {};
			this.inMemoryObjects[classname] = category;
		}

		var object = category[obj.recordID];
		if(object){
			return object;
		}else{
			category[obj.recordID] = obj;
			return obj;
		}
	},
	
	/**
	* Takes an object reference and removes the object from the cache.
	* 
	* @name Social.US.Cache.removeObject
	* @function
	* @private
	*	
	* @param {Object} obj The object to remove from the cache.
	*/	
	removeObject: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		if(category){
			delete category[obj.recordID]; // ZOMG THE DELETE OPERATOR
		}
	},
	
	/**
	* Takes an object reference and returns whether the object is in the cache.
	* 
	* @name Social.US.Cache.isObjectCached
	* @function
	* @private
	*	
	* @param {Object} obj The object to select in the cache.
	*
	* @return Returns <code>true</true> if the object is in the cache; otherwise, it returns <code>false</code>.
	*/		
	isObjectCached: function(obj){
		var classname = obj._classname();
		var category = this.inMemoryObjects[classname];
		return (category && (category[obj.recordID] == obj));
	},
	
	
	saveCache: function(){
		
	},
	
	
	loadCache: function(){
		
	},
	
	/**
	* Takes a JSON array of objects and loads them into the cache.
	*
	* @name Social.US.Cache.loadCacheFromJSONArray
	* @function
	* @private
	*
	* @param {JSON} jsonArray The JSON object array to load into the cache.
	* @param {function} cb <code>loadCacheFromJSONArray()</code> takes an optional callback function.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <code>function(error){<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;<br/>
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;<br/>
	* &nbsp;&nbsp;   }<br/>
	* </code>
	*/			
	loadCacheFromJSONArray: function(jsonArray, cb){
		var objects = [];
        
		for(var idx = 0; idx < jsonArray.length; idx++){
			var hash = jsonArray[idx];
			if(hash && hash.hasOwnProperty("classname") && hash.hasOwnProperty("recordID")){
				var theClassname = hash.classname;
				var theClass = SocialR.Social.US[theClassname];
				var theRecordID = hash.recordID;
				if(theClass && theRecordID){
					var theInstance = this.getObjectWithRecordID(theClassname, theRecordID);
					if(!theInstance){
						theInstance = new theClass(theRecordID, {});
					}
        
					theInstance._deserializeFromHash(hash);
					this.addObject(theInstance);
				}
			}
		}
        
		cb(null, this);
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Session'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Session'] = exports; var CoreReq = require('NGCore/Client/Core');
//var UserReq = require('../Models/User');
var MessageEmitterReq = require('NGCore/Client/Core/MessageEmitter');
var CacheReq = require('NGCore/Client/Social/US/Models/Cache');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * <code>Session</code> manages a user's game sessions.
 * @class 
 * @name Social.US.Session
 */
var Session = exports.Session = MessageEmitterReq.MessageEmitter.subclass({
		
	classname: "Session",
	
	/**
	 * Constructs a session object.
	 * @name Social.US.Session.initialize
	 * @private
	 * @constructs 
	 */	
	initialize: function(gameData){
		if(gameData){
			this._loadSessionData(gameData);
		}
	},
	
	/**
	 * Loads the user's game data into the current session.
	 *
	 * @name Social.US.Session._loadSessionData
	 * @function
	 * @private
	 *
	 * @param {Type} gameData Takes game data and loads it into the current session.
	 */		
	_loadSessionData: function(gameData){
		this._appKey = gameData.appId || this._appKey || null;
		this._appVersion = gameData.appVersion || this._appVersion || null;
		this._platformVersion = gameData.platformVersion || this._platformVersion || "1.0";
		this._serverMode = gameData.serverMode || this._serverMode || null;

		this._user = (gameData.userID ? this.dataCache().getObjectWithRecordID("User", gameData.userID) : null);		
		this.emit({user: this._user});
	},
	
	/**
	 * Returns the cache for the current session. If a session cache does not exist, this call creates a new cache, loads it and returns it.
	 *
	 * @name Social.US.Session.dataCache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The cache for the current session.
	 */			
	dataCache: function(){
		if(!this._cache){
			this._cache = new CacheReq.Cache();
			this._cache.loadCache(function(err){
				NgLogD("Loaded cache: " + err);
			});
		}
		return this._cache;
	},
	
	
	/**
	 * Returns the user for this session.
	 *
	 * @name Social.US.Session.user
	 * @function
	 * @public
	 *
	 * @return {Social.US.User} The user for the current session.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */					
	user: function(){
		return this._user;
	},
	
	

	// data you probably don't need
	/**
	 * Returns the name of the game for this session.
	 *
	 * @name Social.US.Session.appKey
	 * @function
	 * @public
	 *
	 * @return {String} The application name.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */						
	appKey: function(){
		return this._appKey;
	},
	
	/**
	 * Returns the version of the game for this session.	 
	 *
	 * @name Social.US.Session.appVersion
	 * @function
	 * @public
	 *
	 * @return {String} The application version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	appVersion: function(){
		return this._appVersion;
	},
	
	/**
	 * Returns the server mode of the game for this session.
	 *
	 * @name Social.US.Session.serverMode
	 * @function
	 * @public
	 *
	 * @return {String} The server mode.
	 * <b>Note:</b> Valid settings for the server mode include:<br/>
	 * <ul>
	 * <li>staging</li>
	 * <li>integration</li>
	 * <li>sandbox</li>
	 * <li>production</li>
	 * <li>unknown</li>
	 * </ul>
	 * @see Social.US.Session.serverModes
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	serverMode: function(){
		return this._serverMode;
	},
	
	/**
	 * Returns the platform version of the game for this session.
	 *
	 * @name Social.US.Session.platformVersion
	 * @function
	 * @public
	 *
	 * @return {String} The platform version.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	platformVersion: function(){
		return this._platformVersion;
	},
	

	/**
	 * Takes a consumer key and retrieves the session tokens for the the consumer key.
	 *
	 * @name Social.US.Session.getSessionTokensForConsumerKey
	 * @function
	 * @public
	 * 
     * @param {String} consumerKey The consumer key.
	 * @param {Function} cb A callback that retrieves the session tokens for the consumer key. If an error occurs, returns an error code 
	 * and error description.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */	
	getSessionTokensForConsumerKey: function(consumerKey, cb){
		Dispatcher.callClassMethodOnRemoteObject("Session", ["getCurrentSession", "getSessionTokensForConsumerKey"], [[], [consumerKey, cb]]);
	}
});


/**
 * The session modes for the server. Session modes include:
 * <ul>
 * <li><code>staging</code></li>
 * <li><code>integration</code></li>
 * <li><code>sandbox</code></li>
 * <li><code>production</code></li>
 * <li><code>unknown</code></li>
 * </ul>
 * @name Social.US.Session.serverModes
 * @field
 * @public
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.serverModes = {
	staging: "staging",
	integration: "integration",
	partner: "sandbox",
	sandbox: "sandbox",
	production: "production",
	unknown: "unknown"
};

/**
 * Returns the current session.  
 * @name Social.US.Session.getCurrentSession
 * @function
 * @public 
 * @static
 *
 * @return {Social.US.Session} The current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */	
Session.getCurrentSession = function(){
	return Session._currentSession;
};



Session._emitter = null;

/**
 * Adds a listener to the current session.
 *
 * @name Social.US.Session.addCurrentSessionListener
 * @function
 * @public
 * @static
 *  
 * @param {Core.MessageListener }listener The listener to add to the current session.
 * @param {Function} callback The callback function.
 * @param priority The priority for this <code>MessageListener</code>.
 *
 * @see Core.MessageListener
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.addCurrentSessionListener = function(listener, callback, priority){	
	if(!Session._emitter){
		Session._emitter = new MessageEmitterReq.MessageEmitter();
	}
	
	Session._emitter.addListener(listener, callback, priority);
};

/**
 * Removes the listener from the current session.
 *
 * @name Social.US.Session.removeCurrentSessionListener 
 * @function
 * @public 
 * @static
 *
 * @param {Core.MessageListener} listener The listener for the current session.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
Session.removeCurrentSessionListener = function(listener){
	if(Session._emitter){
		Session._emitter.removeListener(listener);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Data/Dispatcher'] = exports; var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var Core = require('NGCore/Client/Core').Core;
var CacheR = require('NGCore/Client/Social/US/Models/Cache');

var SocialR = require('NGCore/Client/Social');
var SessionR = require('NGCore/Client/Social/US/Data/Session');

/**
 * <code>Dispatcher</code> objects know about <code>DataModel</code> objects and can "push" <code>DataModel</code> objects between interpreters.
 * <code>Dispatcher</code> objects can find classes and specific instances of objects, and may invoke their functions.
 * <code>Dispatcher</code> objects also provide a series of convenience functions to facilitate communication between interpreters.
 * @class 
 * @name Social.US.Dispatcher
 * @private
 */
var Dispatcher = exports.Dispatcher = {
				
	classname: "Dispatcher",
	callbackUIDCounter: 0,
	callbacks: {
		"-2": {},
		"-1": {}
	},
	
	/**
	 * Returns the data cache for the current session.
	 * @name Social.US.Dispatcher.cache
	 * @function
	 * @private
	 *
	 * @return {Social.US.Cache} The data cache for the current session.
	 * @see Social.US.Cache
	 */		
	cache: function(){		
		try {		
			return SessionR.Session.getCurrentSession().dataCache();
		}
		catch (err) {
			NgLogD("Mobage/Dispatcher/cache-Warning: cannot get cache. NOTE: This may be expected behavior if early on in initialization. Err=" 
				+ err);

			return null;
		}
	},
	
	
	/**
	 * Gets the current session and loads session data.
	 * If there is no current session, <code>receiveSession()</code> creates a new session.
	 *	 
	 * @name Social.US.Dispatcher.receiveSession
	 * @function
	 * @private
	 *
	 * @param {Type} command Takes a command, which may include the platform version, server mode, application name and application version. 
	 */		
	receiveSession: function(command){		
		var session = SessionR.Session.getCurrentSession();
		if(!session){
			session = new SessionR.Session();
			SessionR.Session._currentSession = session;
		}
		
		var userData = command.data.userData;
		if(userData){
			// the User object will be cached implicitly, then loaded in _loadSessionData
			Dispatcher.receiveObject({data: userData});
		}
		
		session._loadSessionData(command.data);
		
		if(SessionR.Session._emitter){
			SessionR.Session._emitter.emit({session: session});
		}
	},
	
	// DataModel communication
	/**
	 * Finds a particular instance of an object in the local interpreter and calls a method on the object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnLocalObject
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, 
     * its record ID, the method name to call, and any parameters for the method.
	 * The command object takes an optional callback and <code>callMethodOnLocalObject()</code> returns returns the result 
     * and/or any error code and description to the callback function.
	 */		
	callMethodOnLocalObject: function(command){		
		var recordID = command.recordID;
		var classname = command.classname;
		
		var object = Dispatcher.cache().getObjectWithRecordID(classname, recordID);
		if(object){
			var methodName = command.methodName;

			var error = false;
			var args;
			var retVal;
			if(methodName instanceof Array) {
				var methodOwner = object;
				for(var idx = 0; idx < methodName.length; idx++) {
					if(typeof methodOwner[methodName[idx]] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
						retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
						methodOwner = retVal;						
					}
					else {
						error = true;
						break;
					}
				}
			}
			else {
				if(typeof object[methodName] == "function") {
					args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
					retVal = object[methodName].apply(object, args);
				}
				else {
					error = true;
				}
			}
			
			if(error) {
				NgLogD("ERROR: Invalid methods for calling on local object: " + command.recordID + " " + methodName);
			}
			else if(command.callback){
				var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
				if(callback){
					callback(retVal);
				}
			}
		}
	},
	
	
	/**
	 * Finds a particular instance of an object in a remote interpreter and calls a method on the remote object.
	 *	 
	 * @name Social.US.Dispatcher.callMethodOnRemoteObject
 	 * @function
 	 * @private
 	 *
	 * @param {Number} object The object reference (i.e., typically the keyword 'this').
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method, including other <code>DataModel</code> objects or functions.
	 * @param {Function} cb Returns the result and/or any error code and description to the callback function.
	 *
	 * <b>Note:</b> If the target method wants a callback as one/more of its arguments, supply it as an element in the argument array, <b>NOT</b> as the fourth parameter.
	 */			
	callMethodOnRemoteObject: function(object, method, args, cb){		
		if(!object || !method){
			NgLogD("Public.Dispatcher.callMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callMethodOnLocalObject",
			recordID: object.recordID,
			classname: object._classname(),
			methodName: method,
			arguments: args,
			callback: Dispatcher.convertFunctionToJSON(cb)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Calls a static method on a class in the local interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnLocalObject	
	 * @function
	 * @private
	 *
	 * @param {Command} command Takes a command object that identifies the class name of the object, the method name to call, and any parameters for the method.
	 * The command parameter takes an optional callback function and <code>callMethodOnLocalObject()</code> returns returns the result and/or any error code and description to the callback function.
	 */		
	callClassMethodOnLocalObject: function(command){		
		Dispatcher.beginBatching();
		
		var classname = command.classname;
		var methodName = command.methodName;
		if(classname && methodName){
			var theClass = SocialR.Social.US[classname];
			if(!theClass){
				theClass = SocialR.Social.US.Service[classname];
			}
			
			if(theClass){
				var error = false;
				var args;
				var retVal;
				if(methodName instanceof Array) {
					var methodOwner = theClass;
					for(var idx = 0; idx < methodName.length; idx++) {
						if(typeof methodOwner[methodName[idx]] == "function") {
							args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments[idx] || []);
							retVal = methodOwner[methodName[idx]].apply(methodOwner, args);
							methodOwner = retVal;						
						}
						else {
							error = true;
							break;
						}
					}
				}
				else {
					if(typeof theClass[methodName] == "function") {
						args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
						retVal = theClass[methodName].apply(theClass, args);
					}
					else {
						error = true;
					}
				}
				
				if(error) {
					NgLogD("ERROR: Invalid methods for calling on local Class: " + classname + " " + methodName);
				}
				else if(command.callback){
					var callback = Dispatcher.convertFunctionFromJSON({callbackUID: command.callback});
					if(callback){
						callback(retVal);
					}
				}				
			}
		}
		
		Dispatcher.endBatching();
	},

	/**
	 * Calls a static method on a class in a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.callClassMethodOnRemoteObject
	 * @function
	 * @private
	 *
	 * @param {String} theClass The name of the class.
	 * @param {String} method The method name to call.
	 * @param {Array} args An array of parameters for the method.
	 * @param {Function} cb <code>callClassMethodOnRemoteObject()</code> returns returns the result and/or any error code and description to the callback function.
	 * 
	 */			
	callClassMethodOnRemoteObject: function(theClass, methodName, args, cb){		
		if(!theClass || !methodName){
			NgLogD("Public.Dispatcher.callClassMethodOnRemoteObject - bailing");
			if(cb){
				cb();
			}
			return;
		}

		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.callClassMethodOnLocalObject",
			classname: (theClass.classname ? theClass.classname : theClass),
			methodName: methodName,
			arguments: args,
			callback: (cb ? Dispatcher.convertFunctionToJSON(cb) : null)
		};
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},


	// callback communication

	/**
  	 * Takes a callback and sends it to a remote interpreter.
	 *	 
	 * @name Social.US.Dispatcher.sendCallbackToRemote
	 * @function
	 * @private
	 *
	 * @param {String} callbackUID The user ID of the user receiving the callback.
	 * @param {Array} args An array of parameters for the callback function.
	 */		
	sendCallbackToRemote: function(callbackUID, args){		
		args = Dispatcher.convertArgumentsArrayToJSON(args || []);
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveCallbackFromRemote",
			callbackUID: callbackUID,
			arguments: args,
			zone: GSGlobals.getRouterInstance().zone
		};

		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Receives a callback from a remote interpreter and provides the arguments to the local callback function.
	 *	 
	 * @name Social.US.Dispatcher.receiveCallbackFromRemote
	 * @function
	 * @private
	 *
	 * @param {Type} command A JSON object containing the user ID of the user receiving the callback and the callback arguments array.
	 */			
	receiveCallbackFromRemote: function(command){
		var callback = Dispatcher.callbacks[GSGlobals.getRouterInstance().zone][command.callbackUID]; //Dispatcher.convertFunctionFromJSON(command);
		if(!callback){
			return;
		}

		var args = Dispatcher.convertArgumentsArrayFromJSON(command.arguments || []);
		
		callback.apply(callback, args);
	},
	

	// convenience functions to facilitate communication of all objects
	
	/**
	 * Parses a JSON array of function parameters and returns an array of function parameters.
	 *	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayFromJSON
	 * @function
	 * @private
	 * 
	 * @param {Array} args An array of function parameters in JSON format.
	 * @return {Array} Returns an array of function parameters.
	 */	
	convertArgumentsArrayFromJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			
			if(arg && ((arg.recordID && arg.classname) || arg instanceof Array)){
				newArgs[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}else if(arg && arg.callbackUID){
				newArgs[idx] = Dispatcher.convertFunctionFromJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	/**
	 * Parses an array of function parameters and returns the array in JSON format.	 
	 * @name Social.US.Dispatcher.convertArgumentsArrayToJSON
	 * @function
	 * @private
	 *
	 * @param {Array} args An array of function parameters.
	 * 
	 * @returns {JSON} An array of function parameters in JSON format.
	 */
	convertArgumentsArrayToJSON: function(args){		
		var newArgs = [];
		for(var idx=0; idx < args.length; idx++){
			var arg = args[idx];
			if(arg && (arg.recordID && arg._classname && typeof arg._classname == "function" && arg._classname())){
				Dispatcher.sendObjectImmediately(arg);

				arg = Dispatcher.convertModelObjectToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && arg instanceof Array){
				arg = Dispatcher.convertArgumentsArrayToJSON(arg);
				newArgs[idx] = arg;
			}else if(arg && typeof arg == "function"){
				newArgs[idx] = Dispatcher.convertFunctionToJSON(arg);
			}else{
				newArgs[idx] = arg;
			}
		}
		return newArgs;
	},

	// convenience functions to facilitate communication of DataModel objects
	
	/**
	 * Takes a <code>DataModel</code> object and returns the object in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectToJSON
	 * @function
	 * @private
	 * 
	 * @param {Social.Models.DataModel} object A reference to a <code>DataModel</code> object (i.e., typically a subclass of <code>Models.DataModel</code>).
	 *
	 * @return {JSON} A <code>DataModel</code> object in JSON format.
	 */		
	convertModelObjectToJSON: function(object){		
		if(object && object.recordID && object._classname()){
			object = {
				classname: object._classname(),
				recordID:  object.recordID
			};
		}
		return object;
	},


	/**
	 * Takes a <code>DataModel</code> object in JSON format and returns the object.
	 *	 
	 * @name Social.US.Dispatcher.convertModelObjectFromJSON
 	 * @function
 	 * @private
 	 *
	 * @param {JSON} json A <code>DataModel</code> object in JSON format.
	 * 
	 * @return {Social.US.DataModel} A <code>DataModel</code> object.
	 */		
	convertModelObjectFromJSON: function(json){		
		var object = json;
		if(json.recordID && json.classname){
			var obj = Dispatcher.cache().getObjectWithRecordID(json.classname, json.recordID);
			if(obj){
				object = obj;
				if(json.data){
					object._deserializeFromHash(json.data);
				}
			}
		}else if(json instanceof Array){
			for(var idx=0; idx < json.length; idx++){
				var arg = json[idx];
				json[idx] = Dispatcher.convertModelObjectFromJSON(arg);
			}
		}
		return object;
	},

	// convenience functions to facilitate communication of functions
	
	/**
	 * Takes a function and returns the function in JSON format.
	 *	 
	 * @name Social.US.Dispatcher.convertFunctionToJSON
	 * @function
	 * @private	 
	 * 
	 * @param {function} The function to conver to JSON format.
	 * 
	 * @return {JSON} Returns a function in JSON format.
	 */		
	convertFunctionToJSON: function(fn){		
		if(fn && typeof fn == "function"){
			
			var callbackUID = ++Dispatcher.callbackUIDCounter;
			var zone = GSGlobals.getRouterInstance().zone;
			Dispatcher.callbacks[zone][callbackUID] = fn;

			fn = {
				callbackUID: callbackUID,
				zone: zone
			};
		}
		return fn;
	},


	
	/**
 	 * Takes a function expressed in JSON format and returns the function.
	 * @name Social.US.Dispatcher.convertFunctionFromJSON
	 * @function
	 * @private
	 * 
	 * @param {JSON} A function in JSON format.
	 * 
	 * @return {Function} Returns a function.
	 */	
	convertFunctionFromJSON: function(json){		
		var fn = json;
		var callbackUID = fn.callbackUID;
		var zone = fn.zone;
		
		if(callbackUID){
			var callback = Dispatcher.callbacks[zone][callbackUID];
			if(callback){
				fn = callback;
				delete Dispatcher.callbacks[zone][callbackUID];
			}else{
				fn = Dispatcher.generateCallbackForUID(callbackUID);
			}
		}
		return fn;
	},


	
	/**
	 * Takes a user ID and sends the callback to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.generateCallbackForUID
	 * @function
	 * @private
	 *	 
	 * @param {Number} The user ID.
	 * @return {Function} Returns a callback to the remote interpreter.
	 */	
	generateCallbackForUID: function(uid){		
		if(uid.callbackUID){
			uid = uid.callbackUID;
		}
		
		return function(){
			Dispatcher.sendCallbackToRemote(uid, arguments);
		};
	},
	
	
	// object sending and batching
	_batchCount: 0,
	_queuedObjects: [],
	
	/**
	 * <code>beginBatching()</code> increments the batch count.
	 * 
	 * @name Social.US.Dispatcher.
	 * @function
	 * @private
	 */	
	beginBatching: function(){		
		++Dispatcher._batchCount;
	},

	/**
	 * Decrements the batch count.
	 * Decrements the batch count and sends any objects remaining in the queue immediately.
	 *
	 * @name Social.US.Dispatcher.endBatching
	 * @function
	 * @private
	 */	
	endBatching: function(){		
		if((--Dispatcher._batchCount) === 0){
			for(var objKey in Dispatcher._queuedObjects){
				var obj = Dispatcher._queuedObjects[objKey];
				Dispatcher._queuedObjects[objKey] = undefined;
				Dispatcher.sendObjectImmediately(obj);
			}
		}
	},

	/**
	 * Takes an object and adds it to a queue, which pushes the object to the remote interpreter.
	 *
	 * @name Social.US.Dispatcher.sendObject
	 * @function
	 * @private
	 */
	sendObject: function(obj){		
		if(Dispatcher._queuedObjects.indexOf(obj) == -1){
			Dispatcher.beginBatching();
			
			var key = "" + obj.classname + "---" + obj.recordID;
			Dispatcher._queuedObjects[key] = obj;
			
			Dispatcher.endBatching();
		}
	},

	/**
	 * Takes an object and pushes it to the remote interpreter immediately (i.e., bypassing the queue).
	 *
	 * @name Social.US.Dispatcher.sendObjectImmediately
	 * @function
	 * @private
	 */
	sendObjectImmediately: function(obj){		
		if(!obj){
			return;
		}
		
		var cmd = {
			apiURL: "US.Dispatcher.receiveObject",
			data:   obj._serializedHash()
		};
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Receives a serialized object from the remote interpreter, retrieves the local version of the same object from the cache, and deserializes the received object to the local object.
	 * If there is no local version of the received object, <code>receiveObject()</code> creates a local version and adds it to the cache; then, it deserializes the received object to the newly created local object.
	 *
	 * @name Social.US.Dispatcher.receiveObject
	 * @function
	 * @private
	 */
	receiveObject: function(command){		
		var data = command.data;
		var theRecordID  = data.recordID;
		var theClassname = data.classname;
		var theData      = data.data;
		
		if(theRecordID && theClassname && Dispatcher.cache()){
			var obj = Dispatcher.cache().getObjectWithRecordID(theClassname, theRecordID);
			if(!obj){
				var theClass = SocialR.Social.US[theClassname];
				obj = new theClass(theRecordID);
				
				Dispatcher.cache().addObject(obj);
			}

			// TODO disable emitting somehow
			if(theData){
				obj._deserializeFromHash(theData);
			}
		}
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Friends'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var DataModelR = require('NGCore/Client/Social/US/Models/DataModel');
var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.Service.Friends
 */
var Friends = exports.Friends = DataModelR.DataModel.subclass({
    classname: "Friends"
});

/**
 * Opens the "Find Friends" view.
 *
 * @name Social.US.Service.Friends.showFindFriends
 * @function
 * @public
 * @static
 *
 * @param selectedTab Takes an optional tab reference.
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFindFriends = function(selectedTab) {
		NgLogD("Public call showFindFriends");
	
		var cmd = {
			apiURL:"US.Service.Friends.showFindFriends"
		};
		
		if(selectedTab){
			cmd.data.tab = selectedTab;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
};

/**
 * Opens the "Friend Picker" view.
 * 
 * @name Social.US.Service.Friends.openFriendPicker
 * @function
 * @public 
 * @static
 * 
 * @param maxFriendsToPick The maximum number of friends to pick. <code>0</code> for unlimited.
 * @param {Function} callback Retrieves an array of picked users.
 * 
 * <br/> 
 * <b>Callback Example:</b><br/>
 * <pre class="code">function(error, pickedUsers){
 * &nbsp;&nbsp; if(error){
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
 * &nbsp;&nbsp; } else {
 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var users = pickedUsers;
 * &nbsp;&nbsp;}
 * }
 * </pre>
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */		
Friends.showFriendPicker = function(maxFriendsToPick, callback) { 
    Dispatcher.callClassMethodOnRemoteObject(Friends, "showFriendPicker", [maxFriendsToPick, callback]);
};

/**
* <code>Social.US.Service.Friends</code> has an invited user message emitter. 
* To add a message listener to the message emitter, see the example below.
*
* @name Social.US.Service.Friends.invitedUserEmitter
* @field
* @public
* @example
* 
* Social.US.Service.Friends.invitedUserEmitter.addListener(
*				new Core.MessageListener(), 
*				function(user){ 
*				// do sth. w/ User object 
*				}
* Social.US.Service.Friends.invitedUserEmitter.emit({user: user});
* @see Core.MessageListener
* @see Core.MessageEmitter
* @status iOS, Android, Test, iOSTested, AndroidTested
*/
Friends.invitedUserEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Profile'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

/**
 * @class
 * @name Social.US.Service.Profile
 */

exports.Profile = {
	
	/**
	 * Shows the user profile of the user specified by the <code>userOrGamertag</code> parameter.
	 * 
	 * @name Social.US.Service.Profile.showUserProfile
	 * @function
	 * @public
	 * 
	 * @param userOrGamertag Identifies the user or gamertag corresponding to the user profile.
	 * @param tab Specifies the name of the tab to show when the UI opens. If <code>null</code>, it opens the default tab.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */			
	showUserProfile:function(userOrUserGamertag,tab){		
		var cmd = {
			apiURL:"US.Service.Profile.showUserProfile", 
			data:{
				user:userOrUserGamertag
			}
		};
		if(tab){cmd.tab = tab;}
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/ButtonOverlays'] = exports; var UI = require('NGCore/Client/UI').UI;

var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

var Friends = require('NGCore/Client/Social/US/Service/Friends').Friends;
var Profile = require('NGCore/Client/Social/US/Service/Profile').Profile;
var User    = require('NGCore/Client/Social/US/Models/User').User;

/**
 * @class 
 * @name Social.US.Service.ButtonOverlays
 */
exports.ButtonOverlays = {
	/**
	* Displays the "Mobage Community" button.
	*	
	* @name Social.US.Service.ButtonOverlays.showCommunityButton
	* @function
	* @public 
	* 
	* @param {exports.Gravity} gravity Displays the button in the specified corner.
	* @param {Function} callback The callback function if there is an error related to <code>gravity</code> or <code>theme</code> usage.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @see exports.Gravity
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/   
	showCommunityButton: function(gravity, callback) {
		NgLogD("Public - showCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showCommunityButton"
		};
		
		cmd["gravity"] = gravity;
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	* Hides the "Mobage Community" button.
	*
	* @name Social.US.Service.ButtonOverlays.hideCommunityButton
	* @function
	* @public 
	*	
	* @param {Function} callback The callback function if there is an error hiding the button.
	* <br/> 
	* <b>Callback Example:</b><br/>
	* <pre class="code">function(error){
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	* &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	* &nbsp;&nbsp;   }
	* </pre>
	* @status iOS, Android, Test, iOSTested, AndroidTested
	*/	
	hideCommunityButton: function(callback) {
		NgLogD("Public - hideCommunityButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideCommunityButton"
		};
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
		
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Shows the balance button.
	 * Shows the balance button where the <code>rect</code> parameter 
	 * determines the size and position of the button.
	 *
	 * @name Social.US.Service.ButtonOverlays.showBalanceButton
	 * @function
	 * @public
	 *	 
	 * @param {UI.ViewGeometry.Rect} rect Determines the size and position of the balance button.
	 * @param {Function} callback The callback function if there is an error with the <code>rect</code> parameter.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @see UI.ViewGeometry.Rect
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	showBalanceButton: function(rect, callback) {
		NgLogD("Public - showBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.showBalanceButton"
		};
		
		if (rect != undefined) {
			cmd["rect"] = rect;
		} else {
			cmd["rect"] = new UI.ViewGeometry.Rect(50, 50, 0, 0);
		}
		
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Hides the balance button.	
	 * @name Social.US.Service.ButtonOverlays.hideBalanceButton
	 * @function
	 * @public 
	 * 
	 * @param {Function} callback The callback function called after the view closes.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error){
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
	 * &nbsp;&nbsp;   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */		
	hideBalanceButton: function(callback) {
		NgLogD("Public - hideBalanceButton");
		
		var cmd = {
			apiURL:"US.Service.ButtonOverlays.hideBalanceButton"
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		} else {
			cmd["callbackFunc"] = null;
		}
	
		GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	}
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/GameLaunchPayload'] = exports; var RouterInited = require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

var MessageEmitter = require('NGCore/Client/Core/MessageEmitter').MessageEmitter;

/**
* Provides an interface for retrieving a game's last payload from the game service. The game
* payload is returned as a string.
* @name Social.US.GameLaunchPayload
*/

var GameLaunchPayload = exports.GameLaunchPayload = {


	/**
	 * @name Social.US.GameLaunchPayload.getLastPayload
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the last payload generated by the game client from the game service 
     * as a string (e.g., JSON) and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, payload){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var pl = payload;     
     *      }
	 * }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	getLastPayload:function(callback)
	{
        if(callback != undefined && typeof callback == "function")
		{
			var cmd = {
				apiURL:"US.Service.GameLaunchPayload.getLastPayload"
			};

            cmd["callbackFunc"] = callback;

			GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
		}
	},
	
	// private, automatically called when new payload arrives. Do not call.
	onGameLaunchPayload:function(data)
	{
		this.newGamePayloadEmitter.emit(data);
	}
};

GameLaunchPayload.newGamePayloadEmitter = new MessageEmitter();; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Service/Bank'] = exports; // Bank Public Interface
var RouterInited 	= require('NGCore/Client/Social/_Internal/RouterInit');
var GSGlobals 		= require('NGCore/Client/Social/_Internal/GSGlobals');
var UI 				= require('NGCore/Client/UI').UI;

/**
* @ignore
* @private
*/
exports.Bank = {
};


/**
 * @class 
 * @name Bank.Debit
 * @description
 * Bank.Debit is an interface for in-game item purchasing. A transaction begins with a call to <code>createTransaction()</code>, which presents
 * a user interface to the user. If the user follows through with a purchase, the <code>transaction.state</code> property changes from 
 * <code>new</code> to <code>authorized</code>. Once <code>createTransaction()</code> executes its callback, the game may call 
 * <code>openTransaction()</code>, which changes the state from <code>authorized</code> to <code>open</code> and puts funds into escrow. 
 * At this point, the game/game server should deliver the purchased items. Once the items have been delivered, the game should call   
 * <code>closeTransaction()</code>. If there is a problem at any point in the transaction lifecycle, call <code>cancelTransaction()</code>,
 * which sets the <code>transactionState</code> property to <code>canceled</code> and restores funds from escrow back to the user.
 */
exports.Bank.Debit = {
	
		
	/**
	 * Creates a transaction. Initially, it sets the <code>transaction.state</code> to <code>new</code>.
     * Mobage presents a dialog that prompts the user to confirm the transaction. 
	 * If the user decides not to proceed with the transaction, the callback error returns as "usercanceled."
	 * In the client-only flow, this call checks inventory and sets the state to <code>authorized</code>.
	 * 
	 * @name Bank.Debit.createTransaction
	 * @function
	 * @public
	 * 
	 * @param {Array} billingItems The billing items for the transaction. <br/><b>Note:</b> The array is limited to one item for this release.
     * <br/><b>Array Example:</b><br/>
     * <pre class="code"> var billingItems = [{
     *     "item": {
     *           "id": "iceCastle",
     *          },
     *     "quantity": 1
     *    },
     *    {
     *     "item": {
     *           "id": "cobbleStoneRoad",
     *          },
     *     "quantity": 3
     *    } 
     * ];
     * </pre>
	 * @param {String} comment A comment about the transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/> 
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error==='usercanceled'){
     *          var userCanceledDialog = new UI.AlertDialog();
     *          userCanceledDialog.setTitle("Cancel Transaction");
     *          userCanceledDialog.setText("User canceled transaction.");
     *          userCanceledDialog.setChoices([('OK')]);
     *          userCanceledDialog.show();
     *      } else if(error) {
	 *          var errorCode = error.errorCode;
	 *          var errorDesc = error.description;
     *      } else {
     *          var tx = transaction;     
     *      }
	 *   }
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */				
    createTransaction: function(billingItems, comment, callback) {
		NgLogD("Public call createTransaction");
		
		
	var data = {
	    billingItems: billingItems,
	    comment: comment
	};
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.createTransaction",
			data: data
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}    
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Places funds into escrow and begins processing the transaction. 
	 * Indicates the game server needs to deliver the purchased item.
	 * The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>.
	 *
	 * @name Bank.Debit.openTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var tx = transaction;     
     *      }
	 * &nbsp;&nbsp;}
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
	openTransaction: function(transactionId, callback) {
		NgLogD("Public call openTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.openTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Continues processing a transaction.
	 * Checks the inventory to verify the item is valid, available, and so on. After verification, the <code>transaction.state</code> chranges from <code>new</code> to <code>authorized</code>,
	 * and funds are placed in escrow. The <code>transaction.state</code> transitions from <code>authorized</code> to <code>open</code>, which 
	 * indicates the game server needs to deliver the purchased item. 
	 * 	 
	 *
	 * @name Bank.Debit.continueTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or any error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var tx = transaction;     
     *      }
	 * &nbsp;&nbsp;}
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
    continueTransaction: function(transactionId, callback) {
		NgLogD("Public call continueTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.continueTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	

    /**
     * Cancels the transaction. The transaction was canceled or the purchased item was not delivered and the game
     * needs to return the user's funds. The <code>transaction.state</code> transitions to <code>canceled</code>.
     *
     * @name Bank.Debit.cancelTransaction
     * @function
     * @public 
     * 
     * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
     * @param {Function} callback Retrieves the transaction ID and/or an error code and description.
     * <br/>
     * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var tx = transaction;     
     *      }
	 * &nbsp;&nbsp;}
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
     */
    cancelTransaction: function(transactionId, callback) {
		NgLogD("Public call cancelTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.cancelTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = callback;
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
    },


	/**
	 * Closes the transaction. The virtual item was delivered.
	 * The <code>transaction.state</code> transitions from <code>open</code> to <code>closed</code>.
	 *
	 * @name Bank.Debit.closeTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var tx = transaction;     
     *      }
	 * &nbsp;&nbsp;}
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	closeTransaction: function(transactionId, callback) {
		NgLogD("Public call closeTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.closeTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},
	
	/**
	 * Retrieves the transaction corresponding to the given transaction ID parameter.
	 *
	 * @name Bank.Debit.getTransaction
	 * @function
	 * @public
	 * 
	 * @param {String} transactionId The <code>transactionId</code> identifying this transaction.
	 * @param {Function} callback Retrieves the transaction details and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var tx = transaction;     
     *      }
	 * &nbsp;&nbsp;}
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getTransaction: function(transactionId, callback) {
		NgLogD("Public call getTransaction");
		
		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getTransaction",
			data:{}
		};
		
		if (transactionId) {
			cmd.data.transactionId = transactionId;
		}
		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = this._getCallBackFunc(callback);
		}
        
        GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	/**
	 * Retrieves the user's transactions where the state is <code>new</code>, <code>authorized</code> or <code>open</code>.
	 *
	 * @name Bank.Debit.getPendingTransactions
	 * @function
	 * @public
	 * 
	 * @param {Function} callback Retrieves the user's pending transactions and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">function(error, transaction){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var tx = transaction;     
     *      }
	 * &nbsp;&nbsp;}
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPendingTransactions: function(callback) {
		NgLogD("Public call getPendingTransactions");

		var cmd = {
			apiURL:"US.Service.Banking.Purchase.getPendingTransactions",
			data:{}
		};

		if (callback != undefined && typeof callback == "function") {
			cmd["callbackFunc"] = function(err, data) {
				callback(err.error, data.openTransactions);
			};
		}

	    GSGlobals.getRouterInstance().sendCommandToGameService(cmd);
	},

	_getCallBackFunc : function(callback) {
			return function(err, data) {
				if(err) {
					callback(err, undefined);
				} else {
					callback(err, data.transaction);					
				}
			};
	}
};

/**
 * @class 
 * @name Bank.Inventory
 * @description
 * Provides an interface to retrieve items from inventory. The Mobage platform
 * server is responsible for managing item inventory in games.
 */
exports.Bank.Inventory = {


	/**
	 * Retrieves the item identified by its product ID from inventory on the Mobage platform server.
	 *
	 * @name Bank.Inventory.getItem
	 * @function
	 * @public
	 * 
	 * @param {Number} itemId The product ID for the item.
     * @param {Function} callback Retrieves the item from inventory on the Mobage platform server and/or an error code and description.
	 * <br/>
	 * <b>Callback Example:</b><br/>
	 * <pre class="code">var item = {
     *      "id" : "XXXXXXXXX",
     *      "name" : "Tractor",
     *      "price" : 350,
     *      "description" : "Tractor conveys huge amount of equipment.",
     *      "imageUrl" : "http://someurl.com"
     * }
     *function(error, item){
     *      if(error) {
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorCode = error.errorCode;
	 * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var errorDesc = error.description;
     *      } else {
     * &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;   	var itemData = item;
     *      }
	 * &nbsp;&nbsp;}
	 * </pre>
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */    
    getItem: function(itemId,callback) {
	NgLogD("Public call Inventory getItem");

	var data = {
	    itemId: itemId
	};

	var cmd = {
	    apiURL:"US.Service.Banking.Purchase.getItem",
	    data:data
	};

	if (callback != undefined && typeof callback == "function") {
	    cmd["callbackFunc"] =  function(err, data) {
		if(err) {
		    callback(err, undefined);
		} else {
		    callback(err, data.item);					
		}
	    };
	}

	GSGlobals.getRouterInstance().sendCommandToGameService(cmd);

    }


};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSGlobals'] = exports; /**
 * Annoyingly necessary file to break circular dependencies.
 */
var theRouter = null;
exports.setRouterInstance = function(router){
	theRouter = router;
};
exports.getRouterInstance = function(){
	return theRouter;
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/RouterInit'] = exports; var Router = require('NGCore/Client/Social/_Internal/_Router').Router;
var GSGlobals = require('NGCore/Client/Social/_Internal/GSGlobals');

//Generate 1 instance of our router now and treat as the global instance!
GSGlobals.setRouterInstance(new Router());; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/_Router'] = exports; ////////////////////////////////////////////////////////////////////////////////
// Class Router INTERNAL ROUTING CLASS
//
// Copyright (C) 2010 ngmoco:) inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////


var Class = require('NGCore/Shared/Class').Class;
var Core = require('NGCore/Client/Core').Core;
var GSCommand = require('NGCore/Client/Social/_Internal/GSCommand');
var Privileged = require('NGCore/Client/Social/_Internal/Privileged').Social;
var Public = require('NGCore/Client/Social').Social;

////////////////////////////////////////////////////////////////////////////////
var RouterVerbose = false;

exports.Router = Class.subclass(
/** @lends GameService.Router.prototype */
{
	classname: 'Router',
	
	/**
	 * Function.
	 * @constructs
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
	},
	
	/** Member var to help shortcircuit uneccessary bounces out to native. */
	zone:-2,
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
			* Zone for this Router Singleton (per-process)
			* @private */
	Zone:
	{ 
		/** Public Zone */
		Public: -2,
		/** GameService Zone */
		GameService: -1,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 346
	// Method create = -1
	// Method sendToOtherProcess = 2
	// Method onCreate = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 2:
					instance._sendToOtherProcessRecv( cmd );
					break;
				case 3:
					instance._onCreateRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Router._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[346] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_sendToOtherProcessRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		obj[ "gsCommand" ] = Core.Proc.parseJSONString( cmd[ 0 ] );
		if( obj[ "gsCommand" ] === undefined )
		{
			NgLogE("Could not parse gsCommand in Router.sendToOtherProcess from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/** @private */
	_onCreateRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Router.onCreate from command: " + cmd );
			return false;
		}
		
		obj[ "zone" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "zone" ] === undefined )
		{
			NgLogE("Could not parse zone in Router.onCreate from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 346 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_sendToOtherProcessSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 346 + "," + 2 + "," + this.__objectRegistryId + "," + Core.Base64.encode( JSON.stringify( obj[ "gsCommand" ] ) )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// _sendToOtherProcessRecv: function( cmd ) {}
	// sendToOtherProcess: function( gsCommand ) {}
	
	// _onCreateRecv: function( cmd ) {}

// {{/Wg Generated Code}}
	_onCreateRecv:function(cmd) {
		if (!this._onCreateRecvGen(cmd,this)){
			return;
		}
		NgLogD("_Router/_onCreateRecv: "+this.zone);
		//We already stored the zone directly in ourselves (by passing in 'this').
	},
	_sendToOtherProcessRecv: function( cmd )
	{
		var decodedCommand = {};
		if(!this._sendToOtherProcessRecvGen(cmd,decodedCommand)){
			NgLogE("Decode of data for router, failed.");
			return;
		}
		
		var commandObject = decodedCommand["gsCommand"];
		
		//Incoming commands all get executed immediately.
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router/_sendToOtherProcessRecv - in public");
			}
			
			this.dispatchGameCommand(commandObject);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router/ _sendToOtherProcessRecv - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(commandObject);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.dispatchGameCommand(commandObject);
		}
	},
 	sendToOtherProcess: function( gsCommand ) 
	{
		var jsonCommand = GSCommand.makeSafe(gsCommand);
		if(!jsonCommand) {
			NgLogD("Couldn't prep GSCommand message for sending!");
			return;
		}
		
		if(RouterVerbose) {
			NgLogD("_Router.js/sendToOtherProcess: " + JSON.stringify(jsonCommand));
		}
		
		this._sendToOtherProcessSendGen({ "gsCommand": jsonCommand });
	},
	sendCommandToGameService:function(gsCommand) 
	{		
		if(this.zone == this.Zone.Public) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in public");
			}
			
			// In the Public Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.GameService) {
			if(RouterVerbose) {
				NgLogD("_Router: sendCommandToGameService - in privileged");
			}
			
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameServiceCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume public
			this.sendToOtherProcess(gsCommand);
		}
	},
	sendCommandToGame:function(gsCommand)
	{
		if(this.zone == this.Zone.GameService) {
			// In the GameService Interface, this is an alias for sendToOtherProcess
			this.sendToOtherProcess(gsCommand);
		}
		else if(this.zone == this.Zone.Public) {
			// Dispatch Immediately, because we are in the right interpreter
			this.dispatchGameCommand(gsCommand);
		}
		else {
			NgLogE("Unknown Command Zone for the GameService Router.");
			// Assume Privileged
			this.sendToOtherProcess(gsCommand);
		}
	},
	dispatchGameCommand:function(jsonCommand) 
	{
		var tCommand = GSCommand.makeExecutable(jsonCommand);
		//For the time being we expect this to almost always be callbacks
		if(tCommand && tCommand.hasOwnProperty("callbackFunc")) {	
			if( typeof tCommand["callbackFunc"] == "function" ) {
				var args = null;
				var error = null;
				if(tCommand.hasOwnProperty("error")) {
					error = tCommand["error"];
				}
				if(tCommand.hasOwnProperty("callbackData")) {
					args = tCommand["callbackData"];
				}

				//Time to execute the callback function!
				tCommand["callbackFunc"](error,args);
			}
		}
		else if(tCommand) {
			// Case there was no callbackFunc this is odd!!
			var apiURL = null;
			if(tCommand && tCommand.hasOwnProperty("apiURL") ) {
				apiURL = tCommand["apiURL"];

				var apiPieces = apiURL.split(".");
				var curPackage = Public;

				for ( var i = 0; i < apiPieces.length; i++ )
				{
					if(curPackage.hasOwnProperty(apiPieces[i])) {
						curPackage = curPackage[apiPieces[i]];
					}
					else {
						//Total Fail
						NgLogE("Cannot find namespace " + apiURL + " in GameService");
						curPackage = null;
						break;
					}
				}

				if(curPackage && typeof curPackage == "function" ) {			
					curPackage(tCommand);

					return; //done dispatching!
				}else{
					NgLogE("GameService Public cannot dispatch game command " + JSON.stringify(tCommand));
				}
			}
		}
	},
	dispatchGameServiceCommand:function(jsonCommand) 
	{
		//Don't decode the callbackId into a func when on a different interpreter!
		var apiURL = null;
		if(jsonCommand && jsonCommand.hasOwnProperty("apiURL") ) {
			apiURL = jsonCommand["apiURL"];

			var apiPieces = apiURL.split(".");
			var curPackage = Privileged;

			for ( var i = 0; i < apiPieces.length; i++ )
			{
				if(curPackage.hasOwnProperty(apiPieces[i])) {
					curPackage = curPackage[apiPieces[i]];
				}
				else {
					//Total Fail
					NgLogE("Cannot find namespace " + apiURL + " in GameService");
					curPackage = null;
					break;
				}
			}

			if(curPackage && typeof curPackage == "function" ) {			
				curPackage(jsonCommand);

				return; //done dispatching!
			}
		}
		else {
			NgLogE("Someone called GameService without the proper parameters.\n");
		}
	},
	setVerboseLogging:function(useVerbose)
	{
		RouterVerbose = useVerbose;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/GSCommand'] = exports; /**
 * GSCommand.js
 * GameService Command Helper
 *
 * @summary Converts hashes for sending across the interpreter bounds, specifically:
 *		- Takes a hash with a callbackFunc
 * 			- Takes callbackFunc and converts to callbackId
 *		- Takes a hash with a callbackId
 *			- Takes the callbackId and looks up a callbackFunc from the local cache
 */
 
var GameServiceCommandCallbackStore = {};
GameServiceCommandCallbackStore.uidGenerator = 0;

/* @private */
var storeCallbackIdForFunc = function(callbackFunc) {
	var uid = GameServiceCommandCallbackStore.uidGenerator++;
	GameServiceCommandCallbackStore[uid] = callbackFunc;
	return uid;
};
/* @private */
var extractFuncForCallbackId = function(callbackId) {
	if(GameServiceCommandCallbackStore.hasOwnProperty(callbackId)){
		var callbackFunc = GameServiceCommandCallbackStore[callbackId];
		delete GameServiceCommandCallbackStore[callbackId];
		return callbackFunc;
	}
	return null;
};

var blindConvert = function(hash) {
	if ( typeof hash == "object" ) {
		// Case we have a hash
		if ( hash.hasOwnProperty("callbackFunc") ) {
			//	with a callback func to convert
			hash["callbackId"] = storeCallbackIdForFunc(hash["callbackFunc"]);
			
			delete hash["callbackFunc"];
		}
		else if (hash.hasOwnProperty("callbackId")) {
			hash["callbackFunc"] = extractFuncForCallbackId(hash["callbackId"]);
			delete hash["callbackId"];
		}
		return hash;
	}
	
	NgLogD("Error: invalid or non-object passed to gsCmdConvert.");
	return null;
};
exports.makeSafe = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackFunc"))
	{
		return blindConvert(hash);
	}
	return hash;
};
exports.makeExecutable = function(hash) {
	if (hash && typeof hash == "object" && hash.hasOwnProperty("callbackId"))
	{
		return blindConvert(hash);
	}
	return hash;
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/_Internal/Privileged'] = exports; /**
 * Privileged API for GameService (Public Stub)
 * 
 * Access this file as NGCore/Client/Social.js
 */
exports.Social = {
	// stubbed out for the SDK
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] || {}; $MODULE_REGISTRY['NGCore/Client/Social/US/Models/OrderedList'] = exports; var Dispatcher = require('NGCore/Client/Social/US/Data/Dispatcher').Dispatcher;

/**
 * @class 
 * @name Social.US.OrderedList
 * @description
 * Do not instantiate <code>OrderedList</code> objects directly. This description is for information purposes only. 
 * <code>DataModel</code> subclasses that return <code>OrderedList</code> interfaces include:<br/><br/>
 * <div class="ul">
 * <li>{@link Social.US.User}</li>
 * <li>{@link Social.US.Leaderboard}</li>
 * </div><br/>
 * Some <code>DataModel</code> subclasses can return an <code>OrderedList</code>,
 * which is an interface for iterating over a range of values. You determine the iteration range by
 * selecting one of three common functions: <br/><br/>
 * <div class="ul">
 * <li><code>forAll(iterCb, doneCb):</code> Iterates over all values.</li>
 * <li><code>forRange(start, count, iterCb, doneCb):</code> Iterates from the starting index to the count.</li>
 * <li><code>forItem(index, iterCb, doneCb):</code> Iterates over a particular item given by its index.</li>
 * </div>
 * Each of the functions calls an iteration callback (iterCb) for every available item. 
 * When the function iterates over all items or an error occurs, it calls the done callback (doneCb). You <b>MUST</b> provide both callbacks.
 * <br/><br/>
 * <b>Note:</b> The <code>OrderedList</code> interface invokes an iterator on the server. Do NOT assume it will execute your callback functions immediately.
 *
 * @example
 * //NOTE: You MUST provide both callback functions.
 * userBuddiesList.forAll( 
 *      function(error, details){//per item cb body}, 
 *      function(error, details){//done cb body}
 * );
 *
 * @example
 * //Callback examples
 * var done = false;
 * var err = null;
 *
 * currentUser.getFriendsList().forAll(
 *          function(continueCb, user, index){
 *				if(user == otherUser){
 *					foundBuddy = true;
 *					continueCb(false);
 *				}else{
 *					continueCb(true);
 *				}
 *			}, 
 *          function(error){
 *                  if (!error){
 *                      done = true;
 *                   } else {
 *                      err = error;
 *                   }
 *          }
 * );
 * @status iOS, Android, Test, iOSTested, AndroidTested
 */
var OrderedList = {

    /**
    * Returns a public interface for an object.
    * 
    * To expose a privelegee ordered list of a <code>DataModel</code> object in the public interface, 
    * add a function to the object of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getObjectPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },
    *
    * @name Social.US.OrderedList.getObjectPublicInterface
    * @function    
    * @private
    *
    * @param {Object} ownerObject The object that will "own" the public interface.
    * @param {Function} getListFn The function that returns a list of values to the <code>OrderedList</code>.
    * @param interfaceName The name of the interface.
    *
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getObjectPublicInterface: function(ownerObject, getListFn, interfaceName) {
		if(ownerObject[interfaceName]) {
			return ownerObject[interfaceName];
		}
		
		var args = Array.apply(null, arguments);
		if(args && args.length > 3){
			args.splice(0, 3);
		}else{
			args = [];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forAll"], [args,[perItemCb, doneCb]]);		
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forRange"], [args,[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callMethodOnRemoteObject(ownerObject, [getListFn, "forItem"], [args,[index, perItemCb, doneCb]]);
			}
		};
		
		ownerObject[interfaceName] = newInterface;
		
		return newInterface;
	},

    /**
    * Returns a public interface for a class.
    * To expose a priveleged ordered list of a <code>DataModel</code> subclass in the public interface, 
    * add a function to the subclass of the corresponding <code>DataModel</code>
    * subclass in the public interface.
    * @example
    * getFollowersList: function(cb){
 	* 	return OrderedList.getClassPublicInterface(this, "getFollowersList", "_followersListInterface");
	* },    
    *
    * @name Social.US.OrderedList.getClassPublicInterface
    * @function
    * @private
    *
    * @param {Object} owner The owner of the the public interface.
    * @param {Function} getListFn The function to call on each iteration.
    * @param interfaceName The name of the interface.
    * 
    * @return {Social.US.OrderedList} The public interface.
    * @status iOS, Android, Test, iOSTested, AndroidTested
    */
    getClassPublicInterface: function(owner, getListFn, interfaceName) {
		if(owner[interfaceName]) {
			return owner[interfaceName];
		}
		
		var newInterface = {
			forAll: function(perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forAll"], [[],[perItemCb, doneCb]]);
			},
			forRange: function(start, count, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forRange"], [[],[start, count, perItemCb, doneCb]]);
			},
			forItem: function(index, perItemCb, doneCb) {
				Dispatcher.callClassMethodOnRemoteObject(owner, [getListFn, "forItem"], [[],[index, perItemCb, doneCb]]);
			}
		};
		
		owner[interfaceName] = newInterface;
		
		return newInterface;
	}
};

exports.OrderedList = OrderedList;
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Color'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Color'] || {}; $MODULE_REGISTRY['NGCore/Shared/Color'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Color = Class.subclass(
/** @lends Core.Color.prototype */
{
	classname: 'Color',
	
	/**
	 * @class The <code>Color</code> class constructs objects that control the RGB components of a device. 
	 * RGB is a color model used for rendering objects on-screen and is derived 
	 * from the three primary colors used in the model: red, green, and blue.
	 * Each value ranges from <code>(0-1)</code> and determines the color saturation level.	 
	 * @constructs The default constructor.<br><br>
	 * <b>Example:</b> The following code examples illustrate different call styles for <code>Color</code> objects.<br><br>
	 * A new color with all components set to zero (0 = black).
	 * <pre class="code">var style1 = new Core.Color();</pre>
	 *
	 * Copy an existing color.
	 * <pre class="code">var style2 = new Core.Color(style1);</pre>
	 *
	 * Specify all three components.
	 * <pre class="code">var style3 = new Core.Color(1.0, 1.0, 1.0);</pre>
	 *
	 * Specify the color as solid blue.
	 * <pre class="code">var style4 = new Core.Color([0, 0, 1.0]);</pre>
	 *
	 * Specify the color as solid red.
	 * <pre class="code">var style5 = new Core.Color([1.0, 0, 0]);</pre>
	 * 
	 * Specify the color as a dark shade of red.
	 * <pre class="code">var style6 = new Core.Color([.5, 0, 0]);'</pre>
	 * @augments Core.Class
	 * @param {Number} [red=0] The red component.
	 * @param {Number} [green=0] The green component.
	 * @param {Number} [blue=0] The blue component.
	 * @throws {Wrong number of arguments for a Color} Number of parameters passed by this call is invalid.
	 */
	initialize: function(red, green, blue)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._red = 1.0;
				this._green = 1.0;
				this._blue = 1.0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._red = 1.0;
					this._green = 1.0;
					this._blue = 1.0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (color)
					this._red = rhs.getRed();
					this._green = rhs.getGreen();
					this._blue = rhs.getBlue();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._red = 1.0;
							this._green = 1.0;
							this._blue = 1.0;
							break;
						case 1:
							// ([color])
							rhs = rhs[0];
							this._red = rhs.getRed();
							this._green = rhs.getGreen();
							this._blue = rhs.getBlue();
							break;
						case 3:
							// ([red, green, blue])
							this._red = rhs[0];
							this._green = rhs[1];
							this._blue = rhs[2];
							break;
						default:
							throw new Error('Wrong number of arguments for a Color');
					}
				}
				break;
			case 3:
				// (red, gree, blue)
				this._red = arguments[0];
				this._green = arguments[1];
				this._blue = arguments[2];
				break;
			default:
				throw new Error('Wrong number of arguments for a Color');
		}
		return this;
	},
	
	/**
	 * Set the saturation level for all three color components.
	 * @example Core.Color.setAll(0.5, 0.5, 1.0);
	 * @param {Number} [red=0] The red component.
	 * @param {Number} [green=0] The green component.
	 * @param {Number} [blue=0] The blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color for a full list of supported calling styles.
	 */
	setAll: function(red, green, blue)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Retrieve the saturation level for the red component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the red component.
	 */
	getRed: function()
	{
		return this._red;
	},
	
	/**
	 * Retrieve the saturation level for the green component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the green component.
	 */
	getGreen: function()
	{
		return this._green;
	},
	
	/**
	 * Retrieve the saturation level for the blue component of this <code>Color</code>.
	 * @returns {Number} The current saturation level for the blue component.
	 */
	getBlue: function()
	{
		return this._blue;
	},
	
	/**
	 * Set the saturation level for the red component of this <code>Color</code>.
	 * @example Core.Color.setRed(0.7);
	 * @param {Number} red The new saturation level for the red component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getRed
	 */
	setRed: function(red)
	{
		this._red = red;
		return this;
	},
	
	/**
	 * Set the saturation level for the green component of this <code>Color</code>.
	 * @example Core.Color.setGreen(0.3);
	 * @param {Number} green The new saturation level for the green component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getGreen
	 */
	setGreen: function(green)
	{
		this._green = green;
		return this;
	},
	
	/**
	 * Set the saturation level for the blue component of this <code>Color</code>.
	 * @example Core.Color.setBlue(1.0);
	 * @param {Number} blue The new saturation level for the blue component.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color#getBlue
	 */
	setBlue: function(blue)
	{
		this._blue = blue;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Vector'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Vector'] || {}; $MODULE_REGISTRY['NGCore/Shared/Vector'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Vector = Class.subclass(
/** @lends Core.Vector.prototype */
{
	classname: 'Vector',
	
	/**
	 * @class The <code>Vector</code> class constructs objects that define vector point values for the <i>x</i> and <i>y</i> components. 
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Vector</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Vector();</pre>
	 *
	 * Copy an existing vector.
	 * <pre class="code">var style2 = new Core.Vector(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Vector(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Vector([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> component.
	 * @param {Number} [y=0] The <i>y</i> component.
	 * @throws {Wrong number of arguments for a Vector} Number of parameters passed by this call is invalid.
	 * @status iOS, Android, Flash
	 */
	initialize: function()
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (vector)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([vector])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Vector');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Vector');
		}
	},
	
	/**
	 * Set the value of both components for this <code>Vector</code>. 
	 * @param {Number} [x=0] The new <i>x</i> coordinate.
	 * @param {Number} [y=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function()
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Vector</code>.
	 * @returns {Core.Vector} A new vector with identical coordinates to the duplicated vector.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Vector#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Vector</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component for this <code>Vector</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Vector#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Vector</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Vector#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Point'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Point'] || {}; $MODULE_REGISTRY['NGCore/Shared/Point'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Point = Class.subclass(
/** @lends Core.Point.prototype */
{
	classname: 'Point',
	
	/**
	 * @class The <code>Point</code> class defines a 2D point coordinate (<i>x</i> and <i>y</i>). 
	 * @status iOS, Android, Flash, Test
	 * @constructs The default constructor. <br><br>
	 * <b>Example:</b>The following code examples illustrate a variety of different calling styles for <code>Point</code> objects.<br><br>
	 * All components are set to zero.
	 * <pre class="code">var style1 = new Core.Point();</pre>
	 *
	 * Copy an existing point.
	 * <pre class="code">var style2 = new Core.Point(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Point(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Point([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [x=0] The <i>x</i> coordinate.
	 * @param {Number} [y=0] The <i>y</i> coordinate.
	 * @throws {Wrong number of arguments for a Point} Number of parameters passed by this call is invalid.
	 */
	initialize: function(x, y)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._x = 0;
				this._y = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._x = 0;
					this._y = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (point)
					this._x = rhs.getX();
					this._y = rhs.getY();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._x = 0;
							this._y = 0;
							break;
						case 1:
							// ([point])
							rhs = rhs[0];
							this._x = rhs.getX();
							this._y = rhs.getY();
							break;
						case 2:
							// ([x, y])
							this._x = rhs[0];
							this._y = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Point');
					}
				}
				break;
			case 2:
				// (x, y)
				this._x = arguments[0];
				this._y = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Point');
		}
	},
	
	/**
	 * Set the value of both the <i>x</i> and <i>y</i> components. 
	 * @param {Number} [<i>x</i>=0] The new <i>x</i> coordinate.
	 * @param {Number} [<i>y</i>=0] The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(x, y)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Point</code>.
	 * @returns {Core.Point} A new point with identical <i>x</i> and <i>y</i> coordinates to the cloned point.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>x</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>x</i> coordinate.
	 * @see Core.Point#setX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getX: function()
	{
		return this._x;
	},
	
	/**
	 * Set the value of the <i>x</i> component for this <code>Point</code>.
	 * @param {Number} <i>x</i> The new <i>x</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getX
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setX: function(x)
	{
		this._x = x;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>y</i> component of this <code>Point</code>.
	 * @returns {Number} The current <i>y</i> coordinate.
	 * @see Core.Point#setY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getY: function()
	{
		return this._y;
	},
	
	/**
	 * Set the value of the <i>y</i> component for this <code>Point</code>.
	 * @param {Number} <i>y</i> The new <i>y</i> coordinate.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Point#getY
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setY: function(y)
	{
		this._y = y;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Size'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Size'] || {}; $MODULE_REGISTRY['NGCore/Shared/Size'] = exports; var Class = require('NGCore/Shared/Class').Class;

exports.Size = Class.subclass(
/** @lends Core.Size.prototype */
{
	classname: 'Size',
	
	/**
	 * @class The <code>Size</code> class constructs objects that define size values for the <i>height</i> and <i>width</i> components. 
	 * @status iOS, Android, Flash
	 * Supported values range between <code>(0-1)</code>.
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Size</code> objects.<br><br>
	 * Set both component values to 0.
	 * <pre class="code">var style1 = new Core.Size();</pre>
	 *
	 * Copy an existing size.
	 * <pre class="code">var style2 = new Core.Size(style1);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style3 = new Core.Size(1.0, 1.0);</pre>
	 *
	 * Specify a value for both components.
	 * <pre class="code">var style4 = new Core.Size([1.0, 1.0]);</pre>
	 * @augments Core.Class
	 * @param {Number} [width=0] The <i>width</i> component.
	 * @param {Number} [height=0] The <i>height</i> component.
	 */
	initialize: function(width, height)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._width = 0;
				this._height = 0;
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._width = 0;
					this._height = 0;
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (size)
					this._width = rhs.getWidth();
					this._height = rhs.getHeight();
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._width = 0;
							this._height = 0;
							break;
						case 1:
							// ([size])
							rhs = rhs[0];
							this._width = rhs.getWidth();
							this._height = rhs.getHeight();
							break;
						case 2:
							// ([x, y])
							this._width = rhs[0];
							this._height = rhs[1];
							break;
						default:
							throw new Error('Wrong number of arguments for a Size');
					}
				}
				break;
			case 2:
				// (x, y)
				this._width = arguments[0];
				this._height = arguments[1];
				break;
			default:
				throw new Error('Wrong number of arguments for a Size');
		}
	},
	
	/**
	 * Set the value of all components for this <code>Size</code>. 
	 * @param {Number} [width=0] The new <i>width</i>.
	 * @param {Number} [height=0] The new <i>height</i>.
	 * @throws {Wrong number of arguments for a Size} Number of parameters passed by this call is invalid.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(width, height)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate this <code>Size</code>.
	 * @returns {Core.Size} A new size with identical <i>height</i> and <i>width</i> components.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the value of the <i>width</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>width</i>.
	 * @see Core.Size#setWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWidth: function()
	{
		return this._width;
	},
	
	/**
	 * Set the value of the <i>width</i> component for this <code>Size</code>.
	 * @param {Number} width The new <i>width</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getWidth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setWidth: function(width)
	{
		this._width = width;
		return this;
	},
	
	/**
	 * Retrieve the value of the <i>height</i> component for this <code>Size</code>.
	 * @returns {Number} The current <i>height</i>.
	 * @see Core.Size#setHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHeight: function()
	{
		return this._height;
	},
	
	/**
	 * Set the value of the <i>height</i> component for this <code>Size</code>.
	 * @param {Number} height The new <i>height</i>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Size#getHeight
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setHeight: function(height)
	{
		this._height = height;
		return this;
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Rect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Rect'] || {}; $MODULE_REGISTRY['NGCore/Shared/Rect'] = exports; var Class = require('NGCore/Shared/Class').Class;
var Point = require('NGCore/Shared/Point').Point;
var Size = require('NGCore/Shared/Size').Size;

exports.Rect = Class.subclass(
/** @lends Core.Rect.prototype */
{
	classname: 'Rect',
	
	/**
	 * @class The <code>Rect</code> class constructs a rectangle object that is derived from two values: a point of origin  
	 * and a size.	 
	 * @status iOS, Android, Flash
	 * @constructs The default constructor. <br><br>
	 * The following code examples illustrate a variety of different calling styles for <code>Rect</code> objects.<br><br>
	 * All components set to zero.
	 * <pre class="code">var style1 = new Core.Rect();</pre>
	 *
	 * Copy an existing <code>rect</code>.
	 * <pre class="code">var style2 = new Core.Rect(style1);</pre>
	 *
	 * Specify a point and size.
	 * <pre class="code">var style3 = new Core.Rect(new Core.Point(), new Core.Size());</pre>
	 *
	 * Specify four components.
	 * <pre class="code">var style4 = new Core.Rect(0, 0, 100, 100);</pre>
	 * @augments Core.Class
	 * @param {Core.Point} [origin=0] The rectangle point of origin.
	 * @param {Core.Size} [size=0] The rectangle size.
	 * @throws {Wrong number of arguments for a Rect} Number of parameters passed by this call is invalid.
	 */
	initialize: function(origin, size)
	{
		switch(arguments.length)
		{
			case 0:
				// ()
				this._origin = new Point();
				this._size = new Size();
				break;
			case 1:
				var rhs = arguments[0];
				if(rhs === undefined)
				{
					// (undefined)
					this._origin = new Point();
					this._size = new Size();
				}
				else if(!rhs.hasOwnProperty('length'))
				{
					// (rect)
					this._origin = new Point(rhs.getOrigin());
					this._size = new Size(rhs.getSize());
				}
				else
				{
					switch(rhs.length)
					{
						case 0:
							// ([])
							this._origin = new Point();
							this._size = new Size();
							break;
						case 1:
							// ([rect])
							rhs = rhs[0];
							this._origin = new Point(rhs.getOrigin());
							this._size = new Size(rhs.getSize());
							break;
						case 2:
							// ([point, size])
							// ([[x, y], [width, height]])
							this._origin = new Point(rhs[0]);
							this._size = new Size(rhs[1]);
							break;
						case 4:
							// ([x, y, width, height])
							this._origin = new Point(rhs[0], rhs[1]);
							this._size = new Size(rhs[2], rhs[3]);
							break;
						default:
							throw new Error('Wrong number of arguments for a Rect');
					}
				}
				break;
			case 2:
				// (point, size)
				this._origin = new Point(arguments[0]);
				this._size = new Size(arguments[1]);
				break;
			case 4:
				// (x, y, width, height)
				this._origin = new Point(arguments[0], arguments[1]);
				this._size = new Size(arguments[2], arguments[3]);
				break;
			default:
				throw new Error('Wrong number of arguments for a Rect');
		}
	},
	
	/**
	 * Set the value of all components for this <code>rect</code>. 
	 * @param {Core.Point} [origin=0] The new point of origin.
	 * @param {Core.Size} [size=0] The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect for examples of supported calling styles.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAll: function(origin, size)
	{
		this.constructor.apply(this, arguments);
		return this;
	},
	
	/**
	 * Duplicate the point of origin of this <code>rect</code>.
	 * @returns {Core.Point} A new rectangle with an identical origin and size.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	clone: function()
	{
		return new this.constructor(this);
	},
	
	/**
	 * Retrieve the point of origin for this <code>rect</code>.
	 * @returns {Core.Point} The current point of origin.
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOrigin: function()
	{
		return this._origin;
	},
	
	/**
	 * Set the point of origin for this <code>rect</code>.
	 * @param {Core.Point} origin The new point of origin.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOrigin: function(origin)
	{
		this._origin.setAll(origin);
		return this;
	},
	
	/**
	 * Change the point of origin so that the center of this <code>rect</code> is at the specified location.
	 * @param {Core.Point} origin The new point of origin that results in a rectangle with a center position at the specified location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setSizeCentered,
	 * @see Core.Rect#setOrigin
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOriginCentered: function(origin)
	{
		origin = new Core.Point(origin);
		this._origin.setX(origin.getX() - this._size.getWidth()/2);
		this._origin.setY(origin.getY() - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the size of this <code>rect</code>.
	 * @returns {Core.Size} The current rectangle size.
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Set the size of this <code>rect</code>.
	 * @param {Core.Size} size The new rectangle size.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		this._size.setAll(size);
		return this;
	},
	
	/**
	 * Set the size of this <code>rect</code> and preserve the current center position.
	 * @param {Core.Size} size The new rectangle size that retains the current center position.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Rect#setOriginCentered,
	 * @see Core.Rect#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSizeCentered: function(size)
	{
		var oldWidth = this._size.getWidth();
		var oldHeight = this._size.getHeight();
		
		this._size.setAll(size);

		this._origin.setX(this._origin.getX() + oldWidth/2 - this._size.getWidth()/2);
		this._origin.setY(this._origin.getY() + oldHeight/2 - this._size.getHeight()/2);
		return this;
	},
	
	/**
	 * Retrieve the minimum value for <i>x</i>. This is represented by the left coordinate.
	 * @returns {Number} The current minimum value of  the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinX: function()
	{
		return this._origin.getX();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>x</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>x</i> coordinate values. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidX: function()
	{
		return this._origin.getX() +  this._size.getWidth()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>x</i>. This is the right coordinate.
	 * @returns {Number} The current maximum value of the <i>x</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxX: function()
	{
		return this._origin.getX() + this._size.getWidth();
	},
	
	/**
	 * Retrieve the minimum value for <i>y</i>. This is the top coordinate.
	 * @returns {Number} The current minimum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMinY: function()
	{
		return this._origin.getY();
	},
	
	/**
	 * Retrieve the average of the minimum and maximum <i>y</i> values. This is the middle coordinate.
	 * @returns {Number} The current average of the minimum and maximum <i>y</i> coordinate values.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMidY: function()
	{
		return this._origin.getY() + this._size.getHeight()/2;
	},
	
	/**
	 * Retrieve the maximum value for <i>y</i>. This is the bottom coordinate.
	 * @returns {Number} The current maximum value of the <i>y</i> coordinate.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getMaxY: function()
	{
		return this._origin.getY() + this._size.getHeight();
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Shared/Lib/sprintf'] = function(){var exports = $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] || {}; $MODULE_REGISTRY['NGCore/Shared/Lib/sprintf'] = exports; /**
sprintf() for JavaScript 0.6

Copyright (c) Alexandru Marasteanu <alexaholic [at) gmail (dot] com>
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of sprintf() for JavaScript nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL Alexandru Marasteanu BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


Changelog:
2007.04.03 - 0.1:
 - initial release
2007.09.11 - 0.2:
 - feature: added argument swapping
2007.09.17 - 0.3:
 - bug fix: no longer throws exception on empty paramenters (Hans Pufal)
2007.10.21 - 0.4:
 - unit test and patch (David Baird)
2010.05.09 - 0.5:
 - bug fix: 0 is now preceeded with a + sign
 - bug fix: the sign was not at the right position on padded results (Kamal Abdali)
 - switched from GPL to BSD license
2010.05.22 - 0.6:
 - reverted to 0.4 and fixed the bug regarding the sign of the number 0
 Note:
 Thanks to Raphael Pigulla <raph (at] n3rd [dot) org> (http://www.n3rd.org/)
 who warned me about a bug in 0.5, I discovered that the last update was
 a regress. I appologize for that.
**/



exports.sprintf = function() {
	str_repeat = function(i, m) {
		for (var o = []; m > 0; o[--m] = i);
		return o.join('');
	};

	var params = new Array();
	var outputArray = false;
	var paramsConsumed = 1;
	if (typeof(arguments[0]) == 'object' && arguments[0].length) {
		outputArray = true;
		for (var i = 0; i < arguments[0].length; ++i) {
			params[i] = arguments[0][i];
		}
	} else {
		for (var i = 0; i < arguments.length; ++i) {
			params[i] = arguments[i];
		}
	}

	var i = 0, a, f = params[i++], o = [], m, p, c, x, s = '';
	while (f) {
		if (m = /^[^\x25]+/.exec(f)) {
			o.push(m[0]);
		}
		else if (m = /^\x25{2}/.exec(f)) {
			o.push('%');
		}
		else if (m = /^\x25(?:(\d+)\$)?(\+)?(0|'[^$])?(-)?(\d+)?(?:\.(\d+))?([b-fosuxX])/.exec(f)) {
			if (((a = params[m[1] || i++]) == null) || (a == undefined)) {
				throw('Too few arguments.');
			}
			if (/[^s]/.test(m[7]) && (typeof(a) != 'number')) {
				throw('Expecting number but found ' + typeof(a));
			}
			switch (m[7]) {
				case 'b': a = a.toString(2); break;
				case 'c': a = String.fromCharCode(a); break;
				case 'd': a = parseInt(a); break;
				case 'e': a = m[6] ? a.toExponential(m[6]) : a.toExponential(); break;
				case 'f': a = m[6] ? parseFloat(a).toFixed(m[6]) : parseFloat(a); break;
				case 'o': a = a.toString(8); break;
				case 's': a = ((a = String(a)) && m[6] ? a.substring(0, m[6]) : a); break;
				case 'u': a = Math.abs(a); break;
				case 'x': a = a.toString(16); break;
				case 'X': a = a.toString(16).toUpperCase(); break;
			}
			a = (/[def]/.test(m[7]) && m[2] && a >= 0 ? '+'+ a : a);
			c = m[3] ? m[3] == '0' ? '0' : m[3].charAt(1) : ' ';
			x = m[5] - String(a).length - s.length;
			p = m[5] ? str_repeat(c, x) : '';
			o.push(s + (m[4] ? a + p : p + a));
			if (outputArray) ++paramsConsumed;
		}
		else {
			throw('Huh ?!');
		}
		f = f.substring(m[0].length);
	}
	if (outputArray && paramsConsumed > 0) {
		arguments[0].splice(0, paramsConsumed);
	}
	return o.join('');
};

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/AbstractView'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/AbstractView'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var Commands = require('NGCore/Client/UI/Commands').Commands;
var Rect = require('NGCore/Client/UI/ViewGeometry').Rect;

var AbstractView = exports.AbstractView = Element.subclass(
/** @lends UI.AbstractView.prototype */
{
	'type':'<com.ngmoco.view.abstract>',
	/**
	* @class The <code>AbstractView</code> class is a base class for derived classes that handle and manage application views.<br><br>
	* <b>Caution!:</b> This base class is not exported in the UI module. Do not access it or subclass it at runtime. 
	* Derived classes from <code>AbstractView</code> include:
	* <div class="ul">
	 * <li>{@link UI.Button}</li>
	 * <li>{@link UI.CellView}</li>
	 * <li>{@link UI.CheckBox}</li>
	 * <li>{@link UI.CheckoutView}</li>
	 * <li>{@link UI.DocumentView}</li>
	 * <li>{@link UI.EditText}</li>
	 * <li>{@link UI.GLView}</li>
	 * <li>{@link UI.Image}</li>
	 * <li>{@link UI.Label}</li>
	 * <li>{@link UI.Spinner}</li>
	 * <li>{@link UI.View}</li>
	 * <li>{@link UI.WebView}</li>
	 * </div>
	* @constructs The default constructor.
	* @augments UI.Element
	* @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	* @param {String} properties Object properties.
	*/
	initialize: function($super, properties) {
		if (AbstractView._init) AbstractView._init();
		
		this._assignedVisible = true;
		$super(properties);
	},
	
	/** @private */
	destroy: function($super){
		this.removeFromParent();
		$super();
	},
	
	/**
	 * @function 
	 * @description Retrieve the parent node for this view.
	 * @returns Returns the parent if this view is a child of another element. Otherwise, returns undefined.
	 * @see UI.AbstractView#addToParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	getParent: function(){
		return this._parent;
	},
    
	/**
	 * Add a node at the specified index to the specified parent node.
	 * @example var myParent = new UI.View({
	 * 	...
	 * });
	 * var childNode = new UI.View({
	 *	...
	 * });
	 * ...
	 * childNode.addToParent(myParent); 
	 * @function
	 * @param {Object} parentNode The parent node.
	 * @param {Number} [index] The parent node index location.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#removeFromParent
	 */    
	addToParent: function(parentNode, index){
		parentNode.addChild(this, index);
	},
    
	/**
	 * Remove a node from the parent node.
	 * @example childNode.removeFromParent(myParent);
	 * @function 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see UI.AbstractView#getParent,
	 * @see UI.AbstractView#addToParent
	 */    
	removeFromParent: function(){
		if (this._parent && !this._parent._destroyed) {
			this._parent.removeChild(this);
			this._parent = null;
		}
		return this;
	},
	
	
	/**
	 * Add a new view state.
	 * @function 
	 * @example this.addState(UI.State.Disabled);
	 * @param {UI.State} flags View state flags supported by the new view state.
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#clearState
	 */  
	addState: function(flags) {
		this.setState(this._state | flags);
	},
	
	/**
	 * Clear the view state and set view state flags to the default value.
	 * @function 
	 * @example this.clearState(UI.State.Disabled);
	 * @param {UI.State} flags
	 * @see UI.AbstractView#getState,
	 * @see UI.AbstractView#setState,
	 * @see UI.AbstractView#addState
	 */  
	clearState: function(flags) {
		this.setState(this._state & ~flags);
	},
    
	/**
	 * Retrieve the root node for this object.
	 * @function 
	 * @returns Returns the root node if this is a child node. Otherwise, returns undefined.
	 */
	getRoot: function() {
		return this._parent ? this._parent.getRoot() : undefined;
	},
    

	/** @protected */
	_setVisible: function(makeVisible) {
		var willBeVisible = makeVisible && this._assignedVisible && this._parent && this._parent._visible;
		if (this._visible != willBeVisible) {
			this._visible = willBeVisible;
			var fn = this._eventCallbacks[ (makeVisible ? 'appear' : 'disappear') ];
			if (typeof fn == 'function') fn.call(this);
		}
	}
});

// Properties
AbstractView._init = function() {
	delete AbstractView._init;
	if (Element._init) Element._init();
	
	var getVisible = function() {
		return this._visible;
	};
	var setVisible = function(makeVisible) {
		this._assignedVisible = makeVisible;
		Commands.setIsVisible.call(this, makeVisible);
		this._setVisible(makeVisible);
	};
	/**
	 * @name UI.AbstractView#setVisible
	 * @description Set the visibility for this object.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setVisible(true);
	 * @function 
	 * @param {boolean} makeVisible Set as <code>true</code> if this object is visible.
	 * @see UI.AbstractView#getVisible
	 */
	/**
	 * @name UI.AbstractView#getVisible
	 * @description Retrieve the state of visibility for this object.
	 * @function
	 * @returns {boolean} Returns <code>true</code> if this object is visible.
	 * @see UI.AbstractView#setVisible
	 */
	AbstractView.registerAccessors('visible', getVisible, setVisible);
	
	/**
	 * @name UI.AbstractView#setBackgroundColor
	 * @description Set the value for the <code>backgroundColor</code> property. This property defines the color of the background for an object when rendered.
	 * @example SomeView = new UI.View();
	 * ...
	 * SomeView.setBackgroundColor("FF000000");
	 * @param {String} backgroundColor The new background color.
	 * @see UI.AbstractView#getBackgroundColor
	 * @type Color
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBackgroundColor
	 * @description Retrieve the value of the <code>backgroundColor</code> property.
	 * @returns {String} The current background color.
	 * @see UI.AbstractView#setBackgroundColor
	 * @function
	 */
	AbstractView.synthesizeProperty('backgroundColor', Commands.setBackgroundColor);
	/**
	 * @name UI.AbstractView#setEnabled
	 * @description Set the value for the <code>enabled</code> property. This property defines an object as active or inactive.
	 * @param {Boolean} enabled Set as <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#getEnabled
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getEnabled
	 * @description Retrieve the value of the <code>enabled</code> property. 
	 * @returns {Boolean} Returns <code>true</code> if this view state is enabled.
	 * @see UI.AbstractView#setEnabled
	 * @function
	 */
	
	AbstractView.synthesizeProperty('enabled', function(enable) {
		this[ (enable ? 'clearState' : 'setState') ](Commands.State.Disabled);
	});
	/**
	 * @name UI.AbstractView#setState
	 * @description Set the value for the <code>state</code> property. This property defines the view state for an object.
	 * @example cellView.setState(UI.State.Normal);
	 * @param {Number} state The new view state.
	 * @see UI.AbstractView#getState
	 * @type State
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getState
	 * @description Retrieve the value of the <code>state</code> property.
	 * @returns {Number} The current view state.
	 * @see UI.AbstractView#setState
	 * @function
	 */
	AbstractView.synthesizeProperty('state', Commands.setState);

	
	/**
	 * @name UI.AbstractView#getFrame
	 * @description Retrieve the value of the <code>frame</code> property.
	 * @param {Number, Array (Number)} frame Individual components or a component array (<i>x</i>,<i>y</i>,<i>w</i>,<i>h</i>).
	 * @see UI.AbstractView#setFrame
	 * @function
	 */
	var getFrame = function() {
		return this._frame;
	};
	/**
	 * @name UI.AbstractView#setFrame
	 * @function 
	 * @description Set the value of the <code>frame</code> property. This property defines the size of <code>frame</code> objects.
	 * @example var back = new UI.Button();
	 * ...
	 * back.setFrame([10, 10, 64, 64]);
	 * @param {Number, Array (Number), Object} arg0 This parameter will pass in values in one of three ways:
	 * <div class="ul">
	 * <li>Four float values (<i>x</i>, <i>y</i>, <i>w</i>, <i>h</i>).</li>
	 * <li>Single array containing the above four values.</li>
	 * <li>A rect specifying the frame (see <code>{@link UI.ViewGeometry.Rect}</code>).</li>
	 * </div>
	 * @see UI.AbstractView#getFrame
	 * @function
	 */
	var setFrame = function(arg0) {
		if( arg0 instanceof Rect ){
			this._frame = arg0.array();
		}
		else if( arg0 instanceof Array ){
			this._frame = arg0;
		}
		else {
			this._frame = Array.prototype.slice.call(arguments);
		}
		Commands.setFrame.apply(this, this._frame);
	};
	AbstractView.registerAccessors('frame', getFrame, setFrame);

	/**
	 * @name UI.AbstractView#setGradient
	 * @description Set the value of the <code>gradient</code> property for a view state. This property defines an image gradient for the object when rendered.
	 * @example label.setGradient({
	 *	corners: '11 11 11 11',
	 *	gradient: ['FFFF8000 0.0', 'FF703300 1.0']
	 * }, UI.State.Selected);
	 * @param {Object} gradient The new gradient. 
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @see UI.AbstractView#getGradient
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getGradient
	 * @description Retrieve the value of the <code>gradient</code> property for a view state.
	 * @param {UI.State} [flags=UI.State.Normal] The UI view state.
	 * @returns {Object} The current gradient.
	 * @see UI.AbstractView#setGradient
	 * @function	
	 */
	AbstractView.synthesizePropertyWithState('gradient', Commands.setGradient);	
	/**
	 * @name UI.AbstractView#setBlockTouchEvents
	 * @description Set the value of the <code>blockTouchEvents</code> property.
	 * @param {Object} blockTouchEvents The new value for <code>blockTouchEvents</code>.
	 * @see UI.View#getBlockTouchEvents
	 * @function
	 */
	/**
	 * @name UI.AbstractView#getBlockTouchEvents
	 * @description Retrieve the value of the <code>blockTouchEvents</code> property.
	 * @returns {Object} The current value of <code>blockTouchEvents</code>.
	 * @see UI.View#setBlockTouchEvents
	 * @function
	 */
	AbstractView.synthesizeProperty('touchable', Commands.setTouchable);
	/**
	 * @name UI.AbstractView#setAlpha
	 * @function
	 * @description Set the value of the <code>alpha</code> property. This property defines the level of alpha composting for a specified object when rendered.
	 * @example this._node.setAlpha(1);
	 * @param {Number} decimal Alpha value ranging between <code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#getAlpha
	 * @type Float
	 * @status iOS
	 */
	/**
	 * @name UI.AbstractView#getAlpha
	 * @function
	 * @description Retrieve the value of the <code>alpha</code> property.
	 * @returns {Number} Alpha value ranging between </code>(0.0-1.0)</code>.
	 * @see UI.AbstractView#setAlpha
	 * @type Float
	 * @status
	 */
	AbstractView.synthesizeProperty('alpha', Commands.setAlpha);




	// Event Handlers
	/**
	 * @name UI.AbstractView#setOnAppear
	 * @description Set a function to call when the <code>appear</code> event occurs.
	 * @param {Function} appearCallback The new callback function. <br><br><b>Note:</b> The <code>appear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onAppear.appear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnAppear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnAppear
	 * @description Retrieve the function to call when the <code>appear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnAppear
	 * @event
	 */
	AbstractView.registerEventType('appear');
	/**
	 * @name UI.AbstractView#setOnDisappear
	 * @description Set a function to call when the <code>disappear</code> event occurs.
	 * @param {Function} disappearCallback The new callback function. <br><br><b>Note:</b> The <code>disappear</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onDisappear.disappear = true; 
	 * };
	 * @see UI.AbstractView#event:getOnDisappear
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnDisappear
	 * @description Retrieve a function to call when the <code>disappear</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnDisappear
	 * @event
	 */
	AbstractView.registerEventType('disappear');
	/**
	 * @name UI.AbstractView#setOnClick
	 * @description Set a function to call when the <code>click</code> event occurs.
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>click</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onClick.clicked = true; 
	 * };
	 * @see UI.AbstractView#event:getOnClick
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnClick
	 * @description Retrieve a function to call when the <code>click</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnClick
	 * @event
	 */
	AbstractView.registerEventType('click');
	/**
	 * @name UI.AbstractView#setOnSwipe
	 * @description Set a function to call when a <code>swipe</code> event occurs. 
	 * This is when the user swipes a finger across this view, like how you indicate a "delete row"
	 * request on a table view.  The function gets the UI.Commands.SwipeDirection from 
	 * the first parameter.direction.  
	 * @example
	 * view.setOnSwipe( function(params) { 
	 *	NgLogD("swipe code "+params.direction) 
	 *   } 
	 * );
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The <code>swipe</code> event is disabled 
	 * if the value of this parameter is not a function.
	 * @see UI.AbstractView#event:getOnSwipe
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnSwipe
	 * @description Retrieve a function to call when the <code>swipe</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnSwipe
	 * @event
	 */
	AbstractView.registerEventType('swipe');
	/**
	 * @name UI.AbstractView#setOnLongPress
	 * @description Set a function to call when a user taps and holds on a view. 
	 * @param {Function} clickCallback The new callback function. <br><br><b>Note:</b> The event is disabled 
	 * if the value of this parameter is not a function.
	 * @example function() { 
	 *	onLongPress.longpress = true; 
	 * };
	 * @see UI.AbstractView#event:getOnLongPress
	 * @event
	 */
	/**
	 * @name UI.AbstractView#getOnLongPress
	 * @description Retrieve a function to call when a <code>tap and hold</code> event occurs.
	 * @returns {Function} The current callback function.
	 * @see UI.AbstractView#event:setOnLongPress
	 * @event
	 */
	AbstractView.registerEventType('longPress');

	/** @private NOT IMPLEMENTED */
	/*
		AbstractView.registerEventType('touchdown');
		AbstractView.registerEventType('touchup');
		AbstractView.registerEventType('touchmove');
		AbstractView.registerEventType('touchcancel');
	*/
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/WindowLayer'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/WindowLayer'] = exports; var Element = require('NGCore/Client/UI/Element').Element;
var ViewParent = require('NGCore/Client/UI/ViewParent').ViewParent;
var Commands = require('NGCore/Client/UI/Commands').Commands;

/** @private
 * 	This ENTIRE CLASS is private.
 */
var WindowLayer = exports.WindowLayer = Element.subclass( {
	'type':'windowlayer',
	initialize: function($super, props) {
		if (WindowLayer.init) WindowLayer.init();
		$super(props);
		if (WindowLayer._init) WindowLayer._init();
		ViewParent.initialize.call(this);
		this._visible = true;
	},
	getRoot: function(){
		return this;
	},
	getParent: function(){
		return undefined;
	},
	
	getChildCount: ViewParent.getChildCount,
	getChildren: ViewParent.getChildren,
	addChild: ViewParent.addChild,
	removeChild: ViewParent.removeChild
});

WindowLayer.init = function() {
	delete WindowLayer._init;
	if (Element._init) Element._init();
	
	WindowLayer.synthesizeProperty('level', Commands.setIntValue);
};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/UI/ViewParent'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] || {}; $MODULE_REGISTRY['NGCore/Client/UI/ViewParent'] = exports; var Commands = require('NGCore/Client/UI/Commands').Commands;
var AbstractView = require('NGCore/Client/UI/AbstractView').AbstractView;

// CAREFUL! THIS IS NOT A CLASS!
exports.ViewParent = {
	initialize : function() {
		this._children = [];
	},

	getChildCount : function() {
		return this._children.length;
	},

	getChildren : function() {
		return this._children.slice();
	},

	addChild : function(childNode,index) {
		if (childNode === this) throw new Error("Cannot add " + childNode + " as a child of itself!");
		if (childNode instanceof AbstractView) {
			if (childNode._parent) childNode.removeFromParent();

			if (index === 0 || index > 0) {
				index = +index;
				this._children.splice(index, 0, childNode);
			} else {
				index = -1;
				this._children.push(childNode);
			}

			// Must populate parent before setting visibility
			childNode._parent = this;
			childNode._setVisible(this._visible);

			Commands.addSubview.call(this, childNode.__objectRegistryId, index);

		} else throw new Error(this.type + ".addChild: " + childNode + " is not a view!");
		return this;
	},

	removeChild : function(childNode) {
		if (childNode instanceof AbstractView) {
			if (childNode._parent == this) {
				childNode._setVisible(false);

				// Remove this node from parent's child list
				var nodeIndex = this._children.indexOf(childNode);
				if (nodeIndex != -1) {
					this._children.splice(nodeIndex, 1);
				}
			}
			// Clear parent value
			childNode._parent = undefined;

			// Remove from the parent at the system level
			Commands.removeFromSuperview.call(childNode);
		} else throw {message: this.type + ".removeChild: " + childNode + " is not a view!"};
		return childNode;
	}

};; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2'] = exports; /**
 * <p>Classes and objects contained by the GL2 module.</p>
 * @name GL2
 * @namespace
 * @description <p>The GL2 module is a collection of classes that support manipulation of visual effects and frameworks in an application.
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 * <ul>
 * <li><code>{@link GL2.Animation}</code>: Control animations in applications.</li>
 * <li><code>{@link GL2.Node}</code>: Control positionable screen elements.</li>
 * <li><code>{@link GL2.Primitive}</code>: Control the drawing of arbitrary vertex-based geometry.</li>
 * <li><code>{@link GL2.Root}</code>: A singleton that acts as a proxy object for the GLView node hierarchy 
 * (<code>Root</code> is the root element of the node hierarchy for GL2View).</li>
 * <li><code>{@link GL2.Sprite}</code>: Control resources for and use of application sprites.</li>
 * <li><code>{@link GL2.Text}</code>: Control resources for and use of application text.</li>
 * <li><code>{@link GL2.Touch}</code>: Control objects that track touch events for a device.</li>
 * <li><code>{@link GL2.TouchTarget}</code>: Control objects that support physical touch events on a device.</li>
 * </ul>
 * Games must instantiate a {@link UI.GLView} object, set the active state to <code>true</code> and wait for the callback before instantiating any objects in the GL2 class.
 */
exports.GL2 =
{
	Animation:    require('NGCore/Client/GL2/Animation').Animation,
	Node:         require('NGCore/Client/GL2/Node').Node,
	Primitive:    require('NGCore/Client/GL2/Primitive').Primitive,
	Touch:        require('NGCore/Client/GL2/Touch').Touch,
	TouchTarget:  require('NGCore/Client/GL2/TouchTarget').TouchTarget,
	Root:         require('NGCore/Client/GL2/Root').Root,
	Sprite:       require('NGCore/Client/GL2/Sprite').Sprite,
	Text:         require('NGCore/Client/GL2/Text').Text,
};
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Node'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Node'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Node'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Node = Core.Class.subclass(
/** @lends GL2.Node.prototype */
{
	classname: 'Node',
	
	/**
	 * @class The <code>Node</code> class constructs base class objects that contain positionable elements in the GL2 module. 
	 * Applications can use <code>Node</code> objects for grouping and organizing the scene graph. 
	 * <p>
	 * Inside the <code>{@link UI.GLView}</code> class, positionable elements are organized into a node hierarchy. This data
	 * structure is analgous to a scene graph or a node tree. Child nodes inherit data for
	 * transform, visibility, and depth from the parent on a conditional basis. Most drawable attributes for nodes, such as size and color, are specified in 
	 * derived classes. 
	 *</p><p>
	 * All derived GL2 classes from <code>Node</code> are native-backed proxies including <code>Node</code>.
	 * When a <code>Node</code> is instantiated on the Javascript side, a C++ object
	 * is instantiated and managed for the user on the native backend. This condition means the application
	 * must explicity destroy any <code>Node</code> that is no longer used.
	 *</p><p>
	 * A <code>Node</code> can exist independent of the scene, but it will only receive draw or touch updates
	 * when it is attached to the root tree.
	 *</p>
	 *<div class="ul">
	 * <li>Add a node as a child to the root of the scene with <code>{@link GL2.Root#addChild}</code>.</li> 
	 * <li>Add a node as a child to another node with <code>{@link GL2.Node#addChild}</code>.</li>
	 * <li>Remove a node from the root of the scene with <code>{@link GL2.Root#removeChild}.</code></li>
	 * <li>Remove a child node from a parent node with <code>{@link GL2.Node#removeChild}</code>.</li> 
	 *</div><br>
	 * <p>
	 * Call <code><a href="GL2.Node.html#destroy">destroy()</a></code> to automatically remove a node from the parent node.
	 * As previously noted, nodes are supported by a native object on the backend. Maintaining a 
	 * node reference outside of the scene instead of calling <code>destroy()</code> and recreating a new node is a recommended best practice.
	 *</p><p>
	 * Absolute positioning of a single node is determined by the following properties in the defined order:
	 *</p>
	 *<div class="ol">
	 * <li>Scale (two-component [x,y] multiple)</li>
	 * <li>Rotation (degrees about z-axis)</li>
	 * <li>Position (two-component translation)</li>
	 *</div><br>
	 * <p>
	 * Each of these properties is applied to the node relative to the parent node. The final transform
	 * for any given node is the concatenation of each transform in the node graph ancestry. The
	 * root ancestor is fixed to the view and composes the scene so that <code>(0,0)</code> is in the upper
	 * left corner. The first anchored
	 * offset to rotate and scale around is not specified because nodes do not inherently contain a size <code>(see {@link GL2.Animation.Frame#getAnchor}</code>). 
	 *</p><p>
	 * The <code>Depth</code> property of a <code>Node</code> object determines that <code>Node</code> sort order when traversing the scene graph.
	 * Depth is roughly equivalent to z-order or index. Each node is sorted among siblings by
	 * <code>Depth</code>, starting with the lowest depth node and sorting in ascending order.
	 *</p><p>
	 * By default, <code>Nodes</code> are grouped 
	 * with their siblings (not interleaved with cousins) and sorted relative to their parent 
	 * as if the parent depth value was <code>0</code>. However, you can modify this behavior for specific use cases 
	 * with <code><a href="GL2.Node.html#setChildrenDepthGrouped">setChildrenDepthGrouped()</a></code>. 
	 *</p><p>
	 * The node depth (order) in the scene graph will dictate the drawing order and determines what the final frame will look like.
	 * When drawing, <code>GL2.Node</code> utilizes the painter's algorithm.
	 * This means lower depth nodes are obscured by higher depth nodes.
	 * Touch priority occurs in reverse order to drawing order. Touches travel through the scene from higher depth to lower depth nodes 
	 * (front of scene earlier to back of scene later).
	 *</p><p>
	 * As a base class, a <code>Node</code> is not drawable but does maintain <code>Color</code> and <code>Alpha</code>
	 * attributes (see <code><a href="GL2.Node.html#getColor">getColor()</a></code> and <code><a href="GL2.Node.html#getAlpha">getAlpha()</a></code>). 
	 * Child nodes that contain drawable derived classes from 
	 * <code>Node</code> inherit these attributes.
	 * As a result, setting the <code>Color</code> for a parent node affects the color of every child node through multiplication
	 * of color components.</p>
	 * <p>Classes derived from Node include:</p>
	 * <div class="ul">
	 * <li>{@link GL2.Primitive}</li>
	 * <li>{@link GL2.Sprite}</li>
	 * <li>{@link GL2.Text}</li>
	 * </div>
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
        this._parent = null;
        this._position = new Core.Point();
        this._scale = new Core.Vector(1, 1);
        this._color = new Core.Color(1, 1, 1);
        this._alpha = 1;
        this._rotation = 0;
        this._depth = 0;
        this._visible = true;
        this._touchable = true;
		
        this._childrenDepthGrouped = true;
        this._children = [];
		
		this._createSendGen(this);
    },

	/**
	 * The default destructor. Calling <code>destroy()</code> removes the node from the parent, which releases the
	 * native object on the backend. 
	 * <br><br>
	 * <b>Note:</b> Applications must call this explicitly for nodes that are no longer
	 * used.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		children = this._children;
		while(children.length)
		{
			this.removeChild(children[0]);
		}
			
		if(this._parent)
		{
			this._parent.removeChild(this);
		}
		
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},

	/**
	 * Retrieve the position of this <code>Node</code>.
	 * @returns {Core.Vector} The current node position relative to the parent.
	 * @see GL2.Node#setPosition
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the <i>width</i> and <i>height</i> scale multiple of this <code>Node</code>. 
	 * The default scale <code>[1,1]</code> will not modify the resulting transform.
	 * @returns {Core.Vector} The current scale multiple (<i>width</i> and <i>height</i>).
	 * @see GL2.Node#setScale
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getScale: function()
	{
		return this._scale;
	},

	/**
	 * Retrieve the <code>Color</code> component of this <code>Node</code>. Values for <code>Color</code> are based on the RGB color model. 
	 * When drawing, the values for <code>Color</code> are multiplied by the value of each drawable pixel. Child nodes will multiply
	 * the values for <code>Color</code> by the parent composite color before drawing. 
	 * @returns {Core.Color} The current value of all three color components (red, green, blue).
	 *<br><br>
	 * <b>Note:</b> The default RGB triplet <code>[1,1,1]</code> does not produce a color change.
	 * @see Core.Color, 
	 * @see GL2.Node#setColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getColor: function()
	{
		return this._color;
	},

	/**
	 * Retrieve the <cod>alpha</code> components of this <code>Node</code>.
	 * @returns {Number} The new alpha blending state across the open interval ranging between <code>(0-1)</code>. 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @see GL2.Node#setAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAlpha: function()
	{
		return this._alpha;
	},

	/**
	 * Retrieve the <code>rotation</code> component for this <code>Node</code>.
	 * The default value is 0 degrees about the z-axis.
	 * @returns {Number} The current degree of rotation. Expressed as a float.
	 * @see GL2.Node#setRotation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getRotation: function()
	{
		return this._rotation;
	},

	/**
	 * Retrieve the <code>depth</code> component for this <code>Node</code>.
	 * The default value is <code>0</code>.
	 * Applications will sort nodes with identical depth values by the last 
	 * time the node was attached to the root node graph.
	 * @returns {Number} The current node depth level (z-order). Expressed as a float.
	 * @see GL2.Root and 
	 * @see GL2.Node#setDepth
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getDepth: function()
	{
		return this._depth;
	},

	/**
	 * Retrieve the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if the node is visible. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVisible: function()
	{
		return this._visible;
	},

	/**
	 * Retrieve the <code>touchable</code> component for this <code>Node</code>.
	 * This component defines touch-support for a node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit "not touchable" from parent nodes in the scene graph.
	 * @returns {Boolean} Returns <code>true</code> if a node is touchable. Returns <code>false</code> in all other cases.
	 * @see GL2.Node#setTouchable
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchable: function()
	{
		return this._touchable;
	},
	

	/**
	 * Retrieve <code>childrenDepthGrouped</code> component of this <code>Node</code>.
	 * The default value is <code>true</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, child nodes sort amongst (interleave 
	 * with) the children of the nearest depthgrouped ancestor.
	 * @returns {Boolean} Returns as <code>true</code> if sorting with ancestor siblings. Returns as <code>false</code> if sorting only with siblings in the graph.
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getChildrenDepthGrouped: function()
	{
		return this._childrenDepthGrouped;
	},
	
	/**
	 * Retrieve the parent node for this <code>Node</code>.
	 * @returns {GL2.Node} The current parent node.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getParent: function()
	{
		return this._parent;
	},

	/**
	 * Retrieve a copy of the child array for this <code>Node</code>.
	 * @returns {Array GL2.Node} The current list of child nodes.
	 * @status 
	 */
	getChildren: function()
	{
		return this._children.slice();
	},
	
    /**
	 * Set the <code>translation</code> component of the transform for this <code>Node</code>.
	 * You can define the parameter value as a vector or two floats.<br><br>
	 * <b>Note:</b> An application can use this property to translate a group of nodes by
	 * translating the parent. Child nodes inherit this property from the parent node.<br/><br/>
	 * The following code examples illustrate different call styles for <code>setPosition()</code>.<br><br>
	 * 
	 * @example
	 * node.setPosition(new Core.Vector(50, 100));
	 *
	 * @example
	 * node.setPosition(50, 100);
	 * 
	 * @param {Core.Vector} position The new node position relative to the parent.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getPosition,
	 * @see Core.Vector
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setPosition: function(position)
	{
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(
		{
			x: p.getX(),
			y: p.getY(),
		});
		return this;
	},
	
    /**
	 * Set the <i>x</i> and <i>y</i> scale of the transform for this <code>Node</code>.<br><br>
	 * <b>Note:</b> This property affects the coordinate system of child nodes and scales drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setScale()</code>.<br><br>
	 * 
	 * @example
	 * node.setScale(new Core.Vector(2, 0.5));
	 *
	 * @example
	 * node.setScale(2, 0.5);
	 * 
	 * @param {Core.Vector} scale The new scale multiple (<i>width</i> and <i>height</i>). You can define the parameter value as a vector or two floats.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getScale, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setScale: function(scale)
	{
		var s = this._scale;
		s.setAll.apply(s, arguments);
		this._setScaleSendGen(
		{
			x: s.getX(),
			y: s.getY(),
		});
		return this;
	},
	/**
	 * Set the color for the specified entity. Call this method either by reference to a single vector object  
	 * or by defining three float parameters.
	 * Every color pixel value for the entity is multiplied by the value of the parameter before drawing.
	 * <br><br>
	 * <b>Example:</b> If you specify an entity to draw an orange pixel <code>(1.0, 0.5, 0)</code>,
	 * but the entity color is purple <code>(0.5, 0, 1.0)</code>, the resulting pixel color is
	 * <code>(0.5, 0, 0)</code>, which is dark red. The application conducts this efficiently for each pixel in the
	 * entity.<br><br>
	 * The following code examples illustrate different call styles for <code>setColor()</code>.<br><br>
	 * 
	 * @example
	 * node.setColor(new Core.Color(1.0, 0.5, 0));
	 *
	 * @example
	 * node.setColor(1.0, 0.5, 0);
	 * 
	 * @param {Core.Color} color Pixel color value to muliply by the entity color value.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Core.Color, 
	 * @see GL2.Node#getColor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setColor: function(color)
	{
		var c = this._color;
		c.setAll.apply(c, arguments);
		this._setColorSendGen(
		{
			red: c.getRed(),
			green: c.getGreen(),
			blue: c.getBlue(),
		});
		return this;
	},
    /**
	 * Set the alpha blending state for the entity.
	 * Each pixel of the entity blends with the underlying surface. This occurs in proportion to the alpha blending state of the entity.
	 * The application must set the parameter value within the open interval <code>[0, 1]</code>.
	 * <br><br>
	 * <b>Example:</b> Drawing a red entity with an alpha of <code>0.5</code> over a white background results in a light pink entity. 
	 * Drawing an orange pixel <code>(1.0, 0.5, 0)</code> with an alpha of <code>0.66</code> over
	 * a light blue surface <code>(0.0, 1.0, 1.0)</code>, results in a light brown pixel:
	 * @example (1.0, 0.5, 0) * 0.66 + (0.0, 1.0, 1.0) * 0.34 = (0.6, 0.67, 0.34)
	 * @param {Number} alpha The new alpha blending state for the entity ranging between <code>(0-1)</code> 
	 * (0 = completely transparent, 1 = completely opaque). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getAlpha
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAlpha: function(alpha)
	{
		this._alpha = alpha;
		this._setAlphaSendGen(
		{
			alpha: alpha,
		});
		return this;
	},
	
    /**
	 * Set the transform rotation (in degrees) for this <code>Node</code>.<br><br> 	 
	 * <b>Note:</b> This property affects the coordinate system of child nodes and rotates drawing for
	 * derived classes like <code>Sprite</code>, <code>Text</code>, and <code>Primitive</code>.
	 * <br><br>
	 * The following code examples illustrate different call styles for <code>setRotation()</code>.<br><br>
	 * 
	 * Rotate entity 90 degrees.
	 * <pre class="code">node.setRotation(90);</pre> 
	 * Restore entity to original orientation.
	 * <pre class="code">node.setRotation(0);</pre>
	 * Convert radians to degrees.
	 * <pre class="code">var radians = 0.785;
	 * var degrees = radians * Math.PI / 180;</pre>
	 * Convert degrees to radians.
	 * <pre class="code">var degrees = 90;
	 * var radians = degrees * 180 / Math.PI;</pre>
	 *
	 * @param {Number} rotation The new rotation of the entity relative to the parent (in degrees). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getRotation, 
	 * @see GL2.Primitive, 
	 * @see GL2.Sprite, 
	 * @see GL2.Text
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setRotation: function(rotation)
	{
		this._rotation = rotation;
		this._setRotationSendGen(
		{
			rotation: rotation,
		});
		return this;
	},
	
    /**
	 * Set the <code>depth</code> component for this <code>Node</code>.
	 * This property affects how a node is sorted when the scene is traversed. Different depth-levels affect
	 * both drawing order (back to front, low to high) and touch priority (front to back,
	 * high to low).<br><br>
	 * <b>Note:</b> Use <code>{@link GL2.Node#setChildrenDepthGrouped}</code> to set how a node will sort with siblings.
	 * @example node.setDepth(20);
	 * @param {Number} depth The new depth for the entity (z-order). Expressed as a float.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped, 
	 * @see GL2.Node#setChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setDepth: function(depth)
	{
		this._depth = depth;
		this._setDepthSendGen(
		{
			depth: depth,
		});
		return this;
	},
	
    /**
	 * Set the <code>visible</code> component for this <code>Node</code>.
	 * This component defines visibility of the node.
	 * The default value is <code>true</code>.<br><br>
	 * <b>Note:</b> A node can inherit the value of this component from parent nodes in the scene graph.
	 * @example node.setVisible(true);
	 * @param {Boolean} [visible=true] Set as <code>true</code> if a node is visible.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getVisible
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setVisible: function(visible)
	{
		this._visible = visible;
		this._setVisibleSendGen(
		{
			visible: visible,
		});
		return this;
	},
	
    /**
	 * Set the <code>touchable</code> component for this <code>Node</code>.
	 * This component defines a node as "touchable".<br><br>
	 * <b>Note:</b> A node can inherit "not touchable" from parent nodes in the scene graph.
	 * @example node.setTouchable(true);
	 * @param {boolean} [touchable=true] Set as <code>true</code> if this node is touchable.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getTouchahble
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setTouchable: function(touchable)
	{
		this._touchable = touchable;
		this._setTouchableSendGen(
		{
			touchable: touchable,
		});
		return this;
	},
    
	/**
	 * Set whether to sort child nodes adjacent to this <code>Node</code>.
	 * When <code>childrenDepthGrouped</code> is <code>false</code>, the child nodes interleave 
	 * with the children of the nearest similarly grouped ancestor. Applications can use this to sort a distant node
	 * on an independent branch of the graph in close proximity.<br/><br/>
	 * <b>Example:</b> You have multiple group nodes containing a character sprite and a 
	 * shadow sprite. By setting all the shadow sprites to a <code>depth</code> of <code>1</code>, all character sprites to
	 * a <code>depth</code> of <code>2</code>, and setting <code>childrenDepthGrouped</code> to <code>false</code> for each group node, all character sprites will 
	 * sort above shadows when drawn.<br><br>
     * Look at the following structure of nodes.
     * If <code>childrenDepthGrouped</code> is <code>true</code> for the group, the primitive will
     * draw above both the sprite and the text. However, if <code>false</code>,
     * the primitive will draw after the sprite but before the text.
     * <pre class="code">
     * Root
     * +-- Group (depth = 0)
     * |   +-- Sprite (depth = 10)
     * |   +-- Text (depth = -10)
     * |
     * +-- Primitive (depth = 5)
     * </pre>
	 * @param {Boolean} childrenDepthGrouped Set as <code>true</code> to sort with ancestor siblings. Set as <code>false</code> to sort only with siblings in the graph.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#getChildrenDepthGrouped
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setChildrenDepthGrouped: function(childrenDepthGrouped)
	{
		this._childrenDepthGrouped = childrenDepthGrouped;
		
		this._setChildrenDepthGroupedSendGen(
		{
			childrenDepthGrouped: childrenDepthGrouped,
		});
		
		return this;
	},
	
	/**
	 * Add a node as a child to this <code>Node</code>.
	 * @example node.addChild(this.mySprite);
	 * @param {GL2.Node} child The child node to add.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		// Add to children list.
		this._children.push(child);
		
		// Tell child.
		child._didAddToParent(this);
		
		this._addChildSendGen(
		{
			child: Core.ObjectRegistry.objectToId(child),
		});
		
		return this;
	},
	
	/**
	 * Remove a specified child node and its subtree from this <code>Node</code>.
	 * @example node.removeChild(this.mySprite);
	 * @param {String} child The child node to remove from the current entity.
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		// Tell child.
		child._willRemoveFromParent();
		
		// Remove from children list.
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(
		{
			child: Core.ObjectRegistry.objectToId(child),
		});
		
		return this;
	},
	
	/**
	 * Convert the relative location of a scene to the local coordinate space for this <code>Node</code>.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The relative location for a scene.
	 * @see GL2.Node#localToScreen
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		var parent = this._parent;
		if(!parent)
			return undefined;
			
		location = parent.screenToLocal(location);
		if(!location)
			return undefined;
		
		var x = location.getX();
		var y = location.getY();
		
		// Undo translation.
		var p = this._position;
		x -= p.getX();
		y -= p.getY();
		
		// Undo rotation.
		var r = this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undoe scale.
		var s = this._scale;
		x /= s.getX();
		y /= s.getY();
		
		return new Core.Point(x, y);
	},
	
	/**
	 * Convert a location within the local coordinate space for this <code>Node</code> to a location within the screen coordinate
	 * space.
	 * @param {Core.Vector} location A location in the local transform for this <code>Node</code>.
	 * @see GL2.Node#screenToLocal
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		var x = location.getX();
		var y = location.getY();
		
		// Undoe scale.
		var s = this._scale;
		x *= s.getX();
		y *= s.getY();
		
		// Undoe rotation.
		var r = -this._rotation * Math.PI / 180;
		var cosr = Math.cos(r);
		var sinr = Math.sin(r);
		var tx = cosr*x + sinr*y;
		var ty = -sinr*x + cosr*y;
		x = tx;
		y = ty;
		
		// Undoe translation.
		var p = this._position;
		x += p.getX();
		y += p.getY();
		
		var parent = this._parent;
		if(!parent)
			return undefined;
		
		location = parent.localToScreen(new Core.Point(x, y));
		if(!location)
			return undefined;
		return location;
	},
	
	_didAddToParent: function(parent)
	{
		if(this._parent)
			this._parent.removeChild(this);
		
		this._parent = parent;
	},
	
	_willRemoveFromParent: function()
	{
		this._parent = null;
	},
	
	_synchronizeNodeRecv: function( cmd )
	{
		var msg = {};
		if(!this._synchronizeNodeRecvGen(cmd, msg))
			return;
		this._position.setAll(msg.x, msg.y);
		this._rotation = msg.rotation;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 307
	// Method create = -1
	// Method destroy = 2
	// Method setPosition = 3
	// Method setScale = 4
	// Method setColor = 5
	// Method setAlpha = 6
	// Method setRotation = 7
	// Method setDepth = 8
	// Method setVisible = 9
	// Method setTouchable = 10
	// Method setChildrenDepthGrouped = 11
	// Method addChild = 12
	// Method removeChild = 13
	// Method synchronizeNode = 14
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 14:
					instance._synchronizeNodeRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Node._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[307] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_synchronizeNodeRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 3 )
		{
			NgLogE("Could not parse due to wrong argument count in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 0 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 1 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		obj[ "rotation" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "rotation" ] === undefined )
		{
			NgLogE("Could not parse rotation in Node.synchronizeNode from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPositionSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "x" ] + "," + obj[ "y" ]  );
	},
	
	/** @private */
	_setScaleSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 4 + "," + this.__objectRegistryId + "," + obj[ "x" ] + "," + obj[ "y" ]  );
	},
	
	/** @private */
	_setColorSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 5 + "," + this.__objectRegistryId + "," + obj[ "red" ] + "," + obj[ "green" ] + "," + obj[ "blue" ]  );
	},
	
	/** @private */
	_setAlphaSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 6 + "," + this.__objectRegistryId + "," + obj[ "alpha" ]  );
	},
	
	/** @private */
	_setRotationSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 7 + "," + this.__objectRegistryId + "," + obj[ "rotation" ]  );
	},
	
	/** @private */
	_setDepthSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 8 + "," + this.__objectRegistryId + "," + obj[ "depth" ]  );
	},
	
	/** @private */
	_setVisibleSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 9 + "," + this.__objectRegistryId + "," + ( obj[ "visible" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_setTouchableSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 10 + "," + this.__objectRegistryId + "," + ( obj[ "touchable" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_setChildrenDepthGroupedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 11 + "," + this.__objectRegistryId + "," + ( obj[ "childrenDepthGrouped" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_addChildSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 12 + "," + this.__objectRegistryId + "," + obj[ "child" ]  );
	},
	
	/** @private */
	_removeChildSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 307 + "," + 13 + "," + this.__objectRegistryId + "," + obj[ "child" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPosition: function( x, y ) {}
	
	// setScale: function( x, y ) {}
	
	// setColor: function( red, green, blue ) {}
	
	// setAlpha: function( alpha ) {}
	
	// setRotation: function( rotation ) {}
	
	// setDepth: function( depth ) {}
	
	// setVisible: function( visible ) {}
	
	// setTouchable: function( touchable ) {}
	
	// setChildrenDepthGrouped: function( childrenDepthGrouped ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _synchronizeNodeRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Tilemap/Tilemap'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Tilemap/Tilemap'] || {}; $MODULE_REGISTRY['Code/G6/Tilemap/Tilemap'] = exports; var Tile = require('Code/G6/Tilemap/Tile').Tile;
var TileNode = require('Code/G6/Tilemap/TileNode').TileNode;
var Util = require('Code/G6/Util/Util').Util;
var TilemapPathfinder = require('Code/G6/Tilemap/TilemapPathfinder').TilemapPathfinder;
/**
 * @class Tilemap provides functionality for creating tiled maps
 * @constructor The default constructor.
 * @name Core.Class
 */
exports.Tilemap = Node.subclass({
    initialize: function(type, mapSize, tileSize){
    
        this._type = type;
        this._mapSize = mapSize;
        this._tileSize = tileSize;
        this._tileTouchable = [];
        this._tileMap = [];
        this.calculateTouchTileMap();
        this._floor = new GL2.Node();
        this._floor.setDepth(-1);
        this._pathFinder = new TilemapPathfinder(this);
        this._setPoint = new Core.Point(0.5, 1);
        
        //fill it out with tiles;
        for (var x = 0; x < mapSize.getWidth(); x++) {
            for (var y = 0; y < mapSize.getHeight(); y++) {
                var tile = new Tile(null, false);
                var tileID = this.getTileID(new Core.Point(x, y));
                
                this._tileMap[tileID] = tile;
                
            }
        }
        
        //this seems like.... its off. it should be true but for some reason false works.
        this.setChildrenDepthGrouped(false);
        this.addChild(this._floor);
        
        
    },
    
    Type: {
        /** Isometric. */
        Isometric: 0
    },
    
    
    setTile: function(tileID, tilePosition, touchable){
    
        if (typeof touchable == 'undefined') 
            touchable = false;
        
        //stub
        var tile = this.getTile(tilePosition)
        tileNode = new TileNode(new Core.Rect(tilePosition.getX(), tilePosition.getY(), 1, 1), -1);
        tileNode.setImage('Content/30016_o.png', [80, 40]);
        //tileID and z are the same thing actually..
        var tileID = this.getTileID(tilePosition);
        var pos = this.positionForTilePosition(tilePosition);
        tileNode.setDepth(tileID);
        //		tileNode.setDepth(100);		
        tileNode.setPosition(pos);
        this._floor.addChild(tileNode);
        
        if (!tile) {
            tile = new Tile(tileNode, touchable);
            this._tileMap[tileID] = tile;
        }
        else {
            tile.setTileNode(tileNode);
            tile.setTouchable(touchable);
        }
        
    },
    
    setObjectAtTilePosition: function(obj){
    
        if (!obj) 
            return false;
        
        var tilePosition = obj.getRect().getOrigin();
        var objSize = obj.getRect().getSize();
        var layer = obj.getLayer();
        
        
        //need to get the rest of the tiles as well...
        for (var x = tilePosition.getX(); x < tilePosition.getX() + objSize.getWidth(); x++) {
            for (var y = tilePosition.getY(); y < tilePosition.getY() + objSize.getHeight(); y++) {
                var tile = this.getTile(new Core.Point(x, y));
                NgLogD('checking....' + this.pointToString(new Core.Point(x, y)));
                if (tile.hasObject(layer)) {
					alert ('damnn');
                    return false;
                }
                
            }
        }
        
        //set the image and the anchor point
        //		var tmp = new GL2.Sprite();
        //		tmp.setImage('Content/kakashi.png',[60,80], [0.5,1]);
        var mountPos = this.positionForTilePositionsObjectSetPoint(tilePosition, objSize);
        obj.setPosition(mountPos);
		
		
//		this.execOnAllTilesForObject ( this, obj, function( tilemap ) {
//				//removes the object
//                var tile = tilemap.getTile(new Core.Point(x, y));
//                tile.putObject(obj);
//		});		
        
        for (var x = tilePosition.getX(); x < tilePosition.getX() + objSize.getWidth(); x++) {
            for (var y = tilePosition.getY(); y < tilePosition.getY() + objSize.getHeight(); y++) {
                var tile = this.getTile(new Core.Point(x, y));
                tile.putObject(obj);
                
            }
        }
        
        
        //check sizes constraint
        obj.setDepth(this.getTileID(tilePosition));
        this.addChild(obj);
        
        return true;
        
    },
    
    removeObject: function(tilePosition, layer){
    
        var tile = this.getTile(tilePosition);
        
        if (!tile) 
            return;
        
        var obj = tile.getObject(layer);
        
        if (!obj) 
            return;
        
        var objSize = obj.getRect().getSize();
        
        tile.removeObject(layer);
        
        //get
        for (var x = tilePosition.getX(); x < tilePosition.getX() + objSize.getWidth(); x++) {
            for (var y = tilePosition.getY(); y < tilePosition.getY() + objSize.getHeight(); y++) {
                var tile = this.getTile ( new Core.Point(x, y) );
				tile.removeObject(layer, obj);
            }
        }

//		this.execOnAllTilesForObject ( this, obj, function( tilemap ) {
//				//removes the object
//	            var tile = tilemap.getTile (tilePosition);
//				tile.removeObject(layer, obj);
//		});

        
        this.cleanupTileNode(obj);
        
    },
	
	//anonymous functions
	execOnAllTilesForObject: function ( tilemap, obj, func ) {
		
		if (!obj) return;
		
        var tilePosition = obj.getRect().getOrigin();
        var objSize = obj.getRect().getSize();		
		
        for (var x = tilePosition.getX(); x < tilePosition.getX() + objSize.getWidth() - 1; x++) {
            for (var y = tilePosition.getY(); y < tilePosition.getY() + objSize.getHeight() - 1; y++) {
                func(tilemap);
            }
        }		
	},
	
    findPath: function(startPosition, endPosition, inclusive){
        return this._pathFinder.findPath(startPosition, endPosition, inclusive);
    },
    
    getTile: function(tilePosition){
        var t = this.getTileID(tilePosition);
        return this._tileMap[t];
    },
    
    getTileID: function(tilePosition){
        var t = tilePosition.getX() + tilePosition.getY() * this._mapSize.getWidth();
        return t;
    },
    
    getTouchedTile: function(touch){
        var tilePosition = this.getTouchedTilePosition();
        return this._tileMap[tilePosition];
    },
    //returns null if no tile was touched
    getTouchedTilePosition: function(touch){
        //this works for isometric may need to override for others or add conditions
        var local = this.screenToLocal(touch.getPosition());
        
        
        //figure out what grid it is in
        var grid = this.getGridPoint(new Core.Point(local.getX(), local.getY()));
        
        NgLogD("Touched Grid " + grid.getX() + ":" + grid.getY());
        var allTouchedTiles = this._touchTileMap[this.pointToString(grid)];
        
        if (allTouchedTiles) {
            if (allTouchedTiles.length == 0) {
                NgLogD('allTouchedTiles is 0');
                return null;
            }
            if (allTouchedTiles.length == 1) {
                NgLogD('length = 1');
                var tile = allTouchedTiles[0];
                
                return new Core.Point(tile.getX(), tile.getY());
            }
            
            //figure out the best one.
            var best = -1;
            var index = 0;
            
            for (t in allTouchedTiles) {
                var tile = allTouchedTiles[t];
                if (best == -1) {
                    best = 0;
                    index++;
                    continue;
                }
                
                //position should already be in center
                var bestTilePosition = this.positionForTilePosition(allTouchedTiles[best]);
                var contendingTilePosition = this.positionForTilePosition(allTouchedTiles[index]);
                
                var distanceFromBestTile = Math.abs(Util.distanceBetweenTwoPoints(local, bestTilePosition));
                var distanceFromContendingTile = Math.abs(Util.distanceBetweenTwoPoints(local, contendingTilePosition));
                
                
                if (distanceFromContendingTile < distanceFromBestTile) {
                    best = index;
                }
                
                index++;
                
            }
            
            return allTouchedTiles[best];
            
        }
        else {
            NgLogD('allTouchedTiles is null');
            return null;
        }
        
        
    },
    
    
    
    
    calculateTouchTileMap: function(){
        this._touchTileMap = [];
        //anchor points are in the middle.
        
        for (var x = 0; x < this._mapSize.getWidth(); x++) {
            for (var y = 0; y < this._mapSize.getHeight(); y++) {
                var pos = this.upperLeftPositionForTilePosition(new Core.Point(x, y));
                //we'll get top left of this origin position
                var grid1 = this.getGridPoint(pos);
                var grid2 = new Core.Point(grid1.getX(), grid1.getY() + 1);
                var grid3 = new Core.Point(grid1.getX() + 1, grid1.getY());
                var grid4 = new Core.Point(grid1.getX() + 1, grid1.getY() + 1);
                
                
                this.addToTouchTileMap(grid1, new Core.Point(x, y));
                //NgLogD(" grid for tile = " + x + ":" + y + "   grid1 = " + grid1.getX() + " : " + grid1.getY());				
                this.addToTouchTileMap(grid2, new Core.Point(x, y));
                //NgLogD(" grid for tile = " + x + ":" + y + "   grid2 = " + grid2.getX() + " : " + grid2.getY());		
                this.addToTouchTileMap(grid3, new Core.Point(x, y));
                //NgLogD(" grid for tile = " + x + ":" + y + "   grid3 = " + grid3.getX() + " : " + grid3.getY());				
                this.addToTouchTileMap(grid4, new Core.Point(x, y));
                //NgLogD(" grid for tile = " + x + ":" + y + "   grid4 = " + grid4.getX() + " : " + grid4.getY());															
            }
        }
        
    },
    
    getGridPoint: function(point){
        //origin is 0,0
        var originPosition = this.upperLeftPositionForTilePosition(new Core.Point(0, 0));
        
        //we'll get top left of this origin position
        
        
        var pointRelativeToOrigin = new Core.Point(point.getX() - originPosition.getX(), point.getY() - originPosition.getY());
        NgLogD('getting grid point for tile position ' + this.pointToString(point) + " pointRelativeToOrigin: " + this.pointToString(pointRelativeToOrigin));
        var xGrid = 0;
        var yGrid = 0;
        
        if (pointRelativeToOrigin.getY() == 0) {
            yGrid = 0;
        }
        else 
            if (pointRelativeToOrigin.getY() > 0) {
                yGrid = Util.floatToInt(Util.floatToInt(pointRelativeToOrigin.getY()) / Util.floatToInt((this._tileSize.getHeight() * this.getScale().getY()) / 2));
            }
            else 
                if (pointRelativeToOrigin.getY() < 0) {
                    yGrid = Util.floatToInt(Util.floatToInt(pointRelativeToOrigin.getY()) / Util.floatToInt((this._tileSize.getHeight() * this.getScale().getY()) / 2));
                    if (pointRelativeToOrigin.getY() % ((this._tileSize.getHeight() * this.getScale().getY()) / 2) != 0) {
                        yGrid--;
                    }
                }
        
        if (pointRelativeToOrigin.getX() == 0) {
            xGrid = 0;
        }
        else 
            if (pointRelativeToOrigin.getX() > 0) {
                xGrid = Util.floatToInt(Util.floatToInt(pointRelativeToOrigin.getX()) / Util.floatToInt((this._tileSize.getWidth() * this.getScale().getX()) / 2));
            }
            else 
                if (pointRelativeToOrigin.getX() < 0) {
                    NgLogD(pointRelativeToOrigin.getX() + " / " + Util.floatToInt((this._tileSize.getWidth() * this.getScale().getX()) / 2));
                    NgLogD(Util.floatToInt(Util.floatToInt(pointRelativeToOrigin.getX()) / Util.floatToInt((this._tileSize.getWidth() * this.getScale().getX()) / 2)));
                    xGrid = Util.floatToInt(Util.floatToInt(pointRelativeToOrigin.getX()) / Util.floatToInt((this._tileSize.getWidth() * this.getScale().getX()) / 2));
                    if (pointRelativeToOrigin.getX() % ((this._tileSize.getWidth() * this.getScale().getX()) / 2) != 0) {
                        xGrid--;
                    }
                }
        
        
        
        return new Core.Point(Util.floatToInt(xGrid), Util.floatToInt(yGrid));
    },
    
    positionForTilePosition: function(tilePosition){
        var x = Util.floatToInt(this._tileSize.getWidth() / 2 * (this._mapSize.getWidth() + tilePosition.getX() - tilePosition.getY()));
        var y = Util.floatToInt(this._tileSize.getHeight() / 2 * (tilePosition.getX() + tilePosition.getY() + 1));
        return new Core.Point(x, y);
    },
    
    addToTouchTileMap: function(point, tilePosition){
        if (!this._touchTileMap) 
            return;
        var candidates = this._touchTileMap[this.pointToString(point)];
        
        if (!candidates) {
            candidates = new Array();
            this._touchTileMap[this.pointToString(point)] = candidates;
        }
        
        //check all candidates to see if theres equal
        
        var exists = false;
        for (var i in candidates) {
            var candidate = candidates[i];
            if (candidate.getX() == point.getX() && candidate.getY() == point.getY()) {
                exists = true;
            }
        }
        
        if (!exists) {
            NgLogD('adding tile position ' + this.pointToString(tilePosition) + " to grid:" + this.pointToString(point));
            candidates.push(new Core.Point(tilePosition.getX(), tilePosition.getY()));
            
        }
        
        
    },
    
    pointToString: function(point){
        return point.getX() + ':' + point.getY();
    },
    
    upperLeftPositionForTilePosition: function(tilePosition){
        //		pos = this.positionForTilePosition (tilePosition);
        //		return new Core.Point (Util.floatToInt (pos.getX() - this._tileSize.getWidth() / 2), Util.floatToInt (pos.getY() - this._tileSize.getHeight() / 2));
        return this.anchorPositionForTilePosition(tilePosition, new Core.Point(0, 0));
    },
    anchorPositionForTilePosition: function(tilePosition, point){
        pos = this.positionForTilePosition(tilePosition);
        //position returns 0.5,0.5 anchor point so we take the difference
        var diff = Util.pointSub(point, new Core.Point(0.5, 0.5));
        
        
        
        var position = new Core.Point(Util.floatToInt(pos.getX() + (this._tileSize.getWidth() * diff.getX())), Util.floatToInt(pos.getY() + (this._tileSize.getHeight() * diff.getY())));
        
        NgLogD("***** anchorpoint " + this.pointToString(point));
        NgLogD('orig pos = ' + this.pointToString(pos));
        NgLogD('anchor pos = ' + this.pointToString(position));
        
        return position;
    },
    
    //default: set point is 0.5,1, set point is like anchorpoint for where we place the object.
    positionForTilePositionsObjectSetPoint: function(tilePosition, size){
    
    
        //specific for isometric.
        if (typeof size == 'undefined') 
            size = new Core.Size(1, 1);
        
        var width = size.getWidth();
        var height = size.getHeight();
        
        //need to figure out the rect for the entire object, we figure it out by take the other most tile 
        //defined by position + size ... and then take the x coordinate of that tile and averaging the origin tile and the outter tile to get the X
        //as for the Y we just take the bottom of the outer rect
        pos = this.positionForTilePosition(tilePosition);
        bottomPos = this.anchorPositionForTilePosition(new Core.Point(tilePosition.getX() + size.getWidth() - 1, tilePosition.getY() + size.getHeight() - 1), new Core.Point(0.5, 1));

        
        
        var xPos = Util.floatToInt((pos.getX() + bottomPos.getX()) / 2);
        //		var yPos = pos.getY() + Util.floatToInt (this._tileSize.getHeight()/2) + Util.floatToInt (height * this._tileSize.getHeight() * this._setPoint.getY());
        var yPos = bottomPos.getY();
        
        return new Core.Point(xPos, yPos);
    },
    
    isSpaceBlocked: function(tilePosition){
        var tile = this.getTile(tilePosition);
        
        if (!tile) {
            return false;
        }
        
        return tile.blocked();
    },
    
    cleanupTileNode: function(tileNode){
        if (tileNode) {
            if (tileNode.getParent()) {
                tileNode.destroy();
            }
        }
    }
    
    
    
    
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Tilemap/TileNode'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Tilemap/TileNode'] || {}; $MODULE_REGISTRY['Code/G6/Tilemap/TileNode'] = exports; /**
 * @author will
 */
exports.TileNode = GL2.Sprite.subclass(
{
	
	classname: 'TileNode',
	
	initialize: function( rect , layer )
	{
		this._rect = rect;
		
		if (typeof layer == 'undefined' ) layer = 0;		
		this._layer = layer;
	},
	
	getRect: function() 
	{
		return this._rect;
	},
	
	getLayer: function() 
	{
		return this._layer;
	}	
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Sidescroll/SidescrollMap'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Sidescroll/SidescrollMap'] || {}; $MODULE_REGISTRY['Code/G6/Sidescroll/SidescrollMap'] = exports; var Util = require('Code/G6/Util/Util').Util;
/**
 * @author will
 */
exports.SidescrollMap = Node.subclass({

    classname: 'SidescrollMap',
    
    initialize: function(background, mapSize){
    
        this._background = background;
        
        this._mapSize = mapSize;
        //this seems like.... its off. it should be true but for some reason false works.
        //        this.setChildrenDepthGrouped(false);
        
        if (background) {
            background.setDepth(-1);
            this.addChild(background);
        }
        
        this._scrollTouchHandler = new this.ScrollTouchHandler(this, true);
        
        this._touchTarget = new GL2.TouchTarget();
        this._touchTarget.setSize(this._mapSize);
        this._touchTarget.getTouchEmitter().addListener(this._scrollTouchHandler, this._scrollTouchHandler.onTouch);
        
        this.addChild(this._touchTarget);
        this._objectMap = [];
        
        
    },
    
    getTouchTarget: function(){
        return this._touchTarget;
    },
    
    getObject: function(identity){
        return this._objectMap[identity];
    },
    
    addObject: function(identity, img){
    
        this._objectMap[identity] = img;
        this.addChild(img);
    },
    
    objectForTouch: function(touch){
    
    
        for (var i in this._objectMap) {
            var obj = this._objectMap[i];
            
            if (!obj) 
                continue;
            
            var local = obj.screenToLocal(touch.getPosition());
            
            //figures out the top left origin, since 0,0 is where the anchorpoint is, we normalize it to the top left origin.
            var topLeftOrigin = Util.getPositionForAnchorPointGivenValues(new Core.Point(0, 0), obj.getSize(), obj.getAnchor(), new Core.Point(0, 0));
            var itemRect = new Core.Rect(topLeftOrigin.getX(), topLeftOrigin.getY(), obj.getSize().getWidth(), obj.getSize().getHeight());
            
            NgLogD("" + Util.pointToString(local));
            
            //then check to see if the point is within that space.
            if (Util.rectContainsPoint(itemRect, local)) {
                return obj;
            }
            
        }
        
        return null;
    },
    
    canAddObjectWithoutOverlap: function(img){
        for (var i in this._objectMap) {
            var child = this._objectMap[i];
            if (child == null) {
                continue;
            }
            
            
            if (child.getDepth() == img.getDepth()) {
                //check if overlap
                if (this.overlap(img, child)) {
                    return false;
                }
                
            }
        }
        
        return true;
    },
    
    getMapSize: function(){
        return this._mapSize;
    },
    
    overlap: function(img1, img2){
        var rect1 = new Object();
        var rect1pos1 = Util.getPositionForAnchorPoint(img1, new Core.Point(0, 0));
        var rect1pos2 = Util.getPositionForAnchorPoint(img1, new Core.Point(1, 1));
        rect1.x1 = rect1pos1.getX();
        rect1.x2 = rect1pos2.getX();
        rect1.y1 = rect1pos1.getY();
        rect1.y2 = rect1pos2.getY();
        
        NgLogD('rect x1:' + rect1.x1 + 'rect x2:' + rect1.x2 + ' rect y1:' + rect1.y1 + ' rect y2:' + rect1.y2);
        
        var rect2 = new Object();
        var rect2pos1 = Util.getPositionForAnchorPoint(img2, new Core.Point(0, 0));
        var rect2pos2 = Util.getPositionForAnchorPoint(img2, new Core.Point(1, 1));
        rect2.x1 = rect2pos1.getX();
        rect2.x2 = rect2pos2.getX();
        rect2.y1 = rect2pos1.getY();
        rect2.y2 = rect2pos2.getY();
        
        NgLogD('rect x1:' + rect2.x1 + 'rect x2:' + rect2.x2 + ' rect y1:' + rect2.y1 + ' rect y2:' + rect2.y2);
        
        //if (RectA.X1 < RectB.X2 && RectA.X2 > RectB.X1 &&
        //    RectA.Y1 < RectB.Y2 && RectA.Y2 > RectB.Y1)		
        
        return (rect1.x1 < rect2.x2 && rect1.x2 > rect2.x1 &&
        rect1.y1 < rect2.y2 &&
        rect1.y2 > rect2.y1);
        
        
        
    },
    $ScrollTouchHandler: Core.MessageListener.subclass({
        initialize: function(map, lockY){
            this._map = map;
            this._target = map.getTouchTarget();
            
            if (typeof lockY == 'undefined') 
                lockY = false;
            
            this._lockY = lockY;
            
        },
        
        getTouchTarget: function(){
            return this._target;
        },
        
        onTouch: function(touch){
            switch (touch.getAction()) {
                case touch.Action.Start:
                                      NgLogD('action start sidescrollmap');
                    this._trackingId = touch.getId();
                    this._trackingCurrent = touch.getPosition();
                    
                    var local = this._map.getParent().screenToLocal(this._trackingCurrent);
                    var current = this._map.getPosition();
                    
                    //offset of the actual difference between the point of touch and the current position of tilemap
                    this._trackingOffset = new Core.Vector(current.getX() - local.getX(), current.getY() - local.getY());
                    
                    this._touchedObject = this._map.objectForTouch(touch);
                    if (this._touchedObject) {
                    
                    }
					
					this._moveCount = 0;
                    
                    return true;
                case touch.Action.End:
                    if (this._trackingId != touch.getId()) 
                        return;
                    this._trackingId = NaN;
                    
                    if (this._touchedObject) {
                        if (typeof this._touchedObject.touched != 'undefined') 
							this._touchedObject.touched();
                    }
                    
                    break;
                case touch.Action.Move:
                    if (this._trackingId != touch.getId()) 
                        return;
						NgLogD('moved object');
					if (this._moveCount < 7 && this._touchedObject && !(Math.abs(this._trackingCurrent.getX() - touch.getPosition().getX()) > 20 )) {
						this._moveCount++;
						return;
					}
					
					if ( Math.abs(this._trackingCurrent.getX() - touch.getPosition().getX()) < 10 && this._touchedObject) {
						return;
					}					
					
					//if it moved alot kill the touchedobject
					this._touchedObject = null;
					
                    
                    

 
                    
                    this._trackingCurrent = touch.getPosition();
                    var current = this._map.getParent().screenToLocal(this._trackingCurrent);
                    var offset = this._trackingOffset;
                    
                    if (this._lockY) {
                        this._map.setPosition(current.getX() + offset.getX(), this._map.getPosition().getY());
                    }
                    else {
                        this._map.setPosition(current.getX() + offset.getX(), current.getY() + offset.getY());
                    }
                    
                    break;
            }
        }
    }),
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Animation'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Animation'] || {}; $MODULE_REGISTRY['Code/G6/Animation'] = exports; 
exports.Animation = {
	//AnimationFrameCache: require('./Animation/AnimationFrameCache').AnimationFrameCache,
    AnimatedNode: require('Code/G6/Animation/AnimatedNode').AnimatedNode,
    AnimatedSprite: require('Code/G6/Animation/AnimatedSprite').AnimatedSprite,
	ScrollingLabel: require('Code/G6/Animation/ScrollingLabel').ScrollingLabel,	
	SpriteImage: require('Code/G6/Animation/SpriteImage').SpriteImage,
	TransitionLoader: require('Code/G6/Animation/TransitionLoader').TransitionLoader,
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Strip/StripScene'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripScene'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripScene'] = exports; var StripObjectNode = require('Code/StripCity/Scene/Strip/StripObjectNode').StripObjectNode;
var StripObjectBuildMenu = require('Code/StripCity/Scene/Strip/StripObjectBuildMenu').StripObjectBuildMenu;
var StripObjectInfo = require('Code/StripCity/Scene/Strip/StripObjectInfo').StripObjectInfo;
var StripMap = require('Code/StripCity/Scene/Strip/StripMap').StripMap;
var StripMapBackground = require('Code/StripCity/Scene/Strip/StripMapBackground').StripMapBackground;
var GenericAlertNode = require('Code/StripCity/Scene/Common/GenericAlertNode').GenericAlertNode;
var IAPMenu = require('Code/StripCity/Scene/IAP/IAPMenu').IAPMenu;

var animationDuration = 0.5;

/**
 * @author will
 */
exports.StripScene = Node.subclass({
    classname: 'StripScene',
    
    initialize: function(strip){
    
        this._strip = strip;
        
        var screenSize = Util.screenSize(true);
        
        this._bgNode = this.createStripBackgroundNode();
        this._bgNode.setDepth(-1);
        this.addChild(this._bgNode);
        
        var stripUpdateListener = Game.SCGame.getStripUpdateEmitter();
        this._ssMap = new StripMap(this._bgNode, new Core.Size([Scale.droid.width(800), Scale.droid.height(320)]), 75, this);
        this._ssMap.attachUpdateListener(stripUpdateListener);
        this._ssMap.setDepth(1);
        this._ssMap.setYScreenTopBounds(70);
        
        
        var plotMap = strip.getPlotMap();
        
        for (var i in plotMap) {
            var stripObject = plotMap[i];
            if (!stripObject) 
                continue;
            
            //sanity check.
            stripObject.setPlotID(parseInt(i));
            //            var s = this.createStripObjectNode(stripObject);
            //			NgLogD('created strip node object at position  ' + s.getPosition().getX() + "," + s.getPosition().getY());
            //            this._ssMap.addObject(s.getCurrentPlotID(), s);
        
        }
        
        
        this._ssMap.drawPlotMap(plotMap);
        this._ssMap.addInitialCars();
        
        var bottomLeft = AtlasMap.getSprite('stats-bg-bottomleft.png', [0, 1]);
        bottomLeft.setPosition(Scale.droid.width(0), screenSize.getHeight());
        bottomLeft.setDepth(5);
        
        var lobbyImg = AtlasMap.getAnimationFrame('stats-button-lobby-active.png', 0, [0, 1]);
        var lobbyImgI = AtlasMap.getAnimationFrame('stats-button-lobby-inactive.png', 0, [0, 1]);
        this.lobbyItem = new Menu.AnimationFrameMenuItem();
        this.lobbyItem.setFrames(lobbyImgI, lobbyImg, lobbyImg);
        var self = this;
        this.lobbyItem.setAction(function(){
            SCGame.returnToLobby(self);
        });
        
   //     this.setChildrenDepthGrouped(false);
        
        this._menu = new Menu.Menu([this.lobbyItem]);
        this._menu.setPosition(Scale.droid.width(0) + 4, screenSize.getHeight() - 4);
        this._menu.setDepth(5);
        
        this.addChild(this._ssMap);
        this.addChild(bottomLeft);
        this.addChild(this._menu);
        
        
        var cart = AtlasMap.getAnimationFrame('stats-button-bank-active.png', 0, [1, 0]);
        var cartI = AtlasMap.getAnimationFrame('stats-button-bank-inactive.png', 0, [1, 0]);
        
        this.purchaseItem = new Menu.AnimationFrameMenuItem();
        this.purchaseItem.setFrames(cartI, cart, cart);
        var self = this;
        this.purchaseItem.setAction(function(){
            self.showIAP();
        });
        
        this.purchaseMenu = new Menu.Menu([this.purchaseItem]);
        this.purchaseMenu.setPosition(Scale.droid.width(796), Scale.droid.height(4));
        this.purchaseMenu.setDepth(10);
        this.addChild(this.purchaseMenu);
        
        var bottomRight = AtlasMap.getSprite('stats-bg-bottomright.png', [1, 1]);
        bottomRight.setPosition(screenSize.getWidth(), screenSize.getHeight());
        bottomRight.setDepth(5);
        this.addChild(bottomRight);
        
        var build = AtlasMap.getAnimationFrame('stats-button-build-active.png', 0, [0.5, 0.5]);
        var buildI = AtlasMap.getAnimationFrame('stats-button-build-inactive.png', 0, [0.5, 0.5]);
        
        this.buildItem = new Menu.AnimationFrameMenuItem();
        this.buildItem.setFrames(buildI, build, build);
        this.buildItem.setAction(function(){
            self.openBuildTouched();
        });
        
        this.tutorial = null;
		

		
        var gameInfoButtonActive = AtlasMap.getAnimationFrame('stats-button-info-active.png', 0, [0.5, 0.5]);
        var gameInfoButtonInactive = AtlasMap.getAnimationFrame('stats-button-info-inactive.png', 0, [0.5, 0.5]);
        
        this.gameInfo = new Menu.AnimationFrameMenuItem();
        var thisObj = this;
        this.gameInfo.setFrames(gameInfoButtonInactive, gameInfoButtonActive, gameInfoButtonInactive);
        this.gameInfo.setAction(function(){
            thisObj.openTutorial();
        });
        
        
        this.openBuildMenu = new Menu.Menu([this.buildItem, this.gameInfo]);
        this.openBuildMenu.alignItemsHorizontally(5);
        this.openBuildMenu.setPosition(screenSize.getWidth() - 83, screenSize.getHeight() - 28);
        this.openBuildMenu.setDepth(5);
        this.addChild(this.openBuildMenu);
        
        //logout button   
        
        //initialize the player stats
        var playerUpdateEmitter = Game.SCGame.getPlayerUpdateEmitter();
        
        var statsBg = AtlasMap.getSprite('stats-bg.png', [0, 0]);
        statsBg.setDepth(3);
        this.addChild(statsBg);
        
        this.xpStat = new PlayerStatNode(Game.Player.Player.StatType.Experience, Game.SCGame.getPlayer());
        this.xpStat.setDepth(4);
        this.xpStat.setPosition(Scale.droid.width(258), Scale.droid.height(38));
        SCStyle.applyFontStyle(this.xpStat.getTextObject(), SCStyle.FontStyle.Sans14);
		if (Game.SCGame.getPlayer().getNextLevelExpRequired() >= 1000000) //lower font size if exp greater than 1 mil
			SCStyle.applyFontStyle(this.xpStat.getTextObject(), SCStyle.FontStyle.Sans12);
        this.xpStat.attachUpdateListener(playerUpdateEmitter);
        this.addChild(this.xpStat);
        
        this.chipsStat = new PlayerStatNode(Game.Player.Player.StatType.Chips, Game.SCGame.getPlayer());
        this.chipsStat.setDepth(4);
        this.chipsStat.setPosition(Scale.droid.width(424), Scale.droid.height(21));
        this.chipsStat.attachUpdateListener(playerUpdateEmitter);
        this.addChild(this.chipsStat);
        
        this.chipLabel = new GL2.Text();
		this.chipLabel.setFontFamily('DroidSans-Regular');
		this.chipLabel.setFontSize(32);
        this.chipLabel.setDepth(4);
        this.chipLabel.setAnchor(0, 0.5);
        this.chipLabel.setPosition(Scale.droid.width(424), Scale.droid.height(38));
        SCStyle.applyFontStyle(this.chipLabel, SCStyle.FontStyle.Sans14);
        this.chipLabel.setText('Chips');
        this.addChild(this.chipLabel);
        
        this.compStat = new PlayerStatNode(Game.Player.Player.StatType.Comp, Game.SCGame.getPlayer());
        this.compStat.setDepth(4);
        this.compStat.setPosition(Scale.droid.width(594), Scale.droid.height(21));
        this.compStat.attachUpdateListener(playerUpdateEmitter);
        this.addChild(this.compStat);
        
        this.compLabel = new GL2.Text();
		this.compLabel.setFontFamily('DroidSans-Regular');
		this.compLabel.setFontSize(32);
        this.compLabel.setDepth(4);
        this.compLabel.setAnchor(0, 0.5);
        this.compLabel.setPosition(Scale.droid.width(594), Scale.droid.height(38));
        SCStyle.applyFontStyle(this.compLabel, SCStyle.FontStyle.Sans14);
        this.compLabel.setText('Comp Points');
        this.addChild(this.compLabel);
        
        this.levelStat = new PlayerStatNode(Game.Player.Player.StatType.Level, Game.SCGame.getPlayer());
        this.levelStat.setDepth(4);
        this.levelStat.setPosition(Scale.droid.width(257), Scale.droid.height(21));
        this.levelStat.attachUpdateListener(playerUpdateEmitter);
        this.addChild(this.levelStat);
        
        this._buildMenu = new StripObjectBuildMenu(this);
        this._buildMenu.setDepth(11);
        this._buildMenuVisiblePosition = this._buildMenu.getPosition().clone();
        this._buildMenuInvisiblePosition = new Core.Point(this._buildMenuVisiblePosition.getX(), this._buildMenuVisiblePosition.getY() + screenSize.getHeight() + Scale.droid.height(100));
        
        this._buildMenu.setPosition(this._buildMenuInvisiblePosition);
        this._buildMenu.setEnabled(false);
        this._buildMenu.attachPlayerUpdateListener(playerUpdateEmitter);
        
        this.addChild(this._buildMenu);
        
        
        this._stripObjectInfo = new StripObjectInfo(this);
        this._stripObjectInfo.setDepth(6);
        this._stripObjectInfo.setPosition(0, 60);
        this._stripObjectInfo.setVisible(false);
        this.addChild(this._stripObjectInfo);
        
		this.updateAnimationsToRun = 0;
        this.setState(this.State.Scrolling);

		if(!SCGame.getPlayer().getTutorialHistory().finishedStripTutorial())
		{
			this.openTutorial();
		}
        
        //this should add
        //		var prim = new GL2.Primitive();
        //		
        //		var colorLayer = new GL2.Primitive.Vertex( new Core.Point(0,0),new Core.Point(0,0), new Core.Color(255,255,255));
        //		prim.pushVertex(colorLayer);
        //		
        //		var colorLayer2 = new GL2.Primitive.Vertex( new Core.Point(100,0),new Core.Point(0,0), new Core.Color(255,255,255));
        //		prim.pushVertex(colorLayer2);
        //		
        //		var colorLayer3 = new GL2.Primitive.Vertex( new Core.Point(0,50),new Core.Point(0,0), new Core.Color(255,255,255));
        //		prim.pushVertex(colorLayer3);		
        //		
        //		GL2.Root.addChild(prim);
        
        //set up timer.
        var self = this;
        setInterval(function(){
            self.refreshCollect()
        }, 1000);
        
        
        //temp iap node
    
    
    
    },
    
    createStripBackgroundNode: function(){
    
        //var timeObj = new Core.Time();
        var hour = new Date().getHours();
        
        if (!SCGame.isNightTime) {
            var bgWidth = Scale.droid.width(2048);
            var bgHeight = Scale.droid.height(480);
            var bg1 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_day_01_background.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            //var bg2 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_day_06_dust.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            var bg3 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_day_03_fardesert.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            //var bg4 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_day_04_middesert.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            var bg5 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_day_05_street.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            var bg6 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_day_02_sun.png', 0, [168, bgHeight], [0.5, 0]);
            
            var bgNode = new StripMapBackground();
            bgNode.setPosition(Util.screenSize(true).getWidth() / 2, 0);
            bgNode.addLayer(bg1, 1, 20, undefined, false);
            //bgNode.addLayer(bg2, 6, 100);
            bgNode.addLayer(bg3, 3, 60);
            //bgNode.addLayer(bg4, 4, 80);
            bgNode.addLayer(bg5, 5, 100);
            bgNode.addLayer(bg6, 2, 40, true);
        }
        else {
            var bgWidth = Scale.droid.width(2048);
            var bgHeight = Scale.droid.height(480);
            var bg1 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_nite_01_background.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            //var bg2 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_nite_07_dust.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            var bg3 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_nite_04_fardesert.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            //var bg4 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_nite_05_middesert.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            var bg5 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_nite_03_moon.png', 0, [480, bgHeight], [0.5, 0]);
            //var bg6 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_nite_02_stars.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            var bg7 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_nite_06_street.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            var bg8 = new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_nite_08_lights.png', 0, [bgWidth, bgHeight], [0.5, 0]);
            
            var bgNode = new StripMapBackground();
            bgNode.setPosition(Util.screenSize(true).getWidth() / 2, 0);
            bgNode.addLayer(bg1, 1, 20, undefined, false);
            //bgNode.addLayer(bg2, 7, 100);
            bgNode.addLayer(bg3, 4, 60);
            //bgNode.addLayer(bg4, 5, 80);
            bgNode.addLayer(bg5, 3, 40, true);
            //bgNode.addLayer(bg6, 2, 30);
            bgNode.addLayer(bg7, 6, 100);
            bgNode.addLayer(bg8, 8, 100);
        }
        
        bgNode.setCurrentNumberBackgroundSprites(1);
        bgNode.updateImages();
        return bgNode;
    },
    
    State: {
    
        Scrolling: 0,
        BuildingInfo: 1,
        BuildMenu: 2,
        MovingNode: 3,
        IAPMenu: 4,
		Tutorial: 5,
		
    
    },
    
    setState: function(state){
        if (this._state == state) 
            return;
        
        switch (state) {
            case this.State.Scrolling:
                this._ssMap.setTouchable(true);
                this._stripObjectInfo.setTouchable(false);
                this._menu.setTouchable(true);
                this._buildMenu.setEnabled(false);
                this._ssMap.showCollectButtonOnNodes(true);
                this.purchaseItem.setEnabled(true);
                //this.buildItem.setEnabled(true);
				this.updateBuildButtonEnabled();
                this.lobbyItem.setEnabled(true);
                //				this._ssMap.setVisible(true);
                //				this._bgNode.setVisible(true);		
				this.setTextVisible(true);	
                
                break;
            case this.State.BuildingInfo:
                this._ssMap.setTouchable(false);
                this._stripObjectInfo.setTouchable(true);
                this._menu.setTouchable(false);
                this._buildMenu.setEnabled(false);
                this._ssMap.showCollectButtonOnNodes(false);
                this.purchaseItem.setEnabled(false);
                this.buildItem.setEnabled(false);
                this.lobbyItem.setEnabled(false);
				this.setTextVisible(true);					
                break;
            case this.State.BuildMenu:
                this._ssMap.setTouchable(false);
                this._stripObjectInfo.setTouchable(false);
                this._menu.setTouchable(true);
                this._buildMenu.setEnabled(true);
                this._ssMap.showCollectButtonOnNodes(false);
                this.purchaseItem.setEnabled(false);
                this.buildItem.setEnabled(false);
                this.lobbyItem.setEnabled(false);
				this.setTextVisible(false);					
                break;
            case this.State.IAPMenu:
                this._ssMap.setTouchable(false);
                this._stripObjectInfo.setTouchable(false);
                this._menu.setTouchable(false);
                this._buildMenu.setEnabled(false);
                this._ssMap.showCollectButtonOnNodes(false);
                this.purchaseItem.setEnabled(false);
                this.buildItem.setEnabled(false);
                this.lobbyItem.setEnabled(false);
                //				this._ssMap.setVisible(false);	
                //					this._bgNode.setVisible(false);
				
				this.setTextVisible(false);					
                break;
			case this.State.Tutorial:
                this._ssMap.setTouchable(false);
                this._stripObjectInfo.setTouchable(false);
                this._menu.setTouchable(false);
                this._buildMenu.setEnabled(false);
                this._ssMap.showCollectButtonOnNodes(false);
                this.purchaseItem.setEnabled(false);
                this.buildItem.setEnabled(false);
                this.lobbyItem.setEnabled(false);
				this.setTextVisible(false);					
                break;				
            case this.State.MovingNode:
                this._ssMap.setTouchable(true);
                this._stripObjectInfo.setTouchable(false);
                this._menu.setTouchable(false);
                this._buildMenu.setEnabled(false);
                this._ssMap.showCollectButtonOnNodes(false);
                this.purchaseItem.setEnabled(false);
                this.lobbyItem.setEnabled(false);
                this.buildItem.setEnabled(false);
				this.setTextVisible(true);					
                break;
            default:
                this._ssMap.setTouchable(true);
                this._stripObjectInfo.setTouchable(false);
                this._menu.setTouchable(true);
                this.purchaseItem.setEnabled(false);
                break;
                
                
        }
        
        this._state = state;
        
    },
    
    setTextVisible: function(v){
        this.levelStat.setVisible(v);
        this.compLabel.setVisible(v);
        this.chipLabel.setVisible(v);
        this.chipsStat.setVisible(v);
        this.xpStat.setVisible(v);
		this.compStat.setVisible(v);
    },
    
    //happens every second
    refreshCollect: function(){
    
        if (this._stripObjectInfo) {
            this._stripObjectInfo.refreshTimeTilCollectTime();
        }
        
        //only run the check when its in scroll mode.
        if (this._ssMap && this._state == this.State.Scrolling) {
            this._ssMap.runCanCollectCheckOnNodes();
        }
        
    },
    
    testAlertLayer: function(){
    
        var node = new TestAlertNode("TESTING1");
        AlertLayer.queueAlertNode(node);
        
        var node2 = new TestAlertNode("TESTING2");
        AlertLayer.queueAlertNode(node2);
        
        var node3 = new TestAlertNode("TESTING3");
        AlertLayer.queueAlertNode(node3);
    },
    
    close: function(menu){
        if (!menu.isAnimating()) {
            menu.moveTo(this._buildMenuVisiblePosition.getX(), this._buildMenuInvisiblePosition.getY(), animationDuration);
        }
        SCGame.getSCAudio().playsound(11);
        var self = this;
        setTimeout(function(){
            self.setState(self.State.Scrolling);
        }, animationDuration * 1000);
        
        
    },
    
    closeIAPMenu: function(menu){
        if (!menu.isAnimating()) {
            menu.moveTo(this._buildMenuVisiblePosition.getX(), this._iapInvisiblePosition.getY(), animationDuration);
        }
        SCGame.getSCAudio().playsound(11);
        
        var self = this;
        setTimeout(function(){
            self.setState(self.State.Scrolling);
            self.removeChild(menu);
        }, animationDuration * 1000);
    },
    
    destroy: function($super){
        $super();
    },
    
    addUpdateAnimationsToRun: function(amount) {
		
		this.updateAnimationsToRun += amount;
		this.updateBuildButtonEnabled();
	},
	
	updateBuildButtonEnabled: function() {
		
		this.buildItem.setEnabled(this.updateAnimationsToRun <= 0);
	},
	
    stripNodeTouched: function(node){
    
        if (this.updateAnimationsToRun > 0) 
            return;
        if (node.classname != StripObjectNode.classname) 
            return;
        if (node.markedForRemove()) 
            return;
        //the node that was touched..
        
        var s = node.getStripObject();
        
        if (s.getType() != Game.Strip.StripObjectTemplate.Type.Empty) {
        
            //pull up the stripObjectInfo
            
            //how many strip objects left..
            var numActiveStripObjects = this._strip.getNumActiveStripObjects();
            if (numActiveStripObjects > 1) {
                this._stripObjectInfo.showFor(s, true, true);
            }
            else {
                this._stripObjectInfo.showFor(s, false, true);
            }
            
            
            //this._stripObjectInfo.showFor(s);
            this._ssMap.shiftMapForStripObjectInfo(node);
            node.showSpotlights();
            this.setState(this.State.BuildingInfo);
            return;
        }
        
        //		if (this._strip.canBuild()) {
        //		
        //		
        //			//pull up the menu...
        //			if (!this._buildMenu.isAnimating()) 
        //				this._buildMenu.moveTo(this._buildMenuVisiblePosition.getX(), this._buildMenuVisiblePosition.getY(), animationDuration);
        //			this._buildMenu.setOpenForPlotID(node.getStripObjectPlotID());
        //			this.setState(this.State.BuildMenu);
        //		//    AlertLayer.showAlert();
        //		}
        //		else {
        //			AlertLayer.showAlertNode(new GenericAlertNode('too many buildings.'));
        //		}
    },
    
    openBuildTouched: function(){
    
        if (this.updateAnimationsToRun > 0) 
            return;
        
        if (this._strip.canBuild()) {
            SCGame.getSCAudio().playsound(10);
            //pull up the menu...
            if (!this._buildMenu.isAnimating()) 
                this._buildMenu.moveTo(this._buildMenuVisiblePosition.getX(), this._buildMenuVisiblePosition.getY(), animationDuration);
            
            var buildRight = this._ssMap.getPosition().getX() <= 0;
            this._buildMenu.setBuildToTheRight(buildRight);
            this.setState(this.State.BuildMenu);
        }
        else {
            AlertLayer.showAlertNode(new GenericAlertNode('Strip City zoning rules limit you to ten hotels.','ZONING RULES'));
        }
    },
    
    stripObjectInfoHidden: function(so){
    
        var son = this._ssMap.getStripObjectNode(so.getID());
        son.hideSpotlights();
        
        this.setState(this.State.Scrolling);
    },
    
    stripObjectSell: function(so){
    
        var son = this._ssMap.getStripObjectNode(so.getID());
        son.hideSpotlights();
        
        Game.SCGame.handleSellStripObject(so);
        this.setState(this.State.Scrolling);
        
    },
    
    stripObjectBuy: function(so){
    
        var buildRight = this._buildMenu.getBuildToTheRight();
        if (buildRight) 
            this._ssMap.setPositionAllWayToTheRight();
        else 
            this._ssMap.setPositionAllWayToTheLeft();
        
        Game.SCGame.handleBuyStripObject(so, buildRight);
        
        //close the menu
        this.close(this._buildMenu);
    },
    
    stripObjectCollect: function(so){
    
        Game.SCGame.handleCollectStripObject(so);
        
    },
    
    stripObjectMove: function(so){
    
        var son = this._ssMap.getStripObjectNode(so.getID());
        son.hideSpotlights();
        son.setState(StripObjectNode.State.UnlockedMounted);
        
        this._ssMap.setState(StripMap.State.MovingNode);
        this.setState(this.State.MovingNode);
    },
    
    stripObjectMoveConfirmed: function(so, plotID){
        if (!so) 
            return;
        Game.SCGame.handleMoveStripObject(so, plotID);
        
        
        //reset states
        var son = this._ssMap.getStripObjectNode(so.getID());
        son.setState(StripObjectNode.State.Locked);
        
        this._ssMap.setState(StripMap.State.Scrolling);
        this.setState(this.State.Scrolling);
        
    },
    
    stripObjectMoveCanceled: function(so){
        if (!so) 
            return;
        this.redrawStrip();
        
        //reset states
        var son = this._ssMap.getStripObjectNode(so.getID());
        son.setState(StripObjectNode.State.Locked);
        
        this._ssMap.setState(StripMap.State.Scrolling);
        this.setState(this.State.Scrolling);
        
    },
    
    redrawStrip: function(){
        var plotMap = this._strip.getPlotMap();
        
        for (var i in plotMap) {
            var stripObject = plotMap[i];
            if (!stripObject) 
                continue;
            //sanity check
            stripObject.setPlotID(parseInt(i));
        }
        
        this._ssMap.drawPlotMap(plotMap, true);
    },
    
    showIAP: function(){
        SCGame.getSCAudio().playsound(10);
        this.setState(this.State.IAPMenu);
        this._iap = Game.IAP.IAPManager.getMenuAndReset();
        this._iap.setDelegate(this);
        this._iap.setDepth(12);
        this._iapVisiblePosition = this._buildMenuVisiblePosition.clone();
        this._iapInvisiblePosition = this._buildMenuInvisiblePosition.clone();
        this._iap.setPosition(this._iapInvisiblePosition.clone());
        this.addChild(this._iap);
        
        if (!this._iap.isAnimating()) {
            this._iap.moveTo(this._buildMenuVisiblePosition.getX(), this._buildMenuVisiblePosition.getY(), animationDuration);
        }
        
    },
	openTutorial: function() {
		this.setState(this.State.Tutorial);
		if (this.tutorial == null) {
			this.tutorial = new CardGame.Tutorial(this,  SCConstants.Game.Strip);
			this.addChild(this.tutorial.getNode());
		}
		if (SCGame.getPlayer().getTutorialHistory().finishedStripTutorial()) {
			SCGame.getSCAudio().playsound(10);
		}			
		this.tutorial.getNode().setPosition(Scale.droid.width(0), Scale.droid.height(800));
		this.tutorial.getNode().moveTo(Scale.droid.width(0),Scale.droid.height(0), 0.5);
	},
	
	closeTutorial: function() {
		SCGame.getPlayer().getTutorialHistory().setStripTutorial(true);
		SCGame.quickSaveTutorialHistory();		
		 this.setState(this.State.Scrolling);
		 
		SCGame.getSCAudio().playsound(11);				
		this.tutorial.getNode().moveTo(Scale.droid.width(0),Scale.droid.height(800), 0.5);
	},
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Util/Util'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Util/Util'] || {}; $MODULE_REGISTRY['Code/G6/Util/Util'] = exports; /**
 * @author will
 */
Date.prototype.addHours = function(h){
    var copiedDate = new Date(this.getTime());
    copiedDate.setHours(copiedDate.getHours() + h);
    return copiedDate;
}

Date.prototype.addSeconds = function(h){
  var copiedDate = new Date(this.getTime());
    copiedDate.setSeconds(copiedDate.getSeconds()+h);
    return copiedDate;
}


exports.Util = Node.subclass({
    //move this util lib
    
    initialize: function(){
        this.pixelRatio = 1;
        var ratio = Core.Capabilities.getScreenHeight() / Core.Capabilities.getScreenWidth();
        if (ratio > 0.6) {
            //stretch based on width
            this.pixelRatio = Core.Capabilities.getScreenWidth() / 800;
        }
        else {
            //stretch based on height
            this.pixelRatio = Core.Capabilities.getScreenHeight() / 480;
        }
    },
    
    realPixel: function(val){
        return val * this.pixelRatio;
    },
	
	$generateBlankSprite: function(imagePath) {
		
		var sprite = new GL2.Sprite();
		sprite.setImage(imagePath, [0,0], [0,0], [0,0,0,0]);
		return sprite;
	},
	
	$isCurrentlyNightTime: function() {
		
		var hour = new Date().getHours();
		return hour < 7 || hour >= 19;
	},
	
	$randomInt: function(from, to) {
		
		var diff = to - from;
		return Math.floor(Math.random() * diff) + from;
	},
	
	$numberFormat: function(nStr){
	  nStr += '';
	  x = nStr.split('.');
	  x1 = x[0];
	  x2 = x.length > 1 ? '.' + x[1] : '';
	  var rgx = /(\d+)(\d{3})/;
	  while (rgx.test(x1))
	    x1 = x1.replace(rgx, '$1' + ',' + '$2');
	  return x1 + x2;
	},
	
	$dollarFormat: function(nStr) {
		return '$' + Util.numberFormat(nStr);
	},
	
	$translateTime: function (tl, ismillis, shortHand) {
		if (typeof ismillis == 'undefined') ismillis = false;
		
		var timeLeft = tl;		
		if (ismillis) {
			timeLeft = Util.floatToInt( tl / 1000);	
		}

		var hours = Util.floatToInt(timeLeft / 3600);
		var leftover = timeLeft % 3600;
		var hours = Util.floatToInt(timeLeft / 3600);
		var minutes = Util.floatToInt (leftover / 60);
		leftover = leftover % 60;
		var seconds = leftover;
		
		var hourLabel = hours == 1 ? "hour" : "hours";
		
		var minLabel;
		if (shortHand) 
			 minLabel = minutes == 1 ? "min" : "mins";
		else minLabel = minutes == 1 ? "minute" : "minutes";
		
		var secLabel;
		if (shortHand) 
			 secLabel = seconds == 1 ? "sec" : "secs";
		else secLabel = seconds == 1 ? "second" : "seconds";
		
		var result;
		if (hours > 0) {
			result = '' + hours + ' ' + hourLabel;
			if (minutes > 0)
				result += ' ' + minutes + ' ' + minLabel;
		}
		else if (minutes > 0) {
			result = '' + minutes + ' ' + minLabel;
			if (seconds > 0)
				result += ' ' + seconds + ' ' + secLabel;
		}
		else {
			result = '' + seconds + ' ' + secLabel;
		}		
		
		return result;
	},
    
    $distanceBetweenTwoPoints: function(p1, p2){
        var x = p2.getX() - p1.getX();
        var y = p2.getY() - p1.getY();
        
        return Math.sqrt(x * x + y * y);
    },
    $floatToInt: function(num){
        if (num < 0) {
            return Math.ceil(num);
        }
        return Math.floor(num);
    },
    $pointsAreSame: function(point1, point2){
        return (point1.getX() == point2.getX() && point1.getY() == point2.getY());
    },
    
    $removeByValue: function(arr, val){
        for (var i in arr) {
            if (arr[i] == val) {
                arr.splice(i, 1);
                break;
            }
        }
    },
    
    $insertAtIndex: function(arr, index, val){
        arr.splice(index, 0, val);
    },
    
    $removeByIndex: function(arr, index){
        arr.splice(index, 1);
    },
    
    $pointSub: function(point1, point2){
        return new Core.Point(point1.getX() - point2.getX(), point1.getY() - point2.getY());
    },
    
    $pointAddTo: function(point1, point2){
        point1.setX(point1.getX() + point2.getX());
        point1.setY(point1.getY() + point2.getY());
    },
    
    $pointAdd: function(point1, point2){
        return new Core.Point(point1.getX() + point2.getX(), point1.getY() + point2.getY());
    },
    
    $getPositionForAnchorPoint: function(img, translateAP){
        //position returns 0.5,0.5 anchor point so we take the difference
        var currentAP = img._animation.getFrame(0).getAnchor();
        var diff = Util.pointSub(translateAP, currentAP);
        var size = img._animation.getFrame(0).getSize();
        var pos = img.getPosition();
        
        
        
        var position = new Core.Point(Util.floatToInt(pos.getX() + (size.getWidth() * diff.getX())), Util.floatToInt(pos.getY() + (size.getHeight() * diff.getY())));
        
        //       NgLogD("***** anchorpoint " + this.pointToString(currentAP));		
        //        NgLogD("***** anchorpoint " + this.pointToString(translateAP));
        //        NgLogD('orig pos = ' + this.pointToString(pos));
        //        NgLogD('anchor pos = ' + this.pointToString(position));
        
        return position;
    },
    
    $getPositionForAnchorPointGivenValues: function(pos, size, currentAP, translateAP){
        //position returns 0.5,0.5 anchor point so we take the difference
        //		var currentAP = img._animation.getFrame(0).getAnchor();		
        var diff = Util.pointSub(translateAP, currentAP);
        //        var size = img._animation.getFrame(0).getSize();
        //		var pos = img.getPosition();
        
        
        
        var position = new Core.Point(Util.floatToInt(pos.getX() + (size.getWidth() * diff.getX())), Util.floatToInt(pos.getY() + (size.getHeight() * diff.getY())));
        
        //       NgLogD("***** anchorpoint " + this.pointToString(currentAP));		
        //        NgLogD("***** anchorpoint " + this.pointToString(translateAP));
        //        NgLogD('orig pos = ' + this.pointToString(pos));
        //        NgLogD('anchor pos = ' + this.pointToString(position));
        
        return position;
    },
    
    $rectContainsPoint: function(rect, point){
    
    
    
        var x1 = rect.getOrigin().getX();
        var x2 = x1 + rect.getSize().getWidth();
        var y1 = rect.getOrigin().getY();
        var y2 = y1 + rect.getSize().getHeight();
        
        //		NgLogD( 'rect x1= ' + x1 + " x2 = " + x2 + " y1 =" + y1 + " y2 =" + y2);		
        
        
        var pX = point.getX();
        var pY = point.getY();
        
        if (pX >= x1 && pX <= x2 && pY >= y1 && pY <= y2) 
            return true;
        return false;
        
    },
    
    
    $pointToString: function(point){
        return point.getX() + ':' + point.getY();
    },
    
    $screenSize: function(landscape){
        if (landscape) {
            return new Core.Size(Math.max(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenWidth()),Math.min(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenWidth()));
        }
        
        return new Core.Size(Core.Capabilities.getScreenWidth(), Core.Capabilities.getScreenHeight());
    },
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Util/Scaler'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Util/Scaler'] || {}; $MODULE_REGISTRY['Code/G6/Util/Scaler'] = exports; //Lazy / poor man's spring system!
var Scale = {
	screenWidth:-1,
	screenHeight:-1,
	textFactors:null,
	verifyInit:function() {
		if(Scale.screenWidth < 0) {
			if (Capabilities.getScreenWidth() > Capabilities.getScreenHeight()) {
				Scale.screenWidth = Capabilities.getScreenHeight();
			} else {
				Scale.screenWidth = Capabilities.getScreenWidth();
			}
		}
		if(Scale.screenHeight < 0) {
			if (Capabilities.getScreenWidth() > Capabilities.getScreenHeight()) {
				Scale.screenHeight = Capabilities.getScreenWidth();
			} else {
				Scale.screenHeight = Capabilities.getScreenHeight();
			}
		}
		if(!Scale.textFactors) {
			
			if (Capabilities.getPlatformOS().toLowerCase() == 'android') {
				Scale.textFactors = {
					ios:35/30,
					droid:1
				};
			}
			else
			{
				Scale.textFactors = {
					ios:1,
					droid:3/4
				};
			}
		}
	},
	ios:{
		width:function(iPx) {
			Scale.verifyInit();
			return iPx / 320.0 * Scale.screenWidth;
		},
		height:function(iPx) {
			Scale.verifyInit();
			return iPx / 480.0 * Scale.screenHeight;
		},
		textSize:function(iTpx) {
			Scale.verifyInit();
			return iTpx * Scale.textFactors.ios;
		}
	},
	droid:{
		height:function(iPx) {
			Scale.verifyInit();
			return iPx / 480.0 * Scale.screenWidth;
		},
		width:function(iPx) {
			Scale.verifyInit();
			return iPx / 800.0 * Scale.screenHeight;
		},
		textSize:function(iTpx) {
			Scale.verifyInit();
			return iTpx * Scale.textFactors.droid;
		}
	}
};
exports.Scale = Scale;
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Util/Styles'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Util/Styles'] || {}; $MODULE_REGISTRY['Code/G6/Util/Styles'] = exports; //////////////////////////////////////////////////////////////////////////////
/** 
 *  @date:      2010-11-09
 *  @file:      Styles.js
 *  @author:    Frederic Barthelemy
 *  Website:    http://www.ngmoco.com/
 *  Copyright:  2010, by ngmoco:)
 *              Unauthorized redistribution of source code is 
 *              strictly prohibited. Violators will be prosecuted.
 * 
 *  @brief:
 */
//////////////////////////////////////////////////////////////////////////////
var Styles = exports.Styles = {
	STATE_ERROR: 0x4000,
	defaultButtonStyle:{
		normalTextSize: 14, 
		normalTextStyle: 0x01 /*from Fonts.js 'Bold': 0x01,*/
	},
	background: {
		"innerShadow":"FF3DA7FF 200.0 {0.0,0.0}",
		"gradient":[
			"FFC0DCFF 0.000",
			"FFC0DCFF 1.000"
		]
	},
	white: {
		"gradient":[
			"FFFFFFFF 0.000",
			"FFFFFFFF 1.000"
		]
	},	
	loginBox: {
		corners: '0 0 0 4',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"0000FFEC 0.0",
			"0000FFCF 1.0"
		]
	},
	loginBoxDown: {
		corners: '0 0 0 4',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"0000FFCF 0.0",
			"0000FFEC 1.0"
		]
	},
	yellowButton: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FFfcf6cf 0.0",
			"FFd3b700 1.0"
		]
	},
	yellowButtonDown: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FF9f8a00 0.0",
			"FFbab06a 1.0"
		]
	},
	greyButton: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FFe4e4e4 0.0",
			"FF888888 1.0"
		]
	},
	greyButtonDown: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FF888888 0.0",
			"FFe4e4e4 1.0"
		]
	},
	blueButton: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FF9bd6f4 0.0",
			"FF0077BC 1.0"
		]
	},
	blueButtonDown: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FF1a6395 0.0",
			"FF13476c 1.0"
		]
	},
	lightblueButton: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FF9bd6f4 0.0",
			"FF458dc3 1.0"
		]
	},
	lightblueButtonSelected: {
		corners: '8 8 8 8',
		outerLine: "00 2.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FF316b90 0.0",
			"FF508db0 1.0"
		]
	},
	lightblueButtonDown: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FF316b90 0.0",
			"FF508db0 1.0"
		]
	},
	lightpinkButton: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FFf8ced3 0.0",
			"FFc84f75 1.0"
		]
	},
	lightpinkButtonDown: {
		corners: '8 8 8 8',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FFb86b74 0.0",
			"FF993956 1.0"
		]
	},
	lightpinkButtonSelected: {
		corners: '8 8 8 8',
		outerLine: "00 2.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FFb86b74 0.0",
			"FF993956 1.0"
		]
	},
	whiteButton: {
		corners: '4 4 4 4',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FFE3E3E3 0.0",
			"FFFFFFFF 1.0"
		]
	},
	whiteButtonDown: {
		corners: '4 4 4 4',
		outerLine: "00 1.5",
		/*innerLine: "99FF 1.5",*/
		gradient: [
			"FFFFFFFF 0.0",
			"FFE3E3E3 1.0"
		]
	},
	// This style is basically transparent.  It is needed for the two terms
	// buttons to show up on Android
	termsLabelButton: {
		gradient: [
			"0000 0.0",
			"0000 1.0"
		]
	},
	transparent: {
		gradient: [
			"0000 0.0",
			"0000 1.0"
		]
	},
	basicBox: {
		corners: "4",
		outerLine: "00 1.5",
		innerLine: "99FF 1.5",
		gradient: [
			"FF00B6EC 0.0",
			"FF0077CF 1.0"
		]
	},
	basicBoxDown: {
		corners: "4",
		outerLine: "00 1.5",
		innerLine: "55FF 1.5",
		gradient: [
			"FF0077CF 0.0",
			"FF00B6EC 1.0"
		]
	},
	label: {
		gradient: ['FFFF 0.0', 'FFFF 1.0'],
		outerLine: "FFF9 1.0"
	},
	inputLabel:{
		font: {'font-face':['Droid Sans'], 'font-size':16.0, 'bold':false},
		textColor: "FFFFFFFF",
		backgroundColor: "0000"
	},
	inputField: {
		outerLine: "00 1.5",
		corners: "4 4 4 4",
		gradient: [
			"FFF0 0.0",
			"FFFF 1.0"
		]
	},
	inputFieldSelected: {
		outerLine: "FF0066CC 2.0",
		corners: "4 4 4 4",
		gradient: [
			"FFF0 0.0",
			"FFFF 1.0"
		]
	},
	inputFieldErrored: {
		outerLine: "FFFF0000 4.0",
		corners: "4 4 4 4",
		gradient: [
			"FFFF8080 0.0",
			"FFFFA2A2 1.0"
		]
	},
	inputFieldErroredAndFocused: {
		outerLine: "FFFF 4.0",
		innerShadow: "FF00 2.0 {0,-1}",
		corners: "4 4 4 4",
		gradient: [
			"FFFFA0A0 0.0",
			"FFFFFFFF 1.0"
		]
	},
	inputFieldDisabled: {
		outerLine: "FF22 2.0",
		corners: "4 4 4 4",
		gradient: [
			"AF60 0.0",
			"AFA0 1.0"
		]
	},
	inputShadowLight: "4000 2.0 {0,-1}",
	inputShadowDark: "FF00 2.0 {0,-1}",
	adBorder: {
		corners: "9.0"
	},
	cellRow: {
		insets: '4',
		gradient: ['FFF0 0.0', 'FF80 1.0']
	}
};
exports.Styles.inputFieldGradients = {
	'gradient': exports.Styles.inputField,
	'selectedGradient': exports.Styles.inputFieldSelected,
	'disabledGradient': exports.Styles.inputFieldDisabled
};


exports.Styles.configureInputField = function(field) {
	field.setGradient(Styles.inputField, UI.State.Normal);
	field.setGradient(Styles.inputFieldSelected, UI.State.Focused);
	field.setGradient(Styles.inputFieldDisabled, UI.State.Disabled);
	field.setGradient(Styles.inputFieldErrored, Styles.STATE_ERROR);
	field.setGradient(Styles.inputFieldErroredAndFocused, Styles.STATE_ERROR + UI.State.Focused);
	field.setTextShadow(Styles.inputShadowLight, UI.State.Normal);
	field.setTextShadow(Styles.inputShadowDark, Styles.STATE_ERROR);
	field.setTextShadow(Styles.inputShadowLight, Styles.STATE_ERROR + UI.State.Focused);
	field.setTextColor("FF50", UI.State.Normal);
	field.setTextColor("FF00", UI.State.Focused);
	field.setTextColor("FFFF", Styles.STATE_ERROR);
	field.setTextColor("FF00", Styles.STATE_ERROR + UI.State.Focused);
}
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame'] = exports; /**
 * @author raymondlo
 */

exports.CardGame = {
    Deck: require('Code/StripCity/Game/CardGame/Deck').Deck,
	Card: require('Code/StripCity/Game/CardGame/Card').Card,
	Hand: require('Code/StripCity/Game/CardGame/Hand').Hand,
	Chips: require('Code/StripCity/Game/CardGame/Chips').Chips,
	BJHand: require('Code/StripCity/Game/CardGame/BJHand').BJHand,
	TriCardWarHand: require('Code/StripCity/Game/CardGame/TriCardWarHand').TriCardWarHand,
	BaccaratHand: require('Code/StripCity/Game/CardGame/BaccaratHand').BaccaratHand,
	Tutorial: require('Code/StripCity/Game/CardGame/Tutorial/Tutorial').Tutorial,
	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game'] || {}; $MODULE_REGISTRY['Code/StripCity/Game'] = exports; /**
 * @author will
 */
exports.Game = {
	SCGame: require('Code/StripCity/Game/SCGame').SCGame,
	Strip: require('Code/StripCity/Game/Strip').Strip,	
	Player: require('Code/StripCity/Game/Player').Player,
	IAP: require('Code/StripCity/Game/IAP').IAP,
	SCConstants: require('Code/StripCity/Game/SCConstants').SCConstants
};; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/SCGame'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/SCGame'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/SCGame'] = exports; /**
 * @author will
 */
var StripManager = require('Code/StripCity/Game/Strip/StripManager').StripManager;
var IAPManager = require('Code/StripCity/Game/IAP/IAPManager').IAPManager;
var Strip = require('Code/StripCity/Game/Strip/Strip').Strip;
var StripObject = require('Code/StripCity/Game/Strip/StripObject').StripObject;
var SceneController = require('Code/StripCity/Game/Scene/SceneController').SceneController;
var StripObjectTemplate = require('Code/StripCity/Game/Strip/StripObjectTemplate').StripObjectTemplate;
var AtlasMapLoader = require('Code/G6/Atlas/AtlasMapLoader').AtlasMapLoader;
var Settings = require('Code/StripCity/Game/Settings/Settings').Settings;
//var PlusManager = require('../Plus/PlusManager').PlusManager;
//var OpenSocialManager = required('../OpenSocial/OpenSocialManager').OpenSocialManager;

var MAX_BUILDINGS = 10;

//DEBUG_PARAMS
var FORCE_RECREATE = false;

exports.SCGame = Class.singleton({
    initialize: function(){
    
        NgLogD('+++++++ ....initializing SCGame.... ++++++++');
        //should only initialize once. ever.		            
        this.sceneController = new SceneController();
        
        
        AlertLayer.initializeLayer(GL2.Root, 0.8);
        
        var black = new BlackBackground();
        GL2.Root.addChild(black);
        NgLogD('+++++++ ..... finish initializing SCGame...... +++++++');
        
        
        this._stripManager = StripManager;
        this._stripManager.initialize();
        
        this._iapManager = IAPManager;
        this._iapManager.initialize();		
		
		this._settings = new Settings(true,true,false);

		this.plusLoggedIn = false;
		this.isNightTime = Util.isCurrentlyNightTime();
		//this.isNightTime = false;
		
		
    },
	
	finishedPlusLogin: function() {
		return this.plusLoggedIn;
	},
    
    initGame: function(){
    
		this.plusLoggedIn = true;
        this.reset();
        GL2.Root.addChild(this.sceneController.getNode());
		// Mobclix.startWithApplicationId('D26B01C3-5900-41E2-8049-6C57491545EA');
		
		// // Setup Mobclix
		// this.mobAd = new Mobclix.AdView_320x50();
		// this.mobAd.onFinishLoad = function(adView) { console.log("AdView finished load: ", adView); };
		// this.mobAd.onFailedToLoad = function(adView, code, error) { console.log("AdView failed to load: ", adView, code, error); };
		// var adViewFrame = this.mobAd.getFrame();
		// 
		// // adViewFrame[2] = Scale.droid.width(320);  removed.  Mobclix should handle sizing.  
		// // adViewFrame[3] = Scale.droid.height(50);
		// 
		// adViewFrame[0] = Scale.droid.width( Math.floor((UI.Window.getWidth() - adViewFrame[2]) / 2)) ;
		// adViewFrame[1] = Scale.droid.height(7);
		// this.mobAd.setFrame(adViewFrame);
		// // UI.Window.document.addChild(this.mobAd);
		// this.mobAd.resumeAdAutoRefresh();
		
		var screenSize = Util.screenSize(true);
		this._splash = new GL2.Sprite();
		this._splash.setImage('Content/ui_nonatlas_bgs/aas_logo.png', [screenSize.getWidth(), screenSize.getHeight()], [0,0]);
		GL2.Root.addChild(this._splash);
		
		//first load player data
        SCGame.loadData();

    },
	
	destroyGame: function() {
		this.sceneController.destroy();
	},
	
	showTitleScreen: function() {
		this._splash.destroy();
		this._splash = null;
		this.sceneController.showLoadingScene();
		
		 setTimeout(function(){
            SCGame.initialLoad();
        }, 25);
	},
    
    initialLoad: function(){
    
        NgLogD("INITIAL LOAD!!!!!!!!");
        
        AtlasMapLoader.loadMappings();
        NgLogD("INITIAL LOAD!!!!!!!!0.1");
		this.cacheImages();
        NgLogD("INITIAL LOAD!!!!!!!!0.2");
        this.sceneController.createLobbyScene();
        NgLogD("INITIAL LOAD!!!!!!!!0.3");
        this.sceneController.setLoadingScenePercentage(50);
        NgLogD("INITIAL LOAD!!!!!!!!0.4");
		
        setTimeout(function(){
	        NgLogD("INITIAL LOAD!!!!!!!!0.5");
            SCGame.initialLoad2();
        }, 25);		
		
        
    },
    
    initialLoad2: function(){
        NgLogD("INITIAL LOAD!!!!!!!!2");
    
        this.sceneController.setLoadingScenePercentage(75);
		
        this._iapManager.createMenu();
       
		this.sceneController.loadStripSceneForCaching(); // this is necessary to get have the strip scene cached
		//this.sceneController.setStripSceneVisibility(false);
	   
        setTimeout(function(){
            SCGame.initialLoad3();
        }, 25);
    },
    
    initialLoad3: function(){
        NgLogD("INITIAL LOAD!!!!!!!!3");
    
		//this.sceneController.setStripSceneVisibility(true);
	
		if (this.getPlayer().getLastPlayedBonus().toDateString() == new Date('1/1/1970').toDateString()) {
		  var genericAlign = new GenericAlertNode('The "Chips" and "Comp Points" used in this game are "virtual \ncurrency." They have NO "REAL-WORLD" VALUE and are NOT \nEXCHANGEABLE for "real-world" money. The selling, buying, \nexchanging or transferring of "Chips" and "Comp Points" outside \nof this game is strictly prohibited. Remaining and unused "Chips" \nand "Comp Points" cannot be withdrawn for "real-world" money. \nThe "Chips" and "Comp Points" used in this game are for \nentertainment purposes only.','IMPORTANT NOTE');
		  genericAlign.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
			AlertLayer.showAlertNode(genericAlign);
		}
	
        if (this.getPlayer().canPlayBonusGame()) {
			this.loadBonusGame(this.sceneController.strip);
		}
		else {
			this.returnToLobby(this.sceneController.strip);
		}
        
        this.sceneController.hideLoadingScene();

		IAPManager.checkPending();
		NgLogD("INITIAL LOAD!!!!!!!!DONE");
        
    },
    
    loadData: function(){
        //first loads player data and provides callback
        Storage.KeyValueCache.local.getItem(this.getPlayerDataKey(), function(err, playa){
            if (playa && !FORCE_RECREATE) {
                NgLogD('found existing player...' + JSON.stringify(playa));
                SCGame.loadPlayerDataForUser(playa);
            }
            else {
                NgLogD('Could not find player for user... creating new..');
                SCGame.loadPlayerDataForUser(null);
            }
        });
    },
    
    postLoadData: function(){
        this._playerUpdateEmitter = new Core.MessageEmitter();
        this._stripUpdateEmitter = new Core.MessageEmitter();
        
		this._settings.setBackgroundMusicOn(this._player.getBackgroundMusicOn());
		this._settings.setSoundEffectsOn(this._player.getSoundEffectsOn());
		this._settings.setJapaneseOn(this._player.getJapaneseOn());
		this._scaudio = new SCAudio.SCAudio();
		Audio.Music.setPath('Content/bgm/bgm_casino_ambience.mp3');
		this._scaudio.playbackgroundmusic(6);
		if (this._player.getJapaneseOn())		    
			 Core.Localization.setLanguage('jp');

		
		//Need to initialize Audio.Music to some path else the hardware back button will break
		//moved
		setTimeout(function(){
			SCGame.showTitleScreen();
        }, 3000);        
 
    },
	
	cacheImages: function() {
		var blank;	
		var mapFileInfos = AtlasMap.getAllMapFileInfos();
		for (var i in mapFileInfos) {
			
			var info = mapFileInfos[i];
			if (info.getFilePath() == 'Content/obj_atlas_bldg_day1.png' && SCGame.isNightTime) continue;
			if (info.getFilePath() == 'Content/obj_atlas_bldg_day2.png' && SCGame.isNightTime) continue;
			if (info.getFilePath() == 'Content/obj_atlas_bldg_day3.png' && SCGame.isNightTime) continue;
			if (info.getFilePath() == 'Content/obj_atlas_bldg_day4.png' && SCGame.isNightTime) continue;
			if (info.getFilePath() == 'Content/obj_atlas_bldg_night1.png' && !SCGame.isNightTime) continue;
			if (info.getFilePath() == 'Content/obj_atlas_bldg_night2.png' && !SCGame.isNightTime) continue;
			if (info.getFilePath() == 'Content/obj_atlas_bldg_night3.png' && !SCGame.isNightTime) continue;
			if (info.getFilePath() == 'Content/obj_atlas_bldg_night4.png' && !SCGame.isNightTime) continue;
			
			blank = Util.generateBlankSprite(info.getFilePath());
			GL2.Root.addChild(blank);
		}
			
		blank = Util.generateBlankSprite('Content/ui_nonatlas_menus/common-play-bg.png');
		GL2.Root.addChild(blank);

			
	},
    
    quickSavePlayer: function(){
        //NgLogD('quick save player = ' + JSON.stringify(this._player.getData()));
        Storage.KeyValueCache.local.setItem(this.getPlayerDataKey(), JSON.stringify(this._player.getData()));
    },
    
    quickSaveStrip: function(){
        NgLogI('quick save strip = ' + JSON.stringify(this._strip.getData()));		
        Storage.KeyValueCache.local.setItem(this.getStripDataKey(), JSON.stringify(this._strip.getData()));
    },
	
    quickSaveTutorialHistory: function(){
		NgLogD('quick saving ' + this.getTutorialHistoryDataKey()  + ' with: ' + JSON.stringify(this._player.getTutorialHistory().getData()));
        Storage.KeyValueCache.local.setItem(this.getTutorialHistoryDataKey(), JSON.stringify(this._player.getTutorialHistory().getData()));
    },	
    
    getPlayerDataKey: function(){

//        var plusUser = PlusManager.getUser();
//        var playerKey = "com.astroapestudios.stripcity.user." + plusUser.recordID + ".player";
//        var playerKey = "com.astroapestudios.stripcity.user." + 1234 + ".player";
		  var playerKey = "com.astroapestudios.stripcity.user." + OpenSocialManager.getUser().id + ".player";
		NgLogD('Plus Player Data Key = ' + playerKey);        
		return playerKey;
    },
    
    getStripDataKey: function(){
//        var plusUser = PlusManager.getUser();
//        var stripKey = "com.astroapestudios.stripcity.user." + plusUser.recordID + ".strip";
//        var stripKey = "com.astroapestudios.stripcity.user." + 1234 + ".strip";
		var stripKey = "com.astroapestudios.stripcity.user." +  OpenSocialManager.getUser().id + ".strip";
		NgLogD('Strip  Data Key = ' + stripKey);         
		return stripKey;
    },
	
	
    getTutorialHistoryDataKey: function(){
//        var plusUser = PlusManager.getUser();
//        var thKey = "com.astroapestudios.stripcity.user." + plusUser.recordID + ".tutorialhistory";
//		var openSocialUser = OpenSocialManager.getUser();
//        var thKey = "com.astroapestudios.stripcity.user." + 1234 + ".tutorialhistory";
		var thKey = "com.astroapestudios.stripcity.user." +  OpenSocialManager.getUser().id + ".tutorialhistory";
		NgLogD('Tutorial History  Data Key = ' + thKey);         
		return thKey;
    },	
    
    loadPlayerDataForUser: function(playa){
        if (!playa) {
            this.createNewPlayerForUser();
            return;
        }
        else {
            this.initPlayer(playa);
            
        }
        
        //after finish loading player data, tutorial history data...
        Storage.KeyValueCache.local.getItem(this.getTutorialHistoryDataKey(), function(err, th){
            if (th && !FORCE_RECREATE) {
                NgLogD('found existing tutorial history...' + JSON.stringify(th));
                SCGame.loadTutorialHistoryDataForUser(th);
            }
            else {
                NgLogD('Could not find tutorial history for user... creating new..');
                SCGame.loadTutorialHistoryDataForUser(null);
            }
        });	
        
    },
	
    loadTutorialHistoryDataForUser: function(th){
        if (!th) {
            this.createNewTutorialHistoryForUser();
            return;
        }
        else {
			this.initTutorialHistory(th);
        }
        
        //after finish loading player data, load strip data...
        Storage.KeyValueCache.local.getItem(this.getStripDataKey(), function(err, strip){
            if (strip && !FORCE_RECREATE) {
                NgLogD('found existing strip...' + JSON.stringify(strip));
                SCGame.loadStripDataForUser(strip);
            }
            else {
                NgLogD('Could not find strip for user... creating new..');
                SCGame.loadStripDataForUser(null);
            }
        });
        
        
    },		
    
	getNumberStripNodes: function() {
		
		return this._strip.getPlotMap().length;
	},
	
	hasStripReachedStripObjectTemplateLimit: function(template) {
			
		var plotMap = this._strip.getPlotMap();
		
		for (var i in plotMap) {
			var so = plotMap[i];
			
			if (so.getTemplateID() == template.getId()) {
				
				var mod = template.getMod();
				if (mod) 
					return true;
				else 
					return false;
			}
		}
		
		return false;
	},
	
    loadStripDataForUser: function(strip){
        if (!strip) {
            this.createNewStripForUser();
            return;
        }
        else {
            this.initStrip(strip);
            
        }
        
        //after loading strip data
        this.postLoadData();
    },
    
    
    createNewPlayerForUser: function(){
        //current player.
        var newPlayer = new Player();
        newPlayer.setChips(500);
        newPlayer.setComps(0);
        newPlayer.setExp(0);
        newPlayer.setBettingTier(1);

        NgLogD('new player = ' + JSON.stringify(newPlayer.getData()));
        var dataString = JSON.stringify(newPlayer.getData());
        Storage.KeyValueCache.local.setItem(this.getPlayerDataKey(), dataString, function(){
            SCGame.loadPlayerDataForUser(dataString);
        });
        
        
    },
	
	createNewTutorialHistoryForUser: function() {
		
        var newTh = new TutorialHistory();


        var dataString = JSON.stringify(newTh.getData());
        NgLogD('new tutorialHistory = ' + dataString);		
        Storage.KeyValueCache.local.setItem(this.getTutorialHistoryDataKey(), dataString, function(){
            SCGame.loadTutorialHistoryDataForUser(dataString);
        });		
	},
    
    createNewStripForUser: function(){
        //current player.
        var newStrip = new Strip(MAX_BUILDINGS);
        
        //todo: edit real starting strips
        var obj1 = new StripObject(1);
        obj1.resetNextCollectTime();
        
//        var obj2 = new StripObject(2);
//        obj2.resetNextCollectTime();
        
        newStrip.addStripObject(obj1);
//        newStrip.addStripObject(obj2);
        
        var dataString = JSON.stringify(newStrip.getData());
        NgLogD('strip data = ' + dataString);
        
        Storage.KeyValueCache.local.setItem(this.getStripDataKey(), dataString, function(){
            SCGame.loadStripDataForUser(dataString);
        });
        
        
    },
    
    getPlayer: function(){
        return this._player;
    },
    
    getPlayerUpdateEmitter: function(){
        return this._playerUpdateEmitter;
    },
    
    getStripUpdateEmitter: function(){
        return this._stripUpdateEmitter;
    },
    
    updatePlayer: function(statType, amt, emit){
    
        var newAmount = 0;
        switch (statType) {
            case Player.StatType.Chips:
                this._player.addChips(amt);
                newAmount = this._player.getChips();
                break;
            case Player.StatType.Comp:
                this._player.addComps(amt);
                newAmount = this._player.getComps();
                break;
            case Player.StatType.Experience:
                var oldLevel = this._player.getLevel();
                this._player.addExp(amt);
                newAmount = this._player.getExp();
                var newLevel = this._player.getLevel();
                
                if (newLevel != oldLevel) {
                
                    AlertLayer.showAlertNode(new GenericAlertNode('Congratulations!  You\'re now at Level ' + newLevel + '.  \n\nRemember to visit The Bank \nto purchase Chips, Comps and unlock Higher Limits!!', 'CONGRATULATIONS'));
                    if (emit) 
                        this._playerUpdateEmitter.emit(Player.StatType.Level, newLevel);
                }
                break;
        }
        
        if (emit) {
            this._playerUpdateEmitter.emit(statType, newAmount);
        }
    },
    
    initPlayer: function(playerJSON){
        NgLogD('initting player...' + playerJSON);
        var playerData = JSON.parse(playerJSON);
        this._player = new Player(playerData);
    },
    
    initStrip: function(stripJSON){
        NgLogD('initializing strip....' + stripJSON)
        var stripData = JSON.parse(stripJSON);
        this._strip = new Strip(MAX_BUILDINGS, stripData);
        
    },
	
    initTutorialHistory: function(thJSON){
        NgLogD('initializing tutorial history....' + thJSON)
        var data = JSON.parse(thJSON);
        var th = new TutorialHistory(data);
		this._player.setTutorialHistory(th);
		
    },	
    
    getStrip: function(){
        return this._strip;
    },
    
    loadStrip: function(child){
		if (!this.sceneController.isSwappingScenes) {
			OpenSocialManager.showCommunityButton();
			this.sceneController.loadStripScene(child);
			SCGame.getSCAudio().playbackgroundmusic(5);
			// UI.Window.document.removeChild(this.mobAd);
			this.quickSavePlayer();
		}
    },
    
    returnToLobby: function(game){
		if (!this.sceneController.isSwappingScenes) {
			OpenSocialManager.showCommunityButton();
			this.sceneController.returnToLobby(game);
			// UI.Window.document.removeChild(this.mobAd);
			
			if (this.getPlayer().availableChips() < 50) {
				SCGame.updatePlayer(this.getPlayer().StatType.Chips, 500-this.getPlayer().availableChips(), true);
				AlertLayer.showAlertNode(new GenericAlertNode('You\'re out of Chips, but the Casino Manager\nhas comp\'d you some extra cash.\nFor a real stack of chips, make sure to hit The Bank!','ON THE HOUSE'));
			}			
			
			this.quickSavePlayer();
		}
    },
    
   removeAd: function(){
    	// UI.Window.document.removeChild(this.mobAd);
   
	},
   
   showAd: function(){
 			//       if (this.mobAd.getParent() == null) {
 			// UI.Window.document.addChild(this.mobAd);
 			// 
 			//        }
 			//        
   },
    
    loadBlackJack: function(){
		if (!this.sceneController.isSwappingScenes) {
			OpenSocialManager.hideCommunityButton();
			SCGame.getSCAudio().playbackgroundmusic(4);
			this.sceneController.loadBlackJackScene();
		// UI.Window.document.addChild(this.mobAd);
		}
    },
    
    loadBaccarat: function(){
		if (!this.sceneController.isSwappingScenes) {
			OpenSocialManager.hideCommunityButton();			
			SCGame.getSCAudio().playbackgroundmusic(4);
			this.sceneController.loadBaccaratScene();
			// UI.Window.document.addChild(this.mobAd);
		}
    },
    
    loadTriCardWar: function(){
		if (!this.sceneController.isSwappingScenes) {
			OpenSocialManager.hideCommunityButton();			
			SCGame.getSCAudio().playbackgroundmusic(4);
			
			this.sceneController.loadTriCardWarScene();
			// UI.Window.document.addChild(this.mobAd);
		}
    },
    
    loadBonusGame: function(child){
		if (!this.sceneController.isSwappingScenes) {
			OpenSocialManager.hideCommunityButton();			
			this.sceneController.loadBonusGameScene(child);
		}
    },
    
    
    //handling scene events
    handleSellStripObject: function(so, confirmed){
        if (so == null) 
            return;
        if (so.isSold()) 
            return;
        if (typeof confirmed == 'undefined') 
            confirmed = false;
        
        if (this._strip.getNumActiveStripObjects() <= 1) 
            return;
        //todo: confirmation
        
        this._strip.removeStripObject(so);
        so.setSold(true);
	
		this.updatePlayer(Player.StatType.Chips, so.getSellAmount(), true);
        
        this._stripUpdateEmitter.emit(this._strip.getPlotMap(), true);
        this.quickSaveStrip();
		this.quickSavePlayer();
    },
    
    handleBuyStripObject: function(template, buildRight, confirmed){
        if (template == null) 
            return;
        if (template.getType() == StripObjectTemplate.Type.Empty) 
            return;
        if (typeof confirmed == 'undefined') 
            confirmed = false;
        
        var chipCost = template.getCost();
        var compCost = template.getCompCost();
        var costChips = chipCost > 0;
        var costComps = compCost > 0;
        var playerChips = this._player.getChips();
        var playerComps = this._player.getComps();
        
        if (costChips && playerChips < chipCost) 
            return;
        if (costComps && playerComps < compCost) 
            return;
        
        //todo: confirmation
        //create new 
        var so = new StripObject(template.getId());
        so.resetNextCollectTime();
        
        var right = buildRight;
        this._strip.addStripObject(so, right);
        
        if (costChips) 
            this.updatePlayer(Player.StatType.Chips, -chipCost, true);
        if (costComps) 
            this.updatePlayer(Player.StatType.Comp, -compCost, true);
        
        this._stripUpdateEmitter.emit(this._strip.getPlotMap(), true);
        this.quickSaveStrip();
        this.quickSavePlayer();		
        //		var mods = this._strip.getMods();
        //		NgLogD('MODSSSSSS*****');
        //		for (var i in mods ) {
        //			var mod = mods[i]
        //			NgLogD(mod.getDescription());
        //		}
    },
    
    
    handleCollectStripObject: function(so, confirmed){
        if (so == null) 
            return;
        if (typeof confirmed == 'undefined') 
            confirmed = false;
        
        //todo: confirmation
        //create new 
        so.resetNextCollectTime();
        
        this.updatePlayer(Player.StatType.Chips, so.getIncome(), true);
        this.quickSaveStrip();
		this.quickSavePlayer();
        
    },
    
    handleMoveStripObject: function(so, plotID){
        if (so == null) 
            return;
        
        this._strip.moveStripObject(so, plotID);
        this._stripUpdateEmitter.emit(this._strip.getPlotMap(), true);
        this.quickSaveStrip();
        
    },
    
    getSettings: function(){
        return this._settings;
    },
    
    loadSettingsPage: function(){
		OpenSocialManager.showCommunityButton();
        this.sceneController.loadSettingsScene();
    	// UI.Window.document.removeChild(this.mobAd);
	
	},
    
    getSCAudio: function(){
        return this._scaudio;
    },
    
    logout: function(){
        NgLogD('LOGGED OUT!');
        this.loginPlus(true);
    },
    
    loginPlus: function(forceLogin){
		
		
        PlusManager.attemptPlusLogin(function(user){
        
            NgLogD('************ PLUS LOGGED IN USER: *************** ' + user.gamertag);
            
            //        var listener = new MessageListenerReq.MessageListener();
            //        user.addListener(listener, function(){
            //            NgLogD("Quack!");
            //        });
            //        
            //        session.addListener(listener, function(params){
            //            NgLogD("Session emitted " + JSON.stringify(params));
            //        });
            //        
            //        user.gamerscore += 20;
            //        
            //        testLeaderboards(session);
            //        testUserData(session);
            //        
            //        homeScreen.initialize();
            //        UI.NavController.getInstance().forwardToView(homeScreen.getMainContainer());
            
            
            NgLogD('orientation... change.')
            NgApplication.getInstance().setOrientation(NgApplicationOrientation.Portrait);
            NgApplication.getInstance().setOrientation(NgApplicationOrientation.LandscapeRight);
            //initialize the singleton.
            PlusManager.cleanUpLoginViewController();
            
            Game.SCGame.initGame();
            
            var t = new UI.Toast();
            t.setText("Welcome back " + user.gamertag + "!");
            t.show();
        }, forceLogin);
    },
    
    testWithoutPlus: function(){
        NgApplication.getInstance().setOrientation(NgApplicationOrientation.Portrait);
        NgApplication.getInstance().setOrientation(NgApplicationOrientation.LandscapeRight);
        //initialize the singleton.
        //PlusManager.cleanUpLoginViewController();
        
        Game.SCGame.initGame();
        
        var t = new UI.Toast();
    //    t.setText("Welcome back " + user.gamertag + "!");
        t.setText("Welcome back " + 1234 + "!");
        t.show();
    },
	
	startGame: function(){
        NgApplication.getInstance().setOrientation(NgApplicationOrientation.Portrait);
        NgApplication.getInstance().setOrientation(NgApplicationOrientation.LandscapeRight);
		NgLogD('Starting game!');



        Game.SCGame.initGame();
		var t = new UI.Toast();
		var welcome = new GL2.Text();
		welcome.setText('Welcome back ');
		
		t.setText(welcome.getText() +" " + OpenSocialManager.getUser().nickname+ "!");
		t.show();

    },
    
    reset: function(){
        this.sceneController.reset();
        //todo: clean up all old data.
    },
	
	raiseLimit: function(iap, iapBlock) {
		var compCost = iap._compCost;
		if (this.getPlayer().getComps() >= compCost) {
			this.updatePlayer(Player.StatType.Comp, -compCost, true);
			this.getPlayer().setTier(this.getPlayer().getTier() + 1);
			this.quickSavePlayer();
			AlertLayer.showAlertNode(new GenericAlertNode('Your table limit has increased!'),'LIMITS INCREASED');
			iapBlock.setEnabled(false);
			iapBlock._buyText.setText('PURCHASED');
			
			//increase the bet in game if purchased within game
			if (this.sceneController.gamePlaying) {
				if (typeof this.sceneController.gamePlaying.changeMaxBetDisplay != 'undefined') {
					this.sceneController.gamePlaying.changeMaxBetDisplay();
				}
			}
		} else {
			AlertLayer.showAlertNode(new GenericAlertNode('Not enough comps!','NOT ENOUGH COMPS'));
		}
	},

	handleLifecycleEvent: function(event) {
		
		switch (event) {
			
			case Device.LifecycleEmitter.Event.Resume:
//				var title = 'PLEASE RESTART';
//				var text = 'To continue playing please exit and restart Vegas: Strip City';
//				var dismissCB = function() {
//					 var LGL = require('../../../NGCore/Client/Core/LocalGameList').LocalGameList;
//					 LGL.runUpdatedGame('/Samples/Launcher');
//					 return;
//				}
//				AlertLayer.showAlertNode(new GenericAlertNode(text, title, dismissCB));
				break;
			case Device.LifecycleEmitter.Event.Suspend:
				break;
			case Device.LifecycleEmitter.Event.Terminate:
				
				break;
		}
	},

});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio'] = exports; /**
 * <p>Classes and objects contained by the Audio module.</p>
 * @name Audio
 * @namespace 
 * @description <p>The Audio module is a collection of classes that support manipulation of audio effects in an application. 
 * Each class handles a specific aspect of the module implementation and contains APIs that support the class:</p>
 *<ul>
 *<li><code>{@link Audio.ActiveEffect}</code>: Construct objects for controlling the reproduction of <code>Effect</code> objects.</li>
 *<li><code>{@link Audio.Device}</code>: A singleton object that controls device sound effects volume.</li>
 *<li><code>{@link Audio.Effect}</code>: Construct objects that load sound resources into memory.</li>
 *<li><code>{@link Audio.Music}</code>: A singleton object that controls the reproduction of application background music.</li>
 *</ul>
 */
exports.Audio =
{
	ActiveEffect: require('NGCore/Client/Audio/ActiveEffect').ActiveEffect,
	Effect: require('NGCore/Client/Audio/Effect').Effect,
	Device: require('NGCore/Client/Audio/Device').Device,
	Music: require('NGCore/Client/Audio/Music').Music,
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/SCAudio'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/SCAudio'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/SCAudio'] = exports; exports.SCAudio = {
   
	SCAudio: require('Code/StripCity/Game/SCAudio/SCAudio').SCAudio,
	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Player/Player'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Player/Player'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Player/Player'] = exports; var ExperienceManager = require('Code/StripCity/Game/Player/ExperienceManager').ExperienceManager;
var TutorialHistory = require('Code/StripCity/Game/Player/TutorialHistory').TutorialHistory;

exports.Player = Core.Class.subclass({
    classname: 'Player',
    
    StatType: {
        /** Isometric. */
        Chips: 0,
        Comps: 1,
        Experience: 2,
        Level: 3,
    },
    
    initialize: function(data){
        if (typeof data == 'undefined') 
            data = null;
        
        if (!data) {
            this.chips = 0;
            this.comps = 0;
            this.exp = 0;
            this.level = 1;
            this.tier = 1;
            this.multiplier = 1;
			this.lastplayedbonus = new Date('1/1/1970');
			this.canplaybonusgame = true;
			this.backgroundmusicon = true;
			this.soundeffectson = true;
			this.japaneseon = false;
			this.tutorialHistory = new TutorialHistory();
        } else {
            this.chips = data.chips;
            this.comps = data.comps;
            this.setExp(data.exp);
			//level should be calculated based on exp
            this.tier = data.tier;
			//remove multipler from player class
			if (typeof data.multiplier == 'undefined') {
				data.multiplier = 0;
			}
			
			this.tutorialHistory = new TutorialHistory();			
            this.multiplier = data.multiplier;

			if (typeof data.backgroundmusicon == 'undefined'){
				data.backgroundmusicon = true;
			} else if (typeof data.backgroundmusicon == 'string'){
				data.backgroundmusicon = new Bool(data.backgroundmusicon);
			}

			this.backgroundmusicon = data.backgroundmusicon;
			

			if (typeof data.soundeffectson == 'undefined')
			{
				data.soundeffectson = true;
			}else if (typeof data.soundeffectson == 'string'){
				data.soundeffectson = new Bool(data.soundeffectson);
			} 
			this.soundeffectson = data.soundeffectson;

			if (typeof data.japaneseon == 'undefined')
			{
				data.japaneseon = false;
			}else if (typeof data.japaneseon == 'string'){
				data.japaneseon = new Bool(data.japaneseon);
			} 
			this.japaneseon = data.japaneseon;
			
			if (typeof data.lastplayedbonus == 'undefined') {
				data.lastplayedbonus = new Date('1/1/1970');
			} else if (typeof data.lastplayedbonus == 'string'){
				data.lastplayedbonus = new Date(data.lastplayedbonus);
			}
			this.lastplayedbonus = data.lastplayedbonus;
			
			//decide if player can play bonus
			var dnow = new Date();
			var today = new Date((dnow.getMonth()+1) +'/'+dnow.getDate()+'/'+dnow.getFullYear());

				
			//stacks multiplier for consecutive days
			var daysbetween = this.days_between(this.lastplayedbonus, today);

			if (daysbetween == 1) {
				this.canplaybonusgame = true;
				this.multiplier += 1;
				if (this.multiplier > 5) 
					this.multiplier = 5;
			}
			else 
				if (daysbetween > 1) {
					this.canplaybonusgame = true;
					this.multiplier = 1;
				}
				else {
					this.canplaybonusgame = false;
				}
			
		}
        
    },
    
    addChips: function(amt){
        this.chips += amt;
        NgLogD('chips add: ' + amt);
    },
    
    getChips: function(){
        return this.chips;
    },
    
    getComps: function(){
        return this.comps;
    },
    
    setComps: function(t){
        this.comps = t;
    },
    
    getTier: function(){
        return this.tier;
    },
    
    setTier: function(t){
        this.tier = t;
    },
    
	getTutorialHistory: function() {
		return this.tutorialHistory;
	},
	
	setTutorialHistory: function(t) {
		this.tutorialHistory = t;
	},
	 
    addComps: function(amt){
        this.comps += amt;
    },
    
    setLevel: function(s){
        this.level = s;
        
    },
    
    getLevel: function(){
        return this.level;
    },
    
    getBettingTier: function(){
        return this.tier;
    },
    
    setBettingTier: function(tier){
        this.tier = tier;
    },
    
    getExp: function(){
        return this.exp;
    },
    
	getNextLevelExpRequired: function() {
		
		return ExperienceManager.getExpForLevel(this.getLevel()+1);
	},
	
    setExp: function(amt){
        this.exp = amt;
		ExperienceManager.updatePlayerByExperience(this);
    },
    
    addExp: function(amt){
        this.exp += amt;
        ExperienceManager.updatePlayerByExperience(this);
    },
    
    subtractChips: function(amt){
        this.chips -= amt;
        NgLogD('chips minus: ' + amt);
    },
    
    availableChips: function(){
        return parseInt(this.chips);
        
    },
	availableChipsDollarFormat: function(){
        return Util.dollarFormat(parseInt(this.chips));
        
    },
    
    setChips: function(amt){
        this.chips = amt;
    },
    
    getMultiplier: function(){
        return this.multiplier;
    },
    canPlayBonusGame: function(){
        return this.canplaybonusgame;
    },
	getLastPlayedBonus:function(){
		return this.lastplayedbonus;
	},
  	setLastPlayedBonus:function(d){
		if (typeof d == 'undefined') {
			this.lastplayedbonus = new Date('1/1/1970');
		} else if (typeof d == 'string'){
			data.lastplayedbonus = new Date(d);
		}
		this.lastplayedbonus = d;
	},  
    showTotal: function(chipsTxt){
        chipsTxt.setText(this.chips);
        NgLogD('chips total: ' + this.chips)
    },
	
	getData: function() {
		var data = new Object();
		data.chips = this.chips;
		data.exp = this.exp;
		data.comps = this.comps;
		data.tier = this.tier;
		data.multiplier = this.multiplier;
		data.lastplayedbonus = this.lastplayedbonus;
		data.soundeffectson = SCGame.getSettings().getSoundEffectsOn();
		data.backgroundmusicon = SCGame.getSettings().getBackgroundMusicOn();
		data.japaneseon = SCGame.getSettings().getJapaneseOn();
		return data;
	},
	
	days_between: function (date1, date2) {

    var ONE_DAY = 60 * 60 * 24 * 1000;

    // Convert both dates to milliseconds
    var date1_ms = date1.getTime();
    var date2_ms = date2.getTime();

    // Calculate the difference in milliseconds
    var difference_ms = Math.abs(date1_ms - date2_ms);
    
    // Convert back to days and return
    return Math.round(difference_ms/ONE_DAY);

	},
	
	getBackgroundMusicOn: function()
	{
		return this.backgroundmusicon;
	},
	getSoundEffectsOn: function()
	{
		return this.soundeffectson;
	},
	getJapaneseOn: function()
	{
		return this.japaneseon;
	},

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Player/TutorialHistory'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Player/TutorialHistory'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Player/TutorialHistory'] = exports; exports.TutorialHistory = Core.Class.subclass({
    classname: 'TutorialHistory',
    
    
    initialize: function(data){
        if (typeof data == 'undefined') 
            data = null;
        
        if (!data) {
			this.bacTutorial = false;
			this.triTutorial = false;
			this.blackJackTutorial = false;
			this.stripTutorial = false;
        } else {
			this.bacTutorial = data.bacTutorial;
			this.triTutorial = data.triTutorial;
			this.blackJackTutorial = data.blackJackTutorial;
			this.stripTutorial = data.stripTutorial;
		}
        
    },
    	
	getData: function() {
		var data = new Object();
		data.bacTutorial = this.bacTutorial;
		data.triTutorial = this.triTutorial;
		data.blackJackTutorial = this.blackJackTutorial;
		data.stripTutorial = this.stripTutorial;
		return data;
	},
	
	finishedBacTutorial: function() {
		return this.bacTutorial;	
	},
	
	finishedTriCardWarTutorial: function() {
		return this.triTutorial;
	},
	
	finishedBlackJackTutorial: function() {
		return this.blackJackTutorial;
	},
	
	finishedStripTutorial: function() {
		return this.stripTutorial;
	},
	
	setBacTutorial: function(t) {
		this.bacTutorial = t;
	},
	
	setTriCardWarTutorial: function(t) {
		this.triTutorial = t;
	},
	
	setBlackJackTutorial: function(t) {
		this.blackJackTutorial = t;
	},	
	
	setStripTutorial: function(t) {
		this.stripTutorial = t;
	},	
	
	
	

	

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Common/PlayerStatNode'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Common/PlayerStatNode'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Common/PlayerStatNode'] = exports; exports.PlayerStatNode = Node.subclass({

    classname: 'PlayerStatNode',
    
    initialize: function(statType, player){
    
        if (typeof initialValue == 'undefined') 
            initialValue = 0;
        this._statType = statType;
        
        this._statText = new GL2.Text();
		this._statText.setFontFamily('DroidSans-Regular');
		this._statText.setFontSize(32);
        this._statText.setDepth(1);
        this._statText.setAnchor(0, 0.5);
        this._statText.setPosition(0, 0);
		
		SCStyle.applyFontStyle(this._statText, SCStyle.FontStyle.SansB18);   		
		this._player = player;
        //this._currentValue = initialValue;
        
        //this.setTextValue(this._currentValue);
		this.updateTextValue();
        
        this._updateListener = new this.StatUpdateListener(this);
        
        //this.addChild(this._frame);
        this.addChild(this._statText);
        
    },
    
	getTextObject: function() {
		return this._statText;
	},
	
    getStatType: function(){
        return this._statType;
    },
    
	updateTextValue: function() {
		
		switch (this._statType) {
			case Game.Player.Player.StatType.Chips:
				this._currentValue = this._player.getChips();
				break;
			case Game.Player.Player.StatType.Comp:
				this._currentValue = this._player.getComps();
				break;
			case Game.Player.Player.StatType.Experience:
				this._currentValue = this._player.getExp();
				break;
			case Game.Player.Player.StatType.Level:
				this._currentValue = this._player.getLevel();
				break;
		}
		
		var text;
		var value = this._currentValue;
		switch (this._statType) {
			case Game.Player.Player.StatType.Level:
				text = 'Level ' + value;
				//text = Util.numberFormat(4545433);
				break;
			case Game.Player.Player.StatType.Experience:
				text = Util.numberFormat(value) + '/' + Util.numberFormat(this._player.getNextLevelExpRequired());
				if (this._player.getNextLevelExpRequired() >= 1000000) //lower font size if exp greater than 1 mil
					SCStyle.applyFontStyle(this._statText, SCStyle.FontStyle.Sans12);
				break;
			default:
				text = Util.numberFormat(Math.floor(value));
				break;	
		}
		
		this._statText.setText(text);
	},
	
//    setTextValue: function(value){
//        this._currentValue = value;
//        
//		var text;
//        switch (this._statType) {
//			case Game.Player.Player.StatType.Level:
//				text = 'Level ' + value;
//				break;
//            default:
//				text = Util.numberFormat(Math.floor(value));
//                break;
//        }
//		
//		this._statText.setText(text);
//    },
    
    getCurrentValue: function(t){
        return this._currentValue;
    },
    
    getUpdateListener: function(){
        return this._updateListener;
    },
    
    attachUpdateListener: function(emitter){
        emitter.addListener(this._updateListener, this._updateListener.onUpdate);
    },
    
    destroy: function($super){
        $super();
    },
    
    
    
    $StatUpdateListener: Core.MessageListener.subclass({
    
        classname: 'StatUpdateListener',
        
        initialize: function(statNode){
            this._statNode = statNode;
        },
        
        onUpdate: function(statType, value){
            if (statType != this._statNode.getStatType()) return;
			
            if (this._statNode.getCurrentValue() == value) return;
            
			this._statNode.updateTextValue();
            //this._statNode.setTextValue(value);
        }
    }),

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Menu'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Menu'] || {}; $MODULE_REGISTRY['Code/G6/Menu'] = exports; exports.Menu = {
    Menu: require('Code/G6/Menu/Menu').Menu,
    AnimationFrameMenuItem: require('Code/G6/Menu/AnimationFrameMenuItem').AnimationFrameMenuItem,
	RadioButton: require('Code/G6/Menu/RadioButton').RadioButton,
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Background/BlackBackground'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Background/BlackBackground'] || {}; $MODULE_REGISTRY['Code/G6/Background/BlackBackground'] = exports; 
/**
 * @author will
 */
exports.BlackBackground = Node.subclass({
    classname: 'BlackBackground',
    
    initialize: function(){
        var black = new GL2.Sprite();
        var a = new GL2.Animation();
        a.pushFrame(new GL2.Animation.Frame('Content/G6/black.png', 0, [1, 1], [0, 0]));
		black.setDepth(-2);
        black.setAnimation(a);
		a.setBlendEnabled(false);

		if (Core.Capabilities.getScreenWidth() > Core.Capabilities.getScreenHeight()) {
			black.setScale(Core.Capabilities.getScreenWidth(), Core.Capabilities.getScreenWidth());
		}else {
			black.setScale(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenHeight());
		}
		

		
		this.setChildrenDepthGrouped(false);
		
		this.addChild(black);
    }
    
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Alert/AlertLayer'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Alert/AlertLayer'] || {}; $MODULE_REGISTRY['Code/G6/Alert/AlertLayer'] = exports; 
/**
 * @author will
 */
exports.AlertLayer = Class.singleton({
    classname: 'AlertLayer',
    
    initializeLayer: function( root, alpha ){
		
		this._root = root;
		
        this._black = new GL2.Sprite();
        var a = new GL2.Animation();
        a.pushFrame(new GL2.Animation.Frame('Content/G6/black.png', 0, [1, 1], [0, 0]));
        this._black.setAnimation(a);
        //this._black.setScale(Core.Capabilities.getScreenWidth(), Core.Capabilities.getScreenHeight());
		this._black.setScale(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenWidth());
		this._black.setAlpha(alpha);
		this._black.setDepth(100);
		
		var bleedblocker = SCStyle.createBleedBlocker();
		bleedblocker.setDepth(-10);
		
		this._consumingTouchHandler = new this.AlertLayerTouchHandler();
		this._consumingTouchTarget = new GL2.TouchTarget();
		this._consumingTouchTarget.getTouchEmitter().addListener(this._consumingTouchHandler, this._consumingTouchHandler.onTouch);
		this._consumingTouchTarget.setSize(Util.screenSize(true).clone());
		this._consumingTouchTarget.setAnchor(new Core.Point(0,0));
		this._consumingTouchTarget.setDepth(100);
		
		this._black.addChild(bleedblocker);
		
		this._alertQueue = [];
		
		this._dismissing = false;
    },
    
	showAlertNode: function(node) {
		var repeat = false;
		if (this._node != null && node != null) {
			if (this._node.getTitleText() == node.getTitleText()) 
				repeat = true;
		}
		
		if (!repeat) {
			for (x = 0; x < this._alertQueue.length; x++) {
				if (this._alertQueue[x].getTitleText() == node.getTitleText()) {
					repeat = true;
				}
			}
		}
		
		if (repeat) this._dismissing = true;
		
		if (this._node != null && this._node.getParent() != null) {
			
			if (!this._dismissing)
			{
				this.queueAlertNode(this._node);
			}
				
			if (this._node.onAlertDismiss)
				this._node.onAlertDismiss();
		}
		
		this._dismissing = false;
		
		if (this._node != null && this._node.getParent() != null) {
			
			this._root.removeChild(this._node);
			//this._node.destroy();
		}
		this._node = null;
		
		if (this._black.getParent() == null) {
			this._root.addChild(this._black);
			this._root.addChild(this._consumingTouchTarget);
		}
		
		var screensize = Util.screenSize(true).clone();
		
		var winWidth = screensize.getWidth();
		var winHeight = screensize.getHeight();
		
		this._node = node;
		this._node.setDepth(this._consumingTouchTarget.getDepth() + 1);
		this._node.setPosition(winWidth / 2, winHeight / 2);
		this._root.addChild(this._node);
		
		var node = this._node;		
		this._node.runSequence(0.1, function() { node.scaleTo(1.5, 0.1); }, 0.1, function() { node.scaleTo(1,0.1); });
		
		if (this._node.onAlertShow)
			this._node.onAlertShow();
			

	},
	
	queueAlertNode: function(node) {
		
		if (this._node == null || this._dismissing)
			this.showAlertNode(node);
		else
			this._alertQueue.push(node);
	},
	
	dismiss: function() {
		
		if (this._node != null) {
			
		}
		
		if (this._alertQueue.length > 0) {
			
			var node = this._alertQueue.shift();
			this._dismissing = true;
			this.showAlertNode(node);
			return;
		}
		
		this._dismissing = true;
		
		if (this._black.getParent() != null) {
			
			this._root.removeChild(this._black);
			this._root.removeChild(this._consumingTouchTarget);
		}
		
		if (this._node != null && this._node.getParent() != null) {
			
			var node = this._node;
			this._node.runSequence(0.1, function() { node.scaleTo(1.3, 0.1); }, 0.2, function() { node.scaleTo(0.1, 0.2); }, 0, function() { AlertLayer.makeInvisible(); });
		}
	},
	
	instantDismiss: function() {
		this.makeInvisible();
	},
	
	makeInvisible: function() {
		
		if (this._node != null && this._node.getParent() != null) {
			
			if (this._node.onAlertDismiss)
				this._node.onAlertDismiss();
			
			this._root.removeChild(this._node);
			//this._node.destroy();
		}
		this._node = null;
		
		this._dismissing = false;
	},
	
	getCurrentNode: function() {
		
		return this._node;
	},
	
	$AlertLayerTouchHandler: Core.MessageListener.subclass({
		
		initialize: function() {
			
		},
		
		onTouch: function(touch) {
			NgLogD("handleConsumingTouch");
			return true;
		},
		
	}),
	
	getAlertQueueLength:function(){
		return this._alertQueue.length;
	}
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/ProgressBar/ProgressBar'] = function(){var exports = $MODULE_REGISTRY['Code/G6/ProgressBar/ProgressBar'] || {}; $MODULE_REGISTRY['Code/G6/ProgressBar/ProgressBar'] = exports; 
var AnimatedNode = require('Code/G6/Animation/AnimatedNode').AnimatedNode;

exports.ProgressBar = AnimatedNode.subclass({
	
	classname: 'ProgressBar',
	
	initialize: function(options) {
		
		this.options = options;
		
		this.sprite = new GL2.Sprite();
		this.setPercentage(0);
	},
	
	setPercentage: function(percentage) {
		
		this.percentage = percentage;
		
		var animFrame = this.getAnimationFrameForPercentage(percentage);
		if (!this.animation) {
			this.animation = new GL2.Animation();
			this.animation.pushFrame(animFrame);
			this.sprite.setAnimation(this.animation);
		}
		else {
			this.sprite.getAnimation().setFrame(0, animFrame);
		}
		
		if (this.sprite.getParent() == null) {
			this.addChild(this.sprite);
		}
	},
	
	getAnimationFrameForPercentage: function(percentage, duration) {
		
		if (!duration) duration = 0;
		
		var fraction = percentage / 100;
		
		var fillDirection = this.options.fillDirection;
		var frameSize = this.options.frame.getSize();
		var frameHeight = frameSize.getHeight();
		var frameWidth = frameSize.getWidth();
		var frameOrigin = this.options.frame.getOrigin();
		var frameOriginX = frameOrigin.getX();
		var frameOriginY = frameOrigin.getY();
		var imageSize = this.options.imageSize;
		var imageName = this.options.imageName;
		var anchor = this.options.anchorPoint;
		
		var resultOriginX, resultOriginY, resultHeight, resultWidth;
		
		if (this.options.isFillDirectionVertical()) {
			resultWidth = frameWidth;
			resultHeight = frameHeight * fraction;
		}
		else {
			resultHeight = frameHeight;
			resultWidth = frameWidth * fraction;
		}
		
		switch (fillDirection) {
			case this.Options.FillDirection.Left:
				resultOriginX = frameOriginX + frameWidth - resultWidth;
				resultOriginY = frameOriginY;
				break;
			case this.Options.FillDirection.Up:
				resultOriginX = frameOriginX;
				resultOriginY = frameOriginY + frameHeight - resultHeight;
				break;
			default:
				resultOriginX = frameOriginX;
				resultOriginY = frameOriginY;
				break;
		}
		
		var uvs = [resultOriginX / imageSize.getWidth(), resultOriginY / imageSize.getHeight(), resultWidth / imageSize.getWidth(), resultHeight / imageSize.getHeight()];
		var size = new Core.Size(resultWidth, resultHeight);
		
//		NgLogE(imageName);
//		NgLogE(size);
//		NgLogE(anchor);
//		NgLogE(uvs);
		
		var animFrame = new GL2.Animation.Frame(imageName, duration, size, anchor, uvs);
		return animFrame;
	},
	
	$Options: Core.Class.subclass({
		
		FillDirection: {
			Up: 0,
			Down: 1,
			Left: 2,
			Right: 3,
		},
		
		initialize: function() {
			
			this.fillDirection = this.FillDirection.Right;
			this.anchorPoint = [0, 0];	
			//this.imageName
			//this.imageSize
			//this.frame
		},
		
		isFillDirectionVertical: function() {
			return this.fillDirection == this.FillDirection.Up || this.fillDirection == this.FillDirection.Down;
		},
		
		fillByImage: function(name, imageSize) {
			
			this.imageName = name;
			this.imageSize = imageSize;
			this.frame = new Core.Rect(new Core.Point(0,0), imageSize);
		},
		
		fillByAtlasMappingName: function(mappingName) {
		
			var mapping = AtlasMap.getMapping(mappingName);
			var mapFileInfo = mapping.getAtlasMapFileInfo();
			
			this.imageName = mapFileInfo.getFileName();
			this.imageSize = mapFileInfo.getImageSize();
			this.frame = mapping.getFrame();
		},
	}),
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Alert/TestAlertNode'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Alert/TestAlertNode'] || {}; $MODULE_REGISTRY['Code/G6/Alert/TestAlertNode'] = exports; var AnimatedNode = require('Code/G6/Animation/AnimatedNode').AnimatedNode;
//var AlertLayer = require('./AlertLayer').AlertLayer;

exports.TestAlertNode = AnimatedNode.subclass({

	classname: 'TestAlertNode',

	initialize: function(someText) {
		
		this._text = someText;
		
		this._textNode = new GL2.Text();
		this._textNode.setFontFamily('DroidSans-Regular');
		this.addChild(this._textNode);
		
		var close = new GL2.Animation.Frame('Content/close-button.png', 0, [28, 30], [0.5, 0.5]);
		var closeItem = new Menu.AnimationFrameMenuItem();
        closeItem.setFrames(close);
		closeItem.setScale([2,2]);

        closeItem.setAction(function( ){ AlertLayer.dismiss(); });	
		var closeBtn = new Menu.Menu([closeItem]);
		closeBtn.setPosition(100,0);
		this.addChild(closeBtn);
		
		var kakaFrame = new GL2.Animation.Frame('Content/kakashi.png', 0, [60, 80], [0.5, 0.5]);
		var kakaItem = new Menu.AnimationFrameMenuItem();
		kakaItem.setFrames(kakaFrame);
		
		var thisNode = this;
		kakaItem.setAction(function() { thisNode.showText(); });
		
		var menu = new Menu.Menu([kakaItem]);
		this.addChild(menu);
	},
	
	showText: function() {
	
		this._textNode.setText(this._text);
	},
	
//	onAlertShow: function() {
//		NgLogD("Show");
//	},
//	
//	onAlertDismiss: function() {
//		NgLogD("Dismiss");
//	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Atlas/AtlasMap'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Atlas/AtlasMap'] || {}; $MODULE_REGISTRY['Code/G6/Atlas/AtlasMap'] = exports; var Core = require('NGCore/Client/Core').Core;
var GL2 = require('NGCore/Client/GL2').GL2;

exports.AtlasMapFileInfo = Core.Class.subclass(
{
	initialize: function()
	{	
	},
	
	getFileName: function() { return this._fileName; },
	setFileName: function(fileName) { this._fileName = fileName; },	
	
	getImageSize: function() { return this._imageSize; },
	setImageSize: function(imageSize) { this._imageSize = imageSize; },
	
	getFilePath: function() { return AtlasMap._imagePath + this.getFileName(); },
});

exports.AtlasMapping = Core.Class.subclass(
{
	initialize: function() 
	{	
	},
	
	getAtlasMapFileInfo: function() { return this._atlasMapFileInfo; },
	setAtlasMapFileInfo: function(atlasMapFileInfo) { this._atlasMapFileInfo = atlasMapFileInfo; },
	
	getName: function() { return this._name; },
	setName: function(name) { this._name = name; },
	
	//Rect
	getFrame: function() { return this._frame; }, 	
	setFrame: function(frame) { this._frame = frame; },
	
	//Size
	getOffset: function() { return this._offset; },	
	setOffset: function(offset) { this._offset = offset; },
	
});

exports.AtlasMap = Core.Class.singleton(
{
	initialize: function() 
	{
		this._mappings = [];
		this._mapFileInfos = [];
		this._cachedFrames = [];
		this._cachedAnimations = [];
		this._imagePath = 'Content/';
	},	
	
	setImagePath: function(imagePath) {
		this._imagePath = imagePath;
	},
	
	addMapFileInfo: function(info) {
		
		this._mapFileInfos[info.getFileName()] = info;
	},
	
	getAllMapFileInfos: function() {
		
		return this._mapFileInfos;
	},
	
	addMapping: function(mapping) 
	{
		this._mappings[mapping.getName()] = mapping;
	},
	
	getMapping: function(name) {
		
		return this._mappings[name];
	},
	
	getSprite: function(name, anchor, size, linefix) 
	{
		var frame = this.getAnimationFrame(name, 0, anchor, size, linefix);
		if (!frame) return null;
		
		var anim = new GL2.Animation();
		anim.pushFrame(frame);
//		anim.setBlendEnabled(false);
//		var anim = this.getAnimation(name, 0, anchor, size);
//		if (!anim) return null;
		
		var sprite = new GL2.Sprite();
		sprite.setAnimation(anim);
		return sprite;
	},
	
//	getAnimation: function(name, duration, anchor, size) {
//		
//		var frame = this.getAnimationFrame(name, duration, anchor, size);
//		if (!frame) return null;
//		
//		var cacheKey = this.getCachedFrameOrAnimationKey(name, duration, anchor);
//		var cachedAnim = this._cachedFrames[cacheKey];
//		if (cachedAnim) {
//			return cachedAnim;
//		}
//		
//		var anim = new GL2.Animation();
//		anim.pushFrame(frame);
//		this._cachedAnimations[cacheKey] = anim;
//		
//		return anim;
//	},
	
	getCachedFrameOrAnimationKey: function(name, duration, anchor) {
		
		var key = name;
		
		if (duration != 0)
			key += '|' + duration;
		
		if (anchor.length) {
			key += '|' + anchor[0];
			key += '|' + anchor[1];
		}
		else {
			key += '|' + anchor.getX();
			key += '|' + anchor.getY();
		}
		
		// cache not done by size atm
		
		return key;
	},
	
	getAnimationFrame: function(name, duration, anchor, size, linefix) 
	{
		var mapping = this._mappings[name];
		if (!mapping) NgLogD('AtlasMap could not find mapping for ' + name);
		if (!mapping) return null;
		if (typeof linefix == 'undefined') linefix = false;
		
		if (!duration) duration = 0;
		if (!anchor) anchor = [0.5,0.5];
		if (!size) {
			var frameSize = mapping.getFrame().getSize();
			size = new Core.Size(frameSize.getWidth(), frameSize.getHeight());
		}
		else if (size.length != null) {
			size = new Core.Size(size[0], size[1]);
		}
		
		var cacheKey = this.getCachedFrameOrAnimationKey(name, duration, anchor);
		var cachedFrame = this._cachedFrames[cacheKey];
		if (cachedFrame) {
			return cachedFrame;
		}
		
		var image = this._imagePath + mapping.getAtlasMapFileInfo().getFileName();
		var atlasSize = mapping.getAtlasMapFileInfo().getImageSize();
		var origin = mapping.getFrame().getOrigin();
		
		var uvs;
		if (linefix) {
			uvs  = [(origin.getX() + 0.5)/atlasSize.getWidth(), (origin.getY() + 0.5)/atlasSize.getHeight(),size.getWidth()/atlasSize.getWidth(), size.getHeight()/atlasSize.getHeight()];
		} else {
			uvs = [origin.getX()/atlasSize.getWidth(), origin.getY()/atlasSize.getHeight(),size.getWidth()/atlasSize.getWidth(), size.getHeight()/atlasSize.getHeight()];
		}
		
		
		
		var frame = new GL2.Animation.Frame(image, duration, [Scale.droid.width(size._width), Scale.droid.height(size._height)], anchor, uvs);
		this._cachedFrames[cacheKey] = frame;
		
		return frame;
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Atlas/AtlasMapLoader'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Atlas/AtlasMapLoader'] || {}; $MODULE_REGISTRY['Code/G6/Atlas/AtlasMapLoader'] = exports; var AtlasMap = require('Code/G6/Atlas/AtlasMap').AtlasMap;
var AtlasMapping = require('Code/G6/Atlas/AtlasMap').AtlasMapping;
var AtlasMapFileInfo = require('Code/G6/Atlas/AtlasMap').AtlasMapFileInfo;
var Core = require('NGCore/Client/Core').Core;

exports.AtlasMapLoader = Core.Class.singleton({

loadMappings: function() {

var mapFileInfo, mapping, rect, point, size;

size = new Core.Size(1016,1018);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_01.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-6.png');
point = new Core.Point(184,782);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-01-d.png');
point = new Core.Point(352,114);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-j.png');
point = new Core.Point(552,586);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-k.png');
point = new Core.Point(460,586);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-06-n.png');
point = new Core.Point(176,38);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip_25.png');
point = new Core.Point(264,962);
size = new Core.Size(80,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-7.png');
point = new Core.Point(368,530);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-5.png');
point = new Core.Point(276,782);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-8.png');
point = new Core.Point(276,530);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-10.png');
point = new Core.Point(828,534);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip_1000.png');
point = new Core.Point(424,908);
size = new Core.Size(80,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-6.png');
point = new Core.Point(0,750);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-7.png');
point = new Core.Point(368,656);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-6.png');
point = new Core.Point(648,208);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-7.png');
point = new Core.Point(556,208);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-9.png');
point = new Core.Point(184,404);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-8.png');
point = new Core.Point(0,498);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-a.png');
point = new Core.Point(644,334);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-a.png');
point = new Core.Point(280,152);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-06-d.png');
point = new Core.Point(352,38);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-5.png');
point = new Core.Point(368,404);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-5.png');
point = new Core.Point(184,278);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-05-d.png');
point = new Core.Point(704,38);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-k.png');
point = new Core.Point(644,460);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-9.png');
point = new Core.Point(184,656);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip2_500.png');
point = new Core.Point(880,94);
size = new Core.Size(94,94);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-09-n.png');
point = new Core.Point(0,0);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip2_1000.png');
point = new Core.Point(904,188);
size = new Core.Size(94,94);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip2_5000.png');
point = new Core.Point(880,0);
size = new Core.Size(94,94);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-k.png');
point = new Core.Point(460,334);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip2_100000.png');
point = new Core.Point(716,114);
size = new Core.Size(94,94);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-q.png');
point = new Core.Point(188,152);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-4.png');
point = new Core.Point(0,372);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-9.png');
point = new Core.Point(372,152);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-01-n.png');
point = new Core.Point(176,114);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-03-n.png');
point = new Core.Point(352,76);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip2_10000.png');
point = new Core.Point(810,188);
size = new Core.Size(94,94);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip_5.png');
point = new Core.Point(264,908);
size = new Core.Size(80,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-3.png');
point = new Core.Point(92,876);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-j.png');
point = new Core.Point(92,246);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-10.png');
point = new Core.Point(460,460);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-q.png');
point = new Core.Point(920,534);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip2_25.png');
point = new Core.Point(622,114);
size = new Core.Size(94,94);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-5.png');
point = new Core.Point(0,876);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-4.png');
point = new Core.Point(92,750);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-02-n.png');
point = new Core.Point(704,76);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-3.png');
point = new Core.Point(92,372);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-2.png');
point = new Core.Point(920,408);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-8.png');
point = new Core.Point(464,208);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-q.png');
point = new Core.Point(552,460);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-k.png');
point = new Core.Point(0,246);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-j.png');
point = new Core.Point(552,334);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-3.png');
point = new Core.Point(828,408);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-08-n.png');
point = new Core.Point(352,0);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip_500.png');
point = new Core.Point(184,962);
size = new Core.Size(80,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-10.png');
point = new Core.Point(368,278);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-4.png');
point = new Core.Point(736,408);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip2_1.png');
point = new Core.Point(94,152);
size = new Core.Size(94,94);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip2_5.png');
point = new Core.Point(528,114);
size = new Core.Size(94,94);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip2_100.png');
point = new Core.Point(0,152);
size = new Core.Size(94,94);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-08-d.png');
point = new Core.Point(528,0);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-4.png');
point = new Core.Point(368,782);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-9.png');
point = new Core.Point(92,624);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-q.png');
point = new Core.Point(924,282);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-07-d.png');
point = new Core.Point(0,38);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-05-n.png');
point = new Core.Point(528,38);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-6.png');
point = new Core.Point(276,404);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-2.png');
point = new Core.Point(504,892);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-3.png');
point = new Core.Point(460,712);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip_10000.png');
point = new Core.Point(344,962);
size = new Core.Size(80,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-02-d.png');
point = new Core.Point(0,114);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-09-d.png');
point = new Core.Point(176,0);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-04-d.png');
point = new Core.Point(176,76);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-s-2.png');
point = new Core.Point(276,278);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip_100000.png');
point = new Core.Point(344,908);
size = new Core.Size(80,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-a.png');
point = new Core.Point(0,624);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-j.png');
point = new Core.Point(184,530);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip_1.png');
point = new Core.Point(460,838);
size = new Core.Size(80,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-o-back.png');
point = new Core.Point(832,282);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-o-joker.png');
point = new Core.Point(740,282);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-07-n.png');
point = new Core.Point(704,0);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-10.png');
point = new Core.Point(552,712);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-04-n.png');
point = new Core.Point(0,76);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-8.png');
point = new Core.Point(276,656);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-d-2.png');
point = new Core.Point(736,534);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('car-03-d.png');
point = new Core.Point(528,76);
size = new Core.Size(176,38);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-c-a.png');
point = new Core.Point(644,586);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip_5000.png');
point = new Core.Point(184,908);
size = new Core.Size(80,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('card-h-7.png');
point = new Core.Point(92,498);
size = new Core.Size(92,126);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('chip_100.png');
point = new Core.Point(424,962);
size = new Core.Size(80,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(1016,416);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_02.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-limit-03.png');
point = new Core.Point(182,208);
size = new Core.Size(140,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-limit-01.png');
point = new Core.Point(910,0);
size = new Core.Size(106,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-comps-05-sap.png');
point = new Core.Point(182,0);
size = new Core.Size(182,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-comps-06-dia.png');
point = new Core.Point(0,0);
size = new Core.Size(182,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-chips-06.png');
point = new Core.Point(446,208);
size = new Core.Size(94,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-chips-04.png');
point = new Core.Point(634,208);
size = new Core.Size(94,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-chips-05.png');
point = new Core.Point(540,208);
size = new Core.Size(94,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-chips-02.png');
point = new Core.Point(822,208);
size = new Core.Size(94,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-chips-03.png');
point = new Core.Point(728,208);
size = new Core.Size(94,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-comps-01-red.png');
point = new Core.Point(0,208);
size = new Core.Size(182,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-chips-01.png');
point = new Core.Point(916,208);
size = new Core.Size(94,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-limit-02.png');
point = new Core.Point(322,208);
size = new Core.Size(124,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-comps-03-gld.png');
point = new Core.Point(546,0);
size = new Core.Size(182,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-comps-04-plt.png');
point = new Core.Point(364,0);
size = new Core.Size(182,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('iap-comps-02-blk.png');
point = new Core.Point(728,0);
size = new Core.Size(182,208);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(1022,1013);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('ui_atlas_01.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('settings-button-on.png');
point = new Core.Point(800,500);
size = new Core.Size(122,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-03-bj-inactive.png');
point = new Core.Point(590,633);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('tutorial-button-next-inactive.png');
point = new Core.Point(614,957);
size = new Core.Size(112,40);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-04-bank-active.png');
point = new Core.Point(490,849);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-07-settings-inactive.png');
point = new Core.Point(800,392);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-06-social-active.png');
point = new Core.Point(490,633);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bank-item-button-active.png');
point = new Core.Point(390,587);
size = new Core.Size(174,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_13.png');
point = new Core.Point(790,760);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_14.png');
point = new Core.Point(790,704);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_15.png');
point = new Core.Point(790,648);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-04-bank-inactive.png');
point = new Core.Point(490,741);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-02-tricard-inactive.png');
point = new Core.Point(590,849);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('info-bg.png');
point = new Core.Point(0,587);
size = new Core.Size(390,412);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-bg.png');
point = new Core.Point(0,480);
size = new Core.Size(800,51);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('tutorial-pagination-on.png');
point = new Core.Point(790,633);
size = new Core.Size(10,10);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('settings-button-logout-inactive.png');
point = new Core.Point(690,849);
size = new Core.Size(122,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('settings-button-logout-active.png');
point = new Core.Point(690,903);
size = new Core.Size(122,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_09.png');
point = new Core.Point(862,720);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_08.png');
point = new Core.Point(862,776);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bank-item-button-inactive.png');
point = new Core.Point(800,346);
size = new Core.Size(174,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_03.png');
point = new Core.Point(870,832);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_11.png');
point = new Core.Point(912,608);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_01.png');
point = new Core.Point(870,888);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-01-minibac-active.png');
point = new Core.Point(690,741);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('tutorial-button-next-active.png');
point = new Core.Point(800,608);
size = new Core.Size(112,40);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-02-tricard-active.png');
point = new Core.Point(922,500);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('tutorial-bar.png');
point = new Core.Point(0,999);
size = new Core.Size(672,1);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-01-minibac-inactive.png');
point = new Core.Point(690,633);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('tutorial-button-prev-inactive.png');
point = new Core.Point(390,957);
size = new Core.Size(112,40);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-06-social-inactive.png');
point = new Core.Point(900,392);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bank-item-bg.png');
point = new Core.Point(800,0);
size = new Core.Size(198,346);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_10.png');
point = new Core.Point(862,664);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('tutorial-button-prev-active.png');
point = new Core.Point(502,957);
size = new Core.Size(112,40);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('tutorial-pagination-off.png');
point = new Core.Point(998,0);
size = new Core.Size(10,10);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_07.png');
point = new Core.Point(934,664);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_06.png');
point = new Core.Point(934,720);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_05.png');
point = new Core.Point(934,776);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('tutorial-bg.png');
point = new Core.Point(0,0);
size = new Core.Size(800,480);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-06-strip-active.png');
point = new Core.Point(390,849);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('settings-item-bg.png');
point = new Core.Point(0,531);
size = new Core.Size(752,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('settings-button-off.png');
point = new Core.Point(800,554);
size = new Core.Size(122,54);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-07-settings-active.png');
point = new Core.Point(390,633);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-03-bj-active.png');
point = new Core.Point(590,741);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('lobby-06-strip-inactive.png');
point = new Core.Point(390,741);
size = new Core.Size(100,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('info-button-bg-active.png');
point = new Core.Point(682,587);
size = new Core.Size(118,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_02.png');
point = new Core.Point(942,832);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_12.png');
point = new Core.Point(726,957);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('bldg_logo_04.png');
point = new Core.Point(798,957);
size = new Core.Size(72,56);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('info-button-bg-inactive.png');
point = new Core.Point(564,587);
size = new Core.Size(118,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(1024,1024);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('ui_atlas_02.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('game-button-side2-inactive.png');
point = new Core.Point(802,410);
size = new Core.Size(134,62);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-bank-inactive.png');
point = new Core.Point(608,854);
size = new Core.Size(88,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-bank-active.png');
point = new Core.Point(608,903);
size = new Core.Size(88,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stars-4.png');
point = new Core.Point(937,450);
size = new Core.Size(74,16);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-lobby-active.png');
point = new Core.Point(884,662);
size = new Core.Size(104,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-icon-chips-small.png');
point = new Core.Point(1003,16);
size = new Core.Size(18,14);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-play-bg-top.png');
point = new Core.Point(1,482);
size = new Core.Size(800,74);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-icon-comps-small.png');
point = new Core.Point(1003,1);
size = new Core.Size(18,14);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-icon-chips.png');
point = new Core.Point(972,532);
size = new Core.Size(34,34);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-collect.png');
point = new Core.Point(646,745);
size = new Core.Size(88,108);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('game-button-inactive.png');
point = new Core.Point(646,626);
size = new Core.Size(118,52);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-bg-bottomright.png');
point = new Core.Point(802,1);
size = new Core.Size(200,64);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-sct-bg.png');
point = new Core.Point(239,977);
size = new Core.Size(288,40);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-build-inactive.png');
point = new Core.Point(884,711);
size = new Core.Size(104,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-lobby-inactive.png');
point = new Core.Point(646,679);
size = new Core.Size(104,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-bg-exit-active.png');
point = new Core.Point(937,467);
size = new Core.Size(64,64);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-bg-chips.png');
point = new Core.Point(802,107);
size = new Core.Size(160,40);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-settings-active.png');
point = new Core.Point(961,254);
size = new Core.Size(48,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-icon-comps.png');
point = new Core.Point(937,532);
size = new Core.Size(34,34);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-bar.png');
point = new Core.Point(528,977);
size = new Core.Size(117,37);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-menu-bg.png');
point = new Core.Point(1,1);
size = new Core.Size(800,480);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-button-inactive.png');
point = new Core.Point(1,977);
size = new Core.Size(118,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stars-3.png');
point = new Core.Point(961,188);
size = new Core.Size(54,16);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-info-active.png');
point = new Core.Point(961,344);
size = new Core.Size(40,40);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-build-active.png');
point = new Core.Point(751,715);
size = new Core.Size(104,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('game-button-active.png');
point = new Core.Point(765,662);
size = new Core.Size(118,52);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('popup-bg.png');
point = new Core.Point(1,626);
size = new Core.Size(606,350);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('game-button-side1-inactive.png');
point = new Core.Point(802,536);
size = new Core.Size(134,62);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('game-button-info-active.png');
point = new Core.Point(963,127);
size = new Core.Size(60,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('game-button-info-inactive.png');
point = new Core.Point(963,66);
size = new Core.Size(60,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-info-inactive.png');
point = new Core.Point(961,303);
size = new Core.Size(40,40);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stars-5.png');
point = new Core.Point(646,728);
size = new Core.Size(94,16);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('game-button-side1-active.png');
point = new Core.Point(802,599);
size = new Core.Size(134,62);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-bg-comps.png');
point = new Core.Point(802,66);
size = new Core.Size(160,40);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('game-button-side2-active.png');
point = new Core.Point(802,473);
size = new Core.Size(134,62);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-bg-bottomleft.png');
point = new Core.Point(802,345);
size = new Core.Size(152,64);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-button-settings-inactive.png');
point = new Core.Point(961,205);
size = new Core.Size(48,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-bg-exit-inactive.png');
point = new Core.Point(955,385);
size = new Core.Size(64,64);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('stats-bg.png');
point = new Core.Point(1,557);
size = new Core.Size(800,68);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-button-active.png');
point = new Core.Point(120,977);
size = new Core.Size(118,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-tab-bg-active.png');
point = new Core.Point(802,298);
size = new Core.Size(158,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('common-tab-bg-inactive.png');
point = new Core.Point(802,251);
size = new Core.Size(158,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('game-select.png');
point = new Core.Point(802,148);
size = new Core.Size(158,102);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(974,1024);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('ui_atlas_03.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-item-button-buy-inactive.png');
point = new Core.Point(140,978);
size = new Core.Size(342,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-spotlight-day.png');
point = new Core.Point(142,0);
size = new Core.Size(142,526);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-item-bg-unavailable.png');
point = new Core.Point(284,0);
size = new Core.Size(376,336);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-tab-3stars-active.png');
point = new Core.Point(798,8);
size = new Core.Size(158,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-tab-4stars-active.png');
point = new Core.Point(504,928);
size = new Core.Size(158,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-spotlight-night.png');
point = new Core.Point(0,0);
size = new Core.Size(142,526);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-item-info-active.png');
point = new Core.Point(140,930);
size = new Core.Size(48,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-tab-5stars-inactive.png');
point = new Core.Point(188,928);
size = new Core.Size(158,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-tab-5stars-active.png');
point = new Core.Point(346,928);
size = new Core.Size(158,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-item-info-inactive.png');
point = new Core.Point(140,882);
size = new Core.Size(48,48);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-tab-4stars-inactive.png');
point = new Core.Point(482,974);
size = new Core.Size(158,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-item-line.png');
point = new Core.Point(662,0);
size = new Core.Size(312,8);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-item-button-buy-active.png');
point = new Core.Point(188,882);
size = new Core.Size(342,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-move-no-active.png');
point = new Core.Point(70,952);
size = new Core.Size(70,70);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-move-yes-active.png');
point = new Core.Point(0,952);
size = new Core.Size(70,70);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-move-no-inactive.png');
point = new Core.Point(70,882);
size = new Core.Size(70,70);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-move-yes-inactive.png');
point = new Core.Point(0,882);
size = new Core.Size(70,70);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-tab-3stars-inactive.png');
point = new Core.Point(640,974);
size = new Core.Size(158,46);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('build-item-bg.png');
point = new Core.Point(0,526);
size = new Core.Size(390,356);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(817,1020);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_bldg_day1.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-02-d.png');
point = new Core.Point(274,719);
size = new Core.Size(296,261);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-04-d.png');
point = new Core.Point(0,294);
size = new Core.Size(358,249);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-03-d.png');
point = new Core.Point(0,0);
size = new Core.Size(428,294);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-06-d.png');
point = new Core.Point(428,0);
size = new Core.Size(389,246);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-07-d.png');
point = new Core.Point(428,246);
size = new Core.Size(359,369);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-01-d.png');
point = new Core.Point(0,719);
size = new Core.Size(274,301);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-05-d.png');
point = new Core.Point(0,543);
size = new Core.Size(329,176);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(876,994);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_bldg_day2.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-10-d.png');
point = new Core.Point(0,0);
size = new Core.Size(376,346);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-09-d.png');
point = new Core.Point(376,0);
size = new Core.Size(464,303);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-11-d.png');
point = new Core.Point(467,659);
size = new Core.Size(317,335);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-12-d.png');
point = new Core.Point(0,366);
size = new Core.Size(467,340);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-08-d.png');
point = new Core.Point(467,303);
size = new Core.Size(409,356);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(1024,380);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_bldg_day3.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-13-d.png');
point = new Core.Point(0,0);
size = new Core.Size(604,380);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-14-d.png');
point = new Core.Point(604,0);
size = new Core.Size(420,377);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(935,487);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_bldg_day4.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('dust-day-02.png');
point = new Core.Point(0,411);
size = new Core.Size(549,76);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('dust-day-03.png');
point = new Core.Point(549,103);
size = new Core.Size(342,102);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('dust-day-01.png');
point = new Core.Point(549,0);
size = new Core.Size(386,103);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-15-d.png');
point = new Core.Point(0,0);
size = new Core.Size(390,411);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(909,1006);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_bldg_night1.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-04-n1.png');
point = new Core.Point(414,368);
size = new Core.Size(384,264);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-04-n2.png');
point = new Core.Point(414,308);
size = new Core.Size(389,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-06-n1.png');
point = new Core.Point(0,120);
size = new Core.Size(414,260);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-01-n2.png');
point = new Core.Point(0,946);
size = new Core.Size(305,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-01-n1.png');
point = new Core.Point(0,632);
size = new Core.Size(299,314);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-03-n1.png');
point = new Core.Point(459,0);
size = new Core.Size(450,308);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-06-n2.png');
point = new Core.Point(0,60);
size = new Core.Size(420,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-03-n2.png');
point = new Core.Point(0,0);
size = new Core.Size(459,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-02-n2.png');
point = new Core.Point(305,893);
size = new Core.Size(296,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-05-n2.png');
point = new Core.Point(0,380);
size = new Core.Size(360,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-05-n1.png');
point = new Core.Point(0,440);
size = new Core.Size(356,189);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-02-n1.png');
point = new Core.Point(299,632);
size = new Core.Size(296,261);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(935,996);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_bldg_night2.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-07-n1.png');
point = new Core.Point(486,369);
size = new Core.Size(359,369);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-07-n2.png');
point = new Core.Point(407,936);
size = new Core.Size(390,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-08-n1.png');
point = new Core.Point(397,0);
size = new Core.Size(433,369);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-08-n2.png');
point = new Core.Point(342,876);
size = new Core.Size(440,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-09-n1.png');
point = new Core.Point(0,377);
size = new Core.Size(486,317);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-10-n1.png');
point = new Core.Point(0,0);
size = new Core.Size(397,357);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-10-n2.png');
point = new Core.Point(0,936);
size = new Core.Size(407,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('dust-nite-03.png');
point = new Core.Point(0,694);
size = new Core.Size(386,104);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('dust-nite-02.png');
point = new Core.Point(386,738);
size = new Core.Size(549,78);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('dust-nite-01.png');
point = new Core.Point(0,798);
size = new Core.Size(342,102);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-09-n2.png');
point = new Core.Point(342,816);
size = new Core.Size(495,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(987,804);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_bldg_night3.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-11-n2.png');
point = new Core.Point(635,0);
size = new Core.Size(352,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-11-n1.png');
point = new Core.Point(625,60);
size = new Core.Size(345,347);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-12-n2.png');
point = new Core.Point(489,453);
size = new Core.Size(498,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-12-n1.png');
point = new Core.Point(0,453);
size = new Core.Size(489,351);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-13-n1.png');
point = new Core.Point(0,60);
size = new Core.Size(625,393);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-13-n2.png');
point = new Core.Point(0,0);
size = new Core.Size(635,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
size = new Core.Size(420,908);
mapFileInfo = new AtlasMapFileInfo();
mapFileInfo.setFileName('obj_atlas_bldg_night4.png');
mapFileInfo.setImageSize(size);
AtlasMap.addMapFileInfo(mapFileInfo);

mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-15-n2.png');
point = new Core.Point(0,848);
size = new Core.Size(390,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-15-n1.png');
point = new Core.Point(0,437);
size = new Core.Size(390,411);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-14-n1.png');
point = new Core.Point(0,0);
size = new Core.Size(420,377);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);
mapping = new AtlasMapping();
mapping.setAtlasMapFileInfo(mapFileInfo);
mapping.setName('obj-bldg-14-n2.png');
point = new Core.Point(0,377);
size = new Core.Size(420,60);
rect = new Core.Rect(point,size);
mapping.setFrame(rect);
size = new Core.Size(0,0);
mapping.setOffset(size);
AtlasMap.addMapping(mapping);

},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Browser'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Browser'] || {}; $MODULE_REGISTRY['Code/G6/Browser'] = exports; /**
 * @author will
 */
exports.Browser = {
    SmoothBrowser: require('Code/G6/Browser/SmoothBrowser').SmoothBrowser,
	BrowserOptions: require('Code/G6/Browser/BrowserOptions').BrowserOptions,
	SmoothBrowserButtonBlock: require('Code/G6/Browser/SmoothBrowserButtonBlock').SmoothBrowserButtonBlock
};; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Text/CustomLabel'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Text/CustomLabel'] || {}; $MODULE_REGISTRY['Code/G6/Text/CustomLabel'] = exports; /**
 * @author raymondlo
 */

exports.CustomLabel = GL2.Node.subclass({
	classname: 'CustomLabel',
	
	initialize: function(text, xPos, yPos)
	{
		this.label = new GL2.Text();
		this.label.setFontFamily('DroidSans-Regular');
		this.label.setDepth(1);

		this.label.setPosition(xPos,yPos);
		this.label.setAnchor(0.5,0.5);
		this.label.setText(''+text);
		this.addChild(this.label);
	},
	
	setText:function(txt)
	{
		if (!isNaN(txt))
		{
			if (txt==0)
				{this.label.setText('0');}
		}
		this.label.setText(txt);
	}, 
	
	getText:function()
	{
		return this.getLabel().getText();
	}, 
		
	setPosition: function(x, y)
	{
		this.label.setPosition(x,y);
		this.xlocation = x;
		this.ylocation = y;
	},
	
	getLabel: function()
	{
		return this.label;
	},
	
	reset:function()
	{
		this.label.setText(' ');
	}, 
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Settings'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Settings'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Settings'] = exports; exports.Settings = {
	Settings: require('Code/StripCity/Game/Settings/Settings').Settings,
	SettingsPage: require('Code/StripCity/Game/Settings/SettingsPage').SettingsPage,
	
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Common/GenericAlertNode'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Common/GenericAlertNode'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Common/GenericAlertNode'] = exports; 
exports.GenericAlertNode = Animation.AnimatedNode.subclass({

	classname: 'GenericAlertNode',

	initialize: function(someText, titleText, dismissCB) {
		
		this.dismissCB = dismissCB;
		this._text = someText;
		this._titleText = titleText;
		
		this._textNode = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		SCStyle.applyFontStyle(this._textNode, SCStyle.FontStyle.Sans16);
		this._textNode.setDepth(2);
		this.addChild(this._textNode);
		this._textNode.setText(this._text);
		
		var body = AtlasMap.getSprite('popup-bg.png');
		
		//NgLogE("POPUP BG width: " + body.getAnimation().getFrame(0).getSize().getWidth() + " height: " + body.getAnimation().getFrame(0).getSize().getHeight());
		this.addChild(body);
		
		
//		var close = new GL2.Animation.Frame('Content/close-button.png', 0, [Scale.droid.width(28), Scale.droid.height(30)], [0.5, 0.5]);
//		var closeItem = new Menu.AnimationFrameMenuItem();
//        closeItem.setFrames(close);
//		closeItem.setScale([2,2]);
//
//        closeItem.setAction(function( ){ AlertLayer.dismiss(); });	
//		var closeBtn = new Menu.Menu([closeItem]);
//		closeBtn.setPosition(body._animation.getFrame(0).getSize().getWidth()/2,0-body._animation.getFrame(0).getSize().getHeight()/2);
//		closeBtn.setDepth(4);
//		this.addChild(closeBtn);	
			
//		var closeActive = AtlasMap.getAnimationFrame('common-bg-exit-active.png', 0, [0.5,0.5]);
//		var closeInactive = AtlasMap.getAnimationFrame('common-bg-exit-inactive.png', 0, [0.5,0.5]);		
//        var closeAnimation = new Menu.AnimationFrameMenuItem();
//        closeAnimation.setFrames(closeInactive,closeActive,closeActive);
//		closeAnimation.setAction(function(){
//			 AlertLayer.dismiss(); 
//		});
//		
//        var closeMenu = new Menu.Menu([closeAnimation]);
//        closeMenu.setPosition(((body._animation.getFrame(0).getSize().getWidth()-closeAnimation.getSize().getWidth())/2),(0-body._animation.getFrame(0).getSize().getHeight()+closeAnimation.getSize().getHeight())/2);
//        closeMenu.setDepth(4);
//        this.addChild(closeMenu);
		
		
		var buttonDisable = AtlasMap.getAnimationFrame('common-button-active.png', 0, [0.5,0.5]);
		var buttonEnable = AtlasMap.getAnimationFrame('common-button-inactive.png', 0, [0.5,0.5]);
		
		this.okay = new Menu.AnimationFrameMenuItem();
        this.okay.setFrames(buttonEnable, buttonDisable, buttonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('OKAY');
		label.setPosition(0, 0-4);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
		this.okay.addChild(label);
        this.okay.setAction(function(){
			AlertLayer.dismiss();
		});
		
//		this.okay.setPosition(0,(body._animation.getFrame(0).getSize().getHeight()/2) - this.okay.getSize().getHeight());
//		this.addChild(this.okay);

        var okayMenu = new Menu.Menu([this.okay]);
        okayMenu.setPosition(0,(body._animation.getFrame(0).getSize().getHeight()/2) - this.okay.getSize().getHeight() + 6);
        okayMenu.setDepth(4);
        this.addChild(okayMenu);		
		
		if (titleText) {
		
			var titleTextLabel = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
			titleTextLabel.setText(titleText);
			titleTextLabel.setDepth(3);
			titleTextLabel.getLabel().setColor(1, 1, 0.8);
			titleTextLabel.setPosition(0, -(body._animation.getFrame(0).getSize().getHeight() / 2) + 36);
			SCStyle.applyFontStyle(titleTextLabel, SCStyle.FontStyle.Serif32);
			this.addChild(titleTextLabel);
		}
	},
	
	showText: function() {
		this._textNode.setText(this._text);
	},

	setHorizontalAlign: function(horizontalAlign) {
	  this._textNode.setHorizontalAlign(horizontalAlign);
	},
	
	getTitleText:function(){
		return this._titleText;
	},
	
	onAlertDismiss: function() {
		
		if (this.dismissCB) {
			this.dismissCB();
		}
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Common/GenericConfirmNode'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Common/GenericConfirmNode'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Common/GenericConfirmNode'] = exports; 
exports.GenericConfirmNode = Animation.AnimatedNode.subclass({

	classname: 'GenericConfirmNode',

	initialize: function(someText,titleText, confirmCB) {
		
		this._text = someText;
		this._titleText = titleText;
		var self = this;
		
		this._textNode = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		this._textNode.setDepth(2);
		this.addChild(this._textNode);
		this._textNode.setText(this._text);
		
		
		var body = AtlasMap.getSprite('popup-bg.png');
		this.addChild(body);
		
		
		var buttonDisable = AtlasMap.getAnimationFrame('game-button-active.png', 0, [0,0]);
		var buttonEnable = AtlasMap.getAnimationFrame('game-button-inactive.png', 0, [0,0]);
		
		this.okay = new Menu.AnimationFrameMenuItem();
        this.okay.setFrames(buttonEnable, buttonDisable, buttonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Okay');
		label.setPosition(this.okay.getSize().getWidth()/2, this.okay.getSize().getHeight()/2-4);
		label.setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		this.okay.addChild(label);
        this.okay.setAction(function(){
			AlertLayer.dismiss();
			confirmCB();
		});
        
        this.cancel = new Menu.AnimationFrameMenuItem();
        this.cancel.setFrames(buttonEnable, buttonDisable, buttonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Cancel');
		label.setPosition(this.cancel.getSize().getWidth()/2, this.cancel.getSize().getHeight()/2-4);
		label.setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		this.cancel.addChild(label);
        this.cancel.setAction(function(){
			AlertLayer.dismiss();
		});
		
        this.confirmMenu = new Menu.Menu([this.okay, this.cancel]);
		this.confirmMenu.alignItemsHorizontally(Scale.droid.width(100));
        this.confirmMenu.setDepth(4);
		this.confirmMenu.setPosition(Scale.droid.width(-55),Scale.droid.height(110));
		this.addChild(this.confirmMenu);
		
		if (titleText) {
		
			var titleTextLabel = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
			titleTextLabel.setText(titleText);
			titleTextLabel.setDepth(3);
			titleTextLabel.getLabel().setColor(1, 1, 0.8);
			titleTextLabel.setPosition(0, -(body._animation.getFrame(0).getSize().getHeight() / 2) + 36);
			SCStyle.applyFontStyle(titleTextLabel, SCStyle.FontStyle.Serif32);
			this.addChild(titleTextLabel);
		}
	},
	
	showText: function() {
	
		this._textNode.setText(this._text);
	},
	
	getTitleText:function(){
		return this._titleText;
	},
	
	destroy: function($super) {
		this._textNode.destroy();
		this.body.destroy();
		this.okay.destroy();
		this.cancel.destroy();
		this.confirmMenu.destroy();
		$super();
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Title/TitleScreen'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Title/TitleScreen'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Title/TitleScreen'] = exports; /**
 * @author raymondlo
 */


exports.TitleScreen = GL2.Node.subclass({
    classname: 'TitleScreen',
    
    initialize: function(){
    
        this.background = new GL2.Sprite();
		this.background.setImage('Content/stripcity-title.png', [Scale.droid.width(800), Scale.droid.height(480)], [0, 0]);
        this.addChild(this.background);
		
//		this.label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
//		this.label.setDepth(1);
//		this.label.setPosition(Scale.droid.width(360),Scale.droid.height(80));
//		this.label.setAnchor(0.5,0.5);
//		this.label.setFontSize(Scale.droid.textSize(32));
//		this.label.setText('Loading...');
//		this.addChild(this.label);
	
		var progOptions = new ProgressBar.Options();
		progOptions.fillByImage('Content/ui_nonatlas_title/title-loading-bar.png', new Core.Size(Scale.droid.width(700),Scale.droid.height(2)));
		
		this.progressBar = new ProgressBar(progOptions);
		this.progressBar.setPosition(Scale.droid.width(48), Scale.droid.height(460));
		this.progressBar.setDepth(2);
		this.addChild(this.progressBar);
	
		var barPos = this.progressBar.getPosition();
		var progressBg = new GL2.Sprite();
		progressBg.setImage('Content/ui_nonatlas_title/title-loading-bg.png',[Scale.droid.width(700),Scale.droid.height(2)],progOptions.anchorPoint);
		progressBg.setPosition(barPos.getX(), barPos.getY());
		this.addChild(progressBg);
		
    },
	
	setProgressPercentage: function(percent) {
		this.progressBar.setPercentage(percent);
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Lobby/LobbyScene'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Lobby/LobbyScene'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Lobby/LobbyScene'] = exports; /**
 * @author raymondlo
 */
var visibleBlocks = 4;
var animationDuration = 0.5;
var LobbyBackgroundNode = require('Code/StripCity/Scene/Lobby/LobbyBackgroundNode').LobbyBackgroundNode;
var IAPMenu = require('Code/StripCity/Scene/IAP/IAPMenu').IAPMenu;
exports.LobbyScene = Node.subclass({
    classname: 'LobbyScene',
    
    initialize: function(){
        //background slides must have two for every "scene"
        this._backgroundSlides = [];
        this._backgroundSlides.push(new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_lobby_01a.png', 0, [Scale.droid.width(1561), Scale.droid.height(480)], [0, 0]));
        this._backgroundSlides.push(new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_lobby_01b.png', 0, [Scale.droid.width(1500), Scale.droid.height(480)], [0, 0]));
        this._backgroundSlides.push(new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_lobby_02a.png', 0, [Scale.droid.width(1839), Scale.droid.height(480)], [0, 0]));
        this._backgroundSlides.push(new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_lobby_02a.png', 0, [Scale.droid.width(0), Scale.droid.height(0)], [0, 0]));
        this._backgroundSlides.push(new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_lobby_03a.png', 0, [Scale.droid.width(1564), Scale.droid.height(480)], [0, 0]));
        this._backgroundSlides.push(new GL2.Animation.Frame('Content/ui_nonatlas_bgs/bg_lobby_03b.png', 0, [Scale.droid.width(1815), Scale.droid.height(480)], [0, 0]));
        
        // add blanks to try to cache images
        for (var i in this._backgroundSlides) {
        
            var frame = this._backgroundSlides[i];
            var blank = Util.generateBlankSprite(frame.getImage());
            this.addChild(blank);
        }
        
        
        
        this._nextSlide = 0;
        this._activeBackgroundSprites = [];
        
        var first = this.createNextBackgroundNode();
        this.addChild(first);
        this._activeBackgroundSprites.push(first);
        
        
        //	 this._cache = [];
        //		for (var i in this._backgroundSlides) {
        //			//cacheeeeee
        //			var frame = this._backgroundSlides[i];
        //			var sprite = new GL2.Sprite();
        //			sprite.setImage(frame);
        //			this._cache.push(sprite);
        //			
        //			
        //			this.addChild(sprite);
        //			
        //			sprite.setVisible(false);
        //		}
        
        
        
        
        //		var lastNode;
        //		for (var i in this._backgroundSlides) {
        //			
        //			lastNode = this.createNextBackgroundNode();
        //			lastNode.setTail(false);
        //			this.addChild(lastNode);
        //			this._activeBackgroundSprites.push(lastNode);
        //		}
        //		lastNode.setTail(true);
        this.musickey = -1;
        
        
        var screenSize = Util.screenSize(true);
        
        var dock = AtlasMap.getSprite('lobby-bg.png', [0.5, 1]);
        dock.setDepth(1);
        dock.setPosition(screenSize.getWidth() / 2, screenSize.getHeight());
        this.addChild(dock);
        
        this._buttonBlockSize = new Core.Size(Util.floatToInt(Math.max(Core.Capabilities.getScreenWidth(), Core.Capabilities.getScreenHeight()) / visibleBlocks), Util.floatToInt(Math.min(Core.Capabilities.getScreenWidth(), Core.Capabilities.getScreenHeight()) / 4))
        var stripButton = this.createLobbyButtonBlock(SCConstants.Game.Strip, this._buttonBlockSize);
        var bjButton = this.createLobbyButtonBlock(SCConstants.Game.BlackJack, this._buttonBlockSize);
        
		
        var triCardWarButton = this.createLobbyButtonBlock(SCConstants.Game.TriCardWar, this._buttonBlockSize);
        var baccaratButton = this.createLobbyButtonBlock(SCConstants.Game.Baccarat, this._buttonBlockSize);
        var settingsButton = this.createLobbyButtonBlock(SCConstants.Game.Settings, this._buttonBlockSize);
        var bankButton = this.createLobbyButtonBlock(SCConstants.Game.Bank, this._buttonBlockSize);
        // var inquiryButton = this.createLobbyButtonBlock(SCConstants.Game.Inquiry, this._buttonBlockSize);
        
        this._blocks = [stripButton, bjButton, triCardWarButton, baccaratButton, settingsButton, bankButton];
        
        var browserOptions = new Browser.BrowserOptions();
        browserOptions.setYPosition(screenSize.getHeight() / 4 * 3 + this._buttonBlockSize.getHeight() / 2);
        NgLogD('***** YPOS' + browserOptions.getYPosition());
        this.browser = new Browser.SmoothBrowser(this._blocks, browserOptions);
        this.browser.setLocked(true);
        
        var browserSize = this.browser.getBrowserSize();
        if (browserSize.getWidth() < screenSize.getWidth()) {
            widthDiff = screenSize.getWidth() - browserSize.getWidth();
            this.browser.setPosition(widthDiff / 2, 2);
        }
        
        var browserTT = this.browser.getTouchTarget();
        browserTT.setSize(new Core.Size(screenSize.getWidth(), screenSize.getHeight() / 4));
        browserTT.setAnchor(new Core.Point(0, 1));
        browserTT.setPosition(0, screenSize.getHeight());
        browserTT.setDepth(0);
        this.browser.setDepth(2);
        this.addChild(this.browser);
        this.addChild(browserTT);
        
        
		//CHEAT BUTTONS HERE
        
//        this.addChipsButton = new this.addChipsButton(this);
//        this.addChild(this.addChipsButton.getNode());
//        
//		this.addExpButton = new this.addExpButton(this);
//        this.addChild(this.addExpButton.getNode());
		
        //        
        //        var chipLabel = new CustomLabel('Chips', 620, 40);
        //        this.displayPlayerTotal = new CustomLabel('' + SCGame.getPlayer().availableChips(), 620, 80);
        //        this.addChild(chipLabel);
        //        this.addChild(this.displayPlayerTotal);
        //        
        //        var expLabel = new CustomLabel('Exp', 700, 40);
        //        this.displayPlayerExp = new CustomLabel('' + SCGame.getPlayer().getExp(), 700, 80);
        //        this.addChild(expLabel);
        //        this.addChild(this.displayPlayerExp);
        
        this._revolveListener = new this.LobbyRevolverListener(this);
        
        //getting the actual screen width, hacky so this works in the flash one too... 
        this._screenWidth = Math.max(Core.Capabilities.getScreenWidth(), Core.Capabilities.getScreenHeight());
        
        
    },
    
    
    startRevolving: function(){
    
        Core.UpdateEmitter.addListener(this._revolveListener, this._revolveListener.onUpdate);
    },
    
    stopRevolving: function(){
        Core.UpdateEmitter.removeListener(this._revolveListener);
        this.reset();
        this.musickey = -1;
    },
    
    createNextBackgroundNode: function(){
        var indexa = (this._nextSlide * 2) % this._backgroundSlides.length;
        var indexb = indexa + 1;
        
        var node = new LobbyBackgroundNode(this._backgroundSlides[indexa], this._backgroundSlides[indexb]);
        node.setDepth(-1);
        node.setTail(true);
        
        this._nextSlide++;
        return node;
    },
    
    revolve: function(delta){
        var xpos = NaN;
        var toAdd = null;
        if ((this.musickey != (this._nextSlide + 1) % (this._backgroundSlides.length / 2)) && this._activeBackgroundSprites.length > 1) {
            this.musickey = (this._nextSlide + 1) % (this._backgroundSlides.length / 2);
            SCGame.getSCAudio().playbackgroundmusic(this.musickey);
        }
        for (var i in this._activeBackgroundSprites) {
        
            bgSprite = this._activeBackgroundSprites[i];
            if (isNaN(xpos)) {
                xpos = bgSprite.getPosition().getX() - delta / Scale.droid.width(20);
                bgSprite.setPosition(xpos, 0);
            }
            else {
                bgSprite.setPosition(xpos, 0);
                
            }
            
            if (bgSprite.getPosition().getX() < 300 && bgSprite.isTail()) {
                toAdd = this.createNextBackgroundNode();
                bgSprite.setTail(false);
                
            }
            
            xpos += bgSprite.getWidth();
        }
        
        if (toAdd) {
            toAdd.setPosition(xpos, 0);
            this.addChild(toAdd);
            this._activeBackgroundSprites.push(toAdd);
            
        }
        
        if (this._activeBackgroundSprites.length == 0) 
            return;
        
        //removes invisible ones.
        while (this._activeBackgroundSprites.length > 0 && this._activeBackgroundSprites[0].getPosition().getX() < (0 - this._activeBackgroundSprites[0].getWidth())) {
            this._activeBackgroundSprites[0].destroy();
            this._activeBackgroundSprites.shift();
            
        }
    },
    reset: function(){
    
        for (var i = 0; i < this._activeBackgroundSprites.length; i++) {
            this._activeBackgroundSprites[i].destroy();
            this._activeBackgroundSprites.shift();
        }
        this._activeBackgroundSprites.length = 0;
        var first = this.createNextBackgroundNode();
        first.setPosition(0, 0);
        first.setTail(true);
        this.addChild(first);
        this.musickey = -1;
        this._activeBackgroundSprites.push(first);
    },
    
    displayGame: function(gameID){
    
        if (gameID == SCConstants.Game.BlackJack) {
            Game.SCGame.loadBlackJack();
        }
        else 
            if (gameID == SCConstants.Game.TriCardWar) {
                Game.SCGame.loadTriCardWar();
            }
            else 
                if (gameID == SCConstants.Game.Baccarat) {
                    Game.SCGame.loadBaccarat();
                }
                else 
                    if (gameID == SCConstants.Game.Settings) {
                        Game.SCGame.loadSettingsPage();
                    }
					else
				        if (gameID == SCConstants.Game.Bank) {
				            this.showIAP();
				        }
				        else 
					        if (gameID == SCConstants.Game.Inquiry) {
					            //Japan only
								// this.showInquiry();
					        }
					        else 
					            if (gameID == SCConstants.Game.Strip) {
					                Game.SCGame.loadStrip(this);
					            }
    },
    
    //    updatePlayerValue: function(){
    //        this.displayPlayerTotal.setText('' + SCGame.getPlayer().availableChips());
    //        this.displayPlayerExp.setText('' + SCGame.getPlayer().getExp());
    //    },
    
    createLobbyButtonBlock: function(gameID, size){
        var inactive = null;
        var active = null;
        var disabled = null;
        if (gameID == SCConstants.Game.BlackJack) {
            inactive = AtlasMap.getAnimationFrame('lobby-03-bj-inactive.png');
            active = AtlasMap.getAnimationFrame('lobby-03-bj-active.png');
            disabled = disabled;
            
        }
        else 
            if (gameID == SCConstants.Game.TriCardWar) {
                inactive = AtlasMap.getAnimationFrame('lobby-02-tricard-inactive.png');
                active = AtlasMap.getAnimationFrame('lobby-02-tricard-active.png');
                disabled = disabled;
                
            }
            else 
                if (gameID == SCConstants.Game.Baccarat) {
                    inactive = AtlasMap.getAnimationFrame('lobby-01-minibac-inactive.png');
                    active = AtlasMap.getAnimationFrame('lobby-01-minibac-active.png');
                    disabled = disabled;
                }
                else 
                    if (gameID == SCConstants.Game.Settings) {
                        inactive = AtlasMap.getAnimationFrame('lobby-07-settings-inactive.png', undefined, undefined, undefined, true);
                        active = AtlasMap.getAnimationFrame('lobby-07-settings-active.png');
                        disabled = disabled;
                    }
                    else 
                        if (gameID == SCConstants.Game.Bank) {
                            inactive = AtlasMap.getAnimationFrame('lobby-04-bank-inactive.png');
                            active = AtlasMap.getAnimationFrame('lobby-04-bank-active.png');
                            disabled = disabled;
                        }
                        else 
                            if (gameID == SCConstants.Game.Inquiry) {
                                inactive = AtlasMap.getAnimationFrame('lobby-08-inquiry-inactive.png');
                                active = AtlasMap.getAnimationFrame('lobby-08-inquiry-active.png');
                                disabled = disabled;
                            }						
	                        else 
	                            if (gameID == SCConstants.Game.Strip) {
	                                inactive = AtlasMap.getAnimationFrame('lobby-06-strip-inactive.png');
	                                active = AtlasMap.getAnimationFrame('lobby-06-strip-active.png');
	                                disabled = disabled;
	                            }
        
        
        var self = this;
        var gid = gameID;
        callback = function(){
            self.displayGame(gid);
        }
        
        var block = new Browser.SmoothBrowserButtonBlock(gameID, inactive, active, disabled, callback)
        
        return block;
        
    },
    
    addChipsButton: Core.MessageListener.subclass({
        initialize: function(lobby){
            this.lobby = lobby;
            
            var buttonAnimation = new GL2.Animation();
            buttonAnimation.pushFrame(AtlasMap.getAnimationFrame('iap-chips-04.png'));
            this.node = new GL2.Node();
            this.node.setDepth(10);
            this.node.setPosition(Scale.droid.width(750), Scale.droid.height(250));
            this.sprite = new GL2.Sprite();
            this.sprite.setDepth(10);
            this.sprite.setAnimation(buttonAnimation);
            this.sprite.setScale(0.8, 0.8);
            
            this.node.addChild(this.sprite);
            this.target = new GL2.TouchTarget();
            this.target.setDepth(10);
            this.target.setAnchor(this.sprite.getAnimation().getFrame(0).getAnchor());
            this.target.setSize(this.sprite.getAnimation().getFrame(0).getSize());
            this.target.getTouchEmitter().addListener(this, this.onTouch);
            this.node.addChild(this.target);
            
        },
        
        getNode: function(){
            return this.node;
        },
        
        onTouch: function(touch){
            switch (touch.getAction()) {
                case touch.Action.Start:
                    this.sprite.setColor(1, 1, 0.25);
                    return true;
                case touch.Action.End:
                    this.sprite.setColor(1, 1, 1);
                    SCGame.updatePlayer(Player.StatType.Chips, 5000000, true);
                    SCGame.updatePlayer(Player.StatType.Comp, 50000, true);
                    AlertLayer.showAlertNode(new GenericAlertNode('You received 5,000,000 chips and 50,000 comps','QA TEST BUTTON'));
                    SCGame.quickSavePlayer();
                    break;
            }
            
        },
    }),
    
	addExpButton: Core.MessageListener.subclass({
        initialize: function(lobby){
            this.lobby = lobby;
            
            var buttonAnimation = new GL2.Animation();
            buttonAnimation.pushFrame(AtlasMap.getAnimationFrame('iap-chips-04.png'));
            this.node = new GL2.Node();
            this.node.setDepth(10);
            this.node.setPosition(Scale.droid.width(640), Scale.droid.height(250));
            this.sprite = new GL2.Sprite();
            this.sprite.setDepth(10);
            this.sprite.setAnimation(buttonAnimation);
            this.sprite.setScale(0.8, 0.8);
            
            this.node.addChild(this.sprite);
            this.target = new GL2.TouchTarget();
            this.target.setDepth(10);
            this.target.setAnchor(this.sprite.getAnimation().getFrame(0).getAnchor());
            this.target.setSize(this.sprite.getAnimation().getFrame(0).getSize());
            this.target.getTouchEmitter().addListener(this, this.onTouch);
            this.node.addChild(this.target);
            
        },
        
        getNode: function(){
            return this.node;
        },
        
        onTouch: function(touch){
            switch (touch.getAction()) {
                case touch.Action.Start:
                    this.sprite.setColor(1, 1, 0.25);
                    return true;
                case touch.Action.End:
                    this.sprite.setColor(1, 1, 1);
                    SCGame.updatePlayer(Player.StatType.Experience, 5000, true);
                    SCGame.quickSavePlayer();
                    break;
            }
            
        },
    }),
	
    showIAP: function(){
        SCGame.getSCAudio().playsound(10);
        var screenSize = Util.screenSize(true);
        //this.setState(this.State.IAPMenu);		
        this._iap = Game.IAP.IAPManager.getMenuAndReset();
        this._iap.setDelegate(this);
        this._iap.setDepth(12);
        this._iapVisiblePosition = new Core.Vector([1.0, 1.0]);
        
        this._iapInvisiblePosition = new Core.Point(this._iapVisiblePosition.getX(), this._iapVisiblePosition.getY() + screenSize.getHeight() + Scale.droid.height(100));
        this._iap.setPosition(this._iapInvisiblePosition.clone());
        this.addChild(this._iap);
        
        if (!this._iap.isAnimating()) {
            this._iap.moveTo(this._iapVisiblePosition.getX()-1, this._iapVisiblePosition.getY()-1, animationDuration);
        }
		

    },
    closeIAPMenu: function(menu){
        SCGame.getSCAudio().playsound(10);
        if (!menu.isAnimating()) {
            menu.moveTo(this._iapVisiblePosition.getX(), this._iapInvisiblePosition.getY(), animationDuration);
            //NgLogI('closing menu.... y = ' + this._iapInvisiblePosition.getY());	
        }
        //        
        //
        //        var self = this;
        //        setTimeout(function(){
        //            self.setState(self.State.Scrolling);
        //            self.removeChild(menu);
        //        }, animationDuration * 1000);
    },
    
	showInquiry:function(){
		Social.JP.Service.openCommunityFunction("/thisgame/inquiry",
		function(){});
	},
	
	
    $LobbyRevolverListener: Core.MessageListener.subclass({
    
        classname: 'LobbyRevolverListener',
        
        initialize: function(lobby){
            this._lobby = lobby;
        },
        
        
        onUpdate: function(delta){
            //value
            this._lobby.revolve(delta);
        }
    }),




});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/BlackJack'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/BlackJack'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/BlackJack'] = exports; var tutorialMenu_xpos = 736;
var tutorialMenu_ypos = 72;
var betMenu_xpos = 342; //includes chips and [leave,reset,done]
var betMenu_ypos = 341;
var playMenu_xpos = 342;
var playMenu_ypos = 428;
var leftMenu_xpos = -14;
var leftMenu_ypos = 210;
var rightMenu_xpos = 682;
var rightMenu_ypos = 210;
var closeMenu_xpos = 772;
var closeMenu_ypos = 28;
var titleText_xpos = 400;
var titleText_ypos = 25;
var titleSubText_xpos = 400;
var titleSubText_ypos = 51;

var chipLabel_xpos = 58;
var chipLabel_ypos = 42;
var compLabel_xpos = 680;
var compLabel_ypos = 42;
var chipStat_xpos = 58;
var chipStat_ypos = 24;
var compStat_xpos = 680;
var compStat_ypos = 24;
var topChipsBar_xpos = 8;
var topChipsBar_ypos = 12;
var topCompsBar_xpos = 633;
var topCompsBar_ypos = 12;

var Game = GL2.Node.subclass({

    classname: 'Game',
    
    initialize: function(bj, player){
        this.PLAYER_X = Scale.droid.width(400);
        this.PLAYER_Y = Scale.droid.height(580);
        this.DEALER_X = Scale.droid.width(400);
        this.DEALER_Y = Scale.droid.height(-100);
        
        this.PLAYER_HAND_X = Scale.droid.width(320);
        this.PLAYER_HAND_Y = Scale.droid.height(320);
        this.DEALER_HAND_X = Scale.droid.width(320);
        this.DEALER_HAND_Y = Scale.droid.height(135);
        this.PLAYER_SPLIT_HAND_X = Scale.droid.width(160);
        this.PLAYER_SPLIT_HAND_Y = Scale.droid.height(330);
        
        this.PLAYER_CHIPS_X = Scale.droid.width(598);
        this.PLAYER_CHIPS_Y = Scale.droid.height(276);
        this.PLAYER_HAND_TOTAL_X = Scale.droid.width(745);
        this.PLAYER_HAND_TOTAL_Y = Scale.droid.height(313);
        this.DEALER_HAND_TOTAL_X = Scale.droid.width(745);
        this.DEALER_HAND_TOTAL_Y = Scale.droid.height(247);
        
        this.TEXT1_X = Scale.droid.width(370);
        this.TEXT1_Y = Scale.droid.height(228);
        this.TEXT2_X = Scale.droid.width(370);
        this.TEXT2_Y = Scale.droid.height(228);
        
        this.bj = bj;
        this.player = player;
        this.deck = new CardGame.Deck();
        this.dh = new CardGame.BJHand(this.DEALER_HAND_X, this.DEALER_HAND_Y);
        this.ph = new CardGame.BJHand(this.PLAYER_HAND_X, this.PLAYER_HAND_Y);
        this.sh = new CardGame.BJHand(this.PLAYER_SPLIT_HAND_X, this.PLAYER_SPLIT_HAND_Y);
        this.sh.setCanHit(false);
        this.ph.setCanHit(false);
        this.dealt = false;
        this.isAnimating = false;
        
        this.displayCurrentBet = new CardGame.Chips(0, this.PLAYER_CHIPS_X, this.PLAYER_CHIPS_Y);
        this.addChild(this.displayCurrentBet.getNode());
        this.displayExtraBet = new CardGame.Chips(0, this.PLAYER_X, this.PLAYER_Y);
        this.addChild(this.displayExtraBet.getNode());
        
        
        this.chipLabel = new GL2.Text();
		this.chipLabel.setFontFamily('DroidSans-Regular');
		this.chipLabel.setFontSize(32);
        this.chipLabel.setText('Chip Count');
        SCStyle.applyFontStyle(this.chipLabel, SCStyle.FontStyle.Sans14);
        this.chipLabel.setPosition(Scale.droid.width(chipLabel_xpos), Scale.droid.height(chipLabel_ypos));
        this.chipLabel.setAnchor(0, 0.5);
        this.chipLabel.setDepth(4);
        this.addChild(this.chipLabel);
        
        this.compLabel = new GL2.Text();
		this.compLabel.setFontFamily('DroidSans-Regular');
		this.compLabel.setFontSize(32);
        this.compLabel.setText('Comp Points');
        SCStyle.applyFontStyle(this.compLabel, SCStyle.FontStyle.Sans14);
        this.compLabel.setPosition(Scale.droid.width(compLabel_xpos), Scale.droid.height(compLabel_ypos));
        this.compLabel.setAnchor(0, 0.5);
        this.compLabel.setDepth(4);
        this.addChild(this.compLabel);
        
        this.chipsStat = new PlayerStatNode(Player.StatType.Chips, SCGame.getPlayer());
        this.chipsStat.setDepth(4);
        this.chipsStat.setPosition(Scale.droid.width(chipStat_xpos), Scale.droid.height(chipStat_ypos));
        this.chipsStat.attachUpdateListener(SCGame.getPlayerUpdateEmitter());
        this.addChild(this.chipsStat);
        
        this.compStat = new PlayerStatNode(Player.StatType.Comp, SCGame.getPlayer());
        this.compStat.setDepth(4);
        this.compStat.setPosition(Scale.droid.width(compStat_xpos), Scale.droid.height(compStat_ypos));
        this.compStat.attachUpdateListener(SCGame.getPlayerUpdateEmitter());
        this.addChild(this.compStat);
        
        
        this.displayDealerHandTotal = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        SCStyle.applyFontStyle(this.displayDealerHandTotal, SCStyle.FontStyle.SerifB18);
        this.displayDealerHandTotal.setPosition(this.DEALER_HAND_TOTAL_X, this.DEALER_HAND_TOTAL_Y);
        this.addChild(this.displayDealerHandTotal);
        
        this.displayPlayerHandTotal = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        SCStyle.applyFontStyle(this.displayPlayerHandTotal, SCStyle.FontStyle.SerifB18);
        this.displayPlayerHandTotal.setPosition(this.PLAYER_HAND_TOTAL_X, this.PLAYER_HAND_TOTAL_Y);
        this.addChild(this.displayPlayerHandTotal);
        
        
        //Betting
        this.currentbet = 0;
        
        //Mods
        this.winMultiplier = 1; // Gain % extra per win
        this.returnMultiplier = 0; // Lose % less per loss
        var mods = SCGame.getStrip().getMods();
        
        for (x = 0; x < mods.length; x++) {
            if (mods[x].getType() == mods[x].Type.AllWinningsIncrease) {
                this.winMultiplier += mods[x].getValue() / 100;
            }
            else 
                if (mods[x].getType() == mods[x].Type.AllLosingsDecrease) {
                    this.returnMultiplier += mods[x].getValue() / 100;
                }
        }
        
    },
    
    maxBet: function(){
        switch (this.player.getBettingTier()) {
            case 1:
                return 2000;
                break;
            case 2:
                return 5000;
                break;
            case 3:
                return 10000;
                break;
            case 4:
                return 25000;
                break;
            default:
                return 2000;
                break;
        }
    },
    
    deal: function(){
        if (this.dealt) {
            var displayGameResults = new Animation.ScrollingLabel('Hand is not over', this.TEXT1_X, this.TEXT1_Y, Scale.droid.height(70), 3);
            //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
            return;
        }
        this.dealt = true;
        this.bj.exit.setEnabled(false);
        this.bj.change.setEnabled(false);
        this.bj.deal.setEnabled(false);
        this.bj.split.setEnabled(false);
        
        if (this.currentbet > this.player.availableChips()) {
            var displayGameResults = new Animation.ScrollingLabel('Lower your bet', this.TEXT1_X, this.TEXT1_Y, Scale.droid.height(70), 3);
            this.addChild(displayGameResults);
            return;
        }
        this.bj.showPlayMenu();
        this.deck.shuffle();
        this.dh.reset();
        this.ph.reset();
        this.sh.reset();
        this.ph.setActive(true);
        this.dh.setActive(true);
        this.sh.setActive(true);
        
        this.dh.setLocation(this.DEALER_HAND_X, this.DEALER_HAND_Y);
        this.ph.setLocation(this.PLAYER_HAND_X, this.PLAYER_HAND_Y);
        this.sh.setLocation(this.PLAYER_SPLIT_HAND_X, this.PLAYER_SPLIT_HAND_Y);
        
        this.displayDealerHandTotal.reset();
        this.displayPlayerHandTotal.reset();
        this.displayPlayerHandTotal.setPosition(this.PLAYER_HAND_TOTAL_X, this.PLAYER_HAND_TOTAL_Y);
        SCGame.updatePlayer(Player.StatType.Chips, -this.currentbet, true);
        
        this.displayExtraBet.setAmount(0);
        this.displayExtraBet.setPosition(this.PLAYER_X, this.PLAYER_Y);
        this.displayCurrentBet.setPosition(this.PLAYER_CHIPS_X, this.PLAYER_CHIPS_Y);
        
        var card1 = this.deck.getCard();
        var card2 = this.deck.getCard();
        var card3 = this.deck.getCard();
        var card4 = this.deck.getCard();
        var dh = this.dh;
        var bj = this.bj;
        var ph = this.ph;
        var displayDealerHandTotal = this.displayDealerHandTotal;
        var displayPlayerHandTotal = this.displayPlayerHandTotal;
        var thisObj = this;
        
        this.isAnimating = true;
        var animatedNode = new Animation.AnimatedNode();
        animatedNode.runSequence(0.4, function(){
            card1.setFaceup();
            ph.addCard(card1);
            bj.gameNode.addChild(card1.getNode());
            displayPlayerHandTotal.setText('' + ph.BJHandTotal());
        }, 0.4, function(){
            card2.setFaceup();
            dh.addCard(card2);
            bj.gameNode.addChild(card2.getNode());
            displayDealerHandTotal.setText('' + dh.BJHandTotal());
        }, 0.4, function(){
            card3.setFaceup();
            ph.addCard(card3);
            bj.gameNode.addChild(card3.getNode());
            displayPlayerHandTotal.setText('' + ph.BJHandTotal());
        }, 0.4, function(){
            dh.addCard(card4);
            bj.gameNode.addChild(card4.getNode());
            displayDealerHandTotal.setText('' + dh.BJHandTotal());
        }, 0.0, function(){
            thisObj.isAnimating = false;
            thisObj.bj.double.setEnabled(true);
            thisObj.bj.hit.setEnabled(true);
            thisObj.bj.stand.setEnabled(true);
            if (ph.canSplit()) 
                thisObj.bj.split.setEnabled(true);
            animatedNode.destroy();
        });
        
    },
    
    dealResult: function(){
    
        this.dh.setCanHit(true);
        this.ph.setCanHit(true);
        
        if (this.ph.checkBlackJack() && !this.dh.checkBlackJack()) {
            this.ph.setBlackJack();
            SCGame.updatePlayer(Player.StatType.Chips, (this.currentbet * this.ph.winValue()) * this.winMultiplier + this.currentbet, true);
            var displayGameResults = new Animation.ScrollingLabel('Black Jack!!', this.TEXT1_X, this.TEXT1_Y, Scale.droid.height(70), 3);
            //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
            this.addChild(displayGameResults);
            this.wonBet(this.currentbet * this.ph.winValue(), false);
            this.ph.setCanHit(false);
            
            SCGame.updatePlayer(Player.StatType.Experience, this.player.getTier() + 1, true);
            SCGame.updatePlayer(Player.StatType.Comp, this.currentbet / 10000, true);
            
            var thisObj = this;
            setTimeout(function(){
                SCGame.quickSavePlayer();
                thisObj.bj.exit.setEnabled(true);
                thisObj.bj.change.setEnabled(true);
                thisObj.bj.deal.setEnabled(true);
                thisObj.ph.setActive(false);
                thisObj.dh.setActive(false);
                thisObj.sh.setActive(false);
                thisObj.dealt = false;
            }, 1000);
        }
        else 
            if (!this.ph.checkBlackJack() && this.dh.checkBlackJack()) {
                this.dh.cards[1].setFaceup();
                if (this.returnMultiplier > 0) 
                    SCGame.updatePlayer(Player.StatType.Chips, this.currentbet * this.returnMultiplier, true);
                var displayGameResults = new Animation.ScrollingLabel('Dealer Black Jack', this.TEXT1_X, this.TEXT1_Y, Scale.droid.height(70), 3);
                //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                this.addChild(displayGameResults);
                this.displayDealerHandTotal.setText('' + this.dh.BJHandTotal());
                this.lostBet(false);
                this.ph.setCanHit(false);
                
                SCGame.updatePlayer(Player.StatType.Experience, this.player.getTier() + 1, true);
                SCGame.updatePlayer(Player.StatType.Comp, this.currentbet / 10000, true);
                
                var thisObj = this;
                setTimeout(function(){
                    SCGame.quickSavePlayer();
                    thisObj.bj.exit.setEnabled(true);
                    thisObj.bj.change.setEnabled(true);
                    thisObj.bj.deal.setEnabled(true);
                    thisObj.ph.setActive(false);
                    thisObj.dh.setActive(false);
                    thisObj.sh.setActive(false);
                    thisObj.dealt = false;
                }, 1000);
                
            }
            else 
                if (this.ph.checkBlackJack() && this.dh.checkBlackJack()) {
                    this.dh.cards[1].setFaceup();
                    SCGame.updatePlayer(Player.StatType.Chips, this.currentbet, true);
                    var displayGameResults = new Animation.ScrollingLabel('Tie', this.TEXT1_X, this.TEXT1_Y, Scale.droid.height(70), 3);
                    //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                    this.addChild(displayGameResults);
                    this.displayDealerHandTotal.setText('' + this.dh.BJHandTotal());
                    this.ph.setCanHit(false);
                    
                    SCGame.updatePlayer(Player.StatType.Experience, this.player.getTier() + 1, true);
                    SCGame.updatePlayer(Player.StatType.Comp, this.currentbet / 10000, true);
                    
                    var thisObj = this;
                    setTimeout(function(){
                        SCGame.quickSavePlayer();
                        thisObj.bj.exit.setEnabled(true);
                        thisObj.bj.change.setEnabled(true);
                        thisObj.bj.deal.setEnabled(true);
                        thisObj.ph.setActive(false);
                        thisObj.dh.setActive(false);
                        thisObj.sh.setActive(false);
                        thisObj.dealt = false;
                    }, 1000);
                }
        
    },
    
    hit: function(){
    
        if (!(this.ph.canHit() || this.sh.canHit())) 
            return;
        
        this.bj.double.setEnabled(false);
        this.bj.split.setEnabled(false);
        var timer = 0;
        this.isAnimating = true;
        var thisObj = this;
        var animatedNode = new Animation.AnimatedNode();
        animatedNode.runSequence(0.7, function(){
            if (thisObj.ph.canHit()) {
                var card = thisObj.deck.getCard();
                card.setFaceup();
                thisObj.ph.addCard(card);
                thisObj.bj.gameNode.addChild(card.getNode());
                thisObj.displayPlayerHandTotal.setText('' + thisObj.ph.BJHandTotal());
            }
            else 
                if (thisObj.sh.canHit()) {
                    var card = thisObj.deck.getCard();
                    card.setFaceup();
                    thisObj.sh.addCard(card);
                    thisObj.bj.gameNode.addChild(card.getNode());
                    thisObj.displayPlayerHandTotal.setText('' + thisObj.sh.BJHandTotal());
                }
        }, 0.0, function(){
            if (thisObj.ph.BJHandTotal() > 21 && thisObj.ph.canHit() && !thisObj.sh.canHit()) {
                //bust and doesnt have a split hand
                thisObj.ph.setCanHit(false);
                var h = thisObj.dh.getHand();
                h[1].setFaceup();
                thisObj.displayDealerHandTotal.setText('' + thisObj.dh.BJHandTotal());
                if (thisObj.returnMultiplier > 0) 
                    SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet * thisObj.returnMultiplier, true);
                var displayGameResults = new Animation.ScrollingLabel('Bust', thisObj.TEXT1_X, thisObj.TEXT1_Y, Scale.droid.height(70), 3);
                //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                thisObj.addChild(displayGameResults);
                thisObj.lostBet(false);
                timer += 0.7;
                
                SCGame.updatePlayer(Player.StatType.Experience, thisObj.player.getTier() + 1, true);
                SCGame.updatePlayer(Player.StatType.Comp, thisObj.currentbet / 10000, true);
                
                setTimeout(function(){
                    thisObj.bj.exit.setEnabled(true);
                    thisObj.bj.change.setEnabled(true);
                    thisObj.bj.deal.setEnabled(true);
                    thisObj.ph.setActive(false);
                    thisObj.dh.setActive(false);
                    thisObj.sh.setActive(false);
                    thisObj.dealt = false;
                    SCGame.quickSavePlayer();
                }, 700);
            }
            else 
                if (thisObj.ph.BJHandTotal() > 21 && thisObj.ph.canHit() && thisObj.sh.canHit()) {
                    //bust but still has a split hand
                    var splitAnimatedNode = new Animation.AnimatedNode();
                    splitAnimatedNode.runSequence(0.3, function(){
                        thisObj.ph.moveBy(thisObj.PLAYER_SPLIT_HAND_X - thisObj.ph.xlocation, thisObj.PLAYER_SPLIT_HAND_Y - thisObj.ph.ylocation);
                        thisObj.ph.xlocation = thisObj.PLAYER_SPLIT_HAND_X;
                        thisObj.ph.ylocation = thisObj.PLAYER_SPLIT_HAND_Y;
                        thisObj.ph.setSmallScale(true);
                        thisObj.sh.moveBy(thisObj.PLAYER_HAND_X - thisObj.sh.xlocation, thisObj.PLAYER_HAND_Y - thisObj.sh.ylocation);
                        thisObj.sh.xlocation = thisObj.PLAYER_HAND_X;
                        thisObj.sh.ylocation = thisObj.PLAYER_HAND_Y;
                        thisObj.sh.setSmallScale(false);
                    }, 0.0, function(){
                        thisObj.ph.setCanHit(false);
                        if (thisObj.returnMultiplier > 0) 
                            SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet * thisObj.returnMultiplier, true);
                        var card = thisObj.deck.getCard();
                        thisObj.sh.addCard(card);
                        thisObj.bj.gameNode.addChild(card.getNode());
                        card.setFaceup();
                        thisObj.displayPlayerHandTotal.setText('' + thisObj.sh.BJHandTotal());
                        timer += 1.0;
                        splitAnimatedNode.destroy();
                    });
                }
        }, timer, function(){
        }, 0.0, function(){
            thisObj.isAnimating = false;
            if (thisObj.sh.BJHandTotal() > 21 && thisObj.sh.canHit()) {
                thisObj.sh.setCanHit(false);
                thisObj.evaluate();
            }
            animatedNode.destroy();
        });
    },
    
    stay: function(){
    
        if (!(this.ph.canHit() || this.sh.canHit())) 
            return;
        
        if (!this.ph.canHit()) 
            this.sh.setCanHit(false);
        this.ph.setCanHit(false);
        
        
        if (this.sh.canHit()) {
            var thisObj = this;
            this.isAnimating = true;
            
            var animatedNode = new Animation.AnimatedNode();
            animatedNode.runSequence(0.3, function(){
				thisObj.ph.setSmallScale(true);
                thisObj.ph.moveBy(thisObj.PLAYER_SPLIT_HAND_X - thisObj.ph.xlocation, thisObj.PLAYER_SPLIT_HAND_Y - thisObj.ph.ylocation);
                thisObj.ph.xlocation = thisObj.PLAYER_SPLIT_HAND_X;
                thisObj.ph.ylocation = thisObj.PLAYER_SPLIT_HAND_Y;
				thisObj.sh.setSmallScale(false);
                thisObj.sh.moveBy(thisObj.PLAYER_HAND_X - thisObj.sh.xlocation, thisObj.PLAYER_HAND_Y - thisObj.sh.ylocation);
                thisObj.sh.xlocation = thisObj.PLAYER_HAND_X;
                thisObj.sh.ylocation = thisObj.PLAYER_HAND_Y;
                thisObj.displayPlayerHandTotal.setText('' + thisObj.sh.BJHandTotal());
            }, 0.4, function(){
                var card = thisObj.deck.getCard();
                card.setFaceup();
                thisObj.sh.addCard(card);
                thisObj.bj.gameNode.addChild(card.getNode());
                thisObj.displayPlayerHandTotal.setText('' + thisObj.sh.BJHandTotal());
            }, 0.0, function(){
                thisObj.evaluate();
                thisObj.isAnimating = false;
                animatedNode.destroy();
            });
        }
        else {
		
		this.bj.hit.setEnabled(false);
        this.bj.stand.setEnabled(false);
       	this.bj.double.setEnabled(false);
        this.bj.split.setEnabled(false);
			
            this.evaluate();
        }
        
    },
    
    split: function(){
    
        if (!(this.ph.canHit() || this.sh.canHit())) {
            return;
        }
        
        if (this.ph.canHit() && this.ph.cards.length > 2) 
            return;
        
        if ((!this.ph.canSplit() || this.sh.numberOfCards() > 0)) {
            return;
        }
        
        if ((this.currentbet * 2) > this.player.availableChips()) {
            var displayGameResults = new Animation.ScrollingLabel('Not enough money for split', this.TEXT1_X, this.TEXT1_Y, Scale.droid.height(70), 3);
            //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
            this.addChild(displayGameResults);
            return;
        }
        
        this.bj.split.setEnabled(false);
        var animatedNode = new Animation.AnimatedNode();
        var thisObj = this;
        this.isAnimating = true;
        
        animatedNode.runSequence(1.0, function(){
            SCGame.updatePlayer(Player.StatType.Chips, -thisObj.currentbet, true);
            thisObj.sh.addSplitCard(thisObj.ph.splitHand());
            thisObj.sh.setSmallScale(true);
            thisObj.displayExtraBet.setAmount(thisObj.currentbet);
            thisObj.displayExtraBet.setPosition(thisObj.PLAYER_CHIPS_X, thisObj.PLAYER_CHIPS_Y - 70);
            thisObj.displayExtraBet.getNode().moveTo(thisObj.PLAYER_CHIPS_X, thisObj.PLAYER_CHIPS_Y - 70, 0.3);
            
            thisObj.displayPlayerHandTotal.setText('' + thisObj.ph.BJHandTotal());
        }, 0.4, function(){
            var card = thisObj.deck.getCard();
            card.setFaceup();
            thisObj.ph.addCard(card);
            thisObj.bj.gameNode.addChild(card.getNode());
            thisObj.displayPlayerHandTotal.setText('' + thisObj.ph.BJHandTotal());
            thisObj.sh.setCanHit(true);
        }, 0.0, function(){
            thisObj.isAnimating = false;
            animatedNode.destroy();
        });
        
    },
    
    doubledown: function(){
    
        if (!(this.ph.canHit() || this.sh.canHit())) {
            return;
        }
        
        if (this.ph.canHit() && this.ph.cards.length > 2) 
            return;
        if (this.sh.canHit() && this.sh.cards.length > 2) 
            return;
        
        if (this.currentbet > this.player.availableChips() && !this.sh.canHit()) {
            var displayGameResults = new Animation.ScrollingLabel('Not enough money for double', this.TEXT1_X, this.TEXT1_Y, Scale.droid.height(70), 3);
            //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
            this.addChild(displayGameResults);
            return;
        }
        
        if (((this.currentbet * this.ph.winValue()) + this.currentbet) > this.player.availableChips() && this.sh.canHit()) {
            //SCGame.getSCAudio().playsound(11);
            var displayGameResults = new Animation.ScrollingLabel('Not enough money for double', this.TEXT1_X, this.TEXT1_Y, Scale.droid.height(70), 3);
            //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
            this.addChild(displayGameResults);
            return;
        }
        
        if (this.sh.canHit() && !this.ph.canHit()) {
            this.sh.setDoubleDown();
            this.sh.setCanHit(false);
            
            var animatedNode = new Animation.AnimatedNode();
            var thisObj = this;
            
            this.isAnimating = true;
            animatedNode.runSequence(0.4, function(){
                var newChips = new CardGame.Chips(thisObj.currentbet, thisObj.PLAYER_X, thisObj.PLAYER_Y);
                thisObj.addChild(newChips.getNode());
                
                var animatedNode2 = new Animation.AnimatedNode();
                animatedNode2.runSequence(0.3, function(){
                    newChips.getNode().moveTo(thisObj.displayExtraBet.xlocation, thisObj.displayExtraBet.ylocation, 0.3);
                }, 0.0, function(){
                    thisObj.removeChild(newChips.getNode());
                    newChips.destroy();
                    thisObj.displayExtraBet.setAmount(thisObj.displayExtraBet.amt + thisObj.currentbet);
                    SCGame.updatePlayer(Player.StatType.Chips, -thisObj.currentbet, true);
                    animatedNode2.destroy();
                });
                
                
            }, 0.5, function(){
                var card = thisObj.deck.getCard();
                thisObj.sh.addCard(card);
                thisObj.bj.gameNode.addChild(card.getNode());
                card.setFaceup();
            }, 0.0, function(){
                thisObj.evaluate();
                thisObj.isAnimating = false;
                animatedNode.destroy();
            });
            
        }
        else {
            this.ph.setDoubleDown();
            this.ph.setCanHit(false);
            
            var animatedNode = new Animation.AnimatedNode();
            var thisObj = this;
            this.isAnimating = true;
            var timer = 0;
            
            if (this.sh.canHit()) {
                timer = 0.7;
            }
            
            animatedNode.runSequence(0.4, function(){
                var newChips = new CardGame.Chips(thisObj.currentbet, thisObj.PLAYER_X, thisObj.PLAYER_Y);
                thisObj.addChild(newChips.getNode());
                
                var animatedNode2 = new Animation.AnimatedNode();
                animatedNode2.runSequence(0.3, function(){
                    newChips.getNode().moveTo(thisObj.displayCurrentBet.xlocation, thisObj.displayCurrentBet.ylocation, 0.3);
                }, 0.0, function(){
                    thisObj.removeChild(newChips.getNode());
                    newChips.destroy();
                    thisObj.displayCurrentBet.setAmount(thisObj.displayCurrentBet.amt + thisObj.currentbet);
                    SCGame.updatePlayer(Player.StatType.Chips, -thisObj.currentbet, true);
                    animatedNode2.destroy();
                });
            }, 0.7, function(){
                var card = thisObj.deck.getCard();
                thisObj.ph.addCard(card);
                thisObj.bj.gameNode.addChild(card.getNode());
                card.setFaceup();
                thisObj.displayPlayerHandTotal.setText('' + thisObj.ph.BJHandTotal());
            }, timer, function(){
                if (thisObj.sh.canHit()) {
                    var splitAnimatedNode = new Animation.AnimatedNode();
                    splitAnimatedNode.runSequence(0.3, function(){
						thisObj.ph.setSmallScale(true);
                        thisObj.ph.moveBy(thisObj.PLAYER_SPLIT_HAND_X - thisObj.ph.xlocation, thisObj.PLAYER_SPLIT_HAND_Y - thisObj.ph.ylocation);
                        thisObj.ph.xlocation = thisObj.PLAYER_SPLIT_HAND_X;
                        thisObj.ph.ylocation = thisObj.PLAYER_SPLIT_HAND_Y;
						thisObj.sh.setSmallScale(false);
                        thisObj.sh.moveBy(thisObj.PLAYER_HAND_X - thisObj.sh.xlocation, thisObj.PLAYER_HAND_Y - thisObj.sh.ylocation);
                        thisObj.sh.xlocation = thisObj.PLAYER_HAND_X;
                        thisObj.sh.ylocation = thisObj.PLAYER_HAND_Y;
                        
                    }, 0.0, function(){
                        var card = thisObj.deck.getCard();
                        thisObj.sh.addCard(card);
                        thisObj.bj.gameNode.addChild(card.getNode());
                        card.setFaceup();
                        thisObj.displayPlayerHandTotal.setText('' + thisObj.sh.BJHandTotal());
                        splitAnimatedNode.destroy();
                    });
                }
            }, 0.0, function(){
                if (!thisObj.ph.canHit() && !thisObj.sh.canHit()) 
                    thisObj.evaluate();
                thisObj.isAnimating = false;
                animatedNode.destroy();
            });
            
        }
        
    },
    
    evaluate: function(){
        if (!this.ph.canHit() && !this.sh.canHit()) {
            var h = this.dh.getHand();
            h[1].setFaceup();
            this.displayDealerHandTotal.setText('' + this.dh.BJHandTotal());
            var thisObj = this;
            this.isAnimating = true;
            setTimeout(function(){
                thisObj.addDealerCard(thisObj);
            }, 700);
        }
    },
    
    addDealerCard: function(thisObj){
        if (thisObj.dh.BJHandTotal() < 17) {
            var card = thisObj.deck.getCard();
            thisObj.dh.addCard(card);
            thisObj.bj.gameNode.addChild(card.getNode());
            card.setFaceup();
            thisObj.displayDealerHandTotal.setText('' + thisObj.dh.BJHandTotal());
            
            setTimeout(function(){
                thisObj.addDealerCard(thisObj);
            }, 1000);
        }
        else {
            this.compare();
        }
    },
    
    compare: function(){
        this.isAnimating = false;
        
        
        if (!this.ph.canHit() && !this.sh.canHit()) {
            var timer = 0;
            if (this.sh.numberOfCards() > 0) 
                timer = 2;
            var thisObj = this;
            var animatedNode = new Animation.AnimatedNode();
            animatedNode.runSequence(timer, function(){
                if (thisObj.ph.BJHandTotal() > 21) {
                    if (thisObj.returnMultiplier > 0) 
                        SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet * thisObj.returnMultiplier, true);
                    var displayGameResults = new Animation.ScrollingLabel('Bust', thisObj.TEXT1_X, thisObj.TEXT1_Y, Scale.droid.height(70), 3);
                    //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                    thisObj.addChild(displayGameResults);
                    thisObj.lostBet(false);
                }
                else 
                    if ((thisObj.dh.BJHandTotal() < thisObj.ph.BJHandTotal()) || thisObj.dh.BJHandTotal() > 21) {
                        SCGame.updatePlayer(Player.StatType.Chips, (thisObj.currentbet * thisObj.ph.winValue()) * thisObj.winMultiplier + thisObj.currentbet, true);
                        if (thisObj.ph.isDouble) 
                            SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet, true);
                        var displayGameResults = new Animation.ScrollingLabel('You win', thisObj.TEXT1_X, thisObj.TEXT1_Y, Scale.droid.height(70), 3);
                        //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                        thisObj.addChild(displayGameResults);
                        thisObj.wonBet(thisObj.currentbet * thisObj.ph.winValue(), false);
                    }
                    else 
                        if (thisObj.dh.BJHandTotal() > thisObj.ph.BJHandTotal()) {
                            if (thisObj.returnMultiplier > 0) 
                                SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet * thisObj.returnMultiplier, true);
                            var displayGameResults = new Animation.ScrollingLabel('You lose', thisObj.TEXT1_X, thisObj.TEXT1_Y, Scale.droid.height(70), 3);
                            //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                            thisObj.addChild(displayGameResults);
                            thisObj.lostBet(false);
                        }
                        else {
                            SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet, true);
                            var displayGameResults = new Animation.ScrollingLabel('Tie', thisObj.TEXT1_X, thisObj.TEXT1_Y, Scale.droid.height(70), 3);
                            //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
							if (thisObj.ph.isDouble) 
                            	SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet, true);
                            thisObj.addChild(displayGameResults);
                            thisObj.bj.split.setEnabled(false);
                            thisObj.bj.double.setEnabled(false);
                            thisObj.bj.hit.setEnabled(false);
                            thisObj.bj.stand.setEnabled(false);
                            thisObj.bj.deal.setEnabled(false);
                        }
            }, 1.2, function(){
                if (thisObj.sh.numberOfCards() > 1) {
                    if (thisObj.sh.BJHandTotal() > 21) {
                        if (thisObj.returnMultiplier > 0) 
                            SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet * thisObj.returnMultiplier, true);
                        var displayGameResults = new Animation.ScrollingLabel('Bust', thisObj.TEXT2_X, thisObj.TEXT2_Y, Scale.droid.height(70), 3);
                        //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                        thisObj.addChild(displayGameResults);
                        thisObj.lostBet(true);
                    }
                    else 
                        if ((thisObj.dh.BJHandTotal() < thisObj.sh.BJHandTotal()) || thisObj.dh.BJHandTotal() > 21) {
                            SCGame.updatePlayer(Player.StatType.Chips, (thisObj.currentbet * thisObj.sh.winValue()) * thisObj.winMultiplier + thisObj.currentbet, true);
                            if (thisObj.sh.isDouble) 
                                SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet, true);
                            var displayGameResults = new Animation.ScrollingLabel('You win', thisObj.TEXT2_X, thisObj.TEXT2_Y, Scale.droid.height(70), 3);
                            //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                            thisObj.addChild(displayGameResults);
                            thisObj.wonBet(thisObj.currentbet * thisObj.sh.winValue(), true);
                            //											var thisObj = this;
                            setTimeout(function(){
                                thisObj.displayExtraBet.getNode().moveTo(thisObj.PLAYER_X, thisObj.PLAYER_Y, 0.4);
                            }, 1200);
                        }
                        else 
                            if (thisObj.dh.BJHandTotal() > thisObj.sh.BJHandTotal()) {
                                if (thisObj.returnMultiplier > 0) 
                                    SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet * thisObj.returnMultiplier, true);
                                var displayGameResults = new Animation.ScrollingLabel('You lose', thisObj.TEXT2_X, thisObj.TEXT2_Y, Scale.droid.height(70), 3);
                                //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                                thisObj.addChild(displayGameResults);
                                thisObj.lostBet(true);
                            }
                            else {
                                SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet, true);
                                var displayGameResults = new Animation.ScrollingLabel('Tie', thisObj.TEXT2_X, thisObj.TEXT2_Y, Scale.droid.height(70), 3);
                                //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
								if (thisObj.sh.isDouble) 
                            		SCGame.updatePlayer(Player.StatType.Chips, thisObj.currentbet, true);
                                thisObj.addChild(displayGameResults);
                                thisObj.tieBet();
                                thisObj.bj.split.setEnabled(false);
                                thisObj.bj.double.setEnabled(false);
                                thisObj.bj.hit.setEnabled(false);
                                thisObj.bj.stand.setEnabled(false);
                                thisObj.bj.deal.setEnabled(false);
                            }
                }
            }, 0, function(){
                thisObj.displayCurrentBet.setAmount(thisObj.currentbet);
                SCGame.updatePlayer(Player.StatType.Experience, thisObj.player.getTier() + 1, true);
                SCGame.updatePlayer(Player.StatType.Comp, thisObj.currentbet / 10000, true);
                SCGame.quickSavePlayer();
                
                thisObj.bj.exit.setEnabled(true);
                thisObj.bj.change.setEnabled(true);
                thisObj.bj.deal.setEnabled(true);
                thisObj.ph.setActive(false);
                thisObj.dh.setActive(false);
                thisObj.sh.setActive(false);
                thisObj.dealt = false;
                animatedNode.destroy();
            });
        }
    },
    
    lostBet: function(isSplitHand){
        this.bj.split.setEnabled(false);
        this.bj.double.setEnabled(false);
        this.bj.hit.setEnabled(false);
        this.bj.stand.setEnabled(false);
        this.bj.deal.setEnabled(false);
        
        var displayCurrentBet;
        var currentbet = this.currentbet;
        var player = this.player;
        var thisObj = this;
        SCGame.getSCAudio().playsound(7);
        this.isAnimating = true;
        if (isSplitHand) {
            var animatedNode = new Animation.AnimatedNode();
            displayCurrentBet = this.displayExtraBet;
            animatedNode.runSequence(0.6, function(){
                displayCurrentBet.getNode().moveTo(thisObj.DEALER_X, thisObj.DEALER_Y, 0.5);
            }, 0.0, function(){
                thisObj.isAnimating = false;
                animatedNode.destroy();
            });
        }
        else {
            var animatedNode = new Animation.AnimatedNode();
            displayCurrentBet = this.displayCurrentBet;
            animatedNode.runSequence(0.6, function(){
                displayCurrentBet.getNode().moveTo(thisObj.DEALER_X, thisObj.DEALER_Y, 0.5);
            }, 0.4, function(){
                if (currentbet > player.availableChips()) {
                    displayCurrentBet.setAmount(player.availableChips());
                    thisObj.bj.currentBetAmt.setText('' + player.availableChips());
                }
                displayCurrentBet.getNode().setPosition(thisObj.PLAYER_X, thisObj.PLAYER_Y);
            }, 0.4, function(){
                displayCurrentBet.getNode().moveTo(thisObj.PLAYER_CHIPS_X, thisObj.PLAYER_CHIPS_Y, 0.4);
            }, 0.0, function(){
                if (player.availableChips() < 10) {
                    SCGame.updatePlayer(Player.StatType.Chips, 500 - player.availableChips(), true);
                    AlertLayer.showAlertNode(new GenericAlertNode('You\'re out of Chips, but the Casino Manager\nhas comp\'d you some extra cash.\nFor a real stack of chips, make sure to hit The Bank!','ON THE HOUSE'));
                    SCGame.quickSavePlayer();
                }
                thisObj.isAnimating = false;
                animatedNode.destroy();
            });
        }
        
        if (currentbet > player.availableChips()) {
            this.currentbet = this.player.availableChips();
        }
    },
    
    wonBet: function(amt, isSplitHand){
        this.bj.split.setEnabled(false);
        this.bj.double.setEnabled(false);
        this.bj.hit.setEnabled(false);
        this.bj.stand.setEnabled(false);
        this.bj.deal.setEnabled(false);
        
        amt *= this.winMultiplier;
        var winningChips = new CardGame.Chips(amt, this.DEALER_X, this.DEALER_Y);
        var thisObj = this;
        this.addChild(winningChips.getNode());
        var animatedNode = new Animation.AnimatedNode();
        
        var xLoc, yLoc;
        this.isAnimating = true;
        if (isSplitHand) {
            xLoc = this.displayExtraBet.xlocation - Scale.droid.width(84);
            yLoc = this.displayExtraBet.ylocation;
        }
        else {
            xLoc = this.displayCurrentBet.xlocation - Scale.droid.width(84);
            yLoc = this.displayCurrentBet.ylocation;
        }
        SCGame.getSCAudio().playsound(9);
        animatedNode.runSequence(1.2, function(){
            winningChips.getNode().moveTo(xLoc, yLoc, 0.5);
        }, 0.4, function(){
            winningChips.getNode().moveTo(thisObj.PLAYER_X, thisObj.PLAYER_Y, 0.4);
        }, 0.0, function(){
            thisObj.removeChild(winningChips.getNode());
            winningChips.destroy();
            thisObj.isAnimating = false;
            animatedNode.destroy();
        });
    },
    
    tieBet: function(){
        //should only trigger for split hands
        var animatedNode = new Animation.AnimatedNode();
        var displayExtraBet = this.displayExtraBet;
        var thisObj = this;
        this.isAnimating = true;
        SCGame.getSCAudio().playsound(8);
        animatedNode.runSequence(0.5, function(){
            displayExtraBet.getNode().moveTo(thisObj.PLAYER_X, thisObj.PLAYER_Y, 0.4);
        }, 0.0, function(){
            thisObj.isAnimating = false;
            animatedNode.destroy();
        });
        
    },
    
    getDealerHand: function(){
        return this.dh;
    },
    getPlayerHand: function(){
        return this.ph;
    },
    getSplitHand: function(){
        return this.sh;
    },
    
    getDisplayCurrentBet: function(){
        return this.displayCurrentBet;
    },
    getDisplayGameResults: function(){
        return this.displayGameResults;
    },
    getCurrentBet: function(){
        return this.currentbet;
    },
    setCurrentBet: function(b){
        this.currentbet = b;
    },
    destroy: function($super){
        for (var i = 0; i < this._children.length; i++) {
            if (typeof this._children[i].durable === 'undefined') 
                this._children[i].destroy();
            else 
                if (this._children[i].durable == 0) 
                    this._children[i].destroy();
        }
        $super();
    },
    
    setTextVisible: function(v){
        this.compStat.setVisible(v);
        this.chipLabel.setVisible(v);
        this.compLabel.setVisible(v);
        this.chipsStat.setVisible(v);
    }
    
});

exports.BlackJack = Node.subclass({
    className: 'BlackJack',
    
    initialize: function(){
    
        this.Player1 = SCGame.getPlayer();
        this.gameNode = new GL2.Node();
        this.addChild(this.gameNode);
        
        //Background		
        var bgAnimationBasic = new GL2.Animation();
        bgAnimationBasic.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_menus/common-play-bg.png', 0, [Scale.droid.width(800), Scale.droid.height(480)], [0, 0], [0, 0, 1, 1]));
        bgAnimationBasic.setBlendEnabled(false);
        var bgBasic = new GL2.Sprite();
        bgBasic.setAnimation(bgAnimationBasic, 0);
        
        var bgAnimationGame = new GL2.Animation();
        bgAnimationGame.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_menus/play-bg-bj.png', 0, [Scale.droid.width(800), Scale.droid.height(480)], [0, 0], [0, 0, 1, 1]));
        var bgGame = new GL2.Sprite();
        bgGame.setAnimation(bgAnimationGame, 0);
        
        var bgAnimationTop = new GL2.Animation();
        bgAnimationTop.pushFrame(AtlasMap.getAnimationFrame('common-play-bg-top.png', 0, [0, 0]));
        var bgTop = new GL2.Sprite();
        bgTop.setAnimation(bgAnimationTop, 0);
        
        var bgNode = new GL2.Node();
        bgNode.setDepth(-1);
        bgNode.addChild(bgBasic);
        bgNode.addChild(bgGame);
        bgNode.addChild(bgTop);
        this.gameNode.addChild(bgNode);
        
        this.game = new Game(this, this.Player1);
        this.game.setDepth(5);
        this.gameNode.addChild(this.game);
        
        var thisObj = this;
        
        
        
        var gameInfoButtonActive = AtlasMap.getAnimationFrame('game-button-info-active.png', 0, [0, 0]);
        var gameInfoButtonInactive = AtlasMap.getAnimationFrame('game-button-info-inactive.png', 0, [0, 0]);
        
        var gameInfo = new Menu.AnimationFrameMenuItem();
        gameInfo.setFrames(gameInfoButtonInactive, gameInfoButtonActive, gameInfoButtonInactive);
        gameInfo.setAction(function(){
            thisObj.openTutorial();
        });
        
        this.tutorialMenu = new Menu.Menu([gameInfo]);
        this.tutorialMenu.alignItemsHorizontally(0);
        this.tutorialMenu.setDepth(5);
        this.tutorialMenu.setPosition(Scale.droid.width(tutorialMenu_xpos), Scale.droid.height(tutorialMenu_ypos));
        this.gameNode.addChild(this.tutorialMenu);
        
        
        this.tutorial = null;//new CardGame.BJTutorial(this);
        //********************
		if(!SCGame.getPlayer().getTutorialHistory().finishedBlackJackTutorial())
		{
			this.openTutorial();
		}

        var base = this.gameNode;
        var game2 = this.game;
        var player2 = this.Player1;
        
        var betBox1 = AtlasMap.getAnimationFrame('chip2_1.png', 0, [0, 0]);
        var betBox2 = AtlasMap.getAnimationFrame('chip2_5.png', 0, [0, 0]);
        var betBox3 = AtlasMap.getAnimationFrame('chip2_25.png', 0, [0, 0]);
        var betBox4 = AtlasMap.getAnimationFrame('chip2_100.png', 0, [0, 0]);
        var betBox5 = AtlasMap.getAnimationFrame('chip2_500.png', 0, [0, 0]);
        var betBox6 = AtlasMap.getAnimationFrame('chip2_1000.png', 0, [0, 0]);
        var betBox7 = AtlasMap.getAnimationFrame('chip2_5000.png', 0, [0, 0]);
        
        var gameButtonDisable = AtlasMap.getAnimationFrame('game-button-active.png', 0, [0, 0], undefined, true);
        var gameButtonEnable = AtlasMap.getAnimationFrame('game-button-inactive.png', 0, [0, 0], undefined, true);
        
        var item1 = new Menu.AnimationFrameMenuItem();
        item1.setFrames(betBox1, betBox1, betBox1);
        item1.setAction(function(){
            thisObj.betRules(base, game2, player2, 1);
        });
        
        var item2 = new Menu.AnimationFrameMenuItem();
        item2.setFrames(betBox2, betBox2, betBox2);
        item2.setAction(function(){
            thisObj.betRules(base, game2, player2, 5);
        });
        
        var item3 = new Menu.AnimationFrameMenuItem();
        item3.setFrames(betBox3, betBox3, betBox3);
        item3.setAction(function(){
            thisObj.betRules(base, game2, player2, 25);
        });
        
        var item4 = new Menu.AnimationFrameMenuItem();
        item4.setFrames(betBox4, betBox4, betBox4);
        item4.setAction(function(){
            thisObj.betRules(base, game2, player2, 100);
        });
        
        var item5 = new Menu.AnimationFrameMenuItem();
        item5.setFrames(betBox5, betBox5, betBox5);
        item5.setAction(function(){
            thisObj.betRules(base, game2, player2, 500);
        });
        
        var item6 = new Menu.AnimationFrameMenuItem();
        item6.setFrames(betBox6, betBox6, betBox6);
        item6.setAction(function(){
            thisObj.betRules(base, game2, player2, 1000);
        });
        
        var item7 = new Menu.AnimationFrameMenuItem();
        item7.setFrames(betBox7, betBox7, betBox7);
        item7.setAction(function(){
            thisObj.betRules(base, game2, player2, 5000);
        });
        
        this.menu = new Menu.Menu([item1, item2, item3, item4, item5, item6]);
        this.menu.alignItemsHorizontally(Scale.droid.width(5));
        this.menu._touchListener.getListener().setSize(new Core.Size(Core.Capabilities.getScreenHeight() + 100, Core.Capabilities.getScreenWidth()));
        this.menu.setDepth(5);
        
        //Continue with bet menu (bottom portion)
        var leave = new Menu.AnimationFrameMenuItem();
        leave.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Lobby');
        label.setPosition(leave.getSize().getWidth() / 2, leave.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
        leave.addChild(label);
        leave.setAction(function(){
            thisObj.quit();
        });
        
        var reset = new Menu.AnimationFrameMenuItem();
        reset.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Reset');
        label.setPosition(reset.getSize().getWidth() / 2, reset.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
        reset.addChild(label);
        reset.setAction(function(){
            thisObj.betRules(base, game2, player2, 0);
        });
        
        var done = new Menu.AnimationFrameMenuItem();
        done.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Done');
        label.setPosition(done.getSize().getWidth() / 2, done.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
        done.addChild(label);
        done.setAction(function(){
            thisObj.showPlayMenu();
        });
        
        this.menub = new Menu.Menu([leave, reset, done]);
        this.menub.setPosition(Scale.droid.width(0), Scale.droid.height(88));
        this.menub.alignItemsHorizontally(Scale.droid.width(5));
        this.menub._touchListener.getListener().setSize(new Core.Size(Core.Capabilities.getScreenHeight() + 100, Core.Capabilities.getScreenWidth()));
        this.menub.setDepth(5);
        
        this.betMenu = new Animation.AnimatedNode();
        this.betMenu.setDepth(8);
        this.betMenu.setPosition(Scale.droid.width(betMenu_xpos), Scale.droid.height(betMenu_ypos));
        this.betMenu.addChild(this.menu);
        this.betMenu.addChild(this.menub);
        this.gameNode.addChild(this.betMenu);
        
        //Play buttons
        this.exit = new Menu.AnimationFrameMenuItem();
        this.exit.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Lobby');
        label.setPosition(this.exit.getSize().getWidth() / 2, this.exit.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
        this.exit.addChild(label);
        this.exit.setAction(function(){
            thisObj.quit();
        });
        
        this.change = new Menu.AnimationFrameMenuItem();
        this.change.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Change Bet');
        label.setPosition(this.change.getSize().getWidth() / 2, this.change.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        this.change.addChild(label);
        this.change.setAction(function(){
            if (thisObj.game.dealt) 
                return;
            if (thisObj.game.isAnimating) 
                return;
            thisObj.showBetMenu();
        });
        
        this.split = new Menu.AnimationFrameMenuItem();
        this.split.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Split');
        label.setPosition(this.split.getSize().getWidth() / 2, this.split.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
		// if (SCGame.getSettings().getJapaneseOn()) {
		// 	SCStyle.applyFontStyle(label, SCStyle.FontStyle.SansB18);
		// }
		// else {
			SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		// }
        this.split.addChild(label);
        this.split.setAction(function(){
            if (!thisObj.game.dealt) 
                return;
            if (thisObj.game.isAnimating) 
                return;
            SCGame.getSCAudio().playsound(6);
            thisObj.game.split();
        });
        
        this.double = new Menu.AnimationFrameMenuItem();
        this.double.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Double');
        label.setPosition(this.double.getSize().getWidth() / 2, this.double.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
        this.double.addChild(label);
        this.double.setAction(function(){
            if (!thisObj.game.dealt) 
                return;
            if (thisObj.game.isAnimating) 
                return;
            SCGame.getSCAudio().playsound(6);
            thisObj.game.doubledown();
        });
        
        this.hit = new Menu.AnimationFrameMenuItem();
        this.hit.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Hit');
        label.setPosition(this.hit.getSize().getWidth() / 2, this.hit.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
        this.hit.addChild(label);
        this.hit.setAction(function(){
            if (!thisObj.game.dealt) 
                return;
            if (thisObj.game.isAnimating) 
                return;
            SCGame.getSCAudio().playsound(6);
            thisObj.game.hit();
        });
        
        this.stand = new Menu.AnimationFrameMenuItem();
        this.stand.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Stand');
        label.setPosition(this.stand.getSize().getWidth() / 2, this.stand.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
  			SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
        this.stand.addChild(label);
        this.stand.setAction(function(){
            if (!thisObj.game.dealt) 
                return;
            if (thisObj.game.isAnimating) 
                return;
            SCGame.getSCAudio().playsound(6);
            thisObj.game.stay();
        });
        
        this.deal = new Menu.AnimationFrameMenuItem();
        this.deal.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Deal');
        label.setPosition(this.deal.getSize().getWidth() / 2, this.deal.getSize().getHeight() / 2 - 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
        this.deal.addChild(label);
        this.deal.setAction(function(){
            if (thisObj.game.dealt) 
                return;
            if (thisObj.game.isAnimating) 
                return;
            
            if (thisObj.game.getCurrentBet() > 0) {
                var animatedNode = new Animation.AnimatedNode();
                SCGame.getSCAudio().playsound(6);
                animatedNode.runSequence(1.8, function(){
                    thisObj.game.deal();
                }, 0.1, function(){
                    thisObj.game.dealResult();
                    animatedNode.destroy();
                });
            }
            else {
                //SCGame.getSCAudio().playsound(11);
                var displayGameResults = new Animation.ScrollingLabel('Place your bet', Scale.droid.width(400), Scale.droid.height(230), Scale.droid.height(70), 3);
                //displayGameResults.label.setFontSize(Scale.droid.textSize(24));
                thisObj.game.addChild(displayGameResults);
            }
        });
        
        this.menu2 = new Menu.Menu([this.exit, this.change, this.split, this.double, this.hit, this.stand, this.deal]);
        this.menu2.alignItemsHorizontally(Scale.droid.width(-4));
        this.menu2._touchListener.getListener().setSize(new Core.Size(Core.Capabilities.getScreenHeight() + 100, Core.Capabilities.getScreenWidth()));
        this.menu2.setDepth(5);
        this.playMenu = new Animation.AnimatedNode();
        this.playMenu.setDepth(8);
        this.playMenu.setPosition(Scale.droid.width(342), Scale.droid.height(580));
        this.playMenu.addChild(this.menu2);
        this.gameNode.addChild(this.playMenu);
        
        
        //Left Bet Menu
        var sideButtonDisable = AtlasMap.getAnimationFrame('game-button-side1-active.png', 0, [0, 0]);
        var sideButtonEnable = AtlasMap.getAnimationFrame('game-button-side1-inactive.png', 0, [0, 0]);
        
        var incMaxBet = new Menu.AnimationFrameMenuItem();
        incMaxBet.setFrames(sideButtonEnable, sideButtonDisable, sideButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Increase\nMaxBet');
        label.setPosition(incMaxBet.getSize().getWidth() / 2, incMaxBet.getSize().getHeight() / 2 - 3);
        label.getLabel().setColor(0, 0, 0);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Increase');
        label.setPosition(incMaxBet.getSize().getWidth() / 2, incMaxBet.getSize().getHeight() / 2 - 16);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        incMaxBet.addChild(label);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Max Bet');
        label.setPosition(incMaxBet.getSize().getWidth() / 2, incMaxBet.getSize().getHeight() / 2 + 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB20);
        incMaxBet.addChild(label);
        incMaxBet.setAction(function(){
            thisObj.showIAP(true);
        });
        
        var sideButtonDisableSide2 = AtlasMap.getAnimationFrame('game-button-side2-inactive.png', 0, [0, 0], undefined, true);
        var maxBet = new Menu.AnimationFrameMenuItem();
        maxBet.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
        var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        label.setText('Max Bet');
        label.setPosition(maxBet.getSize().getWidth() / 2, 15);
        label.getLabel().setColor(1, 1, 0.8);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        maxBet.addChild(label);
        
        var yourBet = new Menu.AnimationFrameMenuItem();
        yourBet.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
        var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        label.setText('Your Bet');
        label.setPosition(yourBet.getSize().getWidth() / 2, 15);
        label.getLabel().setColor(1, 1, 0.8);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        yourBet.addChild(label);
        
        this.leftMenu = new Menu.Menu([incMaxBet, maxBet, yourBet]);
        this.leftMenu.alignItemsVertically(Scale.droid.height(2));
        this.leftMenu.setPosition(Scale.droid.width(leftMenu_xpos), Scale.droid.height(leftMenu_ypos));
        this.leftMenu.setDepth(2);
        this.gameNode.addChild(this.leftMenu);
        
        //Right Card Menu
        var theBank = new Menu.AnimationFrameMenuItem();
        theBank.setFrames(sideButtonEnable, sideButtonDisable, sideButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('The');
        label.setPosition(theBank.getSize().getWidth() / 2, theBank.getSize().getHeight() / 2 - 16);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        theBank.addChild(label);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Bank');
		// if (SCGame.getSettings().getJapaneseOn()) {
		// 	label.setPosition(theBank.getSize().getWidth() / 2, theBank.getSize().getHeight() / 2 - 6);
		// }
		// else {
			label.setPosition(theBank.getSize().getWidth() / 2, theBank.getSize().getHeight() / 2 + 4);
		// }
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB20);
        theBank.addChild(label);
        theBank.setAction(function(){
            thisObj.showIAP();
        });
        
        var dealer = new Menu.AnimationFrameMenuItem();
        dealer.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
        var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        label.setText('Dealer');
        label.setPosition(dealer.getSize().getWidth() / 2, 15);
        label.getLabel().setColor(1, 1, 0.8);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        dealer.addChild(label);
        
        var player = new Menu.AnimationFrameMenuItem();
        player.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
        var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        label.setText('Player');
        label.setPosition(player.getSize().getWidth() / 2, 15);
        label.getLabel().setColor(1, 1, 0.8);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        player.addChild(label);
        
        this.rightMenu = new Menu.Menu([theBank, dealer, player]);
        this.rightMenu.alignItemsVertically(Scale.droid.height(2));
        this.rightMenu.setPosition(Scale.droid.width(rightMenu_xpos), Scale.droid.height(rightMenu_ypos));
        this.rightMenu.setDepth(2);
        this.gameNode.addChild(this.rightMenu);
        
        
        //Bet value labels
        this.maxBetAmt = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        this.maxBetAmt.setText('' + this.game.maxBet());
        SCStyle.applyFontStyle(this.maxBetAmt, SCStyle.FontStyle.SerifB16);
        this.maxBetAmt.setPosition(Scale.droid.width(55), Scale.droid.height(247));
        this.game.addChild(this.maxBetAmt);
        
        this.currentBetAmt = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        this.currentBetAmt.setText('0');
        SCStyle.applyFontStyle(this.currentBetAmt, SCStyle.FontStyle.SerifB16);
        this.currentBetAmt.setPosition(Scale.droid.width(55), Scale.droid.height(313));
        this.game.addChild(this.currentBetAmt);
        
        //Top Menu
        var topChipsBar = AtlasMap.getAnimationFrame('common-bg-chips.png', 0, [0, 0]);
        var topCompsBar = AtlasMap.getAnimationFrame('common-bg-comps.png', 0, [0, 0]);
        
        var topChipAnimation = new GL2.Animation();
        topChipAnimation.pushFrame(topChipsBar);
        var chipBar = new GL2.Sprite();
        chipBar.setPosition(Scale.droid.width(topChipsBar_xpos), Scale.droid.height(topChipsBar_ypos));
        chipBar.setDepth(2);
        chipBar.setAnimation(topChipAnimation);
        this.gameNode.addChild(chipBar);
        
        var topCompAnimation = new GL2.Animation();
        topCompAnimation.pushFrame(topCompsBar);
        var compBar = new GL2.Sprite();
        compBar.setPosition(Scale.droid.width(topCompsBar_xpos), Scale.droid.height(topCompsBar_ypos));
        compBar.setDepth(2);
        compBar.setAnimation(topCompAnimation);
        this.gameNode.addChild(compBar);
        
//        var closeActive = AtlasMap.getAnimationFrame('common-bg-exit-active.png', 0, [0.5, 0.5]);
//        var closeInactive = AtlasMap.getAnimationFrame('common-bg-exit-inactive.png', 0, [0.5, 0.5]);
//        var closeAnimation = new Menu.AnimationFrameMenuItem();
//        closeAnimation.setFrames(closeInactive, closeActive, closeActive);
//        closeAnimation.setAction(function(){
//            thisObj.quit();
//        });
//        
//        var closeMenu = new Menu.Menu([closeAnimation]);
//        closeMenu.setPosition(Scale.droid.width(closeMenu_xpos), Scale.droid.height(closeMenu_ypos));
//        closeMenu.setDepth(2);
//        this.gameNode.addChild(closeMenu);
        
        var titleText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleText.setText('BLACKJACK');
        titleText.setDepth(3);
        titleText.getLabel().setColor(1, 1, 0.8);
        titleText.setPosition([Scale.droid.width(titleText_xpos), [Scale.droid.height(titleText_ypos)]]);
        SCStyle.applyFontStyle(titleText, SCStyle.FontStyle.SerifB32);
        this.gameNode.addChild(titleText);
        
        var titleSubText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleSubText.setText('B E A T  T H E  D E A L E R');
        titleSubText.setDepth(3);
        titleSubText.getLabel().setColor(1, 1, 0.8);
        titleSubText.setPosition([Scale.droid.width(titleSubText_xpos), [Scale.droid.height(titleSubText_ypos)]]);
        SCStyle.applyFontStyle(titleSubText, SCStyle.FontStyle.Serif12);
        this.gameNode.addChild(titleSubText);
        
        
        
        this.split.setEnabled(false);
        this.double.setEnabled(false);
        this.hit.setEnabled(false);
        this.stand.setEnabled(false);
        this.showBetMenu();
        
        this.setState(this.State.Playing);
        
        var screenSize = Util.screenSize(true);
        this._iapVisiblePosition = new Core.Point(0, 0);
        this._iapInvisiblePosition = new Core.Point(0, 0 + screenSize.getHeight() + Scale.droid.height(100));
        
    },
    
    
    State: {
    
        Playing: 0,
        IAPMenu: 1,
        Tutorial: 2,
    
    },
    
    
    showIAP: function(limit){
    	OpenSocialManager.showCommunityButton();
        if (typeof limit == 'undefined') 
            limit = false;
        
        SCGame.getSCAudio().playsound(10);
        
        this.setState(this.State.IAPMenu);
        this._iap = IAPManager.getMenuAndReset(limit);
        this._iap.setDelegate(this);
        this._iap.setDepth(12);
        this._iap.setPosition(this._iapInvisiblePosition.clone());
        
        
        this.addChild(this._iap);
        
        if (!this._iap.isAnimating()) {
            this._iap.moveTo(this._iapVisiblePosition.getX(), this._iapVisiblePosition.getY(), 0.5);
        }
        
    },
    
    closeIAPMenu: function(menu){
		OpenSocialManager.hideCommunityButton();
        if (!menu.isAnimating()) {
            menu.moveTo(this._iapInvisiblePosition.getX(), this._iapInvisiblePosition.getY(), 0.5);
        }
        SCGame.getSCAudio().playsound(11);
        
        var self = this;
        setTimeout(function(){
            self.setState(self.State.Playing);
            self.removeChild(menu);
        }, 0.5 * 1000);
    },
    
    setState: function(state){
        if (this._state == state) 
            return;
        
        switch (state) {
            case this.State.Playing:
                this.gameNode.setTouchable(true);
//                SCGame.showAd();
				this.game.setTextVisible(true);
                break;
            case this.State.IAPMenu:
//                SCGame.removeAd();
                this.gameNode.setTouchable(false);
				this.game.setTextVisible(false);
                break;
            case this.State.Tutorial:
                this.gameNode.setTouchable(false);
				this.game.setTextVisible(false);
                break;
            default:
                break;
                
        }
        this._state = state;
        
    },
    
    showBetMenu: function(){
        this.playMenu.moveTo(Scale.droid.width(342), Scale.droid.height(580), 0.5);
        this.betMenu.moveTo(Scale.droid.width(betMenu_xpos), Scale.droid.height(betMenu_ypos), 0.5);
    },
    
    showPlayMenu: function(){
        this.betMenu.moveTo(Scale.droid.width(342), Scale.droid.height(580), 0.5);
        this.playMenu.moveTo(Scale.droid.width(playMenu_xpos), Scale.droid.height(playMenu_ypos), 0.5);
    },
    
    getPlayer: function(){
        return this.Player1;
    },
    
    getGame: function(){
        return this.game;
    },
    
    openTutorial: function(){
        this.setState(this.State.Tutorial);
        if (this.tutorial == null) {
            this.tutorial = new CardGame.Tutorial(this, SCConstants.Game.BlackJack);
            this.addChild(this.tutorial.getNode())
        }
        SCGame.getSCAudio().playsound(10);
        
        this.tutorial.getNode().setPosition(Scale.droid.width(0), Scale.droid.height(800));
        this.tutorial.getNode().moveTo(Scale.droid.width(0), Scale.droid.height(0), 0.5);
    },
    
    closeTutorial: function(){
        SCGame.getSCAudio().playsound(11);
		SCGame.getPlayer().getTutorialHistory().setBlackJackTutorial(true);
		SCGame.quickSaveTutorialHistory();				
        this.tutorial.getNode().moveTo(Scale.droid.width(0), Scale.droid.height(800), 0.5);
        this.setState(this.State.Playing);
    },
    
    betRules: function(base, game, player, betvalue){
        this.base = base;
        this.bj = game;
        this.player = player;
        this.betvalue = betvalue;
        
        if (this.bj.dealt) 
            return;
        if (this.bj.isAnimating) 
            return;
        
        currentbet = this.game.getCurrentBet();
        if (this.betvalue == 0) {
            currentbet = 0;
            this.bj.getDisplayCurrentBet().setAmount(0);
            SCGame.getSCAudio().playsound(2);
        }
        else 
            SCGame.getSCAudio().playsound(1);
        
        if (!this.bj.getPlayerHand().canHit() && !this.bj.getSplitHand().canHit()) {
            currentbet += this.betvalue;
            if (currentbet > this.player.availableChips()) {
                currentbet = this.player.availableChips();
            }
            
            if (currentbet > this.bj.maxBet()) {
                currentbet = this.bj.maxBet();
            }
            
            this.bj.setCurrentBet(currentbet);
            this.bj.getDisplayCurrentBet().setAmount(currentbet);
            this.currentBetAmt.setText('' + currentbet);
        }
    },
    
    changeMaxBetDisplay: function(){
        this.maxBetAmt.setText('' + this.game.maxBet());
    },
    
    quit: function(){
        if (!this.game.dealt) {
            SCGame.returnToLobby(this);
        }
        else {
            var displayGameResults = new Animation.ScrollingLabel('Hand is not over', Scale.droid.width(400), Scale.droid.height(230), Scale.droid.height(70), 3);
            displayGameResults.label.setFontSize(Scale.droid.textSize(24));
            this.game.addChild(displayGameResults);
        }
    },
    
    destroy: function($super){
        for (var i = 0; i < this.gameNode._children.length; i++) {
            if (typeof this.gameNode._children[i].durable === 'undefined') 
                this.gameNode._children[i].destroy();
            else 
                if (this.gameNode._children[i].durable == 0) 
                    this.gameNode._children[i].destroy();
        }
        for (var i = 0; i < this.game._children.length; i++) {
            if (typeof this.game._children[i].durable === 'undefined') 
                this.game._children[i].destroy();
            else 
                if (this.game._children[i].durable == 0) 
                    this.game._children[i].destroy();
        }
        this.gameNode.destroy();
        this.game.destroy();
        $super();
    },
});


; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/TriCardWar'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/TriCardWar'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/TriCardWar'] = exports; var tutorialMenu_xpos = 736;
var tutorialMenu_ypos = 72;
var betMenu_xpos = 342; //includes chips and [leave,reset,done]
var betMenu_ypos = 341;
var playMenu_xpos = 342;
var playMenu_ypos = 428;
var leftMenu_xpos = -14;
var leftMenu_ypos = 210;
var rightMenu_xpos = 682;
var rightMenu_ypos = 212;
var closeMenu_xpos = 772;
var closeMenu_ypos = 28;
var titleText_xpos = 400;
var titleText_ypos = 25;
var titleSubText_xpos = 400;
var titleSubText_ypos = 51;

var chipLabel_xpos = 58;
var chipLabel_ypos = 42;
var compLabel_xpos = 680;
var compLabel_ypos = 42;
var chipStat_xpos = 58;
var chipStat_ypos = 24;
var compStat_xpos = 680;
var compStat_ypos = 24;
var topChipsBar_xpos = 8;
var topChipsBar_ypos = 12;
var topCompsBar_xpos = 633;
var topCompsBar_ypos = 12;

var Game = GL2.Node.subclass(
{
		
	classname: 'Game',
		
	initialize: function(tricardwar) {
		this.PLAYER_X = Scale.droid.width(400);
		this.PLAYER_Y = Scale.droid.height(580);
		this.DEALER_X = Scale.droid.width(400);
		this.DEALER_Y = Scale.droid.height(-100);
		
		this.PLAYER_CHIPS_X = Scale.droid.width(598);
        this.PLAYER_CHIPS_Y = Scale.droid.height(276);
		this.PLAYER_HAND_TOTAL_X = Scale.droid.width(745);
        this.PLAYER_HAND_TOTAL_Y = Scale.droid.height(313);
        this.DEALER_HAND_TOTAL_X = Scale.droid.width(745);
        this.DEALER_HAND_TOTAL_Y = Scale.droid.height(247);
		
		this.tricardwar = tricardwar;
		this.player = tricardwar.getPlayer();
			
		this.deck = new CardGame.Deck();
		this.ph = new CardGame.TriCardWarHand();
		this.dh = new CardGame.TriCardWarHand();
		this.ph.setLocation(Scale.droid.width(270),Scale.droid.height(330));
		this.dh.setLocation(Scale.droid.width(270),Scale.droid.height(130));
		
		//Labels
		this.displayCurrentBet = new CardGame.Chips(0,Scale.droid.width(this.PLAYER_CHIPS_X),Scale.droid.height(this.PLAYER_CHIPS_Y));
		this.addChild(this.displayCurrentBet.getNode());		
		
		this.chipLabel = new GL2.Text();
		this.chipLabel.setFontFamily('DroidSans-Regular');
		this.chipLabel.setFontSize(32);
		this.chipLabel.setText('Chip Count');
		this.chipLabel.setPosition(Scale.droid.width(chipLabel_xpos), Scale.droid.height(chipLabel_ypos));
		this.chipLabel.setAnchor(0,0.5);
		SCStyle.applyFontStyle(this.chipLabel, SCStyle.FontStyle.Sans14);
		this.chipLabel.setDepth(4);
		this.addChild(this.chipLabel);
		
		this.compLabel = new GL2.Text();
		this.compLabel.setFontFamily('DroidSans-Regular');
		this.compLabel.setFontSize(32);
		this.compLabel.setText('Comp Points');
		this.compLabel.setPosition(Scale.droid.width(compLabel_xpos), Scale.droid.height(compLabel_ypos));
		this.compLabel.setAnchor(0,0.5);
		SCStyle.applyFontStyle(this.compLabel, SCStyle.FontStyle.Sans14);
		this.compLabel.setDepth(4);
		this.addChild(this.compLabel);
		
		this.chipsStat = new PlayerStatNode(Player.StatType.Chips, SCGame.getPlayer());
        this.chipsStat.setDepth(4);
        this.chipsStat.setPosition(Scale.droid.width(chipStat_xpos), Scale.droid.height(chipStat_ypos));
        this.chipsStat.attachUpdateListener(SCGame.getPlayerUpdateEmitter());
        this.addChild(this.chipsStat);
		
		this.compStat = new PlayerStatNode(Player.StatType.Comp, SCGame.getPlayer());
        this.compStat.setDepth(4);
        this.compStat.setPosition(Scale.droid.width(compStat_xpos), Scale.droid.height(compStat_ypos));
        this.compStat.attachUpdateListener(SCGame.getPlayerUpdateEmitter());
        this.addChild(this.compStat);
		
		this.displayDealerHandTotal = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        SCStyle.applyFontStyle(this.displayDealerHandTotal, SCStyle.FontStyle.SerifB18);
        this.displayDealerHandTotal.setPosition(this.DEALER_HAND_TOTAL_X, this.DEALER_HAND_TOTAL_Y);
        this.addChild(this.displayDealerHandTotal);
        
        this.displayPlayerHandTotal = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        SCStyle.applyFontStyle(this.displayPlayerHandTotal, SCStyle.FontStyle.SerifB18);
        this.displayPlayerHandTotal.setPosition(this.PLAYER_HAND_TOTAL_X, this.PLAYER_HAND_TOTAL_Y);
        this.addChild(this.displayPlayerHandTotal);
		
		this.dealt = false;
		
		//Betting
		this.currentbet = 0;
	
		this.TEXT1_X = Scale.droid.width(400);
		this.TEXT1_Y = Scale.droid.height(230);
		this.TEXT2_X = Scale.droid.width(400);
		this.TEXT2_Y = Scale.droid.height(230);
		
		//Mods
		this.winMultiplier = 1; // Gain % extra per win
		this.returnMultiplier = 0; // Lose % less per loss
		var mods = SCGame.getStrip().getMods();
		
		for (x=0; x < mods.length; x++) {
			if (mods[x].getType() == mods[x].Type.AllWinningsIncrease) {
				this.winMultiplier += mods[x].getValue()/100;
			} else if (mods[x].getType() == mods[x].Type.AllLosingsDecrease) {
				this.returnMultiplier += mods[x].getValue()/100;
			}
		}
	},
	
	maxBet: function() {
		switch (this.player.getBettingTier()) {
			case 1:
				return 2000;
				break;
			case 2:
				return 5000;
				break;
			case 3:
				return 10000;
				break;
			case 4:
				return 25000;
				break;
			default:
				return 2000;
				break;
		}
	},
	
	deal: function(){
		//deal 3 cards
		if (this.dealt)
		{
			return;
		}
		
		if (this.currentbet == 0)
		{
			var displayGameResults = new Animation.ScrollingLabel('Must place a bet',this.TEXT1_X,this.TEXT1_Y,Scale.droid.height(70),3);
			this.addChild(displayGameResults);
			return;
		}
				
		this.dealt = true;
		this.tricardwar.exit.setEnabled(false);
		this.tricardwar.change.setEnabled(false);
		this.tricardwar.deal.setEnabled(false);
		
		this.displayCurrentBet.setPosition(this.PLAYER_CHIPS_X, this.PLAYER_CHIPS_Y);
		SCGame.updatePlayer(Player.StatType.Chips, -this.currentbet, true);
	
		this.deck.shuffle();
		this.ph.reset();
		this.dh.reset();
		this.ph.setActive(true);
		this.dh.setActive(true);
		this.displayPlayerHandTotal.setText('');
		this.displayDealerHandTotal.setText('');
		
		var card1 = this.deck.getCard();
		var card2 = this.deck.getCard();
		var card3 = this.deck.getCard();
		var card4 = this.deck.getCard();
		var card5 = this.deck.getCard();
		var card6 = this.deck.getCard();
		var ph = this.ph;
		var dh = this.dh;
		var tricardwar = this.tricardwar;
		var thisObj = this;
		var animatedNode = new Animation.AnimatedNode();
		animatedNode.runSequence(	0.2, function() { card1.setFaceup(); ph.addCard(card1); tricardwar.gameNode.addChild(card1.getNode()); thisObj.displayPlayerHandTotal.setText('' + thisObj.ph.handTotal());}, 
									0.2, function() { card2.setFaceup(); ph.addCard(card2); tricardwar.gameNode.addChild(card2.getNode()); thisObj.displayPlayerHandTotal.setText('' + thisObj.ph.handTotal());},
									0.6, function() { card3.setFaceup(); ph.addCard(card3); tricardwar.gameNode.addChild(card3.getNode()); thisObj.displayPlayerHandTotal.setText('' + thisObj.ph.handTotal());},
									0.2, function() { card4.setFaceup(); dh.addCard(card4); tricardwar.gameNode.addChild(card4.getNode()); thisObj.displayDealerHandTotal.setText('' + thisObj.dh.handTotal());},
									0.2, function() { card5.setFaceup(); dh.addCard(card5); tricardwar.gameNode.addChild(card5.getNode()); thisObj.displayDealerHandTotal.setText('' + thisObj.dh.handTotal());},  
									0.7, function() { card6.setFaceup(); dh.addCard(card6); tricardwar.gameNode.addChild(card6.getNode()); thisObj.displayDealerHandTotal.setText('' + thisObj.dh.handTotal());},
									1.2, function() {thisObj.evaluateTriCardWar();  }, 
									0, function() {
													SCGame.updatePlayer(Player.StatType.Experience, thisObj.player.getTier() + 1, true);
													SCGame.updatePlayer(Player.StatType.Comp, (thisObj.currentbet)/10000, true);
													SCGame.quickSavePlayer();
													thisObj.tricardwar.exit.setEnabled(true);
													thisObj.tricardwar.change.setEnabled(true);
													thisObj.tricardwar.deal.setEnabled(true);
													thisObj.ph.setActive(false);
													thisObj.dh.setActive(false); 
													thisObj.dealt = false;
										},
									0.1, function() { ph.setHandStatus(true); animatedNode.destroy(); } 
								);

	
	},
	
	
	evaluateTriCardWar: function() {
		var betWinAmt = 0;
		var playBetWon = false;

		if (this.ph.isGreater(this.dh)) {
			var displayGameResults = new Animation.ScrollingLabel('Win',this.TEXT1_X,this.TEXT1_Y,Scale.droid.height(70),3);
			this.addChild(displayGameResults);
			SCGame.updatePlayer(Player.StatType.Chips, (this.currentbet * this.winMultiplier) + this.currentbet, true);
			betWinAmt += this.currentbet * this.winMultiplier;
		}
		else  {
			var displayGameResults = new Animation.ScrollingLabel('Lose',this.TEXT1_X,this.TEXT1_Y,Scale.droid.height(70),3);
			this.addChild(displayGameResults);
			if (this.returnMultiplier > 0) {
				SCGame.updatePlayer(Player.StatType.Chips, this.currentbet * this.returnMultiplier, true);
			}		
			betWinAmt -= this.currentbet;
		}


		
		if (betWinAmt > 0) {
			this.wonBet(this.displayCurrentBet, betWinAmt);
		} else if (betWinAmt < 0){
			this.lostBet(this.displayCurrentBet);
		} else {
			this.displayCurrentBet.getNode().moveTo(this.PLAYER_CHIPS_X, this.PLAYER_CHIPS_X, 0.2);
		}
	},
	
		
	lostBet: function(chips) {
		this.tricardwar.deal.setEnabled(false);
		
		var chipsX = chips.getNode().getPosition().getX();
		var chipsY = chips.getNode().getPosition().getY();
		var currentbet = this.currentbet;
		var player = this.player;
		var thisObj = this;
		var animatedNode = new Animation.AnimatedNode();
		SCGame.getSCAudio().playsound(7);			
		animatedNode.runSequence(
			1.0, function() { chips.getNode().moveTo(thisObj.DEALER_X, thisObj.DEALER_Y, 0.5); }, 
			0.1, function() { if (currentbet > player.availableChips()) { chips.setAmount(player.availableChips()); } chips.getNode().setPosition(thisObj.PLAYER_X, thisObj.PLAYER_Y); }, 
			0.4, function(){ chips.getNode().moveTo(thisObj.PLAYER_CHIPS_X, thisObj.PLAYER_CHIPS_Y, 0.4);},
			0.0, function() {
				if (player.availableChips() < 50) {
					SCGame.updatePlayer(Player.StatType.Chips, 500-player.availableChips(), true);
					AlertLayer.showAlertNode(new GenericAlertNode('You\'re out of Chips, but the Casino Manager\nhas comp\'d you some extra cash.\nFor a real stack of chips, make sure to hit The Bank!','ON THE HOUSE'));
					SCGame.quickSavePlayer();
				}
				animatedNode.destroy();
			}
		);
		
		if (currentbet > player.availableChips()) {
            this.currentbet = this.player.availableChips();
        }
	},
	
	wonBet: function(chips, amt) {
		this.tricardwar.deal.setEnabled(false);
		
		var winningChips = new CardGame.Chips(amt,this.DEALER_X,this.DEALER_Y);
		var chipsX = chips.getNode().getPosition().getX();
		var chipsY = chips.getNode().getPosition().getY();
		var thisObj = this;
		this.addChild(winningChips.getNode());
		var animatedNode = new Animation.AnimatedNode();
		SCGame.getSCAudio().playsound(9);
		animatedNode.runSequence(
			1.2, function() { winningChips.getNode().moveTo(chipsX - Scale.droid.width(84), chipsY, 0.5); },  
			0.4, function() { winningChips.getNode().moveTo(thisObj.PLAYER_X, thisObj.PLAYER_Y, 0.4); },
			0.0, function() { thisObj.removeChild(winningChips.getNode()); winningChips.destroy(); animatedNode.destroy(); } 
		);
	},
	
	getDealerHand: function() {
		return this.dh;
	},
	getPlayerHand: function() {
		return this.ph;
	},
	
	getDisplayCurrentBet: function() {
		return this.displayCurrentBet;
	},
	
	getDisplayGameResults: function() {
		return this.displayGameResults;
	},	
	getCurrentBet: function() {
		return this.currentbet;
	},	
	setCurrentBet:function(b){
		this.currentbet = b;
	},

	destroy: function($super){
		for (var i = 0; i < this._children.length; i++) {
			if (typeof this._children[i].durable === 'undefined')
				this._children[i].destroy();
			else if (this._children[i].durable == 0)	
				this._children[i].destroy();
		}
		$super();
	},
	
    setTextVisible: function(v){
        this.compStat.setVisible(v);
        this.chipLabel.setVisible(v);
        this.compLabel.setVisible(v);
        this.chipsStat.setVisible(v);
    }	
});


exports.TriCardWar = Node.subclass(
{
	className: 'TriCardWar',
	
	initialize : function() {
		this.Player1 = SCGame.getPlayer();
		this.gameNode = new GL2.Node();
		this.addChild(this.gameNode);
		
		var bgAnimationBasic = new GL2.Animation();
		bgAnimationBasic.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_menus/common-play-bg.png', 0, [Scale.droid.width(800), Scale.droid.height(480)], [0,0], [0,0,1,1]));
		bgAnimationBasic.setBlendEnabled(false);
		var bgBasic = new GL2.Sprite();
		bgBasic.setAnimation(bgAnimationBasic,0);
		
		var bgAnimationGame = new GL2.Animation();
		bgAnimationGame.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_menus/play-bg-tricard.png', 0, [Scale.droid.width(800), Scale.droid.height(480)], [0,0], [0,0,1,1]));
		var bgGame = new GL2.Sprite();
		bgGame.setAnimation(bgAnimationGame,0);
		
		var bgAnimationTop = new GL2.Animation();
		bgAnimationTop.pushFrame(AtlasMap.getAnimationFrame('common-play-bg-top.png', 0, [0,0]));
		var bgTop = new GL2.Sprite(); 
		bgTop.setAnimation(bgAnimationTop,0);
		
		var bgNode = new GL2.Node();
		bgNode.setDepth(-1);
		bgNode.addChild(bgBasic);
		bgNode.addChild(bgGame);
		bgNode.addChild(bgTop);
		this.gameNode.addChild(bgNode);	
	
		this.game = new Game(this);
		this.game.setDepth(5);
		this.gameNode.addChild(this.game);
	 		       
		var thisObj = this;        
        
		var gameInfoButtonActive = AtlasMap.getAnimationFrame('game-button-info-active.png', 0, [0,0]);
		var gameInfoButtonInactive = AtlasMap.getAnimationFrame('game-button-info-inactive.png', 0, [0,0]);
		
		var gameInfo = new Menu.AnimationFrameMenuItem();
        gameInfo.setFrames(gameInfoButtonInactive, gameInfoButtonActive, gameInfoButtonInactive);
        gameInfo.setAction(function(){
			thisObj.openTutorial();
		});
		
	    this.tutorialMenu = new Menu.Menu([gameInfo]);
		this.tutorialMenu.alignItemsHorizontally(0);
        this.tutorialMenu.setDepth(5);
		this.tutorialMenu.setPosition(Scale.droid.width(tutorialMenu_xpos),Scale.droid.height(tutorialMenu_ypos));
		this.gameNode.addChild(this.tutorialMenu);

		if(!SCGame.getPlayer().getTutorialHistory().finishedTriCardWarTutorial())
		{
			this.openTutorial();
		}
		
		//********************
		var base = this.gameNode;
		var game2 = this.game;
		var player2 = this.Player1;
		
        var betBox1 = AtlasMap.getAnimationFrame('chip2_1.png', 0, [0,0]);
		var betBox2 = AtlasMap.getAnimationFrame('chip2_5.png', 0, [0,0]);
		var betBox3 = AtlasMap.getAnimationFrame('chip2_25.png', 0, [0,0]);
		var betBox4 = AtlasMap.getAnimationFrame('chip2_100.png', 0, [0,0]);
		var betBox5 = AtlasMap.getAnimationFrame('chip2_500.png', 0, [0,0]);
		var betBox6 = AtlasMap.getAnimationFrame('chip2_1000.png', 0, [0,0]);
		var betBox7 = AtlasMap.getAnimationFrame('chip2_5000.png', 0, [0,0]);
		
		var gameButtonDisable = AtlasMap.getAnimationFrame('game-button-active.png', 0, [0,0], undefined, true);
		var gameButtonEnable = AtlasMap.getAnimationFrame('game-button-inactive.png', 0, [0,0], undefined, true);
		
		var item1 = new Menu.AnimationFrameMenuItem();
        item1.setFrames(betBox1, betBox1, betBox1);
        item1.setAction(function(){
			thisObj.betRules(base,game2,player2,1);
		});
        
        var item2 = new Menu.AnimationFrameMenuItem();
        item2.setFrames(betBox2, betBox2, betBox2);
        item2.setAction(function(){
			thisObj.betRules(base,game2,player2,5);
		});
		
        var item3 = new Menu.AnimationFrameMenuItem();
        item3.setFrames(betBox3, betBox3, betBox3);
        item3.setAction(function(){
			thisObj.betRules(base,game2,player2,25);
		});
		
		var item4 = new Menu.AnimationFrameMenuItem();
        item4.setFrames(betBox4, betBox4, betBox4);
        item4.setAction(function(){
			thisObj.betRules(base,game2,player2,100);
		});
		
		var item5 = new Menu.AnimationFrameMenuItem();
        item5.setFrames(betBox5, betBox5, betBox5);
        item5.setAction(function(){
			thisObj.betRules(base,game2,player2,500);
		});
        
        var item6 = new Menu.AnimationFrameMenuItem();
        item6.setFrames(betBox6, betBox6, betBox6);
        item6.setAction(function(){
			thisObj.betRules(base,game2,player2,1000);
		});
		
        var item7 = new Menu.AnimationFrameMenuItem();
        item7.setFrames(betBox7, betBox7, betBox7);
        item7.setAction(function(){
			thisObj.betRules(base,game2,player2,5000);
		});
		
	    this.menu = new Menu.Menu([item1, item2, item3, item4, item5, item6]);
		this.menu.alignItemsHorizontally(Scale.droid.width(5));
		this.menu._touchListener.getListener().setSize(new Core.Size(Core.Capabilities.getScreenHeight()+100, Core.Capabilities.getScreenWidth()));
        this.menu.setDepth(5);
		
		//Continue with bet menu (bottom portion)
		var leave = new Menu.AnimationFrameMenuItem();
        leave.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Lobby');
		label.setPosition(leave.getSize().getWidth()/2, leave.getSize().getHeight()/2-3);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		leave.addChild(label);
        leave.setAction(function(){
			thisObj.quit();
		});
		
		var reset = new Menu.AnimationFrameMenuItem();
        reset.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Reset');
		label.setPosition(reset.getSize().getWidth()/2, reset.getSize().getHeight()/2-3);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		reset.addChild(label);
        reset.setAction(function(){
			thisObj.betRules(base,game2,player2,0);
		});
		
		var done = new Menu.AnimationFrameMenuItem();
        done.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Done');
		label.setPosition(done.getSize().getWidth()/2, done.getSize().getHeight()/2-3);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		done.addChild(label);
        done.setAction(function(){
			thisObj.showPlayMenu();
		});
		
		this.menub = new Menu.Menu([leave, reset, done]);
		this.menub.setPosition(Scale.droid.width(0), Scale.droid.height(88));
		this.menub.alignItemsHorizontally(Scale.droid.width(5));
		this.menub._touchListener.getListener().setSize(new Core.Size(Core.Capabilities.getScreenHeight()+100, Core.Capabilities.getScreenWidth()));
        this.menub.setDepth(5);
		
		this.betMenu = new Animation.AnimatedNode();
		this.betMenu.setDepth(8);
		this.betMenu.setPosition(Scale.droid.width(betMenu_xpos), Scale.droid.height(betMenu_ypos));
		this.betMenu.addChild(this.menu);
		this.betMenu.addChild(this.menub);
		this.gameNode.addChild(this.betMenu);

        //Play buttons
		var gameButtonDisable = AtlasMap.getAnimationFrame('game-button-active.png', 0, [0,0]);
		var gameButtonEnable = AtlasMap.getAnimationFrame('game-button-inactive.png', 0, [0,0]);
		
		this.exit = new Menu.AnimationFrameMenuItem();
        this.exit.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Lobby');
		label.setPosition(this.exit.getSize().getWidth()/2, this.exit.getSize().getHeight()/2-3);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		this.exit.addChild(label);
        this.exit.setAction(function(){
			thisObj.quit();		
		});
        
        this.change = new Menu.AnimationFrameMenuItem();
        this.change.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Change Bet');
		label.setPosition(this.change.getSize().getWidth()/2, this.change.getSize().getHeight()/2-3);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
		this.change.addChild(label);
        this.change.setAction(function(){
			if (thisObj.game.dealt) return;
			if (thisObj.game.isAnimating) return;
			thisObj.game.getDisplayCurrentBet().setPosition(thisObj.game.PLAYER_CHIPS_X,thisObj.game.PLAYER_CHIPS_Y);
			thisObj.showBetMenu();
		});
		
        this.deal = new Menu.AnimationFrameMenuItem();
        this.deal.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Deal');
		label.setPosition(this.deal.getSize().getWidth()/2, this.deal.getSize().getHeight()/2-3);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		this.deal.addChild(label);
        this.deal.setAction(function(){
			if (thisObj.game.dealt) return;
			if (thisObj.game.isAnimating) return;
			
			// if (!thisObj.game.ph.getHandStatus()) {
			// 	return;
			// } else {
				thisObj.game.ph.setHandStatus(false);
				var animatedNode = new Animation.AnimatedNode();
				animatedNode.runSequence(
					0.5, function() { thisObj.game.deal(); }, 
					0.1, function() { animatedNode.destroy(); }
				);
			// }
					
		});
		
        this.menu2 = new Menu.Menu([this.exit, this.change, this.deal]);
		this.menu2.alignItemsHorizontally(Scale.droid.width(10));
        this.menu2._touchListener.getListener().setSize(new Core.Size(Core.Capabilities.getScreenHeight()+100, Core.Capabilities.getScreenWidth()));
        this.menu2.setDepth(5);
		this.playMenu = new Animation.AnimatedNode();
		this.playMenu.setDepth(8);
		this.playMenu.setPosition(Scale.droid.width(342), Scale.droid.height(580));
		this.playMenu.addChild(this.menu2);
		this.gameNode.addChild(this.playMenu);
		
        //Left Bet Menu
        var sideButtonDisable = AtlasMap.getAnimationFrame('game-button-side1-active.png', 0, [0, 0]);
        var sideButtonEnable = AtlasMap.getAnimationFrame('game-button-side1-inactive.png', 0, [0, 0]);
        
        var incMaxBet = new Menu.AnimationFrameMenuItem();
        incMaxBet.setFrames(sideButtonEnable, sideButtonDisable, sideButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Increase\nMaxBet');
        label.setPosition(incMaxBet.getSize().getWidth() / 2, incMaxBet.getSize().getHeight() / 2 - 3);
        label.getLabel().setColor(0, 0, 0);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Increase');
        label.setPosition(incMaxBet.getSize().getWidth() / 2, incMaxBet.getSize().getHeight() / 2 - 16);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        incMaxBet.addChild(label);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Max Bet');
        label.setPosition(incMaxBet.getSize().getWidth() / 2, incMaxBet.getSize().getHeight() / 2 + 4);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB20);
        incMaxBet.addChild(label);
        incMaxBet.setAction(function(){
            thisObj.showIAP(true);
        });
        
        var sideButtonDisableSide2 = AtlasMap.getAnimationFrame('game-button-side2-inactive.png', 0, [0, 0], undefined, true);
        var maxBet = new Menu.AnimationFrameMenuItem();
        maxBet.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
        var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        label.setText('Max Bet');
        label.setPosition(maxBet.getSize().getWidth() / 2, 15);
        label.getLabel().setColor(1, 1, 0.8);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        maxBet.addChild(label);
        
        var yourBet = new Menu.AnimationFrameMenuItem();
        yourBet.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
        var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        label.setText('Your Bet');
        label.setPosition(yourBet.getSize().getWidth() / 2, 15);
        label.getLabel().setColor(1, 1, 0.8);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        yourBet.addChild(label);
        
        this.leftMenu = new Menu.Menu([incMaxBet, maxBet, yourBet]);
        this.leftMenu.alignItemsVertically(Scale.droid.height(2));
        this.leftMenu.setPosition(Scale.droid.width(leftMenu_xpos), Scale.droid.height(leftMenu_ypos));
        this.leftMenu.setDepth(2);
        this.gameNode.addChild(this.leftMenu);
        
        //Right Card Menu
        var theBank = new Menu.AnimationFrameMenuItem();
        theBank.setFrames(sideButtonEnable, sideButtonDisable, sideButtonDisable);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('The');
        label.setPosition(theBank.getSize().getWidth() / 2, theBank.getSize().getHeight() / 2 - 16);
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        theBank.addChild(label);
        var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        label.setText('Bank');
		// if (SCGame.getSettings().getJapaneseOn()) {
		// 	label.setPosition(theBank.getSize().getWidth() / 2, theBank.getSize().getHeight() / 2 - 6);
		// }
		// else {
			label.setPosition(theBank.getSize().getWidth() / 2, theBank.getSize().getHeight() / 2 + 4);
		// }
        label.getLabel().setColor(0, 0, 0);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB20);
        theBank.addChild(label);
        theBank.setAction(function(){
            thisObj.showIAP();
        });
        
        var dealer = new Menu.AnimationFrameMenuItem();
        dealer.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
        var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        label.setText('Dealer');
        label.setPosition(dealer.getSize().getWidth() / 2, 15);
        label.getLabel().setColor(1, 1, 0.8);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        dealer.addChild(label);
        
        var player = new Menu.AnimationFrameMenuItem();
        player.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
        var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        label.setText('Player');
        label.setPosition(player.getSize().getWidth() / 2, 15);
        label.getLabel().setColor(1, 1, 0.8);
        SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
        player.addChild(label);
        
        this.rightMenu = new Menu.Menu([theBank, dealer, player]);
        this.rightMenu.alignItemsVertically(Scale.droid.height(2));
        this.rightMenu.setPosition(Scale.droid.width(rightMenu_xpos), Scale.droid.height(rightMenu_ypos));
        this.rightMenu.setDepth(2);
        this.gameNode.addChild(this.rightMenu);
        
        
        //Bet value labels
        this.maxBetAmt = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        this.maxBetAmt.setText('' + this.game.maxBet());
        SCStyle.applyFontStyle(this.maxBetAmt, SCStyle.FontStyle.SerifB16);
        this.maxBetAmt.setPosition(Scale.droid.width(55), Scale.droid.height(247));
        this.game.addChild(this.maxBetAmt);
        
        this.currentBetAmt = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        this.currentBetAmt.setText('0');
        SCStyle.applyFontStyle(this.currentBetAmt, SCStyle.FontStyle.SerifB16);
        this.currentBetAmt.setPosition(Scale.droid.width(55), Scale.droid.height(313));
        this.game.addChild(this.currentBetAmt);
	
		//Top Menu
		var topChipsBar = AtlasMap.getAnimationFrame('common-bg-chips.png', 0, [0,0]);
		var topCompsBar = AtlasMap.getAnimationFrame('common-bg-comps.png', 0, [0,0]);
		
		var topChipAnimation = new GL2.Animation();
		topChipAnimation.pushFrame(topChipsBar);
		var chipBar = new GL2.Sprite();
		chipBar.setPosition(Scale.droid.width(topChipsBar_xpos),Scale.droid.height(topChipsBar_ypos));
		chipBar.setDepth(2);
		chipBar.setAnimation(topChipAnimation);
		this.gameNode.addChild(chipBar);
		
		var topCompAnimation = new GL2.Animation();
		topCompAnimation.pushFrame(topCompsBar);
		var compBar = new GL2.Sprite();
		compBar.setPosition(Scale.droid.width(topCompsBar_xpos),Scale.droid.height(topCompsBar_ypos));
		compBar.setDepth(2);
		compBar.setAnimation(topCompAnimation);
		this.gameNode.addChild(compBar);

		var titleText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleText.setText('3 CARD WAR');
        titleText.setDepth(3);
        titleText.getLabel().setColor(1,1,0.8);
        titleText.setPosition([Scale.droid.width(titleText_xpos), [Scale.droid.height(titleText_ypos)]]);
		SCStyle.applyFontStyle(titleText, SCStyle.FontStyle.Serif32);        
        this.gameNode.addChild(titleText);
        
        var titleSubText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleSubText.setText('B E A T  T H E  D E A L E R');
        titleSubText.setDepth(3);
        titleSubText.getLabel().setColor(1,1,0.8);
        titleSubText.setPosition([Scale.droid.width(titleSubText_xpos), [Scale.droid.height(titleSubText_ypos)]]);
		SCStyle.applyFontStyle(titleSubText, SCStyle.FontStyle.Serif12);        
        this.gameNode.addChild(titleSubText);

				
        this.setState(this.State.Playing);
		
        var screenSize = Util.screenSize(true);		
        this._iapVisiblePosition = new Core.Point(0, 0);
        this._iapInvisiblePosition = new Core.Point(0, 0 + screenSize.getHeight() + Scale.droid.height(100));		

	},
	
    State: {
    
        Playing: 0,
        IAPMenu: 1,
        Tutorial: 2,
    
    },
    
    
    showIAP: function(limit){
		OpenSocialManager.showCommunityButton();
		if (typeof limit == 'undefined') limit = false;
		
 		SCGame.getSCAudio().playsound(10);		
   
        this.setState(this.State.IAPMenu);
        this._iap = IAPManager.getMenuAndReset( limit );
        this._iap.setDelegate(this);
        this._iap.setDepth(12);
        this._iap.setPosition(this._iapInvisiblePosition.clone());
		
		
        this.addChild(this._iap);
        
        if (!this._iap.isAnimating()) {
            this._iap.moveTo(this._iapVisiblePosition.getX(), this._iapVisiblePosition.getY(), 0.5);
        }
        
    },
	
    closeIAPMenu: function(menu){
		OpenSocialManager.hideCommunityButton();		
		SCGame.getSCAudio().playsound(11);		

        if (!menu.isAnimating()) {
            menu.moveTo(this._iapInvisiblePosition.getX(), this._iapInvisiblePosition.getY(), 0.5);
        }

        var self = this;
        setTimeout(function(){
            self.setState(self.State.Playing);
            self.removeChild(menu);
        }, 0.5 * 1000);
    },	
    
    setState: function(state){
        if (this._state == state) 
            return;
        
        switch (state) {
            case this.State.Playing:
                this.gameNode.setTouchable(true);
//                SCGame.showAd();
				this.game.setTextVisible(true);
                break;
            case this.State.IAPMenu:
//                SCGame.removeAd();
                this.gameNode.setTouchable(false);
				this.game.setTextVisible(false);
                break;
            case this.State.Tutorial:
                this.gameNode.setTouchable(false);
				this.game.setTextVisible(false);
                break;
            default:
                break;
                
        }
        this._state = state;
        
    },
	
	showBetMenu:function(){
		this.playMenu.moveTo(Scale.droid.width(342),Scale.droid.height(580),0.5);
		this.betMenu.moveTo(Scale.droid.width(betMenu_xpos),Scale.droid.height(betMenu_xpos),0.5);
	},

	showPlayMenu:function(){
		this.betMenu.moveTo(Scale.droid.width(342),Scale.droid.height(580),0.5);
		this.playMenu.moveTo(Scale.droid.width(playMenu_xpos),Scale.droid.height(playMenu_ypos),0.5);
	},


	getPlayer: function()
	{
		return this.Player1;
	},

	getGame: function() {
		return this.game;
	},
	
	openTutorial: function() {
        this.setState(this.State.Tutorial);
		if (this.tutorial == null) {
			this.tutorial = new CardGame.Tutorial(this,  SCConstants.Game.TriCardWar);
			this.addChild(this.tutorial.getNode())
		};
		SCGame.getSCAudio().playsound(10);		
		
		this.tutorial.getNode().setPosition(Scale.droid.width(0), Scale.droid.height(800));
		this.tutorial.getNode().moveTo(Scale.droid.width(0),Scale.droid.height(0), 0.5);
	},
	
	closeTutorial: function() {
		SCGame.getSCAudio().playsound(11);		
		SCGame.getPlayer().getTutorialHistory().setTriCardWarTutorial(true);
		SCGame.quickSaveTutorialHistory();		
		this.tutorial.getNode().moveTo(Scale.droid.width(0),Scale.droid.height(800), 0.5);
        this.setState(this.State.Playing);
	},
	
	betRules: function(base, game, player, betvalue){
        this.base = base;
        this.tricardwar = game;
        this.player = player;
        this.betvalue = betvalue;

        if (this.tricardwar.dealt) 
            return;
        if (this.tricardwar.isAnimating) 
            return;

        currentbet = this.game.getCurrentBet();
        if (this.betvalue == 0) {
            currentbet = 0;
		
            this.tricardwar.getDisplayCurrentBet().setAmount(0);
            SCGame.getSCAudio().playsound(2);
        }
        else 
            SCGame.getSCAudio().playsound(1);

        currentbet += this.betvalue;
        if (currentbet > this.player.availableChips()) {
            currentbet = this.player.availableChips();
        }

        if (currentbet > this.tricardwar.maxBet()) {
            currentbet = this.tricardwar.maxBet();
        }

        this.tricardwar.setCurrentBet(currentbet);
        this.tricardwar.getDisplayCurrentBet().setAmount(currentbet);
        this.currentBetAmt.setText('' + currentbet);
    },
   
	
	changeMaxBetDisplay: function() {
		this.maxBetAmt.setText(''+this.game.maxBet());
	},
	
	quit: function() {
		if (!this.game.dealt) {
			SCGame.returnToLobby(this);
		}
		else {	
//			SCGame.getSCAudio().playsound(11);
			var displayGameResults = new Animation.ScrollingLabel('Hand is not over',Scale.droid.width(400),Scale.droid.height(240),Scale.droid.height(70),3);
			displayGameResults.label.setFontSize(Scale.droid.textSize(24));
			this.game.addChild(displayGameResults);
		}
	},
	
	destroy: function($super) {
		for (var i = 0; i < this.gameNode._children.length; i++) {
			if (typeof this.gameNode._children[i].durable === 'undefined')
				this.gameNode._children[i].destroy();
			else if (this.gameNode._children[i].durable == 0)	
				this.gameNode._children[i].destroy();
		}
		for (var i = 0; i < this.game._children.length; i++) {
			if (typeof this.game._children[i].durable === 'undefined')
				this.game._children[i].destroy();
			else if (this.game._children[i].durable == 0)	
				this.game._children[i].destroy();
		}
		this.gameNode.destroy();
		this.game.destroy();
		$super();
	},
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/Baccarat'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Baccarat'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Baccarat'] = exports; var tutorialMenu_xpos = 736;
var tutorialMenu_ypos = 72;
var betMenu_xpos = 342; //includes chips and [leave,reset,done]
var betMenu_ypos = 341;
var playMenu_xpos = 342;
var playMenu_ypos = 428;
var leftMenu_xpos = -14;
var leftMenu_ypos = 210;
var rightMenu_xpos = 682;
var rightMenu_ypos = 210;
var closeMenu_xpos = 772;
var closeMenu_ypos = 28;
var titleText_xpos = 400;
var titleText_ypos = 25;
var titleSubText_xpos = 400;
var titleSubText_ypos = 51;

var chipLabel_xpos = 58;
var chipLabel_ypos = 42;
var compLabel_xpos = 680;
var compLabel_ypos = 42;
var chipStat_xpos = 58;
var chipStat_ypos = 24;
var compStat_xpos = 680;
var compStat_ypos = 24;
var topChipsBar_xpos = 8;
var topChipsBar_ypos = 12;
var topCompsBar_xpos = 633;
var topCompsBar_ypos = 12;

var Game = GL2.Node.subclass(
{
		
	classname: 'Game',
	
	initialize: function(baccarat,player) {
		
		this.PLAYER_X = Scale.droid.width(400);
		this.PLAYER_Y = Scale.droid.height(580);
		this.DEALER_X = Scale.droid.width(400);
		this.DEALER_Y = Scale.droid.height(-100);
				
		this.baccarat = baccarat;
		this.player = player;
		
		this.deck = new CardGame.Deck();
		this.playerHand = new CardGame.BaccaratHand();
		this.bankerHand = new CardGame.BaccaratHand();
		this.playerHand.setLocation(Scale.droid.width(135),Scale.droid.height(200));
		this.bankerHand.setLocation(Scale.droid.width(500),Scale.droid.height(200));
		
		
		this.chipLabel = new GL2.Text();
		this.chipLabel.setFontFamily('DroidSans-Regular');
		this.chipLabel.setFontSize(32);
		this.chipLabel.setText('Chip Count');
		this.chipLabel.setPosition(Scale.droid.width(chipLabel_xpos), Scale.droid.height(chipLabel_ypos));
		this.chipLabel.setAnchor(0,0.5);
		this.chipLabel.setDepth(4);
		SCStyle.applyFontStyle(this.chipLabel, SCStyle.FontStyle.Sans14);
		this.addChild(this.chipLabel);
		
		this.compLabel = new GL2.Text();
		this.compLabel.setFontFamily('DroidSans-Regular');
		this.compLabel.setFontSize(32);
		this.compLabel.setText('Comp Points');
		this.compLabel.setPosition(Scale.droid.width(compLabel_xpos), Scale.droid.height(compLabel_ypos));
		this.compLabel.setAnchor(0,0.5);
		this.compLabel.setDepth(4);
		SCStyle.applyFontStyle(this.compLabel, SCStyle.FontStyle.Sans14);
		this.addChild(this.compLabel);
		
		this.chipsStat = new PlayerStatNode(Player.StatType.Chips, SCGame.getPlayer());
        this.chipsStat.setDepth(4);
        this.chipsStat.setPosition(Scale.droid.width(chipStat_xpos), Scale.droid.height(chipStat_ypos));
        this.chipsStat.attachUpdateListener(SCGame.getPlayerUpdateEmitter());
        this.addChild(this.chipsStat);
		
		this.compStat = new PlayerStatNode(Player.StatType.Comp, SCGame.getPlayer());
        this.compStat.setDepth(4);
        this.compStat.setPosition(Scale.droid.width(compStat_xpos), Scale.droid.height(compStat_ypos));
        this.compStat.attachUpdateListener(SCGame.getPlayerUpdateEmitter());
        this.addChild(this.compStat);
		
		
		this.displayCurrentBetTie = new CardGame.Chips(0,Scale.droid.width(400),Scale.droid.height(116));
		this.addChild(this.displayCurrentBetTie.getNode());
		
		this.displayCurrentBetBanker = new CardGame.Chips(0,Scale.droid.width(400),Scale.droid.height(214));
		this.addChild(this.displayCurrentBetBanker.getNode());
		
		this.displayCurrentBetPlayer = new CardGame.Chips(0,Scale.droid.width(400),Scale.droid.height(312));
		this.addChild(this.displayCurrentBetPlayer.getNode());
		
		this.displayGameHistory = new Array();
		
		this.displayPlayerHandTotal = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		this.displayPlayerHandTotal.setPosition(Scale.droid.width(745), Scale.droid.height(313));
		SCStyle.applyFontStyle(this.displayPlayerHandTotal, SCStyle.FontStyle.SerifB18);
		this.addChild(this.displayPlayerHandTotal);
		
				
		this.displayBankerHandTotal = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		this.displayBankerHandTotal.setPosition(Scale.droid.width(745), Scale.droid.height(247));
		SCStyle.applyFontStyle(this.displayBankerHandTotal, SCStyle.FontStyle.SerifB18);
		this.addChild(this.displayBankerHandTotal);
		
		
		this.currentbeton = -1;
		this.currentbettie = 0;
		this.currentbetplayer = 0;
		this.currentbetbanker = 0;
		
		//Mods
		this.winMultiplier = 1; // Gain % extra per win
		this.returnMultiplier = 0; // Lose % less per loss
		var mods = SCGame.getStrip().getMods();
		
		for (x=0; x < mods.length; x++) {
			if (mods[x].getType() == mods[x].Type.AllWinningsIncrease) {
				this.winMultiplier += mods[x].getValue()/100;
			} else if (mods[x].getType() == mods[x].Type.AllLosingsDecrease) {
				this.returnMultiplier += mods[x].getValue()/100;
			}
		}
		
		this.isPlaying = false;
		
	},
	
	maxBet: function() {
		switch (this.player.getBettingTier()) {
			case 1:
				return 2000;
				break;
			case 2:
				return 5000;
				break;
			case 3:
				return 10000;
				break;
			case 4:
				return 25000;
				break;
			default:
				return 2000;
				break;
		}
	},
	
	deal: function(){
		
		if (this.isPlaying) return;

		if 	(this.currentbettie + this.currentbetplayer + this.currentbetbanker == 0)
		{
//			SCGame.getSCAudio().playsound(11);
			var displayGameResults = new Animation.ScrollingLabel('Must place a bet',Scale.droid.width(400),Scale.droid.height(240),Scale.droid.height(70),3);
			this.addChild(displayGameResults);			
			return;
		}
		
		if ((this.currentbettie + this.currentbetplayer + this.currentbetbanker) > this.player.availableChips())
		{
//			SCGame.getSCAudio().playsound(11);
			var displayGameResults = new Animation.ScrollingLabel('Lower your bet',Scale.droid.width(400),Scale.droid.height(240),Scale.droid.height(70),3);
			this.addChild(displayGameResults);
			return;
		}
		
		this.isPlaying = true;
		this.playerHand.setActive(true);
		this.bankerHand.setActive(true);
		
		this.baccarat.exit.setEnabled(false);
		this.baccarat.change.setEnabled(false);
		this.baccarat.deal.setEnabled(false);

		SCGame.updatePlayer(Player.StatType.Chips, -this.currentbettie, true);
		SCGame.updatePlayer(Player.StatType.Chips, -this.currentbetplayer, true);
		SCGame.updatePlayer(Player.StatType.Chips, -this.currentbetbanker, true);	
		
		this.deck.shuffle();
		this.playerHand.reset();
		this.bankerHand.reset();
		this.displayBankerHandTotal.reset();
		this.displayPlayerHandTotal.reset();
		
		var card1 = this.deck.getCard();
		var card2 = this.deck.getCard();
		var card3 = this.deck.getCard();
		var card4 = this.deck.getCard();
		var card5 = this.deck.getCard();
		var card6 = this.deck.getCard();
		var playerHand = this.playerHand;
		var bankerHand = this.bankerHand;
		var displayPlayerHandTotal = this.displayPlayerHandTotal;
		var displayBankerHandTotal = this.displayBankerHandTotal;
		var baccarat = this.baccarat;
		var thisObj = this;
		
		var animatedNode = new Animation.AnimatedNode();
		animatedNode.runSequence(	0.4, function() { card1.setFaceup(); playerHand.addCard(card1); baccarat.gameNode.addChild(card1.getNode()); displayPlayerHandTotal.setText(''+playerHand.HandTotal()); }, 
									0.4, function() { card2.setFaceup(); bankerHand.addCard(card2); baccarat.gameNode.addChild(card2.getNode()); displayBankerHandTotal.setText(''+bankerHand.HandTotal()); },
									0.4, function() { card3.setFaceup(); playerHand.addCard(card3); baccarat.gameNode.addChild(card3.getNode()); displayPlayerHandTotal.setText(''+playerHand.HandTotal()); },
									0.8, function() { card4.setFaceup(); bankerHand.addCard(card4); baccarat.gameNode.addChild(card4.getNode()); displayBankerHandTotal.setText(''+bankerHand.HandTotal()); },
									0.0, function() { thisObj.dealPlayerCard(); animatedNode.destroy(); }
								);
	},
	
	
	
	dealPlayerCard: function()
	{
		if (this.bankerHand.HandTotal() == 8 || this.bankerHand.HandTotal() == 9 || this.playerHand.HandTotal()==8 || this.playerHand.HandTotal() == 9) {
			this.results();
		} else if (this.playerHand.HandTotal() <= 5) {
			var playerCard = this.deck.getCard();
			var playerHand = this.playerHand;
			var displayPlayerHandTotal = this.displayPlayerHandTotal;
			var baccarat = this.baccarat;
			var thisObj = this;
			playerCard.setFaceup();
			
			var animatedNode = new Animation.AnimatedNode();
			animatedNode.runSequence(0.8, function() { playerHand.addCard(playerCard); baccarat.gameNode.addChild(playerCard.getNode()); displayPlayerHandTotal.setText(''+playerHand.HandTotal()); }, 0.0, function() {thisObj.dealBankerCard(); animatedNode.destroy();});
		} else {
			this.dealBankerCard();
		}
	},
	
	dealBankerCard:function() {
		var dealBanker = false;
		
		if (this.bankerHand.HandTotal() <=5 && this.playerHand.cards.length == 2) {
			dealBanker = true;
		} else if (this.playerHand.cards.length == 3) {
			if (this.playerHand.cards[2].getNumber() == 2 || this.playerHand.cards[2].getNumber() == 3) {
				if (this.bankerHand.HandTotal() <= 4) {
					dealBanker = true;
				}
			} else if (this.playerHand.cards[2].getNumber() == 2 || this.playerHand.cards[2].getNumber() == 3) {
				if (this.bankerHand.HandTotal() <= 4) {
					dealBanker = true;
				}
			}
			else if (this.playerHand.cards[2].getNumber() == 4 || this.playerHand.cards[2].getNumber() == 5) {
				if (this.bankerHand.HandTotal() <= 5) {
					dealBanker = true;
				}
			}
			else if (this.playerHand.cards[2].getNumber() == 6 || this.playerHand.cards[2].getNumber() == 7) {
				if (this.bankerHand.HandTotal() <= 6) {
					dealBanker = true;
				}
			}
			else if (this.playerHand.cards[2].getNumber() == 8) {
				if (this.bankerHand.HandTotal() <= 2) {
					dealBanker = true;
				}
			} else {
				if (this.bankerHand.HandTotal() <= 3) {
					dealBanker = true;
				}
			}
		}
		
		if (dealBanker) {
			var bankerCard = this.deck.getCard();
			var bankerHand = this.bankerHand;
			var displayBankerHandTotal = this.displayBankerHandTotal;
			var baccarat = this.baccarat;
			var thisObj = this;
			bankerCard.setFaceup();
			
			var animatedNode = new Animation.AnimatedNode();
			animatedNode.runSequence(0.8, function() { bankerHand.addCard(bankerCard); baccarat.gameNode.addChild(bankerCard.getNode()); displayBankerHandTotal.setText(''+bankerHand.HandTotal()); }, 0.0, function() {thisObj.results(); animatedNode.destroy();});
		} else {
			this.results();
		}
	
	},

	results: function() {
		var r = ' ';
		if (this.currentbetbanker > 0 && this.currentbetplayer > 0){
			this.winMultiplier = 1;
			this.returnMultiplier =0;
		}
		
		if (this.bankerHand.HandTotal() > this.playerHand.HandTotal())
		{			
			SCGame.updatePlayer(Player.StatType.Chips, this.currentbetbanker * 0.95 * this.winMultiplier + this.currentbetbanker, true);
			if (this.returnMultiplier > 0) {
				SCGame.updatePlayer(Player.StatType.Chips, (this.currentbettie + this.currentbetplayer) * this.returnMultiplier, true);
			}
			
			if (this.currentbettie > 0) this.lostBet(this.displayCurrentBetTie);
			if (this.currentbetbanker > 0) this.wonBet(this.displayCurrentBetBanker, this.currentbetbanker * 0.95 * this.winMultiplier);
			if (this.currentbetplayer > 0) this.lostBet(this.displayCurrentBetPlayer);
			r = 'Banker';
			
		}
		else if (this.bankerHand.HandTotal() < this.playerHand.HandTotal())
		{
			SCGame.updatePlayer(Player.StatType.Chips, this.currentbetplayer * this.winMultiplier + this.currentbetplayer, true);
			if (this.returnMultiplier > 0) {
				SCGame.updatePlayer(Player.StatType.Chips, (this.currentbettie + this.currentbetbanker) * this.returnMultiplier, true);
			}
			
			if (this.currentbettie > 0) this.lostBet(this.displayCurrentBetTie);
			if (this.currentbetbanker > 0) this.lostBet(this.displayCurrentBetBanker);
			if (this.currentbetplayer > 0) this.wonBet(this.displayCurrentBetPlayer, this.currentbetplayer * this.winMultiplier);
			r = 'Player';
		}
		else 
		{
			SCGame.updatePlayer(Player.StatType.Chips, this.currentbettie*8*this.winMultiplier + this.currentbettie, true);
			SCGame.updatePlayer(Player.StatType.Chips, this.currentbetbanker, true);
			SCGame.updatePlayer(Player.StatType.Chips, this.currentbetplayer, true);
			if (this.currentbettie > 0) this.wonBet(this.displayCurrentBetTie, this.currentbettie * 8 * this.winMultiplier);
//			if (this.currentbetbanker > 0) this.lostBet(this.displayCurrentBetBanker);
//			if (this.currentbetplayer > 0) this.lostBet(this.displayCurrentBetPlayer);
			r = 'Tie';
		}
		
		//var dgh = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		//SCStyle.applyFontStyle(dgh, SCStyle.FontStyle.SerifB14);
		//dgh.setDepth(6);
		switch(r){
			case 'Banker': 
				//dgh.setColor(0,0,1.0);
				var displayGameResults = new Animation.ScrollingLabel('Banker Wins!',Scale.droid.width(400),Scale.droid.height(240),Scale.droid.height(70),3);
				this.addChild(displayGameResults);
			break;
			case 'Player': 
				//dgh.setColor(1.0,0,0);
				var displayGameResults = new Animation.ScrollingLabel('Player Wins!',Scale.droid.width(400),Scale.droid.height(240),Scale.droid.height(70),3);
				this.addChild(displayGameResults);
			break;
			case 'Tie': 
				//dgh.setColor(0,1.0,0);
				var displayGameResults = new Animation.ScrollingLabel('Tie!',Scale.droid.width(400),Scale.droid.height(240),Scale.droid.height(70),3);
				this.addChild(displayGameResults);
			break;
		}
		
		//this.addDisplayGameHistory(dgh);
		
		var biggestBet = Math.max(this.currentbettie, Math.abs(this.currentbetbanker- this.currentbetplayer));
		
		SCGame.updatePlayer(Player.StatType.Experience, this.player.getTier() + 1, true);
		SCGame.updatePlayer(Player.StatType.Comp, biggestBet/10000, true);
		this.baccarat.exit.setEnabled(true);
		this.baccarat.change.setEnabled(true);
		this.baccarat.deal.setEnabled(true);
		
		var thisObj = this;
		setTimeout(function(){
			SCGame.quickSavePlayer();
			thisObj.playerHand.setActive(false);
			thisObj.bankerHand.setActive(false);
			thisObj.isPlaying = false;
		}, 1200);
		
	},
	
	lostBet: function(chips) {
		var chipsX = chips.getNode().getPosition().getX();
		var chipsY = chips.getNode().getPosition().getY();
		var currentbet = this.currentbet;
		var player = this.player;
		var thisObj = this;
		var animatedNode = new Animation.AnimatedNode();
		SCGame.getSCAudio().playsound(7);		
		animatedNode.runSequence(
			1.0, function() { chips.getNode().moveTo(thisObj.DEALER_X, thisObj.DEALER_Y, 0.5); }, 
			0.1, function() { if (currentbet > player.availableChips()) { chips.setAmount(player.availableChips()); } chips.getNode().setPosition(thisObj.PLAYER_X, thisObj.PLAYER_Y); }, 
			0.2, function() { chips.getNode().moveTo(chipsX, chipsY, 0.2); },
			0.0, function() {
				if (player.availableChips() < 10) {
					SCGame.updatePlayer(Player.StatType.Chips, 500-player.availableChips(), true);
					AlertLayer.showAlertNode(new GenericAlertNode('You\'re out of Chips, but the Casino Manager\nhas comp\'d you some extra cash.\nFor a real stack of chips, make sure to hit The Bank!','ON THE HOUSE'));
					SCGame.quickSavePlayer();
				}
				animatedNode.destroy();
			}
		);
	},
	
	wonBet: function(chips, amt) {
		var winningChips = new CardGame.Chips(amt,this.DEALER_X, this.DEALER_Y);
		var chipsX = chips.getNode().getPosition().getX();
		var chipsY = chips.getNode().getPosition().getY();
		var thisObj = this;
		this.addChild(winningChips.getNode());
		var animatedNode = new Animation.AnimatedNode();
		SCGame.getSCAudio().playsound(9);
		animatedNode.runSequence(
			1.2, function() { winningChips.getNode().moveTo(chipsX - Scale.droid.width(84), chipsY, 0.5); },  
			0.4, function() { winningChips.getNode().moveTo(thisObj.PLAYER_X, thisObj.PLAYER_Y, 0.4); },
			0.0, function() { thisObj.removeChild(winningChips.getNode()); winningChips.destroy(); animatedNode.destroy(); } 
		);
	},
	
	getBankerHand: function() {
		return this.bankerHand;
	},
	getPlayerHand: function() {
		return this.playerHand;
	},
	getDisplayGameResults: function() {
		return this.displayGameResults;
	},	
	
	getDisplayCurrentBetTie: function() {
		return this.displayCurrentBetTie;
	},
	
	getDisplayCurrentBetPlayer: function() {
		return this.displayCurrentBetPlayer;
	},
	getDisplayCurrentBetBanker: function() {
		return this.displayCurrentBetBanker;
	},
	getDisplayGameHistory: function() {
		return this.displayGameHistory;
	},	
	addDisplayGameHistory: function(l) {
		this.displayGameHistory.unshift(l);
		this.baccarat.gameNode.addChild(l);
		if (this.displayGameHistory.length > 8)
		{
			var d = this.displayGameHistory.pop();
			d.destroy();
		}
		for (var x = 0; x < this.displayGameHistory.length; x++) {
			this.displayGameHistory[x].setPosition(Scale.droid.width(55),Scale.droid.height(150) + (x * Scale.droid.height(30)));
		}
		
//		return this.displayGameHistory;
	},	
	
	getDisplayChips: function() {
		return this.chips1;
	},	
	
	getCurrentBetTie: function() {
		return this.currentbettie;
	},	
	setCurrentBetTie:function(b){
		this.currentbettie = b;
		
	},
	getCurrentBetPlayer: function() {
		return this.currentbetplayer;
	},	
	setCurrentBetPlayer:function(b){
		this.currentbetplayer = b;
		
	},
	getCurrentBetBanker: function() {
		return this.currentbetbanker;
	},	
	setCurrentBetBanker:function(b){
		this.currentbetbanker = b;
		
	},
	
	getCurrentBetOn: function() {
		return this.currentbeton;
	},
		
	setCurrentBetOn:function(b){
		this.currentbeton = b;

	},
	destroy: function($super){
		for (var i = 0; i < this._children.length; i++) {
			if (typeof this._children[i].durable === 'undefined')
				this._children[i].destroy();
			else if (this._children[i].durable == 0)	
				this._children[i].destroy();
		}
		$super();
	},
	
    setTextVisible: function(v){
        this.compStat.setVisible(v);
        this.chipLabel.setVisible(v);
        this.compLabel.setVisible(v);
        this.chipsStat.setVisible(v);
    }	
	
});


exports.Baccarat = Node.subclass(
{
	className: 'Baccarat',
	
	initialize : function() {
			
		this.Player1 = SCGame.getPlayer();
		this.gameNode = new GL2.Node();
		this.addChild(this.gameNode);

		var bgAnimationBasic = new GL2.Animation();
		bgAnimationBasic.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_menus/common-play-bg.png', 0, [Scale.droid.width(800), Scale.droid.height(480)], [0,0], [0,0,1,1]));
		bgAnimationBasic.setBlendEnabled(false);
		var bgBasic = new GL2.Sprite();
		bgBasic.setAnimation(bgAnimationBasic,0);
		
		var bgAnimationGame = new GL2.Animation();
		bgAnimationGame.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_menus/play-bg-minibac.png', 0, [Scale.droid.width(800), Scale.droid.height(480)], [0,0], [0,0,1,1]));
		var bgGame = new GL2.Sprite();
		bgGame.setAnimation(bgAnimationGame,0);
		
		var bgAnimationTop = new GL2.Animation();
		bgAnimationTop.pushFrame(AtlasMap.getAnimationFrame('common-play-bg-top.png', 0, [0,0]));
		var bgTop = new GL2.Sprite(); 
		bgTop.setAnimation(bgAnimationTop,0);
		
		var bgNode = new GL2.Node();
		bgNode.setDepth(-1);
		bgNode.addChild(bgBasic);
		bgNode.addChild(bgGame);
		bgNode.addChild(bgTop);
		this.gameNode.addChild(bgNode);	
		
		this.game = new Game(this, this.Player1);
		this.game.setDepth(5);
		this.gameNode.addChild(this.game);


		//Selecting bet option
		var betIdle = new GL2.Animation.Frame('Content/blank.png', 0, [Scale.droid.width(158), Scale.droid.height(102)], [0, 0], [0,0,1,1]);
        var betSelected = AtlasMap.getAnimationFrame('game-select.png', 0, [0,0]);
 		       
		var thisObj = this;
		
        var tieBet = new Menu.AnimationFrameMenuItem();
        tieBet.setFrames(betIdle, betSelected, betIdle);
        tieBet.setAction(function(){
			thisObj.game.setCurrentBetOn(1);
		});
        
        var bankerBet = new Menu.AnimationFrameMenuItem();
        bankerBet.setFrames(betIdle, betSelected, betIdle);
        bankerBet.setAction(function(){
			thisObj.game.setCurrentBetOn(2);
		});
        
		var playerBet = new Menu.AnimationFrameMenuItem();
        playerBet.setFrames(betIdle, betSelected, betIdle);
        playerBet.setAction(function(){
			thisObj.game.setCurrentBetOn(3);
		});
		
        
        var betMenu = new Menu.RadioButton([tieBet, bankerBet, playerBet]);
        betMenu.setPosition(Scale.droid.width(320),Scale.droid.height(164));
		betMenu.alignItemsVertically(Scale.droid.height(-4));
		playerBet.setPosition(playerBet.getPosition().getX(), playerBet.getPosition().getY() - Scale.droid.height(2));
        betMenu.setDepth(3);
		betMenu.setSelected(2);
		this.gameNode.addChild(betMenu);

		
		//Tutorial
		if(!SCGame.getPlayer().getTutorialHistory().finishedBacTutorial())
		{
			this.openTutorial();
		}
		

		var gameInfoButtonActive = AtlasMap.getAnimationFrame('game-button-info-active.png', 0, [0,0]);
		var gameInfoButtonInactive = AtlasMap.getAnimationFrame('game-button-info-inactive.png', 0, [0,0]);
		
		var gameInfo = new Menu.AnimationFrameMenuItem();
        gameInfo.setFrames(gameInfoButtonInactive, gameInfoButtonActive, gameInfoButtonInactive);
        gameInfo.setAction(function(){
			thisObj.openTutorial();
		});
		
	    this.tutorialMenu = new Menu.Menu([gameInfo]);
		this.tutorialMenu.alignItemsHorizontally(0);
        this.tutorialMenu.setDepth(5);
		this.tutorialMenu.setPosition(Scale.droid.width(tutorialMenu_xpos),Scale.droid.height(tutorialMenu_ypos));
		this.gameNode.addChild(this.tutorialMenu);		

        //********************
		var base = this.gameNode;
		var game2 = this.game;
		var player2 = this.Player1;
		
        var betBox1 = AtlasMap.getAnimationFrame('chip2_1.png', 0, [0,0]);
		var betBox2 = AtlasMap.getAnimationFrame('chip2_5.png', 0, [0,0]);
		var betBox3 = AtlasMap.getAnimationFrame('chip2_25.png', 0, [0,0]);
		var betBox4 = AtlasMap.getAnimationFrame('chip2_100.png', 0, [0,0]);
		var betBox5 = AtlasMap.getAnimationFrame('chip2_500.png', 0, [0,0]);
		var betBox6 = AtlasMap.getAnimationFrame('chip2_1000.png', 0, [0,0]);
		var betBox7 = AtlasMap.getAnimationFrame('chip2_5000.png', 0, [0,0]);
		
		var gameButtonDisable = AtlasMap.getAnimationFrame('game-button-active.png', 0, [0,0], undefined, true);
		var gameButtonEnable = AtlasMap.getAnimationFrame('game-button-inactive.png', 0, [0,0],undefined, true);
		
		var item1 = new Menu.AnimationFrameMenuItem();
        item1.setFrames(betBox1, betBox1, betBox1);
        item1.setAction(function(){
			thisObj.betRules(base,game2,player2,1);
		});
        
        var item2 = new Menu.AnimationFrameMenuItem();
        item2.setFrames(betBox2, betBox2, betBox2);
        item2.setAction(function(){
			thisObj.betRules(base,game2,player2,5);
		});
		
        var item3 = new Menu.AnimationFrameMenuItem();
        item3.setFrames(betBox3, betBox3, betBox3);
        item3.setAction(function(){
			thisObj.betRules(base,game2,player2,25);
		});
		
		var item4 = new Menu.AnimationFrameMenuItem();
        item4.setFrames(betBox4, betBox4, betBox4);
        item4.setAction(function(){
			thisObj.betRules(base,game2,player2,100);
		});
		
		var item5 = new Menu.AnimationFrameMenuItem();
        item5.setFrames(betBox5, betBox5, betBox5);
        item5.setAction(function(){
			thisObj.betRules(base,game2,player2,500);
		});
        
        var item6 = new Menu.AnimationFrameMenuItem();
        item6.setFrames(betBox6, betBox6, betBox6);
        item6.setAction(function(){
			thisObj.betRules(base,game2,player2,1000);
		});
		
        var item7 = new Menu.AnimationFrameMenuItem();
        item7.setFrames(betBox7, betBox7, betBox7);
        item7.setAction(function(){
			thisObj.betRules(base,game2,player2,5000);
		});
		
	    this.menu = new Menu.Menu([item1, item2, item3, item4, item5, item6]);
		this.menu.alignItemsHorizontally(Scale.droid.width(5));
		this.menu._touchListener.getListener().setSize(new Core.Size(Core.Capabilities.getScreenHeight()+100, Core.Capabilities.getScreenWidth()));
        this.menu.setDepth(5);
		
		//Continue with bet menu (bottom portion)
		var leave = new Menu.AnimationFrameMenuItem();
        leave.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Lobby');
		label.setPosition(leave.getSize().getWidth()/2, leave.getSize().getHeight()/2-4);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		leave.addChild(label);
        leave.setAction(function(){
			thisObj.quit();			
		});
		
		var reset = new Menu.AnimationFrameMenuItem();
        reset.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Reset');
		label.setPosition(reset.getSize().getWidth()/2, reset.getSize().getHeight()/2-4);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		reset.addChild(label);
        reset.setAction(function(){
			thisObj.betRules(base,game2,player2,0);
		});
		
		var done = new Menu.AnimationFrameMenuItem();
        done.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Done');
		label.setPosition(done.getSize().getWidth()/2, done.getSize().getHeight()/2-4);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		done.addChild(label);
        done.setAction(function(){
			thisObj.showPlayMenu();
		});
		
		this.menub = new Menu.Menu([leave, reset, done]);
		this.menub.setPosition(Scale.droid.width(0), Scale.droid.height(88));
		this.menub.alignItemsHorizontally(Scale.droid.width(5));
		this.menub._touchListener.getListener().setSize(new Core.Size(Core.Capabilities.getScreenHeight()+100, Core.Capabilities.getScreenWidth()));
        this.menub.setDepth(5);
		
		this.betMenu = new Animation.AnimatedNode();
		this.betMenu.setDepth(8);
		this.betMenu.setPosition(Scale.droid.width(betMenu_xpos), Scale.droid.height(betMenu_ypos));
		this.betMenu.addChild(this.menu);
		this.betMenu.addChild(this.menub);
		this.gameNode.addChild(this.betMenu);
		
		
		//Play buttons
		this.exit = new Menu.AnimationFrameMenuItem();
        this.exit.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Lobby');
		label.setPosition(this.exit.getSize().getWidth()/2, this.exit.getSize().getHeight()/2-4);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		this.exit.addChild(label);
        this.exit.setAction(function(){
			thisObj.quit();		
		});
        
        this.change = new Menu.AnimationFrameMenuItem();
        this.change.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Change Bet');
		label.setPosition(this.change.getSize().getWidth()/2, this.change.getSize().getHeight()/2-4);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
		this.change.addChild(label);
        this.change.setAction(function(){
			if (thisObj.game.isPlaying) return;
			thisObj.showBetMenu();
		});
		
        this.deal = new Menu.AnimationFrameMenuItem();
        this.deal.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Deal');
		label.setPosition(this.deal.getSize().getWidth()/2, this.deal.getSize().getHeight()/2-4);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB24);
		this.deal.addChild(label);
        this.deal.setAction(function(){
			if (thisObj.game.isPlaying) return;
			
			thisObj.game.deal();
		});
		
        this.menu2 = new Menu.Menu([this.exit, this.change, this.deal]);
		this.menu2.alignItemsHorizontally(Scale.droid.width(50));
        this.menu2._touchListener.getListener().setSize(new Core.Size(Core.Capabilities.getScreenHeight()+100, Core.Capabilities.getScreenWidth()));
        this.menu2.setDepth(5);
		this.playMenu = new Animation.AnimatedNode();
		this.playMenu.setDepth(8);
		this.playMenu.setPosition(Scale.droid.width(342), Scale.droid.height(580));
		this.playMenu.addChild(this.menu2);
		this.gameNode.addChild(this.playMenu);
		
		//Left History Menu
//		var historyImage = new GL2.Animation.Frame('Content/play-bg-minibac-history.png', 0, [Scale.droid.width(134), Scale.droid.height(318)], [0, 0], [0,0,1,1]);;
//		
//		var history = new Menu.AnimationFrameMenuItem();
//		history.setFrames(historyImage, historyImage, historyImage);
//		
//		this.leftMenu = new Menu.Menu([history]);
//		this.leftMenu.alignItemsVertically(Scale.droid.height(2));
//		this.leftMenu.setPosition(Scale.droid.width(-8), Scale.droid.height(85));
//		this.leftMenu.setDepth(2);
//		this.gameNode.addChild(this.leftMenu);
		
		var sideButtonDisable = AtlasMap.getAnimationFrame('game-button-side1-active.png', 0, [0,0]);
		var sideButtonEnable = AtlasMap.getAnimationFrame('game-button-side1-inactive.png', 0, [0,0]);
		
		var incMaxBet = new Menu.AnimationFrameMenuItem();
        incMaxBet.setFrames(sideButtonEnable, sideButtonDisable, sideButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Increase\nMaxBet');
		label.setPosition(incMaxBet.getSize().getWidth()/2, incMaxBet.getSize().getHeight()/2-3);
		label.getLabel().setColor(0,0,0);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Increase');
		label.setPosition(incMaxBet.getSize().getWidth()/2, incMaxBet.getSize().getHeight()/2-16);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
		incMaxBet.addChild(label);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Max Bet');
		label.setPosition(incMaxBet.getSize().getWidth()/2, incMaxBet.getSize().getHeight()/2+4);
		label.getLabel().setColor(0,0,0); 
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB20);
		incMaxBet.addChild(label);
        incMaxBet.setAction(function(){
			thisObj.showIAP( true );		
		});

		var sideButtonDisableSide2 = AtlasMap.getAnimationFrame('game-button-side2-inactive.png', 0, [0,0], undefined, true);    
        var maxBet = new Menu.AnimationFrameMenuItem();
        maxBet.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
		var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		label.setText('Max Bet');
		label.setPosition(maxBet.getSize().getWidth()/2, 15);
		label.getLabel().setColor(1,1,0.8);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
		maxBet.addChild(label);
		
		var yourBet = new Menu.AnimationFrameMenuItem();
        yourBet.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
		var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		label.setText('Total Bet');
		label.setPosition(yourBet.getSize().getWidth()/2, 15);
		label.getLabel().setColor(1,1,0.8);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
		yourBet.addChild(label);
		
		this.leftMenu = new Menu.Menu([incMaxBet, maxBet, yourBet]);
		this.leftMenu.alignItemsVertically(Scale.droid.height(2));
        this.leftMenu.setPosition(Scale.droid.width(leftMenu_xpos), Scale.droid.height(leftMenu_ypos));
        this.leftMenu.setDepth(2);
		this.gameNode.addChild(this.leftMenu);
		
		
		//Right Card Menu		
		var theBank = new Menu.AnimationFrameMenuItem();
        theBank.setFrames(sideButtonEnable, sideButtonDisable, sideButtonDisable);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('The');
		label.setPosition(theBank.getSize().getWidth()/2, theBank.getSize().getHeight()/2-16);
		label.getLabel().setColor(0,0,0);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
		theBank.addChild(label);
		var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		label.setText('Bank');
		// if (SCGame.getSettings().getJapaneseOn()) {
		// 	label.setPosition(theBank.getSize().getWidth() / 2, theBank.getSize().getHeight() / 2 - 6);
		// }
		// else {
			label.setPosition(theBank.getSize().getWidth() / 2, theBank.getSize().getHeight() / 2 + 4);
		// }
		label.getLabel().setColor(0,0,0); 
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB20);
		theBank.addChild(label);
        theBank.setAction(function(){
			thisObj.showIAP();		
		});
        
        var banker = new Menu.AnimationFrameMenuItem();
        banker.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
		var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		label.setText('Banker');
		label.setPosition(banker.getSize().getWidth()/2, 15);
		label.getLabel().setColor(1,1,0.8);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
		banker.addChild(label);
		
		var player = new Menu.AnimationFrameMenuItem();
        player.setFrames(sideButtonDisableSide2, sideButtonDisableSide2, sideButtonDisableSide2);
		var label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		label.setText('Player');
		label.setPosition(player.getSize().getWidth()/2, 15);
		label.getLabel().setColor(1,1,0.8);
		SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB16);
		player.addChild(label);
		
		this.rightMenu = new Menu.Menu([theBank, banker, player]);
		this.rightMenu.alignItemsVertically(Scale.droid.height(2));
        this.rightMenu.setPosition(Scale.droid.width(rightMenu_xpos), Scale.droid.height(rightMenu_ypos));
        this.rightMenu.setDepth(2);
		this.gameNode.addChild(this.rightMenu);
		
		//Bet value labels
		this.maxBetAmt = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		this.maxBetAmt.setText(''+this.game.maxBet());
		SCStyle.applyFontStyle(this.maxBetAmt, SCStyle.FontStyle.SerifB16);
		this.maxBetAmt.setPosition(Scale.droid.width(55), Scale.droid.height(247));
		this.game.addChild(this.maxBetAmt);
		
		this.currentBetAmt = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		this.currentBetAmt.setText('0');
		SCStyle.applyFontStyle(this.currentBetAmt, SCStyle.FontStyle.SerifB16);
		this.currentBetAmt.setPosition(Scale.droid.width(55), Scale.droid.height(313));
		this.game.addChild(this.currentBetAmt);
		
        
		//Top Menu
		var topChipsBar = AtlasMap.getAnimationFrame('common-bg-chips.png', 0, [0,0]);
		var topCompsBar = AtlasMap.getAnimationFrame('common-bg-comps.png', 0, [0,0]);
				
		var topChipAnimation = new GL2.Animation();
		topChipAnimation.pushFrame(topChipsBar);
		var chipBar = new GL2.Sprite();
		chipBar.setPosition(Scale.droid.width(topChipsBar_xpos),Scale.droid.height(topChipsBar_ypos));
		chipBar.setDepth(2);
		chipBar.setAnimation(topChipAnimation);
		this.gameNode.addChild(chipBar);
		
		var topCompAnimation = new GL2.Animation();
		topCompAnimation.pushFrame(topCompsBar);
		var compBar = new GL2.Sprite();
		compBar.setPosition(Scale.droid.width(topCompsBar_xpos),Scale.droid.height(topCompsBar_ypos));
		compBar.setDepth(2);
		compBar.setAnimation(topCompAnimation);
		this.gameNode.addChild(compBar);
		
//		var closeActive = AtlasMap.getAnimationFrame('common-bg-exit-active.png', 0, [0.5,0.5]);
//		var closeInactive = AtlasMap.getAnimationFrame('common-bg-exit-inactive.png', 0, [0.5,0.5]);		
//        var closeAnimation = new Menu.AnimationFrameMenuItem();
//        closeAnimation.setFrames(closeInactive,closeActive,closeActive);
//		closeAnimation.setAction(function(){
//			thisObj.quit();
//		});
//		
//        var closeMenu = new Menu.Menu([closeAnimation]);
//        closeMenu.setPosition(Scale.droid.width(closeMenu_xpos), Scale.droid.height(closeMenu_ypos));
//        closeMenu.setDepth(2);
//        this.gameNode.addChild(closeMenu);
		
		var titleText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleText.setText('MINI BACCARAT');
        titleText.setDepth(3);
        titleText.getLabel().setColor(1,1,0.8);
        titleText.setPosition([Scale.droid.width(titleText_xpos), [Scale.droid.height(titleText_ypos)]]);
		SCStyle.applyFontStyle(titleText, SCStyle.FontStyle.Serif32);        
        this.gameNode.addChild(titleText);
        
        var titleSubText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleSubText.setText('B E A T  T H E  D E A L E R');
        titleSubText.setDepth(3);
        titleSubText.getLabel().setColor(1,1,0.8);
        titleSubText.setPosition([Scale.droid.width(titleSubText_xpos), [Scale.droid.height(titleSubText_ypos)]]);
		SCStyle.applyFontStyle(titleSubText, SCStyle.FontStyle.Serif12);        
        this.gameNode.addChild(titleSubText);
		
		
		
		this.setState(this.State.Playing);
		var screenSize = Util.screenSize(true);		
        this._iapVisiblePosition = new Core.Point(0, 0);
        this._iapInvisiblePosition = new Core.Point(0, 0 + screenSize.getHeight() + Scale.droid.height(100));
	},
	
    State: {
    
        Playing: 0,
        IAPMenu: 1,
        Tutorial: 2,
    
    },
    
    
    showIAP: function(limit){
		OpenSocialManager.showCommunityButton();
		if (typeof limit == 'undefined') limit = false;
		
 		SCGame.getSCAudio().playsound(10);		
   
        this.setState(this.State.IAPMenu);
        this._iap = IAPManager.getMenuAndReset( limit );
        this._iap.setDelegate(this);
        this._iap.setDepth(12);
        this._iap.setPosition(this._iapInvisiblePosition.clone());
		
		
        this.addChild(this._iap);
        
        if (!this._iap.isAnimating()) {
            this._iap.moveTo(this._iapVisiblePosition.getX(), this._iapVisiblePosition.getY(), 0.5);
        }
        
    },
	
    closeIAPMenu: function(menu){
		OpenSocialManager.hideCommunityButton();		
		SCGame.getSCAudio().playsound(11);		
        if (!menu.isAnimating()) {
            menu.moveTo(this._iapInvisiblePosition.getX(), this._iapInvisiblePosition.getY(), 0.5);
        }

        var self = this;
        setTimeout(function(){
            self.setState(self.State.Playing);
            self.removeChild(menu);
        }, 0.5 * 1000);
    },	
    
    setState: function(state){
        if (this._state == state) 
            return;
        
        switch (state) {
            case this.State.Playing:
                this.gameNode.setTouchable(true);
//                SCGame.showAd();
				this.game.setTextVisible(true);
                break;
            case this.State.IAPMenu:
//                SCGame.removeAd();
                this.gameNode.setTouchable(false);
				this.game.setTextVisible(false);
                break;
            case this.State.Tutorial:
                this.gameNode.setTouchable(false);
				this.game.setTextVisible(false);
                break;
            default:
                break;
                
        }
        this._state = state;
        
    },
	
	showBetMenu:function(){
		this.playMenu.moveTo(Scale.droid.width(342),Scale.droid.height(580),0.5);
		this.betMenu.moveTo(Scale.droid.width(betMenu_xpos),Scale.droid.height(betMenu_ypos),0.5);
	},

	showPlayMenu:function(){
		this.betMenu.moveTo(Scale.droid.width(342),Scale.droid.height(580),0.5);
		this.playMenu.moveTo(Scale.droid.width(playMenu_xpos),Scale.droid.height(playMenu_ypos),0.5);
	},
	
	getPlayer: function()
	{
		return this.Player1;
	},
	
	getGame: function() {
		return this.game;
	},
	
	openTutorial: function() {
        this.setState(this.State.Tutorial);
		if (this.tutorial == null) {
			this.tutorial = new CardGame.Tutorial(this,  SCConstants.Game.Baccarat);
			this.addChild(this.tutorial.getNode());
		}
		SCGame.getSCAudio().playsound(10);		
		this.tutorial.getNode().setPosition(Scale.droid.width(0), Scale.droid.height(800));
		this.tutorial.getNode().moveTo(Scale.droid.width(0),Scale.droid.height(0), 0.5);
	},
	
	closeTutorial: function() {
		SCGame.getPlayer().getTutorialHistory().setBacTutorial(true);
		SCGame.quickSaveTutorialHistory();

		this.tutorial.getNode().moveTo(Scale.droid.width(0),Scale.droid.height(800), 0.5);
        this.setState(this.State.Playing);
		SCGame.getSCAudio().playsound(11);		
		
	},
	
	betRules:function(base,game,player,betvalue)
	{
		this.base = base;
		this.baccarat = game;
		this.player = player;
		this.betvalue = betvalue;

		
		if (this.baccarat.isPlaying) return true;
		
		var currentbettie = this.baccarat.getCurrentBetTie();
		var currentbetplayer = this.baccarat.getCurrentBetPlayer();
		var currentbetbanker = this.baccarat.getCurrentBetBanker();
			
		if (this.betvalue == 0) {
		currentbettie = 0;
		currentbetplayer = 0;
		currentbetbanker = 0;
		SCGame.getSCAudio().playsound(2);
		}
		else {SCGame.getSCAudio().playsound(1);}
		
		switch (this.baccarat.getCurrentBetOn()) {
			case 1:
				currentbettie += this.betvalue;
				if (currentbettie + currentbetplayer + currentbetbanker > this.baccarat.maxBet())
					currentbettie = this.baccarat.maxBet()- currentbetplayer - currentbetbanker;;
				if (currentbettie + currentbetplayer + currentbetbanker > this.player.availableChips())
					currentbettie = this.player.availableChips() - currentbetplayer - currentbetbanker;
				if (currentbettie < 0) currentbettie = 0; 
				break;
			case 2:
				currentbetbanker += this.betvalue;
				if (currentbettie + currentbetplayer + currentbetbanker > this.baccarat.maxBet())
					currentbetbanker = this.baccarat.maxBet() - currentbetplayer - currentbettie;
				if (currentbetbanker + currentbettie + currentbetplayer > this.player.availableChips())
					currentbetbanker = this.player.availableChips() - currentbettie - currentbetplayer;
				if (currentbetbanker < 0) currentbetbanker = 0; 
				break;
			case 3:
				currentbetplayer += this.betvalue;
				if (currentbettie + currentbetplayer + currentbetbanker > this.baccarat.maxBet())
					currentbetplayer = this.baccarat.maxBet() - currentbettie - currentbetbanker;
				if (currentbetplayer + currentbettie + currentbetbanker > this.player.availableChips())
					currentbetplayer = this.player.availableChips() - currentbettie - currentbetbanker;
				if (currentbetplayer < 0) currentbetplayer = 0; 
				break;
			default:
				//SCGame.getSCAudio().playsound(1);
				var displayGameResults = new Animation.ScrollingLabel('Select a bet',Scale.droid.width(400),Scale.droid.height(240),Scale.droid.height(70),3);
				this.base.addChild(displayGameResults);
				break;
				
		}
		
		
		this.baccarat.setCurrentBetTie(currentbettie);
		this.baccarat.setCurrentBetPlayer(currentbetplayer);
		this.baccarat.setCurrentBetBanker(currentbetbanker);

		this.baccarat.getDisplayCurrentBetTie().setAmount(currentbettie);
		this.baccarat.getDisplayCurrentBetPlayer().setAmount(currentbetplayer);
		this.baccarat.getDisplayCurrentBetBanker().setAmount(currentbetbanker);
		
		var totalBet = currentbettie + currentbetplayer + currentbetbanker;
		this.currentBetAmt.setText(''+totalBet);
	},
	
	changeMaxBetDisplay: function() {
		this.maxBetAmt.setText(''+this.game.maxBet());
	},
	
	quit: function() {
		if (!this.game.isPlaying) {
			SCGame.returnToLobby(this);
		}
		else {	
//			SCGame.getSCAudio().playsound();
			var displayGameResults = new Animation.ScrollingLabel('Hand is not over',Scale.droid.width(400),Scale.droid.height(240),Scale.droid.height(70),3);
			displayGameResults.label.setFontSize(Scale.droid.textSize(24));
			this.game.addChild(displayGameResults);
		}
	},
	
	destroy: function($super) {
		for (var i = 0; i < this.gameNode._children.length; i++) {
			if (typeof this.gameNode._children[i].durable === 'undefined')
				this.gameNode._children[i].destroy();
			else if (this.gameNode._children[i].durable == 0)	
				this.gameNode._children[i].destroy();
		}
		for (var i = 0; i < this.game._children.length; i++) {
			if (typeof this.game._children[i].durable === 'undefined')
				this.game._children[i].destroy();
			else if (this.game._children[i].durable == 0)	
				this.game._children[i].destroy();
		}
		this.gameNode.destroy();
		this.game.destroy();
		$super();
	},
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/BonusGame/BonusGame'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/BonusGame/BonusGame'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/BonusGame/BonusGame'] = exports; var goldColor = new Core.Color(1, 1, 0.8);
var blackColor = new Core.Color(0, 0, 0);





var Wheel = Core.MessageListener.subclass(
{
	initialize: function(game)
	{
		this.r = 3000 + (Math.floor(Math.random()* 12)* 30);


		this.value =0;
		this.game = game;
		this.multiplier = SCGame.getPlayer().getMultiplier();
		
		var wheelouter = new GL2.Animation();
		wheelouter.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_wheel/wheel-bg-out.png', 0, [Scale.droid.width(630), Scale.droid.height(630)], [0.5, 0.5], [0, 0, 1, 1]));

		this._node = new GL2.Node();
		this._node.setPosition(Scale.droid.width(400), Scale.droid.height(380));

		this._sprite = new GL2.Sprite();
		this._sprite.setDepth(1);
		this._sprite.setAnimation(wheelouter);
		this._node.addChild(this._sprite);
		this._node.setDepth(0);
		
		// Create touch target.
		this._target = new GL2.TouchTarget();
		this._target.setAnchor(this._sprite.getAnimation().getFrame(0).getAnchor());
		this._target.setSize(this._sprite.getAnimation().getFrame(0).getSize());
		this._target.getTouchEmitter().addListener(this, this.onTouch);
		this._node.addChild(this._target);
		
		Core.UpdateEmitter.addListener(this, this.onUpdate);
		
	},
	
	destroy: function()
	{
		this._shadow.destroy();
		this._body.destroy();
		this._node.destroy();
	},
	
	setPosition: function(x, y)
	{
		this._node.setPosition(x, y);
	},
	
	getNode: function()
	{
		return this._node;
	},
	
	onUpdate: function(delta)
	{
		if (this.game.getStartWheel()) {
		
			this._node.setRotation(this._node.getRotation() + (this.r/10 ));
			
			this.r = this.r - delta;
			var spot = (this._node.getRotation() + 15) % 360;
			spot = spot / 30;
			spot = Math.floor(spot);
			
			switch (spot) {
				case 0:
				case 4:
				case 8:
					this.value = 500;
					break;
				case 1:
				case 5:
				case 9:
					this.value = 750;
					break;
				case 2:
				case 6:
				case 10:
					this.value = 100;
					break;
				default:
					this.value = 250;
					break;
					
			}
			
			if (this.r < 15) {
				this._node.setRotation((spot)*30);
				
				if (this.game.getShowOnce()) {
					this.game.setStartWheel(false);
					SCGame.getSCAudio().playsound(13);

					this.game.setShowOnce(false);
					
					SCGame.updatePlayer(Game.Player.Player.StatType.Chips, this.value * this.multiplier, true);
					var dnow = new Date();
					SCGame.getPlayer().setLastPlayedBonus(new Date((dnow.getMonth()+1) +'/'+dnow.getDate()+'/'+dnow.getFullYear()));
					SCGame.quickSavePlayer();
					if (SCGame.getSettings().getJapaneseOn()) {
						this.game.getSpinButtonText().setText(Util.numberFormat(parseInt(this.value * this.multiplier)));
					}
					else {
						this.game.getSpinButtonText().setText(Util.dollarFormat(parseInt(this.value * this.multiplier)));
					}
					this.game.getSpinButtonText2().setText('come back tomorrow \n for another chance');

					
			var game = this.game;
			if (SCGame.getSettings().getJapaneseOn()) {
				var v = Util.numberFormat(parseInt(this.value * this.multiplier));
			}
			else
				var v = Util.dollarFormat(parseInt(this.value * this.multiplier));

			var animatedNode = new Animation.AnimatedNode();

			animatedNode.runSequence(
				2.0, function() {  }, 
				2.0, function() { AlertLayer.showAlertNode(new GenericAlertNode('You just won '+ v +' free Chips. \nCome back on consecutive days to multiply your winnings!','YOU\'VE WON' )); }, 
				0.0, function() {SCGame.returnToLobby(game);  }

			);		
					
				}
			}
		}
	},
	
});

var SpinButton = Core.MessageListener.subclass(
{
	initialize: function(game)
	{

		this.game = game;
		var wheelinner = new GL2.Animation();
		wheelinner.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_wheel/wheel-bg-in.png', 0, [Scale.droid.width(328), Scale.droid.height(468)], [0.5, 0.5], [0, 0, 1, 1]));

		this._node = new GL2.Node();
		this._node.setPosition(Scale.droid.width(400), Scale.droid.height(310));

		this._sprite = new GL2.Sprite();
		this._sprite.setAnimation(wheelinner);
		this._node.addChild(this._sprite);


		
		// Create touch target.
		this._target = new GL2.TouchTarget();
		this._target.setAnchor(this._sprite.getAnimation().getFrame(0).getAnchor());
		this._target.setSize(this._sprite.getAnimation().getFrame(0).getSize());
		this._target.getTouchEmitter().addListener(this, this.onTouch);
		this._node.addChild(this._target);
		Core.UpdateEmitter.addListener(this, this.onUpdate);
		

		
		
	},
	
	destroy: function()
	{
		this._shadow.destroy();
		this._body.destroy();
		this._node.destroy();
	},
	
	setPosition: function(x, y)
	{
		this._node.setPosition(x, y);
	},
	
	getNode: function()
	{
		return this._node;
	},
	
	onTouch: function(touch)
	{
		switch(touch.getAction())
		{
			case touch.Action.Start:
				if (this.game.getShowOnce()) {

					this.game.setStartWheel(true);
					SCGame.getSCAudio().playsound(12);
				}
				return true;
			case touch.Action.End:
				break;
			case touch.Action.Move:
				break;
		}
	},
});
exports.BonusGame = Node.subclass(
{
	className: 'BonusGame',
	
	initialize : function() {
			
			
        var titleText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		SCStyle.applyFontStyle(titleText, SCStyle.FontStyle.Serif24);
        titleText.setText('FORTUNE WHEEL');
        titleText.getLabel().setColor(goldColor);
        titleText.setPosition([Scale.droid.width(400), [Scale.droid.height(22)]]);
        
        this.addChild(titleText);		
        var titleText2 = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		SCStyle.applyFontStyle(titleText2, SCStyle.FontStyle.Serif10);
        titleText2.setText('A L L   T H E   W O R L D \'  S   A   S T A G E ');
        titleText2.getLabel().setColor(goldColor);
        titleText2.setPosition([Scale.droid.width(400), [Scale.droid.height(57)]]);
        this.addChild(titleText2);			
			
		this.Player1 = SCGame.getPlayer();
		this.showonce = true;
		this.startwheel = false;
		var bgAnimation = new GL2.Animation();
//		bgAnimation.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_menus/common-menu-bg.png', 0, [Scale.droid.width(800), Scale.droid.height(480)], [0, 0], [0, 0, 1, 1]));
		bgAnimation.pushFrame(AtlasMap.getAnimationFrame('common-menu-bg.png', 0, [0,0]));
        bgAnimation.setBlendEnabled(false);		
		
		var background = new GL2.Sprite();
		background.setDepth(-1);
		background.setAnimation(bgAnimation);
		this.addChild(background);
		
		var wheel = new Wheel(this);
		this.addChild(wheel.getNode());
		var spinbutton = new SpinButton(this);
		this.addChild(spinbutton.getNode());
		var bgAnimation = new GL2.Animation();
		bgAnimation.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_wheel/wheel-daily-bg.png', 0, [Scale.droid.width(750), Scale.droid.height(88)], [0, 0], [0, 0, 1, 1]));
		
		var n = new GL2.Node();
		n.setPosition(Scale.droid.width(25), Scale.droid.height(392));
		
		var s = new GL2.Sprite();
		s.setDepth(1);
		s.setAnimation(bgAnimation);
		n.addChild(s);
		this.addChild(n); 
		
		this.SpinButtonText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		SCStyle.applyFontStyle(this.SpinButtonText, SCStyle.FontStyle.Serif48);
        this.SpinButtonText.setText('SPIN');
        this.SpinButtonText.getLabel().setColor(goldColor);
        this.SpinButtonText.setPosition([Scale.droid.width(400), [Scale.droid.height(316)]]);
        
        this.addChild(this.SpinButtonText);	
		
        this.SpinButtonText2 = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		SCStyle.applyFontStyle(this.SpinButtonText2, SCStyle.FontStyle.Serif14);
        this.SpinButtonText2.setText('Chance Favors \n The Prepared Mind');
        this.SpinButtonText2.getLabel().setColor(goldColor);
        this.SpinButtonText2.setPosition([Scale.droid.width(400), [Scale.droid.height(366)]]);
        
        this.addChild(this.SpinButtonText2);			
		
		
		for (var x = 0;  x < 5;x++)
		{
			if (x < this.Player1.getMultiplier()) {
				var bgAnimation2 = new GL2.Animation();
				bgAnimation2.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_wheel/wheel-daily-check.png', 0, [Scale.droid.width(24), Scale.droid.height(24)], [0, 0], [0, 0, 1, 1]));
				var n2 = new GL2.Node();
				n2.setPosition(Scale.droid.width(87 + (128 * x)), Scale.droid.height(420));
				var s2 = new GL2.Sprite();
				s2.setAnimation(bgAnimation2);
				n2.addChild(s2);
				n2.setDepth(1);
				this.addChild(n2);
				
			}
			
			
        var Day1 = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		SCStyle.applyFontStyle(Day1, SCStyle.FontStyle.Serif24);
        Day1.setText('Day '+(x+1));
        Day1.getLabel().setColor(blackColor);
        Day1.setPosition([Scale.droid.width(144 + (128 * x)), [Scale.droid.height(423)]]);
        
        this.addChild(Day1);				
			
        var BonusX = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		SCStyle.applyFontStyle(BonusX, SCStyle.FontStyle.Serif14);        
        BonusX.getLabel().setColor(blackColor);
        BonusX.setPosition([Scale.droid.width(144 + (128 * x)), [Scale.droid.height(451)]]);
     
	
			
			if ((x + 1) < this.Player1.getMultiplier()) {
				BonusX.setText('Complete');
			}else if ((x+1) >= this.Player1.getMultiplier()){
				BonusX.setText((x+1)+'x Bonus');
			}

			this.addChild(BonusX);
 	  		
      }
		

	},
	
	getPlayer: function()
	{
		return this.Player1;
	},
	
	getGame: function() {
		return this.g;
	},
	getStartWheel:function(){
		return this.startwheel;
	},
	setStartWheel:function(b){
		this.startwheel = b;
	},
	getShowOnce:function(){
		return this.showonce;
	},
	setShowOnce:function(b){
		this.showonce = b;
	},
	
	getSpinButtonText:function(){
		return this.SpinButtonText;
	},
	getSpinButtonText2:function(){
		return this.SpinButtonText2;
	}	
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/SCConstants'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/SCConstants'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/SCConstants'] = exports; /**
 * @author will
 */
exports.SCConstants = Class.subclass({
    //move this util lib
    Game: {
    	Strip: 0,
        BlackJack: 1,
        TriCardWar: 2,
		Baccarat: 3,
    	Settings: 4,
    	Bank: 5,
		Inquiry: 6,
		
		    },
	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Text/TextWithShadow'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Text/TextWithShadow'] || {}; $MODULE_REGISTRY['Code/G6/Text/TextWithShadow'] = exports; /**
 * @author will
 */

exports.TextWithShadow = GL2.Node.subclass({
    classname: 'TextWithShadow',
    
    
    ShadowType: {
        BlackShadow: 0,
        WhiteSoftShadow: 1
    },
    
    initialize: function(shadowType){
        this._label = new GL2.Text();
		this._label.setFontFamily('DroidSans-Regular');
		this._label.setFontSize(32);		
        this._label.setDepth(1);
        this._label.setAnchor(0.5, 0.5);
        this._label.setText(' ');
        
        
        this._shadow = new GL2.Text();
		this._shadow.setFontFamily('DroidSans-Regular');
		this._shadow.setFontSize(32);		
        this._shadow.setDepth(0);
        this._shadow.setAnchor(0.5, 0.5);
        this._shadow.setText(' ');
        
        switch (shadowType) {
            case this.ShadowType.WhiteSoftShadow:
                this._shadow.setColor(1.0, 1.0, 1.0);
                this._shadow.setAlpha(0.5);
				this._shadow.setPosition(this._label.getPosition().getX() , this._label.getPosition().getY() + 2);				
                break;	
			case this.ShadowType.BlackShadow:				
            default:
                this._shadow.setColor(0, 0, 0);
                this._shadow.setAlpha(1);
				this._shadow.setPosition(this._label.getPosition().getX(), this._label.getPosition().getY() - 2);
                break;        
			}
        



        
        this.addChild(this._label);
        this.addChild(this._shadow);
    },
    
    setAnchor: function(anchor){
    
        this._label.setAnchor(arguments);
        this._shadow.setAnchor(arguments);
    },
    
    setText: function(txt){

        if (!isNaN(txt)) {
            if (txt == 0) {
                this._label.setText('0');
                this._shadow.setText('0');
            }
        }
        this._label.setText(txt);
        this._shadow.setText(txt);

    },
    
	setOverflowMode: function(overflowMode) {
		
		this._label.setOverflowMode(overflowMode);
        this._shadow.setOverflowMode(overflowMode);
	},
	
	setVerticalAlign: function(verticalAlign) {
		this._label.setVerticalAlign(verticalAlign);
        this._shadow.setVerticalAlign(verticalAlign);
	},
	
	setHorizontalAlign: function(horizontalAlign) {
		this._label.setHorizontalAlign(horizontalAlign);
        this._shadow.setHorizontalAlign(horizontalAlign);
	},
	
	setSize: function(size) {
		this._label.setSize(size);
        this._shadow.setSize(size);
	},
    
    setFontSize: function(size){
        this._label.setFontSize(size);
        this._shadow.setFontSize(size);
    },
    
	setFontFamily: function(family) {
		this._label.setFontFamily(family);
        this._shadow.setFontFamily(family);
	},
	
	getFontFamily: function() {
		return this._label.getFontFamily();
	},
	
    getText: function(){
        return this.getLabel().getText();
    },
    
    
    getLabel: function(){
        return this._label;
    },
    
    
    reset: function(){
        this._label.setText(' ');
    },
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Tools/FPSCounter'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Tools/FPSCounter'] || {}; $MODULE_REGISTRY['Code/G6/Tools/FPSCounter'] = exports; /**
 * @author will
 */
exports.FPSCounter = Node.subclass({
    classname: 'FPSCounter',
    
    initialize: function(){
    
        this.setDepth(1000);
        this._fpsLabel = new GL2.Text();
		this._fpsLabel.setFontFamily('DroidSans-Regular');
        this._fpsLabel.setFontSize(24);
        this._fpsLabel.setAnchor([0, 0]);
  	//	this._fpsLabel.setFontFamily('DroidSans-Regular')
        this._fpsLabel.setText('0.0');
        
        this.updateListener = new this.FPSUpdateListener(this);
        Core.UpdateEmitter.addListener(this.updateListener, this.updateListener.onUpdate);
        
        this.addChild(this._fpsLabel);
    },
    
    $FPSUpdateListener: Core.MessageListener.subclass({
    
        classname: 'FPSUpdateListener',
        
        initialize: function(node){
            this.node = node;
            this.frames = 0;
			this.accumDt = 0;
        },
        
        onUpdate: function(dt){
            this.frames++;
            this.accumDt += dt;
            if (this.accumDt > 500) {
                var frameRate = this.frames / this.accumDt;
                this.frames = 0;
                this.accumDt = 0;
				frameRate = frameRate * 1000;				
				this.node._fpsLabel.setText(frameRate.toFixed(2));
				
            }
            
        },
    }),

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/IAP/IAPMenu'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/IAP/IAPMenu'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/IAP/IAPMenu'] = exports; /**
 * @author will
 */
var closeMenu_xpos = 772;
var closeMenu_ypos = 28;
var titleText_xpos = 400;
var titleText_ypos = 25;
var titleSubText_xpos = 400;
var titleSubText_ypos = 51;

var chipLabel_xpos = 106;
var chipLabel_ypos = 42;
var compLabel_xpos = 632;
var compLabel_ypos = 42;
var chipStat_xpos = 106;
var chipStat_ypos = 24;
var compStat_xpos = 632;
var compStat_ypos = 24;
var topChipsBar_xpos = 56;
var topChipsBar_ypos = 12;
var topCompsBar_xpos = 585;
var topCompsBar_ypos = 12;

var tokushuhoMenu_xpos = 650;
var tokushuhoMenu_ypos = 70;

var IAPBlock = require('Code/StripCity/Scene/IAP/IAPBlock').IAPBlock;
var PlayerStatNode = require('Code/StripCity/Scene/Common/PlayerStatNode').PlayerStatNode;

var goldColor = new Core.Color(1, 1, 0.8);

var tabsY = 88;

exports.IAPMenu = Animation.AnimatedNode.subclass({


    classname: 'IAPMenu',
    
    initialize: function(iaps){
    
        var thisMenu = this;
        
        
        var screenSize = Util.screenSize(true);
        
        var bgAnimation = new GL2.Animation();
        bgAnimation.pushFrame(AtlasMap.getAnimationFrame('common-menu-bg.png', 0, [0, 0], [Scale.droid.width(800), Scale.droid.height(480)]));
        bgAnimation.setBlendEnabled(false);
        
        var bg = new GL2.Sprite();
        bg.setAnimation(bgAnimation);
        
        var chipsBg = AtlasMap.getSprite('common-bg-chips.png', [0, 0]);
        chipsBg.setPosition(Scale.droid.width(topChipsBar_xpos), Scale.droid.height(topChipsBar_ypos));
        var compsBg = AtlasMap.getSprite('common-bg-comps.png', [0, 0]);
        compsBg.setPosition(Scale.droid.width(topCompsBar_xpos), Scale.droid.height(topCompsBar_ypos));
        
        this._bgNode = new Animation.AnimatedNode();
        this._bgNode.setDepth(-1);
        this._bgNode.addChild(bg);
        this._bgNode.addChild(chipsBg);
        this._bgNode.addChild(compsBg);
		
		var bleedblocker = SCStyle.createBleedBlocker();
		bleedblocker.setDepth(-10);
		this._bgNode.addChild(bleedblocker);
        		
        this.addChild(this._bgNode);
        
		
        var playerUpdateEmitter = Game.SCGame.getPlayerUpdateEmitter();
        
        var chipsStat = new PlayerStatNode(Game.Player.Player.StatType.Chips, Game.SCGame.getPlayer());
        chipsStat.setDepth(1);
        chipsStat.setPosition(Scale.droid.width(chipStat_xpos), Scale.droid.height(chipStat_ypos));
        chipsStat.attachUpdateListener(playerUpdateEmitter);
        this.addChild(chipsStat);
        
        var chipLabel = new GL2.Text();
		chipLabel.setFontFamily('DroidSans-Regular');
		chipLabel.setFontSize(32);
        chipLabel.setDepth(4);
        chipLabel.setAnchor(0, 0.5);
		chipLabel.setFontSize(32);
        chipLabel.setPosition(Scale.droid.width(chipLabel_xpos), Scale.droid.height(chipLabel_ypos));
        SCStyle.applyFontStyle(chipLabel, SCStyle.FontStyle.Sans14);
        chipLabel.setText('Chips');
        this.addChild(chipLabel);
        
        var compStat = new PlayerStatNode(Game.Player.Player.StatType.Comp, Game.SCGame.getPlayer());
        compStat.setDepth(1);
        compStat.setPosition(Scale.droid.width(compStat_xpos), Scale.droid.height(compStat_ypos));
        compStat.attachUpdateListener(playerUpdateEmitter);
        this.addChild(compStat);
        
        var compLabel = new GL2.Text();
		compLabel.setFontFamily('DroidSans-Regular');
		compLabel.setFontSize(32);
		compLabel.setFontSize(32);
        compLabel.setDepth(4);
        compLabel.setAnchor(0, 0.5);
        compLabel.setPosition(Scale.droid.width(compLabel_xpos), Scale.droid.height(compLabel_ypos));
        SCStyle.applyFontStyle(compLabel, SCStyle.FontStyle.Sans14);
        compLabel.setText('Comp Points');
        this.addChild(compLabel);
        
        this._blocks = [];
        
        //get all the templates.
        for (var i in iaps) {
            var iap = iaps[i];
            
            //            if (template.canBuy()) {
            //                var block = new StripObjectBuildBlock(template, this);
            //                this._blocks.push(block);
            //            }
            
            var block = new IAPBlock(iap, this);
            this._blocks.push(block);
        }
        
        this.initializeText();
        this.initializeBrowsersAndTabs();
        //		this.setStarRatingSelected(3);
        
        var close1 = AtlasMap.getAnimationFrame('common-bg-exit-active.png');
        var close1i = AtlasMap.getAnimationFrame('common-bg-exit-inactive.png');
        var item1 = new Menu.AnimationFrameMenuItem();
        item1.setFrames(close1i, close1, close1i);
        
        item1.setAction(function(){
            thisMenu.close();
        });
        this._closeButton = new Menu.Menu([item1]);
        this._closeButton.setPosition(Scale.droid.width(closeMenu_xpos), Scale.droid.height(closeMenu_ypos));
        this._closeButton.setDepth(100);
        this.addChild(this._closeButton);
        
        
        this._playerUpdateListener = new this.StatUpdateListener(this);
        
        //init
        this.refresh();
        
        this.durable = true;
		

		
    },
    
    initializeBrowsersAndTabs: function(){
    
        this._browsers = [];
        this._browserTTs = [];
        
        var iapTypes = [Game.IAP.IAP.Type.ChipsIAP, Game.IAP.IAP.Type.CompIAP, Game.IAP.IAP.Type.LimitsIAP];
        
        for (var i in iapTypes) {
        
            var type = iapTypes[i];
            
            var typeBlocks = [];
            var limitCount = 0;
            for (var i in this._blocks) {
                var block = this._blocks[i];
                var temp = block.getIAP();
                if (temp.getType() == type) {
                    typeBlocks.push(block);
                    
                    //disable limits that were already purchased
                    if (type == Game.IAP.IAP.Type.LimitsIAP) {
                        limitCount++;
                        NgLogD('limit count = ' + limitCount + ' and tier = ' + SCGame.getPlayer().getTier());
                        if (limitCount < SCGame.getPlayer().getTier()) {
                            NgLogD('limit BAMMED');
                            block.setEnabled(false);
                            block._buyText.setText('PURCHASED');
                        }
                    }
                }
                
            }
            
            var browserOptions = new Browser.BrowserOptions();
            browserOptions.setYPosition(Scale.droid.height(286));
            browserOptions.setYScreenTopBounds(Scale.droid.height(120));
            browserOptions.setSpacing(2);
            
            var browser = new Browser.SmoothBrowser(typeBlocks, browserOptions);
            var browserTT = browser.getTouchTarget();
            browserTT.setSize(Util.screenSize(true).clone());
            browserTT.setAnchor(new Core.Point(0, 0));
            
            browserTT.setDepth(0);
            browser.setDepth(1);
            
            this._browsers[type] = browser;
            this._browserTTs[type] = browserTT;
        }
        
        var chips = AtlasMap.getAnimationFrame('common-tab-bg-active.png', 0, [0.5, 0.5]);
        var chipsi = AtlasMap.getAnimationFrame('common-tab-bg-inactive.png', 0, [0.5, 0.5]);
        var comps = AtlasMap.getAnimationFrame('common-tab-bg-active.png', 0, [0.5, 0.5]);
        var compsi = AtlasMap.getAnimationFrame('common-tab-bg-inactive.png', 0, [0.5, 0.5]);
        var limit = AtlasMap.getAnimationFrame('common-tab-bg-active.png', 0, [0.5, 0.5]);
        var limiti = AtlasMap.getAnimationFrame('common-tab-bg-inactive.png', 0, [0.5, 0.5]);
        
        var thisMenu = this;
        
        this._chipsItem = new Menu.AnimationFrameMenuItem();
        this._chipsItem.setFrames(chipsi, chipsi, chips);
        this._chipsItem.setAction(function(){
            thisMenu.setTypeSelected(Game.IAP.IAP.Type.ChipsIAP);
        });
        this._compsItem = new Menu.AnimationFrameMenuItem();
        this._compsItem.setFrames(compsi, compsi, comps);
        this._compsItem.setAction(function(){
            thisMenu.setTypeSelected(Game.IAP.IAP.Type.CompIAP);
        });
        this._limitItem = new Menu.AnimationFrameMenuItem();
        this._limitItem.setFrames(limiti, limiti, limit);
        this._limitItem.setAction(function(){
            thisMenu.setTypeSelected(Game.IAP.IAP.Type.LimitsIAP);
        });
        
        var typeMenu = new Menu.Menu([this._chipsItem, this._compsItem, this._limitItem]);
        typeMenu.setPosition(Util.screenSize(true).getWidth() / 2, Scale.droid.height(92));
        typeMenu.setDepth(1);
        this.addChild(typeMenu);
        
        
    },
    
    setTypeSelected: function(t){
    
        // handle browsers
        for (var i in this._browsers) {
            var browser = this._browsers[i];
            if (browser.getParent() != null) 
                this.removeChild(browser);
        }
        for (var i in this._browserTTs) {
            var browserTT = this._browserTTs[i];
            if (browserTT.getParent() != null) 
                this.removeChild(browserTT);
        }
        
        var srBrowser = this._browsers[t];
        var srBrowserTT = this._browserTTs[t];
        this.addChild(srBrowser);
        this.addChild(srBrowserTT);
        
        // handle tabs
        for (var sr in this._browsers) {
        
            var item;
            if (sr == Game.IAP.IAP.Type.ChipsIAP) 
                item = this._chipsItem;
            else 
                if (sr == Game.IAP.IAP.Type.CompIAP) 
                    item = this._compsItem;
                else 
                    if (sr == Game.IAP.IAP.Type.LimitsIAP) 
                        item = this._limitItem;
            
            if (sr == t) 
                item.disable();
            else 
                item.enable();
        }
    },
    
    initializeText: function(){
    
        //title text
        var titleText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleText.setText('THE BANK');
        titleText.setDepth(1);
        titleText.getLabel().setColor(goldColor);
        titleText.setPosition([Scale.droid.width(titleText_xpos), [Scale.droid.height(titleText_ypos)]]);
        SCStyle.applyFontStyle(titleText, SCStyle.FontStyle.Serif32);
        this.addChild(titleText);
        
        
        var titleSubText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleSubText.setText('M O N E Y  I S  N O  O B J E C T');
        titleSubText.setDepth(1);
        titleSubText.setColor(goldColor);
        titleSubText.setPosition([Scale.droid.width(titleSubText_xpos), [Scale.droid.height(titleSubText_ypos)]]);
        SCStyle.applyFontStyle(titleSubText, SCStyle.FontStyle.Serif12);
        this.addChild(titleSubText);
        
        var chipsTabText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        chipsTabText.setText('CHIPS');
        chipsTabText.setDepth(3);
        chipsTabText.setColor(goldColor);
        chipsTabText.setPosition([Scale.droid.width(234), [Scale.droid.height(tabsY)]]);
        SCStyle.applyFontStyle(chipsTabText, SCStyle.FontStyle.SerifB16);
        this.addChild(chipsTabText);
        
        var compsTabText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        compsTabText.setText('COMPS');
        compsTabText.setDepth(3);
        compsTabText.setColor(goldColor);
        compsTabText.setPosition([Scale.droid.width(400), [Scale.droid.height(tabsY)]]);
        SCStyle.applyFontStyle(compsTabText, SCStyle.FontStyle.SerifB16);
        this.addChild(compsTabText);
        
        var limitsTabText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        limitsTabText.setText('LIMITS');
        limitsTabText.setDepth(3);
        limitsTabText.setColor(goldColor);
        limitsTabText.setPosition([Scale.droid.width(562), [Scale.droid.height(tabsY)]]);
        SCStyle.applyFontStyle(limitsTabText, SCStyle.FontStyle.SerifB16);
        this.addChild(limitsTabText);
        
		//         if (SCGame.getSettings().getJapaneseOn()) {
		// 
		// 	var gameButtonDisable = AtlasMap.getAnimationFrame('common-tab-bg-active.png', 0, [0, 0], undefined, true);
		// 	var gameButtonEnable = AtlasMap.getAnimationFrame('common-tab-bg-inactive.png', 0, [0, 0], undefined, true);
		// 	
		// 	var tokushuho = new Menu.AnimationFrameMenuItem();
		// 	tokushuho.setFrames(gameButtonEnable, gameButtonDisable, gameButtonDisable);
		// 	var label = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		// 	label.setText('tokushuho');
		// 	label.setPosition(tokushuho.getSize().getWidth() / 2, tokushuho.getSize().getHeight() / 2 - 4);
		// 	SCStyle.applyFontStyle(label, SCStyle.FontStyle.SerifB20);
		// 	        label.getLabel().setColor(goldColor);
		// 	tokushuho.addChild(label);
		// 	tokushuho.setAction(function(){
		// 		Social.JP.Service.openCommunityFunction("/thisgame/tokushoho", function(){
		// 		});
		// 		
		// 	});
		// 	
		// 	var tokushuhoMenu = new Menu.Menu([tokushuho]);
		// 	tokushuhoMenu.alignItemsHorizontally(0);
		// 	tokushuhoMenu.setDepth(5);
		// 	tokushuhoMenu.setPosition(Scale.droid.width(tokushuhoMenu_xpos), Scale.droid.height(tokushuhoMenu_ypos));
		// 	this.addChild(tokushuhoMenu);
		// 	//new warning 
		// 	var warningText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		// 	        warningText.setText('注意：デバイスを変更した場合ゲーム内のデータを引き継ぐ事はできません');
		// 	        warningText.setDepth(3);
		// 	        warningText.setColor(goldColor);
		// 	        warningText.setPosition([Scale.droid.width(412), [Scale.droid.height(464)]]);
		// 	        SCStyle.applyFontStyle(warningText, SCStyle.FontStyle.SansB16);
		// 	        this.addChild(warningText);
		// 	
		// }
        
    },
    
    attachPlayerUpdateListener: function(emitter){
        emitter.addListener(this._playerUpdateListener, this._playerUpdateListener.onUpdate);
    },
    
    setEnabled: function(enabled){
        this.setVisible(enabled);
        this.setTouchable(enabled);
    },
    
    reset: function(limit){
    
    
        if (typeof limit == 'undefined') 
            limit = false;
        
        if (limit) {
            this.setTypeSelected(Game.IAP.IAP.Type.LimitsIAP);
        }
        else {
            this.setTypeSelected(Game.IAP.IAP.Type.ChipsIAP);
        }
        
    },
    
    
    setDelegate: function(delegate){
        this._delegate = delegate;
    },
    
    close: function(){
    
        if (this._delegate) 
            this._delegate.closeIAPMenu(this);
    },
    
    refresh: function(){
        //		for (var i in this._blocks) {
        //			var block = this._blocks[i];
        //			block.refresh(this._player.getChips(), this._player.getComps(), this._player.getLevel());	
        //		}
    },
    
    $StatUpdateListener: Core.MessageListener.subclass({
    
        classname: 'StatUpdateListener',
        
        initialize: function(menu){
            this._menu = menu;
        },
        
        
        onUpdate: function(statType, value){
        
            //update 
            this._menu.refresh();
            
            //            switch (statType) {
            //                case Game.Player.Player.StatType.Chips:
            //                    
            //                    break;
            //                //todo: add other stats
            //                default:
            //                    break;
            //            }
        
        
        }
    }),



});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/IAP/IAPManager'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/IAP/IAPManager'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/IAP/IAPManager'] = exports; /**
 * @author will
 */

var IAP = require('Code/StripCity/Game/IAP/IAP').IAP;
var Limit = require('Code/StripCity/Game/IAP/Limit').Limit;
//var Bank = require("../../../../NGCore/Client/Bank").Bank;

var transactionID = null;
exports.IAPManager = Class.singleton({
    initialize: function(){
		this._iaps = [];
		
		//this.addStripObjectTemplate(new StripObjectTemplate(0,'empty_plot','Content/fs.png', [Scale.droid.width(400), Scale.droid.height(320)], 0, 0, 3, 1, 1250, 43200, null, null, StripObjectTemplate.Type.Empty));
		this.addIAP(new IAP('1101','The Player','250,000 Chips', '150', 'iap-chips-01.png', IAP.Type.ChipsIAP, 250000));
		this.addIAP(new IAP('1102','The Gambler','650,000 Chips', '400', 'iap-chips-02.png', IAP.Type.ChipsIAP, 650000));		
		this.addIAP(new IAP('1103','The Ringer','1,350,000 Chips', '800', 'iap-chips-03.png', IAP.Type.ChipsIAP, 1350000));
		this.addIAP(new IAP('1104','The Hustler','3,600,000 Chips', '2000', 'iap-chips-04.png', IAP.Type.ChipsIAP, 3600000));		
		this.addIAP(new IAP('1105','The Mechanic','7,500,000 Chips', '4000', 'iap-chips-05.png', IAP.Type.ChipsIAP, 7500000));
		this.addIAP(new IAP('1106','The Master','15,700,000 Chips', '8000', 'iap-chips-06.png', IAP.Type.ChipsIAP, 15700000));		
		this.addIAP(new IAP('1201','Red Label','1,500 Comps', '150', 'iap-comps-01-red.png', IAP.Type.CompIAP, 1500));
		this.addIAP(new IAP('1202','Black Label','3,950 Comps', '400', 'iap-comps-02-blk.png', IAP.Type.CompIAP, 3950));
		this.addIAP(new IAP('1203','Gold Club','8,250 Comps', '800', 'iap-comps-03-gld.png', IAP.Type.CompIAP, 8250));
		this.addIAP(new IAP('1204','Platinum Club','21,600 Comps', '2000', 'iap-comps-04-plt.png', IAP.Type.CompIAP, 21600));
		this.addIAP(new IAP('1205','Sapphire Card','44,800 Comps', '4000', 'iap-comps-05-sap.png', IAP.Type.CompIAP, 44800));
		this.addIAP(new IAP('1206','Diamond Card','100,000 Comps', '8000', 'iap-comps-06-dia.png', IAP.Type.CompIAP, 100000));						
		this.addIAP(new Limit('SC_LIMIT_1','Limit 1','Increase your max bet', 'long description', 'iap-limit-01.png', IAP.Type.LimitsIAP, 1, 500));	
		this.addIAP(new Limit('SC_LIMIT_2','Limit 2','Increase your max bet', 'long description', 'iap-limit-02.png', IAP.Type.LimitsIAP, 1, 4000));	
		this.addIAP(new Limit('SC_LIMIT_3','Limit 3','Increase your max bet', 'long description', 'iap-limit-03.png', IAP.Type.LimitsIAP, 1, 20000));								
		this._inTransaction = false;
    },
	
	createMenu: function() {

		this._menu = new IAPMenu( this._iaps);		
	},
	
    addIAP: function( sot ){
		this._iaps[sot.getID()] = sot; 
    },
	
	getIAP: function (id) {
		return this._iaps[id];
	},
	
	getIAPs: function() {
		return this._iaps;
	},
	
	getMenu: function() {
		return this._menu;
	},
	
	getMenuAndReset: function(limit) {
		if (this._menu.getParent()) {
			this._menu.getParent().removeChild(this._menu);
		}
		
		if (typeof limit == 'undefined') limit = false;
				
		
		this._menu.reset( limit );
		

		
		//reset positioning too
		return this._menu;
	},
	

	checkPending : function(){
		/**
		* Create a function to process a single transaction at a time.
		* This method prevents uncontrolled numbers of HTTP connections.
		*/
		var processOneTransaction = function (transactionIds) {
		if (transactionIds.length <= 0) {
			return;
		}
		var oneTransactionId = transactionIds.pop();
		Bank.Debit.getTransaction(oneTransactionId, function(error, tx) {
			walkForward(error, tx, transactionIds);
		});
		};

		/*
		* Provide a means of processing transactions in different states.
		*/
		var walkForward = function(error, tx, transactionIds) {
		if (error || (!tx) || (!tx.state)) {
			var errorCode = error.errorCode;
			var errorDesc = error.description;
			console.log('Error retrieving one transaction: ' +  errorCode + ': ' + errorDesc);

			// Game-specific error handling here
			processOneTransaction(transactionIds);
		} else if (tx.state.toUpperCase() == 'NEW') {
			/*
			* When a tx is in the "new" state, you can call either
			* continueTransaction() or cancelTransaction();
			*/
			Bank.Debit.cancelTransaction(tx.id, function(error, transaction){
				// Game-specific logic here
				processOneTransaction(transactionIds);
			});

		} else if (tx.state.toUpperCase() == 'AUTHORIZED') {
			/*
			* When a tx is in the "authorized" state, 
			* inventory is available funds are in escrow, and the user 
			* wants to move forward with the transaction. You can call 
			* openTransaction() or cancelTransaction().
			*/
			// Bank.Debit.openTransaction(tx.id,  function(error, 
			//   transaction){
			// // Game-specific logic to handle error and/or deliver item
			// Bank.Debit.closeTransaction(tx.id, function(error, 
			//   transaction) {
			// // Game-specific logic here
			// processOneTransaction(transactionIds);
			// });
			// });
			Bank.Debit.cancelTransaction(tx.id, function(error, transaction){
				// Game-specific logic here
				processOneTransaction(transactionIds);
			});
		} else if (tx.state == 'OPEN') {
			/*
			* When a tx is in the "open" state, you must ensure that the 
			* ordered items were delivered, or that you deliver the items. 
			* You may call closeTransaction() or cancelTransaction.
			*
			* WARNING DO NOT CALL closeTransaction() if you have not 
			* delivered the item to the game client!
			*/
			if (true){
			Bank.Debit.closeTransaction(tx.id, function(error, transaction) {
			processOneTransaction(transactionIds);
			});
			} else {
				// YourOrderFulfillmentObject.deliverItems(transaction.items);
				// Bank.Debit.closeTransaction(tx.id, function(error, transaction) {
				// // Game-specific logic here
				// processOneTransaction(transactionIds);
				// });
			}
		} else {
			// Game-specific logic here for unknown state, this is unlikely
			processOneTransaction(transactionIds);
		}
		};


		/*
		* Get pending transactions and process them.
		*/
		Bank.Debit.getPendingTransactions(function(error, transactionIds) {
			if (error){
			var errorCode = error.errorCode;
			var errorDesc = error.description;
			console.log('Cannot retrieve pending transactions!: ' +  errorCode + ': ' + errorDesc);
			} else if (transactionIds && (transactionIds.length >= 1)) {
				processOneTransaction(transactionIds);
			}
		});		

	},

	buyIAP: function(iap){
		if (!iap._id) return;

		var sku = iap._id + "";
		var comment = " ";
		var quantity = "1";
		var billingItems = [{"item" : { "id":sku}, "quantity":quantity}];

		var txId = "";	//will be used to store transaction id 
		var thisObj = this;
		Social.Common.Service.showBalanceButton(new UI.ViewGeometry.Rect(0,0,210,70),function (error,transaction) {} );
		if (thisObj._inTransaction) {
			// AlertLayer.showAlertNode(new GenericAlertNode('ERROR'), 'ERROR');
			Social.Common.Service.hideBalanceButton(new UI.ViewGeometry.Rect(0,0,210,70),function (error,transaction) {});
			return;
		}

		thisObj._inTransaction = true;
		var createTransCallback = function (error, transaction) {
			if (error === 'usercanceled'){
			  	Social.Common.Service.hideBalanceButton(new UI.ViewGeometry.Rect(0,0,210,70),function (error,transaction) {});
				thisObj._inTransaction = false;	
				console.log("User canceled Transaction.");
			}
			else if(error || !transaction)
			{
			  	Social.Common.Service.hideBalanceButton(new UI.ViewGeometry.Rect(0,0,210,70),function (error,transaction) {});
				thisObj._inTransaction = false;				
				console.log("Error creating Transaction.");
				AlertLayer.showAlertNode(new GenericAlertNode('The transaction failed to complete.  Please try again.','Failure'));
				return;
			} 
			else
			{
				txId = transaction.id;
				Bank.Debit.openTransaction(txId, openTransactionCallback.bind(this));
			} 

		}; 

		var orderSuccess = function(itemid) {
			//Add chips/comps

			var purchasedIAP = thisObj._iaps[itemid];
			if (purchasedIAP) {
				if (purchasedIAP.getType() == IAP.Type.ChipsIAP) {
					SCGame.updatePlayer(Player.StatType.Chips, purchasedIAP.getValue(), true);
				} else if (purchasedIAP.getType() == IAP.Type.CompIAP) {
					SCGame.updatePlayer(Player.StatType.Comp, purchasedIAP.getValue(), true);
				}

				SCGame.quickSavePlayer();
				thisObj._inTransaction = false;
				Bank.Debit.closeTransaction(txId,closeTransCallback.bind(this));
			}
		}

		Bank.Debit.createTransaction(billingItems, comment, createTransCallback.bind(this));

		var openTransactionCallback = function (error, transaction){
			if(transaction) {
				//transaction opened at Server
				orderSuccess(iap._id);

			}
			else
			{
				thisObj._inTransaction = false;
				Social.Common.Service.hideBalanceButton(new UI.ViewGeometry.Rect(0,0,210,70),function (error,transaction) {});
				console.log("Error opening Transaction.");
				AlertLayer.showAlertNode(new GenericAlertNode('The transaction failed to complete.  Please try again.','Failure'));
				Bank.Debit.cancelTransaction(txId, cancelTransactionCallback.bind(this));
				return;
			}
		}

		var closeTransCallback = function(error, transaction) {
				if(!error) {
					Social.Common.Service.hideBalanceButton(new UI.ViewGeometry.Rect(0,0,210,70),function (error,transaction) {});
					if(transaction) {
						AlertLayer.showAlertNode(new GenericAlertNode('Your purchase was successful.','SUCCESS'));
					} else {
						thisObj._inTransaction = false;
						return;						
					}
				} else {
					thisObj._inTransaction = false;
					Social.Common.Service.hideBalanceButton(new UI.ViewGeometry.Rect(0,0,210,70),function (error,transaction) {});
					console.log("Error completing/closing Transaction.");
					AlertLayer.showAlertNode(new GenericAlertNode('The transaction failed to complete.  Please try again.','Failure'));
					Bank.Debit.cancelTransaction(txId, cancelTransactionCallback.bind(this));
					return;
				}
		}

	    },

	
	getInTransaction:function(){
		return this._inTransaction;
	},

});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Common/SCStyle'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Common/SCStyle'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Common/SCStyle'] = exports; /**
 * @author will
 */
 
exports.SCStyle = Core.Class.subclass({

    FontStyle: {
        Serif32: 0,
        Serif16: 1,
		Serif14: 2,
		Serif12: 3,
        Serif10: 4,
		Serif24: 5,		
		Serif48: 6,		
		SerifB32:10,		
		SerifB24:11,
		SerifB20:12,
		SerifB18:13,
		SerifB16:14,
		SerifB14:15,
		SerifB12:16,
        Sans32: 20,
		Sans28: 21,
        Sans16: 22,
		Sans14: 23,
		Sans12: 24,
        Sans10: 25,
		SansB32: 30,
		SansB24: 31,
		SansB18: 32,
		SansB16: 33,
		SansB14: 34,
		Sans24: 35,
		Sans22: 36,
    },
    
    $applyFontStyle: function(text, style){
		var shadowText = false; 
		if (text.classname == TextWithShadow.classname) {
			shadowText = true;
		}
		
		text.setFontSize(32);
		
        switch (style) {
            case this.FontStyle.Serif32:
                text.setFontFamily('DroidSerif-Regular');
				break;
            case this.FontStyle.Serif16:
                text.setFontFamily('DroidSerif-Regular');
				text.setScale(0.5,0.5);
                break;
			case this.FontStyle.Serif14:
                text.setFontFamily('DroidSerif-Regular');
				text.setScale(0.4375,0.4375);
                break;
			case this.FontStyle.Serif12:
                text.setFontFamily('DroidSerif-Regular');	
				text.setScale(0.375,0.375);
                break;
            case this.FontStyle.Serif10:
                text.setFontFamily('DroidSerif-Regular');	
				text.setScale(0.3125,0.3125);
                break;
            case this.FontStyle.Serif24:
                text.setFontFamily('DroidSerif-Regular');	
				text.setScale(0.75,0.75);
                break;
            case this.FontStyle.Serif48:
                text.setFontFamily('DroidSerif-Regular');	
				text.setScale(1.5,1.5);
                break;
			case this.FontStyle.SerifB32:
                text.setFontFamily('DroidSerif-Bold');
                break;					
			case this.FontStyle.SerifB24:
                text.setFontFamily('DroidSerif-Bold');
				text.setScale(0.75,0.75);
                break;	
            case this.FontStyle.SerifB20:
                text.setFontFamily('DroidSerif-Bold');
				text.setScale(0.625,0.625);
                break;
			case this.FontStyle.SerifB18:
                text.setFontFamily('DroidSerif-Bold');
				text.setScale(0.5625,0.5625);
                break;
            case this.FontStyle.SerifB16:
                text.setFontFamily('DroidSerif-Bold');	
				text.setScale(0.5,0.5);
                break;
			case this.FontStyle.SerifB14:
                text.setFontFamily('DroidSerif-Bold');	
				text.setScale(0.4375,0.4375);
                break;
			case this.FontStyle.SerifB12:
                text.setFontFamily('DroidSerif-Bold');	
				text.setScale(0.375,0.375);
                break;	
            case this.FontStyle.Sans32:
                text.setFontFamily('DroidSans-Regular');
				break;
            case this.FontStyle.Sans28:
                text.setFontFamily('DroidSans-Regular');
				text.setScale(0.875,0.875);
				break;
            case this.FontStyle.Sans16:
                text.setFontFamily('DroidSans-Regular');
				text.setScale(0.5,0.5);
                break;				
            case this.FontStyle.Sans24:
                text.setFontFamily('DroidSans-Regular');
				text.setScale(0.75,0.75);
                break;
            case this.FontStyle.Sans22:
                text.setFontFamily('DroidSans-Regular');
				text.setScale(0.6875,0.6875);
                break;
			case this.FontStyle.Sans14:
                text.setFontFamily('DroidSans-Regular');
				text.setScale(0.4375,0.4375);
                break;
			case this.FontStyle.Sans12:
                text.setFontFamily('DroidSans-Regular');
				text.setScale(0.375,0.375);
                break;				
            case this.FontStyle.Sans10:
                text.setFontFamily('DroidSans-Regular');	
				text.setScale(0.3125,0.3125);
                break;
			case this.FontStyle.SansB32:
                text.setFontFamily('DroidSans-Bold');	
                break;
			case this.FontStyle.SansB24:
                text.setFontFamily('DroidSans-Bold');
				text.setScale(0.75,0.75);
                break;
			case this.FontStyle.SansB18:
                text.setFontFamily('DroidSans-Bold');
				text.setScale(0.5625,0.5625);
                break;
			case this.FontStyle.SansB16:
                text.setFontFamily('DroidSans-Bold');
				text.setScale(0.5,0.5);
                break;
			case this.FontStyle.SansB14:
                text.setFontFamily('DroidSans-Bold');
				text.setScale(0.4375,0.4375);
                break;															
            default:
                break;
        }
    
      // if(SCGame.getSettings().getJapaneseOn()){
      //   text.setFontFamily('DroidSans-Regular');
      // }
        
    },
	
	$createBleedBlocker: function() {
		
		var fontWorkaround = new GL2.Text();
		fontWorkaround.setFontFamily('DroidSans-Regular');
		fontWorkaround.setFontSize(32);
        fontWorkaround.setDepth(-1);
		fontWorkaround.setText('abcdefghijklmnopqrstuvwxyz1234567890\n\n\n\n\n');
		fontWorkaround.setVisible(true);
		
		var fontWorkaround2 = new GL2.Text();
		fontWorkaround2.setFontFamily('DroidSerif-Regular');
		fontWorkaround2.setFontSize(32);
        fontWorkaround2.setDepth(-1);
		fontWorkaround2.setText('abcdefghijklmnopqrstuvwxyz1234567890\n\n\n\n\n');		
		fontWorkaround2.setVisible(true);

		var fontWorkaround3 = new GL2.Text();
		fontWorkaround3.setFontFamily('DroidSans-Bold');
		fontWorkaround3.setFontSize(32);
        fontWorkaround3.setDepth(-1);
		fontWorkaround3.setText('abcdefghijklmnopqrstuvwxyz1234567890\n\n\n\n\n');
		fontWorkaround3.setVisible(true);
		
		var fontWorkaround4 = new GL2.Text();
		fontWorkaround4.setFontFamily('DroidSerif-Bold');
		fontWorkaround4.setFontSize(32);
        fontWorkaround4.setDepth(-1);
		fontWorkaround4.setText('abcdefghijklmnopqrstuvwxyz1234567890\n\n\n\n\n');		
		fontWorkaround4.setVisible(true);
		
		var node = new GL2.Node();
		node.addChild(fontWorkaround);
		node.addChild(fontWorkaround2);
		node.addChild(fontWorkaround3);
		node.addChild(fontWorkaround4);		
		node.setScale(0.01,0.01);
		
		return node;
				
		
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/OpenSocial/OpenSocialManager'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/OpenSocial/OpenSocialManager'] || {}; $MODULE_REGISTRY['Code/StripCity/OpenSocial/OpenSocialManager'] = exports; var Styles = require('Code/StripCity/OpenSocial/Styles').Styles;
var Dump = require('Code/StripCity/OpenSocial/Dumper').Dump;
var Gravity = UI.ViewGeometry.Gravity;



var DialogController = require('Code/StripCity/OpenSocial/DialogController').DialogController;

exports.OpenSocialManager = Class.singleton({
    initialize: function(){

    },
	
	initUser: function(callback){
		this.currentUser = null;
		var fields = ["id","age","displayName","thumbnailUrl"];
	
//		Social.Common.People.getCurrentUser( fields, function(error, user){
//			OpenSocialManager.setUser(user);
//
//				callback();
//		});

		Social.Common.People.getCurrentUser( fields, function(error, user){
			if (error)
			{
				var alertDialog = new UI.AlertDialog();
               	alertDialog.setTitle("");
		        alertDialog.setText("Error");
	        	alertDialog.onchoice = function(event) {
					LGL.runGame(null);
				};
	        	alertDialog.show();
				return;
			}	
				
			
			
		   	OpenSocialManager.setUser(user);
		  	callback.apply(this);
		});

	},
    
    getUser: function(){
        return this.currentUser;
    },
	
    setUser: function(u){
       	this.currentUser = u;

    },
	
	showCommunityButton:function(){
		var theme = 'default';
		Social.Common.Service.showCommunityButton(Gravity.TopLeft,theme,function(error) {
			var res = {
				error: error
			};
			NgApplication.getInstance().setOrientation(NgApplicationOrientation.LandscapeRight);
		});
				
	},
	
	hideCommunityButton:function(){
		Social.Common.Service.hideCommunityButton(function(error) {
				var res = {
					error: error
				};
				
			});
	}
	
	
});




; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Bank'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Bank'] || {}; $MODULE_REGISTRY['NGCore/Client/Bank'] = exports; 

exports.Bank = require('NGCore/Client/Social/US/Service/Bank').Bank;; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Animation'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Animation'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Animation = Core.Class.subclass(
/** @lends GL2.Animation.prototype */
{
	classname: 'Animation',
    
	/**
	 * @class The <code>Animation</code> class constructs objects that define application animations. Animations aggregate and control 
	 * the instantiation of <code>Frame</code> objects for manipulation of <code>{@link GL2.Sprite}</code> and
	 * <code>{@link GL2.Primitive}</code> objects. Each <code>Frame</code> object defines a duration and an image display area. 
	 * <code>Frame</code> objects also include a pre-transform 
	 * offset that define the rotation and scale of sprite images. 
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
    initialize: function()
    {
		Core.ObjectRegistry.register(this);
		
        this._wrapMode = this.WrapMode.WrapNone;
        this._blendEnabled = true;
        this._filteringEnabled = true;
		this._loopingEnabled = true;
		this._totalDuration = 0;
		this._frames = [];
		
		this._createSendGen(this);
    },

	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Retrieve the specified texture wrap mode for this <code>Animation</code>.
	 * @returns {GL2.Animation#WrapMode} The current texture wrap mode.
	 * @see GL2.Animation#setWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getWrapMode: function()
	{
		return this._wrapMode;
	},
	
	/**
	 * Retrieve the alpha blending state for this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if alpha blending is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getBlendEnabled: function()
	{
		return this._blendEnabled;
	},
	
	/**
	 * Retrieve the filtering state for this <code>Animation</code>. 
	 * @returns {Boolean} Returns <code>true</code> if filtering is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setFilteringEnabled
	 */
	getFilteringEnabled: function()
	{
		return this._filteringEnabled;
	},
	
	/**
	 * Retrieve the looping state of this <code>Animation</code>.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled. Returns <code>false</code> in all other cases.
	 * @see GL2.Animation#setLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getLoopingEnabled: function()
	{
		return this._loopingEnabled;
	},
	
	/**
	 * Retrieve the total duration of this <code>Animation</code> in milliseconds.
	 * @returns {Number} The current duration. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTotalDuration: function()
	{
		return this._totalDuration;
	},
	
	/**
	 * Retrieve the total number of frames in this <code>Animation</code>.
	 * @returns {Number} The current number of frames. 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrameCount: function()
	{
		return this._frames.length;
	},
	
	/**
	 * Retrieve a frame at the specified index for this <code>Animation</code>.
	 * @param {Number} index The specified index.
	 * @returns {GL2.Animation.Frame} The current frame at the specified index.
	 * @see GL2.Animation#setFrame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFrame: function(index)
	{
		return this._frames[index];
	},
    
    /**
	 * Apply a wrap mode to frame textures for this <code>Animation</code>.
	 * @param {GL2.Animation#WrapMode} [wrapMode=0] The new texture wrap mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getWrapMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */						
    setWrapMode: function(wrapMode)
	{
		this._wrapMode = wrapMode;
		
		this._setWrapModeSendGen(
		{
			wrapMode: wrapMode,
		});
		
		return this;
	},
    
    /**
	 * Set the alpha blending state for this <code>Animation</code>. 
	 * <br><br>
	 * <b>Note:</b> You can improve performance for animations with completely opaque frames by disabling alpha blending.
	 * @param {Boolean} [blendEnabled=true] Set as <code>true</code> to enable alpha blending.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getBlendEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setBlendEnabled: function(blendEnabled)
	{
		this._blendEnabled = blendEnabled;
		
		this._setBlendEnabledSendGen(
		{
			blendEnabled: blendEnabled,
		});
		
		return this;
	},
	
	   /**
	 * Set the filtering state for this <code>Animation</code>.
	 * <br><br>
	 * @param {Boolean} [filteringEnabled=false] Set as <code>true</code> to enable filtering. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getFilteringEnabled
	 */
    setFilteringEnabled: function(filteringEnabled)
	{
		this._filteringEnabled = filteringEnabled;
		
		this._setFilteringEnabledSendGen(
		{
			filteringEnabled: filteringEnabled,
		});
		
		return this;
	},
    
    /**
	 * Set the looping state for this <code>Animation</code>.
	 * @param {Boolean} [loopingEnabled=false] Set as <code>true</code> to enable animation looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation#getLoopingEnabled
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setLoopingEnabled: function(loopingEnabled)
	{
		this._loopingEnabled = loopingEnabled;
		
		this._setLoopingEnabledSendGen(
		{
			loopingEnabled: loopingEnabled,
		});
		
		return this;
	},
    
    /**
	 * Add a frame to the end of this <code>Animation</code>.<br><br>
	 * <pre class="code"><font size="2">var animation = new GL2.Animation();
	 * animation.pushFrame(new GL2.Animation.Frame('Content/tank.png', 50, [64, 64], [0.5, 0.5], [0/5, 0, 1/5, 1]));</font></pre>
	 * Calling <code>pushFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * <pre class="code"><font size="2">animation.spliceFrames(animation.getFrameCount(), 0, frame);</font></pre>
	 * @param {GL2.Animation.Frame} frame The frame to add.
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushFrame: function(frame)
	{
		return this.spliceFrames(this._frames.length, 0, frame);
	},
    
    /**
	 * Replace the frame at index <i>i</i>.<br><br>
	 * Calling <code>setFrame()</code> is equivalent to calling <code>spliceFrames()</code> in the following way: 
	 * @example animation.spliceFrames(i, 1, frame)
	 * @param {Number} i Index of the frame to replace.
	 * @param {GL2.Animation.Frame} frame The frame to insert.
	 * @see GL2.Animation#getFrame,
	 * @see GL2.Animation#spliceFrames
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFrame: function(i, frame)
	{
		return this.spliceFrames(i, 1, frame);
	},
    
    /**
	 * Remove a specific number of frames from this <code>Animation</code> and replace them with specified frames.
	 * <br><br>
	 * <b>Note:</b> This method accepts multiple parameters. The third parameter and beyond define all
	 * <code>Frames</code> to use for replacement.<br><br>
	 * The following example passes in three frames to a <code>spliceFrames()</code> call.
	 * @example animation.spliceFrames(0, 0, frame1, frame2, frame3).
	 * @param {Number} start The index of the first frame to remove.
	 * @param {Number} len The total number of frames to remove.
	 * @param {GL2.Animation.Frame} frames The frames to insert. 
	 * <br><br>
	 * <b>Note:</b> This parameter accepts multiple values.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceFrames: function(start, len, frames)
	{
		// Decrement from total duration.
		for(var i=start; i < start + len; ++i)
			this._totalDuration -= this._frames[i].getDuration();
		
		this._frames.splice.apply(this._frames, arguments);
		
		var frameCount = arguments.length-2;
		this._spliceFramesSendGen(
		{
			start: start,
			len: len,
			frameCount: frameCount,
		});
		
		for(var i=0; i < frameCount; ++i)
		{
			var frame = arguments[i+2];
			var duration = frame.getDuration();
			var size = frame.getSize();
			var anchor = frame.getAnchor();
			var uvs = frame.getUVs();
			var uvOrigin = uvs.getOrigin();
			var uvSize = uvs.getSize();
			this._frameSendGen(
			{
				image: frame.getImage(),
				duration: duration,
				width: size.getWidth(),
				height: size.getHeight(),
				anchorX: anchor.getX(),
				anchorY: anchor.getY(),
				startU: uvOrigin.getX(),
				startV: uvOrigin.getY(),
				sizeU: uvSize.getWidth(),
				sizeV: uvSize.getHeight(),
			});
			
			this._totalDuration += duration;
		}
		
		return this;
	},
	
	$Frame: Core.Class.subclass(
	/** @lends GL2.Animation.Frame.prototype */
	{
		classname: 'Frame',
		
		/**
		 * @class <code>Frame</code> objects define a path to an image and any properties that support the image as
		 * a single frame in an animation.
		 * @constructs The default constructor. 
		 * @param {String} image The directory path to an image.
		 * @param {Number} duration The time duration of the frame in milliseconds.
		 * @param {Core.Size} size The size of the frame in pixels.
		 * @param {Core.Point} anchor The offset within the frame used for scaling and rotation.
		 * @param {Core.Rect} uvs The image region to use for the frame. The default value is <code>[0,0,1,1]</code> (the entire image) 
		 * with a start coordinate of <code>(0,0)</code> and a size of <code>(1,1)</code>.<br><br> 
		 * <b>Example:</b> To select the lower left region of an image with nine distinct frames (three horizontally, three vertically), 
		 * you would specify <code>[0, 0.66, 0.33, 0.33]</code>. The start coordinate is <code>(0, 0.66)</code>, 
		 * which is the left edge of the image and 2/3rds down. 
		 * The size is <code>(0.33, 0.33)</code> which is a third of the image in each <i>x</i> and <i>y</i> direction.
		 * @see GL2.Animation
		 * @default [0,0,1,1] (the entire image)
		 * @augments Core.Class
		 */
		initialize: function(image, duration, size, anchor, uvs)
		{
			this._image     = image;
			this._duration  = duration || 0;
			this._size   = new Core.Size(size);
			
			if(anchor)
				this._anchor = new Core.Point(anchor);
			else
				this._anchor = new Core.Point(0.5, 0.5);
			
			if(uvs)
				this._uvs = new Core.Rect(uvs);
			else
				this._uvs = new Core.Rect(0, 0, 1, 1);
		},

		/**
		 * Retrieve the image directory path referenced by this <code>Frame</code>.
		 * @returns {String} The current directory path to the image.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getImage:    function()
		{
			return this._image;
		},
		
		/**
		 * Retrieve time duration in milliseconds for this <code>Frame</code>.
		 * @returns {Number} The current time duration for the frame.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getDuration:  function()
		{
			return this._duration;
		},

		/**
		 * Retrieve the pixel size of this <code>Frame</code>.
		 * @returns {Core.Size} The current frame size in pixels.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getSize:    function()
		{
			return this._size;
		},

		/**
		 * Retrieve the offset used for scaling and rotation from within this <code>Frame</code>.
		 * @returns {Core.Point} The current frame offset.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getAnchor:  function()
		{
			return this._anchor;
		},

		/**
		 * Retrieve the texture rectangle for this <code>Frame</code> in UV coordinates.
		 * @returns {Core.Rect} The current UV bounds of the frame within the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUVs:    function()
		{
			return this._uvs;
		},
	}),
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for UV wrapping modes.
	 * @namespace
	 */
	WrapMode:
	{ 
		/** Clamp in both U and V. */
		WrapNone: 0,
		/** Wrap in U, clamp in V. */
		WrapU: 1,
		/** Wrap in V, clamp in U. */
		WrapV: 2,
		/** Wrap in both U and V. */
		WrapUV: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 306
	// Method create = -1
	// Method destroy = 2
	// Method setWrapMode = 3
	// Method setBlendEnabled = 4
	// Method setLoopingEnabled = 5
	// Method spliceFrames = 6
	// Method frame = 7
	// Method setFilteringEnabled = 8
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Animation._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[306] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 306 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 306 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_setWrapModeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 306 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "wrapMode" ]  );
	},
	
	/** @private */
	_setBlendEnabledSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 306 + "," + 4 + "," + this.__objectRegistryId + "," + ( obj[ "blendEnabled" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_setLoopingEnabledSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 306 + "," + 5 + "," + this.__objectRegistryId + "," + ( obj[ "loopingEnabled" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_spliceFramesSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 306 + "," + 6 + "," + this.__objectRegistryId + "," + obj[ "start" ] + "," + obj[ "len" ] + "," + obj[ "frameCount" ]  );
	},
	
	/** @private */
	_frameSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( "," + Core.Base64.encode( obj[ "image" ] ) + "," + obj[ "duration" ] + "," + obj[ "width" ] + "," + obj[ "height" ] + "," + obj[ "anchorX" ] + "," + obj[ "anchorY" ] + "," + obj[ "startU" ] + "," + obj[ "startV" ] + "," + obj[ "sizeU" ] + "," + obj[ "sizeV" ]  );
	},
	
	/** @private */
	_setFilteringEnabledSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 306 + "," + 8 + "," + this.__objectRegistryId + "," + ( obj[ "filteringEnabled" ] ? 1 : 0 )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setWrapMode: function( wrapMode ) {}
	
	// setBlendEnabled: function( blendEnabled ) {}
	
	// setLoopingEnabled: function( loopingEnabled ) {}
	
	// spliceFrames: function( start, len, frameCount ) {}
	
	// frame: function( image, duration, width, height, anchorX, anchorY, startU, startV, sizeU, sizeV ) {}
	
	// setFilteringEnabled: function( filteringEnabled ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Primitive'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Primitive'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;

exports.Primitive = Node.subclass(
/** @lends GL2.Primitive.prototype */
{
	classname: 'Primitive',
    
	/**
	 * @class The <code>Primitive</code> class constructs objects that draw arbitrary vertex-based geometry.
	 * These objects provide a means of drawing raw 2D <a href="GL2.Primitive.Vertex.html">vertex</a> data as polygons to a <code>{@link UI.View}</code>. Data is
	 * provided by users as a vertex list. 
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 */
    initialize: function()
    {
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
        this._type = this.Type.Triangles;
        this._vertexes = [];
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code>.
	 * @see GL2.Animation
	 * @status iOS, Android, Flash
	 */
	destroy: function()
	{
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	/**
	 * Retrieve the number of listed vertices in the geometry of this <code>Primitive</code>.
	 * @returns {Number} The current number of vertices.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertexCount: function()
	{
		return this._vertexes.length;
	},
	
	/**
	 * Retrieve a single vertex from the vertex list of this <code>Primitive</code>.
	 * @param {Number} index The vertex list offset to retrieve.
	 * @returns {GL2.Primitive.Vertex} The current vertex at the specified index in the vertex list.
	 * @see GL2.Primitive#setVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVertex: function(index)
	{
		return this._vertexes[index];
	},
	
	/**
	 * Retrieve the GL draw mode for this <code>Primitive</code>.
	 * @returns {GL2.Primitive#Type} The current draw mode.
	 * @see GL2.Primitive#setType
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getType: function()
	{
		return this._type;
	},
	
	/**
	 * Retrieve the current <code>Texture Animation</code> object of this <code>Primitive</code>.
	 * @returns {GL2.Animation} The current animation.
	 * @see GL2.Primitive#setAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
	
	/**
	 * Retrieve the complete message emitter for the current animation.
	 * @returns {Core.MessageEmitter} The emitter for the current texture animation.
	 * @see GL2.Animation,  
	 * @see Core.MessageEmitter
	 * @status iOS, Android, Flash
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
	/**
	 * Begin playing the specified animation.
	 * Any animation that is not set to loop will trigger the animation complete callback when done.
	 * @example primitive.setAnimation(myAnimation, 30);
	 * @param {GL2.Animation} animation The current animation.
	 * @param {Number} [startTime=0] The starting point of the animation. Expressed as a float.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @see GL2.Primitive#getAnimation
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen(
		{
			animation: Core.ObjectRegistry.objectToId(animation),
			startTime: startTime || 0,
		});
	},
    
    /**
	 * Set a static image as the current animation for this <code>Primitive</code>.
	 * This method instantiates a single frame animation of infinite duration using the
	 * specified image. If the primitive is playing another animation at the time of this call, 
	 * the new animation will take priority over the primitive.
	 * The previous animation will stop and the complete emitter will not respond. 
	 * This is because the animation did not technically complete a full playback cycle. <br><br>
	 * You can define optional parameters for the size, anchor, and UV coordinates of the specified image. 
	 * @example primitive.setImage('./Content/blank.png', [480, 320], [0, 0]);
	 * @param {String} image The directory path to an image referenced by a frame.
	 * @param {Core.Size} [size] The size of the image to display in pixels.
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Animation, 
	 * @see GL2.Animation.Frame
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(
		{
			animation: Core.ObjectRegistry.objectToId(animation),
			startTime: 0,
		});
		
		return this;
	},
    
    /**
	 * Set the type of geometry on display for this <code>Primitive</code>.
	 * @example primitive.setType(GL2.Primitive.Type.TriangleFan);
	 * @param {GL2.Primitive#Type} type The new GL draw mode.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setType: function(type)
	{
		this._type = type;
		
		this._setTypeSendGen(
		{
			type: type,
		});
		
		return this;
	},
    
    /**
     * Add a vertex to the end of the vertex list for this <code>Primitive</code>.<br>
     * <pre class="code"><font size="2">primitive.pushVertex(new Core.Point(w*2/10, h*5/6));</font></pre><br>
     * Calling <code>pushVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
     * <pre class="code"><font size="2">primitive.spliceVertexes(primitive.getVertexCount(), 0, vertex);</font></pre>
     * @param {GL2.Primitive.Vertex} vertex The vertex to add.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    pushVertex: function(vertex)
	{
		return this.spliceVertexes(this._vertexes.length, 0, vertex);
	},
    
    /**
	 * Set the vertex at index <i>i</i> for this <code>Primitive</code>.
	 * Calling <code>setVertex()</code> is equivalent to calling <code>spliceVertexes()</code> in the following way:
	 * @example primitive.spliceVertexes(i, 1, vertex)
	 * @param {Number} <i>i</i> The index in the vertex list to set.
	 * @param {GL2.Primitive.Vertex} vertex The new vertex.
	 * @see GL2.Primitive#getVertex
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVertex: function(i, vertex)
	{
		return this.spliceVertexes(i, 1, vertex);
	},
    
    /**
	 * Replace <code>len</code> vertices, starting at position <code>start</code>, with specified vertices.<br><br>
	 * The following are examples of different call styles for <code>spliceVertexes</code>.<br><br>
	 * Splice a simple textureless quad into the vertex list.
	 * <pre class="code"><font size="2">var c = new Core.Color([1,1,1]);
	 * var w = 100;
	 * var h = 100;
	 * var v = new Array();
	 * v.push(new GL2.Primitive.Vertex([0,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,0],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([w,h],[0,0],c));
	 * v.push(new GL2.Primitive.Vertex([0,h],[0,0],c));</font></pre>
	 * Insert four vertices at position 0 in the vertex list.
	 * <pre class="code"><font size="2">myPrimitive.spliceVertexes.apply(myPrimitive, ([0,0]).concat(v));
	 * myPrimitive.setType(GL2.Primitive.Type.TriangleFan);</font></pre>
	 * @param {Number} start The index from which to remove vertices in the vertex list.
	 * @param {Number} len The number of vertices to replace.
	 * @param {GL2.Primitive.Vertex} vertexes A list of vertices to insert at the start location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    spliceVertexes: function(start, len, vertexes)
	{
		this._vertexes.splice.apply(this._vertexes, arguments);
		
		var vertexCount = arguments.length-2;
		this._spliceVertexesSendGen(
		{
			start: start,
			len: len,
			vertexCount: vertexCount,
		});
		
		for(var i=0; i < vertexCount; ++i)
		{
			var vertex = arguments[i+2];
			var position = vertex.getPosition();
			var uv = vertex.getUV();
			var color = vertex.getColor();
			this._vertexSendGen(
			{
				x: position.getX(),
				y: position.getY(),
				u: uv.getX(),
				v: uv.getY(),
				red: color.getRed(),
				green: color.getGreen(),
				blue: color.getBlue(),
			});
		}
		
		return this;
	},

	$Vertex: Core.Class.subclass(
	/** @lends GL2.Primitive.Vertex.prototype */
	{
		classname: 'Vertex',
		
		/**
		 * @class <code>Vertex</code> objects specify location, texture coordinates, and color data
		 * for GL primitive geometry.
		 * @constructs The default constructor. 
		 * @param {Core.Vector|float[2]} position A location.
		 * @param {Core.Vector|float[2]} uv A texture coordinate.
		 * @param {Core.Color|float[3]} color An RGB color triplet.
		 * @see GL2.Primitive
		 * @augments Core.Class
		 */
		initialize: function(position, uv, color)
		{
			this._position = new Core.Point(position);
			this._uv = new Core.Point(uv);
			this._color = new Core.Color(color);
		},
		
		/**
		 * Retrieve the location of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the vertex.
    	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getPosition: function()
		{
			return this._position;
		},
		
		/**
		 * Retrieve the texture coordinates of this <code>Vertex</code>.
		 * @returns {Core.Vector} The current <i>x</i>,<i>y</i> coordinates for the texture.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getUV: function()
		{
			return this._uv;
		},
		
		/**
		 * Retrieve the color of this <code>Vertex</code>.
		 * @returns {Core.Color} The current vertex color as a RGB triplet.
		 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
		 */
		getColor: function()
		{
			return this._color;
		},
	}),
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(
			{
				animation: 0,
				startTime: 0,
			});
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
		this._image = null;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for primitive types.
	 * @namespace
	 */
	Type:
	{ 
		/** Every three vertices define a unique triangle. */
		Triangles: 0,
		/** Every vertex defines a triangle with the 2 preceding vertices. */
		TriangleStrip: 1,
		/** Every vertex defines a triangle with the first vertex and the previous vertex. */
		TriangleFan: 2,
		/** Every vertex pair defines a line segment. */
		LineList: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 308
	// Method create = -1
	// Method spliceVertexes = 2
	// Method vertex = 3
	// Method setType = 4
	// Method setAnimation = 5
	// Method animationComplete = 6
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 6:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Primitive._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[308] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Primitive.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 308 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_spliceVertexesSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 308 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "start" ] + "," + obj[ "len" ] + "," + obj[ "vertexCount" ]  );
	},
	
	/** @private */
	_vertexSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( "," + obj[ "x" ] + "," + obj[ "y" ] + "," + obj[ "u" ] + "," + obj[ "v" ] + "," + obj[ "red" ] + "," + obj[ "green" ] + "," + obj[ "blue" ]  );
	},
	
	/** @private */
	_setTypeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 308 + "," + 4 + "," + this.__objectRegistryId + "," + obj[ "type" ]  );
	},
	
	/** @private */
	_setAnimationSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 308 + "," + 5 + "," + this.__objectRegistryId + "," + obj[ "animation" ] + "," + obj[ "startTime" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// spliceVertexes: function( start, len, vertexCount ) {}
	
	// vertex: function( x, y, u, v, red, green, blue ) {}
	
	// setType: function( type ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Touch'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Touch'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Touch = Core.Class.subclass(
/** @lends GL2.Touch.prototype */
{
	classname: 'Touch',
	
	/**
	 * @class The <code>Touch</code> class constructs objects that identify and track the life cycle of unique touch events in the system.
	 * @constructs These objects are constructed by the system.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		this._id = 0;
		this._action = {};
		this._position = new Core.Point();
		this._targetIds = null;
	},
	
	/**
	 * Retrieve a list of every <code>TouchTarget</code> object in which this <code>Touch</code> object resides and is marked as touchable.
	 * @returns {GL2.TouchTarget} A prioritized list of every <code>TouchTarget</code> for this <code>Touch</code>.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchTargets: function()
	{
		var ids = this._targetIds;
		var result = [];
		for(var i in ids)
		{
			var t = Core.ObjectRegistry.idToObject(ids[i]);
			if(t) result.push(t);
		}
		return result;
	},
	
	/**
	 * Retrieve whether or not this <code>Touch</code> object resides in the specified <code>TouchTarget</code>.
	 * @param {GL2.TouchTarget} touchTarget The <code>TouchTarget</code> to test against.
	 * @returns {Boolean} Returns <code>true</code> when this <code>Touch</code> resides in the <code>TouchTarget</code>.
	 * @status iOS, Android, Flash
	 */
	getIsInside: function(touchTarget)
	{
		var ids = this._targetIds;
		var id = Core.ObjectRegistry.objectToId(touchTarget);
		if(this._targetIds.indexOf(id) == -1)
			return false;
		else
			return true;
	},
	
	/**
	 * Retrieve the location of this <code>Touch</code> object in the global coordinate space.
	 * @returns {Core.Vector} The global coordinates of the <code>Touch</code> location.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getPosition: function()
	{
		return this._position;
	},
	
	/**
	 * Retrieve the ID of this <code>Touch</code> object.
	 * <b>Note:</b> When using this ID as a key, append it to a string so that you can use
	 * it to key an associative array. Otherwise, you will end up with a very large array.
	 * @returns {Number} The current <code>Touch</code> ID.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getId: function()
	{
		return this._id;
	},
	
	/**
	 * Retrieve the phase of this <code>touch</code> event.
	 * Use this method from your listener callback.
	 * The following is an example of a <code>touch</code> event handler for a button.
	 * @example
	 * onTouch: function(touch)
	 * {
	 * 	//getAction() informs us of the type of event being handled.
	 * 	//  In order to get Action.Move and Action.End, we need to return true from Action.Start.
	 * 	switch(touch.getAction())
	 * 	{
	 * 		case touch.Action.Start:
	 * 			//Change the color of our Rectangle
	 * 			this.button.setColor(Defaults.onColor);
	 * 			
	 * 			//Return true here if you want to capture this event for its lifetime.
	 * 			//  returning false will let other, lower priority handlers capture the
	 * 			//  event. In that case we would not want to react to the Action.Start since
	 * 			//  we would not get subsequent Action.End or Action.Move.
	 * 			return true;
	 * 			
	 * 		case touch.Action.End:
	 * 			//Reset the color of our Rectangle
	 * 			this.button.setColor(Defaults.offColor);
	 * 			
	 * 			//We do not need to return anything in Action.End or Action.Move.
	 * 			break;
	 * 		case touch.Action.Move:
	 * 			//The touch object allows us to retrieve metadata about the event.
	 * 			//  If the touch has left our bounds, getIsInside() will return false.
	 * 			if(!touch.getIsInside(this._target))
	 * 			{
	 * 				//If the active touch is outside, reset our Rectangle color.
	 * 				this.button.setColor(Defaults.offColor);
	 * 			}
	 * 			else
	 * 			{
	 * 				//If the active touch is inside, set our Rectangle color to on.
	 * 				this.button.setColor(Defaults.onColor);
	 * 			}
	 * 			break;
	 * 	}
	 * }
	 * @returns {GL2.Touch#Action} The current <code>touch</code> event phase.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAction: function()
	{
		return this._action;
	},
	
	_setId: function(id)
	{
		this._id = id;
	},
	
	_setAction: function(action)
	{
		this._action = action;
	},
	
	_setPosition: function(position)
	{
		this._position.setAll(arguments);
	},
	
	_setTargetIds: function(targetIds)
	{
		this._targetIds = targetIds.slice(0);
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for touch action.
	 * @namespace
	 */
	Action:
	{ 
		/** Finger began touching screen. */
		Start: 0,
		/** Finger stopped touching screen. */
		End: 1,
		/** Finger moved where it is touching the screen. */
		Move: 2,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 312
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Touch._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[312] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	// This class is expected to implement the following methods outside of
	// the generated block:

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/TouchTarget'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/TouchTarget'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Sprite = require('NGCore/Client/GL2/Sprite').Sprite;
var Core = require('NGCore/Client/Core').Core;

exports.TouchTarget = Node.subclass(
/** @lends GL2.TouchTarget.prototype */
{
	classname: 'TouchTarget',
    
	/**
	 * @class <code>TouchTarget</code> class constructs objects that provide applications access to touch events.
	 *<br><br>
	 * A <code>TouchTarget</code> is a node with added size and offset attributes that define a
	 * rectangular area as active. Any <a href"GL2.Touch.html">touch</a> that falls within the active area is broadcast
	 * to the <code>TouchTarget</code> where a <code>MessageListener</code> can respond 
	 * to the event. Attach a listener by calling <code><a href="GL2.TouchTarget.html#getTouchEmitter">getTouchEmitter()</a></code>
	 * to retrieve the emitter.
	 *<br><br>
	 * A <code>TouchTarget</code> is created with a <code>0</code> size and a center offset anchor point <code>(0.5,0.5)</code>.
	 * Set these two properties to define a usable area that supports touch events. Generally,
	 * you set these two values as identical to the values for <code><a href="GL2.Sprite.html">sprite</a></code>, <code><a href="GL2.Text.html">text</a></code>, 
	 * or <code><a href="GL2.Primitive.html">primitive</a></code> and add
	 * the <code>TouchTarget</code> as a child of that visible node with a position of <code>0</code>. The <code>TouchTarget</code> 
	 * inherits the transform for the visible node. 
	 * <br><br>
	 * <b>Note:</b> A <code>TouchTarget</code> is not part of the drawing scene traversal and activates regardless of node
	 * visibility or parent visibility. 
	 * Disable touch support for a node by calling <code><a href="GL2.Node.html#setTouchable">setTouchable()</a></code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0.5, 0.5);
		this._touchEmitter = new Core.MessageEmitter();
    },
    
	/**
	 * Destroy this instance and release resources on the backend that are associated with this <code>TouchTarget</code> object.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Return the point size of the <code>TouchTarget</code> area.
	 * @returns {Core.Size} The current size of the <code>TouchTarget</code> area.
	 * @see GL2.TouchTarget#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Return the offset values used for scaling and rotating the <code>TouchTarget</code> area.
	 * @returns {Core.Point} The current offset of the target area.
	 * @see GL2.TouchTarget#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Return the touch emitter for this <code>TouchTarget</code>.
	 * The emitter fires when a captured <code>touch</code> event changes phases. For the initial touch down
	 * phase, this emitter fires when the <code>touch</code> event occurs within the defined touch area. After returning <code>true</code> from
	 * the initial <code>touch</code> event, the emitter fires regardless of where the <code>touch</code> event occurs.<br><br>	 
	 * The following example creates a new <code>TouchTarget</code> in the upper left corner of the scene. 
	 * The listener instance handles the <code>touch</code> events in the <code>onTouch()</code> function.
	 * @example
	 * var target = new GL2.TouchTarget();
	 * target.setAnchor([50,50]);
	 * target.setSize([100,100]);
	 * target.setPosition([50,50]);
	 * 
	 * target.getTouchEmitter().addListener(this, this.onTouch);
	 * 
	 * GL2.Root.addChild(target);
	 * @return {Core.MessageEmitter} The touch emitter for this touch area.
	 * @see GL2.Touch#getAction
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getTouchEmitter: function()
	{
		return this._touchEmitter;
	},
	
    /**
	 * Set the size of this <code>TouchTarget</code> (<i>width</i> and <i>height</i>).
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setSize(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenHeight());
	 * @param {Core.Size} size The new size of the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(
		{
			width: s.getWidth(),
			height: s.getHeight(),
		});
		
		return this;
	},
	
    /**
	 * Set the anchor point used to rotate and scale the <code>TouchTarget</code> area.
	 * @example this.t = new GL2.TouchTarget();
	 * this.t.setAnchor(0, 0);
	 * @param {Core.Point} anchor The new anchor point for the <code>TouchTarget</code> area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(anchor)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(
		{
			x: a.getX(),
			y: a.getY(),
		});
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 313
	// Method create = -1
	// Method setSize = 2
	// Method setAnchor = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in TouchTarget._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[313] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 313 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_setSizeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 313 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "width" ] + "," + obj[ "height" ]  );
	},
	
	/** @private */
	_setAnchorSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 313 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "x" ] + "," + obj[ "y" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Root'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Root'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Root'] = exports; var Core = require('NGCore/Client/Core').Core;
var Touch = require('NGCore/Client/GL2/Touch').Touch;

exports.Root = Core.Class.singleton(
/** @lends GL2.Root.prototype */
{
	classname: 'Root',
	
	/**
	 * @class The <code>Root</code> class constructs a singleton object that serves as the proxy object for the {@link UI.GLView} node hierarchy.
	 * <code>Root</code> is the root element of the node hierarchy (also known as a scene graph) for <code>GLView</code>.
	 * The <code>Root</code> transform is composed at the upper left corner of the view with a descending <i>y</i> axis.<br><br>
	 * Adding a node to the <code>Root</code> ensures applications include it when determining drawing and touch events.
	 * @constructs The default constructor.
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		
		this._children = [];
		
		this._createSendGen(this);
		
		this._touchTracking = {};
	},
	
	/**
	 * Add a node and the node subtree to the root of the scene graph.
	 * @example var spr = new GL2.Sprite();
	 * ...
	 * GL2.Root.addChild(spr);
	 * @param {GL2.Node} child The node to add.
	 * @see GL2.Root#removeChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	addChild: function(child)
	{
		this._children.push(child);
		child._didAddToParent(this);
		
		this._addChildSendGen(
		{
			child: Core.ObjectRegistry.objectToId(child),
		});
	},
	
	/**
	 * Remove the child node and the node subtree from the root of the scene graph.<br><br>
	 * <b>Note:</b> This method will not destroy the node. You can keep or destroy a reference to a node 
	 * if you have no further use for it.
	 * @example GL2.Root.removeChild(spr);
	 * @throws {removeChild called for a node that is not a child} Specified node is not a child node.
	 * @param {GL2.Node} child The node to remove.
	 * @see GL2.Root#addChild
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	removeChild: function(child)
	{
		child._willRemoveFromParent();
		
		var index = this._children.indexOf(child);
		if(index == -1)
			throw new Error('removeChild called for a node that is not a child');
		this._children.splice(index, 1);
		
		this._removeChildSendGen(
		{
			child: Core.ObjectRegistry.objectToId(child),
		});
	},
	
	/** 
	 * Translate screen coordinates into node coordinates.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {Core.Vector} location The screen coordinates to translate.
	 * @returns The location as node coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function(location)
	{
		return location;
	},
	
	/** 
	 * Translate node coordinates into screen coordinates.
	 * @param {Core.Vector} location The node coordinates to translate.
	 * @returns The location as screen coordinates.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function(location)
	{
		return location;
	},
	
	_onTouchEventRecv: function( cmd )
	{
		var msg = {};
		if(!this._onTouchEventRecvGen(cmd, msg))
			return;
		
		// Build touch object.
		var touchId = msg.touchId;
		var touchAction = msg.touchAction;
		var touch = new Touch();
		touch._setId(touchId);
		touch._setAction(touchAction);
		touch._setPosition(msg.x, msg.y);
		
		// Extract all touch targets.
		var ids = [];
		for(var i=0; i < msg.touchTargetCount; ++i)
		{
			var t = {};
			if(!this._touchTargetRecvGen(cmd, t))
				return;
			ids.push(t.nodeId);
		}
		
		touch._setTargetIds(ids);
		
		switch(touchAction)
		{
			case Touch.Action.Start:
				// Dispatch to all touch targets until one handles it.
				for(var i=0; i < ids.length; ++i)
				{
					var id = ids[i];
					var o = Core.ObjectRegistry.idToObject(id);
					if(o && o.getTouchEmitter().chain(touch))
					{
						this._touchTracking[touchId] = id;
						break;
					}
				}
				break;
			case Touch.Action.End:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
					delete this._touchTracking[touch.getId()];
				}
				break;
			case Touch.Action.Move:
				// Dispatch to tracking object.
				var track = this._touchTracking[touchId];
				if(track)
				{
					var o = Core.ObjectRegistry.idToObject(track);
                    if (o)
                        o.getTouchEmitter().chain(touch);
				}
				break;
		}
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 309
	// Method create = -1
	// Method addChild = 2
	// Method removeChild = 3
	// Method onTouchEvent = 4
	// Method touchTarget = 5
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 4:
					instance._onTouchEventRecv( cmd );
					break;
				case 5:
					instance._touchTargetRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Root._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[309] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_onTouchEventRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 5 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "touchId" ] === undefined )
		{
			NgLogE("Could not parse touchId in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchAction" ] = Core.Proc.parseInt( cmd[ 1 ] );
		if( obj[ "touchAction" ] === undefined )
		{
			NgLogE("Could not parse touchAction in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "x" ] = Core.Proc.parseFloat( cmd[ 2 ] );
		if( obj[ "x" ] === undefined )
		{
			NgLogE("Could not parse x in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "y" ] = Core.Proc.parseFloat( cmd[ 3 ] );
		if( obj[ "y" ] === undefined )
		{
			NgLogE("Could not parse y in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		obj[ "touchTargetCount" ] = Core.Proc.parseInt( cmd[ 4 ] );
		if( obj[ "touchTargetCount" ] === undefined )
		{
			NgLogE("Could not parse touchTargetCount in Root.onTouchEvent from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 5);
		return true;
	},
	
	/** @private */
	_touchTargetRecvGen: function( cmd, obj )
	{ 
		if( cmd.length < 1 )
		{
			NgLogE("Could not parse due to wrong argument count in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		obj[ "nodeId" ] = Core.Proc.parseInt( cmd[ 0 ] );
		if( obj[ "nodeId" ] === undefined )
		{
			NgLogE("Could not parse nodeId in Root.touchTarget from command: " + cmd );
			return false;
		}
		
		cmd.splice(0, 1);
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 309 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_addChildSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 309 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "child" ]  );
	},
	
	/** @private */
	_removeChildSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 309 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "child" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// addChild: function( child ) {}
	
	// removeChild: function( child ) {}
	
	// _onTouchEventRecv: function( cmd ) {}
	// _touchTargetRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Sprite'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Sprite'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Animation = require('NGCore/Client/GL2/Animation').Animation;
var Core = require('NGCore/Client/Core').Core;

exports.Sprite = Node.subclass(
/** @lends GL2.Sprite.prototype */
{
	classname: 'Sprite',
	
	/**	 
	 * @class The <code>Sprite</code> class constructs objects that are used to display either a single image file 
	 * (see <code><a href="GL2.Sprite.html#setImage">setImage()</a></code>) or an animation.<br><br>
	 * Sprites apply their composite node transform and color to the final 
	 * rendered output of each <code><a href="GL2.Animation.Frame.html">frame</a></code> they display. Frames manage the
	 * pre-transform offset within the image. The pre-transform offset is used by frames for rotation and scale of the image. Combining these
	 * two features, an application can accurately place an image within the view.<br><br>
	 * Animations that reach the end of the last animation frame will trigger the
	 * <code>AnimationCompleteEmitter</code> (see <code><a href="GL2.Sprite.html#getAnimationCompleteEmitter">getAnimationCompleteEmitter()</a></code>). 
	 * All other cases, such as setting a new
	 * animation, does not trigger the emitter.<br><br>
	 * <b>Note:</b> The tick rate for any animation instantiated through <code>Sprite</code> is set through <code>{@link Core.UpdateEmitter#setTickRate}</code>.
	 * @constructs The default constructor.
	 * @augments GL2.Node
	 */
    initialize: function()
    {
		this._clubObject = null;
        this._animation = null;
		this._ownsAnimation = false;
		
		this._animationCompleteEmitter = new Core.MessageEmitter();
    },

	/**
	 * The default destructor.
	 * This call cleans up any attached <code>Animation</code> and <code>AnimationCompleteEmitter</code> objects.
	 * @see GL2.Animation,
	 * @see GL2.Sprite#getAnimationCompleteEmitter
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._tryDestroyAnimation();
		this._animationCompleteEmitter.destroy();
	},
	
	/**
	 * Retrieve the current <code>Sprite</code> animation.
	 * If the sprite is rendering a single image animation through <code>setImage()</code>,
	 * this method will return <code>undefined</code>.
	 * @returns {GL2.Animation} The current animation. Returns <code>null</code> if the application is not currently playing an animation.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimation: function()
	{
		if(this._ownsAnimation) return null;
		
		return this._animation;
	},
    
    /**
	 * Retrieve the animation complete emitter for this <code>Sprite</code>.
	 *
	 * This emitter is triggered when one of the following conditions occurs:<br><br>
	 *<ul>
	 * <li>The sprite reaches the end of an animation for which the last frame has a duration of <code>0</code>.</li>
	 * <li>A <code>setAnimation()</code> or a <code>setImage()</code> call resets the animation complete emitter.</li>
	 *</ul>
	 * Any code that requires notification when an animation completes should register as a 
	 * listener to this emitter. The emitter callback will pass this sprite as the only parameter.<br><br>
	 * <b>Note:</b> Looping animations and starting new animations do not trigger this emitter.
	 * @returns {Core.MessageEmitter} The emitter that triggers the completion callback.
	 * @see GL2.Sprite#setAnimation,
	 * @see GL2.Sprite#setImage	 
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnimationCompleteEmitter: function()
	{
		return this._animationCompleteEmitter;
	},
    
    /**
	 * Begin playing the specified animation with this <code>Sprite</code>.
	 * If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any animation set with <code>setAnimation()</code> from the native backend if no other frame
	 * contains it.
	 * @example var animation = Animation.getNamed('background');
	 * ...
	 * var sprite = new GL2.Sprite();
	 * sprite.setAnimation(animation);
	 * @param {GL2.Animation} animation The animation to play.
	 * @param {Number} [startTime=0] The time offset where playback should start relative to the actual start of the animation. Expressed in milliseconds.<br><br>
	 * <b>Example:</b> If <code>setAnimation()</code> is called with a <code>startTime</code> equal to half the total duration of the animation, 
	 * playback begins half way through the animation.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setAnimation: function(animation, startTime)
	{
		this._tryDestroyAnimation();
		this._animation = animation;
		
		this._setAnimationSendGen(
		{
			animation: Core.ObjectRegistry.objectToId(animation),
			startTime: startTime || 0,
		});
		
		return this;
	},
    
    /**
	 * Set a static image as the current animation for this <code>Sprite</code>.
	 * Internally, this method instantiates a single frame animation of infinite duration using the
	 * specified image. If the sprite is playing another animation at the time of this call, the new animation will take priority over the sprite.
	 * The previous animation will stop and the complete emitter will not respond. This is because the animation did not technically complete a full playback cycle. 
	 * <br><br>
	 * <b>Note:</b> You can release the resources for any image set with <code>setImage()</code> from the native backend if no other frame
	 * contains it.
	 * @example var myImage = new GL2.Sprite();
	 * myImage.setImage('./Content/animation.png', size);
	 * @param {String} image The directory path to an image resource.
	 * @param {Core.Size} [size] The size of the image to display (in pixels).
	 * @param {Core.Point} [anchor] The anchor coordinates that indicate the image center in the animation.
	 * @param {Core.Rect} [uvs] The UV coordinates used to specify the subset of an image.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setImage: function(image, size, anchor, uvs)
	{
		this._tryDestroyAnimation();
		
		// Create a single frame animation.
		var args = Array.prototype.slice.call(arguments, 0);
		args.splice(1, 0, 0); // Insert a duration of zero into our arguments.
		var frame = new Animation.Frame();
		frame.constructor.apply(frame, args);
		var animation = new Animation();
		animation.pushFrame(frame);
		
		this._animation = animation;
		this._ownsAnimation = true;
		
		this._setAnimationSendGen(
		{
			animation: Core.ObjectRegistry.objectToId(animation),
			startTime: 0,
		});
		
		return this;
	},
	
	_tryDestroyAnimation: function()
	{
		if(this._ownsAnimation)
		{
			// Set our animation to NULL to unlink ourselves from the animation on the backend
			// or else trying to destory the animation will fail because we are still using it.
			this._setAnimationSendGen(
			{
				animation: 0,
				startTime: 0,
			});
		
			this._animation.destroy();
			this._animation = null;
			this._ownsAnimation = false;
		}
		this._animation = null;
	},
	
	_animationCompleteRecv: function(cmd)
	{
		var msg = {};
		if(!this._animationCompleteRecvGen(cmd, msg))
			return;
		
		this._animationCompleteEmitter.emit(this);
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 310
	// Method create = -1
	// Method setAnimation = 2
	// Method animationComplete = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 3:
					instance._animationCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Sprite._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[310] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_animationCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Sprite.animationComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 310 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_setAnimationSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 310 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "animation" ] + "," + obj[ "startTime" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setAnimation: function( animation, startTime ) {}
	
	// _animationCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/GL2/Text'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/GL2/Text'] || {}; $MODULE_REGISTRY['NGCore/Client/GL2/Text'] = exports; var Node = require('NGCore/Client/GL2/Node').Node;
var Core = require('NGCore/Client/Core').Core;

exports.Text = Node.subclass(
/** @lends GL2.Text.prototype */
{
	classname: 'Text',
    
	/**
	 * @class The <code>Text</code> class constructs objects that provide font specifications to the GL2 module. 
	 * <code>Text</code> objects define positionable areas for rendering text strings as application labels.
	 * @constructs The default constructor. 
	 * @augments GL2.Node
	 * @param {String} [text] The text string to render in the constructor.
	 */
    initialize: function(text)
    {
		this._size = new Core.Size();
		this._anchor = new Core.Point(0.5, 0.5);
        this._horizontalAlign = this.HorizontalAlign.Center;
        this._verticalAlign = this.VerticalAlign.Middle;
        this._text = '';
		if (text)
			 this.setText(text);
							 
        this._fontFamily = '';
        this._fontSize = 18;
		this._overflowMode = this.OverflowMode.Multiline;
		this._fontLocation = this.FontLocation.Default;
    },
    
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
	},
	
	/**
	 * Retrieve the size of the text area from this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>.
	 * A value of <code>0</code> for either component means the text area will expand to the size of the string.
	 * @returns {Core.Vector} The current size of the text area (expressed as points).
	 * @see GL2.Text#setSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getSize: function()
	{
		return this._size;
	},
	
	/**
	 * Retrieve the placement offset for translating before applying the transform of this <code>Text</code> node.
	 * This value is specified as a multiple of the text area size with <code>(0,0)</code> as the top-left corner.
	 * @returns {Core.Vector} The current placement offset.
	 * @see GL2.Text#setAnchor
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getAnchor: function()
	{
		return this._anchor;
	},
	
	/**
	 * Retrieve the horizontal alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#HorizontalAlign} The current horizontal alignment of the text area.
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getHorizontalAlign: function()
	{
		return this._horizontalAlign;
	},
	
	/**
	 * Retrieve the vertical alignment of the text area from this <code>Text</code> node.
	 * @returns {GL2.Text#VerticalAlign} The curren vertical alignment of the text area.
	 * @see GL2.Text#setVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getVerticalAlign: function()
	{
		return this._verticalAlign;
	},
	
	/**
	 * Retrieve the text string this <code>Text</code> node will render.
	 * @returns {String} The current text string to render in the text area.
	 * @see GL2.Text#setText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getText: function()
	{
		return this._text;
	},
	
	/**
	 * Retrieve the font family for the text area from this <code>Text</code> node.
	 * The GL2 module uses Arial as the text area font family when this value is undefined.<br><br>
	 * <b>Note:</b> <code>Text</code> nodes default to Arial as the font family when an application cannot load the specified font.
	 * @returns The current font family defined for the text area.
	 * @see GL2.Text#setFontFamily
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getFontFamily: function()
	{
		return this._fontFamily;
	},
	
	/**
	 * Retrieve the font size for the text area from this <code>Text</code> node.
	 * @returns {Number} The current font size defined for the text area.
	 * @see GL2.Text#setFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getFontSize: function()
	{
		return this._fontSize;
	},
	
	/**
	 * Retrieve the overflow style of the text area from this <code>Text</code> node. 
	 * @returns {GL2.Text#OverflowMode} The current overflow style defined for the text area.
	 * @see GL2.Text#setOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	getOverflowMode: function()
	{
		return this._overflowMode;
	},
	
    /**
	 * Set the size in pixels of the text area for this <code>Text</code> node.
	 * The text area size is defined through two components: <i>width</i> and <i>height</i>. 
	 * @example var w = Core.Capabilities.getScreenWidth();
	 * var h = Core.Capabilities.getScreenHeight();
	 * ...
	 * var label = new GL2.Text();
	 * label.setSize(w, h);
	 * @param {Core.Vector} size A new vector specifying the text area size in pixels.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setSize: function(size)
	{
		var s = this._size;
		s.setAll.apply(s, arguments);

		this._setSizeSendGen(
		{
			width: s.getWidth(),
			height: s.getHeight(),
		});
		
		return this;
	},
	
    /**
	 * Set the text area offset as a multiple of the area size (<i>width</i> and <i>height</i>).
	 * An <code>Anchor</code> defines a location the text area will rotate and scale around; <code>Anchors</code> are applied
	 * to the drawing prior to the composite transform for the node. When the text size of the text area is <code>0</code> in either
	 * dimension, the offset is measured from the rendered size of the string in that dimension.<br><br>
	 * <b>Example:</b> If you want to display a text area as centered, you can set the <code>horizontalAlign</code> to
	 * <code>centered</code> and set the <code>anchor</code> to <code>[0.5,h]</code> with <i>h</i> representing a vertical offset.
	 * @example text.setAnchor(0.5,h);
	 * @param {Core.Vector} location A new vector specifying the offset location.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Node,
	 * @see GL2.Text#getAnchor,
	 * @see GL2.Text#setHorizontalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setAnchor: function(location)
	{
		var a = this._anchor;
		a.setAll.apply(a, arguments);
		
		this._setAnchorSendGen(
		{
			x: a.getX(),
			y: a.getY(),
		});
		
		return this;
	},
	
    /**
	 * Set the horizontal alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setHorizontalAlign(GL2.Text.HorizontalAlign.Center);
	 * @param {GL2.Text#HorizontalAlign} horizontalAlign The new horizontal alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setHorizontalAlign: function(horizontalAlign)
	{
		this._horizontalAlign = horizontalAlign;
		
		this._setHorizontalAlignSendGen(
		{
			align: horizontalAlign,
		});
		
		return this;
	},
    
    /**
	 * Set the vertical alignment of the text area for this <code>Text</code> node.
	 * @example var t = new GL2.Text(this._label);
	 * ...
	 * t.setVerticalAlign(GL2.Text.VerticalAlign.Middle);
	 * @param {GL2.Text#VerticalAlign} verticalAlign The new vertical alignment for the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getVerticalAlign
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setVerticalAlign: function(verticalAlign)
	{
		this._verticalAlign = verticalAlign;
		
		this._setVerticalAlignSendGen(
		{
			align: verticalAlign,
		});
		
		return this;
	},
    
    /**
	 * Set the text string to render in the text area of this <code>Text</code> node.
	 * @example var label = new GL2.Text();
	 * ...
	 * label.setText('This is a label');
	 * @param {String} text The new text string to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getText
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setText: function(text)
	{
		this._text = text;
		
		this._setTextSendGen(
		{
			text: text, // JMARR TODO: Base64 string
		});
		
		return this;
	},
    
    /**
	 * Set the font family to use for rendering text strings in the text area of this <code>Text</code> node.<br><br>
	 * Using this call to set application specific fonts (os-independent) requires you to add the font file name with extension (.ttf) to the manifest.json.
	 * The font family file must reside in the <code>Content</code> directory. The font family file name is passed in this call. The font face is applied to each object of type 
	 * <code>GL2.Text</code> that will override the system font.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontFamily("Content/Cacophony.ttf");
	 * @param {String} [fontFamily=Arial] The new font family to render in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontFamily
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
    setFontFamily: function(fontFamily)
	{
		this._fontFamily = fontFamily;
		
		this._setFontFamilySendGen(
		{
			fontFamily: fontFamily,
		});
		
		return this;
	},
    
    /**
	 * Set the text area font size for this <code>Text</code> node.
	 * @example var fontSize = 24;
	 *
	 * var font = new GL2.Text();
	 * ...
	 * font.setFontSize(fontSize);
	 * @param {Number} [fontSize=18pt] The new font size for text strings (expressed in points).
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getFontSize
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontSize: function(fontSize)
	{
		this._fontSize = fontSize;
		
		this._setFontSizeSendGen(
		{
			fontSize: fontSize,
		});
		
		return this;
	},
	
	/**
	 * Set the overflow style of the text area for this <code>Text</code> node. 
	 * This method defines how a <code>Text</code> node will fit a rendered string inside 
	 * the text area when the string is too long.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setOverflowMode(GL2.Text.OverflowMode.ReduceFontSize);
	 * @param {GL2.Text#OverflowMode} overflowMode The overflow rendering style for long text strings.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see GL2.Text#getOverflowMode,
	 * @see GL2.Text#OverflowMode
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setOverflowMode: function(overflowMode)
	{
		this._overflowMode = overflowMode;
		
		this._setOverflowModeSendGen(
		{
			overflowMode: overflowMode,
		});
		
		return this;
	},
	
	/**
	 * Set the directory path to the location of a font used by this <code>Text</code> node.
	 * @example var font = new GL2.Text();
	 * ...
	 * font.setFontLocation(GL2.Text.FontLocation.System);
	 * @param {String} fontLocation The new directory path to a font used in the text area.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	setFontLocation: function(fontLocation)
	{
		this._fontLocation = fontLocation;
		
		this._setFontLocationSendGen(
		{
			fontLocation: fontLocation,
		});
		
		return this;
	},
	
	/**
	 * Translate a global scene location to the local coordinate space of this <code>Text</code> node.
	 * Use this method when determining <code>touchMoved</code> offsets.
	 * @example var p = Game.getRoot().screenToLocal(touch.getPosition());
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	screenToLocal: function($super, location)
	{
		location = $super(location);
		if(!location)
			return undefined;
		
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() + a.getX() * s.getWidth());
		location.setY(location.getY() + a.getY() * s.getHeight());
		return location;
	},
	
	/**
	 * Translate a location in the local coordinate space to the global scene coordinate space of this <code>Text</code> node.
	 * Use this method for translating between local coordinate spaces.
	 * @param {$super} $super This parameter is a reference to the base class implementation and is stripped out during execution. Do not supply it.
	 * @param {Core.Vector} location The location to transform.
	 * @status iOS, Android, Flash, Test, iOSTested, AndroidTested
	 */
	localToScreen: function($super, location)
	{
		var a = this._anchor;
		var s = this._size;
			
		location.setX(location.getX() - a.getX() * s.getWidth());
		location.setY(location.getY() - a.getY() * s.getHeight());
		
		location = $super(location);
		if(!location)
			return undefined;
		return location;
	},
	
// {{?Wg Generated Code}}
	
	// Enums.
	/** 
	 * Enumeration for horizontal alignment modes.
	 * @namespace
	 */
	HorizontalAlign:
	{ 
		/** Align text to the left. */
		Left: 0,
		/** Align text in the center. */
		Center: 1,
		/** Align text to the right. */
		Right: 2,
	},
	
	/** 
	 * Enumeration for vertical alignment modes.
	 * @namespace
	 */
	VerticalAlign:
	{ 
		/** Align text to the top. */
		Top: 0,
		/** Align text in the middle. */
		Middle: 1,
		/** Align text to the bottom. */
		Bottom: 2,
	},
	
	/** 
	 * Enumeration for the behavior when there is too much text to fit on one line.
	 * @namespace
	 */
	OverflowMode:
	{ 
		/** Reduce the font size until the text fits. */
		ReduceFontSize: 0,
		/** Break the text across multiple lines. */
		Multiline: 1,
	},
	
	/** 
	 * Enumeration for location of fonts.
	 * @namespace
	 */
	FontLocation:
	{ 
		/** Use Default fonts. */
		Default: 0,
		/** Use System fonts. */
		System: 1,
		/** Use bundled fonts that ship with engine and available to all apps. */
		Bundled: 2,
		/** Use custom fonts that are loaded with app manifest. */
		Manifest: 3,
	},
	
	///////
	// Class constants (for internal use only):
	// Class ID = 311
	// Method create = -1
	// Method destroy = 2
	// Method setSize = 3
	// Method setAnchor = 4
	// Method setHorizontalAlign = 5
	// Method setVerticalAlign = 6
	// Method setText = 7
	// Method setFontFamily = 8
	// Method setFontSize = 9
	// Method setOverflowMode = 10
	// Method setFontLocation = 11
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Text._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[311] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_setSizeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "width" ] + "," + obj[ "height" ]  );
	},
	
	/** @private */
	_setAnchorSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 4 + "," + this.__objectRegistryId + "," + obj[ "x" ] + "," + obj[ "y" ]  );
	},
	
	/** @private */
	_setHorizontalAlignSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 5 + "," + this.__objectRegistryId + "," + obj[ "align" ]  );
	},
	
	/** @private */
	_setVerticalAlignSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 6 + "," + this.__objectRegistryId + "," + obj[ "align" ]  );
	},
	
	/** @private */
	_setTextSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 7 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "text" ] )  );
	},
	
	/** @private */
	_setFontFamilySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 8 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "fontFamily" ] )  );
	},
	
	/** @private */
	_setFontSizeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 9 + "," + this.__objectRegistryId + "," + obj[ "fontSize" ]  );
	},
	
	/** @private */
	_setOverflowModeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 10 + "," + this.__objectRegistryId + "," + obj[ "overflowMode" ]  );
	},
	
	/** @private */
	_setFontLocationSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 311 + "," + 11 + "," + this.__objectRegistryId + "," + obj[ "fontLocation" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setSize: function( width, height ) {}
	
	// setAnchor: function( x, y ) {}
	
	// setHorizontalAlign: function( align ) {}
	
	// setVerticalAlign: function( align ) {}
	
	// setText: function( text ) {}
	
	// setFontFamily: function( fontFamily ) {}
	
	// setFontSize: function( fontSize ) {}
	
	// setOverflowMode: function( overflowMode ) {}
	
	// setFontLocation: function( fontLocation ) {}
	

// {{/Wg Generated Code}}
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Tilemap/Tile'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Tilemap/Tile'] || {}; $MODULE_REGISTRY['Code/G6/Tilemap/Tile'] = exports; 

/**
 * @author will
 */
exports.Tile = Class.subclass(
{
	initialize: function(tileNode, touchable)
	{
		
		if (typeof touchable == 'undefined' ) touchable = false;		
		this._touchable = touchable;
		//tile node is the floor
		this._tileNode = tileNode;
		this._objectMap = [];
	},
	
	getTileNode: function() 
	{
		return this._tileNode;
	},
	
	getTouchable: function()
	{
		return this._touchable;
	},
	
	setTileNode: function( node) 
	{
		if (this._tileNode) {
			this._tileNode.destroy();
		}		
		this._tileNode = node;
	},
	
	setTouchable: function( touchable)
	{
		this._touchable = touchable;
	},
	
	putObject: function ( obj ) {
		//only supports layer 1 right now.
		
		if (typeof touchable == 'undefined' ) force = false;	
		
		var layer = obj.getLayer();		
		var existingObject = this._objectMap[layer];
		
		
		
//		if (existingObject) {
//            if (force) {
//				if (existingObject.parentNode() != null) {
//					existingObject.destroy();
//				}
//            }
//			else {
//				return;
//			}
//		} 
		
		this._objectMap[layer] = obj;
		
		return existingObject;
		
		//get the position of the tile node.
	},	
	
	getObject: function ( layer ) {
		return this._objectMap[ layer] ;
	},
	
	
	//we specific obj if we want to be extra sure we remoe the right thing. obj is optional	
	removeObject: function ( layer, obj ) {

//		
//		if ()

		if (typeof obj == 'undefined' ) obj = null;
		

		var existingObject = this._objectMap[layer];
		if (obj == null) {
			this._objectMap[layer] = null;					
			return;
		}
		
		if (obj == existingObject) {
			this._objectMap[layer] = null;
		}
		
	},
	
	removeObjectByValue: function ( obj ) {
		for ( var i in this._objectMap) {
			var o = this._objectMap [o];
			if (obj == o) {
				this._objectMap[i] = null;
			}
		}
	},
	
	hasObject: function ( layer ) {
		var existingObject = this._objectMap[layer];
		
		return (existingObject != null);
		
	},
	blocked: function () {
		//blocked rulesets here...override if you want.
		var existingObject = this._objectMap[0];
		
		if (existingObject) {
			return true;
		} 
		
		return !this._touchable;
		
		
	},		
	
	destroy: function()
	{
		if (this._tileNode) {
			this._tileNode.destroy();
			this._tileNode = null;
		}

	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Tilemap/TilemapPathfinder'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Tilemap/TilemapPathfinder'] || {}; $MODULE_REGISTRY['Code/G6/Tilemap/TilemapPathfinder'] = exports; var Util = require('Code/G6/Util/Util').Util;
/**
 * @author will
 */
exports.TilemapPathfinder = Node.subclass(
{
	initialize: function( dataSource )
	{
		this._dataSource = dataSource;
	},
	
	isSpaceBlocked: function( tilePosition ) 
	{
		var blocked = this._dataSource.isSpaceBlocked(tilePosition)
		return 
	},
	
	nodeInArray: function( a, tilePosition )
	{
		if (!a) return null;
		
		for (i in a) {
			var n = a[i];
			if (n.nodeX == tilePosition.getX() && n.nodeY == tilePosition.getY()) {
				return n;	
			}
		}
		
		return null;
	},
	
	lowestCostNodeInArray: function (a) 
	{
		var lowest;
		
		lowest = null;
		
		if (!a) return null;
		
		for (i in a) {
			var n = a[i];
			if (lowest == null) {
				lowest = n;
			}
			else {
				if (n.cost < lowest.cost) {
					lowest = n;
				}
			}
		}
		
		return lowest;		
		
	},
	
	findPath: function( startPosition, endPosition, inclusive ) 
	{
		var x = 0;
		var y = 0;
		var newX = 0;
		var newY = 0;
		var currentX = 0
		var currentY = 0;
		var endX = endPosition.getX();
		var endY = endPosition.getY();

		
		if (Util.pointsAreSame(startPosition, endPosition)) {
			return null;
		}
		
		var mapSize = this._dataSource._mapSize;
		
		var openList = [];
		var closedList = [];
		var finalList = [];		
		
		var currentNode = new Object();
		currentNode.nodeX = 0;
		currentNode.nodeY = 0;
		currentNode.parentNode = null;
		currentNode.cost = 0;	
		
		var aNode = new Object();
		aNode.nodeX = 0;
		aNode.nodeY = 0;
		aNode.parentNode = null;
		aNode.cost = 0;		
		
		var startNode = new Object();;
		startNode.nodeX = startPosition.getX();
		startNode.nodeY = startPosition.getY();
		startNode.parentNode = null;
		startNode.cost = 0;
		
		openList.push(startNode);
		
		//while open set is not empty
		while (openList.length > 0) {
			//get the node in the open set with the lowest f value
			currentNode = this.lowestCostNodeInArray(openList);
			
			//if this is the goal then we are done
			if (currentNode.nodeX == endPosition.getX() && currentNode.nodeY == endPosition.getY()) {
				//if inclusive we will add the final position as well
				if (inclusive) {
					finalList.push (endPosition.clone());
					
				}
				
				//path found
				
				aNode = currentNode.parentNode;
				while (aNode.parentNode != null) {
					finalList.push(new Core.Point(aNode.nodeX, aNode.nodeY));
					aNode = aNode.parentNode;
				}
				
				//final list reverse
				return finalList.reverse();
				
			}
			else {
				//add it to the closed set
				closedList.push(currentNode);
				
				
				//remove the current node from the open set
				Util.removeByValue(openList, currentNode);
				
				currentX = currentNode.nodeX;
				currentY = currentNode.nodeY;
				
				//check all the surrounding nodes/tiles on the y axis
				for ( var y =-1; y <=1 ; y ++ ) {
					newY = currentY + y;
					newX = currentX;
					
					if (y == 0 ) continue;
					
					//simple bounds check..
					
					this.nodeCompute (newX, newY, endX, endY, mapSize, openList, closedList,currentNode);
				}
				
				for ( var x =-1; x <=1 ; x ++ ) {
					newY = currentY;
					newX = currentX + x;
					
					if (x == 0 ) continue;
					
					//simple bounds check..
					
					this.nodeCompute (newX, newY, endX, endY, mapSize, openList, closedList,currentNode);
				}				
				
				
				
				
			}
			
			
		}
		
		//no path found
		
		var nextBestNode;
		var lowestDist = 99999999;
		for (i in closedList) {
			var cNode = closedList [i];
			var dist = (Math.abs((cNode.nodeX) - endX) + Math.abs((cNode.nodeY) - endY));
			
			if (dist < lowestDist) {
				nextBestNode = cNode;
				lowestDist = dist;
			}
			
			
		}
		
		if (!nextBestNode) return finalList;
		
		while (nextBesetNode.parentNode != null) {
			finalList.push(new Core.Point (nextBestNode.nodeX, nextBestNode.nodeY));
			nextBestNode = nextBestNode.parentNode;
		}
		
		return finalList.reverse();
		
		
	},
	
	nodeCompute: function (newX,newY,endX,endY, mapSize , openList, closedList, currentNode) {
		if ((newX >= 0 ) && (newY >= 0) && (newX < mapSize.getWidth()) && (newY < mapSize.getHeight())) {
			var newPosition = new Core.Point( newX, newY);
			if (!this.nodeInArray( openList, newPosition) ) {
				if (!this.nodeInArray( closedList, newPosition )) {
					if ( !this.isSpaceBlocked(newPosition) || (!inclusive && newX == endX && newY == endY)) {
						
						var pathFindNode = new Object();
						pathFindNode.nodeX = newX;
						pathFindNode.nodeY = newY;
						pathFindNode.parentNode = currentNode;
						pathFindNode.cost = currentNode.cost + 1;
						
						//compute cost here...
						
						pathFindNode.cost += (Math.abs((newX) - endX) + Math.abs((newY) - endY));
						
						openList.push(pathFindNode);
					}
						
				}							
					
			}
			
		}		
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Animation/AnimatedNode'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Animation/AnimatedNode'] || {}; $MODULE_REGISTRY['Code/G6/Animation/AnimatedNode'] = exports; /**
 * @author raymondlo
 */
exports.AnimatedNode = GL2.Node.subclass({

    classname: 'AnimatedNode',
    
    initialize: function(){
    
        var current = this.getPosition();

		this.moveStartPosX = current.getX();
		this.moveStartPosY = current.getY();
		this.moveDeltaX = 0;
		this.moveDeltaY = 0;
        this.moveTime = 0;
        this.moveDuration = 0;
		this.moveEaseInRate = 0;
		this.moveEaseOutRate = 0;
        
        this.fadeTime = 0;
        this.fadeDuration = 0;
        this.fadePerSec = 0;
		
		var currScale = this.getScale();
		
		this.scaleChangeX = 0;
		this.finalScaleX = currScale.getX(); 
		this.scaleXTime = 0;
		this.scaleXDuration = 0;
		
		this.scaleChangeY = 0;
		this.finalScaleY = currScale.getY();
		this.scaleYTime = 0;
		this.scaleYDuration = 0;
		
		this.rotateStartDegrees = 0;
		this.rotateDelta = 0;
		this.rotateTime = 0;
		this.rotateDuration = 0;
		
		this.animating = false;
        
		this.sequences = [];
		this.sequenceIdCounter = 0;
		
		this.updateListener = new this.AnimatedNodeUpdateListener( this );
		
		//NgLogD('constructing animated node...');
        Core.UpdateEmitter.addListener(this.updateListener, this.updateListener.onUpdate);
        
    },
    
    
    destroy: function($super){
		Core.UpdateEmitter.removeListener(this.updateListener);
		this.updateListener.destroy();
        $super();
    },
    
    isAnimating: function() {
		return this.animating;	
	},
    
	scaleTo: function(scale, sec) {
	
		var currScale = this.getScale().clone();
		
		this.finalScaleX = scale;
		this.finalScaleY = scale;
		
		this.scaleChangeX = scale - currScale.getX();
		this.scaleChangeY = scale - currScale.getY();
		
		this.scaleXDuration = sec * 1000;
		this.scaleXTime = sec * 1000;
		this.scaleYDuration = sec * 1000;
		this.scaleYTime = sec * 1000;
	},
	
	scaleBy: function(scaleBy, sec) {
		
		var currScale = this.getScale().clone();
		
		this.finalScaleX = currScale.getX() * scaleBy;
		this.finalScaleY = currScale.getY() * scaleBy;
		
		this.scaleChangeX = currScale.getX() * scaleBy - currScale.getX();
		this.scaleChangeY = currScale.getY() * scaleBy - currScale.getY();
		
		this.scaleXDuration = sec * 1000;
		this.scaleXTime = sec * 1000;
		this.scaleYDuration = sec * 1000;
		this.scaleYTime = sec * 1000;
	},
	
	scaleXTo: function(scale, sec) {
		
		var currScale = this.getScale().clone();
		
		this.finalScaleX = scale;
		this.scaleChangeX = scale - currScale.getX();
		
		this.scaleXDuration = sec * 1000;
		this.scaleXTime = sec * 1000;
	},
	
	scaleXBy: function(scaleBy, sec) {
		
		var currScale = this.getScale().clone();
		this.finalScaleX = currScale.getX() * scaleBy;
		this.scaleChangeX = currScale.getX() * scaleBy - currScale.getX();
		
		this.scaleXDuration = sec * 1000;
		this.scaleXTime = sec * 1000;
	},
	
	scaleYTo: function(scale, sec) {
		
		var currScale = this.getScale().clone();
		this.finalScaleY = scale;
		this.scaleChangeY = scale - currScale.getY();
		
		this.scaleYDuration = sec * 1000;
		this.scaleYTime = sec * 1000;
	},
	
	scaleYBy: function(scaleBy, sec) {
		
		var currScale = this.getScale().clone();
		this.finalScaleY = currScale.getY() * scaleBy;
		this.scaleChangeY = currScale.getY() * scaleBy - currScale.getY();
		
		this.scaleYDuration = sec * 1000;
		this.scaleYTime = sec * 1000;
	},
	
	rotateTo: function(degrees, sec) {
		
		this.rotateStartDegrees = this.getRotation();
		this.rotateDelta = degrees - this.rotateStartDegrees;
		this.rotateTime = sec * 1000;
		this.rotateDuration = sec * 1000;
	},
	
	rotateBy: function(degrees, sec) {
		
		this.rotateStartDegrees = this.getRotation();
		this.rotateDelta = degrees;
		this.rotateTime = sec * 1000;
		this.rotateDuration = sec * 1000;
	},
	
    moveBy: function(positionX, positionY, sec){
		
		this.moveStartPosX = this.getPosition().getX();
		this.moveStartPosY = this.getPosition().getY();
		this.moveDeltaX = positionX;
		this.moveDeltaY = positionY;
		
        this.moveTime = sec * 1000;
        this.moveDuration = sec * 1000;
    },
    
    moveTo: function(positionX, positionY, sec){
		
		this.moveStartPosX = this.getPosition().getX();
		this.moveStartPosY = this.getPosition().getY();
		this.moveDeltaX = positionX - this.moveStartPosX;
		this.moveDeltaY = positionY - this.moveStartPosY;
		
        this.moveTime = sec * 1000;
        this.moveDuration = sec * 1000;
    },
    
    moveToWithSpeed: function(positionX, positionY, speed){
        //move to location with static speed
        this.moveStartPosX = this.getPosition().getX();
		this.moveStartPosY = this.getPosition().getY();
		this.moveDeltaX = positionX - this.moveStartPosX;
		this.moveDeltaY = positionY - this.moveStartPosY;
        var a = Math.pow(this.moveDeltaX, 2);
        var b = Math.pow(this.moveDeltaY, 2);
        var c = Math.pow(a + b, 0.5);
        this.moveTime = c * 30 / speed;
        this.moveDuration = c * 30 / speed;
    },
    
    moveByWithSpeed: function(positionX, positionY, speed){
        this.moveStartPosX = this.getPosition().getX();
		this.moveStartPosY = this.getPosition().getY();
		this.moveDeltaX = positionX;
		this.moveDeltaY = positionY;
        var a = Math.pow(this.moveDeltaX, 2);
        var b = Math.pow(this.moveDeltaY, 2);
        var c = Math.pow(a + b, 0.5);
        this.moveTime = c * 30 / speed;
        this.moveDuration = c * 30 / speed;
    },
    
    fadeTo: function(value, sec){
        this.fadePerSec = (value - this.getAlpha()) / (sec * 1000);
        this.fadeTime = sec * 1000;
        this.fadeDuration = sec * 1000;
    },
    moveToWithEaseInAndFade: function(positionX, positionY, value, sec, rate){
		this.moveToWithEaseIn(positionX, positionY, sec, rate);
		this.fadeTo(value,sec);
    },	
    moveToWithEaseOutAndFade: function(positionX, positionY, value, sec, rate){
			this.fadeTo(value,sec);
		this.moveToWithEaseOut(positionX, positionY, sec, rate);

    },		
	moveToWithEaseIn: function(positionX, positionY, sec, rate) {
		
		this.moveStartPosX = this.getPosition().getX();
		this.moveStartPosY = this.getPosition().getY();
		this.moveDeltaX = positionX - this.moveStartPosX;
		this.moveDeltaY = positionY - this.moveStartPosY;
		
        this.moveTime = sec * 1000;
        this.moveDuration = sec * 1000;
		this.moveEaseInRate = rate;
	},
	
	moveByWithEaseIn: function(positionX, positionY, sec, rate) {
		
		this.moveStartPosX = this.getPosition().getX();
		this.moveStartPosY = this.getPosition().getY();
		this.moveDeltaX = positionX;
		this.moveDeltaY = positionY;
		
        this.moveTime = sec * 1000;
        this.moveDuration = sec * 1000;
		this.moveEaseInRate = rate;
	},
	
	moveToWithEaseOut: function(positionX, positionY, sec, rate) {
		
		this.moveStartPosX = this.getPosition().getX();
		this.moveStartPosY = this.getPosition().getY();
		this.moveDeltaX = positionX - this.moveStartPosX;
		this.moveDeltaY = positionY - this.moveStartPosY;
		
        this.moveTime = sec * 1000;
        this.moveDuration = sec * 1000;
		this.moveEaseOutRate = rate;
	},
	
	moveByWithEaseOut: function(positionX, positionY, sec, rate) {
		
		this.moveStartPosX = this.getPosition().getX();
		this.moveStartPosY = this.getPosition().getY();
		this.moveDeltaX = positionX;
		this.moveDeltaY = positionY;
		
        this.moveTime = sec * 1000;
        this.moveDuration = sec * 1000;
		this.moveEaseOutRate = rate;
	},
	
	runSequence: function() {
		
		var isArray = arguments[0].length != null;
		
		var theArray;
		if (isArray) theArray = arguments[0];
		else theArray = arguments;
		
		var sequenceId = this.sequenceIdCounter++;
		this.sequences[sequenceId] = true;
		
		var thisNode = this;
		var timeOffset = 0;
		for (var i=0; i < theArray.length; i+=2) {
			timeOffset += theArray[i];
			var func = theArray[i+1];
			if (i == 0) func();
			
			if (i + 3 < theArray.length) { 
				var nextFunc = theArray[i+3];
				
				var newNextFunc = function(func){
					
					return function(){
						if (thisNode.sequences[sequenceId]) {
							func();
						}
					};
				}(nextFunc);
				
				setTimeout(newNextFunc, timeOffset * 1000);
				//setTimeout(nextFunc, timeOffset * 1000);
			}
		}
	},
	
	// DOES NOT WORK PROPERLY WITH MORE THAN 2 ACTIONS
	runSequenceForever: function() {
		
		var isArray = arguments[0].length != null;
		
		var theArray;
		if (isArray) theArray = arguments[0];
		else theArray = arguments;
		
		var sequenceId = this.sequenceIdCounter++;
		this.sequences[sequenceId] = true;
		
		var thisNode = this;
		var timeOffset = 0;
		for (var i=0; i < theArray.length; i+=2) {
			timeOffset += theArray[i];
			var func = theArray[i+1];
			if (i == 0) func();
			
			if (i + 3 < theArray.length) {			
				var nextFunc = theArray[i+3];
				
				var newNextFunc = function(func){
					return function(){
						if (thisNode.sequences[sequenceId]) {
							func();
						}
					};
				}(nextFunc);
				
				setTimeout(newNextFunc, timeOffset * 1000);
				//setTimeout(nextFunc, timeOffset * 1000);
			}
		}
		
		var repeatFunc = function() {
			if (thisNode.sequences[sequenceId]) {
				thisNode.runSequenceForever(theArray);
			}
		}
		
		setTimeout(repeatFunc, timeOffset * 1000);
	},
	
	stopAllActions: function() {
		this.sequences = [];
		this.moveTime = 0;
		this.moveDuration = 0;
		this.fadeTime = 0;
		this.fadeDuration = 0;
		this.scaleXTime = 0;
		this.scaleXDuration = 0;
		this.scaleYTime = 0;
		this.scaleYDuration = 0;
		this.rotateTime = 0;
		this.rotateDuration = 0;
	},
	
	setPosition: function(position) {
				
		var oldX, newX, diffX;
		if (this.onChangePositionX)
			oldX = this._position.getX();
		
		// this is copied from GL2.Node.... the override was not working
		var p = this._position;
		p.setAll.apply(p, arguments);
		this._setPositionSendGen(
		{
			x: p.getX(),
			y: p.getY(),
		});
		
		if (this.onChangePositionX) {
			newX = this._position.getX();
			diffX = newX - oldX;
			
			if (diffX != 0) {
				this.onChangePositionX(diffX);
			}
		}
		
		return this;
	},
    
    $AnimatedNodeUpdateListener: Core.MessageListener.subclass({
    
        classname: 'AnimatedNodeUpdateListener',
        
        initialize: function(node){
            this.node = node;
        },
           
        onUpdate: function(delta){
        
			this.node.animating = false;
            var p = this.node.getPosition();
			var newX = p.getX();
			var newY = p.getY();
			
            //moves node
            if (this.node.moveTime > 0) {
                if (delta > this.node.moveTime) {
					newX = this.node.moveStartPosX + this.node.moveDeltaX;
					newY = this.node.moveStartPosY + this.node.moveDeltaY;
                }
                else {
					
					var startX = this.node.moveStartPosX;
					var startY = this.node.moveStartPosY;
					var t = (this.node.moveDuration - this.node.moveTime + delta) / this.node.moveDuration;
					if (this.node.moveEaseInRate > 0)
						t = Math.pow(t, this.node.moveEaseInRate);
					else if (this.node.moveEaseOutRate > 0)
						t = Math.pow(t, 1/this.node.moveEaseOutRate);		
					
					newX = startX + this.node.moveDeltaX * t;
					newY = startY + this.node.moveDeltaY * t;
                }
                this.node.moveTime -= delta;
            	this.node.animating = true;
			}
            else {
				this.node.animating |= false;
                this.node.moveTime = 0;
                this.node.moveDuration = 0;
				this.node.moveEaseInRate = 0;
				this.node.moveEaseOutRate = 0;
            }
			this.node.setPosition(newX, newY);
            
			// rotate node
			if (this.node.rotateTime > 0) {
				
				var newDeg;
				
				if (delta > this.node.rotateTime) {
					newDeg = this.node.rotateStartDegrees + this.node.rotateDelta;
				}
				else {
					var startDeg = this.node.rotateStartDegrees;
					var t = (this.node.rotateDuration - this.node.rotateTime + delta) / this.node.rotateDuration;
					
					newDeg = startDeg + this.node.rotateDelta * t;
				}
				
				this.node.rotateTime -= delta;
            	this.node.animating = true;
				this.node.setRotation(newDeg);
			}
			else {
				this.node.animating |= false;
				this.node.rotateTime = 0;
				this.node.rotateDuration = 0;
			}
			
            //fades node
            if (this.node.fadeTime > 0) {
				
                this.node.setAlpha(this.node.getAlpha() + (delta * this.node.fadePerSec));
                this.node.fadeTime -= delta;
            	this.node.animating = true;
			}
            else {
				this.node.animating |= false;
                this.node.fadeTime = 0;
                this.node.fadeDuration = 0;
            }
            
			var currScale = this.node.getScale();
			var currScaleX = currScale.getX();
			var currScaleY = currScale.getY();
			var newScaleX = currScale.getX();
			var newScaleY = currScale.getY();
			
			// scale X
			if (this.node.scaleXTime > 0) {
			
				if (delta > this.node.scaleXTime) {
					newScaleX = this.node.finalScaleX;
				}
				else {
					newScaleX = currScaleX + ((delta / this.node.scaleXDuration) * this.node.scaleChangeX);
				}
				
				this.node.scaleXTime -= delta;
				this.node.animating = true;
			}
			else {
				this.node.animating |= false;
				this.node.scaleXTime = 0;
				this.node.scaleXDuration = 0;
			}
			
			// scale Y
			if (this.node.scaleYTime > 0) {
				
				if (delta > this.node.scaleYTime) {
					newScaleY = this.node.finalScaleY;
				}
				else {
					newScaleY = currScaleY + ((delta / this.node.scaleYDuration) * this.node.scaleChangeY);
				}
				this.node.scaleYTime -= delta;
				this.node.animating = true;
				
			}
			else {
				this.node.animating |= false;
				this.node.scaleYTime = 0;
				this.node.scaleYDuration = 0;
			}
			
			if (currScaleX != newScaleX || currScaleY != newScaleY) {
				this.node.setScale([newScaleX, newScaleY]);
			}
        },
    }),


});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Animation/AnimatedSprite'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Animation/AnimatedSprite'] || {}; $MODULE_REGISTRY['Code/G6/Animation/AnimatedSprite'] = exports; /**
 * @author raymondlo
 */


exports.AnimatedSprite = Core.MessageListener.subclass(
{

    classname: 'AnimatedSprite',
    
	initialize: function(animation)
	{
		
		// Create a node to house everything.
		this.node = new GL2.Node();
		this.node.setPosition(0,0);
		
		// Create body.
		this.sprite = new GL2.Sprite();
		this.sprite.setAnimation(animation, 0);
		this.node.addChild(this.sprite);
		
		// Create touch target.
		this.target = new GL2.TouchTarget();
		this.target.setAnchor(this.sprite.getAnimation().getFrame(0).getAnchor());
		this.target.setSize(this.sprite.getAnimation().getFrame(0).getSize());
		//this.target.setAnchor(0.5, 0.5);
		//this.target.setSize(51,60);
		this.target.getTouchEmitter().addListener(this, this.onTouch);
		this.node.addChild(this.target);
        this.touchEnable = false;
		
		//var current = this.node.getParent().screenToLocal(this.trackingCurrent);
		var current = this.node.getPosition();
		this.destinationX = current.getX();
		this.destinationY = current.getY();
		this.finalDestinationX = current.getX();
		this.finalDestinationY = current.getY();
		this.moveTime = 0;
		this.moveDuration = 0;
		
		this.fadeTime = 0;
		this.fadeDuration = 0;
		this.fadePerSec = 0;
		
		Core.UpdateEmitter.addListener(this, this.onUpdate);
		
		this.trackingId = NaN;
	},
	
    setTouchEnable: function(enabled)
    {
        this.touchEnable = enabled;
    },
    
	destroy: function()
	{
		this.node.destroy();
	},
	
	setPosition: function(x, y)
	{
		this.node.setPosition(x, y);
	},
	
	getNode: function()
	{
		return this.node;
	},
	
	getSprite: function()
	{
		return this.sprite;
	},
	
	moveBy: function(positionX, positionY, sec) 
	{
		this.destinationX = positionX;
		this.destinationY = positionY;
		this.finalDestinationX = positionX + this.node.getPosition().getX();
		this.finalDestinationY = positionY + this.node.getPosition().getY();
		this.moveTime = sec * 1000;
		this.moveDuration = sec * 1000;
	},
	
	moveTo: function(positionX, positionY, sec) 
	{
		this.destinationX =  positionX - this.node.getPosition().getX();
		this.destinationY =  positionY - this.node.getPosition().getY();
		this.finalDestinationX = positionX;
		this.finalDestinationY = positionY;
		this.moveTime = sec * 1000;
		this.moveDuration = sec * 1000;
	},
	
	moveToWithSpeed: function(positionX, positionY, speed) 
	{
		//move to location with static speed
		this.destinationX =  positionX - this.node.getPosition().getX();
		this.destinationY =  positionY - this.node.getPosition().getY();
		this.finalDestinationX = positionX;
		this.finalDestinationY = positionY;
		var a = Math.pow(this.destinationX, 2);
		var b = Math.pow(this.destinationY, 2);
		var c = Math.pow(a + b, 0.5);
		this.moveTime = c * 30 / speed;
		this.moveDuration = c * 30 / speed;
	},
	
	moveByWithSpeed: function(positionX, positionY, speed) 
	{
		this.destinationX = positionX;
		this.destinationY = positionY;
		this.finalDestinationX = positionX + this.node.getPosition().getX();
		this.finalDestinationY = positionY + this.node.getPosition().getY();
		var a = Math.pow(this.destinationX, 2);
		var b = Math.pow(this.destinationY, 2);
		var c = Math.pow(a + b, 0.5);
		this.moveTime = c * 30 / speed;
		this.moveDuration = c * 30 / speed;
	},
	
	fadeTo: function(value, sec) 
	{
		this.fadePerSec = (value - this.node.getAlpha()) / (sec * 1000);
		this.fadeTime = sec * 1000;
		this.fadeDuration = sec * 1000;
	},
	
	onUpdate: function(delta) 
	{
		
		if(this.trackingId)
		{
			var current = this.node.getParent().screenToLocal(this.trackingCurrent);
			var offset = this.trackingOffset;
			this.node.setPosition(current.getX() + offset.getX(), current.getY() + offset.getY());
			return;
		}
		
		var p = this.node.getPosition();
		
		//moves sprite
		if (this.moveTime > 0) {
			if (delta > this.moveTime) {
				p.setX(this.finalDestinationX);
				p.setY(this.finalDestinationY);
			} else {
				p.setX(p.getX() + ((delta / this.moveDuration) * this.destinationX));
				p.setY(p.getY() + ((delta / this.moveDuration) * this.destinationY));
			}
			this.moveTime -= delta;
		} else {
			this.moveTime = 0;
			this.moveDuration = 0;
		}
		this.node.setPosition(p);
		
		//fades sprite
		if (this.fadeTime > 0) {
			this.node.setAlpha(this.node.getAlpha() + (delta * this.fadePerSec));
			this.fadeTime -= delta;
		} else {
			this.fadeTime = 0;
			this.fadeDuration = 0;
		}
		
	},
	
	onTouch: function(touch)
	{
        if (!this.touchEnable) return;
        
		switch(touch.getAction())
		{
			case touch.Action.Start:
				this.trackingId = touch.getId();
				this.trackingCurrent = touch.getPosition();
				
				var local = this.node.getParent().screenToLocal(this.trackingCurrent);
				var current = this.node.getPosition();
				this.trackingOffset = new Core.Vector(current.getX() - local.getX(), current.getY() - local.getY());
				
				this.sprite.setColor(1, 0.25, 0.25);
				return true;
			case touch.Action.End:
				if(this.trackingId != touch.getId())
					return;
				this.trackingId = NaN;
				this.sprite.setColor(1, 1, 1);
				break;
			case touch.Action.Move:
				if(this.trackingId != touch.getId())
					return;
				this.trackingCurrent = touch.getPosition();
				break;
		}
	},
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Animation/ScrollingLabel'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Animation/ScrollingLabel'] || {}; $MODULE_REGISTRY['Code/G6/Animation/ScrollingLabel'] = exports; /**
 * @author raymondlo
 */
var goldColor = new Core.Color(1, 1, 0.8);
exports.ScrollingLabel = GL2.Node.subclass({

    classname: 'ScrollingLabel',
    
    initialize: function(text, xPos, yPos, pixUp, sec){
    
		this.animatedNode = new Animation.AnimatedNode();
		
		this.a_stc_bg = new GL2.Animation();
		this.a_stc_bg.pushFrame(AtlasMap.getAnimationFrame('common-sct-bg.png',0, [0.5,0.5]));
		this.s_stc_bg = new GL2.Sprite();
		this.s_stc_bg.setAnimation(this.a_stc_bg, 0);
		
		this.n_stc_bg = new Animation.AnimatedNode();
		this.n_stc_bg.setDepth(0);
		this.n_stc_bg.addChild(this.s_stc_bg);
		this.n_stc_bg.setPosition(xPos, yPos);
		this.n_stc_bg.setAlpha(0, 0, 0);			
								
		this.addChild(this.n_stc_bg);
		
		this.n_label = new Animation.AnimatedNode();
        this.label = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        this.label.setText(''+text);
//        this.label.setFontSize(Scale.droid.textSize(24));
		SCStyle.applyFontStyle(this.label, SCStyle.FontStyle.Serif24);
        this.label.setDepth(1);
        this.label.setColor(goldColor);
//        this.label.setFontFamily('DroidSerif-Regular');
				
        this.n_label.addChild(this.label);
		this.n_label.setPosition(xPos-200, yPos);
		this.n_label.setAlpha(0, 0, 0);	
		this.addChild(this.n_label);
		this.addChild(this.animatedNode);
		
		var self = this;
		
		this.animatedNode.setDepth(1);
		this.animatedNode.runSequence(0.5, function(){self.n_stc_bg.fadeTo(0.7, 0.5);}, 
								 1, function(){self.n_label.moveToWithEaseOutAndFade(xPos,yPos,1,0.5,10); }, 
								 0.5, function(){self.n_label.moveToWithEaseInAndFade(xPos+200,yPos,0,0.5,10); }, 
								 1.0, function(){self.n_stc_bg.fadeTo(0,1);}, 				 
								 0.1, function(){self.destroy();}
		);
	
    },
	
	destroy: function($super) {
		this.a_stc_bg.destroy();
		this.s_stc_bg.destroy();
		this.n_stc_bg.destroy();
		this.n_label.destroy();
		this.label.destroy();
		this.animatedNode.destroy();
		$super();
	},
    
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Animation/SpriteImage'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Animation/SpriteImage'] || {}; $MODULE_REGISTRY['Code/G6/Animation/SpriteImage'] = exports; /**
 * @author raymondlo
 */

var Core = require('NGCore/Client/Core').Core;
 
exports.SpriteImage = Core.Class.subclass( 
{
	classname: 'SpriteImage',
	
	initialize: function(image, size, anchor, uvs)
	{
		this.image = image;
		this.size = size;
		this.anchor = anchor;
		this.uvs = uvs;
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Animation/TransitionLoader'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Animation/TransitionLoader'] || {}; $MODULE_REGISTRY['Code/G6/Animation/TransitionLoader'] = exports; /**
 * @author georgeyang
 */
exports.TransitionLoader = GL2.Node.subclass({

    classname: 'TransitionLoader',
    
      initialize: function(base, node, exitingscene,exitingfunction,enteringscene,enteringfunction){
	  	
		if (!base.isSwappingScenes) {
			base.setIsSwappingScenes(true);
						
			var animatedNode = new Animation.AnimatedNode();

			var a = new GL2.Animation();
			a.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_transition/trans-bg.png', 0, [Scale.droid.width(800), Scale.droid.height(480)], [0, 0], [0, 0, 1, 1]));
			var bgSprite1 = new GL2.Sprite();
			bgSprite1.setAnimation(a, 0);
			
			var transitiontop = new Animation.AnimatedNode();
			transitiontop.setDepth(999);
			transitiontop.addChild(bgSprite1);
			transitiontop.setPosition(0, 0);
			transitiontop.setAlpha(0, 0, 0);			

//			var a3 = new GL2.Animation();
//			a3.pushFrame(new GL2.Animation.Frame('Content/ui_nonatlas_transition/trans-bg-logo.png', 0, [Scale.droid.width(320), Scale.droid.height(400)], [0.5, 0.5], [0, 0, 1, 1]));
//			var bgSprite3 = new GL2.Sprite();
//			bgSprite3.setAnimation(a3, 0);
//			var transitionlogo = new Animation.AnimatedNode();
//			transitionlogo.setDepth(999);
//			transitionlogo.addChild(bgSprite3);
//			transitionlogo.setPosition(Scale.droid.width(400), Scale.droid.height(240));
//			transitionlogo.setAlpha(0, 0, 0);

			var bleedblocker = SCStyle.createBleedBlocker();
			bleedblocker.setDepth(-10);
			transitiontop.addChild(bleedblocker);
			
			node.addChild(transitiontop);
//			node.addChild(transitionlogo);

			
			var self = this;

			//Currently modified transition (might be changed again)
			animatedNode.setDepth(999);
			animatedNode.runSequence(1, function(){
				transitiontop.fadeTo(1, 0.5);
				
			}, 1, function(){
				exitingfunction(node, exitingscene);
				enteringfunction(node, enteringscene);
			}, 0.5, function(){
				transitiontop.fadeTo(0, 0.5);
			}, 0.1, function(){
				transitiontop.removeChild(bleedblocker);
				node.removeChild(transitiontop);
				
				bleedblocker.destroy();
				transitiontop.destroy();
				a.destroy();
				bgSprite1.destroy();
				animatedNode.destroy();
				base.setIsSwappingScenes(false);
				self.destroy();
			});
		}

    },
    

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Strip/StripObjectNode'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripObjectNode'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripObjectNode'] = exports; /**
 * @author will
 */
exports.StripObjectNode = Animation.AnimatedNode.subclass({

    classname: 'StripObjectNode',
    
    initialize: function(stripObject){
    
        this._stripObject = stripObject;
		
		var frames = [];
		var assetNames = stripObject.getAssetNames(SCGame.isNightTime);
		for (var i in assetNames) {
			var assetName = assetNames[i];
			var frame = AtlasMap.getAnimationFrame(assetName, 0, [0.5,1]);
			frames.push(frame);
		}
		 
//		for (var i = assetNames.length-1; i >=0; i--) {			
//			var assetName = assetNames[i];
//			var frame = AtlasMap.getAnimationFrame(assetName, 0, [0.5,1]);
//			frames.push(frame);
//		}
		
		this._imgFrameSize = frames[0].getSize();
		this._imgFrameAnchor = frames[0].getAnchor();
		
		this._imgNode = new Animation.AnimatedNode();
		this._imgNode.setDepth(2);
		
		// frames should be added in reverse
		for (var i = frames.length-1; i >= 0; i--) {
			var frame = frames[i];
			var anim = new GL2.Animation(); anim.pushFrame(frame);
			
			var sprite = new GL2.Sprite();
			sprite.setAnimation(anim);
			
			this._imgNode.addChild(sprite);
		}
		this.addChild(this._imgNode);
		
        this._plotID = stripObject.getPlotID();
        this._delegate = null;
        this._forBuild = false;
        
        this._state = -1;
        this.setState(this.State.Locked);
        
        this._moveCancelButton = null;
        this._moveConfirmButton = null;
        this._collectButton = null;
		this._collectframeitem = null;
        this._canCollect = false;
		
        this.spotlightNodes = [];
		this.dustNodes = [];
    },
    
    State: {
    
        Locked: 0,
        UnlockedUnmounted: 1,
        UnlockedMounted: 2,
    
    },
    
	runBuildAnimation: function(callbackFunc) {
		
		var animDur = 8;
		var thisNode = this;
		this.setAlpha(1);
		this._imgNode.setAlpha(0);
		SCGame.getSCAudio().playsound(3);
		
		var fadeIn = function() { thisNode._imgNode.fadeTo(1, animDur) };
		
		if (callbackFunc)
			this.runSequence(animDur, fadeIn, 0, function() { thisNode.removeDustNodes();}, 0, callbackFunc);
		else
			this.runSequence(animDur, fadeIn, 0, function() { thisNode.removeDustNodes();});
			
		var frameWidth = this._imgFrameSize.getWidth();
		var halfWidth = frameWidth / 2;	
		var frontXPos = 1.1 * halfWidth;
		var backXPos = .9 * halfWidth;
	
		var moveFunc, fadeFunc, fadeFunc2;
			
		var dustFrontLeft = AtlasMap.getSprite(this.getDustImagePrefix() + '01.png',[0.5,1]);
		//dustFrontLeft.setImage(this.getDustImagePrefix() + '01.png',[386,103],[0.5,1]);
		dustFrontLeft.setPosition(-frontXPos,0);
		var dustNode = new Animation.AnimatedNode();
		dustNode.setAlpha(0);
		dustNode.setDepth(3);
		dustNode.addChild(dustFrontLeft);
		this.dustNodes.push(dustNode);
		this.addChild(dustNode);
		moveFunc = function() { dustNode.moveBy(-20, 0, animDur); }
		fadeFunc = function() { dustNode.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
		
		var dustFrontRight = AtlasMap.getSprite(this.getDustImagePrefix() + '03.png',[0.5,1]);
		//dustFrontRight.setImage(this.getDustImagePrefix() + '03.png',[342,102],[0.5,1]);
		dustFrontRight.setPosition(frontXPos,0);
		var dustNode2 = new Animation.AnimatedNode();
		dustNode2.setAlpha(0);
		dustNode2.setDepth(3);
		dustNode2.addChild(dustFrontRight);
		this.dustNodes.push(dustNode2);
		this.addChild(dustNode2);
		moveFunc = function() { dustNode2.moveBy(40, 0, animDur); }
		fadeFunc = function() { dustNode2.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode2.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode2.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
		
		var dustFrontMain = AtlasMap.getSprite(this.getDustImagePrefix() + '02.png',[0.5,1]);
		//dustFrontMain.setImage(this.getDustImagePrefix() + '02.png', [549,76], [0.5, 1]);
		var dustNode3 = new Animation.AnimatedNode();
		dustNode3.setAlpha(0);
		dustNode3.setDepth(4);
		dustNode3.addChild(dustFrontMain);
		this.dustNodes.push(dustNode3);
		this.addChild(dustNode3);
		moveFunc = function() { dustNode3.moveBy(0, -20, animDur); }
		fadeFunc = function() { dustNode3.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode3.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode3.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
		
		var dustBackLeft = AtlasMap.getSprite(this.getDustImagePrefix() + '01.png',[0.5,1]);
		//dustBackLeft.setImage(this.getDustImagePrefix() + '01.png',[386,103],[0.5,1]);
		dustBackLeft.setPosition(-backXPos, 0);
		var dustNode4 = new Animation.AnimatedNode();
		dustNode4.setAlpha(0);
		dustNode4.setDepth(1);
		dustNode4.addChild(dustBackLeft);
		this.dustNodes.push(dustNode4);
		this.addChild(dustNode4);
		moveFunc = function() { dustNode4.moveBy(-40, 0, animDur); }
		fadeFunc = function() { dustNode4.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode4.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode4.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
		
		var dustBackRight = AtlasMap.getSprite(this.getDustImagePrefix() + '03.png',[0.5,1]);
		//dustBackRight.setImage(this.getDustImagePrefix() + '03.png',[342,102],[0.5,1]);
		dustBackRight.setPosition(backXPos, 0);
		var dustNode5 = new Animation.AnimatedNode();
		dustNode5.setAlpha(0);
		dustNode5.setDepth(1);
		dustNode5.addChild(dustBackRight);
		this.dustNodes.push(dustNode5);
		this.addChild(dustNode5);
		moveFunc = function() { dustNode5.moveBy(40, 0, animDur); }
		fadeFunc = function() { dustNode5.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode5.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode5.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
	},
	
	removeDustNodes: function() {
		
		for (var i in this.dustNodes) {
			
			var node = this.dustNodes[i];
			node.stopAllActions();
			node.destroy();
		}
		
		this.dustNodes = [];
	},
	
	getDustImagePrefix: function() {
		if (SCGame.isNightTime)
			return 'dust-nite-';
		else
			return 'dust-day-';
	},
	
	runSellAnimation: function(callbackFunc) {
		SCGame.getSCAudio().playsound(4);
	
		this.hideCollectButton();
		
		var animDur = 8;
		var thisNode = this;
		this.setAlpha(1);
		
		var fadeOut = function() { thisNode._imgNode.fadeTo(0, animDur) };
		
		if (callbackFunc)
			this.runSequence(animDur, fadeOut, 0, function() { thisNode.removeDustNodes();}, 0, callbackFunc);
		else
			this.runSequence(animDur, fadeOut, 0, function() { thisNode.removeDustNodes();});
			
		var frameWidth = this._imgFrameSize.getWidth();
		var halfWidth = frameWidth / 2;	
		var frontXPos = 1.1 * halfWidth;
		var backXPos = .9 * halfWidth;
	
		var moveFunc, fadeFunc, fadeFunc2;
			
		var dustFrontLeft = AtlasMap.getSprite(this.getDustImagePrefix() + '01.png', [0.5,1]);
		//dustFrontLeft.setImage(this.getDustImagePrefix() + '01.png',[386,103],[0.5,1]);
		dustFrontLeft.setPosition(-frontXPos,0);
		var dustNode = new Animation.AnimatedNode();
		dustNode.setAlpha(0);
		dustNode.setDepth(3);
		dustNode.addChild(dustFrontLeft);
		this.dustNodes.push(dustNode);
		this.addChild(dustNode);
		moveFunc = function() { dustNode.moveBy(-20, 0, animDur); }
		fadeFunc = function() { dustNode.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
		
		var dustFrontRight = AtlasMap.getSprite(this.getDustImagePrefix() + '03.png', [0.5,1]);
		//dustFrontRight.setImage(this.getDustImagePrefix() + '03.png',[342,102],[0.5,1]);
		dustFrontRight.setPosition(frontXPos,0);
		var dustNode2 = new Animation.AnimatedNode();
		dustNode2.setAlpha(0);
		dustNode2.setDepth(3);
		dustNode2.addChild(dustFrontRight);
		this.dustNodes.push(dustNode2);
		this.addChild(dustNode2);
		moveFunc = function() { dustNode2.moveBy(40, 0, animDur); }
		fadeFunc = function() { dustNode2.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode2.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode2.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
		
		var dustFrontMain = AtlasMap.getSprite(this.getDustImagePrefix() + '02.png', [0.5,1]);
		//dustFrontMain.setImage(this.getDustImagePrefix() + '02.png', [549,76], [0.5, 1]);
		var dustNode3 = new Animation.AnimatedNode();
		dustNode3.setAlpha(0);
		dustNode3.setDepth(4);
		dustNode3.addChild(dustFrontMain);
		this.dustNodes.push(dustNode3);
		this.addChild(dustNode3);
		moveFunc = function() { dustNode3.moveBy(0, -20, animDur); }
		fadeFunc = function() { dustNode3.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode3.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode3.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
		
		var dustBackLeft = AtlasMap.getSprite(this.getDustImagePrefix() + '01.png', [0.5,1]);
		//dustBackLeft.setImage(this.getDustImagePrefix() + '01.png',[386,103],[0.5,1]);
		dustBackLeft.setPosition(-backXPos, 0);
		var dustNode4 = new Animation.AnimatedNode();
		dustNode4.setAlpha(0);
		dustNode4.setDepth(1);
		dustNode4.addChild(dustBackLeft);
		this.dustNodes.push(dustNode4);
		this.addChild(dustNode4);
		moveFunc = function() { dustNode4.moveBy(-40, 0, animDur); }
		fadeFunc = function() { dustNode4.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode4.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode4.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
		
		var dustBackRight = AtlasMap.getSprite(this.getDustImagePrefix() + '03.png', [0.5,1]);
		//dustBackRight.setImage(this.getDustImagePrefix() + '03.png',[342,102],[0.5,1]);
		dustBackRight.setPosition(backXPos, 0);
		var dustNode5 = new Animation.AnimatedNode();
		dustNode5.setAlpha(0);
		dustNode5.setDepth(1);
		dustNode5.addChild(dustBackRight);
		this.dustNodes.push(dustNode5);
		this.addChild(dustNode5);
		moveFunc = function() { dustNode5.moveBy(40, 0, animDur); }
		fadeFunc = function() { dustNode5.fadeTo(1, animDur/2); }
		fadeFunc2 = function() { dustNode5.fadeTo(0, animDur/2); }
		moveFunc();
		dustNode5.runSequence(animDur/2, fadeFunc, animDur/2, fadeFunc2);
	},
	
//	runBuildAnimation: function(callbackFunc) {
//		
//		var assetWidth = this._stripObject.getAssetSize()[0];
//		var totalHeight = this._stripObject.getAssetSize()[1];
//		var whiteSpace = Scale.droid.height(40);
//		
//		var increments = Scale.droid.height(80);
//		var incrHeight = (totalHeight - whiteSpace) / increments;
//		
//		var totalDuration = 4000;
//		
//		var anim = new GL2.Animation();
//		anim.setLoopingEnabled(false);
//		var assetName = this._stripObject.getAssetNames(SCGame.isNightTime)[0];
//		for (var i=0; i<increments; i++) {
//			var currHeight = (i+1) * incrHeight;
//			var uvs = [0,0,1,currHeight / totalHeight];
//			var duration = i+1 == increments ? 0 : totalDuration / increments;
//			var frame = new GL2.Animation.Frame(assetName, duration, [assetWidth, currHeight], [0.5, 1], uvs);
//				
//			anim.pushFrame(frame);
//		}
//		
//		this.removeChild(this._imgNode);
//		
//		this._buildSpr = new GL2.Sprite();
//		this._buildSpr.setPosition(0, -whiteSpace);
//		this._buildSpr.setAnimation(anim);
//		this.addChild(this._buildSpr);
//		
//		var listener = new this.BuildAnimationCompleteListener(this);
//		var emitter = this._buildSpr.getAnimationCompleteEmitter();
//		emitter.addListener(listener, listener.onAnimationComplete);
//		
//		var thisNode = this;
//		var animDur = 0.05;
//		var animIncr = totalDuration / (animDur * 1000 * 3);
//		var sequenceArray = [];
//		for (var i=0; i<animIncr-1; i++) {
//			
//			sequenceArray.push(animDur);
//			var moveFunc1 = function() { thisNode.moveBy(5, 0, animDur);  }
//			sequenceArray.push(moveFunc1);
//			sequenceArray.push(animDur);
//			var moveFunc2 = function() { thisNode.moveBy(-10, 0, animDur);  }
//			sequenceArray.push(moveFunc2);
//			sequenceArray.push(animDur);
//			var moveFunc3 = function() { thisNode.moveBy(5, 0, animDur);  }
//			sequenceArray.push(moveFunc3);
//		}
//		
//		if (callbackFunc) {
//			sequenceArray.push(0);
//			sequenceArray.push(callbackFunc);
//		}
//		
//		this.runSequence(sequenceArray);
//	},
	
//	onBuildAnimationComplete: function() {
//		
//		if (this._buildSpr) {
//			if (this._buildSpr.getParent() != null)
//				this.removeChild(this._buildSpr);
//			
//			this._buildSpr = null;
//		
//			if (this._imgNode.getParent() == null)
//				this.addChild(this._imgNode);		
//		}
//	},
	
//	runSellAnimation: function(callbackFunc) {
//		
//		var assetWidth = this._stripObject.getAssetSize()[0];
//		var totalHeight = this._stripObject.getAssetSize()[1];
//		var whiteSpace = Scale.droid.height(40);
//		
//		var increments = Scale.droid.height(80);
//		var incrHeight = (totalHeight-whiteSpace) / increments;
//		
//		var totalDuration = 4000;
//		
//		var anim = new GL2.Animation();
//		anim.setLoopingEnabled(false);
//		var assetName = this._stripObject.getAssetNames(SCGame.isNightTime)[0];
//		for (var i=increments; i>0; i--) {
//			var currHeight = (i-1) * incrHeight;
//			var uvs = [0,0,1,currHeight / totalHeight];
//			var duration = i-1 == 0 ? 0 : totalDuration / increments;
//			var frame = new GL2.Animation.Frame(assetName, duration, [assetWidth, currHeight], [0.5, 1], uvs);
//				
//			anim.pushFrame(frame);
//		}
//		
//		this._imgNode.setAlpha(0);
//		this.removeChild(this._imgNode);
//		
//		this._sellSpr = new GL2.Sprite();
//		this._sellSpr.setPosition(0, -whiteSpace);
//		this._sellSpr.setAnimation(anim);
//		this.addChild(this._sellSpr);
//		
//		var listener = new this.SellAnimationCompleteListener(this);
//		var emitter = this._sellSpr.getAnimationCompleteEmitter();
//		emitter.addListener(listener, listener.onAnimationComplete);
//		
//		var thisNode = this;
//		var animDur = 0.05;
//		var animIncr = totalDuration / (animDur * 1000 * 3);
//		var sequenceArray = [];
//		for (var i=0; i<animIncr-1; i++) {
//			
//			sequenceArray.push(animDur);
//			var moveFunc1 = function() { thisNode.moveBy(5, 0, animDur);  }
//			sequenceArray.push(moveFunc1);
//			sequenceArray.push(animDur);
//			var moveFunc2 = function() { thisNode.moveBy(-10, 0, animDur);  }
//			sequenceArray.push(moveFunc2);
//			sequenceArray.push(animDur);
//			var moveFunc3 = function() { thisNode.moveBy(5, 0, animDur);  }
//			sequenceArray.push(moveFunc3);
//		}
//		
//		if (callbackFunc) {
//			sequenceArray.push(0);
//			sequenceArray.push(callbackFunc);
//		}
//		
//		this.runSequence(sequenceArray);
//	},

//	onSellAnimationComplete: function() {
//		
//		if (this._sellSpr) {
//			if (this._sellSpr.getParent() != null)
//				this.removeChild(this._sellSpr);
//			
//			this._sellSpr = null;
//		
//			if (this._imgNode.getParent() == null)
//				this.addChild(this._imgNode);		
//		}
//	},
	
	showSpotlights: function() {
		
		if (this.spotlightNodes.length > 0) return;
		
		var width = this._imgFrameSize.getWidth();
		var widthFrac = width * .3;
		var rotateDur = 3;
		
		var spotlightAssetName = SCGame.isNightTime ? 'build-spotlight-night.png' : 'build-spotlight-day.png';
		var spotlightAnchor = [0.5, 1];
		var spotlightY = -50;
		
		if (this._stripObject.getStarRating() < 5) {
		
			var sl1 = AtlasMap.getSprite(spotlightAssetName, spotlightAnchor);
			var slnode1 = new Animation.AnimatedNode();
			slnode1.addChild(sl1);
			slnode1.setDepth(-1);
			slnode1.setPosition(-widthFrac, spotlightY);
			slnode1.setRotation(45);
			slnode1.runSequenceForever(rotateDur, function(){
				slnode1.rotateTo(-45, rotateDur);
			}, rotateDur, function(){
				slnode1.rotateTo(45, rotateDur);
			});
			this.addChild(slnode1);
			this.spotlightNodes.push(slnode1);
			
			var sl2 = AtlasMap.getSprite(spotlightAssetName, spotlightAnchor);
			var slnode2 = new Animation.AnimatedNode();
			slnode2.addChild(sl2);
			slnode2.setDepth(-1);
			slnode2.setPosition(widthFrac, spotlightY);
			slnode2.setRotation(-45);
			slnode2.runSequenceForever(rotateDur, function(){
				slnode2.rotateTo(45, rotateDur);
			}, rotateDur, function(){
				slnode2.rotateTo(-45, rotateDur);
			});
			this.addChild(slnode2);
			this.spotlightNodes.push(slnode2);
		}
		else {
			
			var sl1 = AtlasMap.getSprite(spotlightAssetName, spotlightAnchor);
			var slnode1 = new Animation.AnimatedNode();
			slnode1.addChild(sl1);
			slnode1.setDepth(-1);
			slnode1.setPosition(-widthFrac, spotlightY);
			slnode1.setRotation(27.5);
			slnode1.runSequenceForever(rotateDur, function(){
				slnode1.rotateTo(-27.5, rotateDur);
			}, rotateDur, function(){
				slnode1.rotateTo(27.5, rotateDur);
			});
			this.addChild(slnode1);
			this.spotlightNodes.push(slnode1);
			
			var sl2 = AtlasMap.getSprite(spotlightAssetName, spotlightAnchor);
			var slnode2 = new Animation.AnimatedNode();
			slnode2.addChild(sl2);
			slnode2.setDepth(-1);
			slnode2.setPosition(-widthFrac, spotlightY);
			slnode2.setRotation(-27.5);
			slnode2.runSequenceForever(rotateDur, function(){
				slnode2.rotateTo(27.5, rotateDur);
			}, rotateDur, function(){
				slnode2.rotateTo(-27.5, rotateDur);
			});
			this.addChild(slnode2);
			this.spotlightNodes.push(slnode2);
			
			var sl3 = AtlasMap.getSprite(spotlightAssetName, spotlightAnchor);
			var slnode3 = new Animation.AnimatedNode();
			slnode3.addChild(sl3);
			slnode3.setDepth(-1);
			slnode3.setPosition(widthFrac, spotlightY);
			slnode3.setRotation(27.5);
			slnode3.runSequenceForever(rotateDur, function(){
				slnode3.rotateTo(-27.5, rotateDur);
			}, rotateDur, function(){
				slnode3.rotateTo(27.5, rotateDur);
			});
			this.addChild(slnode3);
			this.spotlightNodes.push(slnode3);
			
			var sl4 = AtlasMap.getSprite(spotlightAssetName, spotlightAnchor);
			var slnode4 = new Animation.AnimatedNode();
			slnode4.addChild(sl4);
			slnode4.setDepth(-1);
			slnode4.setPosition(widthFrac, spotlightY);
			slnode4.setRotation(-45);
			slnode4.runSequenceForever(rotateDur, function(){
				slnode4.rotateTo(27.5, rotateDur);
			}, rotateDur, function(){
				slnode4.rotateTo(-27.5, rotateDur);
			});
			this.addChild(slnode4);
			this.spotlightNodes.push(slnode4);
		}
	},
	
	hideSpotlights: function() {
		
		for (var i in this.spotlightNodes) {
			
			var node = this.spotlightNodes[i];
			this.removeChild(node);
			node.stopAllActions();
			node.destroy();
		}
		
		if (this.spotlightNodes.length > 0)
			this.spotlightNodes = [];
	},
	
    checkCanCollect: function(){
        //already can collect.
        if (this._canCollect) 
            return;
        
        
        this.cleanupCollectButton();
        
        if (this._stripObject.canCollect()) {
            this.createCollectButton();
            this._canCollect = true;
        }
    },
    
    cleanupCollectButton: function(){
        if (this._collectButton) {
			this._collectButton.stopAllActions();
            this._collectButton.destroy();
			this._collectButton = null;
			this._collectframeitem = null;
        }
    },
    
    resetCanCollect: function(){
        this._canCollect = false;
        this.cleanupCollectButton();
    },
    
    hideCollectButton: function(){
        if (this._collectButton) {
            this._collectButton.setVisible(false);
            this._collectButton.setTouchable(false);
			this._collectButton.stopAllActions();
			this._collectButton.setPosition(0, this._collectButtonY);
        }
        
    },
    
    showCollectButton: function(){
        if (this._collectButton) {
            this._collectButton.setVisible(true);
            this._collectButton.setTouchable(true);
			
			this.animateCollectButton();
        }
        
    },
    
	animateCollectButton: function() {
		
		if (!this._collectButton.animating) {

			var thisNode = this;
			var moveUp = function() { thisNode._collectButton.moveBy(0, 10, 0.2); }
			var moveDown = function() { thisNode._collectButton.moveBy(0, -10, 0.2); }
				
			this._collectButton.runSequenceForever(0.2, moveUp, 0.2, moveDown);
		}
	},
	
    createCollectButton: function(){
        this.cleanupCollectButton();
        
		var collectFrame = AtlasMap.getAnimationFrame('common-collect.png');
        this._collectframeitem = new Menu.AnimationFrameMenuItem();
        this._collectframeitem.setFrames(collectFrame);
        
        var collectmenuf = this;
        this._collectframeitem.setAction(function(){
            collectmenuf.collect();
        });
        
		this._collectButtonY = Scale.droid.height(-290);
		
        this._collectButton = new Menu.Menu([this._collectframeitem]);
        this._collectButton.setPosition(0, this._collectButtonY);
        this._collectButton.setDepth(2);
        
        this.addChild(this._collectButton);
        
		this.animateCollectButton();
    },
   
   
   collect: function() {
   		NgLogD('collect');
			SCGame.getSCAudio().playsound(5);		
		if (!this._stripObject.canCollect()) return;
		this._collectframeitem.setEnabled(false);
		this._delegate.stripObjectNodeCollect ( this );   
   }, 
   

    
    setState: function(state){
        if (this._state == state) 
            return;
        
        this.cleanupMoveButtons();
        switch (state) {
            case this.State.Locked:
                this.setAlpha(1);
                //this shows.. only if there is a collect button
                this.showCollectButton();
                break;
            case this.State.UnlockedUnmounted:
                this.setAlpha(0.5);
                this.hideCollectButton();
                //remove collectbutton
                break;
            case this.State.UnlockedMounted:
                this.setAlpha(0.75);
                this.createMoveButtons();
                this.hideCollectButton();
                //remove collectbutton
                break;
            default:
                break;
                
                
        }
        
        this._state = state;
        
    },
    
    createMoveButtons: function(){
    
        if (!this._moveConfirmButton) {
            //move button
            var m1a = AtlasMap.getAnimationFrame('build-move-yes-inactive.png', 0, [0.5,0.5]);
            var m1i = AtlasMap.getAnimationFrame('build-move-yes-active.png', 0, [0.5,0.5]);			
            var moveOkItem = new Menu.AnimationFrameMenuItem();
            moveOkItem.setFrames(m1a,m1i,m1i);
            
            var self = this;
            moveOkItem.setAction(function(){
                self.moveConfirm();
            });
            
            this._moveConfirmButton = new Menu.Menu([moveOkItem]);
            this._moveConfirmButton.setPosition(-(this.getSize().getWidth()/4),-(this.getSize().getHeight()/2) );
            this._moveConfirmButton.setDepth(2);
            this.addChild(this._moveConfirmButton);
            
            //this._moveConfirmButton.setColor(0, 0.5, 0);
        }
        
        if (!this._moveCancelButton) {
        
            //move button
            var m2a = AtlasMap.getAnimationFrame('build-move-no-inactive.png', 0, [0.5,0.5]);
            var m2i = AtlasMap.getAnimationFrame('build-move-no-active.png', 0, [0.5,0.5]);			
            var moveCancelItem = new Menu.AnimationFrameMenuItem();
            moveCancelItem.setFrames(m2a,m2i,m2i);
            
            var self = this;
            moveCancelItem.setAction(function(){
                self.moveCancel();
            });
            
            this._moveCancelButton = new Menu.Menu([moveCancelItem]);
            this._moveCancelButton.setPosition((this.getSize().getWidth()/4), -(this.getSize().getHeight()/2));
            this._moveCancelButton.setDepth(2);
            
            this.addChild(this._moveCancelButton);
            
            //this._moveCancelButton.setColor(0.5, 0, 0);
            
	        }
    },
    
    cleanupMoveButtons: function(){
        NgLogD('clean up move buttons...');
        if (this._moveConfirmButton) {
            this._moveConfirmButton.destroy();
            this._moveConfirmButton = null;
        }
        
        if (this._moveCancelButton) {
            this._moveCancelButton.destroy();
            this._moveCancelButton = null;
        }
    },
    
    moveConfirm: function(){
        if (this._state != this.State.UnlockedMounted) 
            return;
        if (!this._delegate) 
            return;
        this._delegate.stripObjectNodeMoveConfirmed(this);
    },
    
    moveCancel: function(){
        if (this._state != this.State.UnlockedMounted) 
            return;
        if (!this._delegate) 
            return;
        this._delegate.stripObjectNodeMoveCanceled(this);
    },
    
    getState: function(){
        return this._state;
    },
    
    setDelegate: function(del){
        this._delegate = del;
    },
    
    getDelegate: function(){
        return this._delegate;
    },
    
    getStripObjectID: function(){
        return this._stripObject.getID();
    },
    
    getCurrentPlotID: function(){
        return this._plotID;
    },
    
    setCurrentPlotID: function(t){
        this._plotID = t;
    },
    
    getAnchor: function() {
		return this._imgFrameAnchor;
        //return this._img._animation.getFrame(0).getAnchor();
    },
    
    getSize: function(){
		return this._imgFrameSize;
        //return this._img._animation.getFrame(0).getSize();
    },
    
    touched: function(){
        this._delegate.stripNodeTouched(this);
        
    },
    
    getStripObject: function(){
        return this._stripObject;
    },
    
    getStripObjectPlotID: function(){
        return this._stripObject.getPlotID();
    },
    
    markedForRemove: function(){
        return this._stripObject.isSold();
    },
    
    markedForBuildAnimation: function(){
        return this._forBuild;
    },
    
    setMarkedForBuildAnimation: function(t){
        this._forBuild = t;
    },
    
    isMovable: function(){
        return this._stripObject.isMovable();
    },

	$BuildAnimationCompleteListener: Core.MessageListener.subclass({
		
		initialize: function(node) {
			this._node = node;
		},
		
		onAnimationComplete: function() {
			this._node.onBuildAnimationComplete();
		}
	}),
	
	$SellAnimationCompleteListener: Core.MessageListener.subclass({
		
		initialize: function(node) {
			this._node = node;
		},
		
		onAnimationComplete: function() {
			this._node.onSellAnimationComplete();
		}
	}),
});

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Strip/StripObjectBuildMenu'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripObjectBuildMenu'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripObjectBuildMenu'] = exports; /**
 * @author will
 */

var closeMenu_xpos = 772;
var closeMenu_ypos = 28;
var titleText_xpos = 400;
var titleText_ypos = 25;
var titleSubText_xpos = 400;
var titleSubText_ypos = 51;

var chipLabel_xpos = 106;
var chipLabel_ypos = 42;
var compLabel_xpos = 632;
var compLabel_ypos = 42;
var chipStat_xpos = 106;
var chipStat_ypos = 24;
var compStat_xpos = 632;
var compStat_ypos = 24;
var topChipsBar_xpos = 56;
var topChipsBar_ypos = 12;
var topCompsBar_xpos = 585;
var topCompsBar_ypos = 12;

var StripObjectBuildBlock = require('Code/StripCity/Scene/Strip/StripObjectBuildBlock').StripObjectBuildBlock;
var PlayerStatNode = require('Code/StripCity/Scene/Common/PlayerStatNode').PlayerStatNode;
var goldColor = new Core.Color(1, 1, 0.8);
exports.StripObjectBuildMenu = Animation.AnimatedNode.subclass({


    classname: 'StripObjectBuildMenu',
    
    initialize: function(delegate){
		
		var thisMenu = this;
        var templates = Game.Strip.StripManager.getTemplates();
		
        this._delegate = delegate;
        this._player = Game.SCGame.getPlayer();
        
		var screenSize = Util.screenSize(true);
	
        var bgAnimation = new GL2.Animation();
        bgAnimation.pushFrame(AtlasMap.getAnimationFrame('common-menu-bg.png',0, [0,0],[Scale.droid.width(800), Scale.droid.height(480)]));	
	    bgAnimation.setBlendEnabled(false);
	
		var bg = new GL2.Sprite();
		bg.setAnimation(bgAnimation);
		
		var chipsBg = AtlasMap.getSprite('common-bg-chips.png', [0,0]);
		chipsBg.setPosition(Scale.droid.width(topChipsBar_xpos), Scale.droid.height(topChipsBar_ypos));
		var compsBg = AtlasMap.getSprite('common-bg-comps.png', [0,0]);
		compsBg.setPosition(Scale.droid.width(topCompsBar_xpos), Scale.droid.height(topCompsBar_ypos));
		
		
		
		
        this._bgNode = new Animation.AnimatedNode();
		this._bgNode.setDepth(-1);
		this._bgNode.addChild(bg);
		this._bgNode.addChild(chipsBg);
		this._bgNode.addChild(compsBg);
		this.addChild(this._bgNode);
		
        var titleText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleText.setText('REAL ESTATE');
        titleText.setDepth(1);
        titleText.getLabel().setColor(goldColor);
        titleText.setPosition([Scale.droid.width(titleText_xpos), [Scale.droid.height(titleText_ypos)]]);
		SCStyle.applyFontStyle(titleText, SCStyle.FontStyle.Sans32);
        this.addChild(titleText);
        
        
        var titleSubText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleSubText.setText('T H E  S T R I P  I S  Y O U R S');
        titleSubText.setDepth(1);
        titleSubText.setColor(goldColor);
        titleSubText.setPosition([Scale.droid.width(titleSubText_xpos), [Scale.droid.height(titleSubText_ypos)]]);
		SCStyle.applyFontStyle(titleSubText, SCStyle.FontStyle.Sans12);        
        this.addChild(titleSubText);		
		
		        
		var playerUpdateEmitter = Game.SCGame.getPlayerUpdateEmitter();
		
		var chipsStat = new PlayerStatNode(Game.Player.Player.StatType.Chips, Game.SCGame.getPlayer());
        chipsStat.setDepth(1);
        chipsStat.setPosition(Scale.droid.width(chipStat_xpos), Scale.droid.height(chipStat_ypos));
        chipsStat.attachUpdateListener(playerUpdateEmitter);
        this.addChild(chipsStat);
		
		var chipLabel = new GL2.Text();
		chipLabel.setFontFamily('DroidSans-Regular');
		chipLabel.setFontSize(32);
		chipLabel.setDepth(4);
		chipLabel.setAnchor(0,0.5);
		chipLabel.setPosition(Scale.droid.width(chipLabel_xpos), Scale.droid.height(chipLabel_ypos));
		SCStyle.applyFontStyle(chipLabel, SCStyle.FontStyle.Sans12);
		chipLabel.setText('Chips');
		this.addChild(chipLabel);
		
		var compStat = new PlayerStatNode(Game.Player.Player.StatType.Comp, Game.SCGame.getPlayer());
		compStat.setDepth(1);
		compStat.setPosition(Scale.droid.width(compStat_xpos), Scale.droid.height(compStat_ypos));
		compStat.attachUpdateListener(playerUpdateEmitter);
		this.addChild(compStat);
		
		var compLabel = new GL2.Text();
		compLabel.setFontFamily('DroidSans-Regular');
		compLabel.setFontSize(32);
		compLabel.setDepth(4);
		compLabel.setAnchor(0,0.5);
		compLabel.setPosition(Scale.droid.width(compLabel_xpos), Scale.droid.height(compLabel_ypos));
		SCStyle.applyFontStyle(compLabel, SCStyle.FontStyle.Sans12);
		compLabel.setText('Comp Points');
		this.addChild(compLabel);
		
        this._blocks = [];
        
        //get all the templates.
        for (var i in templates) {
            var template = templates[i];
            
            if (template.canBuy()) {
                var block = new StripObjectBuildBlock(template, this);
                this._blocks.push(block);
            }
        }
               
		this.initializeBrowsersAndTabs();  
		this.setStarRatingSelected(3);
			   
		var close1 = AtlasMap.getAnimationFrame('common-bg-exit-active.png');
		var close1i = AtlasMap.getAnimationFrame('common-bg-exit-inactive.png');
        var item1 = new Menu.AnimationFrameMenuItem();
        item1.setFrames(close1i, close1, close1i);
        
        item1.setAction(function(){ thisMenu.close(); });
        this._closeButton = new Menu.Menu([item1]);
        this._closeButton.setPosition(Scale.droid.width(closeMenu_xpos), Scale.droid.height(closeMenu_ypos));
        this._closeButton.setDepth(100);
        this.addChild(this._closeButton);
        
        //this._openForPlotID = NaN;
		this._buildToTheRight;
        
        this._playerUpdateListener = new this.StatUpdateListener(this);
		
		//init
		this.refresh();
    },
    
	initializeBrowsersAndTabs: function() {
		
		this._browsers = [];
		this._browserTTs = [];
		
		for (var sr = 3; sr <= 5; sr++) {
			
			var srBlocks = [];
			for (var i in this._blocks) {
				
				var block = this._blocks[i];
				var temp = block.getTemplate();
				if (temp.getStarRating() == sr)
					srBlocks.push(block);
			}
			
			var browserOptions = new Browser.BrowserOptions();
			browserOptions.setYPosition(Scale.droid.height(303));
			browserOptions.setYScreenTopBounds(Scale.droid.height(120));
			browserOptions.setSpacing(2);
			
			var browser = new Browser.SmoothBrowser(srBlocks, browserOptions);
			var browserTT = browser.getTouchTarget();
			browserTT.setSize(Util.screenSize(true).clone());
			browserTT.setAnchor(new Core.Point(0,0));
			
			browserTT.setDepth(0);
			browser.setDepth(1);
			
			this._browsers[sr] = browser;
			this._browserTTs[sr] = browserTT;
		}
		
		var star3 = AtlasMap.getAnimationFrame('build-tab-3stars-active.png', 0, [0.5,0.5]);
		var star3i = AtlasMap.getAnimationFrame('build-tab-3stars-inactive.png', 0, [0.5,0.5]);
		var star4 = AtlasMap.getAnimationFrame('build-tab-4stars-active.png', 0, [0.5,0.5]);
		var star4i = AtlasMap.getAnimationFrame('build-tab-4stars-inactive.png', 0, [0.5,0.5]);
		var star5 = AtlasMap.getAnimationFrame('build-tab-5stars-active.png', 0, [0.5,0.5]);
		var star5i = AtlasMap.getAnimationFrame('build-tab-5stars-inactive.png', 0, [0.5,0.5]);
		
		var thisMenu = this;
		
		this._star3Item = new Menu.AnimationFrameMenuItem();
		this._star3Item.setFrames(star3i,star3i,star3);
		this._star3Item.setAction(function() { thisMenu.setStarRatingSelected(3); });
		this._star4Item = new Menu.AnimationFrameMenuItem();
		this._star4Item.setFrames(star4i,star4i,star4);
		this._star4Item.setAction(function() { thisMenu.setStarRatingSelected(4); });
		this._star5Item = new Menu.AnimationFrameMenuItem();
		this._star5Item.setFrames(star5i,star5i,star5);
		this._star5Item.setAction(function() { thisMenu.setStarRatingSelected(5); });
		
		var starMenu = new Menu.Menu([this._star3Item, this._star4Item, this._star5Item]);
		starMenu.setPosition(Util.screenSize(true).getWidth() / 2, Scale.droid.height(100));
		starMenu.setDepth(1);
		this.addChild(starMenu);
	},
	
	setStarRatingSelected: function(rating) {
		
		// handle browsers
		for (var sr in this._browsers) {
			var browser = this._browsers[sr];
			if (browser.getParent() != null)
				this.removeChild(browser);
		}
		for (var sr in this._browserTTs) {
			var browserTT = this._browserTTs[sr];
			if (browserTT.getParent() != null)
				this.removeChild(browserTT);
		}
		
		var srBrowser = this._browsers[rating];
		var srBrowserTT = this._browserTTs[rating];
		this.addChild(srBrowser);
		this.addChild(srBrowserTT);
		
		// handle tabs
		for (var sr in this._browsers) {
			
			var srItem;
			if (sr == 3) 		srItem = this._star3Item;
			else if (sr == 4)	srItem = this._star4Item;
			else if (sr == 5)   srItem = this._star5Item;
			
			if (sr == rating)
				srItem.disable();
			else
				srItem.enable();
		}
	},
	
    attachPlayerUpdateListener: function(emitter){
        emitter.addListener(this._playerUpdateListener, this._playerUpdateListener.onUpdate);
    },
    
    setEnabled: function(enabled){
        this.setVisible(enabled);
        this.setTouchable(enabled);
    },
    
	setBuildToTheRight: function(boolll) {
		this._buildToTheRight = boolll;
	},
	
	getBuildToTheRight: function() {
		return this._buildToTheRight;
	},
	
//    setOpenForPlotID: function(p){
//        this._openForPlotID = p;
//    },
//    
//    getOpenForPlotID: function(){
//        return this._openForPlotID;
//    },
    
    stripObjectBuy: function(template){
        this._delegate.stripObjectBuy(template);
    },
    
    close: function(){
        this._delegate.close(this);
    },
	
	refresh: function () {
		for (var i in this._blocks) {
			var block = this._blocks[i];
			block.refresh(this._player.getChips(), this._player.getComps(), this._player.getLevel());	
		}
	},
    
    $StatUpdateListener: Core.MessageListener.subclass({
    
        classname: 'StatUpdateListener',
        
        initialize: function(menu){
            this._menu = menu;
        },
        
        
        onUpdate: function(statType, value){
			
			//update 
			this._menu.refresh();
        
//            switch (statType) {
//                case Game.Player.Player.StatType.Chips:
//                    
//                    break;
//                //todo: add other stats
//                default:
//                    break;
//            }
            

        }
    }),



});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Strip/StripObjectInfo'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripObjectInfo'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripObjectInfo'] = exports; /**
 * @author will
 */

var goldColor = new Core.Color(1, 1, 0.8);
exports.StripObjectInfo = Animation.AnimatedNode.subclass({
    classname: 'StripObjectInfo',
    
    initialize: function(delegate){
    
        this._delegate = delegate;
        //this._bg = new GL2.Sprite();
        
        var screenSize = Util.screenSize(true);
        
		this._bg = AtlasMap.getSprite('info-bg.png',[0,0]);
        this._bg.setDepth(-1);
        
        
        this._stripObject = null;
        
        this._name = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        this._name.setDepth(1);
        this._name.setAnchor(0.5, 0.5);
        this._name.setPosition(Scale.droid.width(200), Scale.droid.height(37));
        this._name.getLabel().setColor(goldColor);
		SCStyle.applyFontStyle(this._name, SCStyle.FontStyle.Serif24);
		
		this._infoText = new GL2.Text();
		this._infoText.setFontFamily('DroidSans-Regular');
		this._infoText.setFontSize(32);
		this._infoText.setDepth(1);
        this._infoText.setAnchor(0, 0);
        this._infoText.setPosition(Scale.droid.width(50), Scale.droid.height(87));
        this._infoText.setColor(1, 1, 1);
		this._infoText.setOverflowMode(GL2.Text.OverflowMode.Multiline);
		this._infoText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this._infoText.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		this._infoText.setSize(new Core.Size(Scale.droid.width(685), screenSize.getHeight()));
		SCStyle.applyFontStyle(this._infoText, SCStyle.FontStyle.Sans14);
				
		var valueX = Scale.droid.width(343);
		
        this._income = new GL2.Text();
		this._income.setFontFamily('DroidSans-Regular');
		this._income.setFontSize(32);
        this._income.setDepth(1);
        this._income.setAnchor(1, 0.5);
        this._income.setPosition(valueX, Scale.droid.height(239));
        this._income.setColor(1, 1, 1);
		SCStyle.applyFontStyle(this._income, SCStyle.FontStyle.Sans16);
		
        this._modText = new GL2.Text();
		this._modText.setFontFamily('DroidSans-Regular');
		this._modText.setFontSize(32);
        this._modText.setDepth(1);
        this._modText.setAnchor(1, 0.5);
        this._modText.setPosition(valueX, Scale.droid.height(322));
        this._modText.setColor(1, 1, 1);
		SCStyle.applyFontStyle(this._modText, SCStyle.FontStyle.Sans16);	
		
		this._valueText = new GL2.Text();
		this._valueText.setFontFamily('DroidSans-Regular');
		this._valueText.setFontSize(32);
        this._valueText.setDepth(1);
        this._valueText.setAnchor(1, 0.5);
        this._valueText.setPosition(valueX, Scale.droid.height(294));
        this._valueText.setColor(1, 1, 1);
		SCStyle.applyFontStyle(this._valueText, SCStyle.FontStyle.Sans16);
		
		this._timeTilCollectTime = new GL2.Text();
		this._timeTilCollectTime.setFontFamily('DroidSans-Regular');
		this._timeTilCollectTime.setFontSize(32);
        this._timeTilCollectTime.setDepth(3);
        this._timeTilCollectTime.setAnchor(1, 0.5);
        this._timeTilCollectTime.setPosition(valueX, Scale.droid.height(266));
        this._timeTilCollectTime.setColor(1, 1, 1);
		SCStyle.applyFontStyle(this._timeTilCollectTime, SCStyle.FontStyle.Sans16);
		
		
		var labelX = Scale.droid.width(45);
		
		var ratingLabel = new GL2.Text();
		ratingLabel.setFontFamily('DroidSans-Regular');
		ratingLabel.setFontSize(32);
		ratingLabel.setText("RATING");
		ratingLabel.setDepth(1);
		ratingLabel.setPosition(labelX, Scale.droid.height(214));
		ratingLabel.setAnchor (0, 0.5);
		ratingLabel.setColor(1,1,1);
		SCStyle.applyFontStyle(ratingLabel, SCStyle.FontStyle.SansB16);
		this.addChild(ratingLabel);	
		
		var incomeLabel = new GL2.Text();
		incomeLabel.setFontFamily('DroidSans-Regular');
		incomeLabel.setFontSize(32);
		incomeLabel.setText("INCOME");
		incomeLabel.setDepth(1);
		incomeLabel.setPosition(labelX, Scale.droid.height(239));
		incomeLabel.setAnchor (0, 0.5);
		incomeLabel.setColor(1,1,1);
		SCStyle.applyFontStyle(incomeLabel, SCStyle.FontStyle.SansB16);
		this.addChild(incomeLabel);	
		
		var timeLeftLabel = new GL2.Text();
		timeLeftLabel.setFontFamily('DroidSans-Regular');
		timeLeftLabel.setFontSize(32);
		timeLeftLabel.setText("TIME LEFT");
		timeLeftLabel.setDepth(1);
		timeLeftLabel.setPosition(labelX, Scale.droid.height(266));
		timeLeftLabel.setAnchor (0, 0.5);
		timeLeftLabel.setColor(1,1,1);
		SCStyle.applyFontStyle(timeLeftLabel, SCStyle.FontStyle.SansB16);
		this.addChild(timeLeftLabel);	
		
		var valueLabel = new GL2.Text();
		valueLabel.setFontFamily('DroidSans-Regular');
		valueLabel.setFontSize(32);
		valueLabel.setText("VALUE");
		valueLabel.setDepth(1);
		valueLabel.setPosition(labelX, Scale.droid.height(294));
		valueLabel.setAnchor (0, 0.5);
		valueLabel.setColor(1,1,1);
		SCStyle.applyFontStyle(valueLabel, SCStyle.FontStyle.SansB16);
		this.addChild(valueLabel);	
		
		var abilityLabel = new GL2.Text();
		abilityLabel.setFontFamily('DroidSans-Regular');
		abilityLabel.setFontSize(32);
		abilityLabel.setText("ABILITY");
		abilityLabel.setDepth(1);
		abilityLabel.setPosition(labelX, Scale.droid.height(322));
		abilityLabel.setAnchor (0, 0.5);
		abilityLabel.setColor(1,1,1);
		SCStyle.applyFontStyle(abilityLabel, SCStyle.FontStyle.SansB16);
		this.addChild(abilityLabel);	
		
		var infoButtonFrame = AtlasMap.getAnimationFrame('info-button-bg-active.png',0,[0,0]);
		var infoButtonFrameI = AtlasMap.getAnimationFrame('info-button-bg-inactive.png',0,[0,0]);
		
		//close button
        var item1 = new Menu.AnimationFrameMenuItem();
        item1.setFrames(infoButtonFrameI, infoButtonFrame, infoButtonFrame);
        
		this._closeText = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		this._closeText.setDepth(3);
        this._closeText.setAnchor(0.5, 0.5);
        this._closeText.setPosition(Scale.droid.width(60), Scale.droid.height(19));
        this._closeText.getLabel().setColor(0, 0, 0);
		SCStyle.applyFontStyle(this._closeText, SCStyle.FontStyle.SerifB16);
		this._closeText.setText('EXIT');
		item1.addChild(this._closeText);
		
        var closemenuf = this;
        item1.setAction(function(){
            closemenuf.hide();
        });
		
		//move button
        this._moveitem = new Menu.AnimationFrameMenuItem();
        this._moveitem.setFrames(infoButtonFrameI, infoButtonFrame, infoButtonFrame);
        
		this._moveText = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		this._moveText.setDepth(3);
        this._moveText.setAnchor(0.5, 0.5);
        this._moveText.setPosition(Scale.droid.width(60), Scale.droid.height(19));
        this._moveText.getLabel().setColor(0, 0, 0);	
		SCStyle.applyFontStyle(this._moveText, SCStyle.FontStyle.SerifB16);
		this._moveText.setText('MOVE');
		this._moveitem.addChild(this._moveText);
		
		
        var self = this;
        this._moveitem.setAction(function(){
            self.move();
        });
			
		//sell button
        this._sellframeitem = new Menu.AnimationFrameMenuItem();
		this._sellframeitem.setFrames(infoButtonFrameI, infoButtonFrame, infoButtonFrame);
        
		this._sellText = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		this._sellText.setDepth(3);
        this._sellText.setAnchor(0.5, 0.5);
        this._sellText.setPosition(Scale.droid.width(60), Scale.droid.height(19));
        this._sellText.getLabel().setColor(0, 0, 0);
		SCStyle.applyFontStyle(this._sellText, SCStyle.FontStyle.SerifB16);
		this._sellText.setText('SELL');
		this._sellframeitem.addChild(this._sellText);
		
        var sellmenuf = this;
        this._sellframeitem.setAction(function(){
            sellmenuf.sell();
        });
		
		this._bottomMenu = new Menu.Menu([this._sellframeitem, this._moveitem, item1]);
		this._bottomMenu.alignItemsHorizontally(-5);
		this._bottomMenu.setPosition(Scale.droid.width(137), Scale.droid.height(353));
		this._bottomMenu.setDepth(2);
			
		
//        this._collectframeitem = new Menu.AnimationFrameMenuItem();
//        this._collectframeitem.setFrames(new GL2.Animation.Frame('Content/collect-button.png', 0, [Scale.droid.width(80), Scale.droid.height(128)], [0.5, 0.5]),
//		new GL2.Animation.Frame('Content/collect-button-disabled.png', 0, [Scale.droid.width(100), Scale.droid.height(100)], [0.5, 0.5]),
//		new GL2.Animation.Frame('Content/collect-button-disabled.png', 0, [Scale.droid.width(100), Scale.droid.height(100)], [0.5, 0.5]));
//		
//		//default value should be disabled
//		this._collectframeitem.setEnabled(false);
//        
//        var collectmenuf = this;
//        this._collectframeitem.setAction(function(){
//            collectmenuf.collect();
//        });		
//		
//        this._collectButton = new Menu.Menu([this._collectframeitem]);
//        this._collectButton.setPosition(Scale.droid.width(90), Scale.droid.height(140));
//        this._collectButton.setDepth(2);			
		
				
		this.addChild(this._bottomMenu);
		this.addChild(this._modText);
        this.addChild(this._bg);
        this.addChild(this._name);
		this.addChild(this._infoText);
		this.addChild(this._income);
		this.addChild(this._timeTilCollectTime);
		this.addChild(this._valueText);
		
    },
    
    showFor: function(so, enableMove, enableSell){
        if (!so) 
            return;
			
		if (typeof enableMove == 'undefined') enableMove = true;
		if (typeof enableSell == 'undefined') enableSell = true;
        
        this.setVisible(true);

        var same = false;
        
        if (so == this._stripObject) 
            same = true;
			
        this._stripObject = so;
		this.refreshTimeTilCollectTime();        
		
        if (!same) {
            //refresh information	
            this._name.setText(so.getName());
			this._infoText.setText(so.getInfoText());
			// if (SCGame.getSettings().getJapaneseOn()) {
			// 	this._income.setText(Util.numberFormat(so.getIncome()) + ' チップ');
			// 	this._valueText.setText(Util.numberFormat(so.getSellAmount()) + ' チップ');
			// }
			// else {
				this._income.setText(Util.dollarFormat(so.getIncome()));
				this._valueText.setText(Util.dollarFormat(so.getSellAmount()));
			// }
			this.setStripObjectStarRatingImage();
			
			if (so.hasMod()) {
				this._modText.setText(so.getMod().getDescription());
			} 
			else {	
				this._modText.setText('None');
			}
			
        }
		
		
		this._moveitem.setEnabled(enableMove);
		this._sellframeitem.setEnabled(enableSell);
		    
    },
	
	setStripObjectStarRatingImage: function() {
		
		//NgLogD(this._stripObject.getStarRating());
		
		if (!this._starRating) {
			this._starRating = new GL2.Sprite();
		}
		if (this._starRating && this._starRating.getParent() != null)
			this.removeChild(this._starRating);
		
		var imgName;
		var starX = 345;
		switch (this._stripObject.getStarRating())
		{
			case 3: 
				imgName = 'stars-3.png';
				//starX += 20; 
				break;
			case 4: 
				imgName = 'stars-4.png'; 
				//starX += 10;
				break;
			case 5: 
				imgName = 'stars-5.png'; 
				break;
		}
		
		if (imgName) {
			
			var animFrame = AtlasMap.getAnimationFrame(imgName, 0, [1, 0.5]);
			
			var animation = new GL2.Animation();
			animation.pushFrame(animFrame);
			this._starRating.setAnimation(animation); 
			this._starRating.setPosition(Scale.droid.width(starX),Scale.droid.height(211));
			this.addChild(this._starRating);	
		}
	},
	
	refreshTimeTilCollectTime: function() {
		var now = new Date();
		var so = this._stripObject;
		
		if (so==null) return;
		

		//if (now >= so.getNextCollectTime()) {
		if (so.canCollect()) {
			this._timeTilCollectTime.setText('Collect Now.');
		}
		else if (!so.canCollectIgnoringTime()) {
			
			this._timeTilCollectTime.setText('N/A');
		}
		else {
			var timeLeft = so.getNextCollectTime().getTime() - now.getTime();		
			this._timeTilCollectTime.setText( Util.translateTime( timeLeft, true, true));	
		}
		
	},
    
    hide: function(){
        this.setVisible(false);
		this._delegate.stripObjectInfoHidden(this._stripObject);
    },
	
	sell: function() {
		
		var numActiveStripObjects = this._delegate._strip.getNumActiveStripObjects();
        if (numActiveStripObjects > 1) {
			if (this._stripObject == null)  return;
			
			this.setVisible(false);
			this._delegate.stripObjectSell(this._stripObject);
			this._stripObject = null;
		}
		else {
			AlertLayer.showAlertNode(new GenericAlertNode('Strip City zoning rules require you to have at least one hotel.','ZONING RULES'));
		}
	},
	

	
	move: function () {
		if (this._stripObject == null) return;
		this.setVisible(false);		
		this._delegate.stripObjectMove ( this._stripObject);
		//todo: run collect animation
	}	
    
    
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Strip/StripMap'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripMap'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripMap'] = exports; /**
 * @author will
 */
var StripObjectNode = require('Code/StripCity/Scene/Strip/StripObjectNode').StripObjectNode;


var moveNodeEdgePixels = 100;

exports.StripMap = Animation.AnimatedNode.subclass({

    classname: 'StripMap',
    
    initialize: function(background, mapSize, unitWidth, delegate){
    
        this._background = background;
        
		this._buildingY = Scale.droid.height(426);
		
        this._unitWidth = Scale.droid.width(20);
        this._delegate = delegate;
         
        //map size hsould be calculated
        this._mapSize = mapSize;	
        //this seems like.... its off. it should be true but for some reason false works.
        //        this.setChildrenDepthGrouped(false);

        this._updateListener = new this.StripUpdateListener(this);
        this._scrollTouchHandler = null;
        this._moveNodeTouchHandler = null;
        
		this._yScreenTopBounds = 0;
		this._yScreenBottomBounds = Util.screenSize(true).getHeight();
		
        this._touchTarget = new GL2.TouchTarget();
        
        //todo: temporary.
        //        this._touchTarget.setSize(this._mapSize);
        this._touchTarget.setSize([Scale.droid.width(8000), Scale.droid.height(6000)]);
        this._touchTarget.setAnchor([0.5, 0.5])
        this.addChild(this._touchTarget);
        this._objectMap = null;
        
        this._numPlots = 0;
        
        this._state = -1;
        this.setState(this.State.Scrolling);
        
		this.initForCars();
    },
    
    State: {
    
        Scrolling: 0,
        MovingNode: 1,

    
    },
    
	getYScreenTopBounds: function() {
		return this._yScreenTopBounds;
	},
	
	setYScreenTopBounds: function(bounds) {
		this._yScreenTopBounds = bounds;
	},
	
	getYScreenBottomBounds: function() {
		return this._yScreenBottomBounds;
	},
	
	setYScreenBottomBounds: function(bounds) {
		this._yScreenBottomBounds = bounds;
	},
	
    setState: function(state){
    
        if (this._state == state) 
            return;
        
        //clean up
        if (this._moveNodeTouchHandler) {
            this._moveNodeTouchHandler.destroy();
            this._moveNodeTouchHandler = null;
        }
        if (this._scrollTouchHandler) {
            this._scrollTouchHandler.destroy();
            this._scrollTouchHandler = null;
            
        }
        
        switch (state) {
            case this.State.Scrolling:
                this._scrollTouchHandler = new this.ScrollTouchHandler(this, true);
                this._touchTarget.getTouchEmitter().addListener(this._scrollTouchHandler, this._scrollTouchHandler.onTouch);
                break;
            case this.State.MovingNode:
                this._moveNodeTouchHandler = new this.MoveNodeTouchHandler(this);
                this._touchTarget.getTouchEmitter().addListener(this._moveNodeTouchHandler, this._moveNodeTouchHandler.onTouch);
                break;
            default:
                break;
                
                
        }
        
        this._state = state;
        
    },
    
	setPositionAllWayToTheRight: function() {
		
		this.setPosition(-this._width / 2, this.getPosition().getY());
	},
	
	setPositionAllWayToTheLeft: function() {
		
		this.setPosition(this._width / 2, this.getPosition().getY());
	},
	
	initForCars: function() {
		
		this.cars = [];
		this.carFrames = [];
		
		this.allowAddMoreCars = true;
	
		var isNight = SCGame.isNightTime;	
		for (var i = 1; i <= 9; i++) {
			var numStr;
			if (i < 10) numStr = '0' + i;
			else numStr = '' + i;
			
			var nightStr = isNight ? 'n' : 'd';
			
			var frameName = 'car-' + numStr + '-' + nightStr + '.png';
			this.carFrames.push(AtlasMap.getAnimationFrame(frameName)); 
		}
		
		this.carUpdateListener = new this.CarUpdateListener(this);
		Core.UpdateEmitter.addListener(this.carUpdateListener, this.carUpdateListener.onUpdate); 
	},
	
	getCarYPositionByLane: function(lane) {
		
		if (lane == 1)
			return 440;
		else 
			return 465;
	},
	
	addInitialCars: function() {
		
		var width = this._width;
		var scrWidth = Util.screenSize(true).getWidth();
		var totalWidth = scrWidth*2 + width;
		
		var numNodes = SCGame.getNumberStripNodes();
		var laneDist = 800;
		if (numNodes < 5) {
			var invFrac = 5 / numNodes;
			laneDist *= invFrac;
		}
		
		var myWidth = totalWidth - scrWidth / 2;
		var startPos = totalWidth / 2;
		var lane1Dist = laneDist;
		var lane1Offset = lane1Dist / 3;
		var lane2Dist = laneDist;
		var lane2Offset = lane2Dist / 3;
		
		for (var currPos = startPos; currPos > startPos-myWidth; currPos -= lane1Dist) {
			
			var randOffset = Math.random() * lane1Offset*2 - lane1Offset;
			var xPos = randOffset + currPos;
			
			this.addCarInLaneAtXPosition(1, xPos); 
		}
		
		for (var currPos = startPos; currPos > startPos-myWidth; currPos -= lane2Dist) {
			
			var randOffset = Math.random() * lane2Offset*2 - lane2Offset;
			var xPos = randOffset + currPos;
			
			this.addCarInLaneAtXPosition(2, xPos); 
		}
	},
	
	addCarInLaneAtStripStart: function(lane) {
		
		var width = this._width;
		var scrWidth = Util.screenSize(true).getWidth();
		var totalWidth = scrWidth*2 + width;
		
		this.addCarInLaneAtXPosition(lane, totalWidth / 2);
	},
	
	addCarInLaneAtXPosition: function(lane, xPos) {
		
		if (!this.allowAddMoreCars) return;
		
		var carNode = this.generateCarNode(lane);
		carNode.lane = lane;
		carNode.setDepth(5);
		
		var frameWidth = carNode.frame.getSize().getWidth();
		carNode.setPosition(new Core.Vector(xPos + frameWidth / 2,this.getCarYPositionByLane(lane)));
		this.runMoveSequenceOnCarNode(carNode);
		carNode.addChild(carNode);
		
		this.addChild(carNode);
		this.cars.push(carNode);
	},
	
	runMoveSequenceOnCarNode: function(carNode) {
		
		var speed = carNode.lane == 1 ? 4 : 5;
		
		var width = this._width;
		var scrWidth = Util.screenSize(true).getWidth();
		var totalWidth = scrWidth*2 + width;
		var frameWidth = carNode.frame.getSize().getWidth();
		
		var xPos = carNode.getPosition().getX();
		var xDest = -(totalWidth + frameWidth) / 2;
		var xDelta = xDest - xPos;
		if (xDelta < 0) xDelta = -xDelta;
		var moveTime = xDelta * 30 / (speed * 1000);
		 
		var yPos = carNode.getPosition().getY();
		
		var thisMap = this;
		carNode.runSequence(moveTime, function() { carNode.moveTo(xDest, yPos, moveTime); },
							0, function() { thisMap.onCarFinishedMoving(carNode); });
	},
	
	haltAllCars: function() {
		
		this.allowAddMoreCars = false;
		
		for (var i in this.cars) {
			var carNode = this.cars[i];
			carNode.stopAllActions();
		}
	},
	
	resumeAllCars: function() {
		
		this.allowAddMoreCars = true;
		
		for (var i in this.cars) {
			var carNode = this.cars[i];
			this.runMoveSequenceOnCarNode(carNode);
		}
	},
	
	onCarFinishedMoving: function(carNode) {
		
		this.removeChild(carNode);
		Util.removeByValue(this.cars, carNode);
		carNode.stopAllActions();
		carNode.destroy();
	},
	
	getRandomCarAnimationFrame: function() {
		
		var numFrames = this.carFrames.length;
		var randIndex = Util.randomInt(0, numFrames-1);
		
		return this.carFrames[randIndex];
	},
	
	generateCarNode: function(lane) {
		
		var anim = new GL2.Animation();
		var frame = this.getRandomCarAnimationFrame();
		anim.pushFrame(frame);
		
		var sprite = new GL2.Sprite();
		sprite.setAnimation(anim);
		
		var scale = 1;
		if (lane == 1) scale = .95;
		sprite.setScale([scale,scale]);
		
		var node = new Animation.AnimatedNode();
		node.frame = frame;
		node.addChild(sprite);
		return node;
	},
	
    drawPlotMap: function(origPlotMap, animated){
    
        if (typeof animated == 'undefined') 
            animated = false;
        //add the object based on its id
        if (!origPlotMap) 
            return;
        
        var plotMap = origPlotMap.slice();
        
        //sort the damn thing by plot id
        
        plotMap.sort(function(a, b){
            if (a.getPlotID() < b.getPlotID()) 
                return -1;
            if (a.getPlotID() > b.getPlotID()) 
                return 1;
            return 0;
        })
        
        var firstDraw = false;
        
        if (!this._objectMap) {
            this._objectMap = {};
            firstDraw = true;
        }
        
        var activeStripObjectNodes = [];
        
        
        //gather all active strip nodes
        if (firstDraw) {
            for (var i in plotMap) {
                var so = plotMap[i];
                var son = this.createStripObjectNode(so);
                activeStripObjectNodes.push(son);
                son.setCurrentPlotID(so.getPlotID());
            }
            
        }
        else {
            for (var i in plotMap) {
                var so = plotMap[i];
                var son = this.getStripObjectNode(so.getID());
                if (typeof son == 'undefined' || son == null) {
                    //means its not there yet we create it
                    son = this.createStripObjectNode(so);
                    this.addNewStripObjectNode(son);
                    
                    if (animated) {
                        son.setMarkedForBuildAnimation(true);
                    }
                }
                activeStripObjectNodes.push(son);
                son.setCurrentPlotID(so.getPlotID());
                
            }
        }
        
        this._numPlots = plotMap.length;
		this._width = this.calculateTotalWidth(activeStripObjectNodes);
		this.updateStripMapBackgroundForWidth();
        
        //if its the first time drawing we also need to add them to the map
        if (firstDraw) {
            this.calculatePositions(activeStripObjectNodes);
            for (var i in activeStripObjectNodes) {
                var currentNode = activeStripObjectNodes[i];
                this.addNewStripObjectNode(currentNode);
            }
        }
        else 
            //if its an animated update.
            if (animated) {
            
                this.runAnimationForUpdate(activeStripObjectNodes, plotMap);
                
                
            }
            else {
                this.calculatePositions(activeStripObjectNodes);
                //todo: add nodes
                
                //remove all the nodes.
                for (var i in this._objectMap) {
                    var son = this._objectMap[i];
                    if (son.markedForRemove()) {
                        this.removeStripObjectNode(son);
                    }
                }
            }
			
			this.printActiveStripObjectNodes();
    },
    
    runAnimationForUpdate: function(activeStripObjectNodes, plotMap){
    
        this._width = this.calculateTotalWidth(activeStripObjectNodes);
        
        var offset = Util.floatToInt((this._mapSize.getWidth() - this._width) / 2);
        var xPos = offset;
        
        var buildAnimations = [];
        var moveAnimations = [];
        var sellAnimations = [];
        
        //new     
        
        //if not an animated update, calculate moves...
        for (var i in activeStripObjectNodes) {
      
	        var node = activeStripObjectNodes[i];
            if (!node) continue;
            
            //update
            xPos += this._unitWidth;
            var halfWidth = Util.floatToInt(node.getSize().getWidth() / 2);
            xPos += halfWidth;
            var position = new Core.Point(xPos, this._buildingY);
            xPos += halfWidth;
                     
            if (node.markedForBuildAnimation()) {
				
                var buildAnimation = new this.StripUpdateAnimation(this, this.StripUpdateAnimation.Type.Build, node, position);
                buildAnimations.push(buildAnimation);
                node.setMarkedForBuildAnimation(false);
            }
            else {
				
                if (node.getPosition().getX() == position.getX() && node.getPosition().getY() == position.getY()) 
                    continue;				
                var moveAnimation = new this.StripUpdateAnimation(this, this.StripUpdateAnimation.Type.Move, node, position);
                moveAnimations.push(moveAnimation);
            }
            
            
        }
        
        for (var i in this._objectMap) {
            var son = this._objectMap[i];
            if (son.markedForRemove()) {
                var sellAnimation = new this.StripUpdateAnimation(this, this.StripUpdateAnimation.Type.Sell, son, null);
                sellAnimations.push(sellAnimation)
            }
        }
        
//        NgLogD('build animations = ' + buildAnimations.length);
//        NgLogD('sell animations = ' + sellAnimations.length);
//        NgLogD('move animations = ' + moveAnimations.length);
        
		var totalAnim = buildAnimations.length + sellAnimations.length + moveAnimations.length;
		//this._delegate.updateAnimationsToRun += totalAnim;
		this._delegate.addUpdateAnimationsToRun(totalAnim);
		
        for (var i in buildAnimations) {
            var animation = buildAnimations[i];
            animation.execute();
        }
        
        
        for (var i in sellAnimations) {
            var animation = sellAnimations[i];
            animation.execute();
        }
        
        if (sellAnimations.length == 0) {
			this.runMoveAnimations(moveAnimations);
		}
		else {
			var thisMap = this;
			setTimeout(function() { thisMap.runMoveAnimations(moveAnimations) }, 8000);
		}
    },
    
	runMoveAnimations: function(moveAnimations) {
		
		for (var i in moveAnimations) {
			var animation = moveAnimations[i];
			animation.execute();
		}
	},
	
    createMoveAnimations: function(activeStripObjectNodes, positions){
        var moveAnimations = [];
        for (var i in activeStripObjectNodes) {
            var node = activeStripObjectNodes[i];
            if (!node) 
                continue;
            
            var position = positions[i].clone();
            
            if (node.markedForBuildAnimation()) {
                continue;
            }
            else {
                if (node.getPosition().getX() == position.getX() && node.getPosition().getY() == position.getY()) 
                    continue;
                var moveAnimation = new this.StripUpdateAnimation(this, this.StripUpdateAnimation.Type.Move, node, position);
                moveAnimations.push(moveAnimation);
            }
        }
        
        return moveAnimations;
    },
    
    getTouchTarget: function(){
        return this._touchTarget;
    },
    
    getStripObjectNode: function(identity){
        return this._objectMap['id:' + identity];
    },
    
    addNewStripObjectNode: function(node){
        NgLogD('adding new strip object node = ' + node.getStripObjectID());
        this._objectMap['id:' + node.getStripObjectID()] = node;
        this.addChild(node);
    },
    
    removeStripObjectNode: function(node){
        NgLogD('removing node ' + node.getStripObjectID());
        delete this._objectMap['id:' + node.getStripObjectID()];
        //		for (var i in this._objectMap) {
        //			var n = this._objectMap[i];
        //			NgLogD('---node so id ' + i +":" +  n.getStripObjectID());
        //		}
        
        this.removeChild(node);
        node.destroy();
    },
    
    objectForTouch: function(touch){
    
    
        for (var i in this._objectMap) {
            var obj = this._objectMap[i];
            
            if (!obj) 
                continue;
            
            var local = obj.screenToLocal(touch.getPosition());
            
            //figures out the top left origin, since 0,0 is where the anchorpoint is, we normalize it to the top left origin.
            var topLeftOrigin = Util.getPositionForAnchorPointGivenValues(new Core.Point(0, 0), obj.getSize(), obj.getAnchor(), new Core.Point(0, 0));
            var itemRect = new Core.Rect(topLeftOrigin.getX(), topLeftOrigin.getY(), obj.getSize().getWidth(), obj.getSize().getHeight());
            
            
            //then check to see if the point is within that space.
            if (Util.rectContainsPoint(itemRect, local)) {
                return obj;
            }
            
        }
        
        return null;
    },
	
	runCanCollectCheckOnNodes: function() {
        for (var i in this._objectMap) {
            var son = this._objectMap[i];
            if (!son) 
                continue;
            if (!son.markedForRemove()) {
                son.checkCanCollect();
            }
        }
	},
	
	
	showCollectButtonOnNodes: function( show ) {
        for (var i in this._objectMap) {
            var son = this._objectMap[i];
            if (!son) 
                continue;
            if (show) {
                son.showCollectButton();
            }
            else {
                son.hideCollectButton();
            }
            
            
        }
	},
    
    
    
    
    snapNodeTo: function(node, plotID, animateNode, callback){
        if (node == null || typeof plotID == 'undefined') {
            return;
        }
        
        if (!this._objectMap) {
            return;
        }
        
        if (!node.isMovable()) 
            return;
        //shoudl we animate the node in question or only the other nodes.		
        if (typeof animateNode == 'undefined') 
            animateNode = true;
        
        var startPlotID = node.getCurrentPlotID();
        var endPlotID = plotID;
        
        var swap = true;
        if (startPlotID == endPlotID) 
            swap = false;
        
        var activeStripObjectNodes = [];
        var startPlotIDNode = null;
        var endPlotIDNode = null;
        for (var i in this._objectMap) {
            var son = this._objectMap[i];
            if (!son.markedForRemove()) {
                activeStripObjectNodes.push(son);
            }
            
            
            if (!swap) 
                continue;
            
            if (son.getCurrentPlotID() == startPlotID) {
                startPlotIDNode = son;
            }
            else 
                if (son.getCurrentPlotID() == endPlotID) {
                    endPlotIDNode = son;
                }
            
        }
        
        //do the swap.		
        if (swap) {
        
            if (startPlotIDNode) {
                //we tried to swap a immovable node return;
                if (!startPlotIDNode.isMovable()) 
                    return;
                
            }
            
            if (endPlotIDNode) {
                //we tried to swap a immovable node return;
                if (!endPlotIDNode.isMovable()) 
                    return;                
            }
            
            if (startPlotIDNode) {
                startPlotIDNode.setCurrentPlotID(endPlotID);
            }
            if (endPlotIDNode) {
                //we tried to swap a immovable node return;  
                endPlotIDNode.setCurrentPlotID(startPlotID);
            }
            
        }
        
        
        
        
        
        
        activeStripObjectNodes.sort(function(a, b){
            if (a.getCurrentPlotID() < b.getCurrentPlotID()) 
                return -1;
            if (a.getCurrentPlotID() > b.getCurrentPlotID()) 
                return 1;
            return 0;
        });
        
        var positions = this.getPositions(activeStripObjectNodes);
        
        var moveAnimations = this.createMoveAnimations(activeStripObjectNodes, positions);
		//this._delegate.updateAnimationsToRun += moveAnimations.length;
		this._delegate.addUpdateAnimationsToRun(moveAnimations.length);
        
        for (var i in moveAnimations) {
            var animation = moveAnimations[i];
            
            //check if its original node
            if (!animateNode && animation.getNode() == node) {
                NgLogD(' not animating node in questions');
				//this._delegate.updateAnimationsToRun--;
				this._delegate.addUpdateAnimationsToRun(-1);
                continue;
            }
            animation.execute();
        }
		
		if ( typeof callback == 'undefined') return;
		
		callback();
        
        
    },
    
    
    calculatePositions: function(stripObjectNodes){
    
    
    
        var positions = this.getPositions(stripObjectNodes);
        
        for (var i in stripObjectNodes) {
            var son = stripObjectNodes[i];
            if (son == null) 
                continue;
            son.setPosition(positions[i].clone());
        }
        
    },
	
	printActiveStripObjectNodes: function() {
   
        for (var i in this._objectMap) {
            var son = this._objectMap[i];
            if (!son.markedForRemove()) {
                NgLogD('strip object node... plotid ' + son.getStripObjectPlotID() + ' currentplotid ' + son.getCurrentPlotID());
            }
        }		
		
	},
    
    getCurrentPositions: function(){
        var activeStripObjectNodes = [];
        
        if (this._objectMap == null) 
            return [];
        
        for (var i in this._objectMap) {
            var son = this._objectMap[i];
            if (!son.markedForRemove()) {
                activeStripObjectNodes.push(son);
            }
        }
        activeStripObjectNodes.sort(function(a, b){
            if (a.getCurrentPlotID() < b.getCurrentPlotID()) 
                return -1;
            if (a.getCurrentPlotID() > b.getCurrentPlotID()) 
                return 1;
            return 0;
        });
        
        
        return this.getPositions(activeStripObjectNodes);
    },
    
    getPositions: function(stripObjectNodes){
    
        var width = this.calculateTotalWidth(stripObjectNodes);
        var offset = Util.floatToInt((this._mapSize.getWidth() - width) / 2);
        var xPos = offset;
        
        var positions = []
        //if not an animated update
        for (var i in stripObjectNodes) {
            var node = stripObjectNodes[i];
            if (!node) 
                continue;
            
            xPos += this._unitWidth;
            var halfWidth = Util.floatToInt(node.getSize().getWidth() / 2);
            xPos += halfWidth;
            pos = new Core.Point(xPos, this._buildingY);
            xPos += halfWidth;
            
            positions.push(pos);
        }
        
        return positions;
    },
    
    
    calculateTotalWidth: function(nodes){
        var width = 0;
        for (var i in nodes) {
            var node = nodes[i];
            width += node.getSize().getWidth();
            width += this._unitWidth;
        }
        
        return width;
    },
	
    createStripObjectNode: function(stripObject){
    
        var s1 = new StripObjectNode(stripObject);
        s1.setDelegate(this);
        s1.setDepth(1);
        return s1;
    },
    
    canAddObjectWithoutOverlap: function(img){
        for (var i in this._objectMap) {
            var child = this._objectMap[i];
            if (child == null) {
                continue;
            }
            
            
            if (child.getDepth() == img.getDepth()) {
                //check if overlap
                if (this.overlap(img, child)) {
                    return false;
                }
                
            }
        }
        
        return true;
    },
    
    getMapSize: function(){
        return this._mapSize;
    },
    
    stripNodeTouched: function(node){
        this._delegate.stripNodeTouched(node);
    },
	
	stripObjectNodeMoveConfirmed: function ( node ) {
		if (!node ) return;
		this._delegate.stripObjectMoveConfirmed( node.getStripObject(), node.getCurrentPlotID());
	},
	
	stripObjectNodeMoveCanceled: function( node ) {
		if (!node ) return;		
		this._delegate.stripObjectMoveCanceled( node.getStripObject());		
	},
	
	stripObjectNodeCollect: function ( node ) {
		if (!node) return;
		if (node.getStripObject() == null) return;
		node.resetCanCollect();
		this._delegate.stripObjectCollect(node.getStripObject());
	},
    
	shiftMapForStripObjectInfo: function(node) {
		if (!node) return;
	
		var nodePos = this.getNodePositionOnScreen(node).getX();
		var targetPos = Util.screenSize(true).getWidth() * 3 / 4;
		var nodePosDiff = targetPos - nodePos;
	
		var yPos = this.getPosition().getY();
		var xPos = this.getPosition().getX() + nodePosDiff;
		this.moveTo(xPos, yPos, 0.5);
	
	},
	
	getNodePositionOnScreen: function(node) {
		
		return node.localToScreen(new Core.Point(0,0));
	},

	onChangePositionX: function(diffX) {
		
		// background parallax
		for (var i in this._background.getLayers()) {
			var layer = this._background.getLayers()[i];
			var layerFraction = layer.movePercent / 100;
			var layerPos = layer.getPosition();
			var newLayerX = layerPos.getX() + diffX * layerFraction;
							
			layer.setPosition(newLayerX, layerPos.getY());
		}
	},
	
    overlap: function(img1, img2){
        var rect1 = new Object();
        var rect1pos1 = Util.getPositionForAnchorPoint(img1, new Core.Point(0, 0));
        var rect1pos2 = Util.getPositionForAnchorPoint(img1, new Core.Point(1, 1));
        rect1.x1 = rect1pos1.getX();
        rect1.x2 = rect1pos2.getX();
        rect1.y1 = rect1pos1.getY();
        rect1.y2 = rect1pos2.getY();
        

        
        var rect2 = new Object();
        var rect2pos1 = Util.getPositionForAnchorPoint(img2, new Core.Point(0, 0));
        var rect2pos2 = Util.getPositionForAnchorPoint(img2, new Core.Point(1, 1));
        rect2.x1 = rect2pos1.getX();
        rect2.x2 = rect2pos2.getX();
        rect2.y1 = rect2pos1.getY();
        rect2.y2 = rect2pos2.getY();
        
        
        //if (RectA.X1 < RectB.X2 && RectA.X2 > RectB.X1 &&
        //    RectA.Y1 < RectB.Y2 && RectA.Y2 > RectB.Y1)		
        
        return (rect1.x1 < rect2.x2 && rect1.x2 > rect2.x1 &&
        rect1.y1 < rect2.y2 &&
        rect1.y2 > rect2.y1);
    },
    
    attachUpdateListener: function(emitter){
        emitter.addListener(this._updateListener, this._updateListener.onUpdate);
    },
	
	updateStripMapBackgroundForWidth: function() {
		
		var width = this._width;
		var scrWidth = Util.screenSize(true).getWidth();
		var totalWidth = scrWidth*2 + width;
		
		this._background.setCurrentNumberBackgroundSpritesByMapWidth(totalWidth);
		this._background.updateImages();
	},
	
	$CarUpdateListener: Core.MessageListener.subclass({
		
		classname: 'CarUpdateListener',
		
		initialize: function(map) {
			this.map = map;
			this.lane1counter = 0;
			this.lane2counter = 0;
			this.setNextLane1WaitTime();
			this.setNextLane2WaitTime();
		},
		
		setNextLane1WaitTime: function() {
			
			var numNodes = SCGame.getNumberStripNodes();
			var multiplier = 2.66666;
			var skew = 4;
			
			this.nextLane1 = Math.random() * multiplier + skew;
			if (numNodes < 5) {
				var invFrac = 5 / numNodes;
				this.nextLane1 *= invFrac;
			}
			this.nextLane1 *= 1000;
		},
		
		setNextLane2WaitTime: function() {
			
			var numNodes = SCGame.getNumberStripNodes();
			var multiplier = 2.66666;
			var skew = 4;
			
			this.nextLane2 = Math.random() * multiplier + skew;
			if (numNodes < 5) {
				var invFrac = 5 / numNodes;
				this.nextLane2 *= invFrac;
			}
			this.nextLane2 *= 1000;
		},
		
		onUpdate: function(delta) {
			
			this.lane1counter += delta;
			this.lane2counter += delta;
			
			if (this.lane1counter > this.nextLane1) {
				this.lane1counter = 0;
				this.setNextLane1WaitTime();
				
				this.map.addCarInLaneAtStripStart(1);
			}
			if (this.lane2counter > this.nextLane2) {
				this.lane2counter = 0;
				this.setNextLane2WaitTime();
				
				this.map.addCarInLaneAtStripStart(2);
			}
		},
	}),
	
    $StripUpdateListener: Core.MessageListener.subclass({
    
        classname: 'StripUpdateListener',
        
        initialize: function(stripMap){
            this._stripMap = stripMap;
        },
        
        
        onUpdate: function(plotMap, animated){
            //value
            this._stripMap.drawPlotMap(plotMap, animated);
        }
    }),
    
    $StripUpdateAnimation: Core.MessageListener.subclass({
    
        classname: 'StripUpdateAnimation',
        
        initialize: function(map, type, node, value){
            this._map = map;
            this._node = node;
            this._value = value;
            this._type = type;
            
            
            switch (this._type) {
                case this.Type.Build:
                    this._node.setPosition(value);
                    this._node.setAlpha(0);
                    break;
                default:
                    break;
            }
            
        },
        
        Type: {
        
            Move: 0,
            Sell: 1,
            Build: 2,
        
        },
        
        getNode: function(){
            return this._node;
        },
        
        getValue: function(){
            return this._value;
        },
        
        getType: function(){
            return this._type;
        },
        
        execute: function(){
            switch (this._type) {
                case this.Type.Move:
                    this.executeMove();
                    break;
                case this.Type.Sell:
                    this.executeSell();
                    break;
                case this.Type.Build:
                    this.executeBuild();
                    break;
                default:
                    break;
            }
        },
        
		decrementStripSceneUpdateAnimationsToRun: function() {
			//this._map._delegate.updateAnimationsToRun--;
			this._map._delegate.addUpdateAnimationsToRun(-1);
		},
		
        executeMove: function(){
			
			var thisUpdate = this;
			var node = this._node;
			
			node.runSequence(0.5, function() { node.moveTo(thisUpdate._value.getX(), thisUpdate._value.getY(), 0.5);  }, 0, function() { thisUpdate.decrementStripSceneUpdateAnimationsToRun(); } );
            //this._node.moveTo(this._value.getX(), this._value.getY(), 0.5);
        },
        
        executeSell: function(){
        
			var thisUpdate = this;
            var map = this._map;
            var son = this._node;
            setTimeout(function(){
                map.removeStripObjectNode(son);
				thisUpdate.decrementStripSceneUpdateAnimationsToRun();
            }, 8050)
            this._node.runSellAnimation();
        },
        
        executeBuild: function(){
            NgLogD('execute build');
            
			var thisUpdate = this;
		
            this._node.runBuildAnimation(function() { thisUpdate.decrementStripSceneUpdateAnimationsToRun(); });
            
        },
    
    
    }),
    
    $ScrollTouchHandler: Core.MessageListener.subclass({
    
        classname: 'ScrollTouchHandler',
        
        initialize: function(map, lockY){
            this._map = map;
            this._target = map.getTouchTarget();
            
			this._swipeAccelAnchorX = [];
            this._swipeAccelAnchorY = [];
            this._swipeHistoryCount = 3;
			
            if (typeof lockY == 'undefined') 
                lockY = false;
            this._lockY = lockY;
            
        },
        
        getTouchTarget: function(){
            return this._target;
        },
        
        onTouch: function(touch){
            switch (touch.getAction()) {
                case touch.Action.Start:
                    NgLogD('action start sidescrollmap');
                    this._trackingId = touch.getId();
                    this._trackingCurrent = touch.getPosition();
					
					var yPos = this._trackingCurrent.getY();
                    this._isInYBounds = yPos >= this._map.getYScreenTopBounds() && yPos <= this._map.getYScreenBottomBounds();
					if (!this._isInYBounds) return;
					
					this._map.stopAllActions();
					
                    var local = this._map.getParent().screenToLocal(this._trackingCurrent);
                    var current = this._map.getPosition();
                    
                    //offset of the actual difference between the point of touch and the current position of tilemap
                    this._trackingOffset = new Core.Vector(current.getX() - local.getX(), current.getY() - local.getY());
                    
                    this._touchedObject = this._map.objectForTouch(touch);
                    if (this._touchedObject) {
                    
                    }
                    
					for (var i = 0; i < this._swipeHistoryCount; i++) {
                        this._swipeAccelAnchorX[i] = touch.getPosition().getX();
                        this._swipeAccelAnchorY[i] = touch.getPosition().getY();
                    }
					
                    this._moveCount = 0;
                    
                    return true;
                case touch.Action.End:
                    if (this._trackingId != touch.getId())  return;
					if (!this._isInYBounds) return;
					
                    this._trackingId = NaN;
                    
                    if (this._touchedObject) {
                        if (typeof this._touchedObject.touched != 'undefined') 
                            this._touchedObject.touched();
                    }
					else {
						this._moveCount++;
                        var mod = this._moveCount % this._swipeHistoryCount;
                        var swipeDistance = touch.getPosition().getX() - this._swipeAccelAnchorX[mod];
						
						var accelModPositon, accelDuration, easeOutRate;
                        if (Math.abs(swipeDistance) > Scale.droid.width(80)) {
                            accelModPosition = new Core.Vector(swipeDistance * 7, 0);
                            accelDuration = 1.5;
                            easeOutRate = 3;
                        }
                        else 
                            if (Math.abs(swipeDistance) > Scale.droid.width(20)) {
                                accelModPosition = new Core.Vector(swipeDistance * 4, 0);
                                accelDuration = 1;
                                easeOutRate = 2;
                            }
                            else {
                                accelModPosition = new Core.Vector(swipeDistance * 2, 0);
                                accelDuration = 0.3;
                                easeOutRate = 1;
                            }
                        
						
						var newX = accelModPosition.getX() + this._map.getPosition().getX();
						
						var halfWidth = this._map._width / 2;
						var minX = -halfWidth;
						var maxX = halfWidth;
						//NgLogD('minX:' + minX + ' maxX:' + maxX);
						
						if (newX > maxX) {
							this._map.moveTo(maxX, 0, 0.3);
						}
						else 
							if (newX < minX) {
								this._map.moveTo(minX, 0, 0.3);
							}
							else {
								this._map.moveByWithEaseOut(accelModPosition.getX(), 0, accelDuration, easeOutRate);
							}
					}
                    
                    break;
                case touch.Action.Move:
                    if (this._trackingId != touch.getId())  return;
					if (!this._isInYBounds) return;
					
                    if (this._moveCount < 7 && this._touchedObject && !(Math.abs(this._trackingCurrent.getX() - touch.getPosition().getX()) > Scale.droid.width(20))) {
                        this._moveCount++;
                        return;
                    }
                    
                    if (Math.abs(this._trackingCurrent.getX() - touch.getPosition().getX()) < Scale.droid.width(10) && this._touchedObject) {
                        return;
                    }
                    
                    //if it moved alot kill the touchedobject
                    this._touchedObject = null;
                    
                    
                    this._trackingCurrent = touch.getPosition();
                    var current = this._map.getParent().screenToLocal(this._trackingCurrent);
                    var offset = this._trackingOffset;
                    
					 this._moveCount++;
                    
                    var mod = this._moveCount % this._swipeHistoryCount;
                    this._swipeAccelAnchorX[mod] = touch.getPosition().getX();
                    this._swipeAccelAnchorY[mod] = touch.getPosition().getY();
					
                    if (this._lockY) {
						
						var newX = current.getX() + offset.getX();
						
						var halfWidth = this._map._width / 2;
						var minX = -halfWidth;
						var maxX = halfWidth;
						
						if (newX > maxX) newX = maxX;
						else if (newX < minX) newX = minX;
						
                        this._map.setPosition(newX, this._map.getPosition().getY());
                    }
                    
                    break;
            }
        }
    }),
    
    $MoveNodeTouchHandler: Core.MessageListener.subclass({
    
        classname: 'MoveNodeTouchHandler',
        
        initialize: function(map){
            this._map = map;
            this._target = map.getTouchTarget();
			this._trackingId = NaN;
            
            
        },
        
        getTouchTarget: function(){
            return this._target;
        },
        
        onTouch: function(touch){
            switch (touch.getAction()) {
                case touch.Action.Start:

					if (!isNaN(this._trackingId)) return false;

                    this._trackingId = touch.getId();
                    this._trackingCurrent = touch.getPosition();
                    this._trackingPrevious = touch.getPosition();
                    
                    var local = this._map.getParent().screenToLocal(this._trackingCurrent);
                    var current = this._map.getPosition();
                    
                    //offset of the actual difference between the point of touch and the current position of tilemap
                    this._trackingOffset = new Core.Vector(current.getX() - local.getX(), current.getY() - local.getY());
                    
                    this._unlockedNode = null;
                    var touchedNode = this._map.objectForTouch(touch);
                    
                    this._plotPositions = [];
                    //make sure there is a valid object.
                    if (touchedNode != null && typeof touchedNode.getState != 'undefined') {
                        if (touchedNode.getState() == StripObjectNode.State.UnlockedMounted && touchedNode.getParent() !== null) {
                            this._unlockedNode = touchedNode;
                            var local = this._unlockedNode.getParent().screenToLocal(this._trackingCurrent);
                            var current = this._unlockedNode.getPosition();
                            this._unlockedNodeOriginalPosition = current.clone();
                            //offset of the actual difference between the point of touch and the current position of tilemap
                            this._trackingOffset = new Core.Vector(current.getX() - local.getX(), current.getY() - local.getY());
                            
                            //take a snapshot of the positions
                            this._plotPositions = this._map.getCurrentPositions();
							
							//
							touchedNode.setState(StripObjectNode.State.UnlockedUnmounted);
                        }
                    }
                    
                    return true;
                case touch.Action.End:
                    if (this._trackingId != touch.getId()) 
                        return;
                    this._trackingId = NaN;
                    
                    if (this._unlockedNode != null) {
						//
						var n = this._unlockedNode;
                        this._map.snapNodeTo(this._unlockedNode, this._unlockedNode.getCurrentPlotID(), true, function() { n.setState(StripObjectNode.State.UnlockedMounted); });
                    }
                    
                    
                    
                    this._unlockedNode = null;
                    this._unlockedNodeOriginalPosition = null;
                    this._plotPositions = null;
                    
                    
                    
                    
                    break;
                case touch.Action.Move:
							
                    if (this._trackingId != touch.getId()) 
                        return;
                    
                    this._trackingCurrent = touch.getPosition();
					
					var newX;
					
                    if (!this._unlockedNode) {
                        var current = this._map.getParent().screenToLocal(this._trackingCurrent);
                        var offset = this._trackingOffset;
						newX = current.getX() + offset.getX();
                        //this._map.setPosition(current.getX() + offset.getX(), this._map.getPosition().getY());
                    }
                    else {
						
						
						
						//todo: tweak this.
						//checks if it is close to the edge.
						if (touch.getPosition().getX() < moveNodeEdgePixels) {
							newX = this._map.getPosition().getX() + Scale.droid.width(10) + this._edgeScrollModifier++;
							//this._map.setPosition(this._map.getPosition().getX() + Scale.droid.width(10) + this._edgeScrollModifier++, this._map.getPosition().getY());
						}

						//hacky to get it work in flash..
						else if (touch.getPosition().getX() > Math.max( Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenWidth() )- moveNodeEdgePixels) {
							newX = this._map.getPosition().getX() - Scale.droid.width(10) - this._edgeScrollModifier++;
							//this._map.setPosition(this._map.getPosition().getX() - Scale.droid.width(10) - this._edgeScrollModifier++, this._map.getPosition().getY());
						} else {
							this._edgeScrollModifier = 0;
						}				
						
                        var current = this._unlockedNode.getParent().screenToLocal(this._trackingCurrent);
                        var offset = this._trackingOffset;
                        
                        var newPosition = new Core.Point(current.getX() + offset.getX(), this._unlockedNode.getPosition().getY())
                        this._unlockedNode.setPosition(newPosition);
                        
                        //check if it has passed over another objects territory..
                        
                        //moving left ( - plotid)
                        if (this._trackingCurrent.getX() < this._trackingPrevious.getX()) {
                            this.swapNodesIfNeeded(this._unlockedNode, false);
                        }
                        //moving right ( + plot id)
                        else 
                            if (this._trackingCurrent.getX() > this._trackingPrevious.getX()) {
                                this.swapNodesIfNeeded(this._unlockedNode, true);
                            }
                    }
					
					if (newX) {
						var halfWidth = this._map._width / 2;
						var minX = -halfWidth;
						var maxX = halfWidth;
						
						if (newX > maxX) newX = maxX;
						else if (newX < minX) newX = minX;
						
                        this._map.setPosition(newX, this._map.getPosition().getY());
					}
                    
                    this._trackingPrevious = touch.getPosition();
                    
                    
                    break;
            }
        },
        
        swapNodesIfNeeded: function(node, right){
            if (this._plotPositions == null) 
                return;
            var positions = this._plotPositions;
            if (right) {
                for (var i = node.getCurrentPlotID() + 1; i < positions.length; i++) {
                    var p = positions[i];
                    if (node.getPosition().getX() > p.getX()) {
                        this._map.snapNodeTo(this._unlockedNode, i, false);
                        this._plotPositions = this._map.getCurrentPositions();
                    }
                    else {
                        return;
                    }
                }
            }
            else {
                for (var i = node.getCurrentPlotID() - 1; i >= 0; i--) {
                    var p = positions[i];
                    if (node.getPosition().getX() < p.getX()) {
                        this._map.snapNodeTo(this._unlockedNode, i, false);
                        this._plotPositions = this._map.getCurrentPositions();
                    }
                    else {
                        return;
                    }
                }
            }
        },
    }),
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Strip/StripMapBackground'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripMapBackground'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripMapBackground'] = exports; 
exports.StripMapBackground = Animation.AnimatedNode.subclass({
	
	classname: 'StripMapBackground',
	
	initialize: function() {
		
		this.layers = [];
		this.currentNumberBackgroundSprites = 0;
		this.previousNumberBackgroundSprites = 0;
	},
	
	addLayer: function(frame, depth, movePercent, displayOnce, blendEnabled) {
		
		if (typeof blendEnabled == 'undefined') blendEnabled = true;
		if (!depth) depth = 0;
		if (!movePercent) movePercent = 100;
		
		var layer = new this.Layer();
		layer.animationFrame = frame;
		layer.animation = new GL2.Animation();
		layer.animation.pushFrame(frame);
		layer.animation.setBlendEnabled(blendEnabled);
		layer.displayOnce = displayOnce;
		layer.setDepth(depth);
		layer.movePercent = movePercent;
		
		this.addChild(layer);
		this.layers.push(layer);
	},
	
	// we assume a [0.5, 0] anchor
	updateImages: function() {
		
		var numDiff = this.currentNumberBackgroundSprites - this.previousNumberBackgroundSprites;
		
		for (var i in this.layers) {
			
			var layer = this.layers[i];
			var frame = layer.animationFrame;
			var frameWidth = frame.getSize().getWidth();
			
			for (var j = 0; j < numDiff; j++) {
				
				var currNum = j + this.previousNumberBackgroundSprites;
				if (currNum > 0 && layer.displayOnce) break;
				
				var sprite = new GL2.Sprite();
//				var anim = new GL2.Animation();
//				anim.pushFrame(frame);
				//sprite.setAnimation(anim);
				sprite.setAnimation(layer.animation);
				sprite.setPosition(-frameWidth * currNum, 0);
				layer.addChild(sprite);
				
				if (currNum > 0) {
					sprite = new GL2.Sprite();
//					anim = new GL2.Animation();
//					anim.pushFrame(frame);
//					sprite.setAnimation(anim);
					sprite.setAnimation(layer.animation);
					sprite.setPosition(frameWidth * currNum, 0);
					layer.addChild(sprite);
				}
			}
		}
	},
	
	setCurrentNumberBackgroundSprites: function(number) {
		
		if (number > this.currentNumberBackgroundSprites) {
			this.previousNumberBackgroundSprites = this.currentNumberBackgroundSprites;
			this.currentNumberBackgroundSprites = number;
		}
	},
	
	setCurrentNumberBackgroundSpritesByMapWidth: function(width) {
		
		// assumption right now is all layers have same width
		var frameWidth = this.layers[0].animationFrame.getSize().getWidth();
		
		var fraction = width / frameWidth;
		var numSprites = Math.ceil(fraction);
		
		this.setCurrentNumberBackgroundSprites(numSprites);
	},
	
	// we assume a [0.5, 0] anchor
//	genAndAddFrameSprites: function(frame, layer) {
//		
//		var frameWidth = frame.getSize().getWidth();
//		
//		var sprite = new GL2.Sprite();
//		var anim = new GL2.Animation();
//		anim.pushFrame(frame);
//		sprite.setAnimation(anim);
//		layer.addChild(sprite);
//		
//		sprite = new GL2.Sprite();
//		anim = new GL2.Animation();
//		anim.pushFrame(frame);
//		sprite.setAnimation(anim);
//		sprite.setPosition(-frameWidth, 0);
//		layer.addChild(sprite);
//		
//		sprite = new GL2.Sprite();
//		anim = new GL2.Animation();
//		anim.pushFrame(frame);
//		sprite.setAnimation(anim);
//		sprite.setPosition(frameWidth, 0);
//		layer.addChild(sprite);
//	},
	
	getLayers: function() {
		return this.layers;
	},
	
	$Layer: Animation.AnimatedNode.subclass({
		
		initialize: function() {
			//this.movePercent
			//this.animationFrame
		},
		
	}),
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Strip/StripObjectBuildBlock'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripObjectBuildBlock'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Strip/StripObjectBuildBlock'] = exports; /**
 * @author will
 */
exports.StripObjectBuildBlock = Animation.AnimatedNode.subclass({
    initialize: function(template, delegate){
    
		// NOTE ALL SIZES ON GL2.TEXTS ARE SO THEY DONT DISAPPEAR AS IN SAMVS-27
		
		var thisBlock = this;
        var assetName = template.getAssetNames(SCGame.isNightTime)[0];
        
        this._template = template;
        this._delegate = delegate;
        
        this._id = template.getId();
		
		this._bg = AtlasMap.getSprite('build-item-bg.png', [0.5,0.5]);
		
        this._objImage = AtlasMap.getSprite(assetName, [0.5,1]);
        //this._objImage.setImage(assetName, template.getAssetSize(), [0.5, 1]);
		this._objImage.setScale([0.5, 0.5]);
		this._objImage.setPosition(0, Scale.droid.height(42));
		this._objImageNode = new Animation.AnimatedNode();
		this._objImageNode.addChild(this._objImage);
        
		var textWidthSize = Scale.droid.width(500);
		var textHeightSize = Scale.droid.height(50);
		
        this._cost = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        this._cost.setAnchor(1, 0.5);
        this._cost.setPosition(Scale.droid.width(141), Scale.droid.height(126));
		this._cost.getLabel().setColor(0,0,0);
		this._cost.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
		this._cost.setSize(new Core.Size(textWidthSize,textHeightSize));
		SCStyle.applyFontStyle(this._cost, SCStyle.FontStyle.SerifB16);		
        
		var buildFrame = AtlasMap.getAnimationFrame('build-item-button-buy-active.png',0, [0.5,0.5]);
		var buildFrameI = AtlasMap.getAnimationFrame('build-item-button-buy-inactive.png',0, [0.5,0.5]);
		this._buildItem = new Menu.AnimationFrameMenuItem();
		this._buildItem.setFrames(buildFrameI, buildFrame, buildFrame);
		this._buildItem.setAction(function() { thisBlock.buyStripObject(); });
		
		this._buildMenu = new Menu.Menu([this._buildItem]);
		this._buildMenu.setPosition(0, Scale.droid.height(130));
		
		var buildLabel = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
		buildLabel.setAnchor(0, 0.5);
		buildLabel.setPosition(Scale.droid.width(-142), Scale.droid.height(126));
		buildLabel.getLabel().setColor(0,0,0);
		buildLabel.setText('BUILD');
		buildLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		buildLabel.setSize(new Core.Size(textWidthSize,textHeightSize));
		SCStyle.applyFontStyle(buildLabel, SCStyle.FontStyle.SerifB16);		
		
		var incomeLabel = new GL2.Text();
		incomeLabel.setFontFamily('DroidSans-Regular');
		incomeLabel.setFontSize(32);
		incomeLabel.setAnchor(0 ,0.5);
		incomeLabel.setPosition(Scale.droid.width(-164), Scale.droid.height(74));
		incomeLabel.setColor(1,1,1);
		incomeLabel.setText("INCOME");
		incomeLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		incomeLabel.setSize(new Core.Size(textWidthSize,textHeightSize));
		SCStyle.applyFontStyle(incomeLabel, SCStyle.FontStyle.SansB16);		

		// if (SCGame.getSettings().getJapaneseOn()){
		// 	var incomeTextt = Util.numberFormat(template.getIncome()) + ' チップ / ' + Util.translateTime(template.getCollectTimeInterval(), null, true);
		// }		
		// else
			var incomeTextt = Util.dollarFormat(template.getIncome()) + ' / ' + Util.translateTime(template.getCollectTimeInterval(), null, true);
		var incomeText = new GL2.Text();
		incomeText.setFontFamily('DroidSans-Regular');
		incomeText.setFontSize(32);
		incomeText.setAnchor(1, 0.5);
		incomeText.setPosition(Scale.droid.width(164), Scale.droid.height(73));
		incomeText.setColor(1,1,1);
		incomeText.setText(incomeTextt);
		incomeText.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
		incomeText.setSize(new Core.Size(textWidthSize,textHeightSize));
		SCStyle.applyFontStyle(incomeText, SCStyle.FontStyle.Sans16);		
		
		var bonusLabel = new GL2.Text();
		bonusLabel.setFontFamily('DroidSans-Regular');
		bonusLabel.setFontSize(32);
		bonusLabel.setAnchor(0, 0.5);
		bonusLabel.setPosition(Scale.droid.width(-166), Scale.droid.height(98));
		bonusLabel.setColor(1,1,1);
		bonusLabel.setText("BONUS");
		bonusLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		bonusLabel.setSize(new Core.Size(textWidthSize,textHeightSize));
		SCStyle.applyFontStyle(bonusLabel, SCStyle.FontStyle.SansB16);	
		
		var bonusValueLabel = new GL2.Text();
		bonusValueLabel.setFontFamily('DroidSans-Regular');
		bonusValueLabel.setFontSize(32);
		bonusValueLabel.setAnchor(1, 0.5);
		bonusValueLabel.setPosition(Scale.droid.width(164), Scale.droid.height(97));
		bonusValueLabel.setColor(1,1,1);
		bonusValueLabel.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
		bonusValueLabel.setSize(new Core.Size(textWidthSize,textHeightSize));
		SCStyle.applyFontStyle(bonusValueLabel, SCStyle.FontStyle.Sans16);		
		if (template.hasMod()) {
			bonusValueLabel.setText(template.getMod().getDescription());	
		}
		else {
			bonusValueLabel.setText('None');		
		}
	
		this._logo = AtlasMap.getSprite(template.getLogoImageName(), [0,0]);
		this._logo.setPosition(Scale.droid.width(-170), Scale.droid.height(-160));
	
		this.infoMenuItem = new Menu.AnimationFrameMenuItem();
		this.infoMenuItem.setFrames(AtlasMap.getAnimationFrame('build-item-info-inactive.png',0,[1, 0]));
		this.infoMenuItem.setAction(function() { thisBlock.infoButtonToggle(); });
		
		this.infoMenuItem2 = new Menu.AnimationFrameMenuItem();
		this.infoMenuItem2.setFrames(AtlasMap.getAnimationFrame('build-item-info-active.png',0,[1, 0]));
		this.infoMenuItem2.setAction(function() { thisBlock.infoButtonToggle(); });
		this.infoMenuItem2.setVisible(false);
		this.infoMenuItem2.setEnabled(false);
		
		var infoMenu = new Menu.Menu([this.infoMenuItem, this.infoMenuItem2], true);
		infoMenu.setPosition(Scale.droid.width(184), Scale.droid.height(-170));
		
		this._infoText = new GL2.Text();
		this._infoText.setFontFamily('DroidSans-Regular');
		this._infoText.setFontSize(32);
		this._infoText.setAnchor(0, 0);
        this._infoText.setPosition(Scale.droid.width(-150), Scale.droid.height(-80));
        this._infoText.setColor(1, 1, 1);
		this._infoText.setOverflowMode(GL2.Text.OverflowMode.Multiline);
		this._infoText.setHorizontalAlign(GL2.Text.HorizontalAlign.Left);
		this._infoText.setVerticalAlign(GL2.Text.VerticalAlign.Top);
		this._infoText.setSize(new Core.Size(Scale.droid.width(685), Util.screenSize(true).getHeight()));
		SCStyle.applyFontStyle(this._infoText, SCStyle.FontStyle.Sans14);		
		
		this._nameText = new GL2.Text();
		this._nameText.setFontFamily('DroidSans-Regular');
		this._nameText.setFontSize(32);
		this._nameText.setPosition(0, Scale.droid.height(-120));
		this._nameText.setColor(1,1,1);
		this._nameText.setSize(new Core.Size(textWidthSize,textHeightSize));
		// if( SCGame.getSettings().getJapaneseOn()){
		//       SCStyle.applyFontStyle(this._nameText, SCStyle.FontStyle.Sans22);  
		// }else{
      SCStyle.applyFontStyle(this._nameText, SCStyle.FontStyle.Sans32);
	  // }
		
		var infoTextLine = AtlasMap.getSprite('build-item-line.png', [0.5,0.5]);
		infoTextLine.setPosition(0, Scale.droid.height(-88));
		
		this._infoText.setText(template.getInfoText());
		this._nameText.setText(template.getName());
		this._infoTextNode = new Animation.AnimatedNode();
		this._infoTextNode.addChild(this._infoText);
		this._infoTextNode.addChild(this._nameText);
		this._infoTextNode.addChild(infoTextLine);
		this._infoTextNode.setVisible(false);
		
		this.addChild(this._bg);
        //this.addChild(this._objImage); this._objImage.setDepth(1);
		this.addChild(this._objImageNode); this._objImageNode.setDepth(1);
		this.addChild(this._logo); this._logo.setDepth(1);
		this.addChild(this._buildMenu); this._buildMenu.setDepth(2);
        this.addChild(this._cost); this._cost.setDepth(2);
		//this.addChild(this._infoText); this._infoText.setDepth(2);
		this.addChild(this._infoTextNode); this._infoTextNode.setDepth(2);
		this.addChild(buildLabel); buildLabel.setDepth(2);
		this.addChild(incomeLabel); incomeLabel.setDepth(2);
		this.addChild(incomeText); incomeText.setDepth(2);
		this.addChild(bonusLabel); bonusLabel.setDepth(2);
		this.addChild(bonusValueLabel); bonusValueLabel.setDepth(2);
		this.addChild(infoMenu); infoMenu.setDepth(2);
        
        this.setEligibilityType (this.EligibilityType.Unknown);
        
        
    },
    
    EligibilityType: {
        /** Isometric. */
		Unknown: 0,
        Eligible: 1,
        NotEnoughChips: 2,
        NotEnoughLevels: 3,
		NotEnoughComps: 4,
		TemplateLimitReached: 5,
    },
    
    setEligibilityType: function(t){
		
        if (this._eligibilityType == t) 
            return;
			
		var chipCost = this._template.getCost();
		var compCost = this._template.getCompCost();	
			
		this._elibilityType = t;	
		switch (this._elibilityType) {
			case this.EligibilityType.Eligible:
				this._canBuy = true;
				this._buildItem.setEnabled(true);
				//this.infoMenuItem.setEnabled(true);
				
//				if (this._disableOverlay) {
//					this._disableOverlay.destroy();
//					this._disableOverlay = null;
//				}
				
				break;
			default:
				this._canBuy = false;
				this._buildItem.setEnabled(false);
				//this.infoMenuItem.setEnabled(false);
				
//				if (!this._disableOverlay) {
//					
////					this._disableOverlay = new GL2.Sprite();
////					var anim = new GL2.Animation();
////					anim.pushFrame(new GL2.Animation.Frame('Content/G6/black.png', 0, [1, 1], [0.5, 0.5]));
////					this._disableOverlay.setAnimation(anim);
////					this._disableOverlay.setScale(Scale.droid.width(385), Scale.droid.height(351));
////					this._disableOverlay.setDepth(4);
////					this._disableOverlay.setAlpha(0.5);
//					this._disableOverlay = AtlasMap.getSprite('build-item-bg-unavailable.png');
//					this._disableOverlay.setDepth(4);
//					this._disableOverlay.setPosition(0, -8);
//					this.addChild(this._disableOverlay);
//				}
				
				break;
		}
		
        switch (this._elibilityType) {
            case this.EligibilityType.Eligible:
			
				if (chipCost > 0)
       				this._cost.setText('' + Util.numberFormat(this._template.getCost()) + ' Chips');
				else
					this._cost.setText(Util.numberFormat(compCost) + ' Comps');				
                break;
				
            case this.EligibilityType.NotEnoughChips:
        		this._cost.setText('' + Util.numberFormat(this._template.getCost())+ ' Chips');		
                break;
				
			case this.EligibilityType.NotEnoughComps:
				this._cost.setText(Util.numberFormat(compCost) + ' Comps');	
				break;	
			
			case this.EligibilityType.TemplateLimitReached:
				this._cost.setText('Limit One Only');
				break;
			
            case this.EligibilityType.NotEnoughLevels:
				//todo: exp lock
                break;		
										
            default:
                break;
        }
    },
    
    
    getSize: function(){
        return this._bg._animation.getFrame(0).getSize();
    },
    
    getAnchor: function(){
        return this._bg._animation.getFrame(0).getAnchor();
    },
    
    getTemplate: function() {
		return this._template;
	},
    
    getId: function(){
        return this._id;
    },
    
    refresh: function(playerChips, playerComps, playerLevel){
        NgLogD(playerChips + ":" + playerComps + ":" + playerLevel);
		
		var chipCost = this._template.getCost();
		var compCost = this._template.getCompCost();
		var costChips = chipCost > 0;
		var costComps = compCost > 0;
		
		//todo: level requirement?
		if (SCGame.hasStripReachedStripObjectTemplateLimit(this._template)) {
			this.setEligibilityType(this.EligibilityType.TemplateLimitReached);	
		}
		else if (costChips && playerChips < chipCost) {
			this.setEligibilityType(this.EligibilityType.NotEnoughChips);
		}
		else if (costComps && playerComps < compCost) {
			this.setEligibilityType(this.EligibilityType.NotEnoughComps);
		}
		else {
			this.setEligibilityType(this.EligibilityType.Eligible);
		}
    },
    
	infoButtonToggle: function() {
		
		if (this._objImageNode.getAlpha() >= 1) {
			
			this.infoMenuItem.setVisible(false);
			this.infoMenuItem.setEnabled(false);
			this.infoMenuItem2.setVisible(true);
			this.infoMenuItem2.setEnabled(true);
			
			var node = this._objImageNode;
            this._objImageNode.runSequence(0.5, function(){
                node.fadeTo(0, 0.5);
            },
			0, function() { node.setVisible(false);}
			);
			
			
			this._infoTextNode.setVisible(true);
			this._infoTextNode.fadeTo(1,0.5);
		}
		else if (this._infoTextNode.getAlpha() >= 1) {
			
			this.infoMenuItem2.setVisible(false);
			this.infoMenuItem2.setEnabled(false);
			this.infoMenuItem.setVisible(true);
			this.infoMenuItem.setEnabled(true);
			
			this._objImageNode.fadeTo(1,0.5);
			this._objImageNode.setVisible(true);

			
			var node = this._infoTextNode;

            this._infoTextNode.runSequence(0.5, function(){
                node.fadeTo(0, 0.5);
            },
			0, function() { node.setVisible(false);}
			);			

		}
	},
	
    //purchase...
    touched: function(){

        //NgLogD('touched block..');
        //this.buyStripObject();
    },
    
    buyStripObject: function(){
    	if (!this._canBuy) return;		
        this._delegate.stripObjectBuy(this._template);
        
    },



});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/IAP/IAPBlock'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/IAP/IAPBlock'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/IAP/IAPBlock'] = exports; /**
 * @author will
 */
//because this anchor point is in the middle
var midPoint = 0;
var buttonY = 130;

exports.IAPBlock = GL2.Node.subclass({

    classname: 'IAPBlock',
    
    initialize: function(iap, delegate){
    
        // NOTE ALL SIZES ON GL2.TEXTS ARE SO THEY DONT DISAPPEAR AS IN SAMVS-27
        
        var thisBlock = this;
        
        var textWidthSize = Scale.droid.width(400);
        var textHeightSize = Scale.droid.height(50);
        //        var assetName = template.getAssetName();
        
        this._iap = iap;
        this._delegate = delegate;
        
        this._id = iap.getID();
        
        this._bg = AtlasMap.getSprite('bank-item-bg.png', [0.5, 0.5], undefined, true);
        
        NgLogD(iap.getAssetName());
        this._objImage = AtlasMap.getSprite(iap.getAssetName());
        this._objImage.setPosition(0, -50);
        
        this._name = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        this._name.setAnchor(0.5, 0.5);
        this._name.setPosition(Scale.droid.width(midPoint), Scale.droid.height(76));
        this._name.setText(iap.getName());
        //this._name.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
        this._name.setSize(new Core.Size(textWidthSize, textHeightSize));
        SCStyle.applyFontStyle(this._name, SCStyle.FontStyle.SerifB20);
        
        
        //        this._cost = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        //        this._cost.setAnchor(1, 0.5);
        //        this._cost.setPosition(Scale.droid.width(46), Scale.droid.height(buttonY));
        //        this._cost.getLabel().setColor(0, 0, 0);
        //        this._cost.setFontSize(16);
        //		this._cost.setText(Util.dollarFormat(iap.getPrice()));
        //        this._cost.setFontFamily('DroidSerif-Regular');
        
        this._description = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        this._description.setAnchor(0.5, 0.5);
        this._description.setPosition(Scale.droid.width(midPoint), Scale.droid.height(101));
        this._description.setText(iap.getShortDescription());
        //this._description.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
        this._description.setSize(new Core.Size(textWidthSize, textHeightSize));
        SCStyle.applyFontStyle(this._description, SCStyle.FontStyle.Sans16);
        
        var buildFrame = AtlasMap.getAnimationFrame('bank-item-button-active.png', 0, [0.5, 0.5], undefined, true);
        var buildFrameI = AtlasMap.getAnimationFrame('bank-item-button-inactive.png', 0, [0.5, 0.5], undefined, true);
        this.buildItem = new Menu.AnimationFrameMenuItem();
        this.buildItem.setFrames(buildFrameI, buildFrame, buildFrame);
        this.buildItem.setAction(function(){
        
            thisBlock.buyIAP();
        });
        
        this._buildMenu = new Menu.Menu([this.buildItem]);
        this._buildMenu.setPosition(0, Scale.droid.height(buttonY + 7));
        
        
        this._buyText = new TextWithShadow(TextWithShadow.ShadowType.WhiteSoftShadow);
        this._buyText.setAnchor(0.5, 0.5);
        this._buyText.setPosition(Scale.droid.width(0), Scale.droid.height(buttonY + 3));
        //this._buyText.setHorizontalAlign(GL2.Text.HorizontalAlign.Right);
        this._buyText.setSize(new Core.Size(textWidthSize, textHeightSize));
        SCStyle.applyFontStyle(this._buyText, SCStyle.FontStyle.SerifB16);
		
        if (this._iap.getType() == Game.IAP.IAP.Type.LimitsIAP && this._iap.classname == Game.IAP.Limit.classname) {
            SCStyle.applyFontStyle(this._buyText, SCStyle.FontStyle.SerifB12);
            this._buyText.setText('BUY for ' + this._iap.getCompCost() + ' COMPS');
        }
        else {
            this._buyText.setText('BUY');
        }
        
        this._buyText.getLabel().setColor(0, 0, 0);
        
        //		
        //		var incomeLabel = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        //		incomeLabel.setAnchor(0 ,0.5);
        //		incomeLabel.setPosition(Scale.droid.width(-150), Scale.droid.height(71));
        //		incomeLabel.setColor(1,1,1);
        //		incomeLabel.setText("INCOME");
        //		
        //		var incomeTextt = Util.dollarFormat(template.getIncome()) + ' / ' + Util.translateTime(template.getCollectTimeInterval(), null, true);
        //		var incomeText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        //		incomeText.setAnchor(1, 0.5);
        //		incomeText.setPosition(Scale.droid.width(155), Scale.droid.height(71));
        //		incomeText.setColor(1,1,1);
        //		incomeText.setText(incomeTextt);
        //		
        //		var bonusLabel = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        //		bonusLabel.setAnchor(0, 0.5);
        //		bonusLabel.setPosition(Scale.droid.width(-150), Scale.droid.height(96));
        //		bonusLabel.setColor(1,1,1);
        //		bonusLabel.setText("BONUS");
        //		
        //		var bonusValueLabel = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        //		bonusValueLabel.setAnchor(0, 0.5);
        //		bonusValueLabel.setPosition(0, Scale.droid.height(96));
        //		bonusValueLabel.setColor(1,1,1);
        //		if (template.hasMod()) {
        //			bonusValueLabel.setText(template.getMod().getDescription());	
        //		}
        //		else {
        //			bonusValueLabel.setText('None.');		
        //		}
        
        
        this.addChild(this._bg);
        
        this.addChild(this._objImage);
        this._objImage.setDepth(1);
        this.addChild(this._buildMenu);
        this._buildMenu.setDepth(2);
        this.addChild(this._name);
        this._name.setDepth(2);
        this.addChild(this._description);
        this._description.setDepth(2);
        //        //        this.addChild(this._cost);
        //        //        this._cost.setDepth(2);
        //        
        this.addChild(this._buyText);
        this._buyText.setDepth(2);
        
        //		this.addChild(incomeLabel); incomeLabel.setDepth(2);
        //		this.addChild(incomeText); incomeText.setDepth(2);
        //		this.addChild(bonusLabel); bonusLabel.setDepth(2);
        //		this.addChild(bonusValueLabel); bonusValueLabel.setDepth(2);
    
    
    
    
    },
    
    getId: function(){
        return this._id;
    },
    
    getSize: function(){
        return this._bg._animation.getFrame(0).getSize();
    },
    
    getIAP: function(){
        return this._iap;
    },
    
    getAnchor: function(){
        return this._bg._animation.getFrame(0).getAnchor();
    },
    
    buyIAP: function(){
        if (!IAPManager.getInTransaction()) {
        
            if (this.getIAP().getType() == Game.IAP.IAP.Type.LimitsIAP) {
                SCGame.raiseLimit(this.getIAP(), this);
            }
            else {
                IAPManager.buyIAP(this.getIAP());
            }
        }
    },
    
    setEnabled: function(enable){
        this.buildItem.setEnabled(enable);
        if (enable) {
            this.setColor(1, 1, 1);
        }
        else {
            this.setColor(0.7, 0.7, 0.7);
        }
    },

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/Deck'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Deck'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Deck'] = exports; /**
 * @author raymondlo
 */

var Card = require('Code/StripCity/Game/CardGame/Card').Card;
 
exports.Deck = Core.Class.subclass( 
{
	classname: 'Deck',
	
	initialize: function()
	{
		this.shuffle();
	},
	
	shuffle: function() {
		this.deck = new Array();
		for (var x = 0; x < 52; x++) {
			var number = (x % 13) + 1;
			var suit = parseInt(x / 13);
			this.deck.push(new Card(x,number,suit));
		}
		this.shuffleArray(this.deck);
	},
	
	shuffleArray: function(myArray) {
		var i = myArray.length;
		if ( i == 0 ) return false;
		while ( --i ) {
			var j = Math.floor( Math.random() * ( i + 1 ) );
			var tempi = myArray[i];
			var tempj = myArray[j];
			myArray[i] = tempj;
			myArray[j] = tempi;
		}
	},
	
	getDeck: function()
	{
		return this.deck;
	},
	
	getCard: function() 
	{
		//var randomPos = Math.floor(Math.random()*this.deck.length);
		//return this.deck.splice(randomPos,1);
		return this.deck.pop();
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/Card'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Card'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Card'] = exports; /**
 * @author raymondlo
 */

exports.Card = Core.Class.subclass( 
{
	classname: 'Card',
	
	initialize: function(id, number, suit) 
	{	
		this.id = id;
		this.number = number;
		this.suit = suit;
		this.xlocation = 0;
		this.ylocation = 0;
		this.faceup = false;
		this.util = new Util();
		var a = new GL2.Animation();
		a.pushFrame(AtlasMap.getAnimationFrame('card-o-back.png'));
		//a.pushFrame(new GL2.Animation.Frame('Content/cards.png', 0, [Scale.droid.width(64), Scale.droid.height(64)], [0.5, 0.5], [2/13, 4/5, 1/13, 1/5]));

        
	    var t = 10;
		this._node = new GL2.Node();
		this._node.setPosition(this.xlocation,this.ylocation );
	
		
		// Create body.
		this._sprite = new GL2.Sprite();
		
		this._sprite.setAnimation(a, t);
		this._node.addChild(this._sprite);
		
	},
	
	setCard:function(number,suit)
	{
		
		this._Card=a;
		return this._Card;
	},
	
	getNumber: function() 
	{
		return this.number;
	},
	
	getSuit: function() 
	{
		return this.suit;
	},
	
	setNumber: function(number)
	{
		this.number = number;
	},
	
	setSuit: function(suit)
	{
		this.suit = suit;
	},
	
	isFaceUp:function()
	{
		return this.faceup;
	},
	
	getCardFrameName: function() {
		
		var suitChar;
		switch (this.suit) {
			
			case 0: suitChar = 'c'; break;
			case 1: suitChar = 'd'; break;
			case 2: suitChar = 'h'; break;
			case 3: suitChar = 's'; break;
			default:
				// this is some other card, probably joker 
				return 'card-o-joker.png';
		}
		
		var numberChar;
		switch (this.number) {
			
			case 1: numberChar = 'a'; break;
			case 11: numberChar = 'j'; break;
			case 12: numberChar = 'q'; break;
			case 13: numberChar = 'k'; break;
			default: numberChar = '' + this.number; break;
		}
		
		return 'card-' + suitChar + '-' + numberChar + '.png'; 
	},
	
	setFaceup:function()
	{
		var a = new GL2.Animation();
		a.setLoopingEnabled(false);
		
		var backFrame = AtlasMap.getAnimationFrame('card-o-back.png', 220);
		a.pushFrame(backFrame);
		a.pushFrame(AtlasMap.getAnimationFrame('card-o-back.png', 80, [0.5,0.5], [Scale.droid.width(15), backFrame.getSize().getHeight()]));
		a.pushFrame(AtlasMap.getAnimationFrame(this.getCardFrameName(), 1000));
		//a.pushFrame(new GL2.Animation.Frame('Content/cards.png', 220, [Scale.droid.width(64), Scale.droid.height(64)], [0.5, 0.5], [2/13, 4/5, 1/13, 1/5]));
		//a.pushFrame(new GL2.Animation.Frame('Content/cards.png', 80, [Scale.droid.width(15), Scale.droid.height(64)], [0.5, 0.5], [2/13, 4/5, 1/13, 1/5]));
		//a.pushFrame(new GL2.Animation.Frame('Content/cards.png', 1000, [Scale.droid.width(64), Scale.droid.height(64)], [0.5, 0.5], [(this.number-1)/13, this.suit/5, 1/13, 1/5]));
		this._sprite.setAnimation(a,0);
		this.faceup = true;

	},
	
	setFacedown:function()
	{
		var a = new GL2.Animation();
		a.pushFrame(AtlasMap.getAnimationFrame('card-o-back.png'));
		this._sprite.setAnimation(a,0);
		this.faceup = false;
	},
	
	destroy: function()
	{
		this._shadow.destroy();
		this._body.destroy();
		this._node.destroy();
	},
	
	setPosition: function(x, y)
	{
		this._node.setPosition(x, y);
		this.xlocation = x;
		this.ylocation = y;
	},
	
	getPosition: function() {
		return this._node.getPosition();
	},
	
	showPosition: function()
	{
		return this.xlocation +','+ this.ylocation;
	},
	getNode: function()
	{
		return this._node;
	},
	
	
	onUpdate: function()
	{
		if(this._trackingId)
		{
			var current = this._node.getParent().screenToLocal(this._trackingCurrent);
			var offset = this._trackingOffset;
			this._node.setPosition(current.getX() + offset.getX(), current.getY() + offset.getY());
			return;
		}
		
		var p = this._node.getPosition();
		
		var halfWidth = Core.Capabilities.getScreenWidth()/2;
		var halfHeight = Core.Capabilities.getScreenHeight()/2;
		
		if(p.getX() < -halfWidth)
		{
			p.setX(-halfWidth);
			this._vx = - this._vx;
		}
		if(p.getX() > halfWidth)
		{
			p.setX(halfWidth);
			this._vx = -this._vx;
		}
		if(p.getY() < -halfHeight)
		{
			p.setY(-halfHeight);
			this._vy = - this._vy;
		}
		if(p.getY() > halfHeight)
		{
			p.setY(halfHeight);
			this._vy = -this._vy;
		}
		this._node.setPosition(p);
	},
	
	destroy: function()
	{
		this._node.destroy();
	},
	
	getSprite: function() {
		return this._sprite;
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/Hand'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Hand'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Hand'] = exports; /**
 * @author raymondlo
 */
 
exports.Hand = Core.Class.subclass( 
{
	classname: 'Hand',
	
	initialize: function(id, number, suit) 
	{	
		this.hasPair = false;
		this.hasTwoPairs = false;
		this.hasTrips = false;
		this.hasQuads = false;
		this.hasStraight = false;
		this.hasFlush = false;
	},
	
	checkHand: function(cards)
	{
		if (cards.length > 0) {
			cards.sort(function(a) { return a.number; });
			for (var x = 0; x < cards.length; cards++) {
				
			}
		}
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/Chips'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Chips'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Chips'] = exports; 
exports.Chips = Core.Class.subclass( 
{
	classname: 'Chips',
	
	initialize: function(amt, xloc, yloc) 
	{	
		this.amt = amt;
		this.xlocation = xloc;
		this.ylocation = yloc;
		this.chiparray = new Array();

		this._node = new Animation.AnimatedNode();
		this._node.setPosition(this.xlocation,this.ylocation );
		
		this.showChips();
			
	},

	setAmount:function(amt){
		this.amt = amt;
		this.showChips();
	},

	showChips:function(){
		var Bet1 = 0;
		var Bet5 = 0;
		var Bet25 = 0;
		var Bet100 = 0;
		var Bet500 = 0;
		var Bet1000 = 0;
		var Bet5000 = 0;
		var Bet10000 = 0;		
		var Bet100000 = 0;
				
		if (this.chiparray.length > 0)
		{
		  for (var x = 0; x < this.chiparray.length; x++) {
           	this.chiparray[x].destroy();
		 	}
		this.chiparray.length = 0;	

		}
		
		
		var chipcount = this.amt;
		
		Bet100000 = Math.floor(chipcount / 100000);
		chipcount = chipcount % 100000;		
		Bet10000 = Math.floor(chipcount / 10000);
		chipcount = chipcount % 10000;		
		Bet5000 = Math.floor(chipcount / 5000);
		chipcount = chipcount % 5000;		
		Bet1000 = Math.floor(chipcount / 1000);
		chipcount = chipcount % 1000;		
		Bet500 = Math.floor(chipcount / 500);
		chipcount = chipcount % 500;		
		Bet100 = Math.floor(chipcount / 100);
		chipcount = chipcount % 100;		
		Bet25 = Math.floor(chipcount / 25);
		chipcount = chipcount % 25;
		Bet5 = Math.floor(chipcount / 5);
		chipcount = chipcount % 5;
		Bet1 = chipcount;
		
		var height100000 = 0;
		var height10000 = 0;
		var height5000 = 0;
		var height1000 = 0;
		var height500 = 0;
		var height100 = 0;
		var height25 = 0;
		var height5 = 0;
		

		for (var x = 1; x <= Bet100000; x++) {
		var chipnode = new GL2.Node();
		chipnode.setPosition(0,-(Scale.droid.height(7)*x) );
		var a = new GL2.Animation();
		
		a.pushFrame(AtlasMap.getAnimationFrame('chip_100000.png', 0, [0.5,0.5]));
		var sprite = new GL2.Sprite();
		sprite.setAnimation(a);
		chipnode.addChild(sprite);	
		sprite.setDepth(this.chiparray.length+1);
		this.chiparray.push(chipnode);
		this._node.addChild(chipnode);
		height10000 = Scale.droid.height(7)*x;
		}


		for (var x = 1; x <= Bet10000; x++) {
		var chipnode = new GL2.Node();
		chipnode.setPosition(0,-(Scale.droid.height(7)*x) - height100000 );
		var a = new GL2.Animation();
		
		a.pushFrame(AtlasMap.getAnimationFrame('chip_10000.png', 0, [0.5,0.5]));
		var sprite = new GL2.Sprite();
		sprite.setAnimation(a);
		chipnode.addChild(sprite);	
		sprite.setDepth(this.chiparray.length+1);
		this.chiparray.push(chipnode);
		this._node.addChild(chipnode);
		height10000 = Scale.droid.height(7)*x;
		}



		for (var x = 1; x <= Bet5000; x++) {
		var chipnode = new GL2.Node();
		chipnode.setPosition(0,-(Scale.droid.height(7)*x) - height100000 - height10000  );
		var a = new GL2.Animation();
		
		a.pushFrame(AtlasMap.getAnimationFrame('chip_5000.png', 0, [0.5,0.5]));
		var sprite = new GL2.Sprite();
		sprite.setAnimation(a);
		chipnode.addChild(sprite);	
		sprite.setDepth(this.chiparray.length+1);
		this.chiparray.push(chipnode);
		this._node.addChild(chipnode);
		height5000 = Scale.droid.height(7)*x;
		}


		for (var x = 1; x <= Bet1000; x++) {
		var chipnode = new GL2.Node();
		chipnode.setPosition(0,-(Scale.droid.height(7)*x) - height100000 - height10000 - height5000  );
		var a = new GL2.Animation();
		
		//a.pushFrame(new GL2.Animation.Frame('Content/Bet1000.png', 0, [Scale.droid.width(64), Scale.droid.height(64)], [0.5, 0.5], [0,0,1,1]));
		a.pushFrame(AtlasMap.getAnimationFrame('chip_1000.png', 0, [0.5,0.5]));
		var sprite = new GL2.Sprite();
		sprite.setAnimation(a);
		chipnode.addChild(sprite);	
		sprite.setDepth(this.chiparray.length+1);
		this.chiparray.push(chipnode);
		this._node.addChild(chipnode);
		height1000 = Scale.droid.height(7)*x;
		}

		for (var x = 1; x <= Bet500; x++) {
		var chipnode = new GL2.Node();
		chipnode.setPosition(0,-(Scale.droid.height(7)*x) - height100000 - height10000 - height5000 - height1000);
		var a = new GL2.Animation();
		
		//a.pushFrame(new GL2.Animation.Frame('Content/Bet500.png', 0, [Scale.droid.width(64), Scale.droid.height(64)], [0.5, 0.5], [0,0,1,1]));
		a.pushFrame(AtlasMap.getAnimationFrame('chip_500.png', 0, [0.5,0.5]));
		var sprite = new GL2.Sprite();
		sprite.setAnimation(a);
		chipnode.addChild(sprite);	
		sprite.setDepth(this.chiparray.length+1);
		this.chiparray.push(chipnode);
		this._node.addChild(chipnode);
		height500 = Scale.droid.height(7)*x;
		}
		
		for (var x = 1; x <= Bet100; x++) {
		var chipnode = new GL2.Node();
		chipnode.setPosition(0,-(Scale.droid.height(7)*x) - height100000 - height10000 - height5000 - height1000 - height500 );
		var a = new GL2.Animation();
		
		//a.pushFrame(new GL2.Animation.Frame('Content/Bet100.png', 0, [Scale.droid.width(64), Scale.droid.height(64)], [0.5, 0.5], [0,0,1,1]));
		a.pushFrame(AtlasMap.getAnimationFrame('chip_100.png', 0, [0.5,0.5]));
		var sprite = new GL2.Sprite();
		sprite.setAnimation(a);
		chipnode.addChild(sprite);	
		sprite.setDepth(this.chiparray.length+1);
		this.chiparray.push(chipnode);
		this._node.addChild(chipnode);
		height100 = Scale.droid.height(7)*x;
		}

		for (var x = 1; x <= Bet25; x++) {
		var chipnode = new GL2.Node();
		chipnode.setPosition(0,-(Scale.droid.height(7)*x) - height100000 - height10000 - height5000 - height1000 - height500 - height100 );
		var a = new GL2.Animation();
		
		//a.pushFrame(new GL2.Animation.Frame('Content/Bet25.png', 0, [Scale.droid.width(64), Scale.droid.height(64)], [0.5, 0.5], [0,0,1,1]));
		a.pushFrame(AtlasMap.getAnimationFrame('chip_25.png', 0, [0.5,0.5]));
		var sprite = new GL2.Sprite();
		sprite.setAnimation(a);
		chipnode.addChild(sprite);	
		sprite.setDepth(this.chiparray.length+1);
		this.chiparray.push(chipnode);
		this._node.addChild(chipnode);
		height25 = Scale.droid.height(7)*x;
		}
		
		for (var x = 1; x <= Bet5; x++) {
		var chipnode = new GL2.Node();
		chipnode.setPosition(0, -(Scale.droid.height(7)*x) - height100000 - height10000 - height5000 - height1000 - height500 - height100 - height25  );
		var a = new GL2.Animation();
		
		//a.pushFrame(new GL2.Animation.Frame('Content/Bet5.png', 0, [Scale.droid.width(64), Scale.droid.height(64)], [0.5, 0.5], [0,0,1,1]));
		a.pushFrame(AtlasMap.getAnimationFrame('chip_5.png', 0, [0.5,0.5]));
		var sprite = new GL2.Sprite();
		sprite.setAnimation(a);
		chipnode.addChild(sprite);	
		sprite.setDepth(this.chiparray.length+1);

		this.chiparray.push(chipnode);
		this._node.addChild(chipnode);
		height5 = Scale.droid.height(7)*x;
		}
			
		for (var x = 1; x <= Bet1; x++) {
		var chipnode = new GL2.Node();
		chipnode.setPosition(0, -(Scale.droid.height(7)*x) - height100000 - height10000 - height5000 - height1000 - height500 - height100 - height25 - height5);
		var a = new GL2.Animation();
		
		//a.pushFrame(new GL2.Animation.Frame('Content/Bet1.png', 0, [Scale.droid.width(64), Scale.droid.height(64)], [0.5, 0.5], [0,0,1,1]));
		a.pushFrame(AtlasMap.getAnimationFrame('chip_1.png', 0, [0.5,0.5]));
		var sprite = new GL2.Sprite();
		sprite.setAnimation(a);
		chipnode.addChild(sprite);	
		sprite.setDepth(this.chiparray.length+1);

		this.chiparray.push(chipnode);
		this._node.addChild(chipnode);

		}
		
//		this.displayamount.setText(''+this.amt);
		
	},
	
	destroy: function() {
		for (var i = 0; i < this._node._children.length; i++) {
			if (typeof this._node._children[i].durable === 'undefined')
				this._node._children[i].destroy();
			else if (this._node._children[i].durable == 0)	
				this._node._children[i].destroy();
		}
		this._node.destroy();
	},
	
	setPosition: function(x, y)
	{
		this._node.setPosition(x, y);
		this.xlocation = x;
		this.ylocation = y;
	},
	
	showPosition: function()
	{
		return this.xlocation +','+ this.ylocation;
	},

	getNode: function()
	{
		return this._node;
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/BJHand'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/BJHand'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/BJHand'] = exports; /**
 * @author George
 */


exports.BJHand = Core.Class.subclass({
    classname: 'BJHand',
	

    
    initialize: function(xloc, yloc){
        this.total = 0;
        this.cards = new Array();
        this.xlocation = xloc;
        this.ylocation = yloc;
		this.canhit = false;
		this.isDouble = false;
		this.winvaluemultiple = 1;       
		this.isSmall = false;
    },
    
	setCanHit:function(b)
	{
		this.canhit = b;
		
	},
	
	canHit: function()
	{
		return this.canhit;
	},
	
	setDoubleDown: function()
	{
		this.winvaluemultiple = 2;
		this.isDouble = true;		
		
	},
	
	setBlackJack: function()
	{
		this.winvaluemultiple = 1.5;		
	},
	
	winValue: function()
	{
		return this.winvaluemultiple;		
		
	},
	
	numberOfCards:function()
	{
		return	this.cards.length;
		
	},
	
    addCard: function(card){
		SCGame.getSCAudio().playsound(6); 
        card.setPosition(Scale.droid.width(400), Scale.droid.height(-30));
		card.getSprite().setDepth(this.cards.length);
        this.cards.push(card);
		
		var updateListener = new this.AnimatedCardUpdateListener(card, this.xlocation + (Scale.droid.width(35) * (this.cards.length-1)), this.ylocation);
        Core.UpdateEmitter.addListener(updateListener, updateListener.onUpdate);
        
    },
	
	addSplitCard: function(card) {
		card.getSprite().setDepth(this.cards.length);
		this.cards.push(card);
		
		var updateListener = new this.AnimatedCardUpdateListener(card, this.xlocation + (Scale.droid.width(35) * (this.cards.length-1)), this.ylocation);
        Core.UpdateEmitter.addListener(updateListener, updateListener.onUpdate);
	},
	
	moveBy: function(xLoc, yLoc) {
		var moveExtra = 0;
		for (var x = 0; x < this.cards.length; x++) {
			if (this.isSmall) {
				moveExtra = 14 * x;
				if (xLoc < 0) moveExtra *= -1;
			}
			var updateListener = new this.AnimatedCardUpdateListener(this.cards[x], this.cards[x].getPosition().getX() + xLoc + moveExtra, this.cards[x].getPosition().getY() + yLoc);
			Core.UpdateEmitter.addListener(updateListener, updateListener.onUpdate);
		}
	},

	setLocation: function(xloc, yloc){
        this.xlocation = xloc;
        this.ylocation = yloc;
        //this.currentValueTxt.setPosition(this.xlocation-300,this.ylocation-20);
	
		for (var x = 0; x < this.cards.length; x++) {
            this.cards[x].setPosition(this.xlocation + (10 * x),this.ylocation);
		}							
		
    },
	
	setActive: function(active) {
		if (active) {
			for (var x = 0; x < this.cards.length; x++) {
				this.cards[x].getNode().setColor(1, 1, 1);
			}
		} else {
			for (var x = 0; x < this.cards.length; x++) {
				this.cards[x].getNode().setColor(0.7,0.7,0.7);
			}
		}
	},
	
	setSmallScale: function(small) {
		if (this.isSmall == small) return;
		this.isSmall = small;
		
		var thisCard;
		if (small) {
			for (var x = 0; x < this.cards.length; x++) {
				thisCard = this.cards[x].getNode(); 
				thisCard.setScale(0.6, 0.6);
			}
		} else {
			for (var x = 0; x < this.cards.length; x++) {
				thisCard = this.cards[x].getNode(); 
				thisCard.setScale(1, 1);
			}
		}
	},
    
    BJHandTotal: function(){
        var t = 0;
        
        for (var x = 0; x < this.cards.length; x++) {
            var number = this.cards[x].number;
            if (this.cards[x].faceup) {
                if (number == 11 || number == 12 || number == 13) 
                    t += 10;
                else 
                    if (number != 1) 
                        t += number;
					else 
						t +=11;
            }
        }	
	   for (var x = 0; x < this.cards.length; x++) {
			var number = this.cards[x].number;
			if (this.cards[x].faceup && number == 1) {
				if (t > 21) 
					t -= 10;
			}
		}
		
        return t;
    },
    
	checkBlackJack: function(){
		if (((this.cards[0].number == 10 || this.cards[0].number == 11 || this.cards[0].number == 12 || this.cards[0].number == 13) && (this.cards[1].number == 1))  ||
		((this.cards[1].number == 10 || this.cards[1].number == 11 || this.cards[1].number == 12 || this.cards[1].number == 13) && (this.cards[0].number == 1)))  
		{
			return true;	
		}
		
		return false;
    },
     
    splitHand: function(){
        return this.cards.pop();
    },

	getHand:function()
	{
		return this.cards;
		
	},
	
	reset:function()
	{
		this.total = 0;
		this.canhit = false;
		this.isDouble = false;
		this.isSmall = false;
		this.winvaluemultiple = 1;        
		  for (var x = 0; x < this.cards.length; x++) {
           	this.cards[x].destroy();
            }
        this.cards = new Array();
		//this.currentValueTxt.setText('');
		
	},
	

    canSplit: function(){
        
            if (this.cards[0].number == this.cards[1].number && this.cards.length == 2)
				{return true;}
			else if (((this.cards[0].number == 10 || this.cards[0].number == 11 || this.cards[0].number == 12 || this.cards[0].number == 13) &&	((this.cards[1].number == 10 || this.cards[1].number == 11 || this.cards[1].number == 12 || this.cards[1].number == 13) )))  
			{
				return true;
			}
			else
				{return false;}
            
        
    },
	
	getXlocation:function()
	{
		return this.xlocation;
	},

	getYlocation:function()
	{
		return this.ylocation;
	},
	
	$AnimatedCardUpdateListener: Core.MessageListener.subclass({
    
        initialize: function(card, positionX, positionY){
            this.card = card;
			this.destinationLengthX = positionX - this.card.getPosition().getX();
	        this.destinationLengthY = positionY - this.card.getNode().getPosition().getY();
	        this.finalDestinationX = positionX;
	        this.finalDestinationY = positionY;
//	        var a = Math.pow(this.destinationLengthX, 2);
//	        var b = Math.pow(this.destinationLengthY, 2);
//	        var c = Math.pow(a + b, 0.5);
//	        this.moveTime = c * 2;
//	        this.moveDuration = c * 2;
			this.moveTime = 300;
			this.moveDuration = 300;  
			
			this.shrinkFaceDown = false;
			this.shrinkFaceUp = false;
			
        },
           
        onUpdate: function(delta){
            var p = this.card.getNode().getPosition();

            //moves sprite
           	if (this.moveTime > 0) {
		   
                if (delta > this.moveTime) {
                    p.setX(this.finalDestinationX);
                    p.setY(this.finalDestinationY);
                }
                else {
                    p.setX(p.getX() + ((delta / this.moveDuration) * this.destinationLengthX));
                    p.setY(p.getY() + ((delta / this.moveDuration) * this.destinationLengthY));
                }
                this.moveTime -= delta;
			}
            else {
				this.moveTime = 0;
                this.moveDuration = 0;
				Core.UpdateEmitter.removeListener(this);
            }
			
            this.card.getNode().setPosition(p);
			
        },
    }),
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/TriCardWarHand'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/TriCardWarHand'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/TriCardWarHand'] = exports; /**
 * @author raymondlo
 */

exports.TriCardWarHand = Core.Class.subclass( 
{
	classname: 'TriCardWarHand',
	
	initialize: function() 
	{	
		this.cards = new Array();
		this.xlocation = 0;
		this.ylocation = 0;
		this.util = new Util();
			
		this.handstatus = false;
		
	},
	
	getHandStatus :function(){
		return this.handstatus;
	},
	setHandStatus :function(b){
		this.handstatus = b;
	},
	
	addCard: function(card)
	{
		SCGame.getSCAudio().playsound(6); 
		card.setPosition(Scale.droid.width(400), Scale.droid.height(-30));
		this.cards.push(card);
		
		var updateListener = new this.AnimatedCardUpdateListener(card, this.xlocation + (Scale.droid.width(65) * this.cards.length), this.ylocation);
        Core.UpdateEmitter.addListener(updateListener, updateListener.onUpdate);
		NgLogD('cardadded');
	},
	
	setLocation: function(xloc,yloc)
	{
		this.xlocation = xloc;
		this.ylocation = yloc;
	},
	
	setActive: function(active) {
		if (active) {
			for (var x = 0; x < this.cards.length; x++) {
				this.cards[x].getNode().setColor(1, 1, 1);
			}
		} else {
			for (var x = 0; x < this.cards.length; x++) {
				this.cards[x].getNode().setColor(0.7,0.7,0.7);
			}
		}
	},
	
	reset: function()
	{
        
	  for (var x = 0; x < this.cards.length; x++) {
       	this.cards[x].destroy();
        }
        this.cards = new Array();
		return;
	},
		
	getCardsDecending: function()
	{
		var c1 = this.cards;
		c1.sort(function(a,b){return b.getNumber() - a.getNumber()});
		return c1;
	},
	
	isGreater:function(yourcards)
	{	
		var myTotal = this.handTotal();
		var yourTotal = yourcards.handTotal();;
			
		if (myTotal > yourTotal)
		{
			return true;
		}
		else 
		{
			return false;
		}
		return false;
	},
	
	handTotal: function(){
        var t = 0;
        
        for (var x = 0; x <  this.cards.length; x++) {
            var number =  this.cards[x].number;
			if (number == 1)
				t += 15;
			else
				t += number;
       	}			
		
		return t;
    },
	
	
	$AnimatedCardUpdateListener: Core.MessageListener.subclass({
    
        initialize: function(card, positionX, positionY){
            this.card = card;
			this.destinationLengthX = positionX - this.card.getPosition().getX();
	        this.destinationLengthY = positionY - this.card.getNode().getPosition().getY();
	        this.finalDestinationX = positionX;
	        this.finalDestinationY = positionY;
			this.moveTime = 300;
			this.moveDuration = 300;  
			
			this.shrinkFaceDown = false;
			this.shrinkFaceUp = false;
			
        },
           
        onUpdate: function(delta){
            var p = this.card.getNode().getPosition();

            //moves sprite
           	if (this.moveTime > 0) {
		   
                if (delta > this.moveTime) {
                    p.setX(this.finalDestinationX);
                    p.setY(this.finalDestinationY);
                }
                else {
                    p.setX(p.getX() + ((delta / this.moveDuration) * this.destinationLengthX));
                    p.setY(p.getY() + ((delta / this.moveDuration) * this.destinationLengthY));
                }
                this.moveTime -= delta;
			}
            else {
				this.moveTime = 0;
                this.moveDuration = 0;
				Core.UpdateEmitter.removeListener(this);
            }
			
            this.card.getNode().setPosition(p);
			
        },
    }),
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/BaccaratHand'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/BaccaratHand'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/BaccaratHand'] = exports; /**
 * @author raymondlo
 */

exports.BaccaratHand = Core.Class.subclass( 
{
	classname: 'BaccaratHand',
	
	initialize: function() 
	{	
		this.cards = new Array();
		this.xlocation = 0;
		this.ylocation = 0;
		
	},
	
	addCard: function(card)
	{
		SCGame.getSCAudio().playsound(6); 
		card.setPosition(Scale.droid.width(400), Scale.droid.height(-30));
        this.cards.push(card);
		
		var updateListener = new this.AnimatedCardUpdateListener(card, this.xlocation + (Scale.droid.width(40) * this.cards.length), this.ylocation);
        Core.UpdateEmitter.addListener(updateListener, updateListener.onUpdate);
	},
	
	setLocation: function(xloc,yloc)
	{
		this.xlocation = xloc;
		this.ylocation = yloc;
	},
	
	setActive: function(active) {
		if (active) {
			for (var x = 0; x < this.cards.length; x++) {
				this.cards[x].getNode().setColor(1, 1, 1);
			}
		} else {
			for (var x = 0; x < this.cards.length; x++) {
				this.cards[x].getNode().setColor(0.7,0.7,0.7);
			}
		}
	},
	
	reset: function()
	{
		for (var x = 0; x < this.cards.length; x++) {
			this.cards[x].destroy();
		}
        this.cards = new Array();
		this.cards.length = 0;
	},
	
  HandTotal: function(){
        var t = 0;
        
        for (var x = 0; x < this.cards.length; x++) {
            var number = this.cards[x].number;
            if (this.cards[x].faceup) {
                if (number == 10 || number == 11 || number == 12 || number == 13) 
                    t += 0;
                else
				    t += number;
            }
        }	
		
        return t % 10;
    },
	
	$AnimatedCardUpdateListener: Core.MessageListener.subclass({
    
        initialize: function(card, positionX, positionY){
            this.card = card;
			this.destinationLengthX = positionX - this.card.getPosition().getX();
	        this.destinationLengthY = positionY - this.card.getNode().getPosition().getY();
	        this.finalDestinationX = positionX;
	        this.finalDestinationY = positionY;
			this.moveTime = 300;
			this.moveDuration = 300;  
			
			this.shrinkFaceDown = false;
			this.shrinkFaceUp = false;
			
        },
           
        onUpdate: function(delta){
            var p = this.card.getNode().getPosition();

            //moves sprite
           	if (this.moveTime > 0) {
		   
                if (delta > this.moveTime) {
                    p.setX(this.finalDestinationX);
                    p.setY(this.finalDestinationY);
                }
                else {
                    p.setX(p.getX() + ((delta / this.moveDuration) * this.destinationLengthX));
                    p.setY(p.getY() + ((delta / this.moveDuration) * this.destinationLengthY));
                }
                this.moveTime -= delta;
			}
            else {
				this.moveTime = 0;
                this.moveDuration = 0;
				Core.UpdateEmitter.removeListener(this);
            }
			
            this.card.getNode().setPosition(p);
			
        },
    }),
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/CardGame/Tutorial/Tutorial'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Tutorial/Tutorial'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/CardGame/Tutorial/Tutorial'] = exports; /**
 * @author raymondlo
 */
var closeMenu_xpos = 772;
var closeMenu_ypos = 28;
var titleText_xpos = 400;
var titleText_ypos = 20;
var titleSubText_xpos = 400;
var titleSubText_ypos = 50;

exports.Tutorial = Core.Class.subclass({
    classname: 'Tutorial',

    initialize: function(obj,gameid) {
		this.obj = obj;
		this.objDepth = 1;
        this.node = new Animation.AnimatedNode();
		var currentslide = 0;
		var bgAnimation = new GL2.Animation();
		bgAnimation.pushFrame(AtlasMap.getAnimationFrame('tutorial-bg.png', 0, [0,0]));
		var background = new GL2.Sprite();
		background.setDepth(this.objDepth + 1);
		background.setAnimation(bgAnimation);

		var bleedblocker = SCStyle.createBleedBlocker();
		bleedblocker.setDepth(-10);
		this.node.addChild(bleedblocker);

		this.node.addChild(background);
				
		var closeActive = AtlasMap.getAnimationFrame('common-bg-exit-active.png', 0, [0.5,0.5]);
		var closeInactive = AtlasMap.getAnimationFrame('common-bg-exit-inactive.png', 0, [0.5,0.5]);		
        var closeAnimation = new Menu.AnimationFrameMenuItem();
        closeAnimation.setFrames(closeInactive,closeActive,closeActive);
		closeAnimation.setAction(function(){
			obj.closeTutorial();
		});
		
        var closeMenu = new Menu.Menu([closeAnimation]);
        closeMenu.setPosition(Scale.droid.width(closeMenu_xpos), Scale.droid.height(closeMenu_ypos));
        closeMenu.setDepth(this.objDepth + 4);
        this.node.addChild(closeMenu);
		this.node.setDepth(40);
		
		var titleText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleText.setText('TUTORIAL');
        titleText.setDepth(this.objDepth + 5);
        titleText.getLabel().setColor(1,1,0.8);
        titleText.setPosition([Scale.droid.width(titleText_xpos), [Scale.droid.height(titleText_ypos)]]);
		SCStyle.applyFontStyle(titleText, SCStyle.FontStyle.Serif32);        
        this.node.addChild(titleText);
        
        var titleSubText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
        titleSubText.setText('L E A R N  T H E  S T R I P');
        titleSubText.setDepth(this.objDepth + 5);
        titleSubText.getLabel().setColor(1,1,0.8);
        titleSubText.setPosition([Scale.droid.width(titleSubText_xpos), [Scale.droid.height(titleSubText_ypos)]]);
		SCStyle.applyFontStyle(titleSubText, SCStyle.FontStyle.Serif12);        
        this.node.addChild(titleSubText);

		
		var pages = [];

		var t1 = '';
		var t2 = '';
		var t3 = '';
		
		switch (gameid){
			case SCConstants.Game.BlackJack: 
				t1 = '\n\n\n\n\n\n\nPerhaps the most common of the casino card games, blackjack is a gambler\'s favorite and can lead to good returns if you find yourself on a hot streak. In blackjack the player\'s goal is to receive a hand of cards with a higher value--without going over 21--than the dealer\'s cards. Cards 2 through 10 are worth their value, face cards are worth 10 and an Ace can be worth 1 or 11 at the player\'s discretion. \n\nThe best hand in blackjack is a two-card hand totaling 21 (10 or face card + Ace), called a "blackjack", that pays 3:2 while the rest of the winning hands pay out 1:1.  '; 
				t2 = '\n\n\n\n\n\n\nSelect your wager by tapping the CHIPS icon corresponding with the value of your bet, then tap DONE. Tap DEAL and the player and dealer are then dealt two cards. Based on what card the dealer is showing, the player may want to receive more cards, tap HIT to receive more cards. Be careful, if you tap HIT too many times and accumulate cards totaling above 21, you have "busted" and lose the bet. When satisfied with your cards tap STAND.\n\nAfter you choose to stand, the dealer will reveal his second card. The dealer then hits or stands based on the rules of the game and must hit on a 16 or under, and stand on a 17 or higher. Tap DEAL to play a new hand, or tap CHANGE BET to adjust your wager.'; 
				t3 = '\n\n\n\n\n\n\nIf the player is feeling especially lucky, after receiving the initial two cards, the player may choose to double his or her original bet. If you choose to double down, you will only receive one more card no matter what its value and no matter the total of your three cards.\n\n\n\nIf you receive two of the same card on your initial deal, you can split the pair by making a second bet equal to your first bet and playing each of the paired cards as a separate hand. For example, if you\'re dealt two sixes, you could hit on a 12, or split the cards by placing another bet and play two sequential hands, each starting with one six card.';
			break;
			case SCConstants.Game.TriCardWar: 
				t1 = '\n\n\n\n\n\n\nA new spin on everyone\'s first card game.  3 Card War is a simple and quick way to make money for your Strip.\n\n\n\nSelect your wager by tapping the CHIPS icon corresponding with the value of your bet.  Then tap DONE.  Tap DEAL and the player and dealer are then dealt three cards each.  Whoever has the highest sum of three cards wins.  \n\n\n\nJacks are worth 11, Queens are worth 12, Kings are worth 13, and Aces are worth 15.  The dealer wins in the event of a tie.  Payout is 1:1.  '; 
				t2 = ''; 
				t3 = '';
			break;
			case SCConstants.Game.Baccarat: 
				t1 = '\n\n\n\n\n\n\nBaccarat is a unique game in that it doesn\'t require strategy on the player\'s part, yet rewards the player with a minimal house edge. The player makes one of four choices by placing wagers on either (1) The Player, (2) The Banker (which charges a commission due to the minimal house edge), (3) The Tie, which pays out 8:1, or (4) The Tie in addition to a simultaneous Player or Banker bet.\n\n\n\n\nTie\nBanker\nPlayer'; 
				t2 = '\n\n\n\n\n\n\nDecide which bet you would like to make by tapping the TIE, BANKER, or PLAYER circle.  Then tap the CHIP amount you would like to wager. You can place another bet similarly (example: a Tie + Banker bet), then tap DONE. Once you\'ve made your bet, tap DEAL and the outcome is determined by the draw/stand rules that baccarat adheres to (see chart on next page). There are only two cards dealt to the Player and Banker with the possibility of a third card drawn depending on those draw/stand rules. Tap DEAL to play a new hand, or tap CHANGE BET to adjust your wager.\n\n\n\nThe goal is to wager on the hand with the outcome closest to 9 (the highest score). The tens digit is ignored, thus for any sum of cards over 9, you focus on the right digit and the card suit is irrelevant. Aces are worth 1, Tens and face cards are worth 0. Since the goal of baccarat is a hand with a value of 9, a two-card hand of 8 or 9 is considered a natural. This is an automatic win for the Player unless the Banker defeats the Player\'s natural-8 with a natural-9, or there is a tie. See the following chart.'; 
				t3 = '\n\n\n\n\n\n\nSum of 1st two cards (right digit)\n0, 1, 2, 3, 4, 5\n6, 7\n8, 9\n\n\n\n\nSum of 1st two cards (right digit)\n3\n4\n5\n6\n7\n8,9\n0,1,2\n\nNote: if P has a standing hand of 6 or 7, dealer will only draw a third card when holding a sum of 0, 1, 2, 3, 4, 5';
			break;
			case SCConstants.Game.Strip: 
				t1 = '\n\n\n\n\n\n\nFeel the glitz and glamour and experience the elegance while developing your very own Strip! Then, step inside the Strip City Casino and try your luck at one of three intriguing card games. Beat the house at Blackjack, Tri-Card or Mini-Baccarat and earn CHIPS you can use to buy more hotels for your Strip City empire.\n\nEveryone wants to own a Vegas hotel, but they don\'t come cheap. Luckily, you\'ve just received the deed to your first three-star hotel. Pair of Kings, like other hotels on the Strip, pays you rent in the form of CHIPS. Tap the hotel to see when payment is due and return later to collect the rent by tapping the CHIPS icon above the hotel. CHIPS can be used for card games, or to purchase more hotels!\n\nSome hotels also provide an advantage for gambling inside the Strip City Casino. Purchase one of these hotels and enjoy a bonus on your winnings or a discount on your losses. Note, Strip City zoning rules allow you to own only one of these bonus/discount hotels at a time.'; 
				t2 = '\n\n\n\n\n\n\nWin or lose, if you\'re a high roller or a Strip City regular, you can earn COMP POINTS based on the size and frequency of your bets. Place high value bets and you\'ll be rewarded with greater COMP POINTS, even if you lose the hand. COMP POINTS can also be used to purchase exclusive hotels.\n\nSuffered a few bad beats at the tables? Had a run of bad luck with the deck? Visit The Bank to purchase more CHIPS or COMP POINTS!\n\nNothing lasts forever in Strip City. When you\'re ready to re-develop your Strip, you can sell hotels back for CHIPS and upgrade to bigger and better ones! Now get to it, your Strip City empire is waiting!'; 
				t3 = '';
			break;
		}


        var p1 = new GL2.Text();
		p1.setFontSize(32);
		p1.setOverflowMode(p1.OverflowMode.Multiline);
		p1.setHorizontalAlign(p1.HorizontalAlign.Left);
		p1.setVerticalAlign(p1.VerticalAlign.Top);
		p1.setSize([Scale.droid.width(800)*1.70, Scale.droid.height(480)*1.80]);
		p1.setFontFamily('DroidSerif-Regular');
        SCStyle.applyFontStyle(p1, SCStyle.FontStyle.Serif16);
		
        p1.setText(t1);
        p1.setAnchor(0, 0);
		var p1_node = new Animation.AnimatedNode();
		p1_node.addChild(p1);
		p1_node.setPosition(Scale.droid.width(70), 0);
        p1_node.setDepth(40);
		p1_node.addChild(p1);

		if (t2 != '') {
				
	        var p2 = new GL2.Text();
			p2.setFontSize(32);
			p2.setOverflowMode(p2.OverflowMode.Multiline);
			p2.setHorizontalAlign(p2.HorizontalAlign.Left);
			p2.setVerticalAlign(p2.VerticalAlign.Top);		
			  // if (SCGame.getSettings().getJapaneseOn()) {
			  // 			  p2.setSize([Scale.droid.width(800)*1.70, Scale.droid.height(500)*1.80]);}
			  //       else{
	 			  p2.setSize([Scale.droid.width(800)*1.70, Scale.droid.height(480)*1.80]);
			  // }
			p2.setFontFamily('DroidSerif-Regular');
	        SCStyle.applyFontStyle(p2, SCStyle.FontStyle.Serif16);

	        p2.setText(t2);
	        p2.setAnchor(0, 0);
			var p2_node = new Animation.AnimatedNode();
			p2_node.addChild(p2);
	        p2_node.setDepth(40);
			p2_node.setPosition(Scale.droid.width(70), 0);
			p2_node.setAlpha(0, 0, 0);
		}

		if (t3 != '') {
			var p3 = new GL2.Text;
			p3.setFontSize(32);
	        p3.setOverflowMode(p3.OverflowMode.Multiline);
			p3.setHorizontalAlign(p3.HorizontalAlign.Left);
			p3.setVerticalAlign(p3.VerticalAlign.Top);			
		  // if (SCGame.getSettings().getJapaneseOn()) {
		  // 			  p3.setSize([Scale.droid.width(800)*1.70, Scale.droid.height(500)*1.80]);}
		  //       else{
 			  p3.setSize([Scale.droid.width(800)*1.70, Scale.droid.height(480)*1.80]);
			// }
			p3.setFontFamily('DroidSerif-Regular');
			SCStyle.applyFontStyle(p3, SCStyle.FontStyle.Serif16);

			p3.setText(t3);
			p3.setAnchor(0, 0);
			var p3_node = new Animation.AnimatedNode();
			p3_node.addChild(p3);
			p3_node.setDepth(40);
			p3_node.setPosition(Scale.droid.width(70), 0);
			p3_node.setAlpha(0, 0, 0);

		}
		
		switch (gameid){
			case SCConstants.Game.BlackJack: 
				var p1a = new GL2.Text();
				p1a.setFontSize(32);
				p1a.setFontFamily('DroidSerif-Regular');
				p1a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
				p1a.setText('Blackjack');
				p1a.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p1a, SCStyle.FontStyle.Serif24);
				p1_node.addChild(p1a);
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p1a.getPosition().getX()+336,p1a.getPosition().getY()+32);
				p1_node.addChild(bar);	
				
				var p2a = new GL2.Text();
				p2a.setFontSize(32);
				p2a.setFontFamily('DroidSerif-Regular');
				p2a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
				p2a.setText('Playing Blackjack');
				p2a.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p2a, SCStyle.FontStyle.Serif24);
				p2_node.addChild(p2a);
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p2a.getPosition().getX()+336,p2a.getPosition().getY()+32);
				p2_node.addChild(bar);	
						
				
				var p3a = new GL2.Text();
				p3a.setFontSize(32);
				p3a.setFontFamily('DroidSerif-Regular');
				p3a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
				p3a.setText('Double Down');
				p3a.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p3a, SCStyle.FontStyle.Serif24);
				p3_node.addChild(p3a);	
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p3a.getPosition().getX()+336,p3a.getPosition().getY()+32);
				p3_node.addChild(bar);						
				
				var p3b = new GL2.Text();
				p3b.setFontSize(32);
				p3b.setFontFamily('DroidSerif-Regular');
				// if (SCGame.getSettings().getJapaneseOn()) {
				// 	p3b.setPosition(Scale.droid.width(0),Scale.droid.height(233));
				// }
				// else
					p3b.setPosition(Scale.droid.width(0),Scale.droid.height(223));
				p3b.setText('Split');
				p3b.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p3b, SCStyle.FontStyle.Serif24);
				p3_node.addChild(p3b);	
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p3b.getPosition().getX()+336,p3b.getPosition().getY()+32);
				p3_node.addChild(bar);						
			break;
			case SCConstants.Game.TriCardWar: 
				var p1a = new GL2.Text();
				p1a.setFontSize(32);
				p1a.setFontFamily('DroidSerif-Regular');
				p1a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
				p1a.setText('3 Card War');
				p1a.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p1a, SCStyle.FontStyle.Serif24);
				p1_node.addChild(p1a);
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p1a.getPosition().getX()+336,p1a.getPosition().getY()+32);
				p1_node.addChild(bar);						
				
	// 			var p2a = new GL2.Text();
	// 				p2a.setFontSize(32);
	// 				p2a.setFontFamily('DroidSerif-Regular');
	// 				p2a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
	// 				p2a.setText('Playing Tri-Card');
	// 				p2a.setAnchor(0, 0);
	// 		        SCStyle.applyFontStyle(p2a, SCStyle.FontStyle.Serif24);
	// 				p2_node.addChild(p2a);	
	// 				var bar = AtlasMap.getSprite('tutorial-bar.png');
	// 				bar.setPosition(p2a.getPosition().getX()+336,p2a.getPosition().getY()+32);
	// 				p2_node.addChild(bar);
	// 								
	// 				var p3a = new GL2.Text();
	// 				p3a.setFontSize(32);
	// 				p3a.setFontFamily('DroidSerif-Regular');
	// 				p3a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
	// 				p3a.setText('Pair Plus');
	// 				p3a.setAnchor(0, 0);
	// 		        SCStyle.applyFontStyle(p3a, SCStyle.FontStyle.Serif24);
	// 				p3_node.addChild(p3a);		
	// 				var bar = AtlasMap.getSprite('tutorial-bar.png');
	// 				bar.setPosition(p3a.getPosition().getX()+336,p3a.getPosition().getY()+32);
	// 				p3_node.addChild(bar);	
	// 				
	// 				var p3b = new GL2.Text();
	// 				p3b.setFontSize(32);
	// 				p3b.setFontFamily('DroidSerif-Regular');
	// 				p3b.setPosition(Scale.droid.width(0),Scale.droid.height(220));
	// 				p3b.setText('Priority of Hand & Payout Schedule');
	// 				p3b.setAnchor(0, 0);
	// 		        SCStyle.applyFontStyle(p3b, SCStyle.FontStyle.Serif24);
	// 				p3_node.addChild(p3b);		
	// 				var bar = AtlasMap.getSprite('tutorial-bar.png');
	// 				bar.setPosition(p3b.getPosition().getX()+336,p3b.getPosition().getY()+32);
	// 				p3_node.addChild(bar);									
	// 				
	// //		        var p3c1 = new GL2.Text();
	// //				p3c1.setFontSize(32);
	// //		        SCStyle.applyFontStyle(p3c1, SCStyle.FontStyle.Serif16);
	// //				p3c1.setHorizontalAlign(p3c1.HorizontalAlign.Left);
	// //				p3c1.setVerticalAlign(p3c1.VerticalAlign.Top);
	// //				p3c1.setFontFamily('DroidSerif-Regular');
	// //		        p3c1.setText('HAND\nStraight Flush\nThree of a Kind\nStraight\nFlush\nPair\nHigh Card');
	// //		        p3c1.setAnchor(0, 0);
	// //				p3c1.setPosition(Scale.droid.width(0),Scale.droid.height(300));
	// //				p3_node.addChild(p3c1);						
	// 
	// 		        var p3c2 = new GL2.Text();
	// 				p3c2.setFontSize(32);
	// 				p3c2.setHorizontalAlign(p3c2.HorizontalAlign.Left);
	// 				p3c2.setVerticalAlign(p3c2.VerticalAlign.Top);
	// 				p3c2.setFontFamily('DroidSerif-Regular');
	// 		        SCStyle.applyFontStyle(p3c2, SCStyle.FontStyle.Serif16);
	// 		        p3c2.setText('PAYOUT (STANDARD)\n6 : 1 (ante bonus 5 : 1)\n5 : 1 (ante bonus 4 : 1)\n2 : 1 (ante bonus 1 : 1)\n1 : 1\n1 : 1\n1 : 1');
	// 		        p3c2.setAnchor(0, 0);
	// 				// if (SCGame.getSettings().getJapaneseOn()) {
	// 				// 	p3c2.setPosition(Scale.droid.width(180), Scale.droid.height(273));
	// 				// }
	// 				// else {
	// 					p3c2.setPosition(Scale.droid.width(180), Scale.droid.height(260));
	// 				// }
	// 				p3_node.addChild(p3c2);						
	// 
	// 		        var p3c3 = new GL2.Text();
	// 				p3c3.setFontSize(32);
	// 				p3c3.setHorizontalAlign(p3c3.HorizontalAlign.Left);
	// 				p3c3.setVerticalAlign(p3c3.VerticalAlign.Top);
	// 				p3c3.setFontFamily('DroidSerif-Regular');
	// 		        SCStyle.applyFontStyle(p3c3, SCStyle.FontStyle.Serif16);
	// 		        p3c3.setText('PAYOUT (PAIR PLUS)\n40 : 1\n30 : 1\n6 : 1\n4 : 1\n1 : 1\nNone');
	// 		        p3c3.setAnchor(0, 0);
	// 				// if (SCGame.getSettings().getJapaneseOn()) {
	// 				// 	p3c3.setPosition(Scale.droid.width(400), Scale.droid.height(273));
	// 				// }
	// 				// else {
	// 					p3c3.setPosition(Scale.droid.width(400), Scale.droid.height(260));
	// 				// }
	// 				p3_node.addChild(p3c3);						
				
				
			break;
			case SCConstants.Game.Baccarat: 
				var p1a = new GL2.Text();
				p1a.setFontSize(32);
				p1a.setFontFamily('DroidSerif-Regular');
				p1a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
				p1a.setText('Mini-Baccarat');
				p1a.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p1a, SCStyle.FontStyle.Serif24);
				p1_node.addChild(p1a);	
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p1a.getPosition().getX()+336,p1a.getPosition().getY()+32);
				p1_node.addChild(bar);					
				
				var p1b = new GL2.Text();
				p1b.setFontSize(32);
				p1b.setFontFamily('DroidSerif-Regular');
				p1b.setPosition(Scale.droid.width(0),Scale.droid.height(260));
				p1b.setText('Payout');
				p1b.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p1b, SCStyle.FontStyle.Serif24);
				p1_node.addChild(p1b);		
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p1b.getPosition().getX()+336,p1b.getPosition().getY()+32);
				p1_node.addChild(bar);		
								
		        var p1c2 = new GL2.Text();
				p1c2.setFontSize(32);
				p1c2.setHorizontalAlign(p1c2.HorizontalAlign.Left);
				p1c2.setVerticalAlign(p1c2.VerticalAlign.Top);
				p1c2.setFontFamily('DroidSerif-Regular');
		        SCStyle.applyFontStyle(p1c2, SCStyle.FontStyle.Serif16);
		        p1c2.setText('8 : 1\n1 : 1 (minus 5% commission)\n1 : 1');
		        p1c2.setAnchor(0, 0);
				// if (SCGame.getSettings().getJapaneseOn()) {
				// 	p1c2.setPosition(Scale.droid.width(180), Scale.droid.height(292));
				// }
				// else {
					p1c2.setPosition(Scale.droid.width(180), Scale.droid.height(300));
				// }
				p1_node.addChild(p1c2);						
				
				var p2a = new GL2.Text();
				p2a.setFontSize(32);
				p2a.setFontFamily('DroidSerif-Regular');
				p2a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
				p2a.setText('Playing Mini-Baccarat');
				p2a.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p2a, SCStyle.FontStyle.Serif24);
				p2_node.addChild(p2a);	
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p2a.getPosition().getX()+336,p2a.getPosition().getY()+32);
				p2_node.addChild(bar);						

				var p2b = new GL2.Text();
				p2b.setFontSize(32);
				p2b.setFontFamily('DroidSerif-Regular');
				// if (SCGame.getSettings().getJapaneseOn()) {
				//   			  p2b.setPosition(Scale.droid.width(0),Scale.droid.height(280));}
				//   			else{
  			  	p2b.setPosition(Scale.droid.width(0),Scale.droid.height(270));
				// }
				p2b.setText('The Rules');
				p2b.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p2b, SCStyle.FontStyle.Serif24);
				p2_node.addChild(p2b);	
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p2b.getPosition().getX()+336,p2b.getPosition().getY()+32);
				p2_node.addChild(bar);					
				
				var p3a = new GL2.Text();
				p3a.setFontSize(32);
				p3a.setFontFamily('DroidSerif-Regular');
				p3a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
				p3a.setText('Player\'s Hand (Dealt First)');
				p3a.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p3a, SCStyle.FontStyle.Serif24);
				p3_node.addChild(p3a);		
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p3a.getPosition().getX()+336,p3a.getPosition().getY()+32);
				p3_node.addChild(bar);	
								
				var p3b = new GL2.Text();
				p3b.setFontSize(32);
				p3b.setFontFamily('DroidSerif-Regular');
				p3b.setPosition(Scale.droid.width(0),Scale.droid.height(230));
				p3b.setText('Banker\'s Hand');
				p3b.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p3b, SCStyle.FontStyle.Serif24);
				p3_node.addChild(p3b);
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p3b.getPosition().getX()+336,p3b.getPosition().getY()+32);
				p3_node.addChild(bar);								
				
//				var p3c1 = new GL2.Text();
//				p3c1.setFontSize(32);
//		        SCStyle.applyFontStyle(p3c1, SCStyle.FontStyle.Serif16);
//				p3c1.setHorizontalAlign(p3c1.HorizontalAlign.Left);
//				p3c1.setVerticalAlign(p3c1.VerticalAlign.Top);
//				p3c1.setFontFamily('DroidSerif-Regular');
//		        p3c1.setText('');
//		        p3c1.setAnchor(0, 0);
//				p3c1.setPosition(Scale.droid.width(0),Scale.droid.height(100));
//				p3_node.addChild(p3c1);						

		        var p3c2 = new GL2.Text();
				p3c2.setFontSize(32);
				p3c2.setHorizontalAlign(p3c2.HorizontalAlign.Left);
				p3c2.setVerticalAlign(p3c2.VerticalAlign.Top);
				p3c2.setFontFamily('DroidSerif-Regular');
				SCStyle.applyFontStyle(p3c2, SCStyle.FontStyle.Serif16);
		        p3c2.setText('Action taken\nDraws a third card\nStands\nNatural! (stands)');
		        p3c2.setAnchor(0, 0);
				// if (SCGame.getSettings().getJapaneseOn()) {
				// 	p3c2.setPosition(Scale.droid.width(160), Scale.droid.height(125));
				// }
				// else {
					p3c2.setPosition(Scale.droid.width(270), Scale.droid.height(130));
				// }
				p3_node.addChild(p3c2);						

//				var p3c1b = new GL2.Text();
//				p3c1b.setFontSize(32);
//		        SCStyle.applyFontStyle(p3c1b, SCStyle.FontStyle.Serif16);
//				p3c1b.setHorizontalAlign(p3c1b.HorizontalAlign.Left);
//				p3c1b.setVerticalAlign(p3c1b.VerticalAlign.Top);
//				p3c1b.setFontFamily('DroidSerif-Regular');
//		        p3c1b.setText('Sum of 1st two cards (right digit)\n3\n4\n5\n6\n7\n8,9\n0,1,2');
//		        p3c1b.setAnchor(0, 0);
//				p3c1b.setPosition(Scale.droid.width(0),Scale.droid.height(300));
//				p3_node.addChild(p3c1b);						

		        var p3c2b = new GL2.Text();
				p3c2b.setFontSize(32);
				p3c2b.setHorizontalAlign(p3c2b.HorizontalAlign.Left);
				p3c2b.setVerticalAlign(p3c2b.VerticalAlign.Top);
				p3c2b.setFontFamily('DroidSerif-Regular');
		        SCStyle.applyFontStyle(p3c2b, SCStyle.FontStyle.Serif16);
		        p3c2b.setText('Draws if P\'s 3rd card =\n0, 1, 2, 3, 4, 5, 6, 7, 9\n2, 3, 4, 5, 6, 7\n4, 5, 6, 7\n6, 7\nNever Draws\nNatural! (stands)\nMust Draw');
		        p3c2b.setAnchor(0, 0);
				// if (SCGame.getSettings().getJapaneseOn()) {
				// 	p3c2b.setPosition(Scale.droid.width(160), Scale.droid.height(273));
				// }
				// else {
					p3c2b.setPosition(Scale.droid.width(270), Scale.droid.height(279));
				// }
				p3_node.addChild(p3c2b);			
				
		        var p3c3b = new GL2.Text();
				p3c3b.setFontSize(32);
				p3c3b.setHorizontalAlign(p3c3b.HorizontalAlign.Left);
				p3c3b.setVerticalAlign(p3c3b.VerticalAlign.Top);
				p3c3b.setFontFamily('DroidSerif-Regular');
		        SCStyle.applyFontStyle(p3c3b, SCStyle.FontStyle.Serif16);
		        p3c3b.setText('Stands if P\'s 3rd card =\n8\n0, 1, 8, 9\n0, 1, 2, 3, 8, 9\n0, 1, 2, 3, 4, 5, 8, 9\nAlways Stands\nAlways Stands\nNever Stands');
		        p3c3b.setAnchor(0, 0);
				// if (SCGame.getSettings().getJapaneseOn()) {
				// 	p3c3b.setPosition(Scale.droid.width(415), Scale.droid.height(273));
				// }
				// else {
					p3c3b.setPosition(Scale.droid.width(470), Scale.droid.height(279));
				// }
				p3_node.addChild(p3c3b);			

			break;
			case SCConstants.Game.Strip: 
			
				var p1a = new GL2.Text();
				p1a.setFontSize(32);
				p1a.setFontFamily('DroidSerif-Regular');
				p1a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
				p1a.setText('Welcome to Vegas Strip City');
				p1a.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p1a, SCStyle.FontStyle.Serif24);
				p1_node.addChild(p1a);	
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p1a.getPosition().getX()+336,p1a.getPosition().getY()+32);
				p1_node.addChild(bar);					

				var p2a = new GL2.Text();
				p2a.setFontSize(32);
				p2a.setFontFamily('DroidSerif-Regular');
				p2a.setPosition(Scale.droid.width(0),Scale.droid.height(90));
				p2a.setText('Welcome to Vegas Strip City (con\'t)');
				p2a.setAnchor(0, 0);
		        SCStyle.applyFontStyle(p2a, SCStyle.FontStyle.Serif24);
				p2_node.addChild(p2a);		
				var bar = AtlasMap.getSprite('tutorial-bar.png');
				bar.setPosition(p2a.getPosition().getX()+336,p2a.getPosition().getY()+32);
				p2_node.addChild(bar);									
			break;
		}

		pages.push(p1_node);
		this.node.addChild(pages[0]);

		if (t2 != '') {
			pages.push(p2_node);		
			this.node.addChild(pages[1]);
		}
		if (t3 != '') {
			pages.push(p3_node);
			this.node.addChild(pages[2]);
		}

		var pagination = [];
		for (p = 0; p < pages.length; p++) {
//			var paginationActive = new GL2.Animation.Frame('Content/ui_nonatlas_tutorial/tutorial-pagination-on.png', 0, [Scale.droid.width(10), Scale.droid.height(10)], [0.5, 0.5], [0, 0, 1, 1])
//			var paginationInactive = new GL2.Animation.Frame('Content/ui_nonatlas_tutorial/tutorial-pagination-off.png', 0, [Scale.droid.width(10), Scale.droid.height(10)], [0.5, 0.5], [0, 0, 1, 1])
			var paginationActive = AtlasMap.getAnimationFrame('tutorial-pagination-on.png', 0, [0.5,0.5]);
			var paginationInactive = AtlasMap.getAnimationFrame('tutorial-pagination-off.png', 0, [0.5,0.5]);				

			var paginationAnimation = new Menu.AnimationFrameMenuItem();
			paginationAnimation.setFrames(paginationActive, paginationInactive, paginationInactive);
			paginationAnimation.setEnabled(false);
			pagination.push(paginationAnimation);
		}
		pagination[0].setEnabled(true);
			
        var paginationMenu = new Menu.Menu(pagination);
        paginationMenu.setPosition(Scale.droid.width(400), Scale.droid.height(465));
        paginationMenu.setDepth(this.objDepth + 3);
        this.node.addChild(paginationMenu);



		var animation = new Animation.AnimatedNode();
		var isSwapping = false;		
//		var prevActive = new GL2.Animation.Frame('Content/ui_nonatlas_tutorial/tutorial-button-prev-inactive.png', 0, [Scale.droid.width(160), Scale.droid.height(40)], [0.5, 0.5], [0, 0, 1, 1]);
//		var prevInactive = new GL2.Animation.Frame('Content/ui_nonatlas_tutorial/tutorial-button-prev-active.png', 0, [Scale.droid.width(160), Scale.droid.height(40)], [0.5, 0.5], [0, 0, 1, 1]);
		var prevActive = AtlasMap.getAnimationFrame('tutorial-button-prev-inactive.png', 0, [0.5,0.5]);
		var prevInactive = AtlasMap.getAnimationFrame('tutorial-button-prev-active.png', 0, [0.5,0.5]);				

        var prevAnimation = new Menu.AnimationFrameMenuItem();

        prevAnimation.setFrames(prevActive, prevInactive,prevInactive);
		prevAnimation.setAction(function(){
			if (currentslide <= 1) {prevAnimation.setEnabled(false);} else {prevAnimation.setEnabled(true);}
			nextAnimation.setEnabled(true);
			if (currentslide > 0 && !isSwapping) {
				animation.runSequence(0.0, function(){isSwapping = true; for (i=0;i<pages.length;i++){ if (currentslide == i || (currentslide - 1) == i) {pages[i].setVisible(true);} else {pages[i].setVisible(false);} if ((currentslide-1) == i) {pagination[i].setEnabled(true);} else {pagination[i].setEnabled(false);}  } },
						  			  0.0, function(){pages[currentslide].fadeTo(0,0.5);},
									  0.0, function(){pages[currentslide].setDepth(pages[currentslide].getDepth()-1);pages[currentslide-1].setDepth(pages[currentslide-1].getDepth()+1);},
									  0.0, function(){pages[currentslide-1].fadeTo(1,0.5);},
									  0.0, function(){currentslide--;isSwapping = false; }
									  );
									  
			}
		});
		
		
//		var nextActive = new GL2.Animation.Frame('Content/ui_nonatlas_tutorial/tutorial-button-next-inactive.png', 0, [Scale.droid.width(160), Scale.droid.height(40)], [0.5, 0.5], [0, 0, 1, 1]);
//		var nextInactive = new GL2.Animation.Frame('Content/ui_nonatlas_tutorial/tutorial-button-next-active.png', 0, [Scale.droid.width(160), Scale.droid.height(40)], [0.5, 0.5], [0, 0, 1, 1]);
		var nextActive = AtlasMap.getAnimationFrame('tutorial-button-next-inactive.png', 0, [0.5,0.5]);
		var nextInactive = AtlasMap.getAnimationFrame('tutorial-button-next-active.png', 0, [0.5,0.5]);				

        var nextAnimation = new Menu.AnimationFrameMenuItem();
        nextAnimation.setFrames(nextActive,nextInactive,nextInactive);
		nextAnimation.setAction(function(){
			if (currentslide >= pages.length-2) {nextAnimation.setEnabled(false);} else {nextAnimation.setEnabled(true);}
			prevAnimation.setEnabled(true);			
			
			if(currentslide < pages.length-1 && !isSwapping){
			animation.runSequence(0.0, function(){isSwapping = true;  for (i=0;i<pages.length;i++){ if (currentslide == i || (currentslide+1) == i) {pages[i].setVisible(true);} else {pages[i].setVisible(false);} if ((currentslide+1) == i) {pagination[i].setEnabled(true);} else {pagination[i].setEnabled(false);}   } },
								  0.0, function(){pages[currentslide].fadeTo(0,0.5); },
								  0.0, function(){pages[currentslide].setDepth(pages[currentslide].getDepth()-1);pages[currentslide+1].setDepth(pages[currentslide+1].getDepth()+1);},
								  0.0, function(){pages[currentslide+1].fadeTo(1,0.5);},
								  0.0, function(){currentslide++;isSwapping = false; }
								  );
				}
		});
		
        var NavMenu = new Menu.Menu([prevAnimation, nextAnimation]);
        NavMenu.setPosition(Scale.droid.width(400), Scale.droid.height(32));
		NavMenu.alignItemsHorizontally(Scale.droid.width(460));
        NavMenu.setDepth(this.objDepth + 4);
        this.node.addChild(NavMenu);
		prevAnimation.setEnabled(false);
    },
    
	getNode: function() {
		return this.node;
	},
	

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Strip'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Strip'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Strip'] = exports; /**
 * @author will
 */
exports.Strip = {
	Strip: require('Code/StripCity/Game/Strip/Strip').Strip,
	StripManager: require('Code/StripCity/Game/Strip/StripManager').StripManager,
	StripObjectTemplate: require('Code/StripCity/Game/Strip/StripObjectTemplate').StripObjectTemplate,
	StripObject: require('Code/StripCity/Game/Strip/StripObject').StripObject,
};; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Player'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Player'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Player'] = exports; /**
 * @author George Yang
 */

exports.Player = {
	Player: require('Code/StripCity/Game/Player/Player').Player,
};
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/IAP'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/IAP'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/IAP'] = exports; /**
 * @author will
 */
exports.IAP = {
	IAP: require('Code/StripCity/Game/IAP/IAP').IAP,
	IAPManager: require('Code/StripCity/Game/IAP/IAPManager').IAPManager,
	Limit: require('Code/StripCity/Game/IAP/Limit').Limit,	
};; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Strip/StripManager'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Strip/StripManager'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Strip/StripManager'] = exports; /**
 * @author will
 */
var StripObjectTemplate = require('Code/StripCity/Game/Strip/StripObjectTemplate').StripObjectTemplate;
var StripObjectModifier = require('Code/StripCity/Game/Strip/StripObjectModifier').StripObjectModifier;
exports.StripManager = Class.singleton({
    initialize: function(){
		NgLogD('initialize strip manager');		
		this._templates = [];
		var temp;
		
		//this.addStripObjectTemplate(new StripObjectTemplate(0,'empty_plot','Content/fs.png', [Scale.droid.width(400), Scale.droid.height(320)], 0, 0, 3, 1, 1250, 43200, null, null, StripObjectTemplate.Type.Empty));
		temp = new StripObjectTemplate(1,'Pair of Kings','obj-bldg-01', [Scale.droid.width(305), Scale.droid.height(318)], 'bldg_logo_01.png',20000, 0, 3, 1, 1250, 43200, null, null);
		temp.setInfoText('A pair of kings may not be enough at the tables but Pair of Kings casino is a winner. A member of the "Glitz Group," Pair of Kings boasts over 700 rooms and 50,000 sq. feet of gaming space and features the world\'s largest slot machine all under its iconic crown.');
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(2,'Oriental Palace','obj-bldg-02', [Scale.droid.width(438), Scale.droid.height(281)], 'bldg_logo_02.png',50000, 0, 3, 2, 0, 0, StripObjectModifier.Type.AllWinningsIncrease, 5);
		temp.setInfoText('A monument to the far east, Oriental Palace features eastern architectural cues such as articulation, bilateral symmetry and layered roofs. Exuding balance and calm, the OP also features a classic car showroom and over 2,000 rooms. You may even see Elvis at the bar.');
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(3,'Jester','obj-bldg-03', [Scale.droid.width(459), Scale.droid.height(309)], 'bldg_logo_03.png',100000, 0, 3, 2, 1250, 43200, null, null);
		temp.setInfoText('While everything at Jester is bright and colorful, the most extravagant of its architecture may be the three 23-karat gold-leaf harlequin clown sculptures. Each sculpture extends over 35 feet in length and weighs over 12 tons.');		
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(4,'Gold Rush','obj-bldg-04', [Scale.droid.width(389), Scale.droid.height(268)], 'bldg_logo_04.png',200000, 0, 3, 2, 0, 0, StripObjectModifier.Type.AllLosingsDecrease, 5);
		temp.setInfoText('One of the oldest casinos in the city and somewhat tarnished by its age, Gold Rush features a shark tank and the world\'s largest brick of gold on display. Hollywood considers Gold Rush "vintage" Vegas and has featured it in many movies and TV shows.');
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(5,'Belmonte','obj-bldg-05', [Scale.droid.width(360), Scale.droid.height(191)], 'bldg_logo_05.png',250000, 0, 3, 2, 3500, 86400, null, null);
		temp.setInfoText('Central to the Belmonte Street Experience, Belmonte was also the tallest building in Nevada at its opening. Perhaps most notable because famed Las Vegas entertainer Dwayne Knewton made his debut in the Belmonte lounge in 1959.');
		this.addStripObjectTemplate(temp);	
		temp = 	new StripObjectTemplate(6,'Zillions','obj-bldg-06', [Scale.droid.width(420), Scale.droid.height(261)], 'bldg_logo_06.png',0, 5000, 4, 2, 0, 0, StripObjectModifier.Type.AllWinningsIncrease, 5);
		temp.setInfoText('Popular since the \'50s, Zillions is the casino for those looking for a traditional Vegas experience. Inside, low ceilings, velour walls and acres of garish carpeting contain hundreds of penny slot machines and $5 blackjack tables.');
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(7,'Silver Spurs','obj-bldg-07', [Scale.droid.width(404), Scale.droid.height(438)], 'bldg_logo_07.png',600000, 0, 4, 2, 3500, 43200, null, null);
		temp.setInfoText('Embracing a wild western theme, Silver Spurs Hotel boasts four towers holding over 1,000 rooms and brings a Texan flair to the heart of Las Vegas. Step through the saloon doors and enjoy a fitness center, rooftop pool, full gaming and of course, Hold \'em Poker.');
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(8,'Troposphere','obj-bldg-08', [Scale.droid.width(440), Scale.droid.height(373)], 'bldg_logo_08.png',850000, 0, 4, 2, 1000, 7200, null, null);
		temp.setInfoText('Vegas meets the space age at The Troposphere, the casino of the future. Dedicated to space exploration and the unknown, The Trop features a satellite tower with observation deck, orbiting satellites, UFOs and of course the best HDTV reception on The Strip.');
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(9,'Big Top','obj-bldg-09', [Scale.droid.width(495), Scale.droid.height(318)], 'bldg_logo_09.png',1250000, 0, 4, 2, 3000, 14400, null, null);
		temp.setInfoText('Step right up at Big Top and in addition to a full casino you can enjoy an indoor amusement park, roller coaster and giant Ferris wheel. No luck at the tables? Try the full array of carnival games while enjoying the best cotton candy and balloon animals in town.');		
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(10,'Sphinx','obj-bldg-10', [Scale.droid.width(407), Scale.droid.height(382)], 'bldg_logo_10.png',0, 9000, 5, 2, 0, 0, StripObjectModifier.Type.AllLosingsDecrease, 5);
		temp.setInfoText('Uniquely designed inside and out, Sphinx embodies the strength and benevolence of The Great Egyptian Sphinx which inspired its design. Other postmodern architectural features include an enormous open atrium, 260 foot obelisk and 10 story Pyramid.');
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(11,'The Illusion','obj-bldg-11', [Scale.droid.width(352), Scale.droid.height(353)], 'bldg_logo_11.png',3500000, 0, 5, 2, 10000, 86400, StripObjectModifier.Type.AllWinningsIncrease, 5);
		temp.setInfoText('High atop The Illusion sits an illuminated rabbit and top hat. Known to have the premier magic shows on The Strip, you can satisfy your need for performance art with wild animal illusions, card tricks and vanishing objects - all while enjoying over 100,000 sq ft of gaming space.');
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(12,'Arthur\'s Court','obj-bldg-12', [Scale.droid.width(498), Scale.droid.height(359)], 'bldg_logo_12.png',5000000, 0, 5, 2, 50000, 57600, null, null);
		temp.setInfoText('One of the more family-friendly casinos on The Strip, only at Arthur\'s Court can you enjoy a medieval joust with real Destriers while dining on round unsliced loaves of bread (no utensils, of course) in between hands of baccarat.');	
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(13,'Caligulas','obj-bldg-13', [Scale.droid.width(635), Scale.droid.height(395)], 'bldg_logo_13.png',10000000, 0, 5, 2, 0, 0, StripObjectModifier.Type.AllLosingsDecrease, 10);
		temp.setInfoText('The Roman Empire still reigns at Caligulas. Satisfy all your hedonistic desires and live like an emperor.  Bath towels woven from the hands of virgins; chariot races through the casino; and gladiator battles in the nightclubs are a few examples of the decadence.');	
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(14,'Bellini','obj-bldg-14', [Scale.droid.width(626), Scale.droid.height(392)], 'bldg_logo_14.png',0, 25000, 5, 2, 3000, 7200, null, null);
		temp.setInfoText('Bellini is where the pros play. A homage to Venice, Italy, Bellini is a gambler\'s paradise and the chosen venue for the world\'s best poker players. High-limit tables, private poker rooms and high stakes tournaments, Bellini has it all.');	
		this.addStripObjectTemplate(temp);
		temp = new StripObjectTemplate(15,'Wind','obj-bldg-15', [Scale.droid.width(729), Scale.droid.height(426)], 'bldg_logo_15.png',0, 60000, 5, 2, 3000, 7200, StripObjectModifier.Type.AllWinningsIncrease, 15);
		temp.setInfoText('A basic element of life, wind powers the turbines that enable Wind to be the "greenest" casino on The Strip. Wind offers the ultimate in high-end luxury with award-winning organic restaurants and three natural habitat nightclubs featuring lakes and waterfalls.');	
		this.addStripObjectTemplate(temp);		

    },
    addStripObjectTemplate: function( sot ){
		this._templates[sot.getId()] = sot; 
    },
	
	getStripObjectTemplate: function (id) {
		return this._templates[id];
	},
	
	getTemplates: function() {
		return this._templates;
	},
   
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Strip/Strip'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Strip/Strip'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Strip/Strip'] = exports; /**
 * @author will
 */
var StripObjectTemplate = require('Code/StripCity/Game/Strip/StripObjectTemplate').StripObjectTemplate;
var StripObject = require('Code/StripCity/Game/Strip/StripObject').StripObject;

exports.Strip = Core.Class.subclass({
    classname: 'Strip',
    
    initialize: function( max, stripData ){
		if (typeof stripData == 'undefined') stripData = null;
		
		this._maxBuildings = max;
        this._plotMap = [];
        this._leftEdgePlotID = 0;
        this._rightEdgePlotID = 0;
        this._id = NaN;
        this._stripObjectIdCount = 0;
        
//        var emptyObj1 = new StripObject(0, this._stripObjectIdCount++);
//        emptyObj1.setPlotID(0);
//        
//        var emptyObj2 = new StripObject(0, this._stripObjectIdCount++);
//        emptyObj2.setPlotID(1);
//        
//        this._plotMap.push(emptyObj1);
//        this._plotMap.push(emptyObj2);
		
		if (stripData) {
			var stripObjects = stripData.stripObjects;
			
			for (var i in stripObjects) {

				var soData = stripObjects[i];
				var templateId = soData.templateId;
				var nextCollectTime = soData.nextCollectTime;
				
				NgLogD('creating strip object from data...' + templateId + ':' + nextCollectTime + '...' + typeof templateId + ":" + typeof nextCollectTime);				
				
				var obj = new StripObject(templateId);
				obj.setNextCollectTime( new Date(nextCollectTime) );
				
				this.addStripObject(obj);
				
			}
		}
    },
	
	
    
    
    //	putStripObject: function( obj, plotID )
    //	{
    //		this._plotMap[plotID] = obj;
    //		
    //		if (obj.getType() == StripObjectTemplate.Type.Empty) return;
    //		
    //		if (plotID <= this._leftEdgePlotID) {
    //			this._leftEdgePlotID = plotID - 1;
    //		}
    //		
    //		if (plotID >= this._rightEdgePlotID) {
    //			this._rightEdgePlotID = plotID + 1;
    //		}
    //	},
    
    addStripObject: function(so, right){
        if (!so) 
            return;
        if (typeof right == 'undefined') 
            right = true;
        so.setID(this._stripObjectIdCount++);
        var index = 0;
        if (right) {
            //index = this._plotMap.length - 1;
			index = this._plotMap.length;
            so.setPlotID(index);
            Util.insertAtIndex(this._plotMap, index, so);
        }
        else {
            //index = 1;
			index = 0;
            so.setPlotID(index);
            Util.insertAtIndex(this._plotMap, index, so);
            
            
        }
        
        //since we shifted everything, we need to adjust the  plotid's in the objects.		
        for (var i = index; i < this._plotMap.length; i++) {
            var stripObject = this._plotMap[i];
            if (!stripObject) 
                continue;
            stripObject.setPlotID(i);
        }
        
        //this.print();
    
    },
    
    moveStripObject: function(so, newPlotID){
        NgLogD('insertingStripObject from ' + so.getPlotID() + ' to : ' + newPlotID);
        Util.removeByValue(this._plotMap, so);
        Util.insertAtIndex(this._plotMap, newPlotID, so);
        
        for (var i = 0; i < this._plotMap.length; i++) {
            var stripObject = this._plotMap[i];
            if (!stripObject) 
                continue;
            stripObject.setPlotID(i);
        }
        
    },
    
    print: function(){
        for (var i in this._plotMap) {
            NgLogD('index=' + i + ' value=' + this._plotMap[i].getName() + 'plotid' + this._plotMap[i].getPlotID() + ' i = ' + typeof i);
        }
    },
    
    getStripObject: function(plotID){
        return this._plotMap[plotID];
    },
    
    getPlotMap: function(){
        return this._plotMap;
    },
    
    getLeftEdgePlotID: function(){
        return this._leftEdgePlotID;
    },
    
    getRightEdgePlotID: function(){
        return this._rightEdgePlotID;
    },
    
    getMods: function(){
        var mods = []
        for (var i in this._plotMap) {
            var so = this._plotMap[i];
            if (!so) 
                continue;
            if (so.getType() == StripObjectTemplate.Type.Empty) 
                continue;
            if (so.hasMod()) {
    			mods.push(so.getMod());        
            }
        }
		
		return mods;
    },
    
    getNumActiveStripObjects: function(){
        var num = 0;
        for (var i in this._plotMap) {
            var so = this._plotMap[i];
            if (!so) 
                continue;
            if (so.getType() == StripObjectTemplate.Type.Empty) 
                continue;
            if (so.isSold()) 
                continue;
            
            num++;
        }
        
        return num;
    },
	
	canBuild: function() {
		return this.getNumActiveStripObjects() < this._maxBuildings;
	},
    
    removeStripObject: function(obj){
        //remove strip object
        
        Util.removeByValue(this._plotMap, obj);
        for (var i = 0; i < this._plotMap.length; i++) {
            var stripObject = this._plotMap[i];
            if (!stripObject) 
                continue;
            stripObject.setPlotID(i);
        }
        
        this.print();
        
    },
	
	getData: function() {
		var stripData = new Object();
		stripData.stripObjects = [];
        for (var i in this._plotMap) {
            var so = this._plotMap[i];
            if (!so) 
                continue;
            if (so.getType() == StripObjectTemplate.Type.Empty) 
                continue;
            if (so.isSold()) 
                continue;
            stripData.stripObjects.push(so.getData());
        }
		
		return stripData;
	}

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Strip/StripObject'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Strip/StripObject'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Strip/StripObject'] = exports; /**
 * @author will
 */
var StripManager = require('Code/StripCity/Game/Strip/StripManager').StripManager;
var StripObjectTemplate = require('Code/StripCity/Game/Strip/StripObjectTemplate').StripObjectTemplate;
exports.StripObject = Core.Class.subclass({
    classname: 'StripObject',
    
    initialize: function(templateId, id){
        this._templateId = templateId;
		this._id = id;
        var template = this.getTemplate();
        
        //initialize this strip object based on the template
        this.setType(template.getType());
        this.setName(template.getName());
        this.setCost(template.getCost());
		this.setCompCost(template.getCompCost());
        this.setStarRating(template.getStarRating());
        //this.setAssetName(template.getAssetName());
		this.setAssetSize(template.getAssetSize());
        this.setSize(template.getSize());
		this.setIncome(template.getIncome());
		this.setMod(template.getMod());
		this.setInfoText(template.getInfoText());
		this._sold = false;
        this._plotID = NaN;
		
		//in seconds.
		this._collectTimeInterval = (template.getCollectTimeInterval());		
		this._nextCollectTime = null;
		
        
    },
	
	getNextCollectTime: function() {
		return this._nextCollectTime;
	},
	
	setNextCollectTime: function (t) {
		this._nextCollectTime =  t;
	},
	
	canCollect: function() {
		
		if (!this.canCollectIgnoringTime()) return false;
		
		var now = new Date();
		return now >= this._nextCollectTime;
	},
	
	canCollectIgnoringTime: function() {
		
		if (this._type == StripObjectTemplate.Type.Empty) return false;
		if (this.isSold()) return false;
		if (this.getIncome() <= 0) return false;
		
		return true;
	},
	
	//collect
	resetNextCollectTime: function() {
		this._nextCollectTime = new Date().addSeconds( this._collectTimeInterval );
	},
	
    getID: function(){
        return this._id;
    },
    
    setID: function(t){
        this._id = t;
    },
	
	getInfoText: function() {
		return this._infoText;
	},
	
	setInfoText: function(infoText) {
		this._infoText = infoText;
	},
	
	hasMod: function() {
		return this._mod != null;
	},
	
    getMod: function(){
        return this._mod;
    },
    
    setMod: function(t){
        this._mod = t;
    },	
	
	getCollectTimeInterval: function()
	{
		return this._collectTimeInterval;
	},
	
	setCollectTimeInterval: function(t)
	{
		this._collectTimeInterval = t;
	},
    
    getPlotID: function(){	
        return this._plotID;
			
    },
    
    setPlotID: function(t){
        this._plotID = t;		
    },
    
    getTemplate: function(){
        return StripManager.getStripObjectTemplate(this._templateId);
    },
    
    getId: function(){
        return this._id;
    },
    
    
    getType: function(){
        return this._type;
    },
    
    
    setType: function(t){
        this._type = t;
    },
    
    getSize: function(){
        return this._size;
    },
    
    
    setSize: function(t){
        this._size = t;
    },
	
	getIncome: function() 
	{
		return this._income;
	},
	
	
	setIncome: function(t)
	{
		this._income = t;
	},	
    
    getAssetNames: function(night){
        return this.getTemplate().getAssetNames(night);
    },
    	
	getAssetSize: function() 
	{
		return this._assetSize;
	},
	
	setAssetSize: function(t) 
	{
		this._assetSize = t;	
	},
    
    getName: function(){
        return this._name;
    },
    
    
    setName: function(t){
        this._name = t;
    },
    
    getCost: function(){
        return this._cost;
    },
    
    
    setCost: function(t){
        this._cost = t;
    },
    
	getCompCost: function() {
		return this._compCost;
	},
	
	setCompCost: function(t) {
		this._compCost = t;
	},
	
	getSellAmount: function() {
		
		return this.getTemplate().getSellAmount();
	},
	
    getStarRating: function(){
        return this._starRating;
    },
    
    
    setStarRating: function(t){
        this._starRating = t;
    },
	
	setSold: function( t ) {
		this._sold = t;
	},
	
	isSold: function () {
		return this._sold;
	}, 
	
	isMovable: function() {
		return this._type != StripObjectTemplate.Type.Empty; 
	},
	
	getTemplateID: function() {
		return this._templateId;
	},
	
	

	getData: function() {
		var data = new Object();
		data.nextCollectTime = this.getNextCollectTime();
		data.templateId = this.getTemplateID();
		
		return data;
	},


});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Scene/SceneController'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Scene/SceneController'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Scene/SceneController'] = exports; /**
 * @author will
 */
exports.SceneController = Core.Class.subclass({
    classname: 'SceneController',
    
    initialize: function(){
        this.node = new GL2.Node();
        //this.node.setChildrenDepthGrouped(false);
        
        this.lobby = null;
        this.strip = null;
        this.isSwappingScenes = false;
		this.gamePlaying = null;
    },
	
	destroy: function() {
		this.node.destroy();
	},
    
    createLobbyScene: function(){
    
        if (this.lobby) 
            return;
        this.lobby = new LobbyScene();
    },
    
    createStripScene: function(s){
    
        if (this.strip) 
            return;
        this.strip = new StripScene(s);
    },
    
	setStripSceneVisibility: function(visible) {
		
		if (this.strip) this.strip.setVisible(visible);
	},
	
    showLoadingScene: function(){
    
        NgLogD("SHOW LOADING SCENE");
        
        if (!this._loadingScene) {
            this._loadingScene = new TitleScreen();
            this._loadingScene.setDepth(100);
        }
        
        if (this._loadingScene.getParent() == null) 
            //GL2.Root.addChild(this._loadingScene);
            this.node.addChild(this._loadingScene);
    },
    
    setLoadingScenePercentage: function(percent){
    
        NgLogD("Updating Loading Progress To " + percent);
        
        this._loadingScene.setProgressPercentage(percent);
    },
    
    hideLoadingScene: function(){
    
        NgLogD("HIDE LOADING SCENE");
        
        if (!this._loadingScene) 
            return;
        if (this._loadingScene.getParent() == null) 
            return;
        
        //GL2.Root.removeChild(this._loadingScene);
        this.node.removeChild(this._loadingScene);
    },
    
    loadStripScene: function(child){
        //		if (child && child == this.lobby) {
        //			this.leaveLobby();
        //		}
        //		else if (child) {
        //			this.node.removeChild(child);
        //		}
        //		var scene = new StripScene( Game.SCGame.getStrip() );
        //
        //		this.node.addChild(scene);
        
        var exitingscene = child;
        var basenode = this.node;
        var sc = this;
		if (this.lobby) this.lobby.browser.setEnabled(false);
		if (this.strip) this.strip.lobbyItem.setEnabled(true);
        
		if (!this.strip) 
            this.createStripScene(Game.SCGame.getStrip());
		this.setStripSceneVisibility(true);
        var enteringscene = this.strip;
        
        var TL = new Animation.TransitionLoader(this,basenode, exitingscene, function(basenode, exitingscene){
            
			
			if (exitingscene && sc.lobby == exitingscene) {
                basenode.removeChild(exitingscene);
                exitingscene.stopRevolving();
            } else if (exitingscene){
				basenode.removeChild(exitingscene);
			}
            
        }, enteringscene, function(basenode, enteringscene){
            basenode.addChild(enteringscene);
        });
        
    },
    
	loadStripSceneForCaching: function() {
		
		if (!this.strip) 
            this.createStripScene(Game.SCGame.getStrip());
		
		this.node.addChild(this.strip);	
		this.setStripSceneVisibility(false);	
		
		
	},
	
    //	returnToLobby: function(game){
    //		if (game) {
    //			this.node.removeChild(game);
    //			game.destroy();
    //		}
    //		this.node.addChild(this.lobby);
    //		this.lobby.startRevolving();
    //	},
    //	
    returnToLobby: function(game){
    
        var exitingscene = game;
        var enteringscene = this.lobby;
        var basenode = this.node;
		this.gamePlaying = null;
		if (this.lobby) this.lobby.browser.setEnabled(true);
		if (this.strip) this.strip.lobbyItem.setEnabled(false);
        
        var sc = this;
        var TL = new Animation.TransitionLoader(this,basenode, exitingscene, function(basenode, exitingscene){
            if (exitingscene) {
            
                if (exitingscene == sc.strip) {
                    basenode.removeChild(exitingscene);
                }
                else {
                    basenode.removeChild(exitingscene);
                    exitingscene.destroy();
                }
                
            }
        }, enteringscene, function(basenode, enteringscene){
            basenode.addChild(enteringscene);
            enteringscene.startRevolving();
        });
        
    },
    
    leaveLobby: function(){
        this.node.removeChild(this.lobby);
        this.lobby.stopRevolving();
    },
    
    loadBlackJackScene: function(){
        var exitingscene = this.lobby;
        var basenode = this.node;
        var enteringscene = new BlackJack();
		this.gamePlaying = enteringscene;
		if (this.lobby) this.lobby.browser.setEnabled(false);
        
        var TL = new Animation.TransitionLoader(this,basenode, exitingscene, function(basenode, exitingscene){
            basenode.removeChild(exitingscene);
            exitingscene.stopRevolving();
        }, enteringscene, function(basenode, enteringscene){
            basenode.addChild(enteringscene);
        });
    },
    
    loadTriCardWarScene: function(){
        var exitingscene = this.lobby;
        var basenode = this.node;
        var enteringscene = new TriCardWar();
		this.gamePlaying = enteringscene;
		if (this.lobby) this.lobby.browser.setEnabled(false);
        
        var TL = new Animation.TransitionLoader(this,basenode, exitingscene, function(basenode, exitingscene){
            basenode.removeChild(exitingscene);
            exitingscene.stopRevolving();
        }, enteringscene, function(basenode, enteringscene){
            basenode.addChild(enteringscene);
        });
        
    },
    
    loadBaccaratScene: function(){
        var exitingscene = this.lobby;
        var basenode = this.node;
        var enteringscene = new Baccarat();
		this.gamePlaying = enteringscene;
		if (this.lobby) this.lobby.browser.setEnabled(false);
        
        var TL = new Animation.TransitionLoader(this,basenode, exitingscene, function(basenode, exitingscene){
            basenode.removeChild(exitingscene);
            exitingscene.stopRevolving();
        }, enteringscene, function(basenode, enteringscene){
            basenode.addChild(enteringscene);
        });
        
        
    },
    
    loadBonusGameScene: function(child){
        var exitingscene = child;
        var basenode = this.node;
        var enteringscene = new BonusGame();
        
        var TL = new Animation.TransitionLoader(this,basenode, exitingscene, function(basenode, exitingscene){
            if (exitingscene) {
                basenode.removeChild(exitingscene);
            }
            
        }, enteringscene, function(basenode, enteringscene){
            basenode.addChild(enteringscene);
        });
        
    },
    
    getNode: function(){
        return this.node;
    },
    
    loadSettingsScene: function(){
        var exitingscene = this.lobby;
        var basenode = this.node;
        var enteringscene = new Settings.SettingsPage();
		if (this.lobby) this.lobby.browser.setEnabled(false);
        
        var TL = new Animation.TransitionLoader(this,basenode, exitingscene, function(basenode, exitingscene){
            basenode.removeChild(exitingscene);
            exitingscene.stopRevolving();
        }, enteringscene, function(basenode, enteringscene){
            basenode.addChild(enteringscene);
        });
    },
    
    
    reset: function(){
        if (this.node) {
            this.node.destroy();
            this.node = new GL2.Node();
            //this.node.setChildrenDepthGrouped(false);
            
        }
        
        if (this.lobby) {
            this.lobby.destroy();
            this.lobby = new LobbyScene();
        }
    },
	
	setIsSwappingScenes:function(b){
		this.isSwappingScenes = b;
	},
	isSwappingScenes:function(){
		return this.isSwappingScenes;
		
	}
		

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Strip/StripObjectTemplate'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Strip/StripObjectTemplate'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Strip/StripObjectTemplate'] = exports; /**
 * @author will
 */
var StripObjectModifier = require('Code/StripCity/Game/Strip/StripObjectModifier').StripObjectModifier;
exports.StripObjectTemplate = Core.Class.subclass( 
{
	classname: 'StripObjectTemplate',
	
	Type: {
        /** Isometric. */
		Empty:0,
        Building: 1,
		
    },
	
	initialize: function(id, name, assetPrefix, assetSize, logoImageName, cost, compCost, starRating, size, income, collectTimeInterval, modType, modValue, type)
	{
		//for now only buildings
		
		if (typeof type == 'undefined') type = this.Type.Building;
		
		this._id = id;
		this._name = name;
		this._type = type;
		this._assetPrefix = assetPrefix;
		this._assetSize = assetSize;
		this._logoImageName = logoImageName;
		this._cost = cost;
		this._compCost = compCost;
		this._size = size;
		this._starRating = starRating;
		this._income = income;
		this._collectTimeInterval = collectTimeInterval;
		this._modType = modType;
		this._modValue = modValue;
		this._infoText = '';
		
		this._mod = null;
		
		if (this._modType!=null) {
			this._mod = new StripObjectModifier(this._modType, this._modValue);
		}
		
	},
	
	getId: function() 
	{
		return this._id;
	},
	
	getCollectTimeInterval: function()
	{
		return this._collectTimeInterval;
	},
	
	setCollectTimeInterval: function(t)
	{
		this._collectTimeInterval = t;
	},
	
	
	getType: function() 
	{
		return this._type;
	},
	
	
	setType: function(t)
	{
		this._type = t;
	},
	
	getSize: function() 
	{
		return this._size;
	},
	
	
	setSize: function(t)
	{
		this._size = t;
	},	
	
	getIncome: function() 
	{
		return this._income;
	},
	
	
	setIncome: function(t)
	{
		this._income = t;
	},		
	
	getLogoImageName: function(t) {
		return this._logoImageName;
	},
	
	getAssetPrefix: function() 
	{
		return this._assetPrefix;
	},
	
	setAssetPrefix: function(t)
	{
		this._assetPrefix = t;
	},
	
	getAssetNames: function(night) {
		
	
		var result;
		if (night)
			result = [this.getAssetPrefix() + '-n1.png', this.getAssetPrefix() + '-n2.png'];
		else
			result = [this.getAssetPrefix() + '-d.png'];
		
		return result;	
	},
	
	getAssetSize: function() 
	{
		return this._assetSize;
	},
	
	setAssetSize: function(t) 
	{
		this._assetSize = t;	
	},
	
	getName: function() 
	{
		return this._name;
	},
	
	
	setName: function(t)
	{
		this._name = t;
	},	
	
	getInfoText: function() {
		return this._infoText;
	},
	
	setInfoText: function(infoText) {
		this._infoText = infoText;
	},
	
	getCost: function() 
	{
		return this._cost;
	},
	
	
	setCost: function(t)
	{
		this._cost = t;
	},
	
	getSellAmount: function() {
		
		var total = 0;
		if (this._cost)
			total += this._cost / 2;
		if (this._compCost)
			total += this._compCost * 60;
		
		return total;
	},
	
	getCompCost: function()
	{
		return this._compCost;
	},
	
	setCompCost: function(t)
	{
		this._compCost = t;
	},
	
	getStarRating: function() 
	{
		return this._starRating;
	},
	
	hasMod : function() 
	{
		return this._modType != null;
	},
	
	getMod: function() {
		return this._mod;	
	},
	
	setStarRating: function(t)
	{
		this._starRating = t;
	},
	
	canBuy: function() {
		return (this._type!= this.Type.Empty);
	}
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Settings/Settings'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Settings/Settings'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Settings/Settings'] = exports; exports.Settings = Core.Class.subclass( 
{
	classname: 'Settings',
		
	initialize: function(bg,se,jp)
	{
		this.backgroundmusicon = bg;
		this.soundeffectson = se;
		this.japaneseon = jp;
		
	},
	
	getBackgroundMusicOn: function()
	{
		return this.backgroundmusicon;
	},
	setBackgroundMusicOn: function(b){
		this.backgroundmusicon = b;
	},
	
	getSoundEffectsOn: function()
	{
		return this.soundeffectson;
	},

	setSoundEffectsOn: function(b)
	{
		this.soundeffectson = b;
	},

	getJapaneseOn: function()
	{
		return this.japaneseon;
	},
	setJapaneseOn: function(b)
	{
		this.japaneseon = b;
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Strip/StripObjectModifier'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Strip/StripObjectModifier'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Strip/StripObjectModifier'] = exports; /**
 * @author will
 */
exports.StripObjectModifier = Core.Class.subclass({
    classname: 'StripObjectModifier',
    
    Type: {
        AllWinningsIncrease: 0,
        AllLosingsDecrease: 1,
    
    },
    initialize: function(modType, modValue){
    
        this._type = modType;
        this._value = modValue;
        
    },
    
    getType: function(){
        return this._type;
    },
    
    setType: function(t){
        this._type = t;
    },
    
    getValue: function(){
        return this._value;
    },
    
    setValue: function(t){
        this._value = t;
    },
    
    
    getDescription: function(){
        switch (this._type) {
            case this.Type.AllWinningsIncrease:
				return 'Earn +' + this._value + '% extra on every win';
			case this.Type.AllLosingsDecrease:
				return 'Lose ' + this._value + '% less on every loss';
            default:
                return '';
        }
        
        return '';
    },

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/IAP/IAP'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/IAP/IAP'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/IAP/IAP'] = exports; /**
 * @author will
 */


exports.IAP = Core.Class.subclass({
	classname: 'IAP',
	
	initialize: function(id, name, sd, d, assetName, type, value){
		this._id = id;
		this._name = name;
		this._shortDescription = sd;
		this._description = d;
		this._type = type;
		this._value = value;
		this._assetName = assetName;
		
		
	},
	
	Type: {
		ChipsIAP: 0,
		CompIAP: 1,
		LimitsIAP:2
	},
	
	
    getID: function(){
        return this._id;
    },
    
    setID: function(t){
        this._id = t;
    },
	
    getName: function(){
        return this._name;
    },
    
    setName: function(t){
        this._name = t;
    },

    getDescription: function(){
        return this._description;
    },
    
    setDescription: function(t){
        this._description = t;
    },
	
    getShortDescription: function(){
        return this._shortDescription;
    },
    
    setShortDescription: function(t){
        this._shortDescription = t;
    },	
	
    getAssetName: function(){
        return this._assetName;
    },
    
    setAssetName: function(t){
        this._assetName = t;
    },		
	
	getType: function() {
		return this._type;
	},
	
	getValue: function() {
		return this._value;
	}
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/IAP/Limit'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/IAP/Limit'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/IAP/Limit'] = exports; /**
 * @author will
 */

var IAP = require('Code/StripCity/Game/IAP/IAP').IAP;
exports.Limit = IAP.subclass({
	classname: 'Limit',
	
	initialize: function($super, id, name, sd, d, assetName, type, value, compCost){
		$super(id,name,sd,d,assetName,type,value);
		this._compCost = compCost;
		
	},
	
	getCompCost: function() {
		return this._compCost;
	},
	
	setCompCost: function(t) {
		this._compCost = t;
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Player/ExperienceManager'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Player/ExperienceManager'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Player/ExperienceManager'] = exports; var ExperienceLevelInfo = require('Code/StripCity/Game/Player/ExperienceLevelInfo').ExperienceLevelInfo;

exports.ExperienceManager = Class.singleton( 
{
	classname: 'ExperienceManager',
	
	initialize: function()
	{
		// THIS COLLECTION MUST BE ORDERED BY LEVEL
		this.highestExpRequired = 0;
		//this.highestExpLevelInfo
		this.levelInfoMap = [];
		
		var expLevel = [0,50,150,300,480,750,1000,1300,1650,2050,2500,3050,4000,6500,10400,16300,22700,29500,36900,44900,53100,
						64500,76600,89200,102300,116100,133000,151700,172400,195100,220200,247600,277500,310200,345700,384200,
						425900,471000,519600,571900,628100,688400,753000,822100,895900,974600,1058500,1147600,1242400,1350000];
		
		for (var level=0; level < expLevel.length; level++) {
			var levelInfo = new ExperienceLevelInfo();
			levelInfo.setLevel(level+1);
			levelInfo.setExperienceRequired(expLevel[level]);
			this.addLevelInfo(levelInfo);
		}
		
	},
	
	addLevelInfo: function(levelInfo) {
		
		this.levelInfoMap[levelInfo.getLevel()] = levelInfo;
		
		if (levelInfo.getExperienceRequired() > this.highestExpRequired) {
			this.highestExpRequired = levelInfo.getExperienceRequired();
			this.highestExpLevelInfo = levelInfo;
		}
	},
	
	updatePlayerByExperience: function(player) {
		
		var playerExp = player.getExp();
		var level = this.getLevelForExp(playerExp);
		player.setLevel(level);
		
		if (playerExp > this.highestExpRequired) 
			player.setExp(this.highestExpRequired);
	},
	
	getLevelForExp: function(exp) {
		
		for (var i = this.levelInfoMap.length-1; i >= 0; i--) {
			
			var levelInfo = this.levelInfoMap[i];
			if (exp >= levelInfo.getExperienceRequired())
				return levelInfo.getLevel();	
		}
	},
	
	getExpForLevel: function(level) {
		
		var levelInfo = this.levelInfoMap[level];
		if (levelInfo)
			return levelInfo.getExperienceRequired();
		else
			return this.highestExpRequired;
	},
	
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Player/ExperienceLevelInfo'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Player/ExperienceLevelInfo'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Player/ExperienceLevelInfo'] = exports; 
exports.ExperienceLevelInfo = Core.Class.subclass({
	
	classname: 'ExperienceLevelInfo',
	
	initialize: function() {
		
	},
	
	setLevel: function(level) { this.level = level; },
	setExperienceRequired: function(exp) { this.experienceRequired = exp; },
	
	getLevel: function() { return this.level; },
	getExperienceRequired: function() { return this.experienceRequired; },
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/ActiveEffect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.ActiveEffect = Core.Class.subclass(
/** @lends Audio.ActiveEffect.prototype */
{
	/**
	 * @class The <code>ActiveEffect</code> class constructs objects that control 
	 * the reproduction of an audio effect. Audio effects in Mobage applications are captured as <code>{@link Audio.Effect}</code> objects. 
	 * <code>{@link Audio.Effect}</code> objects handle and load data for an audio effect into memory. 
	 * This seperation allows applications to manage effect data independently of effect reproduction.
	 * <br><br>
	 * <b>Note:</b> You can only specify <code>{@link Audio.Effect}</code> objects to reproduce at instantiation.
	 * 
	 * @example
	 *
	 *   var effect = new Audio.Effect('some_effect.wav');
	 *   var activeEffect = new Audio.ActiveEffect(effect);
	 *   activeEffect.play();
	 * @constructs The default constructor. 	 
	 * @augments Core.Class
	 * @param {Audio.Effect} effect The <code>{@link Audio.Effect}</code> that this <code>ActiveEffect</code> object plays.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(effect)
	{
		this._volume  = 1.0;
		this._loops   = false;
		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter = new Core.MessageEmitter();

		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
		this._setEffect(effect);
	},
	
	/**
	 * Destroy this instance and releases resources on the backend.<br><br>
	 * <b>Note:</b> This call does not destroy the associated <code>{@link Audio.Effect}</code> object.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this.stop();
		this._effect = null;
		this._playCompleteEmitter.destroy();
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Return the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Number} The current volume level.
	 * @see Audio.ActiveEffect#setVolume
	 * @status iOS, Android, Test
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * Calling this changes the volume even if an application is in the middle of reproducing an <code>{@link Audio.Effect}</code> object.
	 * The new volume level applies to any subsequent reproductions of the <code>{@link Audio.Effect}</code> object.
	 * @example Audio.ActiveEffect.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume level. Supported values range between <code>(0-1)</code>. 
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getVolume
	 * @status iOS, Android
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen( { "volume": volume } );
		return this;
	},
	
	/**
	 * Return the loop status for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if looping is enabled.
	 * @see Audio.ActiveEffect#setLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getLoops: function()
	{
		return this._loops;
	},
	
	/**
	 * Set the loop state for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * A looped effect wraps seamlessly from begining to end.
	 * @example Audio.ActiveEffect.setLoops(true);
	 * @param {Boolean} loops Set as <code>true</code> to enable looping.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.ActiveEffect#getLoops
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setLoops: function(loops)
	{
		this._loops = loops;
		this._setLoopsSendGen( { "loops": loops } );
		return this;
	},
	
	/**
	 * Return the <code>Play Complete</code> emitter for the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * The <code>Play Complete</code> emitter notifies applications when reproduction of an <code>{@link Audio.Effect}</code> is complete.<br><br>
	 * <b>Notes:</b>
	 * <ul>
	 *   <li>Any <code>{@link Audio.Effect}</code> object that does not loop uses the <code>Play Complete</code> emitter. </li>
	 * </ul>
	 * @returns {Core.MessageEmitter} The current state of the <code>Play Complete</code> emitter.
	 * @status iOS
	 */
	getPlayCompleteEmitter: function()
	{
		return this._playCompleteEmitter;
	},
	
	/**
	 * Return the play status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>ActiveEffect</code> is reproducing an <code>{@link Audio.Effect}</code>.
	 * @see Audio.ActiveEffect#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause status of the <code>{@link Audio.Effect}</code> this <code>ActiveEffect</code> is reproducing.
	 * @returns {Boolean} Returns <code>true</code> if this <code>(@link Audio.Effect}</code> is in a paused state.
	 * @see Audio.ActiveEffect#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproducing an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>{@link Audio.Effect}</code> is new or in a stopped state,
	 * reproduction starts at the beginning.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is in a paused state, reproduction resumes from the previous position.</li>
	 * <li>If this <code>{@link Audio.Effect}</code> is playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.ActiveEffect#getIsPlaying
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( null );
	},
	
	/**
	 * Pause reproduction of an <code>{@link Audio.Effect}</code>.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is in the process of reproducing an <code>{@link Audio.Effect}</code>, this call pauses reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped or paused state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling this does not trigger the <code>Play Complete</code> emitter.
	 * @see Audio.ActiveEffect#getIsPaused
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( null );
	},
	
	/**
	 * Stop reprodution of an <code>{@link Audio.Effect}</code> object.
	 * <ul>
	 * <li>If this <code>ActiveEffect</code> is currently reproducing an <code>{@link Audio.Effect}</code> or the <code>{@link Audio.Effect}</code> is in a paused state, this call stops reproduction.</li>
	 * <li>If the <code>{@link Audio.Effect}</code> is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * <b>Note:</b> Calling <code>stop()</code> does not trigger the <code>Play Complete</code> emitter.
	 * @status iOS, Android, Test, iOSTested, AndroidTested	 
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( null );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 328
	// Method create = -1
	// Method destroy = 2
	// Method setVolume = 3
	// Method setLoops = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method setEffect = 8
	// Method playComplete = 9
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 9:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in ActiveEffect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[328] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in ActiveEffect.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 328 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 328 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_setVolumeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 328 + "," + 3 + "," + this.__objectRegistryId + "," + obj[ "volume" ]  );
	},
	
	/** @private */
	_setLoopsSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 328 + "," + 4 + "," + this.__objectRegistryId + "," + ( obj[ "loops" ] ? 1 : 0 )  );
	},
	
	/** @private */
	_playSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 328 + "," + 5 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 328 + "," + 6 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 328 + "," + 7 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_setEffectSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 328 + "," + 8 + "," + this.__objectRegistryId + "," + obj[ "effectId" ]  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setVolume: function( volume ) {}
	
	// setLoops: function( loops ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// setEffect: function( effectId ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_setEffect: function(effect)
	{
		this._effect  = effect;
		this._setEffectSendGen({effectId: this._effect.__objectRegistryId});
		return this;
	},

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;

		this._playCompleteEmitter.emit(this);
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Effect'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Effect'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Effect = Core.Class.subclass(
/** @lends Audio.Effect.prototype */
{
	/**
	 * @class The <code>Effect</code> class constructs objects for handling audio resources that comprise an audio effect.
	 * Instantiating these objects allocates resources on the backend.
	 * After creating an <code>Effect</code> object, applications can control reproduction through an <code>{@link Audio.ActiveEffect}</code> object.<br><br>
	 * @example
	 * var effect = new Audio.Effect('Content/explosion.wav');
	 * @constructs The default constructor.<br><br>
	 * The following code is an example of constructing a new <code>Effect</code> object.
	 * @augments Core.Class
	 * @param {String} path A directory path that points to the audio file to load.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	initialize: function(path)
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
		this._setPath(path);
	},
	
	/**
	 * Destroy this instance and release resources on the backend.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	destroy: function()
	{
		this._destroySendGen();
		Core.ObjectRegistry.unregister(this);
	},
	
	/**
	 * Set a directory path to the audio file resource for this <code>Effect</code> object.
	 * @param {String} path The new directory path.
	 * @returns Calls to <code>setPath()</code> return <code>this</code> to support method invocation chaining.
	 */
	_setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen({path: path});
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 326
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Effect._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[326] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 326 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 326 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 326 + "," + 3 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "path" ] )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Device'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Device'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Device'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Device = Core.Class.singleton(
/** @lends Audio.Device.prototype */
{
	classname: 'Device',

	/**
	 * @class The <code>Device</code> class constructs a singleton object that contains audio device properties.
	 * Applications can use <codeDevice</code> objects to control global audio effects volume 
	 * and reproduce detached audio effects.
	 * <br><br>
	 * <b>Note:</b> An application should never directly allocate a singleton.
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	 
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
		this._volume = undefined; // default value

		var KeyValueCache = require('NGCore/Client/Storage/KeyValue').KeyValueCache;
		var initialValues = KeyValueCache.global("Audio.Device.InitialValues");

		var self = this;
		initialValues.getItem("effectsVolume", function(error, value) {
			self._volume = parseFloat(value);
		});
	},
	
	/**
	 * Return the global sound effects volume for this <code>Device</code> object.
	 * @returns {Number} The current global sound effects volume.
	 * @see Audio.Device#setEffectsVolume	 
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getEffectsVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the global sound effects volume for this <code>Device</code> object.
	 * Volume for each active effect multiplies
	 * by this value to produce a new volume level. 
	 * For example, if the global sound effects volume is set to 0.5, each active effect will play at half the volume set on the effect.
	 * @param {Number} [effectsVolume=1] The new volume for global sound effects. 
	 * Supported values range between <code>(0-1)</code>. 
	 * @example Audio.Device.setEffectsVolume(0.5);
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Device#getEffectsVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setEffectsVolume: function(effectsVolume)
	{
		if (effectsVolume < 0.0) effectsVolume = 0.0;
		if (effectsVolume > 1.0) effectsVolume = 1.0;

		this._volume = effectsVolume;
		this._setEffectsVolumeSendGen( { "effectsVolume": effectsVolume } );
		return this;
	},
	
	/**
	 * Play an audio effect in a way that is completely detached from upstream or downstream processing.
	 * Using this call is a simple, high-level way to reproduce an audio effect.<br><br>
	 * The specified audio effect is only reproduced once.
	 * There is no control over the effect volume or effect playback.
	 * Resource allocation automatically occurs on the backend when playback begins. Resources are automatically released when playback ends.	 
	 * The following code is an example of a <code>playDetached()</code> call.
	 * @example
	 * Audio.Device.playDetached('Content/explosion.wav');
	 * @param {String} path A relative directory path to the audio file.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	playDetached: function(path)
	{
		this._playDetachedSendGen( { "path": path } );
		return this;
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 327
	// Method create = -1
	// Method setEffectsVolume = 2
	// Method playDetached = 3
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Device._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[327] = h; return h;})(),
	
	/////// Private recv methods.
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 327 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_setEffectsVolumeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 327 + "," + 2 + "," + this.__objectRegistryId + "," + obj[ "effectsVolume" ]  );
	},
	
	/** @private */
	_playDetachedSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 327 + "," + 3 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "path" ] )  );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// setEffectsVolume: function( effectsVolume ) {}
	
	// playDetached: function( path ) {}
	

// {{/Wg Generated Code}}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['NGCore/Client/Audio/Music'] = function(){var exports = $MODULE_REGISTRY['NGCore/Client/Audio/Music'] || {}; $MODULE_REGISTRY['NGCore/Client/Audio/Music'] = exports; var Core = require('NGCore/Client/Core').Core;

exports.Music = Core.Class.singleton(
/** @lends Audio.Music.prototype */
{
	classname: 'Music',

	/**
	 * @class The <code>Music</code> class constructs a singleton object that provides control over reproduction
	 * of application background music.
	 * This object is constructed independently of <code>Device</code> objects because many devices
	 * already provide hardware-accelerated streaming and decode
	 * for a single background music track. Some
	 * devices gracefully mute a background music track
	 * if the user is playing a music track from their own library.
	 * <br><br>
	 * <b>Note:</b> Applications should never directly allocate a singleton.
	 * @example 
	 * var background = new Audio.Music('Content/music.mp3');
	 * @constructs The default constructor. 
	 * @augments Core.Class
	 */
	initialize: function()
	{
		Core.ObjectRegistry.register(this);
		this._createSendGen(this);
		this._path    = null;
		this._playing = false;
		this._paused  = false;
		this._volume  = 1.0;
	},
	
	/**
	 * Return the directory path to the background music file used as a resource for this <code>Music</code> object.
	 * @returns {String} The directory path to a music file.
	 * @see Audio.Music#setPath
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getPath: function()
	{
		return this._path;
	},
	
	/**
	 * Set the directory path for the background music file that this <code>Music</code> object loads.<br><br>
	 * <b>Note:</b> If the application is reproducing music when this is called, reproduction will stop.
	 * The application must call <code>play()</code> again to start reproduction of the new resource.<br><br>
	 * The code in the following example sets a directory path to a music resource and plays that resource.
	 * @example
	 * Audio.Music.setPath('Content/music.mp3');
	 * Audio.Music.play();
	 *
	 * @param {string} path The new directory path to a music file.
	 * @see Audio.Music#getPath,
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setPath: function(path)
	{
		this._path = path;
		this._setPathSendGen( { "path": path } );
	},
	
	/**
	 * Return the volume level used for reproduction of this <code>Music</code> object.
	 * @returns {Number} The current volume level.
	 * @see Audio.Music#setVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getVolume: function()
	{
		return this._volume;
	},
	
	/**
	 * Set the volume level used for reproduction of this <code>Music</code> object.
	 * This call instantly modifies the background music volume level.
	 * Any subsequent reproductions of background music will play at the specified volume.
	 * @example Audio.Music.setVolume(0.5);
	 * @param {Number} [volume=1] The new volume. Supported values range between <code>(0-1)</code>.
	 * @returns This function returns <code>this</code> to support method invocation chaining.
	 * @see Audio.Music#getVolume
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	setVolume: function(volume)
	{
		if (volume < 0.0) volume = 0.0;
		if (volume > 1.0) volume = 1.0;

		this._volume = volume;
		this._setVolumeSendGen( { "volume": volume } );
		return this;
	},
	
	/**
	 * Return the playback state of this <code>Music</code> object. 
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#play
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPlaying: function()
	{
		return this._playing;
	},
	
	/**
	 * Return the pause state of this <code>Music</code> object.
	 * @returns {Boolean} Returns <code>true</code> if an application is reproducing background music.
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	getIsPaused: function()
	{
		return this._paused;
	},
	
	/**
	 * Begin reproduction of this <code>Music</code> object.
	 * <ul>	
	 * <li>If this <code>Music</code> object is a new background music track, or the application has stopped the current background music track, 
	 * this call begins reproduction from the beginning.</li>
	 * <li>If the background music track is in a paused state, this call resumes reproduction from the previous position.</li>
	 * <li>If the background music track is currently playing, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPlaying,
	 * @see Audio.Music#pause,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	play: function()
	{
		this._playing = true;
		this._paused  = false;
		this._playSendGen( null );
	},
	
	/**
	 * Pause reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If an application is currently reproducing a background music track, this call pauses reproduction.</li>
	 * <li>If the background music track is in a paused or stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#getIsPaused
	 * @see Audio.Music#play,
	 * @see Audio.Music#stop
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	pause: function()
	{
		this._playing = false;
		this._paused  = true;
		this._pauseSendGen( null );
	},
	
	/**
	 * Stop reproduction of this <code>Music</code> object.
	 * <ul>
	 * <li>If the background music track is playing or in a paused state, this call stops playback.</li>
	 * <li>If the background music track is in a stopped state, this call does nothing.</li>
	 * </ul>
	 * @see Audio.Music#play,
	 * @see Audio.Music#pause
	 * @status iOS, Android, Test, iOSTested, AndroidTested
	 */
	stop: function()
	{
		this._playing = false;
		this._paused  = false;
		this._stopSendGen( null );
	},
	
// {{?Wg Generated Code}}
	
	///////
	// Class constants (for internal use only):
	// Class ID = 329
	// Method create = -1
	// Method destroy = 2
	// Method setPath = 3
	// Method setVolume = 4
	// Method play = 5
	// Method pause = 6
	// Method stop = 7
	// Method playComplete = 8
	
	/** 
	 * Command dispatch.
	 * @private
	 */
	$_commandRecvGen: (function() { var h = (function ( cmd )
	{
		var cmdId = Core.Proc.parseInt( cmd.shift() );
		
		if( cmdId > 0 )	// Instance Method.
		{
			var instanceId = Core.Proc.parseInt( cmd.shift() );
			var instance = Core.ObjectRegistry.idToObject( instanceId );
			
			if( ! instance )
			{
				NgLogE("Object instance could not be found for command " + cmd + ". It may have been destroyed this frame.");
				return;
			}
			
			switch( cmdId )
			{
				
				case 8:
					instance._playCompleteRecv( cmd );
					break;
				default:
					NgLogE("Unknown instance method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
		else			// Static method.
		{
			switch( cmdId )
			{
				
				default:
					NgLogE("Unknown static method id " + cmdId + " in Music._commandRecvGen from command: " + cmd );
					return;
			}
		}
	}); if(typeof(PROC_DISPATCH_TABLE) == 'undefined') PROC_DISPATCH_TABLE = {}; PROC_DISPATCH_TABLE[329] = h; return h;})(),
	
	/////// Private recv methods.
	
	/** @private */
	_playCompleteRecvGen: function( cmd, obj )
	{ 
		if( cmd.length != 0 )
		{
			NgLogE("Could not parse due to wrong argument count in Music.playComplete from command: " + cmd );
			return false;
		}
		
		return true;
	},
	
	/////// Private send methods.
	
	/** @private */
	$_createSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 329 + "," + -1  + "," + obj[ "__objectRegistryId" ]  );
	},
	
	/** @private */
	_destroySendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 329 + "," + 2 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_setPathSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 329 + "," + 3 + "," + this.__objectRegistryId + "," + Core.Base64.encode( obj[ "path" ] )  );
	},
	
	/** @private */
	_setVolumeSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 329 + "," + 4 + "," + this.__objectRegistryId + "," + obj[ "volume" ]  );
	},
	
	/** @private */
	_playSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 329 + "," + 5 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_pauseSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 329 + "," + 6 + "," + this.__objectRegistryId );
	},
	
	/** @private */
	_stopSendGen: function( obj )
	{
		Core.Proc.appendToCommandString( ":" + 329 + "," + 7 + "," + this.__objectRegistryId );
	},
	
	// This class is expected to implement the following methods outside of
	// the generated block:
	// $create: function( __objectRegistryId ) {}
	
	// destroy: function(  ) {}
	
	// setPath: function( path ) {}
	
	// setVolume: function( volume ) {}
	
	// play: function(  ) {}
	
	// pause: function(  ) {}
	
	// stop: function(  ) {}
	
	// _playCompleteRecv: function( cmd ) {}

// {{/Wg Generated Code}}

	_playCompleteRecv: function( cmd )
	{
		var msg = {};
		if(!this._playCompleteRecvGen(cmd, msg))
			return;

		this._playing = false;
		this._paused  = false;
	}
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/SCAudio/SCAudio'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/SCAudio/SCAudio'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/SCAudio/SCAudio'] = exports; 

exports.SCAudio = Core.Class.subclass({
    classname: 'SCAudio',
    
    initialize: function(){
        this.soundeffectson = SCGame.getSettings().getSoundEffectsOn();
        this.backgroundmusicon = SCGame.getSettings().getBackgroundMusicOn();
        this.updateListener = null;
        
        this.sf = new Array();
        for (var x = 0; x < 13; x++) {
            switch (x + 1) {
                case 1:
                    contentpath = 'Content/sfx/bet-placechips.mp3';
                    break;
                case 2:
                    contentpath = 'Content/sfx/bet-removechips.mp3';
                    break;
                case 3:
                    contentpath = 'Content/sfx/building-create.mp3';
                    break;
                case 4:
                    contentpath = 'Content/sfx/building-sell.mp3';
                    break;
                case 5:
                    contentpath = 'Content/sfx/collect-income.mp3';
                    break;
                case 6:
                    contentpath = 'Content/sfx/hand-cardmove.mp3';
                    break;
                case 7:
                    contentpath = 'Content/sfx/hand-lose.mp3';
                    break;
                case 8:
                    contentpath = 'Content/sfx/hand-tie.mp3';
                    break;
                case 9:
                    contentpath = 'Content/sfx/hand-win.mp3';
                    break;
                case 10:
                    contentpath = 'Content/sfx/menu.mp3';
                    break;
                case 11:
                    contentpath = 'Content/sfx/menu.mp3';
                    break;
                case 12:
                    contentpath = 'Content/sfx/wheel-spin.mp3';
                    break;
                case 13:
                    contentpath = 'Content/sfx/wheel-win.mp3';
                    break;
            }
            this.sf.push(new createPlayOnce(contentpath));
        }
        
    },
    playsound: function(soundkey){
        this.soundeffectson = SCGame.getSettings().getSoundEffectsOn();
        if (this.soundeffectson) {
            this.sf[soundkey - 1].playActiveEffect();
        }
    },
    
    playbackgroundmusic: function(musickey){
    
        this.backgroundmusicon = SCGame.getSettings().getBackgroundMusicOn();
        
        if (this.backgroundmusicon) {
        
            this.updateListener = new this.ChangeMusicUpdateListener(musickey);
            Core.UpdateEmitter.addListener(this.updateListener, this.updateListener.onUpdate);
            
        }
        else 
            if (Audio.Music.getIsPlaying()) 
                Audio.Music.stop();
        
    },
    
    
    
    $ChangeMusicUpdateListener: Core.MessageListener.subclass({
    
        initialize: function(musickey){
            this.musickey = musickey;
            
            this.bgvolume = -1000;
            this.setnewsong = false;
            
            if (!Audio.Music.getIsPlaying()) {
                this.bgvolume = 0;
            }
            
            
            this.bgmusic = new Array();
            this.bgmusic.push('Content/bgm/bgm-lobby1.mp3');
            this.bgmusic.push('Content/bgm/bgm-lobby2.mp3');
            this.bgmusic.push('Content/bgm/bgm-lobby3.mp3');
            this.bgmusic.push('Content/bgm/bgmusic3.mp3');
            this.bgmusic.push('Content/bgm/bgm_casino_ambience.mp3');
            this.bgmusic.push('Content/bgm/bgm-strip.mp3');
            this.bgmusic.push('Content/bgm/bgm-title.mp3');
            
        },
        onUpdate: function(delta){
        
        
        
            //when it detects a change in music key...
            if (Audio.Music.getPath() != this.bgmusic[this.musickey]) {
            
                if (delta > 1000) {
                    Audio.Music.stop();
                    this.setMusic(this.musickey);
                    Audio.Music.setVolume(1);
                    Core.UpdateEmitter.removeListener(this);
					return					
                }
                
                //always starts at -1000...
                this.bgvolume += delta;
                if (this.bgvolume > -1000 && this.bgvolume < 0) {
                    
                    //this will affectively fade it down.
                    Audio.Music.setVolume(Math.abs(this.bgvolume) / 1000);
                }
                //then at the next second it will increase the volume
                if (this.bgvolume < 1000 && this.bgvolume >= 0) {

                    if (!this.setnewsong) {
                        Audio.Music.stop();
                        this.setMusic(this.musickey);
                        this.setnewsong = true;
                    }
                    Audio.Music.setVolume((this.bgvolume) / 1000);
                }
            }
            
            if (this.setnewsong) {
                this.bgvolume += delta;
                if (this.bgvolume > 1000) {
                    this.setnewsong = false;
                    this.bgvolume = 1000;
                    Audio.Music.setVolume((this.bgvolume) / 1000);
                    Core.UpdateEmitter.removeListener(this);
                }
            }
        },
        setMusic: function(musickey){
            Audio.Music.setPath(this.bgmusic[musickey]);
            Audio.Music.play();
        },
        
        changeMusicKey: function(mk){
            this.musickey = mk;
        },
    }),

});

var createPlayOnce = Core.MessageListener.subclass({
    initialize: function(contentpath){
        this._effect = new Audio.Effect(contentpath);
        this._activeEffect = new Audio.ActiveEffect(this._effect);
        //this._activeEffect.setVolume(1);
        emitter = this._activeEffect.getPlayCompleteEmitter();
        emitter.addListener(this, this.playCompleted);
    },
    
    playActiveEffect: function(){
        this._activeEffect.play();
    },
    
    playCompleted: function(emitter){
        this._effect.destroy();
        this._activeEffect.destroy();
    },

});




; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Menu/Menu'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Menu/Menu'] || {}; $MODULE_REGISTRY['Code/G6/Menu/Menu'] = exports; /**
 * @author will
 */
exports.Menu = Animation.AnimatedNode.subclass({
	
	classname:'Menu',
	
    initialize: function(items, dontAlign){
			
		
		for (var i in items) {

			var child = items[i];
			this.addChild(child);
			
		}

		if (!dontAlign)
			this.alignItemsHorizontally();
			
		this._touchListener = new this.MenuTouchListener( this );
		this.addChild(this._touchListener.getListener());
		
    },
	
	alignItemsHorizontally: function (padding) {
		if (typeof padding == 'undefined') padding = 5;	
		
		var width = -padding;
		for (var i in this._children) {
			var child = this._children[i];
			
			if (child.classname == 'TouchTarget') continue;
			width += child.getSize().getWidth() * child.getScale().getX() + padding;
		}

		var x = -width / 2.0;
		
		for (var i in this._children) {
			var child = this._children[i];
			NgLogD('classname = ' + child.classname);
			if (child.classname == 'TouchTarget') continue;			
			child.setPosition ( new Core.Point(  x  + child.getSize().getWidth() * child.getScale().getX() / 2, 0));
			x += child.getSize().getWidth() * child.getScale().getX() + padding;
		}
	},
	
	alignItemsVertically: function (padding) {
		if (typeof padding == 'undefined') padding = 5;
		
		var height = -padding;
		for (var i in this._children) {
			var child = this._children[i];
			
			if (child.classname == 'TouchTarget') continue;
			height += child.getSize().getHeight() * child.getScale().getY() + padding;
		}
		
		var y = -height / 2.0;
		
		for (var i in this._children) {
			var child = this._children[i];
			NgLogD('classname = ' + child.classname);
			if (child.classname == 'TouchTarget') continue;			
			child.setPosition ( new Core.Point( 0, y  + child.getSize().getHeight() * child.getScale().getY() / 2));
			y += child.getSize().getHeight() * child.getScale().getY() + padding;
		
		}		
		
		
	},
	
	itemForTouch: function ( touch ) {

		
		for (var i in this._children) {
			var child = this._children[i];
			
			if (child.classname == 'TouchTarget') continue;
			if (!child.isEnabled()) continue;
			
			var local = child.screenToLocal ( touch.getPosition() );
			
			//figures out the top left origin, since 0,0 is where the anchorpoint is, we normalize it to the top left origin.
			var topLeftOrigin = Util.getPositionForAnchorPointGivenValues ( new Core.Point(0,0), child.getSize(), child.getAnchor(), new Core.Point(0,0));
			var itemRect = new Core.Rect (topLeftOrigin.getX(),topLeftOrigin.getY(),child.getSize().getWidth(), child.getSize().getHeight());
			
//			NgLogD('local point =' + Util.pointToString(local) + ' top left origin = ' + Util.pointToString(topLeftOrigin));
						
			//then check to see if the point is within that space.
			if (Util.rectContainsPoint(itemRect, local)) {
				return child;
			}
			
		} 
		
		return null;		
	},
	
	destroy: function($super) {
		for (var i in this._children) {
			this._children[i].destroy();
		}
		$super();
	},
	
	$MenuTouchListener: Core.MessageListener.subclass({
 	
		classname: 'MenuTouchListener',
	
        initialize: function( menu ){
            this._menu = menu;
            
            // Choose a random start time.
            this._target = new GL2.TouchTarget();
			//assume menus are middle anchor point.. for now.
			this._target.setAnchor(new Core.Point (0.5,0.5));
            //this._target.setSize(new Core.Size(Core.Capabilities.getScreenWidth(), Core.Capabilities.getScreenHeight()));
			this._target.setSize(new Core.Size(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenWidth()));			
            this._target.getTouchEmitter().addListener(this, this.onTouch);
            
        },
        
        getListener: function(){
            return this._target;
        },
        
        onTouch: function(touch){
			
            switch (touch.getAction()) {
                case touch.Action.Start:
					//keeps track of previous touches
					if (this._trackingId != touch.getId()) 
					{
						this._previousItem = this._currentItem;
					}
					else this._previousItem = null;
					
             		this._trackingId = touch.getId();   
					
					var item = this._menu.itemForTouch(touch);
					if (!item) return;  
					
					this._currentItem = item;
					this._currentItem.activate();             
                    return true;
                case touch.Action.End:
					//kills previous touch
                    if (this._trackingId != touch.getId()) 
					{
						if (this._previousItem)
							this._previousItem.inactivate();
                        return;
					}
					
					//remove touch if button is disabled while holding down button
					if (this._currentItem) {
						if (typeof this._currentItem.isEnabled != 'undefined') {
							if (!this._currentItem.isEnabled())
								return;
						}
					}
					
                   	//call action
					if (this._currentItem) this._currentItem.inactivate();
					if (this._currentItem) {
						//call action
						this._currentItem.executeAction();
					}
					return true;
                    break;
                case touch.Action.Move:
				//kills previous touch
                    if (this._trackingId != touch.getId()) 
					{
						if (this._previousItem)
							this._previousItem.inactivate();
                        return;
					}
						
					//remove touch if button is disabled while holding down button
					if (this._currentItem) {
						if (typeof this._currentItem.isEnabled != 'undefined') {
							if (!this._currentItem.isEnabled())
								break;
						}
					}
					
					//check to see if it has changed..
					var item = this._menu.itemForTouch(touch);
					
					if ( this._currentItem != item) {
						
						if (this._currentItem) this._currentItem.inactivate();
						this._currentItem = item;
						if (this._currentItem) this._currentItem.activate();						
					}					
                    break;
            }
        },

		destroy: function($super) {
			this._target.getTouchEmitter().removeListener(this);
			for (var i in this._children) {
				this._children[i].destroy();
			}
			$super();
		},
    }),	
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Menu/AnimationFrameMenuItem'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Menu/AnimationFrameMenuItem'] || {}; $MODULE_REGISTRY['Code/G6/Menu/AnimationFrameMenuItem'] = exports; /**
 * @author will
 */
exports.AnimationFrameMenuItem = GL2.Node.subclass({
	classname: 'AnimationFrameMenuItem',
	
	setFrames : function ( inactive, active, disabled ) {
		if (typeof active == 'undefined') active = inactive;
		if (typeof disabled == 'undefined') disabled = inactive;
		this._inactiveFrame = inactive;
		this._activeFrame = active;
		this._disabledFrame = disabled;
		
		this._enabled = true;
		this._target = null;


		//set the animation frame..
		this._itemNode = new GL2.Sprite();
//		this._itemNode.setImage('Content/kakashi.png',[60, 80]);
		var a = new GL2.Animation();
		a.pushFrame(this._inactiveFrame);
		this._itemNode.setAnimation(a);
		
		//this.setChildrenDepthGrouped(false);
		
		this.addChild(this._itemNode);		

	},
	
	
	inactivate: function() {
		//when button is idle and not doing anything
		this._itemNode.getAnimation().setFrame(0,this._inactiveFrame);
	},
	
	
	activate: function() {
		//when the button is pressed..
		this._itemNode.getAnimation().setFrame(0,this._activeFrame);		
		//call function
			
	},
	
	setAction: function(action) {
		this._action = action;
	},
	
	setTarget: function(target) {
		this._target = target;
	},	
	
	getTarget: function() {
		return this._target;
	},
	
	executeAction: function() {
		if (this._target == null) {
			if (typeof this._action != 'undefined') {
				this._action();				
			}
			return;
		}
		this._action.call(this._target);
	},
	
	setTouchPosition: function( pt ) {
		this._touchListener.getListener().setPosition( pt);
	},
	
	disable: function() {
		//when the button is disabled..
		this._itemNode.getAnimation().setFrame(0,this._disabledFrame);		
	},
	
	getInactiveSprite: function() {
		return this._inactiveFrame;
	},
	
	getSize: function() {
		return this._inactiveFrame.getSize();
	},	
	
	getAnchor: function() {
		return this._inactiveFrame.getAnchor();
	},		
	
	enable: function() {
		this._itemNode.getAnimation().setFrame(0,this._inactiveFrame);	
	},
	
	getListener: function() {
		return this._touchListener.getListener();
	},
	
	isEnabled: function() {
		return this._enabled;
	},
	
	setEnabled: function( a ) {

		if (this._enabled == a) return;
		
		this._enabled = a;
		
		if (!this._enabled) {
			this.disable();
		}
		else {
			this.enable();
		}
		
		
	},
	

	
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Menu/RadioButton'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Menu/RadioButton'] || {}; $MODULE_REGISTRY['Code/G6/Menu/RadioButton'] = exports; 
exports.RadioButton = Node.subclass({
	
	classname:'RadioButton',
	
    initialize: function( items ){
		
		for (var i in items) {

			var child = items[i];
			this.addChild(child);
			
		}

		this.alignItemsVertically(1);
		this._touchListener = new this.RadioButtonTouchListener( this );
		this.addChild(this._touchListener.getListener());
    },
	
	
	
	alignItemsHorizontally: function (padding) {
//		if (typeof padding == 'undefined') padding = 5;
		
		var width = -padding;
		for (var i in this._children) {
			var child = this._children[i];
			
			if (child.classname == 'TouchTarget') continue;
			width += child.getSize().getWidth() * child.getScale().getX() + padding;
		}
		
		var x = -width / 2.0;
		
		for (var i in this._children) {
			var child = this._children[i];
			NgLogD('classname = ' + child.classname);
			if (child.classname == 'TouchTarget') continue;			
			child.setPosition ( new Core.Point(  x  + child.getSize().getWidth() * child.getScale().getX() / 2, 0));
			x += child.getSize().getWidth() * child.getScale().getX() + padding;
		
		}		
		
		
	},

	alignItemsVertically: function (padding) {
		if (typeof padding == 'undefined') padding = 5;
		
		var height = -padding;
		for (var i in this._children) {
			var child = this._children[i];
			
			if (child.classname == 'TouchTarget') continue;
			height += child.getSize().getHeight() * child.getScale().getY() + padding;
		}
		
		var y = -height / 2.0;
		
		for (var i in this._children) {
			var child = this._children[i];
			NgLogD('classname = ' + child.classname);
			if (child.classname == 'TouchTarget') continue;			
			child.setPosition ( new Core.Point( 0, y  + child.getSize().getHeight() * child.getScale().getY() / 2));
			y += child.getSize().getHeight() * child.getScale().getY() + padding;
		
		}		
		
		
	},
	getAllChildren:function()
	{
		return this._children;
		
	},
	setSelected:function(count)
	{
		if (this._children.length < count)	return;
			
		this._children[count].activate();
		this._children[count].executeAction();
	},
	
	itemForTouch: function ( touch ) {

		
		for (var i in this._children) {
			var child = this._children[i];
			
			if (child.classname == 'TouchTarget') continue;
			if (!child.isEnabled()) continue;
			
			var local = child.screenToLocal ( touch.getPosition() );
			
			//figures out the top left origin, since 0,0 is where the anchorpoint is, we normalize it to the top left origin.
			var topLeftOrigin = Util.getPositionForAnchorPointGivenValues ( new Core.Point(0,0), child.getSize(), child.getAnchor(), new Core.Point(0,0));
			var itemRect = new Core.Rect (topLeftOrigin.getX(),topLeftOrigin.getY(),child.getSize().getWidth(), child.getSize().getHeight());
			
//			NgLogD('local point =' + Util.pointToString(local) + ' top left origin = ' + Util.pointToString(topLeftOrigin));
						
			//then check to see if the point is within that space.
			if (Util.rectContainsPoint(itemRect, local)) {
				return child;
			}
			
		} 
		
		return null;		
	},
	
	destroy: function($super) {
		for (var i in this._children) {
			this._children[i].destroy();
		}
		$super();
	},
	
	
	$RadioButtonTouchListener: Core.MessageListener.subclass({
 	
		classname: '$RadioButtonTouchListener',
	
        initialize: function( menu ){
            this._menu = menu;
            
            // Choose a random start time.
            this._target = new GL2.TouchTarget();
			//assume menus are middle anchor point.. for now.
			this._target.setAnchor(new Core.Point (0.5,0.5));
            //this._target.setSize(new Core.Size(Core.Capabilities.getScreenWidth(), Core.Capabilities.getScreenHeight()));
			this._target.setSize(new Core.Size(Core.Capabilities.getScreenHeight(), Core.Capabilities.getScreenWidth()));			
            this._target.getTouchEmitter().addListener(this, this.onTouch);
            
        },
        
        getListener: function(){
            return this._target;
        },
		
        
        onTouch: function(touch){
            switch (touch.getAction()) {
                case touch.Action.Start:
					NgLogD('menu clicked');
             		this._trackingId = touch.getId();   
					
					var item = this._menu.itemForTouch(touch);
					if (!item) return;  
					
					this._currentItem = item;
					this._currentItem.activate();  
					
	
		          
                    return true;
                case touch.Action.End:
					NgLogD('end');  
                    if (this._trackingId != touch.getId()) 
                        return;
						
                   	//call action
					//if (this._currentItem) this._currentItem.inactivate();
					var cs = this._menu.getAllChildren();		
					
					var item = this._menu.itemForTouch(touch);
					for (var i in cs) {
					var child = cs[i];
					
					if (child.classname == 'TouchTarget') continue;
					if (child != item)
						child.inactivate();
					}
		
					if (this._currentItem) {
						//call action
						this._currentItem.executeAction();
					}
					return true;
                    break;
                case touch.Action.Move:
                    if (this._trackingId != touch.getId()) 
                        return;
					//check to see if it has changed..
					var item = this._menu.itemForTouch(touch);
					
					if ( this._currentItem != item) {
						
						if (this._currentItem) this._currentItem.inactivate();
						this._currentItem = item;
						if (this._currentItem) this._currentItem.activate();						
					}					
                    break;
            }
        },
		
		destroy: function($super) {
			this._target.getTouchEmitter().removeListener(this);
			for (var i in this._children) {
				this._children[i].destroy();
			}
			$super()
		},
    }),	
	
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Browser/SmoothBrowser'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Browser/SmoothBrowser'] || {}; $MODULE_REGISTRY['Code/G6/Browser/SmoothBrowser'] = exports; /**
 * @author will
 */
var Util = require('Code/G6/Util/Util').Util;
var AnimatedNode = require('Code/G6/Animation/AnimatedNode').AnimatedNode;
var BrowserOptions = require('Code/G6/Browser/BrowserOptions').BrowserOptions;

/**
 * @author will
 */
exports.SmoothBrowser = AnimatedNode.subclass({

    classname: 'SmoothBrowser',
    
    initialize: function(blocks, browserOptions){
    
        this._browserOptions = browserOptions;
        this._blocks = blocks;
        this._origin = this.getPosition().clone();
        this._locked = false;
        
        this._touchTarget = new GL2.TouchTarget();
        this._scrollTouchHandler = new this.BrowserScrollTouchHandler(this, true);
        //        this._touchTarget.setSize(this._browserSize);
        //		this._touchTarget.setAnchor(new Core.Point(0.5,0.5));
        this._touchTarget.getTouchEmitter().addListener(this._scrollTouchHandler, this._scrollTouchHandler.onTouch);
        
        //     this.addChild(this._touchTarget);
        this._blockMap = [];
        
        for (var i in this._blocks) {
            var block = this._blocks[i];
            this.addBlock(block.getId(), block);
        }
        
        this.setBrowserSizeByBlocks();
        
        this.calculatePositions(this._blocks);
    },
    
    setBrowserSizeByBlocks: function(){
    
        var xSize = 0;
        for (var i in this._blocks) {
            var block = this._blocks[i];
            xSize += block.getSize().getWidth();
			if (i != 0) {
				//added to include spacing for centering of browser
				xSize += this._browserOptions.getSpacing();
			}
        }
        
        var ySize = Core.Capabilities.getScreenHeight();
        this._browserSize = new Core.Size(xSize, ySize);
    },
    
    // browserSize should be set before this is called
    calculatePositions: function(blocks){
        //var yPos = this._browserSize.getHeight() / 2;
        var xPos = 0;
        var blockWidth;
        for (var i in blocks) {
            var block = blocks[i];
            blockWidth = block.getSize().getWidth();
            
            // theres no anchor point to set... do it manually
            if (xPos == 0) 
                xPos = blockWidth / 2;
            
            //block.setPosition(xPos,yPos);
            block.setPosition(xPos, this._browserOptions.getYPosition());
            xPos += blockWidth + this._browserOptions.getSpacing();
            
        }
    },
    
	setLocked: function(locked) {
		this._locked = locked;
	},
	
    getOrigin: function(){
        return this._origin;
    },
    
    setEnabled: function(enabled){
        this.setVisible(enabled);
        this.setTouchable(enabled);
        this._touchTarget.setTouchable(enabled);
    },
    
    getTouchTarget: function(){
        return this._touchTarget;
    },
    
    getBlock: function(identity){
        return this._blockMap[identity];
    },
    
    addBlock: function(identity, img){
    
        this._blockMap[identity] = img;
        this.addChild(img);
    },
    
    objectForTouch: function(touch){
    
    
        for (var i in this._blockMap) {
            var obj = this._blockMap[i];
            
            if (!obj) 
                continue;
            
            var local = obj.screenToLocal(touch.getPosition());
            
            //figures out the top left origin, since 0,0 is where the anchorpoint is, we normalize it to the top left origin.
            var topLeftOrigin = Util.getPositionForAnchorPointGivenValues(new Core.Point(0, 0), obj.getSize(), obj.getAnchor(), new Core.Point(0, 0));
            var itemRect = new Core.Rect(topLeftOrigin.getX(), topLeftOrigin.getY(), obj.getSize().getWidth(), obj.getSize().getHeight());
            
            if (Util.rectContainsPoint(itemRect, local)) {
                return obj;
            }
            
        }
        
        return null;
    },
    
    getBrowserOptions: function(){
        return this._browserOptions;
    },
    
    getBrowserSize: function(){
        return this._browserSize;
    },
    
    $BrowserScrollTouchHandler: Core.MessageListener.subclass({
        initialize: function(browser, lockY){
        
            this._browser = browser;
            this._target = browser.getTouchTarget();
            this._snapLeft = false;
            this._snapRight = false;
            this._bounceBackPixels = 10;
            this._swipeAccelAnchorX = [];
            this._swipeAccelAnchorY = [];
            this._swipeHistoryCount = 3;
            
            if (typeof lockY == 'undefined') 
                lockY = false;
            
            this._lockY = lockY;
        },
        
        getTouchTarget: function(){
            return this._target;
        },
        
        getWidthForSnapRight: function(){
            var browserWidth = this._browser.getBrowserSize().getWidth();
            var windowWidth = Util.screenSize(true).getWidth();
            
            return browserWidth >= windowWidth ? browserWidth - windowWidth : 0;
        },
        
        onTouch: function(touch){
            switch (touch.getAction()) {
                case touch.Action.Start:
                    
                    NgLogD('smooth browser touch');
					// keeps track of touches
                    if (this._trackingId != touch.getId()) 
					{
						this._previoustouchedBlock = this._touchedBlock;
					}
					else this._previoustouchedBlock = null;
					
					
                    this._trackingId = touch.getId();
                    this._trackingCurrent = touch.getPosition();
                    
					var options = this._browser.getBrowserOptions();
					var yPos = this._trackingCurrent.getY();
					this._isInYBounds = yPos >= options.getYScreenTopBounds() && yPos <= options.getYScreenBottomBounds();
					if (!this._isInYBounds) return;
					
					this._browser.stopAllActions();
					
                    var local = this._browser.getParent().screenToLocal(this._trackingCurrent);
                    var current = this._browser.getPosition();
                    
                    this._originalPosition = this._browser.getPosition().clone();
                    
                    //offset of the actual difference between the point of touch and the current position of tilemap
                    this._trackingOffset = new Core.Vector(current.getX() - local.getX(), current.getY() - local.getY());
                    
                    // recording swipe data for scrolling
                    for (var i = 0; i < this._swipeHistoryCount; i++) {
                        this._swipeAccelAnchorX[i] = touch.getPosition().getX();
                        this._swipeAccelAnchorY[i] = touch.getPosition().getY();
                    }
                    this._moveCount = 0;
                    
                    this._touchedBlock = this._browser.objectForTouch(touch);
                    if (this._touchedBlock) {
                        NgLogD("Touched Block")
                        if (this._touchedBlock.classname == 'SmoothBrowserButtonBlock') {
                            this._touchedBlock.activate();
                        }
                    }
                    
                    return true;
                case touch.Action.End:
                   	// kills previous item touched
					if (this._trackingId != touch.getId()) 
					{
						if (this._previoustouchedBlock)
							this._previoustouchedBlock.inactivate();
                        return;
					}
					
					if (!this._isInYBounds) return;
					
                    this._trackingId = NaN;
                    
                    //todo: tweak this shit
                    
                    if (this._touchedBlock) {
                        if (typeof this._touchedBlock.touched != 'undefined') 
                            this._touchedBlock.touched();
                    }
                    else {
                    
						if (this._browser._locked) return;
					
                        var origin = this._browser.getOrigin();
                        var width = this.getWidthForSnapRight();
                        
                        this._moveCount++;
                        var mod = this._moveCount % this._swipeHistoryCount;
                        var swipeDistance = touch.getPosition().getX() - this._swipeAccelAnchorX[mod];
                        
                        // Start Snap Code
                        if (this._snapLeft) {
                        
                            NgLogD("End: Snap Left");
                            this._browser.moveTo(this._browser.getOrigin().getX(), 0, 0.3);
                            return;
                        }
                        else 
                            if (this._snapRight) {
                            
                                var snapRightPositionX = origin.getX() - width;
                                
                                NgLogD("End: Snap Right");
                                this._browser.moveTo(snapRightPositionX, 0, 0.3);
                                return;
                            }
                        this._snapLeft = false;
                        this._snapRight = false;
                        // End Snap Code
                        
                        var accelModPositon, accelDuration, easeOutRate;
                        if (Math.abs(swipeDistance) > 80) {
                            accelModPosition = new Core.Vector(swipeDistance * 7, 0);
                            accelDuration = 1.5;
                            easeOutRate = 3;
                        }
                        else 
                            if (Math.abs(swipeDistance) > 20) {
                                accelModPosition = new Core.Vector(swipeDistance * 4, 0);
                                accelDuration = 1;
                                easeOutRate = 2;
                            }
                            else {
                                accelModPosition = new Core.Vector(swipeDistance * 2, 0);
                                accelDuration = 0.3;
                                easeOutRate = 1;
                            }
                        
                        var newPosition = new Core.Vector(accelModPosition.getX() + this._browser.getPosition().getX(), accelModPosition.getY() + this._browser.getPosition().getY());
                        
                        // Check for snapback first
                        var bounceBackPixels = this._browser.getBrowserOptions().getBounceBackPixels();
                        if (newPosition.getX() >= origin.getX() + bounceBackPixels) {
                        
                            NgLogD("End: SnapBack Left");
                            this._browser.moveTo(this._browser.getOrigin().getX(), 0, 0.3);
                            
                        // TODO: Add Slide Action
                        }
                        else 
                            if (newPosition.getX() <= origin.getX() - width - bounceBackPixels) {
                            
                                NgLogD("End: SnapBack Right");
                                var snapRightPositionX = origin.getX() - width;
                                this._browser.moveTo(snapRightPositionX, 0, 0.3);
                            }
                            else {
                                this._browser.moveByWithEaseOut(accelModPosition.getX(), 0, accelDuration, easeOutRate);
                                
                            // TODO: Add Slide Action
                            }
                    }
                    
                    break;
                case touch.Action.Move:
					// kills previous item touched
					if (this._trackingId != touch.getId()) 
					{
						if (this._previoustouchedBlock)
							this._previoustouchedBlock.inactivate();
                        return;
					}
					if (!this._isInYBounds) return;
					
                    var xChange = Math.abs(this._trackingCurrent.getX() - touch.getPosition().getX());
                    if (xChange < 10 && this._touchedBlock) {
                        return;
                    }
                    
                    if (this._touchedBlock && this._touchedBlock.classname == 'SmoothBrowserButtonBlock') {
                        this._touchedBlock.inactivate();
                    }
                    //if it moved kill the touchedobject
                    this._touchedBlock = null;
                    
					if (this._browser._locked) return;
					
                    this._trackingCurrent = touch.getPosition();
                    var current = this._browser.getParent().screenToLocal(this._trackingCurrent);
                    var offset = this._trackingOffset;
                    
                    this._moveCount++;
                    
                    var mod = this._moveCount % this._swipeHistoryCount;
                    this._swipeAccelAnchorX[mod] = touch.getPosition().getX();
                    this._swipeAccelAnchorY[mod] = touch.getPosition().getY();
                    
                    var newPosition;
                    // Simply assume Y Lock
                    newPosition = new Core.Vector(current.getX() + offset.getX(), this._browser.getPosition().getY());
                    
                    // Start Snap Code
                    var width = this.getWidthForSnapRight();
                    var origin = this._browser.getOrigin();
                    var bounceBackPixels = this._browser.getBrowserOptions().getBounceBackPixels();
                    
                    if (newPosition.getX() >= origin.getX() + bounceBackPixels) {
                    
                        NgLogD("Move: Snap Left");
                        this._snapLeft = true;
                    //newPosition = new Core.Vector(current.getX() + (offset.getX() / 2), this._browser.getPosition().getY());
                    
                    }
                    else 
                        if (newPosition.getX() <= origin.getX() - width - bounceBackPixels) {
                        
                            NgLogD("Move: Snap Right");
                            this._snapRight = true;
                        //newPosition = new Core.Vector(current.getX() + (offset.getX() / 2), this._browser.getPosition().getY());
                        }
                        else {
                            this._snapLeft = false;
                            this._snapRight = false;
                        }
                    // End Snap Code
                    
                    this._browser.setPosition(newPosition);
                    
                    break;
            }
        }
    }),
});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Browser/BrowserOptions'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Browser/BrowserOptions'] || {}; $MODULE_REGISTRY['Code/G6/Browser/BrowserOptions'] = exports; var Util = require('Code/G6/Util/Util').Util;

exports.BrowserOptions = Core.Class.subclass(
{
	initialize: function()
	{	
		this._bounceBackPixels = 10;
		this._spacing = 10;
		this._yPosition = 200;
		this._yScreenTopBounds = 0;
		this._yScreenBottomBounds = Util.screenSize(true).getHeight();
	},
	
	getYScreenTopBounds: function() {
		return this._yScreenTopBounds;
	},
	
	setYScreenTopBounds: function(bounds) {
		this._yScreenTopBounds = bounds;
	},
	
	getYScreenBottomBounds: function() {
		return this._yScreenBottomBounds;
	},
	
	setYScreenBottomBounds: function(bounds) {
		this._yScreenBottomBounds = bounds;
	},
	
	getBounceBackPixels: function() {
		return this._bounceBackPixels;
	},
	
	setBounceBackPixels: function(pixels) {
		this._bounceBackPixels = pixels;
	},
	
	getSpacing: function() {
		return this._spacing;
	},
	
	setSpacing: function(spacing) {
		this._spacing = spacing;
	},
	
	getYPosition: function() {
		return this._yPosition;
	},
	
	setYPosition: function( t) {
		this._yPosition = t;
	},
});; return exports;};
$MODULE_FACTORY_REGISTRY['Code/G6/Browser/SmoothBrowserButtonBlock'] = function(){var exports = $MODULE_REGISTRY['Code/G6/Browser/SmoothBrowserButtonBlock'] || {}; $MODULE_REGISTRY['Code/G6/Browser/SmoothBrowserButtonBlock'] = exports; /**
 * @author will
 */
exports.SmoothBrowserButtonBlock = GL2.Node.subclass({
	
	classname: 'SmoothBrowserButtonBlock',
	
    initialize: function(id, inactive, active, disabled, callback){
        if (typeof active == 'undefined') 
            active = inactive;
        if (typeof disabled == 'undefined') 
            disabled = inactive;
        this._inactiveFrame = inactive;
        this._activeFrame = active;
        this._disabledFrame = disabled;
		this._id = id;
		
		this._callback = callback;
        
        this._enabled = true;
        this._target = null;
        
        
        //set the animation frame..
        this._itemNode = new GL2.Sprite();

        var a = new GL2.Animation();
        a.pushFrame(this._inactiveFrame);
        this._itemNode.setAnimation(a);        
        this.addChild(this._itemNode);
        
    },
	
	inactivate: function() {
		//when button is idle and not doing anything
		this._itemNode.getAnimation().setFrame(0,this._inactiveFrame);
	},
	
	
	activate: function() {
		//when the button is pressed..
		this._itemNode.getAnimation().setFrame(0,this._activeFrame);		
		//call function
			
	},	
	
	getId: function() {
		return this._id;
	},
    
	getSize: function() {
		return this._inactiveFrame.getSize();
	},	
	
	getAnchor: function() {
		return this._inactiveFrame.getAnchor();
	},	
    
    touched: function(){
		this.inactivate();
    	this._callback();
    },
    

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Game/Settings/SettingsPage'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Game/Settings/SettingsPage'] || {}; $MODULE_REGISTRY['Code/StripCity/Game/Settings/SettingsPage'] = exports; var goldColor = new Core.Color(1, 1, 0.8);
var settings1height = 156;
var settings2height = 220;
var settings3height = 284;
var settingsButtonX = 702;

var closeMenu_xpos = 772;
var closeMenu_ypos = 28;
var titleText_xpos = 400;
var titleText_ypos = 25;
var titleSubText_xpos = 400;
var titleSubText_ypos = 51;

exports.SettingsPage = Node.subclass({
    classname: 'SettingsPage',
    
    initialize: function(){
        var backgroundmusicon = SCGame.getSettings().getBackgroundMusicOn();
        var soundeffectson = SCGame.getSettings().getSoundEffectsOn();
        var japaneseon = SCGame.getSettings().getJapaneseOn();
        var bgAnimation = new GL2.Animation();
        
        var screenSize = Util.screenSize(true);

        bgAnimation.pushFrame(AtlasMap.getAnimationFrame('common-menu-bg.png',0, [0,0]));
        bgAnimation.setBlendEnabled(false);
		        
        var background = new GL2.Sprite();
        background.setDepth(-1);
        background.setAnimation(bgAnimation);
        this.addChild(background);
        
       //create the settings controls backgrounds
	   var bgmBgAnimation = new GL2.Animation();
	   var settingsBgFrame = AtlasMap.getAnimationFrame('settings-item-bg.png',0, [0.5,0.5]);
	   
	   bgmBgAnimation.pushFrame(settingsBgFrame);
	   
	   
	   var bgmBg = new GL2.Sprite();
	   bgmBg.setDepth(0);
	   bgmBg.setAnimation(bgmBgAnimation);
	   bgmBg.setPosition(Scale.droid.width(400), Scale.droid.height(settings1height));
	   this.addChild(bgmBg);
	   
	   
	   var sfxBgAnimation = new GL2.Animation();
	   sfxBgAnimation.pushFrame(settingsBgFrame);
	   
	   
	   var sfxBg = new GL2.Sprite();
	   sfxBg.setDepth(0);
	   sfxBg.setAnimation(sfxBgAnimation);
	   sfxBg.setPosition(Scale.droid.width(400), Scale.droid.height(settings2height));
	   this.addChild(sfxBg);	   


//	   var jpnBgAnimation = new GL2.Animation();
//	   jpnBgAnimation.pushFrame(settingsBgFrame);
//	   	   
//	   var jpnBg = new GL2.Sprite();
//	   jpnBg.setDepth(0);
//	   jpnBg.setAnimation(sfxBgAnimation);
//	   jpnBg.setPosition(Scale.droid.width(400), Scale.droid.height(settings3height));
//	   this.addChild(jpnBg);		   
//	   	   
//	   var logoutBgAnimation = new GL2.Animation();
//	   logoutBgAnimation.pushFrame(settingsBgFrame);
	   
//	   var logoutBg = new GL2.Sprite();
//	   logoutBg.setDepth(0);
//	   logoutBg.setAnimation(logoutBgAnimation);
//	   logoutBg.setPosition(Scale.droid.width(400), Scale.droid.height(settings3height));
//	   this.addChild(logoutBg);		   
        
        
        
        var onIcon = AtlasMap.getAnimationFrame('settings-button-on.png',0, [0.5,0.5]);
        var offIcon = AtlasMap.getAnimationFrame('settings-button-off.png',0, [0.5,0.5]);
        var bgIcon = null;
        var sfIcon = null;
        var jpIcon = null;
        
        var logoutIcon = AtlasMap.getAnimationFrame('settings-button-logout-inactive.png',0, [0.5,0.5]);
        var logoutIconActive = AtlasMap.getAnimationFrame('settings-button-logout-active.png',0, [0.5,0.5]);
        
        if (backgroundmusicon) {
            bgIcon = onIcon;
        }
        else {
            bgIcon = offIcon;
        }
        
        if (soundeffectson) {
            sfIcon = onIcon;
        }
        else {
            sfIcon = offIcon;
        }

        if (japaneseon) {
            jpIcon = onIcon;
        }
        else {
            jpIcon = offIcon;
        }
        
        var item1 = new Menu.AnimationFrameMenuItem();
        item1.setFrames(bgIcon, bgIcon, bgIcon);
        item1.setAction(function(){
            if (backgroundmusicon) {
                bgIcon = offIcon;
                SCGame.getSettings().setBackgroundMusicOn(false);
                backgroundmusicon = false;

            }
            else {
                bgIcon = onIcon;
                SCGame.getSettings().setBackgroundMusicOn(true);
                backgroundmusicon = true;
				        Audio.Music.setPath('Content/bgm/bgm-title.mp3');
            }
            this.setFrames(bgIcon, bgIcon, bgIcon);
			  SCGame.getSCAudio().playbackgroundmusic(4);
            
        });
        
        var item2 = new Menu.AnimationFrameMenuItem();
        item2.setFrames(sfIcon, sfIcon, sfIcon);
        item2.setAction(function(){
            if (soundeffectson) {
                sfIcon = offIcon;
                SCGame.getSettings().setSoundEffectsOn(false);
                soundeffectson = false;
            }
            else {
                sfIcon = onIcon;
                SCGame.getSettings().setSoundEffectsOn(true);
                soundeffectson = true;
            }
            this.setFrames(sfIcon, sfIcon, sfIcon);
        });
        
//        var item3 = new Menu.AnimationFrameMenuItem();
//        item3.setFrames(jpIcon, jpIcon, jpIcon);
//        item3.setAction(function(){
//            if (japaneseon) {
//                jpIcon = offIcon;
//                SCGame.getSettings().setJapaneseOn(false);
//                japaneseon = false;
//			          Core.Localization.setLanguage('en');
//            }
//            else {
//                jpIcon = onIcon;
//                SCGame.getSettings().setJapaneseOn(true);
//                japaneseon = true;
//			          Core.Localization.setLanguage('jp');
//            }
//            this.setFrames(jpIcon, jpIcon, jpIcon);
//        });

        //LOGOUT
//        var item3 = new Menu.AnimationFrameMenuItem();
//        item3.setFrames(logoutIcon, logoutIconActive, logoutIconActive);
//        item3.setAction(function(){
//            item3.setEnabled(false);
//            SCGame.logout();
//        });
//        
        
        var menu = new Menu.Menu([item1, item2]);
        menu.setPosition([Scale.droid.width(settingsButtonX), Scale.droid.height(settings2height - 28)]);
        menu.setDepth(2);
        menu.alignItemsVertically(10);
        
        this.addChild(menu);
        
//        var exit = new exitButton(this);
//        this.addChild(exit.getNode());
//        
//        var t = new testButton(this);
//        this.addChild(t.getNode());

		var close1 = AtlasMap.getAnimationFrame('common-bg-exit-active.png', 0, [0.5,0.5]);
		var close1i = AtlasMap.getAnimationFrame('common-bg-exit-inactive.png', 0, [0.5,0.5]);		
        var item1 = new Menu.AnimationFrameMenuItem();
        item1.setFrames(close1i,close1,close1);
		
        var thisMenu = this;
        item1.setAction(function(){ thisMenu.close();	SCGame.quickSavePlayer(); });
        this._closeButton = new Menu.Menu([item1]);
        this._closeButton.setPosition(Scale.droid.width(closeMenu_xpos), Scale.droid.height(closeMenu_ypos));
        this._closeButton.setDepth(100);
        this.addChild(this._closeButton);
		
		this.initializeText();  
        
    },
    
    initializeText: function(){    	
		
		//title text
        var titleText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		SCStyle.applyFontStyle(titleText, SCStyle.FontStyle.Serif32);
        titleText.setText('SETTINGS');
        titleText.setDepth(1);
        titleText.setColor(goldColor);
        titleText.setPosition([Scale.droid.width(titleText_xpos), [Scale.droid.height(titleText_ypos)]]);
        this.addChild(titleText);
        
        
        var titleSubText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		SCStyle.applyFontStyle(titleSubText, SCStyle.FontStyle.Serif12);
        titleSubText.setText('C O N T R O L  Y O U R  W O R L D');
        titleSubText.setDepth(1);
        titleSubText.setColor(goldColor);
        titleSubText.setPosition([Scale.droid.width(titleSubText_xpos), [Scale.droid.height(titleSubText_ypos)]]);
        this.addChild(titleSubText);
        
       
        var bgmText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		SCStyle.applyFontStyle(bgmText, SCStyle.FontStyle.Serif24);
        bgmText.setText('Background Music');
        bgmText.setDepth(1);
		bgmText.setAnchor(0,0.5);
        bgmText.setColor(goldColor);
        bgmText.setPosition([Scale.droid.width(45), [Scale.droid.height(settings1height)]]);
        
        this.addChild(bgmText);	
		
		var sfxText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
		SCStyle.applyFontStyle(sfxText, SCStyle.FontStyle.Serif24);
        sfxText.setText('Sound Effects');
        sfxText.setDepth(1);
		sfxText.setAnchor(0,0.5);
        sfxText.setColor(goldColor);
        sfxText.setPosition([Scale.droid.width(45), [Scale.droid.height(settings2height)]]);
        
        this.addChild(sfxText);		

//		var jpnText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
//		SCStyle.applyFontStyle(jpnText, SCStyle.FontStyle.Serif24);
//        jpnText.setText('Japanese');
//        jpnText.setDepth(1);
//		jpnText.setAnchor(0,0.5);
//        jpnText.setColor(goldColor);
//        jpnText.setPosition([Scale.droid.width(45), [Scale.droid.height(settings3height)]]);
//        
//        this.addChild(jpnText);	
		
//		var logoutText = new TextWithShadow(TextWithShadow.ShadowType.BlackShadow);
//		SCStyle.applyFontStyle(logoutText, SCStyle.FontStyle.Serif24);
//        logoutText.setText('Account');
//        logoutText.setDepth(1);
//		logoutText.setAnchor(0,0.5);
//        logoutText.setColor(goldColor);
//        logoutText.setPosition([Scale.droid.width(45), [Scale.droid.height(settings3height)]]);
//        
//        this.addChild(logoutText);			
		
    },
	
    destroy: function($super){
        $super();
    },
	
	close: function() {
		SCGame.returnToLobby(this);		
	}
    
});

//DEPRACATED NO LONGER USED, use MENU isntead
var exitButton = Core.MessageListener.subclass({

    initialize: function(settingspage){
        this.settingspage = settingspage;
        var buttonAnimation = new GL2.Animation();
        buttonAnimation.pushFrame(new GL2.Animation.Frame('Content/exit.png', 0, [Scale.droid.width(50), Scale.droid.height(50)], [0, 0], [0, 0, 1, 1]));
        
        this.node = new GL2.Node();
        this.node.setPosition(Scale.droid.width(10), Scale.droid.height(10));
        
        this.sprite = new GL2.Sprite();
        this.sprite.setDepth(1);
        this.sprite.setAnimation(buttonAnimation);
        
        this.node.addChild(this.sprite);
        
        this.target = new GL2.TouchTarget();
        this.target.setAnchor(this.sprite.getAnimation().getFrame(0).getAnchor());
        this.target.setSize(this.sprite.getAnimation().getFrame(0).getSize());
        this.target.getTouchEmitter().addListener(this, this.onTouch);
        this.node.addChild(this.target);
    },
    
    getNode: function(){
        return this.node;
    },
    
    onTouch: function(touch){
        switch (touch.getAction()) {
            case touch.Action.Start:
                this.sprite.setColor(1, 1, 0.25);
                return true;
            case touch.Action.End:
                this.sprite.setColor(1, 1, 1);
                SCGame.returnToLobby(this.settingspage);
                break;
        }
        
    },

});


var testButton = Core.MessageListener.subclass({

    initialize: function(settingspage){
        this.settingspage = settingspage;
        var buttonAnimation = new GL2.Animation();
        buttonAnimation.pushFrame(new GL2.Animation.Frame('Content/exit.png', 0, [Scale.droid.width(50), Scale.droid.height(50)], [0, 0], [0, 0, 1, 1]));
        
        this.node = new GL2.Node();
        this.node.setPosition(Scale.droid.width(100), Scale.droid.height(100));
        
        this.sprite = new GL2.Sprite();
        this.sprite.setDepth(1);
        this.sprite.setAnimation(buttonAnimation);
        
        this.node.addChild(this.sprite);
        
        this.target = new GL2.TouchTarget();
        this.target.setAnchor(this.sprite.getAnimation().getFrame(0).getAnchor());
        this.target.setSize(this.sprite.getAnimation().getFrame(0).getSize());
        this.target.getTouchEmitter().addListener(this, this.onTouch);
        this.node.addChild(this.target);
        
        
    },
    
    getNode: function(){
        return this.node;
    },
    
    onTouch: function(touch){
        switch (touch.getAction()) {
            case touch.Action.Start:
                this.sprite.setColor(1, 1, 0.25);
                return true;
            case touch.Action.End:
                this.sprite.setColor(1, 1, 1);
                //				this._e = new Audio.Effect('Content/Shuffle.mp3');
                //				this._ae = new Audio.ActiveEffect(this._e);
                //				this._ae.play();
                SCGame.getSCAudio().playsound(2);
                break;
        }
        
    },

});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/Scene/Lobby/LobbyBackgroundNode'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/Scene/Lobby/LobbyBackgroundNode'] || {}; $MODULE_REGISTRY['Code/StripCity/Scene/Lobby/LobbyBackgroundNode'] = exports; /**
 * @author will
 */
/**
 * @author raymondlo
 */
exports.LobbyBackgroundNode = Node.subclass({
    classname: 'LobbyBackgroundNode',
    
    initialize: function($super, framea, frameb){
        $super();
        this._tail = true;
		
		this._img = new GL2.Sprite();
        this.a = new GL2.Animation();
        this.a.pushFrame(framea);
        this._img.setAnimation(this.a);		
		this.n = new GL2.Node();
		this.n.addChild(this._img);
		this.n.setPosition(0,0);
		
		this._img2 = new GL2.Sprite();
        this.a2 = new GL2.Animation();
        this.a2.pushFrame(frameb);
        this._img2.setAnimation(this.a2);		
		this.n2 = new GL2.Node();
		this.n2.addChild(this._img2);
		this.n2.setPosition(this._img._animation.getFrame(0).getSize().getWidth(),0);
		
		this.addChild(this.n);
		this.addChild(this.n2);
    },
    
	//if this node is the tail of the background node.
    isTail: function(){
        return this._tail;
    },
	
	setTail: function(t) {
		this._tail = t
	},
    
    getWidth: function(){
        return this._img._animation.getFrame(0).getSize().getWidth()+this._img2._animation.getFrame(0).getSize().getWidth() ;
    },

	destroy: function($super) {
		this._img.destroy();
		this.a.destroy();
		this.n.destroy();
		this._img2.destroy();
		this.a2.destroy();
		this.n2.destroy();
		$super();
	},


});
; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/OpenSocial/Styles'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/OpenSocial/Styles'] || {}; $MODULE_REGISTRY['Code/StripCity/OpenSocial/Styles'] = exports; var Styles = exports.Styles = {
	apiList: {
		height : 50
	},
	basicBox: {
		corners: "4",
		outerLine: "00 1.5",
		innerLine: "99FF 1.5",
		gradient: [
			"FF666666 0.0",
			"FFCCCCCC 1.0"
		]
	},
    background: {
        //"innerShadow":"FF999999 200.0 {0.0,0.0}",
        "gradient":[
            "CCDFDFDF 0.000",
            "CC999999 1.000"
        ]
    },
    greyButton: {
        corners: '8 8 8 8', 
        outerLine: "00 1.5",
        /*innerLine: "99FF 1.5",*/
        gradient: [
            "FFe4e4e4 0.0",
            "FF888888 1.0"
        ]
    },
    greyButtonDown: {
        corners: '8 8 8 8', 
        outerLine: "00 1.5",
        /*innerLine: "99FF 1.5",*/
        gradient: [
            "FF888888 0.0",
            "FFe4e4e4 1.0"
        ]
    }
};

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/OpenSocial/Dumper'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/OpenSocial/Dumper'] || {}; $MODULE_REGISTRY['Code/StripCity/OpenSocial/Dumper'] = exports; function _Dump( data, offset ) {
    if ( typeof(offset) == "undefined" )  { offset = ""; }
    var nextoff = offset + "  ";
    var type = typeof(data);
    //alert(type);
    if (type == "string") {
        return '"'+data+'"';
    } else if ( type == 'number' ) {
        return data;
    } else if ( type =="boolean") {
        return data ? "true" : "false";
    } else if ( type == "undefined") {
        return "undefined";
    } else if ( type == "object") {
		if ( data === null ) {
            return "null";
        } else if ( data.constructor == Array ) {
            var array = [];
            for ( var i=0; i<data.length; i++ ) {
                array[i] = _Dump( data[i], nextoff );
            }
            return "[\n"+nextoff+array.join( ",\n"+nextoff )+"\n"+offset+"]";
        } else {
            var array = [];
            for ( var key in data ) {
                var val =_Dump( data[key], nextoff );
                //              if ( key.match( /[^A-Za-z0-9_]/ )) {
                key = '"'+key+'"';
                //              }
                array[array.length] = key+": "+val;
            }
            if ( array.length == 1 && ! array[0].match( /[\n\{\[]/ ) ) {
                return "{ "+array[0]+" }";
            }
            return "{\n"+nextoff+array.join( ",\n"+nextoff )+"\n"+offset+"}";
        }
    } else {
            return data;
        // unsupported data type
    }
}

exports.Dump = _Dump;

; return exports;};
$MODULE_FACTORY_REGISTRY['Code/StripCity/OpenSocial/DialogController'] = function(){var exports = $MODULE_REGISTRY['Code/StripCity/OpenSocial/DialogController'] || {}; $MODULE_REGISTRY['Code/StripCity/OpenSocial/DialogController'] = exports; 
//var Core = require("./NGCore/Client/Core").Core;
//var Logger = require("./NGCore/Client/Core/Logger").Logger;
//var UI = require("./NGCore/Client/UI").UI;
//var Scale = require("./NGCore/Client/UI/ViewGeometry").Scale;
var Styles = require('Code/StripCity/OpenSocial/Styles').Styles;
var Dump = require('Code/StripCity/OpenSocial/Dumper').Dump;

exports.DialogController = Core.Class.singleton(
{
	initialize: function() {
		var self = this;
		var screen = {
			width: Core.Capabilities.getScreenWidth(),
			height: Core.Capabilities.getScreenHeight()
		};

		var sizeRate = {
			width: 90,
			height: 90
		};
		var dialog = {
			width: screen.width * sizeRate.width / 100,
			height: screen.height * sizeRate.height / 100
		};
		var dialogRect = new UI.ViewGeometry.Rect( 
			(screen.width - dialog.width) /2 , 
			(screen.height - dialog.height) /2, 
			dialog.width, 
			dialog.height);

		var rect = dialogRect.array();
		this.messageDialog = new UI.View();
		this.messageDialog.setFrame(dialogRect.array());
		this.messageDialog.setGradient(Styles.background);

		this.scrollView = new UI.ScrollView();
		this.scrollView.setFrame(dialogRect.array());
		this.scrollView.setContentSize([dialog.width, 600]);
		this.messageDialog.addChild(this.scrollView);

		var labelSizeRate = {
			width: 90,
			height: 70
		};
		var label = {
			width: dialog.width * labelSizeRate.width / 100,
			height: dialog.height * labelSizeRate.height / 100
		};
		var labelRect = new UI.ViewGeometry.Rect(
			0,
			0,
			label.width, 
			label.height);
		rect = labelRect.array();
		Logger.log("label " +rect[0] + ":" + rect[1] + ":" + rect[2] + ":" + rect[3]);

		this.messageLabel = new UI.Label();
		this.messageLabel.setFrame(labelRect.array());
		this.messageLabel.setTextSize(10);
		this.messageLabel.setTextGravity(UI.ViewGeometry.Gravity.TopLeft);
		this.scrollView.addChild(this.messageLabel);

		var button = {
			width: 100,
			height: 40
		};

		var buttonRect = new UI.ViewGeometry.Rect(
			(dialog.width - button.width)/2,
			dialog.height * 0.85,
			button.width, 
			button.height);

		rect = buttonRect.array();
		var closeButton = new UI.Button();
		closeButton.setFrame(buttonRect.array());
		closeButton.setNormalGradient(Styles.greyButton);
		closeButton.setHighlightedGradient(Styles.greyButtonDown);
		closeButton.setNormalText('OK');
		closeButton.onclick = function(){
			self.messageDialog.removeFromParent();
		};
		this.messageDialog.addChild(closeButton);

	},
	show: function(message) {
		NgLogD('show dialog ' + message);

		var labelText = Dump(message);
		this.messageLabel.setText(labelText);
		UI.Window.document.addChild(this.messageDialog);
	},
	showWithImage: function(message, imageUrl) {
		this.image = new UI.Image();
		this.image.setImage(imageUrl);
		this.image.setFrame([100, 100, 100, 100]);
		this.messageDialog.addChild(this.image);
		UI.Window.document.addChild(this.messageDialog);
	}
});

; return exports;};
(function()
{
	if(!Function.prototype.hasOwnProperty('bind'))
	{
		var slice = Array.prototype.slice;
		Function.prototype.bind = function(context)
		{
			var func = this;
			if(arguments.length > 1)
			{
				var args = slice.call(arguments, 1);
				return function()
				{
					if(arguments.length)
					{
						var finalArgs = args.concat(slice.call(arguments));
						return func.apply(context, finalArgs);
					}
					else
					{
						return func.apply(context, args);
					}
				}
			}
			else
			{
				return function()
				{
					if(arguments.length)
						return func.apply(context, arguments);
					else
						return func.call(context);
				}
			}
		}
	}
})();

(function()
{
	if(!Array.prototype.hasOwnProperty('indexOf'))
	{
		Array.prototype.indexOf = function(obj)
		{
			var len = this.length;
			for(var i=0; i < this.length; ++i)
			{
				if(obj === this[i])
					return i;
			}
			return -1;
		}
	}
})();

(function()
{
	if (typeof(console) == 'undefined') { 
		console = { log: function(str) {} };
	}
})();

function userGameInit()
{
	console.log("ngCore calling main()");
	main();
}
//////////////////////////////////////////////////////////////////////////////
/** 
 *  @date:      2010-11-0?
 *  @file:      NgWebEngine.js
 *  Website:    http://www.ngmoco.com/
 *  Copyright:  2010, by ngmoco:)
 *              Unauthorized redistribution of source code is 
 *              strictly prohibited. Violators will be prosecuted.
 * 
 *  @brief:
 */
//////////////////////////////////////////////////////////////////////////////
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;
var SystemBinding = require('NGCore/Client/UI/SystemBinding').SystemBinding;
var UI = require('NGCore/Client/UI').UI;
var AlertDialog = UI.AlertDialog;
var ProgressDialog = UI.ProgressDialog;
var Downloader = require('NGCore/Client/Network/DownloadManifest').Downloader;
var LocalGameList = require('NGCore/Client/Core/LocalGameList').LocalGameList;
var Device = require('NGCore/Client/Device').Device;
var Core = require('NGCore/Client/Core').Core;
var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Localization = require('NGCore/Client/Core/Localization').Localization;

// Global until oauth does not depend on storage.
Storage = require('NGCore/Client/Storage').Storage;

//////////////////////////////////////////////////////////////////////////////////////////////////
// App switching.

var NgProcID =
{
    PersistProc: -1,
    GameProc: -2
};

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

var gNgShutdownPending = false;


/////////////////////////////////////////////////////////////////////////////////////////////////
// Global data.
//////////////////////////////////////////////////////////////////////////////////////////////////

var gNgEngineEntities;
var gNgAddedEngineEntities;
var gNgRemovedEngineEntities;

var gNgUpdateEngineEntities;
var gNgTouchEngineEntities;
var gNgKeyPressEngineEntities;

//////////////////////////////////////////////////////////////////////////////////////////////////
// This function is called once by the html container to initialize the game.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineInitPrivate()
{
	NgLogInit();

	NgApplication.getInstance().restart();

	gNgEngineEntities = new Array();
	gNgAddedEngineEntities = new Array();
	gNgRemovedEngineEntities = new Array();

	gNgUpdateEngineEntities = new Array();
	gNgTouchEngineEntities = new Array();
    gNgKeyPressEngineEntities = new Array();

	Core.Analytics.instantiate();
}

//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */

function NgEngineProcessEntityAddRemove()
{
	for(var i in gNgAddedEngineEntities)
	{
		var e = gNgAddedEngineEntities[i];
		if(e.mIsTouchable) NgInsertSortedTouch(e);
		if(e.mIsKeyable)	NgInsertSortedKeyPress(e);
		if(e.mIsUpdatable) gNgUpdateEngineEntities[e.mId] = e;
	}
	gNgAddedEngineEntities = [];

	for(var i in gNgRemovedEngineEntities)
	{
		var e = gNgRemovedEngineEntities[i];

		if(e.mIsTouchable)	gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,e),1);
		if(e.mIsKeyable) gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,e),1);
		if(e.mIsUpdatable) delete gNgUpdateEngineEntities[e.mId];
	}
	gNgRemovedEngineEntities = [];
}

/**
  * @private
  */

function NgEngineInit(inputs)
{
	NgLogD("NgEngineInit beg");
	try
	{
		NgEngineInitPrivate();

		time.setCtr('frame',1000,NgLogD);

		//NgLogD("Initializing Storage");
		//Storage.init();
		//NgLogD("Storage initialized");
		NgLogD("KeyValue Storage initializing...");
		Storage.KeyValueCache.init();
		NgLogD("KeyValue Storage initialized...");
	
		Core.Time.instantiate();
	
		NgLogD("Instantiate the Localization context (singleton), depends on Capabilities");
		Localization.instantiate();

	}
	catch( ex )
	{
		NgLogException( ex );
	}
	NgLogD("NgEngineInit end");	
	
	return NgEngineUpdate(inputs);
}

function NgPreInit(inputs)
{
	NgLogD("Localization NgPreInit beg");
	return update(inputs);
}

/**
  * @private
  */

function NgGameInit(inputs)
{
	NgLogD("NgGameInit beg");
	try
	{
		NGWindow = UI.Window;

		userGameInit();
	}
	catch( ex )
	{
		NgLogException( ex );
	}
	NgLogD("NgGameInit end");

	return update(inputs);
}

/**
  * @private
  */

// TEMPORARY: Until native code is updated to call NgEngineUpdate.
function update ( inputs )
{
	return NgEngineUpdate ( inputs );
}

//Frame loop calls this every time, get the object out of require once ahead of time.
var NGSetTimeoutRunTimers = require('NGCore/Client/UI/NGJSEnvironmentSupport').NGSetTimeoutRunTimers;

/**
  *	Main entry point for native to invoke JS.
  * @private
  */
var NgEngineUpdate = (function()
{
	var Core = require('NGCore/Client/Core').Core;
	
return function ( inputs )
{
	// time causes a racehorse-sized leak in v8. Only use this for single profiling runs. DO NOT CHECK IN.
//	time.stop('frame');
//	time.start('frame');
	
	try {
		NGSetTimeoutRunTimers();

		if(inputs.length)
		{
			NgEngineProcessEntityAddRemove();
			var commands = inputs.split(':');
			for(var i=0; i<commands.length; ++i)
			{
				command = commands[i];

				// Make sure this isn't an empty input.
				if(0 == command.length) {
					continue;
				}

				switch(parseInt(command))
				{
					case NgEntityTypes.App:
						NgApplication.getInstance().handleCommand(command);
						break;
					case NgEntityTypes.NgFileSys:
						NgApplication.getInstance().getFileSys().handleCommand(command);
                        break;
					case NgEntityTypes.Storage:
						NgLogD("Command for storage is " + command);
						Storage.getInstanceForCommand(command).handleCommand(command);
						break;
					case NgEntityTypes.NgUI:
						NGWindow.handleCommand(command);
						break;
					case NgEntityTypes.NgSystemBinding:
						SystemBinding.handleCommand(command);
						break;
					case 3117:
						console.log('got leet response');
						if(typeof(_WifiDiagCallback) != 'undefined')
							_WifiDiagCallback(command);
						break;
					default:
						Core.Proc._classRecvGen( command.split( ',' ) );
						break;
				}
			}
		}

		if( gNgShutdownPending )
		{
			gNgShutdownPending = false;
		}
		else	// Don't do updates if we're resetting.
		{
			NgEngineProcessEntityAddRemove();
			for(var i in gNgUpdateEngineEntities)
			{
				var entity = gNgUpdateEngineEntities[i];
				if(!entity.mRegistered) continue;
				entity.onUpdate();
			}
		}
	}
	catch(ex)
	{
		NgLogException( ex );
	}
		
	var tmp = Core.Proc.getCommandString() + gNgCommandString;
	gNgCommandString = tmp;
	Core.Proc.clearCommandString();

	return NgFlushCommandsToString();
}
})();


//////////////////////////////////////////////////////////////////////////////////////////////////
////	NgApplication class
//////////////////////////////////////////////////////////////////////////////////////////////////

var Capabilities = require('NGCore/Client/Core/Capabilities').Capabilities;
var Logger = require('NGCore/Client/Core/Logger').Logger;

/** @private */

var NgApplicationCommands = {
	Caps : 0,
	Debug : 1,
	FrameTime : 2,
	FrameRate : 3,
	Start : 4,
	DeviceOrientation: 10,
	SetOrientation: 11,
	BackPress: 12,
	OnBackPressed: 13,
	LaunchExternalNativeApp: 15,
	ExitSystemProcess: 16
};

/**
  * Enumeration values for orientation change events received by
  * {@link NgApplicationObserver}.
  */

var NgApplicationOrientation = {
	Portrait : 0,
	PortraitUpsideDown : 1,
	LandscapeLeft : 2,
	LandscapeRight : 3,
	FaceUp : 4,
	FaceDown : 5
};

/**
  * The NgApplication constructor is invoked during application bootstrap and
  * should not be created by the ngGame application.  Access to the application
  * object should be through the singleton accessor {@link NgApplication#getInstance}.
  * @constructor
  *
  * @class
  * The NgApplication class represents global state and services that are available to
  * ngGame applications.  This includes file system operations,
  * download services, etc.  The application class also manages a time source
  * that is synchronized between the native engine and the ngGame application. <br>
  * The application object is a singleton and should only be accessed through the
  * {@link NgApplication#getInstance} method.
  */

function NgApplication()
{
	/** @private */
	this.mFileSys = Storage.FileSystem;
	/** @private */
	this.mFrameTime = 0.0;
	/** @private */
	this.mObservers = [];
}

// Singleton instance.
/** @private */
NgApplication.sInstance = null;

/**
  * Acquire the singleton instance of the application class.
  * @type NgApplication
  * @return The global application object.
  */

NgApplication.getInstance = function()
{
	if( NgApplication.sInstance == null )
		NgApplication.sInstance = new NgApplication();

	return NgApplication.sInstance;
};

// APITODO: Switch these methods to be defined out-of-line, not by an object literal.

NgApplication.prototype =
{
	mFileSys : null,
	mObservers : [],
	mFrameTime : 0.0,
	
	/** @private */
	restart : function()
	{
	},
	
	/** @private */
	handleCommand : function(command)
	{
		//		NgLogD( "NgApplication command = " + command );

		var commandId = NgPeekCommandId( command );

		switch( commandId )
		{
			case NgApplicationCommands.FrameTime:
				this.parseFrameTime( command );
				break;
			case NgApplicationCommands.Start:
				this.onApplicationStart();
				break;
			case NgApplicationCommands.OnBackPressed:
				this.onApplicationBackPressed();
				break;
			default:
				NgLogE( "NgApplication command unknown: " + command);
				break;
		}
	},
	
	/**
	  * Acquire the file system object.
	  * @type NgFileSys
	  * @return The file system instance.
	  */
	getFileSys : function()
	{
		return this.mFileSys;
	},

	/** @private */
	ngLog : function( level, dbgStr )
	{
		NgPushCommand4( NgEntityTypes.App, NgApplicationCommands.Debug, Core.Base64.encode( dbgStr ), level );
	},
	
	/** @private */
	parseFrameTime : function( command )
	{
		var fields = NgParseCommand2(command,parseInt,parseFloat);
		var frameTime = fields[1];

		if(this.mFrameDelta == undefined)
			this.mFrameDelta = 0;
		else
			this.mFrameDelta = frameTime - this.mFrameTime;

		this.mFrameTime = frameTime;
	},
	
	/**
	  * Get the application time for the current frame.
	  * @type number
	  * @return The time in milliseconds.
	  */
	getFrameTime : function()
	{
		return this.mFrameTime;
	},
	
	/**
	  * Get the application time delta between the current frame and the last frame.
	  * @type number
	  * @return The time delta in milliseconds.
	  */
	getFrameDelta : function()
	{
		return this.mFrameDelta;
	},

	/**
	  * Set the desired application frame rate. <br>
	  * Note: The frame rate specification is not currently fully functional on all 
	  * platforms.
	  * @param {number} frameRate The desired frame rate in hz.
	  * @type void
	  */
	setFrameRate : function(frameRate)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.FrameRate, frameRate);
	},

	/**
	  * Set the current device orientation for the application. <br>
	  * Note: Setting the orientation is not currently fully functional on all
	  * platforms.
	  * @param {NgApplicationOrientation} orientation The desired orientation.
	  * @type void
	  */
	setOrientation : function(orientation)
	{
		NgPushCommand3( NgEntityTypes.App, NgApplicationCommands.SetOrientation, orientation);
	},

	/**
	  * Register an application observer to receive application callbacks.
	  * @param {NgApplicationObserver} obs The observer to register.
	  * @type void
	  */
	registerObserver : function(obs)
	{
		obs.index = this.mObservers.push(obs);
	},

	unregisterObserver : function(obs)
	{
		if (obs.index)
			delete this.mObservers[obs.index - 1];
	},

	/** @private */
	onApplicationStart : function()
	{
		NgUI.onLoad();
		for (i in this.mObservers)
		{
			// TODO is this even possible?
			this.mObservers[i].onApplicationStart();
		}
	},
	
	/** @private */
	onApplicationReceivedCustomMessage : function( message )
	{
		for (i in this.mObservers)
		{
			this.mObservers[i].onApplicationReceivedCustomMessage( message );
		}
	},
	
	/** @private */
	onApplicationBackPressed : function()
	{
			var observerResult = false;
			for (i in this.mObservers)
			{
				 if (this.mObservers[i].onApplicationBackPressed())
				 {
					observerResult = true;
					break;
				 }
			}
			if (!observerResult)
			{
				// back button was not fully handled. Ask the native application to handle it.
				NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
			}
	},
	
	/** @private */
	exitSystemProcess : function ()
	{
		NgLogD ( "pushing exit command" );
		//This makes java exit the app through android lifecycle
		NgPushCommand2(NgEntityTypes.App, NgApplicationCommands.BackPress);
		NgLogD ( "pushed exit command" );
	}
};

// Observer base class for application events.

/**
  * Initialize a new application observer.
  * @constructor
  *
  * @class
  * The NgApplicationObserver class is used as the base class for any user-defined
  * class that receives application-level callbacks.  This currently includes
  * notifications on all application lifecycle events and device orientation
  * changes. <br>
  * Register the application observer by calling {@link NgApplication#registerObserver}.
  */

function NgApplicationObserver() {}

NgApplicationObserver.prototype =
{
	index: 0,
	/**
	  * Callback for application lifecycle start event.
	  * @type void
	  */
	onApplicationStart:function() {},

	/** @private */
	onApplicationReceivedCustomMessage:function( message ) {},

	/**
	  * Callback for device orientation change events.
	  * @param {NgApplicationOrientation} orientation Orientation enumeration value.
	  * @type void
	  */
	onApplicationDeviceOrientation:function( orientation ) {},

	/*
	 * Listener for when the user pushes the HW back button. Currently Android only.
	 *
	 * @return boolean true if back was handled entirely (eat the event), 
	 * false if it was not
	 *
	 */
	onApplicationBackPressed:function()
	{
		return false;
	}
};

//////////////////////////////////////////////////////////////////////////////////////////////////
// class Entity
// Base class for other entity types.
//////////////////////////////////////////////////////////////////////////////////////////////////

// ObjectTypes
// Defined in
//		JS:  NgEntityTypes in NgWebEngine.js and
//		C++: EntityCommandIds in GameView.h
// 1 = App
// 2 = NgTouchEvent
// 3 = NgKeyPressEvent
// 4 = Accel
// 5 = NgTextInputBox2D
// 6 = Animation (completion events)
// 7 = Sound (completion events)
// 8 = EngineEntity
// 9 = DrawableEntity2D
// 10 = NgCanvas2D
// 11 = NgCamera2D
// 12 = NgSprite2D
// 13 = NgText2D
// 14 = NgWebView2D
// 15 = NgAudioManager
// 16 = NgGroup2D
// 100 = LoadApp

// App Commands
// in:
// capabilities = 0, command dictionary format
// frameTime = 2, double
// out:
// NgLogD = 1, string

// NgTouchEvent Commands
// non-native
//	action: 1 = add, 2 = remove, 3 = modify
//	id: touch instance ID
//	x: x position
//	y: y position
// native
//	action: 4 = add, 5 = remove, 6 = modify
//	id: touch instance ID
//	x: x pos
//	y: y pos
//  eid: entity instance ID
//	lx: local x pos
//  ly: local y pos

// NgKeyPressEvent Commands
// action: 1 = down, 2 = up
// id: instance ID
// value: key value

// InputText Box Commands

// Animation
// in:
// only one kind of event, so first value is id of sprite to callback.

// Sound
// in:
//

// Accel Commands
// out:
// SetEventRate = 0, rate (hz)
// in:
// x, y, z position (floats)

// EngineEntity commands

// DrawableEntity2D commands:
// SetNativeTouchType=1,id,value (None=1, Enable = 2, EnableBounds = 3)

// NgCanvas2D Commands
// NewNgCanvas2D=1, id
// DeleteNgCanvas2D=2, id
// Update=3, id, args... not used currently
// SetRoot=4, id, grp id
// ClearRoot=5, id
// EnableNativePicking=6, id, bool

// NgCamera2D Commands
// NewNgCamera2D=1,		id, canvasId, porperties
// DeleteNgCamera2D=2,	id
// UpdateNgCamera2D=3,	id, properties
//	Properties: vx, vy, vz, vh, vw, cx, cy, ch, cw

// NgSprite2D Commands
// NewNgSprite2D=1,		id, canvasId, texture, properties
// DeleteNgSprite2D=2,	id
// UpdateNgSprite2D=3,	id, properties
//   Properties: x, y, z, w, h, r, a

// NgText2D Operations
// NewNgText2D=1		id, canvasId, properties
// DeleteNgText2D=2	id
// UpdateNgText2D=3	id, properties
//  Properties: x, y, z, w, h, justify, text

// NgGroup2D Operations
// New = 1			id, canvasId, [properties/todo]
// Delete = 2		id
// Update = 3		id, [properties/todo]
// Child = 4		id, subcmd, [child id]
//						subcmd 0 = add, 1 = rem, 2 = remAll (no child id)
// Rot = 5			id, anglef
// Pos = 6			id, xf, yf, zf
// Alpha = 7		id, alphaf
// Scale = 8		id, xf, yf

// APITODO: Clean up these identifiers.
// APITODO: Sound is probably not used any more.
// APITODO: Animation is probably not used any more.

var NgEntityTypes = {
	App : 1,
	NgTouchEvent : 2,
	NgKeyPressEvent : 3,
	Accel : 4,
	NgTextInputBox2D : 5,
	Animation : 6,
	Sound : 7,
	NgEngineEntity : 8,
	NgDrawableEntity2D : 9,
	NgCanvas2D : 10,
	NgCamera2D : 11,
	NgSprite2D : 12,
	NgText2D : 13,
	NgWebView2D : 14,
	NgGroup2D : 16,
	NgPhysics2D: 17,
	NgPrimitive2D: 18,
	NgFileSys: 19,
	Gyro : 22,
	NgUI : 23,
	Storage: 24,
	NgSystemBinding: 25,
	NgCustomMessage : 50,
	LoadApp : 100
};

var NgEngineEntityCommandIDs = {
	SetNativeTouchType : 1
};

/**
 * Initializes instance to default values. <br>
 * mId member defaults to 0 but can be set by application before calling {@link NgEngineEntity#register}.
 * @constructor
 *
 * @class
 * NgEngineEntity is the base class for all game entities, such as NgSprite2D and NgText2D. <br>
 * This class introduces key callback functions for touch, key press and per-frame update
 * notification. <br>
 * Additionally, the class introduces a register/unregister mechanism
 * for controlling the existence of the entity in the native game engine.
 *
 */

function NgEngineEntity()
{
	/** The entity id.  Used by the native engine for identification.  @type number */
	this.mId = 0;
	/** The touch priority.  Touches are routed first to the highest priority entities.  @type number */
	this.mTouchPriority = 0;
	/** The key press priority.  Key presses are routed first to the highest priority entities.  @type number */
	this.mKeyPressPriority = 0;
	/** @private */
	this.mIsTouchable = false;
	/** @private */
	this.mIsKeyable = false;
	/** @private */
	this.mIsUpdatable = false;
	/** @private */
	this.mNativeTouchType = NgEngineEntity.NativeTouchType.Enable;
	/** @private */
	this.mRegistered = false;
}

// Static methods and data.

/**
  * NgEngineEntity touch policy enumeration. <br>
  * Used with {@link NgEngineEntity#setNativeTouchType} and {@link NgCanvas2D#enableNativePicking}. <br>
  * Values: <br>
  * None : Disables native touches for this entity (and its children). <br>
  * Enable : Enables this entity to receive touches (or visits child entities) <br>
  * EnableBounds : Enables this entity to receive touches on its axis-aligned bounding box.  If
  * a touch is received on a group, it will report the touch and _not_ visit the group's children.
  */

NgEngineEntity.NativeTouchType = {
	None : 0,
	Enable : 1,
	EnableBounds : 2
};

/**
  * @private
  */

NgEngineEntity.engineCurrentId = 1;

/**
  * Allocate a unique ID for an entity.
  * @return ID value.
  * @type number
  * @private
  */

NgEngineEntity.newEngineId = function ()
{
	return NgEngineEntity.engineCurrentId++;
}

/**
  * Reclaim an entity ID.
  * @private
  */

NgEngineEntity.deleteEngineId = function ()
{
	// Nothing.
}

// Instance methods.

// Basic entity callbacks.

/** @private */

NgEngineEntity.prototype.newEntity = function() {}

/** @private */

NgEngineEntity.prototype.deleteEntity = function() {}

/**
  *	Callback for standard touch events. <br>
  * Standard touch events correspond to all touches
  * within the game view.  For each touch on the game view, all registered touchable
  * entities will receive the event.  Application logic must perform filtering to determine
  * if a particular entity corresponds to the touch event. <br>
  * Refer to {@link NgEngineEntity#toggleTouchable} for control of an entity's touchable state.
  * @param {NgTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onTouch = function(touch)
{
	return false;
}

/**
  * Callback for native touch events. <br>
  * Native touch events are pre-filtered by the game engine
  * to correspond to a specific touchable entity.  For each touch on the game view, the game
  * engine will determine which game entities are selected by the touch event.  Only the 
  * selected entities will receive the onNativeTouch event callback. <br>
  * Native touch capability is not affected by touchable state of the entity determined by
  * {@link NgEngineEntity#toggleTouchable}.  Refer to {@link NgEngineEntity#setNativeTouchType} 
  * for management of an entity's native touch policy.
  * @param {NgNativeTouchEvent} touch The touch event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onNativeTouch = function(touch)
{

}

/**
  * Callback for keyboard events. <br>These events correspond to physical or software keyboard events. <br>
  * Enable/disable key press events for an entity with {@link NgEngineEntity#toggleKeyable}.
  * @param {NgKeyPressEvent} keyPress The key press event.
  * @return The application can return true to indicate that it has consumed this event or false
  * to allow other entities to continue processing this event.
  * @type bool
  */

NgEngineEntity.prototype.onKeyPress = function(keyPress)
{
	return false;
}

/**
  *	Callback for update events. <br>Per-frame entity logic should be implemented in this callback. <br>
  * Enable/disable update events for an entity with {@link NgEngineEntity#toggleUpdatable}.
  * The return value of this method is ignored.
  * @type void
  */

NgEngineEntity.prototype.onUpdate = function()
{
}

/**
  *	Register this entity instance with the native game engine. <br>
  * The initialization sequence of engine entities has specific constraints: <br>
  * After construction and before calling
  * the register method, class methods that affect the native engine state cannot be called.  
  * During this period, changes to entity state by changing instance variables will be
  * sent to the native engine on the call to register. <br>
  * After register is called, 
  * changes to instance variables will be ignored.  During this phase, the only
  * way to affect native engine state is through methods that push commands to
  * the native side.
  * @type void
  */

NgEngineEntity.prototype.register = function()
{
	this.mParents = new Array();

	if( this.mId >= 0 )
	{
		this.mId = NgEngineEntity.newEngineId();
	}

	this.mRegistered = true;
	gNgEngineEntities[this.mId] = this;
	gNgAddedEngineEntities[this.mId] = this;
	this.newEntity();
}

/**
  * Unregister this entity from the native game engine.
  * @type void
  */

NgEngineEntity.prototype.unregister = function()
{
	var parents = this.mParents.concat(new Array());

	for (var i in parents)
	{
		NgLogD ( "Removing child " + this.mId + " from parent Group " + parents[i].mId + " because the Entity was unregistered");
		parents[i].removeChild( this );
	}

	this.mRegistered = false;
	delete gNgEngineEntities[this.mId];
	// CAUTION : DO NOT SPLICE gNgEngineEntities EVER.
	//gNgEngineEntities.splice(this.mId,1);

	gNgRemovedEngineEntities[this.mId] = this;
	this.deleteEntity();

	if(this.mId >= 0)
		NgEngineEntity.deleteEngineId(this.mId);
}

/**
  * Enable/disable key press callbacks for this entity. <br>This method flips the enable state
  * for key press events. <br>
  * In order to receive key press callbacks, an entity
  * must override the onKeyPress event and enable keyable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleKeyable = function()
{
	if(this.mIsKeyable)
		gNgKeyPressEngineEntities.splice(NgFindIndex(gNgKeyPressEngineEntities,this),1);
	else
		NgInsertSortedKeyPress(this);

	this.mIsKeyable = !this.mIsKeyable;
}

/**
  * Enable/disable update callbacks for this entity. <br>
  * This method flips the enable state
  * for update events. <br>
  * In order to receive update callbacks, an entity
  * must override the onUpdate event and enable updatable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleUpdatable = function()
{
	if(this.mIsUpdatable)
	{
		delete gNgUpdateEngineEntities[this.mId];
	}
	else
	{
		gNgUpdateEngineEntities[this.mId] = this;
	}
	this.mIsUpdatable = !this.mIsUpdatable;
}

/**
  * Enable/disable touch callbacks for this entity. <br>
  * This method flips the enable state for touch events. <br>
  * In order to receive touch callbacks, an entity
  * must override the onTouch event and enable touchable state by calling this 
  * method. <br>
  * The default state is false.
  * @type void
  */

NgEngineEntity.prototype.toggleTouchable = function()
{
	if(this.mIsTouchable)
		gNgTouchEngineEntities.splice(NgFindIndex(gNgTouchEngineEntities,this),1);
	else
		NgInsertSortedTouch(this);

	this.mIsTouchable = !this.mIsTouchable;
}

/**
  * Set native touch traversal policy. <br>
  * This method controls how the native game engine
  * traverses the game scene graph. <br>
  * The policies are described in further detail with {@link NgEngineEntity#NativeTouchType}. <br>
  * The default state is "Enable".
  * @param {NativeTouchType} type The policy enum for native touch processing.
  * @type void
  */

NgEngineEntity.prototype.setNativeTouchType = function( type )
{
	this.mNativeTouchType = type;
	NgPushCommand4(NgEntityTypes.NgDrawableEntity2D, NgEngineEntityCommandIDs.SetNativeTouchType, this.mId, this.mNativeTouchType );
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
var Core = require('NGCore/Client/Core').Core;

// These methods handle all composition for commands being sent back to the
// native engine.

/**
  * @private
  */

var gNgCommandStrings = [];

/**
  * @private
  */

var gNgCommandString = '';

// 0 deferred string composition via user loop
// 1 deferred string composition via internal loop
// 2 on-the-fly string composition.

// TODO: Benchmark all variation on all platforms.  Choose appropriate one(s)
// and prune code for others.

// UPDATE: ALL variations on contructing a string performed IDENTICALLY in
// the iPhone's UIWebView.  Unbelievable.

/**
  * @private
  */

var gNgCommandMode = 2;

/**
  * @private
  */

function NgQueueCommandText(command)
{
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings.push( command );
			break;
		case 2:
			gNgCommandString += command;
			break;
	}
}

/**
  * @private
  */

function NgFlushCommandsToString()
{
	var outputString = '';
	
	switch(gNgCommandMode)
	{	
		case 0:
			for( var num = 0, end = gNgCommandStrings.length; num < end; ++num )
			{
				outputString += gNgCommandStrings[ num ];
			}
			break;
			
		case 1:
			outputString = String.prototype.concat.apply(gNgCommandStrings);
			break;
	}
	
	switch(gNgCommandMode)
	{
		case 0:
		case 1:
			gNgCommandStrings = [];
			break;
		case 2:
			outputString = gNgCommandString;
			gNgCommandString = '';
			break;
	}
	
	return outputString;	
}

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

function NgParseString(txt)
{
	return txt;
}

/**
  * @private
  */

function NgParseBase64(txt)
{
	if( txt )
		return Core.Base64.decode(txt);
	else
		return "";
}

/**
  * @private
  */

function NgParseBool(txt)
{
	return parseInt(txt) ? true : false;
}

function NgParseInt(txt)
{
	return parseInt(txt, 10);
}

function NgKVArrayToCmd(kvArray)
{
	var out = "";
	var count = 0
	for (var s in kvArray)
	{
		var value = kvArray[s];
		
		out += "," + s + "," + Core.Base64.encode(value);
		++count;
	}
	return count + out;
}
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
 * Submit a command with 1 argument to the native engine.
 * @private
 */
function NgPushCommand1(arg1)
{
	gNgCommandString += ":" + arg1;
}

/**
 * Submit a command with 2 arguments to the native engine.
 * @private
 */
function NgPushCommand2(arg1, arg2)
{
	gNgCommandString += ":" + arg1 + "," + arg2;
}

/**
 * Submit a command with 3 arguments to the native engine.
 * @private
 */
function NgPushCommand3(arg1, arg2, arg3)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3;
}

/**
 * Submit a command with 4 arguments to the native engine.
 * @private
 */
function NgPushCommand4(arg1, arg2, arg3, arg4)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4;
}

/**
 * Submit a command with 5 arguments to the native engine.
 * @private
 */
function NgPushCommand5(arg1, arg2, arg3, arg4, arg5)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5;
}

/**
 * Submit a command with 6 arguments to the native engine.
 * @private
 */
function NgPushCommand6(arg1, arg2, arg3, arg4, arg5, arg6)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6;
}

/**
 * Submit a command with 7 arguments to the native engine.
 * @private
 */
function NgPushCommand7(arg1, arg2, arg3, arg4, arg5, arg6, arg7)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand8(arg1, arg2, arg3, arg4, arg5, arg6, arg7,arg8)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8;
}

/**
 * Submit a command with 8 arguments to the native engine.
 * @private
 */
function NgPushCommand9(arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
{
	gNgCommandString += ":" + arg1 + "," + arg2 + "," + arg3 + "," + arg4 + "," + arg5 + "," + arg6 + "," + arg7 + "," + arg8 + "," + arg9;
}

/**
 * Submit a command with n arguments to the native engine.
 * @private
 */
function NgPushCommandN()
{
	var argv = arguments;
	var argc = argv.length;
	
	var tmp = ":";
	
	if( argc > 0 )
	{
		tmp += argv[ 0 ];
		
		for( var num = 1; num < argc; ++num )
		{
			tmp += "," + argv[ num ];
		}
	}
	
	gNgCommandString += tmp;
}

/**
 * Peek at the command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Command id or null if parsing failed.
 * @private
 */

function NgPeekCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
		return parseInt ( vals[ 1 ] );
	else
		return null;
}

/**
 * Peek at the class and command ID in a command string.  This helps avoid 
 * splitting the string twice in a number of cases.
 * @return Two-element array of ids or null if parsing failed.
 * @private
 */

function NgPeekClassAndCommandId(str)
{
	var vals = str.split ( ",", 2 );
	if( vals.length == 2 )
	{
		vals[ 0 ] = parseInt ( vals[ 0 ] );
		vals[ 1 ] = parseInt ( vals[ 1 ] );
		return vals;
	}
	else
		return null;
}


/**
 * Parse an incoming command string to individual strings.
 * @return an array of fields in serialization order.
 * @private
 */
function NgParseCommandToStrings(src)
{
	return src.split(",");
}

/**
  * @private
  */

function NgParseCommand1(src, func1)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand2(src, func1, func2)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand3(src, func1, func2, func3)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand4(src, func1, func2, func3, func4)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	
	return ret;
}

/**
  * @private
  */

function NgParseCommand5(src, func1, func2, func3, func4, func5)
{
	var ret = [];
	
	var fields = src.split(",");
	
	ret[ 0 ] = func1( fields[ 1 ] );
	ret[ 1 ] = func2( fields[ 2 ] );
	ret[ 2 ] = func3( fields[ 3 ] );
	ret[ 3 ] = func4( fields[ 4 ] );
	ret[ 4 ] = func5( fields[ 5 ] );
	
	return ret;
}


/**
 * Parse an incoming command string to typed values based on passed-in functions.
 * ex: NgParseCommandN("1:1,1.0,ACFHENA==",parseInt, parseFloat, NgParseString);
 * NOTE: The first item is assumed to be the command type, and will be
 * discarded in the output.  I.e., the output starts with the second src element.
 * @return an array of parsed fields in serialization order.
 * @private
 */

function NgParseCommandN(src)
{
	var ret = [];
	
	var argv = arguments;
	var argc = argv.length;
	
	var fields = src.split(",");
	for( var num = 1; num < argc; ++num )
	{
		ret[ num - 1 ] = argv[ num ]( fields[ num ] );
	}
	
	return ret;
}

/**
 * Parse an incoming typed dictionary.  The format of the dictionary is:
 * type,field name,value,type,field name,value[...]
 * Parsed values will be asigned to the field name in the dst array/object.
 * NOTE: Strings passed in this format must not have embedded commas (use
 * base64 encoding if arbitrary strings are being used.
 * @arg src The source command string.
 * @arg srcStart The field index to start parsing dictionary entries from.
 * @arg dst The destination object/array for parsed values.
 * @arg initialFields Optionally store the fields before srcStart in the passed-in array.
 * @return true if all fields were successfully parsed.
 * @private
 */

function NgParseCommandDictionary(src,srcStart,dst,initialFields)
{
	var ret = true;
	var fields = src.split(",");
	var end = fields.length;
	
	if(initialFields)
	{
		for( var num = 0; num < srcStart; ++num )
		{
			initialFields[ num ] = fields[ num ];
		}
	}
	
	for( var num = srcStart; num < end; )
	{
		var type = fields[ num++ ];
		var name = fields[ num++ ];
		var val = fields[ num++ ];
		var good = true;
		
		switch(type)
		{
			case 'i':	// int
				val = parseInt( val );
				break;
			case 'f':	// float
				val = parseFloat( val );
				break;
			case 's':	// string
				break;
			case 'S':	// base64 string
				val = Core.Base64.decode(val);
				break;
			case 'b':	// bool
				val = parseInt(val) ? true : false;
				break;
			default:
				//				NgLogD("NgParseCommandDictionary unknown type for " + type + " " + name + " " + val);
				ret = false;
				good = false;
				break;
		}
		
		if( good )
		{
			dst[ name ] = val;
			
			// TEMP PRW
			NgLogD( "dict: " + name + " : " + dst[ name ] );
		}
		else
		{
			NgLogD("dict: could not process " + type );
		}
	}
	
	return ret;
}
/**
  * @private
  */

var gNgTrace=null;

//////////////////////////////////////////////////////////////////////////////////////////////////
// Logging functions.
//////////////////////////////////////////////////////////////////////////////////////////////////

/**
  * @private
  */
var NgDebugModes = {
	BrowserTrace : {},
	NgCommand : {},
	NgCommandDocLoc : {}
};

/**
  * @private
  */
var NgLogLevel = {
	Verbose : 5,
	Debug : 4,
	Info : 3,
	Warning : 2,
	Error : 1
};

/**
  * @private
  */
var NgLogStr = [ '', 'e', 'w', 'i', 'd', 'v'];


/**
  * @private
  */

// TEMP... this is not how we want to do this long-term.
function NgSetDebugDefaultDestination()
{
	if (typeof navigator == 'undefined')
	{
		return NgDebugModes.NgCommand;
	}

	var agent=navigator.userAgent.toLowerCase();
	if( ! ( (agent.indexOf('iphone') >=0) || (agent.indexOf('ipad') >= 0) ) )
	{
		return NgDebugModes.BrowserTrace;
	}
	else
	{
		return NgDebugModes.NgCommand;
	}
}

/**
  * @private
  */

var gNgDebugMode = NgSetDebugDefaultDestination();

/**
  * @private
  */

function NgLogInit()
{
	if( gNgDebugMode == NgDebugModes.BrowserTrace )
	{
		gNgTrace = document.getElementById("trace");
	}

	// Other modes don't need initialization.
}

function NgLogSetLevel(level)
{
	switch( level )
	{
		case NgLogLevel.Debug:
		{
			NgLogV = NgNoLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Info:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Warning:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		case NgLogLevel.Error:
		{
			NgLogV = NgNoLog;
			NgLogD = NgNoLog;
			NgLogI = NgNoLog;
			NgLogW = NgNoLog;
			NgLogE = NgDoErrorLog;
		}
			break;

		default:
		case NgLogLevel.Verbose:
		{
			NgLogV = NgDoVerboseLog;
			NgLogD = NgDoDebugLog;
			NgLogI = NgDoInfoLog;
			NgLogW = NgDoWarningLog;
			NgLogE = NgDoErrorLog;
		}
			break;
	}
}

NgDoVerboseLog = function ( msg ) {
	NgLog(NgLogLevel.Verbose, msg);
}

NgDoDebugLog = function ( msg ) {
	NgLog(NgLogLevel.Debug, msg);
}

NgDoInfoLog = function ( msg ) {
	NgLog(NgLogLevel.Info, msg);
}

NgDoWarningLog = function ( msg ) {
	NgLog(NgLogLevel.Warning, msg);
}

NgDoErrorLog = function ( msg ) {
	NgLog(NgLogLevel.Error, msg);
}

NgNoLog = function() {};
NgLogSetLevel(NgLogLevel.Verbose);

var useConsole = ((typeof console != 'undefined') && (typeof console.log == 'function'));

function NgLog( level, msg )
{
	console.log(NgLogStr[level] + ": " + msg);
}

function NgLogException( ex )
{
    var str = "\nEXCEPTION:\n";

    for( var prop in ex )
    {
		str += "property: "+ prop+ " value: ["+ ex[prop]+ "]\n";
    }

    str += "toString(): " + " value: [" + ex.toString() + "]\n\n";

	NgLogD( str );
}
/*
 @author: Remy Sharp / http://remysharp.com
 @date: 2007-04-20
 @name: time
 @methods:
 start - start named timer
 stop - stop named timer
 event - hook predefined event
 func - hook existing function, or hook anonymous function (note refrence is passed back)
 report - output timings
 */
if ((typeof window == 'undefined') || (typeof window.time == 'undefined'))
{
	(function() {
		time = {
			// start + stop taken from firebuglite.js -
			// http://getfirebug.com/firebuglite
			start : function(name) {
				if (!name) {
					error('start: If starting a timer manually a name must be set');
				} else {
					timeMap[name] = (new Date()).getTime();
					if (name in NgRecordMap) {
					} else {
						NgRecordMap[name] = new NgRecord(name);
					}
				}
			},

			stop : function(name) {
				if (name in timeMap) {
					var stop = (new Date()).getTime();
					// var l = new Report(name, timeMap[name], stop);
					var l = NgRecordMap[name].addRecord(stop - timeMap[name]);
					log.push(l);
					if (NgRecordMap[name].records % NgRecordMap[name].ctr == 0) {
						NgRecordMap[name].lineReportMethod.call(this, l);
						NgRecordMap[name].records = 0;
						NgRecordMap[name].avg = 0;
						NgRecordMap[name].min = 55555;
						NgRecordMap[name].max = 0;
					}
					delete timeMap[name];
				} else {
					error('stop:' + name + ' not found');
				}
			},

			event : function(name, elm, type) {
				if (typeof name != 'string') {
					// name has not been passed in
					type = elm;
					elm = name;
					name = '';
				}

				if (!elm.length) {
					elm = [ elm ];
				}

				if (type.indexOf('on') == -1) {
					type = 'on' + type;
				}

				var i = elm.length;
				var timerN = null;
				var c = null;
				while (i--) {
					timerN = name;
					if (!timerN) {
						timerN = elm[i].id || elm[i].getAttribute('class')
								|| elm[i].getAttribute('className')
								|| elm[i].tagName;
					}

					mapEvent(elm[i], type, timerN);
				}
			},

			func : function(name, fn) {
				if (typeof name == 'function') {
					fn = name;
				}

				// get function name as this browser may not support fn.name (IE
				// + Safari + Opera)
				if (!fn.name && typeof fn == 'function') {
					var m = fn.toString().match(/function\s*(.*)\s*\(/);
					if (m[1]) {
						fn.name = m[1];
					}
				}

				if (typeof fn == 'function' && !fn.name) {
					// function is anonymous -
					// time function using var func = time.fn(function() { ...do
					// stuff });
					if (typeof name != 'string') {
						anonFuncId++;
						name = 'anonymous' + anonFuncId;
					}

					return function() {
						time.start(name);
						var ret = fn.apply(window, arguments);
						time.stop(name);
						return ret;
					};
				} else {
					var fnName = fn.name || fn;
					if (typeof name != 'string') {
						name = fnName;
					}

					eval('var fnCopy = ' + fnName);
					if (typeof fnCopy == 'function') {
						var wrap = function() {
							time.start(name);
							var ret = fnCopy.apply(this, arguments);
							time.stop(name);
							return ret;
						};
						wrap.hooked = true;
						eval(fnName + ' = wrap;');
						return eval(fnName);
					} else {
						// error hooking
						error('func: Could not hook function (name: ' + name + ')');
					}
				}
			},

			report : function(name) {
				if (typeof name == 'undefined') {
					reportMethod.call(this, log);
				} else {
					var i = log.length;
					var l = [];
					while (i--) {
						if (name == log[i].name) {
							l.push(log[i]);
						}
					}
					reportMethod.call(this, l);
				}
			},

			setReportMethod : function(fn) {
				if (fn.hooked) {
					error('setReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					reportMethod = fn;
				}
			},

			setCtr : function(name, ctr, fn) {
				if (name in NgRecordMap) {
				} else
					NgRecordMap[name] = new NgRecord(name, ctr, fn);
			},

			setLineReportMethod : function(fn) {
				if (fn.hooked) {
					error('setLineReportMethod: Cannot use hooked method ' + fn.name);
				} else {
					lineReportMethod = fn;
					lineReport = true;
				}
			},

			errors : false
		};

		var timeMap = {};
		var NgRecordMap = {};
		var log = [];
		var reportMethod = defaultReport;
		var lineReport = false;
		var lineReportMethod = defaultLineReport;
		var anonFuncId = 0;

		var Report = function(n, s, e) {
			this.name = n;
			this.start = s;
			this.stop = e;
			this.delta = e - s;
			// useful if I could grab the call - but can't see how due to anon
			// functions (though I can see them in the start method)
		};

		Report.prototype.toString = function() {
			return this.name + ": " + this.delta + "ms";
		};

		function defaultReport(l) {
			alert(l.join("\n"));
		}

		function defaultLineReport(l) {
			alert(l);
		}

		function error(e) {
			if (time.errors)
				alert(e);
		}

		var NgRecord = function(name, ctr, fn) {
			this.name = name;
			this.records = 0;
			this.avg = 0;
			this.min = 555555;
			this.max = 0;
			this.ctr = ctr;
			if (fn.hooked) {
				error('setLineReportMethod: Cannot use hooked method. Will use default method' + fn.name);
				this.lineReportMethod = defaultLineReport;
			} else {
				this.lineReportMethod = fn;
			}

		}

		NgRecord.prototype.addRecord = function(delta) {
			this.avg = (this.avg * this.records + delta) / (this.records + 1);
			if (this.min > delta)
				this.min = delta;
			if (this.max < delta)
				this.max = delta;
			this.records++;
			frq = 1000 / this.avg;
			return this.name + '->  max:' + this.max + '  min:' + this.min
					+ '  avg:' + this.avg.toFixed(2) + '  freq:'
					+ frq.toFixed(2) + '\n';
		}

		// required to create a brand new instance of our copied function
		function mapEvent(e, t, n) {
			var c = e[t];
			if (typeof c == 'function') {
				e[t] = function() {
					time.start(n + ':' + t);
					var ret = c.apply(this, arguments);
					time.stop(n + ':' + t);
					return ret;
				};
			} else {
				error('event: Function must be set on element.' + t
						+ ' before hooking (name: ' + n + ')');
			}
		}
	})();
}

/**
 * @author will
 */
var Core = require('NGCore/Client/Core').Core;
var Class = require('NGCore/Client/Core/Class').Class;
var GL2 = require('NGCore/Client/GL2').GL2;
var UI = require('NGCore/Client/UI').UI;
var Node = require('NGCore/Client/GL2/Node').Node;
var Device = require('NGCore/Client/Device').Device;
//var PlusRequestReq = require('../NGCore/Client/Plus/PlusRequest');
//var SessionReq = require('../NGCore/Client/Plus/Session');
//var PurchaseControllersReq = require('../NGCore/PlusUI/PurchaseControllers');
//var UserReq = require('../NGCore/Client/Plus/User');
var Tilemap = require('Code/G6/Tilemap/Tilemap').Tilemap;
var TileNode = require('Code/G6/Tilemap/TileNode').TileNode;
var SidescrollMap = require('Code/G6/Sidescroll/SidescrollMap').SidescrollMap;
var Animation = require('Code/G6/Animation').Animation;
var StripScene = require('Code/StripCity/Scene/Strip/StripScene').StripScene;
var Util = require('Code/G6/Util/Util').Util;
var Scale = require('Code/G6/Util/Scaler').Scale;
var Styles = require('Code/G6/Util/Styles').Styles;
var CardGame = require('Code/StripCity/Game/CardGame').CardGame;
var Game = require('Code/StripCity/Game').Game;
var SCGame = require('Code/StripCity/Game/SCGame').SCGame;
var Audio = require('NGCore/Client/Audio').Audio;
var SCAudio = require('Code/StripCity/Game/SCAudio').SCAudio;
var Player = require('Code/StripCity/Game/Player/Player').Player;
var TutorialHistory = require('Code/StripCity/Game/Player/TutorialHistory').TutorialHistory;
var PlayerStatNode = require('Code/StripCity/Scene/Common/PlayerStatNode').PlayerStatNode;

var Menu = require('Code/G6/Menu').Menu;
var BlackBackground = require('Code/G6/Background/BlackBackground').BlackBackground;
var AlertLayer = require('Code/G6/Alert/AlertLayer').AlertLayer;
var ProgressBar = require('Code/G6/ProgressBar/ProgressBar').ProgressBar;
var TestAlertNode = require('Code/G6/Alert/TestAlertNode').TestAlertNode;
var AtlasMap = require('Code/G6/Atlas/AtlasMap').AtlasMap;
var AtlasMapLoader = require('Code/G6/Atlas/AtlasMapLoader').AtlasMapLoader;
//var AnimationFrameCache = require('./G6/Animation/AnimationFrameCache');
var Browser = require('Code/G6/Browser').Browser;
var CustomLabel = require('Code/G6/Text/CustomLabel').CustomLabel;
var Settings = require('Code/StripCity/Game/Settings').Settings;
var GenericAlertNode = require('Code/StripCity/Scene/Common/GenericAlertNode').GenericAlertNode;
var GenericConfirmNode = require('Code/StripCity/Scene/Common/GenericConfirmNode').GenericConfirmNode;

var TitleScreen = require('Code/StripCity/Scene/Title/TitleScreen').TitleScreen;
var LobbyScene = require('Code/StripCity/Scene/Lobby/LobbyScene').LobbyScene;

var BlackJack = require('Code/StripCity/Game/CardGame/BlackJack').BlackJack;
var TriCardWar = require('Code/StripCity/Game/CardGame/TriCardWar').TriCardWar;
var Baccarat = require('Code/StripCity/Game/CardGame/Baccarat').Baccarat;
var BonusGame = require('Code/StripCity/Game/BonusGame/BonusGame').BonusGame;


//var PlusRequest = require("../NGCore/Client/Plus/PlusRequest");
//var RegistrationRecord = require("../NGCore/Client/Plus/RegistrationRecord").RegistrationRecord;
//var SessionReq = require("../NGCore/Client/Plus/Session");
//var LoginViewController = require('./StripCity/Plus/LoginViewController').LoginViewController;
var MessageListenerReq = require('NGCore/Shared/MessageListener');
//var UserReq = require("../NGCore/Client/Plus/User");
//var PlusManager = require('./StripCity/Plus/PlusManager').PlusManager;
var SCConstants = require('Code/StripCity/Game/SCConstants').SCConstants;

var TextWithShadow = require('Code/G6/Text/TextWithShadow').TextWithShadow;

var FPSCounter = require('Code/G6/Tools/FPSCounter').FPSCounter;

var IAPMenu = require('Code/StripCity/Scene/IAP/IAPMenu').IAPMenu;
var IAPManager = require('Code/StripCity/Game/IAP/IAPManager').IAPManager;
var SCStyle = require('Code/StripCity/Scene/Common/SCStyle').SCStyle;
var LGL = require('NGCore/Client/Core/LocalGameList').LocalGameList;
var OrientationEmitter = require('NGCore/Client/Device/OrientationEmitter').OrientationEmitter;

var Social = require('NGCore/Client/Social').Social;
var OpenSocialManager = require('Code/StripCity/OpenSocial/OpenSocialManager').OpenSocialManager;
var Bank = require('NGCore/Client/Bank').Bank;
//var Logger = require("./NGCore/Client/Core/Logger").Logger;

// var Mobclix = require('../NGCore/Client/Mobclix').Mobclix;


var SC_VERSION = 1.0;

var SHOW_FPS = false;

//var HardwareBack = Core.MessageListener.subclass({
//    initialize: function(){
//        Device.KeyEmitter.addListener(this, this.onUpdate);
//    },
//    
//    destroy: function(){
//        Device.KeyEmitter.removeListener(this);
//    },
//    
//    onUpdate: function(keyEvent){
//        NgLogD('back pressed....');
//        var self = this;
//        if (keyEvent.code === Device.KeyEmitter.Keycode.back) {
//			  NgApplication.getInstance().setOrientation(NgApplicationOrientation.LandscapeRight);
////            if (SCGame.finishedPlusLogin()) {
//              if (true) {
////                AlertLayer.showAlertNode(new GenericConfirmNode('Are you sure you want to quit?','Exit', function(){
//                AlertLayer.showAlertNode(new GenericConfirmNode('終了してよろしいですか？','閉じる', function(){
//                    SCGame.quickSavePlayer();
//                    NgApplication.getInstance().setOrientation(NgApplicationOrientation.Portrait);
//                    SCGame.destroyGame();
//                    self.destroy();
//                    
//                    setTimeout(function(){
//                        LGL.runUpdatedGame(Core.Capabilities.getStartingServer() + '/' + Core.Capabilities.getBootGame());
//                    }, 500);
//                    
//                    return;
//                }));
//            }
//            else 
//            if (UI.NavController.getInstance().getTopView() && typeof UI.NavController.getInstance().getTopView().backButtonOveride != 'undefined') {
//                UI.NavController.getInstance().getTopView().backButtonOveride();
//            }
//            return true;
//        }
//    },
//});

var LifecycleListener = Core.MessageListener.subclass({

    initialize: function(){
    
        Device.LifecycleEmitter.addListener(this, this.onUpdate);
    },
    
    destroy: function(){
    
        Device.LifecycleEmitter.removeListener(this);
    },
    
    onUpdate: function(event){
    
        //		switch (event) {
        //			
        //			case Device.LifecycleEmitter.Event.Resume:
        //				NgLogD('Lifecycle: Resume');
        //				break;
        //			case Device.LifecycleEmitter.Event.Suspend:
        //				NgLogD('Lifecycle: Suspend');
        //				break;
        //			case Device.LifecycleEmitter.Event.Terminate:
        //				NgLogD('Lifecycle: Terminate');
        //				break;
        //		}
        SCGame.handleLifecycleEvent(event);
    },
});


var MemoryListener = Core.MessageListener.subclass({

    initialize: function(){
        Device.MemoryEmitter.addListener(this, this.onUpdate);
    },
    
    destroy: function(){
    
        Device.MemoryEmitter.removeListener(this);
    },
    
    onUpdate: function(event){
        NgLogD('***************WARNING... VSS low memory.....!');
    },
});


function main(){


    // NgLogD('Version:' + Core.Capabilities.getSDKVersion());
    // NgLogD('SDK BUILD DATE:' + Core.Capabilities.getSDKBuildDate());
   	Device.OrientationEmitter.setInterfaceOrientation(Device.OrientationEmitter.Orientation.LandscapeLeft, false);

    var lifecycleListener = new LifecycleListener();
    var memListener = new MemoryListener();
	var myW = UI.Window.outerHeight;
	var myH = UI.Window.outerWidth;

	var glView = new UI.GLView({
		frame: [0, 0, myW,myH],
		onLoad: function() {


        if (SHOW_FPS) {
            var fpsCounter = new FPSCounter();
            SCStyle.applyFontStyle(fpsCounter._fpsLabel, SCStyle.FontStyle.Sans32);
            GL2.Root.addChild(fpsCounter);
        }

       OpenSocialManager.initUser(SCGame.startGame);
      }  
	});

	glView.setActive(true);





}
